**Welcome to ChemShell!**

To install ChemShell please follow the instructions *Installing ChemShell* in the *INSTALL* file.

**************************************
Running ChemShell: A Quick-Start Guide
**************************************

After successful compile, a ChemShell runtime script

  *YOUR_CHEMSH_ROOT/bin/CHEMSH_ARCH/chemsh*

and binary

  *YOUR_CHEMSH_ROOT/bin/CHEMSH_ARCH/chemsh.x*

will be installed, where *CHEMSH_ARCH* can be "intel" or "gnu" depending on the compilers you have used (they may coexist).

To print the helper::

  YOUR_CHEMSH_ROOT/bin/CHEMSH_ARCH/chemsh -h


Linux PC
========

Basic run
---------

On a Linux PC, a serial job is run by::

  YOUR_CHEMSH_ROOT/bin/CHEMSH_ARCH/chemsh YOUR_CHEMSH_JOB.py > YOUR_CHEMSH_JOB.log

A parallel job, for example, of 4 MPI processes can be run by (use ``--debug`` to control how many details are printed)::

  YOUR_CHEMSH_ROOT/bin/CHEMSH_ARCH/chemsh -np 4 --debug 3 YOUR_CHEMSH_JOB.py > YOUR_CHEMSH_JOB.log

To run a task-farm parallel job consisting of 6 workgroups with 2 MPI processes in each workgroup::

  YOUR_CHEMSH_ROOT/bin/CHEMSH_ARCH/chemsh -np 12 -nwg 6 --debug 5 YOUR_CHEMSH_JOB.py > YOUR_CHEMSH_JOB.log

:HINT: All commands previously used for running ChemShell are saved in a local file: *_chemsh_run.log*

Advanced run
------------

To start an (MPI parallel) interactive Python shell with ChemShell::

  YOUR_CHEMSH_ROOT/bin/CHEMSH_ARCH/chemsh -np 12 -nwg 6 --debug 5

The above command is equivalent to::

  mpirun -np 12 YOUR_CHEMSH_ROOT/bin/CHEMSH_ARCH/chemsh.x -nwg 6 --debug 5

Python interpreter
------------------

ChemShell inputs can also be executed in a Python interpreter, as follows::

  export PYTHONPATH=YOUR_CHEMSH_ROOT

  export CHEMSH_ARCH=intel [or gnu, etc.]

  python3 YOUR_CHEMSH_JOB.py

This mode of execution can be useful on local computers (e.g. to aid developers when debugging), but using the chemsh
script is in general recommended, especially on HPC systems. Execution via the chemsh script is required for MPI 
parallel calculations.

HPC platforms
=============

ChemShell installed on a supercomputer normally can preload all necessary modules so you will not have to do it youself.
ChemShell by default launches an interactive Python/ChemShell enviroment the same as on a Linux PC, this is to enable small
tasks to be completed prior to submitting the heavy compute to the scheduler.
for example::

  YOUR_CHEMSH_ROOT/bin/intel/chemsh -np 2 -nwg 2 -npmm 1 --debug 5 YOUR_CHEMSH_JOB.py

This will run Chemshell interactively on a login node, which is not always allowed on HPC systems. To submit your job to the
scheduling system on the supercomputer provide the --submit flag. You should also set some of the paramters that control your
job execution such as wall time, for example::

  YOUR_CHEMSH_ROOT/bin/intel/chemsh --submit -A YOUR_ACCOUNT -J YOUR_JOBNAME -wt 24:00:00 -np 1024 -nwg 64 -npmm 8 --debug 3 YOUR_CHEMSH_JOB.py

requests to the job scheduler 1024 MPI processes devided into 64 task-farm workgroups, 8 processes for the MM calculation
within a workgroup, and 24 hours of walltime.

Building the documentation 
==========================

To build the ChemShell manual and tutorial webpages type ``make`` in the docs/ directory. 
You will need to have the Sphinx documentation system installed (sphinx-doc.org).
The manual and tutorial can then be opened in any web browser at *docs/manual.html* and *docs/tutorial.html*.

(Rowan Hanson, MChem)

designing_files is a directory with the files used in the working and designing of the cuso4_solv tutorial as well as the beginnings of bmim_OTf, which were not completed within the official timeframe of the project.

Note to users
=============

The scripts in this directory are used only for validation of the P450 test 
against the original Tcl-ChemShell implementation, and are not necessary
for running the tutorial examples.

!  Copyright (C) 2017 The authors of Py-ChemShell
!
!  This file is part of Py-ChemShell.
!
!  Py-ChemShell is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as
!  published by the Free Software Foundation, either version 3 of the
!  License, or (at your option) any later version.
!
!  Py-ChemShell is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with Py-ChemShell.  If not, see
!  <http://www.gnu.org/licenses/>.

module ChemShellGAMESSUKModule

    use, intrinsic :: iso_c_binding
    use DL_PY2F
    use ChemShellParallelModule

    private

    public register_gamess_uk, interface_gamess_uk
!    public PyFrag, PyShells, nshells

    type(dictType) , pointer :: PyFrag, PyShells
    integer                  :: nshells
    integer(c_int)           :: c_debug
    integer(c_int)           :: gamess_uk_handle
    integer                  :: first_time_run = 1

    contains

      
    subroutine register_gamess_uk(debug) bind(c, name="f_register_gamess_uk")

        use ChemShellParallelModule, only : chemsh_parallel

        integer(c_int), intent(in) :: debug

        type(c_funptr)             :: gamess_uk_pointer

        c_debug = debug
        gamess_uk_pointer = c_funloc(gamess_uk_wrap)
        gamess_uk_handle = chemsh_parallel%get_function_handle(gamess_uk_pointer)

    endsubroutine register_gamess_uk
    ! called by master process only
    subroutine interface_gamess_uk(fragPtr) bind(c)
 
        use ChemShellParallelModule, only : chemsh_parallel

        implicit none
 
        type(PyType)  , intent(in) :: fragPtr
 
        integer                    :: ierror
        type(PyType)  , pointer    :: shellsPtr
 
        ! set up dict of fragObj
        allocate(PyFrag, source=ptr2dict(fragPtr))
        call PyFrag%get('shells', shellsPtr)
 
        ! set up dict of shellsObj and save nshells
        allocate(PyShells, source=ptr2dict(shellsPtr))
        call PyShells%get('npts', nshells)
 
        if(chemsh_parallel%is_parallel()) then
           ierror = chemsh_parallel%exec_function(gamess_uk_handle, c_debug)
        else
           ierror = gamess_uk_wrap()
        endif
 
        deallocate(PyFrag, PyShells)
 
    endsubroutine interface_gamess_uk


    ! also called by slave processes
    integer function gamess_uk_wrap() result(ierror)

        ! first_time_run = 1 should only be applied at the first time ChemShell invokes GAMESS-UK,
        ! otherwise it cannot be run over 100 times (see pg_begin() in GAMESS-UK/m4/parallel.m)
        !call chemsh_gamess(first_time_run, ierror)
        call gamess(first_time_run, ierror)

        call flush(6)

        first_time_run = 0

    endfunction gamess_uk_wrap

endmodule ChemShellGAMESSUKModule

! **********************************************************************
! **                                                                  **
! **                Task assignment and management                    **
! **                                                                  **
! **********************************************************************
!!****h* main/task
!!
!! NAME
!! task
!!
!! FUNCTION
!! Manage optimisation tasks, call dlf_run (which does one 
!! optimisation loop)
!!
!! DATA
!! $Date$                   
!! $Rev$                                                              
!! $Author$                                                         
!! $URL$   
!! $Id$                      
!!
!! COPYRIGHT
!!
!!  Copyright 2007 Johannes Kaestner (kaestner@theochem.uni-stuttgart.de),
!!  Tom Keal (thomas.keal@stfc.ac.uk)
!!
!!  This file is part of DL-FIND.
!!
!!  DL-FIND is free software: you can redistribute it and/or modify
!!  it under the terms of the GNU Lesser General Public License as 
!!  published by the Free Software Foundation, either version 3 of the 
!!  License, or (at your option) any later version.
!!
!!  DL-FIND is distributed in the hope that it will be useful,
!!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!!  GNU Lesser General Public License for more details.
!!
!!  You should have received a copy of the GNU Lesser General Public 
!!  License along with DL-FIND.  If not, see 
!!  <http://www.gnu.org/licenses/>.
!!
!! SOURCE
!!****
module dlf_task_module
  logical, save :: tconverged ! is the last calculation converged
end module dlf_task_module

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* task/dlf_task
!!
!! FUNCTION
!! Assign and manage dl-find tasks
!!
!! In case of a direct coordinate transformation (glob%icoord<10):
!! * Find the number of degrees of freedom
!! * (Initialise HDLCs)
!! * Allocate global arrays (glob%icoords, glob%igradient, glob%step)
!!
!! In multiple image methods (NEB, dimer) call their respective init routines
!!
!! SYNOPSIS
subroutine dlf_task( &
#ifdef GAMESS
    core&
#endif
    )
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr,stdout,printl,printf
  use dlf_stat, only: stat
  use dlf_allocate, only: allocate,deallocate
  use dlf_task_module, only: tconverged
  use dlf_store
  implicit none
#ifdef GAMESS
  real(rk) :: core(*) ! GAMESS memory, not used in DL-FIND
#endif
  integer  :: task ! will become global!
  logical  :: tok
  real(8)  :: distort_in
! **********************************************************************

! 0      normal, no modification
! 1xxx   input near TS (+ TS-mode if avail.) 
! 1001   TS with dimer, then vibration freqyency
! 1011   TS with dimer/P-RFO, then find both downhill structures
!
! 2xxx   input RS + PS

!  glob%task=1001

  select case (glob%task)

! ======================================================================
! task = 0: standard optimisation, input unmodified
! ======================================================================
  case (0)

    ! main optimisation cycle
    call dlf_run( &
#ifdef GAMESS
        core&
#endif
        )

! ======================================================================
! task = 1001: TS with dimer, then vibration frequency
! ======================================================================
  case (1001)
    
    ! switch off any NEB attempts
    if( glob%icoord>=100 .and. glob%icoord<200) then
      glob%icoord=mod(glob%icoord,10)
    end if

    ! make sure the dimer method is used
    if( glob%icoord<200 .or. glob%icoord>299) then
      glob%icoord=mod(glob%icoord,10)+220
    end if

    if(printl>=2) &
        write(stdout,1000) "Searching the transition state with the dimer method"


    ! main optimisation cycle
    call dlf_run( &
#ifdef GAMESS
        core&
#endif
        )

    ! catch the case of a not-converging initial calculation
    if(.not.tconverged.and. printl >=2 ) then
      write(stdout,1000) "Dimer optimisation not converged, skipping"
      write(stdout,1000) " the frequency calculation"
      return
    end if
    
    if(printl>=2) &
        write(stdout,1000) "Calculating the imaginary frequency with the dimer method"
    
    ! make sure direct coordinates are cartesians
    glob%icoord=glob%icoord-mod(glob%icoord,10)

    if(.not.allocated(glob%xcoords2)) call dlf_fail( &
        "Error: glob%xcoords2 should be allocated after dimer run")
    
    ! get the end coordinates after the last run
    call dlf_formstep_get_ra("TSCOORDS",glob%nat*3,glob%xcoords,tok)

    ! send the TS coords to the calling program to deal with (e.g. write to a file)
    call dlf_put_coords(glob%nvar,3,glob%energy,glob%xcoords,glob%iam)
    
    ! make sure TS-mode from the first run is used
    call dlf_formstep_get_ra("TSMODE_R",glob%nat*3,glob%xcoords2(:,:,1),tok)
    if(.not.tok) then
      if(printl>=2) &
          write(stdout,1000) "Warning: unable to use dimer direction from previous run"
      glob%tcoords2=.false.
      call deallocate(glob%xcoords2)
    end if

    glob%massweight=.true.
    glob%maxrot=40
    glob%tolrot=0.1D0
    glob%maxcycle=1
    ! make sure input is not converged
    glob%tolerance=glob%tolerance * 0.001D0 

    call dlf_stat_reset

    ! main optimisation cycle
    call dlf_run( &
#ifdef GAMESS
        core&
#endif
        )

    ! send the TS mode to the calling program to deal with (e.g. write to a file)
    call dlf_put_coords(glob%nvar,2,0.0D0,glob%xcoords2(:,:,1),glob%iam)

    if(printl>=2) &
        write(stdout,1000) "Finished: Transition mode and imag. frequency have been calculated."

! ======================================================================
! task = 1011: TS search (dimer or P-RFO), then find both downhill structures
! ======================================================================
  case (1011)

    ! switch off any NEB attempts
    if( glob%icoord>=100 .and. glob%icoord<200) then
      glob%icoord=mod(glob%icoord,10)
    end if

    if(glob%iopt/=10) then
      if( glob%icoord<200 .or. glob%icoord>299) then
        ! nither P-RFO nor dimer chosen in the input. Choosing P-RFO
        glob%icoord=mod(glob%icoord,10)+220
        glob%iopt=3
        glob%iline=0
        if(printl>=2) then
          write(stdout,1000) "A transition state search was requested using tasks,"
          write(stdout,1000) " however, no TS option was chosen. Using the dimer method"
        end if
      end if
    end if

    if(abs(glob%distort) > 0.D0 ) then
      distort_in=glob%distort
    else
      distort_in=0.1D0
    end if
    glob%distort=0.D0

    if(printl>=2) &
        write(stdout,1000) "Searching the transition state"

    ! main optimisation cycle
    call dlf_run( &
#ifdef GAMESS
        core&
#endif
        )

    ! catch the case of a not-converging initial calculation
    if(.not.tconverged.and. printl >=2 ) then
      write(stdout,1000) "Transition state optimisation not converged, skipping"
      write(stdout,1000) " the downhill runs"
      return
    end if

    ! store the transition structure
    call dlf_formstep_get_ra("TSCOORDS",glob%nat*3,glob%xcoords,tok)
    call store_allocate("tscoords",3*glob%nat)
    call store_set("tscoords",3*glob%nat,glob%xcoords)

    ! store the transition mode
    ! make sure TS-mode from the first run is used
    call dlf_formstep_get_ra("TSMODE_R",glob%nat*3,glob%xcoords2(:,:,1),tok)
    if(.not.tok) then
      write(stdout,1000) "Transition mode not available, skipping"
      write(stdout,1000) " the downhill runs"
      return
    end if

    call store_allocate("tsmode",3*glob%nat)
    call store_set("tsmode",3*glob%nat,glob%xcoords2(:,:,1))

    ! write an xyz file with the TS structure
    if(printf>=4 .and. glob%iam == 0) then
      open(unit=601,file="TS.xyz")
      call write_xyz(601,glob%nat,glob%znuc,glob%xcoords)
      close(601)
      call dlf_put_coords(glob%nvar,3,glob%energy,glob%xcoords,glob%iam)
    end if

    ! Now minimise the system downhill with positive distort
    glob%iopt=3
    glob%iline=1
    glob%toldenergy=.false. ! to initiate a new trust radius
    glob%distort=distort_in
    ! switch off dimer method
    if(glob%icoord>100) glob%icoord=mod(glob%icoord,10)

    call dlf_stat_reset

    if(printl>=2) &
        write(stdout,1000) "Transition state converged, now minimising &
        &downhill into the first direction"

    ! main optimisation cycle
    call dlf_run( &
#ifdef GAMESS
        core&
#endif
        )

    if(printl>=2) then
        write(stdout,1000) "Downhill minimsation in the first&
        & direction has been finished."
        write(stdout,1000) "Now minimising downhill into the second &
            &direction."
      end if

    ! write an xyz file with the minimum structure
    if(tconverged.and.printf>=4 .and. glob%iam == 0) then
      open(unit=601,file="minimum_+.xyz")
      call write_xyz(601,glob%nat,glob%znuc,glob%xcoords)
      close(601)
      call dlf_put_coords(glob%nvar,4,glob%energy,glob%xcoords,glob%iam)
    end if

    ! Now minimise the system downhill with negative distort

    call store_get("tscoords",3,glob%nat,glob%xcoords)
    call store_get("tsmode",3,glob%nat,glob%xcoords2(:,:,1))
    

    glob%toldenergy=.false. ! to initiate a new trust radius
    glob%distort=-distort_in

    call dlf_stat_reset

    ! main optimisation cycle
    call dlf_run( &
#ifdef GAMESS
        core&
#endif
        )

    ! write an xyz file with the minimum structure
    if(tconverged.and.printf>=4 .and. glob%iam == 0) then
      open(unit=601,file="minimum_-.xyz")
      call write_xyz(601,glob%nat,glob%znuc,glob%xcoords)
      close(601)
      call dlf_put_coords(glob%nvar,5,glob%energy,glob%xcoords,glob%iam)
    end if

    call store_delete("tscoords")
    call store_delete("tsmode")

    if(printl>=2) &
        write(stdout,1000) "Finished: Downhill minimsation in the second&
        & direction has been finished."

! ======================================================================
! Wrong task setting
! ======================================================================
  case default
    write(stderr,*) "Task number",glob%task," not implemented"
    call dlf_fail("Task number error")

  end select

1000 format ("TaskManager: ",a)

end subroutine dlf_task
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* task/dlf_task_set_l
!!
!! FUNCTION
!! Set logical entries in the task_module
!!
!! SYNOPSIS
subroutine dlf_task_set_l(label,value)
!! SOURCE
  use dlf_task_module
  implicit none
  character(*), intent(in) :: label
  logical     , intent(in) :: value
! **********************************************************************
  if (label=="CONVERGED") then
    tconverged=value
  else
    call dlf_fail("Wrong label in dlf_task_set_l")
  end if
end subroutine dlf_task_set_l
!!****

!  Copyright (C) 2017 The authors of Py-ChemShell
!
!  This file is part of Py-ChemShell.
!
!  Py-ChemShell is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as
!  published by the Free Software Foundation, either version 3 of the
!  License, or (at your option) any later version.
!
!  Py-ChemShell is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with Py-ChemShell.  If not, see
!  <http://www.gnu.org/licenses/>.

! no MPI methods should appear here
module ChemShellGAModule

    use mpi

    implicit none

    private

    public :: GAType

    integer, parameter :: intType = sizeof(MPI_INTEGER)

    type GAType
        private
        integer(kind=intType), public :: debug
        integer(kind=intType), public :: ncolours
        integer(kind=intType), public :: nkeys
        integer(kind=intType), public :: colour
        integer(kind=intType), public :: comm_colour
        integer(kind=intType), public :: key
        contains
        procedure, public :: initialise
        procedure, public :: is_root
        procedure, public :: finalise    => private_dummy
        procedure, public :: synchronise => private_dummy
        procedure, public :: print       => private_function
        procedure, public :: summarise   => private_function
        procedure, private :: private_dummy
        procedure, private :: private_function
    endtype GAType
    contains
    integer(kind=intType) function initialise(this, ncolours, ga_memory, debug) result(ierror)

        implicit none

!        include 'mpif.h'

        class(GAType)        , intent(inout) :: this
        integer(kind=intType), intent(in)    :: ncolours
        integer(kind=intType), intent(in)    :: ga_memory
        integer(kind=intType), intent(in)    :: debug

        integer(kind=intType) :: rank, nprocs

        this%debug    = debug
        this%ncolours = ncolours

        call MPI_COMM_SIZE(MPI_COMM_WORLD, nprocs, ierror)
        call MPI_COMM_RANK(MPI_COMM_WORLD, rank  , ierror)

        ! TCS: WG_size
        if(mod(nprocs, ncolours).eq.0) then
            this%nkeys = nprocs/ncolours
        else
            print *, ">>> FATAL ERROR: number of processors (-np) not divisible by number of workgroups (-nwg)"
            stop
        endif

        ! TCS: myWorkgroup
        this%colour = rank/this%nkeys

        ! TCS: WG_proc
        this%key = mod(rank, this%nkeys)

    endfunction initialise
    logical function is_root(this) result(result)

        class(GAType), intent(in) :: this

        result = this%key.eq.0

    endfunction is_root
    subroutine private_dummy(this)

        class(GAType), intent(in) :: this

    endsubroutine private_dummy
    integer function private_function(this, arg) result(result)

        class(GAType), intent(in)           :: this
        class(*)     , intent(in), optional :: arg

        result = 0

    endfunction private_function

endmodule ChemShellGAModule

!!****h* main/checkpoint
!!
!! NAME
!! checkpoint
!!
!! FUNCTION
!! Global checkpoint file read and write routines
!!
!!   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!   %%  Global checkpoint file read and write routines                %%
!!   %%  Other files that handle checkpoint information and use this   %%
!!   %%   modue:                                                       %%
!!   %%   dlf_neb.f90                                                  %%
!!   %%   dlf_coords.f90                                               %%
!!   %%   dlf_formstep.f90                                             %%
!!   %%   dlf_lbfgs.f90                                                %%
!!   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!
!!  Issue: An unformatted restart file written by a binary using integer(8)
!!  can not be read by a binary using integer(4) - and vice versa.
!!
!! COPYRIGHT
!!
!!  Copyright 2007 Johannes Kaestner (kaestner@theochem.uni-stuttgart.de),
!!  Tom Keal (thomas.keal@stfc.ac.uk)
!!
!!  This file is part of DL-FIND.
!!
!!  DL-FIND is free software: you can redistribute it and/or modify
!!  it under the terms of the GNU Lesser General Public License as 
!!  published by the Free Software Foundation, either version 3 of the 
!!  License, or (at your option) any later version.
!!
!!  DL-FIND is distributed in the hope that it will be useful,
!!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!!  GNU Lesser General Public License for more details.
!!
!!  You should have received a copy of the GNU Lesser General Public 
!!  License along with DL-FIND.  If not, see 
!!  <http://www.gnu.org/licenses/>.
!!
!! SOURCE
module dlf_checkpoint
  ! variables
  logical,parameter :: tchkform=.false. ! Checkpoint files formatted?

contains
  ! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  subroutine read_separator(unit,name,tok)
    ! read a separator from a checkpoint file and compare it to the
    ! given name. In case they don't match, close the file and 
    ! return tok=false
    use dlf_global, only: glob,stdout,printl
    implicit none
    integer      ,intent(in) :: unit
    character(*) ,intent(in) :: name
    logical      ,intent(out):: tok
    character(20)            :: separator,fname
    ! ******************************************************************
    if(printl >= 4) write(stdout,"('Reading checkpoint: ',a)") &
        name
    if(tchkform) then
      read(unit,'(a20)',end=201,err=200) separator
    else
      read(unit,end=201,err=200) separator
    end if
    write(fname,'(a20)') name
    tok=.true.
    if(separator==fname) return

    write(stdout,10) "Error reading separator "//trim(name)
    close(unit)
    tok=.false.
    return

    ! return on error
200 tok=.false.
    close(unit)
    write(stdout,10) "Error reading file at separator "//trim(name)
    return
201 tok=.false.
    close(unit)
    write(stdout,10) "Error (EOF) reading file at separator "//trim(name)
    return

10  format("Checkpoint reading WARNING: ",a)
  end subroutine read_separator

  ! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  subroutine write_separator(unit,name)
    ! read a separator from a checkpoint file and compare it to the
    ! given name. In case they don't match, close the file and 
    ! return tok=false
    implicit none
    integer      ,intent(in) :: unit
    character(*) ,intent(in) :: name
    character(20)            :: name20
    ! ******************************************************************
    if(tchkform) then
      write(unit,'(a20)') name
    else
      write(name20,'(a20)') name
      write(unit) name20
    end if
  end subroutine write_separator

end module dlf_checkpoint
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* checkpoint/dlf_checkpoint_read
!!
!! FUNCTION
!!
!! Read restart information from checkpoint file
!! If an error in reading is encountered, print warnings, but try to 
!! continue execution as if starting from scratch.
!!
!! SYNOPSIS
subroutine dlf_checkpoint_read(status,tok)
!! SOURCE
  use dlf_parameter_module, only: rk,ik
  use dlf_global, only: glob,stdout,printl
  use dlf_stat, only: stat
  use dlf_checkpoint, only: tchkform, read_separator
  implicit none
  integer,intent(out) :: status
  logical,intent(out) :: tok
  logical       :: tchk
  integer       :: nvar
  integer       :: iopt,iline,lbfgs_mem,icoord,nivar,nimage,ncons,nconn
  integer       :: imultistate, needcoupling
  integer       :: po_pop_size
  logical       :: tcoords2
  ! YL 15/12/2020: we need avoid using file units ifunit, 101, or 102 to make Cray compiler happy
  !                see pp 141: http://103.251.184.12/wp-content/uploads/2018/01/Cray_Fortran_Reference_Manual_S-3901_86.pdf
  !                The values of INPUT_UNIT, OUTPUT_UNIT, and ERROR_UNIT defined in the ISO_Fortran_env module are
  !                ifunit, 101, and 102, respectively. These three unit numbers are reserved and may not be used for other purposes.
  !                The files connected to these units are the same files used by the companion C processor for standard input
  !                (stdin), output (stdout), and error (stderr). An asterisk (*) specified as the unit for a READ statement specifies unit
  !                ifunit. An asterisk specified as the unit for a WRITE statement, and the unit for PRINT statements is unit 101. All
  !                positive default integer values are available for use as unit numbers.
  integer, parameter :: ifunit = 104

! **********************************************************************
  tok=.false.

  ! check if checkpoint file exists
  INQUIRE(FILE="dlf_global.chk",EXIST=tchk)
  if(.not.tchk) then
    write(stdout,10) "File dlf_global.chk not found"
    return
  end if

  if(tchkform) then
    open(unit=ifunit,file="dlf_global.chk",form="formatted")
  else
    open(unit=ifunit,file="dlf_global.chk",form="unformatted")
  end if
  
  call read_separator(ifunit,"Global sizes",tchk)
  if(.not.tchk) return
  if(tchkform) then
    read(ifunit,*,end=201,err=200) &
        nvar, iopt, iline, lbfgs_mem, icoord, nivar, nimage, ncons, nconn, &
        imultistate, needcoupling
  else
    read(ifunit,end=201,err=200) &
        nvar, iopt, iline, lbfgs_mem, icoord, nivar, nimage, ncons, nconn, &
        imultistate, needcoupling
  end if

  if(nvar/=glob%nvar) then
    write(stdout,10) "Different system size"
    write(stdout,*) "nvar read     ",nvar
    write(stdout,*) "nvar expected ",glob%nvar
    write(stdout,*) "Kind of integers in current code",ik
    if(nvar>huge(1_4).and..not.tchkform ) then
      if(ik==8) then
        write(stdout,*) "This may mean that the checkpoint file was written by a DL-FIND version "
        write(stdout,*) "using integer(4) while the current one uses integer(8)."
        write(stdout,*) "A solution may be to recompile the current code using integer(4)."
      end if
    end if
    
    close(ifunit)
    return
  end if
  if(iopt/=glob%iopt) then
    write(stdout,10) "Different optimiser (iopt)"
    write(stdout,*) "iopt read     ",iopt
    write(stdout,*) "iopt expected ",glob%iopt
    write(stdout,*) "Kind of integers in current code",ik
    if(iopt==0.and..not.tchkform) then
      if(ik==4) then
        write(stdout,*) "This may mean that the checkpoint file was written by a DL-FIND version "
        write(stdout,*) "using integer(8) while the current one uses integer(4)."
        write(stdout,*) "A solution may be to recompile the current code using integer(8)."
      end if
    end if
    close(ifunit)
    return
  end if
  if(iline/=glob%iline) then
    write(stdout,10) "Different line search (iline)"
    close(ifunit)
    return
  end if
  if(lbfgs_mem/=glob%lbfgs_mem) then
    write(stdout,10) "Different memory size of L-BFGS"
    close(ifunit)
    return
  end if
  if(icoord/=glob%icoord) then
    write(stdout,10) "Different coordinate definition (icoord)"
    close(ifunit)
    return
  end if
  if(nivar/=glob%nivar) then
    write(stdout,10) "Different number of internal coordinates"
    close(ifunit)
    return
  end if
  if(nimage/=glob%nimage) then
    write(stdout,10) "Different number of images"
    close(ifunit)
    return
  end if
  if(ncons/=glob%ncons) then
    write(stdout,10) "Different number of constraints"
    close(ifunit)
    return
  end if
  if(nconn/=glob%nconn) then
    write(stdout,10) "Different number of user connections"
    close(ifunit)
    return
  end if
  if(imultistate/=glob%imultistate) then
    write(stdout,10) "Different multistate calculation (imultistate)"
    close(ifunit)
    return
  end if
  if(needcoupling/=glob%needcoupling) then
    write(stdout,10) "Different multistate calculation (needcoupling)"
    close(ifunit)
    return
  end if
    
  call read_separator(ifunit,"Global parameters",tchk)
  if(.not.tchk) return
  
  if(tchkform) then
    read(ifunit,*,end=201,err=200) &
        glob%nat ,printl ,glob%tolerance, glob%energy &
        , glob%oldenergy ,glob%toldenergy ,glob%tinit &
        , glob%tatoms &
        , glob%maxene, glob%maxstep, glob%scalestep &
        , glob%taccepted, glob%nebk &
        , glob%update, glob%maxupd, glob%delta &
        , glob%toldenergy_conv, glob%oldenergy_conv
  else
    read(ifunit,end=201,err=200) &
        glob%nat ,printl ,glob%tolerance, glob%energy &
        , glob%oldenergy ,glob%toldenergy ,glob%tinit &
        , glob%tatoms &
        , glob%maxene, glob%maxstep, glob%scalestep &
        , glob%taccepted, glob%nebk &
        , glob%update, glob%maxupd, glob%delta &
        , glob%toldenergy_conv, glob%oldenergy_conv
  end if

  call read_separator(ifunit,"XYZ data",tchk)
  if(.not.tchk) return

  if(tchkform) then
    read(ifunit,*,end=201,err=200) &
        glob%xcoords, glob%xgradient &
        , glob%weight, glob%mass
    if(glob%tcoords2) read(ifunit,*,end=201,err=200) glob%xcoords2
  else
    read(ifunit,end=201,err=200) &
        glob%xcoords, glob%xgradient &
        , glob%weight, glob%mass
    if(glob%tcoords2) read(ifunit,end=201,err=200) glob%xcoords2
  end if

  call read_separator(ifunit,"internal c data",tchk)
  if(.not.tchk) return
  
  if(tchkform) then
    read(ifunit,*,end=201,err=200) &
        glob%icoords, glob%igradient, glob%step, glob%spec, glob%icons &
        , glob%iconn
  else
    read(ifunit,end=201,err=200) &
        glob%icoords, glob%igradient, glob%step, glob%spec, glob%icons &
        , glob%iconn
  end if

  if (glob%imultistate > 0) then
     call read_separator(ifunit, "Multistate data", tchk)
     if (.not. tchk) return
     if (tchkform) then
        read(ifunit, *, end=201, err=200) &
             glob%state_i, glob%state_j, &
             glob%pf_c1, glob%pf_c2, glob%gp_c3, glob%gp_c4, &
             glob%ln_t1, glob%ln_t2
        read(ifunit, *, end=201, err=200) &
             glob%msenergy, glob%msgradient, glob%mscoupling
     else
        read(ifunit, end=201, err=200) &
             glob%state_i, glob%state_j, &
             glob%pf_c1, glob%pf_c2, glob%gp_c3, glob%gp_c4, &
             glob%ln_t1, glob%ln_t2
        read(ifunit, end=201, err=200) &
             glob%msenergy, glob%msgradient, glob%mscoupling
     endif
  end if

  if (glob%iopt/10 == 5) then
     call read_separator(ifunit, "Parallel opt data", tchk)
     if (.not. tchk) return
     if (tchkform) then
        read(ifunit, *, end=201, err=200) &
             po_pop_size, glob%po_radius_base, &
             glob%po_contraction, glob%po_tol_r_base, glob%po_tolerance_g, &
             glob%po_distribution, glob%po_maxcycle, glob%po_init_pop_size, &
             glob%po_reset, glob%po_mutation_rate, glob%po_death_rate, &
             glob%po_scalefac, glob%po_nsave
     else
        read(ifunit, end=201, err=200) &
             po_pop_size, glob%po_radius_base, &
             glob%po_contraction, glob%po_tol_r_base, glob%po_tolerance_g, &
             glob%po_distribution, glob%po_maxcycle, glob%po_init_pop_size, &
             glob%po_reset, glob%po_mutation_rate, glob%po_death_rate, &
             glob%po_scalefac, glob%po_nsave
     endif
     if (po_pop_size /= glob%po_pop_size) then
        write(stdout,10) "Different population size"
        close(ifunit)
        return
     end if
  end if

  call read_separator(ifunit,"stat module",tchk)
  if(.not.tchk) return

  if(tchkform) then
    read(ifunit,*,end=201,err=200) stat
  else
    read(ifunit,end=201,err=200) stat
  end if

  call read_separator(ifunit,"status",tchk)
  if(.not.tchk) return

  if(tchkform) then
    read(ifunit,*,end=201,err=200) status
  else
    read(ifunit,end=201,err=200) status
  end if

  call read_separator(ifunit,"END",tchk)
  if(.not.tchk) return

  if(printl >= 4) write(stdout,"('Global checkpoint file successfully read')")

  tok=.true.
  close(ifunit)

  call dlf_checkpoint_coords_read(tok)
  if(.not.tok) return
  call dlf_checkpoint_formstep_read(tok)
  if(.not.tok) return
  call dlf_checkpoint_linesearch_read(tok)
  if(.not.tok) return
  call dlf_checkpoint_conint_read(tok)
  if(.not.tok) return

  return

  ! return on error
  close(ifunit)
200 continue
  write(stdout,10) "Error reading global checkpoint file"
  return
201 continue
  write(stdout,10) "Error (EOF) reading file"
  return

10 format("Checkpoint reading WARNING: ",a)
end subroutine dlf_checkpoint_read
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* checkpoint/dlf_checkpoint_write
!!
!! FUNCTION
!!
!! Write restart information to checkpoint file
!!
!! SYNOPSIS
subroutine dlf_checkpoint_write(status)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,printl
  use dlf_stat, only: stat
  use dlf_checkpoint, only: tchkform, write_separator
  implicit none
  integer, intent(in) :: status
  character(20) :: separator
  integer, parameter :: ifunit = 104
! **********************************************************************

! Only want one processor to do the writing; that processor must know 
! all the necessary information.
  if (glob%iam /= 0) return
  ! Q: Should task-farming really be treated differently?
  ! It might be better for each 
  ! workgroup to write its own checkpoint so task-farming 
  ! runs could restart at any point too (at the cost of extra
  ! I/O and disk space) - this could be useful for a
  ! large standalone FD Hessian calc for example.
  ! If this were done then ntasks should be 
  ! saved to chk files as this would need to be consistent on restart.
  ! In most sophisticated solution each workgroup would write 
  ! only the data which differed between workgroups.
  ! NB: File names would have to be labelled by workgroup too 
  ! as we cannot assume each has its own scratch directory.
  if(tchkform) then
    open(unit=ifunit,file="dlf_global.chk",form="formatted")
    call write_separator(ifunit,"Global sizes")
    write(ifunit,*) &
        glob%nvar, glob%iopt, glob%iline, glob%lbfgs_mem, glob%icoord, &
        glob%nivar, glob%nimage, glob%ncons, glob%nconn, &
        glob%imultistate, glob%needcoupling
    call write_separator(ifunit,"Global parameters")
    write(ifunit,*) &
        glob%nat ,printl ,glob%tolerance, glob%energy &
        , glob%oldenergy ,glob%toldenergy ,glob%tinit &
        , glob%tatoms &
        , glob%maxene, glob%maxstep, glob%scalestep &
        , glob%taccepted, glob%nebk &
        , glob%update, glob%maxupd, glob%delta &
        , glob%toldenergy_conv, glob%oldenergy_conv
    call write_separator(ifunit,"XYZ data")
    write(ifunit,*) glob%xcoords, glob%xgradient &
        , glob%weight, glob%mass
    if(glob%tcoords2)  write(ifunit,*) glob%xcoords2
    call write_separator(ifunit,"internal c data")
    write(ifunit,*) glob%icoords, glob%igradient, glob%step, glob%spec &
        , glob%icons, glob%iconn
    if (glob%imultistate > 0) then
       call write_separator(ifunit,"Multistate data")
       write(ifunit,*) glob%state_i, glob%state_j, &
            glob%pf_c1, glob%pf_c2, glob%gp_c3, glob%gp_c4, &
            glob%ln_t1, glob%ln_t2
       write(ifunit,*) &
            glob%msenergy, glob%msgradient, glob%mscoupling 
    endif
    if (glob%iopt/10 == 5) then
       call write_separator(ifunit, "Parallel opt data")
       write(ifunit, *) &
            glob%po_pop_size, glob%po_radius_base, &
            glob%po_contraction, glob%po_tol_r_base, glob%po_tolerance_g, &
            glob%po_distribution, glob%po_maxcycle, glob%po_init_pop_size, &
            glob%po_reset, glob%po_mutation_rate, glob%po_death_rate, &
            glob%po_scalefac, glob%po_nsave
    end if
    call write_separator(ifunit,"stat module")
    write(ifunit,*) stat
    call write_separator(ifunit,"status")
    write(ifunit,*) status
    call write_separator(ifunit,"END")

  else
    open(unit=ifunit,file="dlf_global.chk",form="unformatted")
    call write_separator(ifunit,"Global sizes")
    write(ifunit) &
        glob%nvar, glob%iopt, glob%iline, glob%lbfgs_mem, glob%icoord, &
        glob%nivar, glob%nimage, glob%ncons, glob%nconn, &
       glob%imultistate, glob%needcoupling
    call write_separator(ifunit,"Global parameters")
    write(ifunit) &
        glob%nat ,printl ,glob%tolerance, glob%energy &
        , glob%oldenergy ,glob%toldenergy ,glob%tinit &
        , glob%tatoms &
        , glob%maxene, glob%maxstep, glob%scalestep &
        , glob%taccepted, glob%nebk &
        , glob%update, glob%maxupd, glob%delta &
        , glob%toldenergy_conv, glob%oldenergy_conv
    call write_separator(ifunit,"XYZ data")
    write(ifunit) glob%xcoords, glob%xgradient &
        , glob%weight, glob%mass
    if(glob%tcoords2) write(ifunit) glob%xcoords2
    call write_separator(ifunit,"internal c data")
    write(ifunit) glob%icoords, glob%igradient, glob%step, glob%spec &
        , glob%icons, glob%iconn
    if (glob%imultistate > 0) then
       call write_separator(ifunit,"Multistate data")
       write(ifunit) glob%state_i, glob%state_j, &
            glob%pf_c1, glob%pf_c2, glob%gp_c3, glob%gp_c4, &
            glob%ln_t1, glob%ln_t2
       write(ifunit) &
            glob%msenergy, glob%msgradient, glob%mscoupling 
    endif
    if (glob%iopt/10 == 5) then
       call write_separator(ifunit, "Parallel opt data")
       write(ifunit) &
            glob%po_pop_size, glob%po_radius_base, &
            glob%po_contraction, glob%po_tol_r_base, glob%po_tolerance_g, &
            glob%po_distribution, glob%po_maxcycle, glob%po_init_pop_size, &
            glob%po_reset, glob%po_mutation_rate, glob%po_death_rate, &
            glob%po_scalefac, glob%po_nsave
    end if
    call write_separator(ifunit,"stat module")
    write(ifunit) stat
    call write_separator(ifunit,"status")
    write(ifunit) status
    call write_separator(ifunit,"END")
  end if

  close(ifunit)

  call dlf_checkpoint_coords_write
  call dlf_checkpoint_formstep_write
  call dlf_checkpoint_linesearch_write
  call dlf_checkpoint_conint_write

end subroutine dlf_checkpoint_write
!!****

  !=========================================================================!
  ! Key Internal Variables:                                                 !
  !          seedname - the seedname  that was passed on the command line   !
  !-------------------------------------------------------------------------!
  ! Rajany K. V. on 13/March/2023 using the libcastep.so and castep_lib.f90 !                                          !
  ! written by Peter Byrne.                                                 !
  !=========================================================================!
  
  subroutine castepfunc(input_seed, initial, is_root, communicator, &
                        energy, forces, new_lattice, new_positions, natoms)

  !castep_lib.mod is used to call the functions in the corresponding library
  use castep_lib, only     :  initialise, calculate_energy, calculate_forces,&
                              update_lattice_and_positions

  implicit none

  !Rajany: this is the double used in castep
  integer, parameter :: dp=selected_real_kind(15,300)
  logical, save :: initialised = .false.
  
  character(len=*), intent(in)         :: input_seed
  logical         , intent(in)         :: initial
  logical         , intent(in)         :: is_root
  integer(kind=4) , intent(in)         :: communicator
  real(kind=dp)   , intent(inout)      :: energy
  real(kind=dp), dimension(:,:), allocatable,  intent(out) :: forces
  real(kind=dp), dimension(3,3), intent(inout)             :: new_lattice
  real(kind=dp), dimension(:,:), intent(in)                :: new_positions
  integer(kind=4) , intent(in)         :: natoms

  !Rajany: Other arguments
  integer                              :: linput
  character(len=:), allocatable        :: input_seedname


  linput=len(trim(adjustl(input_seed)))

  allocate(character(len=linput):: input_seedname)
  allocate(forces(3,natoms))
  !print *, forces  
  !flush(6)
  input_seedname = input_seed(1:linput)

  if(initial) then
      if(is_root) then
          write(*, '(/A/)') " ChemShell/CASTEP: initialising..." ! New line !! .. text string new line
          call flush(6)
      endif
      call initialise(communicator,input_seedname)
      !write(*,'(/A/)') "Initialized"
      !call flush(6)
      !endif
  else
      call update_lattice_and_positions(new_lattice, new_positions)
      !write(*,'(/A/)') "Updated positions"
      !call flush(6)
  endif

  call calculate_energy(energy)
  call calculate_forces(forces)

  deallocate(input_seedname)
end subroutine castepfunc

! **********************************************************************
! **                  Utility functions to DL-FIND                    **
! **                                                                  **
! **  Several sub-files:                                              **
! **   dlf_allocate                                                   **
! **   dlf_checkpoint                                                 **
! **   dlf_linalg                                                     **
! **   dlf_time                                                       **
! **                                                                  **
! **********************************************************************
!!****h* DL-FIND/utilities
!!
!! NAME
!! utilities
!!
!! FUNCTION
!! Utility functions to DL-FIND
!!
!! DATA
!! $Date$
!! $Rev$
!! $Author$
!! $URL$
!! $Id$
!!
!! COPYRIGHT
!!
!!  Copyright 2007 Johannes Kaestner (kaestner@theochem.uni-stuttgart.de),
!!  Tom Keal (thomas.keal@stfc.ac.uk)
!!
!!  This file is part of DL-FIND.
!!
!!  DL-FIND is free software: you can redistribute it and/or modify
!!  it under the terms of the GNU Lesser General Public License as 
!!  published by the Free Software Foundation, either version 3 of the 
!!  License, or (at your option) any later version.
!!
!!  DL-FIND is distributed in the hope that it will be useful,
!!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!!  GNU Lesser General Public License for more details.
!!
!!  You should have received a copy of the GNU Lesser General Public 
!!  License along with DL-FIND.  If not, see 
!!  <http://www.gnu.org/licenses/>.
!!
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
character(2) function get_atom_symbol(atomic_number)
  implicit none
  integer, intent(in) :: atomic_number
  character(2), parameter :: elements(111) = &
       (/ 'H ','He', &
          'Li','Be','B ','C ','N ','O ','F ','Ne', &
          'Na','Mg','Al','Si','P ','S ','Cl','Ar', &
          'K ','Ca','Sc','Ti','V ','Cr','Mn','Fe','Co','Ni','Cu', &
          'Zn','Ga','Ge','As','Se','Br','Kr', &
          'Rb','Sr','Y ','Zr','Nb','Mo','Tc','Ru','Rh','Pd','Ag', &
          'Cd','In','Sn','Sb','Te','I ','Xe', &
          'Cs','Ba','La','Ce','Pr','Nd','Pm','Sm','Eu','Gd','Tb','Dy', &
          'Ho','Er','Tm','Yb','Lu','Hf','Ta','W ','Re','Os','Ir','Pt', &
          'Au','Hg','Tl','Pb','Bi','Po','At','Rn', &
          'Fr','Ra','Ac','Th','Pa','U ','Np','Pu','Am','Cm','Bk','Cf', &
          'Es','Fm','Md','No','Lr','Rf','Db','Sg','Bh','Hs','Mt','Ds', &
          'Rg' /)
! **********************************************************************
  if (atomic_number >= 1 .and. atomic_number <= size(elements)) then
     get_atom_symbol = elements(atomic_number)
  else
     get_atom_symbol = 'XX'
  endif
end function get_atom_symbol 

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
module dlf_bspline

  ! creates a set of cubic spline functions with the same number of 
  ! grid points (length).
  ! Their x-values may be different
  !
  ! Calling-Sequence:
  !   call spline_init
  !   call spline_create once for each function (each ifunc)
  !   call spline_get for each interpolated value
  !   call spline_destroy

  use dlf_parameter_module, only: rk
  use dlf_allocate, only: allocate,deallocate
  implicit none

  public :: spline_init, spline_create, spline_get, spline_destroy, spline_create_clamped

  interface spline_init
    module procedure spline_init
  end interface

  interface spline_create
    module procedure spline_create
    module procedure spline_create_nonnatural
  end interface

  interface spline_create_clamped
    module procedure spline_create_clamped
  end interface

  interface spline_get
    module procedure spline_get
  end interface

  interface spline_destroy
    module procedure spline_destroy
  end interface

  private
  logical :: tinit
  integer :: nfunc ! number of functions to be interpolated
  integer :: length ! number of values to be interpolated between
  logical, allocatable, save :: created(:) ! (nfunc)
  real(rk),allocatable, save :: gridx(:,:) ! (length,nfunc) !x values of grid
  real(rk),allocatable, save :: gridy(:,:) ! (length,nfunc) !y values of grid
  real(rk),allocatable, save :: grid_d2ydx2(:,:) ! (length,nfunc)
contains

  subroutine spline_init(length_in,nfunc_in)
    integer, intent(in) :: length_in 
    integer, intent(in) :: nfunc_in 
    ! ******************************************************************

    ! re-initialise if necessary
    if(allocated(created)) call spline_destroy

    nfunc=nfunc_in
    length=length_in
    if(nfunc*length<=0) call dlf_fail("wrong parameters to spline_init")

    tinit=.true.
    call allocate(created,nfunc)
    call allocate(gridx,length,nfunc)
    call allocate(gridy,length,nfunc)
    call allocate(grid_d2ydx2,length,nfunc)

    created(:)=.false.

  end subroutine spline_init

  subroutine spline_destroy
    ! ******************************************************************
    tinit=.false.
    call deallocate(created)
    call deallocate(gridx)
    call deallocate(gridy)
    call deallocate(grid_d2ydx2)

  end subroutine spline_destroy

  SUBROUTINE spline_create(ifunc,x_in,y_in)
    ! creates the spline function number ifunc, i.e. calculates its 
    ! second derivatives at the grid points
    ! x_in must be monotonically increasing
    ! using natural boundary conditions
    ! ******************************************************************
    integer , intent(in) :: ifunc
    real(rk), intent(in) :: x_in(length),y_in(length)
    !
    real(rk) :: store(length)! u
    real(rk) :: svar, svar2  ! sig, p
    integer  :: ival
    ! ******************************************************************

    ! check integrity
    if(.not.tinit) call dlf_fail("spline_create must not be called &
        &before spline_init!")
    if(ifunc<1) call dlf_fail("ifunc < 1 in spline_create")
    if(ifunc>nfunc) call dlf_fail("ifunc > nfunc in spline_create")
    
    gridx(:,ifunc)=x_in(:)
    gridy(:,ifunc)=y_in(:)

    ! natural boundaries
    grid_d2ydx2(1,ifunc)=0.D0
    store(1)=0.D0

    do ival=2,length-1
      svar=(gridx(ival,ifunc)-gridx(ival-1,ifunc))/(gridx(ival+1,ifunc)-gridx(ival-1,ifunc))
      svar2=svar*grid_d2ydx2(ival-1,ifunc)+2.D0
      grid_d2ydx2(ival,ifunc)=(svar-1.D0)/svar2
      store(ival)=(6.D0*((gridy(ival+1,ifunc)-gridy(ival,ifunc))/(gridx(ival+1,ifunc)- &
          gridx(ival,ifunc))-(gridy(ival,ifunc)-gridy(ival-1,ifunc)) /(gridx(ival,ifunc)- &
          gridx(ival-1,ifunc)))/(gridx(ival+1,ifunc)-gridx(ival-1,ifunc))- &
          svar*store(ival-1))/svar2
    enddo

    ! natural boundaries
    grid_d2ydx2(length,ifunc)=0.D0

    do ival=length-1,1,-1 
      grid_d2ydx2(ival,ifunc)=grid_d2ydx2(ival,ifunc)*grid_d2ydx2(ival+1,ifunc)+store(ival) 
    enddo

    created(ifunc)=.true.

  END SUBROUTINE spline_create

  SUBROUTINE spline_create_nonnatural(ifunc,x_in,y_in,d2y_low,d2y_high)
    ! creates the spline function number ifunc, i.e. calculates its 
    ! second derivatives at the grid points
    ! x_in must be monotonically increasing
    ! using natural boundary conditions
    ! ******************************************************************
    integer , intent(in) :: ifunc
    real(rk), intent(in) :: x_in(length),y_in(length)
    real(rk), intent(in) :: d2y_low,d2y_high
    !
    real(rk) :: store(length)! u
    real(rk) :: svar, svar2  ! sig, p
    integer  :: ival
    ! ******************************************************************

    ! check integrity
    if(.not.tinit) call dlf_fail("spline_create must not be called &
        &before spline_init!")
    if(ifunc<1) call dlf_fail("ifunc < 1 in spline_create")
    if(ifunc>nfunc) call dlf_fail("ifunc > nfunc in spline_create")
    
    gridx(:,ifunc)=x_in(:)
    gridy(:,ifunc)=y_in(:)

    !print*,"JK dy2 low hi",d2y_low,d2y_high

    ! non-natural boundaries
    grid_d2ydx2(1,ifunc)=d2y_low
    store(1)=d2y_low

    do ival=2,length-1
      svar=(gridx(ival,ifunc)-gridx(ival-1,ifunc))/(gridx(ival+1,ifunc)-gridx(ival-1,ifunc))
      svar2=svar*grid_d2ydx2(ival-1,ifunc)+2.D0
      grid_d2ydx2(ival,ifunc)=(svar-1.D0)/svar2
      store(ival)=(6.D0*((gridy(ival+1,ifunc)-gridy(ival,ifunc))/(gridx(ival+1,ifunc)- &
          gridx(ival,ifunc))-(gridy(ival,ifunc)-gridy(ival-1,ifunc)) /(gridx(ival,ifunc)- &
          gridx(ival-1,ifunc)))/(gridx(ival+1,ifunc)-gridx(ival-1,ifunc))- &
          svar*store(ival-1))/svar2
    enddo

    ! non-natural boundaries
    grid_d2ydx2(length,ifunc)=d2y_high

    do ival=length-1,1,-1 
      grid_d2ydx2(ival,ifunc)=grid_d2ydx2(ival,ifunc)*grid_d2ydx2(ival+1,ifunc)+store(ival) 
    enddo

    !print*,"store 1 len",store(1),store(length)
    !print*,"grid_d2ydx2( 1, length",grid_d2ydx2(1,ifunc),grid_d2ydx2(length,ifunc)

    created(ifunc)=.true.

  END SUBROUTINE spline_create_nonnatural

  SUBROUTINE spline_create_clamped(ifunc,x_in,y_in,dy_low,dy_high)
    ! creates the spline function number ifunc, i.e. calculates its 
    ! second derivatives at the grid points
    ! x_in must be monotonically increasing
    ! The two extral conditions are the first derivatives at the endpoints
    ! ******************************************************************
    integer , intent(in) :: ifunc
    real(rk), intent(in) :: x_in(length),y_in(length)
    real(rk), intent(in) :: dy_low,dy_high
    !
    real(rk) :: amat(length,length)
    real(rk) :: bvec(length)
    real(rk) :: svar
    integer  :: ival,jval
    ! ******************************************************************

    ! check integrity
    if(.not.tinit) call dlf_fail("spline_create must not be called &
        &before spline_init!")
    if(ifunc<1) call dlf_fail("ifunc < 1 in spline_create")
    if(ifunc>nfunc) call dlf_fail("ifunc > nfunc in spline_create")
    
    gridx(:,ifunc)=x_in(:)
    gridy(:,ifunc)=y_in(:)

    !print*,"JK dy low hi",dy_low,dy_high

    amat(:,:)=0.D0
    bvec(:)=0.D0
    ! conditions of C2-continuity:
    do ival=2,length-1
      amat(ival,ival-1)=x_in(ival)-x_in(ival-1)
      amat(ival,ival  )=2.D0*(x_in(ival+1)-x_in(ival-1))
      amat(ival,ival+1)=x_in(ival+1)-x_in(ival)
      bvec(ival)=3.D0*( (y_in(ival+1)-y_in(ival))/(x_in(ival+1)-x_in(ival)) - &
          (y_in(ival)-y_in(ival-1))/(x_in(ival)-x_in(ival-1)) )
    end do

    ! now first derivatives at bounds:
    amat(1,1)=-2.D0*(x_in(2)-x_in(1))/3.D0
    amat(1,2)=-(x_in(2)-x_in(1))/3.D0
    bvec(1)=dy_low-(y_in(2)-y_in(1))/(x_in(2)-x_in(1))

    amat(length,length-1)=(x_in(length)-x_in(length-1))/3.D0
    amat(length,length)=2.D0*(x_in(length)-x_in(length-1))/3.D0
    bvec(length)=dy_high-(y_in(length)-y_in(length-1))/(x_in(length)-x_in(length-1))
!!$
!!$    ! natural:
!!$    amat(1,1)=1.D0
!!$    amat(length,length)=1.D0
    

    ! solve Ax=B
    call dlf_matrix_invert(length,.false.,amat,svar) ! this is really an overkill ...
    !print*,"Determinant",svar
    grid_d2ydx2(:,ifunc)=2.D0*matmul(amat,bvec)
    !  grid_d2ydx2(:,ifunc)= 2.D0*x
    

    created(ifunc)=.true.

  END SUBROUTINE spline_create_clamped

  SUBROUTINE spline_get(ifunc,xval,yval,dyval,d2yval)
    ! calculates a cubic-spline interpolated value (yval) and its 
    ! derivative (dyval) at a position xval
    ! this is done for the interpolation ifunc
    ! ******************************************************************
    integer ,intent(in) :: ifunc
    real(rk),intent(in) :: xval
    real(rk),intent(out):: yval
    real(rk),intent(out):: dyval
    real(rk),intent(out):: d2yval
    ! 
    integer  :: low,high,ivar
    real(rk) :: aval,bval,delta
    ! ******************************************************************

    ! check integrity
    if(.not.tinit)  call dlf_fail("spline_get must not be called before &
        &spline_init!")
    if(ifunc<1) call dlf_fail("ifunc < 1 in spline_get")
    if(ifunc>nfunc) call dlf_fail("ifunc > nfunc in spline_get")
    if(.not.created(ifunc)) then
      print*,"Number of spline:",ifunc
      call dlf_fail("spline_get must not be called&
        & before spline_create!")
    end if
    
    low=1 
    ! bisection on the grid
    high=length
    do while (high-low>1) 
      ivar=(high+low)/2
      if(gridx(ivar,ifunc).gt.xval)then
        high=ivar
      else
        low=ivar
      endif
    end do
    !low and high now bracket the input value of xval.

    delta=gridx(high,ifunc)-gridx(low,ifunc)

    if (delta<=0.D0) call dlf_fail("grid points for spline not distinct")

    aval=(gridx(high,ifunc)-xval)/delta !Cubic spline polynomial is now evaluated.
    bval=(xval-gridx(low,ifunc))/delta
    yval=aval*gridy(low,ifunc)+bval*gridy(high,ifunc) + ((aval**3-aval)* &
        grid_d2ydx2(low,ifunc)+(bval**3-bval)*grid_d2ydx2(high,ifunc)) &
        *(delta**2)/6.D0
    dyval=1.D0/delta * ( gridy(high,ifunc) - gridy(low,ifunc) + delta**2/6.D0 * ( &
        (3.D0*bval**2-1.D0) * grid_d2ydx2(high,ifunc) - &
        (3.D0*aval**2-1.D0) * grid_d2ydx2(low,ifunc) ) ) 
    d2yval=bval * grid_d2ydx2(high,ifunc) + &
         aval * grid_d2ydx2(low,ifunc) 
  END SUBROUTINE spline_get

end module dlf_bspline
! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
module dlf_store

  ! Allocates bunches of memory, to store (mainly real number) data
  ! The data are organised in a linked list. They can be set, read out
  ! and deleted
  !
  use dlf_parameter_module, only: rk
  use dlf_global, only: stderr,stdout
  use dlf_allocate, only: allocate,deallocate
  implicit none

  public :: store_initialise, store_allocate, store_set, store_get, &
      store_delete, store_delete_all

  interface store_initialise
    module procedure store_initialise
  end interface

  interface store_allocate
    module procedure store_allocate
  end interface

  interface store_set
    module procedure store_set
    module procedure store_set_a2
    module procedure store_set_a3
  end interface

  interface store_get
    module procedure store_get
    module procedure store_get_a2
    module procedure store_get_a3
  end interface

  interface store_delete
    module procedure store_delete
  end interface

  interface store_delete_all
    module procedure store_delete_all
  end interface

  private

  type store_type_R
    character(40)              :: tag
    integer                    :: size
    real(rk),pointer           :: array(:)
    type(store_type_R),pointer :: next
  end type store_type_R

  type(store_type_R),pointer,save :: first_R
  logical                   ,save :: tinit=.false.

contains

  subroutine store_initialise
    ! ******************************************************************
    if(tinit) call dlf_fail("store is already initialised")
    allocate(first_R)
    nullify(first_R%next)
    nullify(first_R%array)
    first_R%size=0
    first_R%tag=""
    tinit=.true.
  end subroutine store_initialise

  subroutine store_allocate(tag,size)
    character(*)      ,intent(in) :: tag
    integer           ,intent(in) :: size
    type(store_type_R),pointer    :: this
    ! ******************************************************************
    this => first_R
    !print*,"This%size 1",This%size
    ! find last used entry
    do while (associated(this%next))
      !print*," allocate search: this%tag ",this%tag
      if(this%tag == tag) call dlf_fail("Store tag aleady allocated")
      this => this%next
    end do
    ! this is now last set entry
    !print*,"This%size 2",This%size

    ! if this is the first entry, and it is empty, use it, otherwhise use the next
    if(this%size > 0) then
      allocate(this%next)
      this => this%next
      nullify(this%next)
      nullify(this%array)
    end if

    ! set tag and size
    this%tag=tag
    this%size=size
    !print*,"allocated(this%array)",associated(this%array)
    if(associated(this%array)) print*,"shape(this%array)",shape(this%array)
    allocate (this%array(size)) ! pointer

  end subroutine store_allocate

  subroutine store_set(tag,size,array)
    character(*)      ,intent(in) :: tag
    integer           ,intent(in) :: size
    real(rk)          ,intent(in) :: array(size)
    type(store_type_R),pointer    :: this
    ! ******************************************************************

    ! find correct entry
    this => first_R
    do while (associated(this))
      !print*," set search: this%tag ",this%tag
      if(this%tag == tag) exit
      this => this%next
    end do

    if(.not.associated(this)) then
      write(stdout,*) "Storage tag ",tag," not found!"
      call dlf_fail("Storage tag to set not found")
    end if

    if(this%size /= size) call dlf_fail("Storage set size inconsistent")

    this%array(:)=array(:)

    !print*,"Tag ",tag," now set"

  end subroutine store_set

  subroutine store_get(tag,size,array)
    character(*)      ,intent(in) :: tag
    integer           ,intent(in) :: size
    real(rk)          ,intent(out):: array(size)
    type(store_type_R),pointer    :: this
    ! ******************************************************************

    ! find correct entry
    this => first_R
    do while (associated(this))
      !print*," get search: this%tag ",this%tag
      if(this%tag == tag) exit
      this => this%next
    end do

    if(.not.associated(this)) then
      write(stdout,*) "Storage tag ",tag," not found!"
      call dlf_fail("Storage tag to get not found")
    end if

    if(this%size /= size) call dlf_fail("Storage get size inconsistent")

    array(:)=this%array(:)
    !print*,"Tag ",tag," now got"

  end subroutine store_get

  subroutine store_delete(tag)
    ! delete one tag
    character(*)      ,intent(in) :: tag
    type(store_type_R),pointer    :: this,del

    ! find correct entry
    this => first_R

    ! handle the case of deletion of the first entry separately
    if(this%tag == tag) then
      if(.not.associated(this%next)) then
        ! first entry is the only entry
        !print*," deleting first and only entry ",tag
        if(associated(this%array)) deallocate(this%array) ! pointer
        this%size=0
        this%tag=""
      else
        ! other entries exist
        !print*," deleting first entry ",tag
        first_R => this%next
        if(associated(this%array)) deallocate(this%array) ! pointer
        deallocate(this)
      end if
      return
    end if

    do while (associated(this%next))
      !print*," delete search: this%next%tag ",this%next%tag
      if(this%next%tag == tag) exit
      this => this%next
    end do
    ! this%next points to the tag to be deleted

    if(.not.associated(this%next)) then
      write(stdout,*) "Storage tag ",tag," not found!"
      call dlf_fail("Storage tag to delete not found")
    end if

    ! delete this%next
    this%next%size=0
    if(associated(this%next%array)) then
      deallocate(this%next%array) ! pointer
      !print*,"Deallocating tag ",this%next%tag
    else
      !print*,"Warning: not able to deallocate tag",tag
    end if

    if(associated(this%next%next)) then
      del => this%next%next
      deallocate(this%next)
      this%next => del
    else
      ! the one to be deleted is the last one
      deallocate(this%next)
      nullify(this%next)
    end if

  end subroutine store_delete

  subroutine store_delete_all
    ! delete all tags
    type(store_type_R),pointer    :: this,next

    if(.not.tinit) return

    this => first_R

    do while (associated(this%next))
      next => this%next
      !print*," deleteing this%tag ",this%tag

      if(associated(this%array)) deallocate(this%array) ! pointer
      deallocate(this)

      this => next
    end do

    ! now deallocate the last one
    !print*," deleteing this%tag ",this%tag

    if(associated(this%array)) deallocate(this%array) ! pointer
    deallocate(this)

    tinit=.false.

  end subroutine store_delete_all

  subroutine store_set_a2(tag,size,array)
    ! dummy routine to cover rank 2 arrays
    character(*)      ,intent(in) :: tag
    integer           ,intent(in) :: size
    real(rk)          ,intent(in) :: array(:,:)
    call store_set(tag,size,reshape(array,(/size/)))
  end subroutine store_set_a2

  subroutine store_set_a3(tag,size,array)
    ! dummy routine to cover rank 3 arrays
    character(*)      ,intent(in) :: tag
    integer           ,intent(in) :: size
    real(rk)          ,intent(in) :: array(:,:,:)
    call store_set(tag,size,reshape(array,(/size/)))
  end subroutine store_set_a3

  subroutine store_get_a2(tag,size1,size2,array)
    ! dummy routine to cover rank 2 arrays
    character(*)      ,intent(in) :: tag
    integer           ,intent(in) :: size1
    integer           ,intent(in) :: size2
    real(rk)          ,intent(out):: array(:,:)
    real(rk)  :: tmp_array(size1*size2)
    call store_get(tag,size1*size2,tmp_array)
    array=reshape(tmp_array,(/size1,size2/))
  end subroutine store_get_a2

  subroutine store_get_a3(tag,size1,size2,size3,array)
    ! dummy routine to cover rank 3 arrays
    character(*)      ,intent(in) :: tag
    integer           ,intent(in) :: size1
    integer           ,intent(in) :: size2
    integer           ,intent(in) :: size3
    real(rk)          ,intent(out):: array(:,:,:)
    real(rk)  :: tmp_array(size1*size2*size3)
    call store_get(tag,size1*size2*size3,tmp_array)
    array=reshape(tmp_array,(/size1,size2,size3/))
  end subroutine store_get_a3

end module dlf_store

!!****h* DL-FIND/constants
!!
!! NAME
!! constants
!!
!! FUNCTION
!! Provide numeric values for physical constants to other modules
!!
!! SOURCE
!!****
module dlf_constants
  use dlf_parameter_module, only: rk
  implicit none

  Public :: dlf_constants_get
  Public :: dlf_constants_init

  private
  ! Numeric values from http://physics.nist.gov/cuu/Constants/index.html
  !
  ! values of the atomic base units in SI units
  !
  real(rk),parameter :: hbar = 1.054571628E-34_rk
  real(rk),parameter :: echarge = 1.602176487E-19_rk
  real(rk),parameter :: emass = 9.10938215E-31_rk
  
  real(rk),parameter :: speed_of_light = 299792458.E0_rk !m/s

  ! exactly derived from speed_of_light
  !real(rk),parameter :: epsilon0 = 8.854187817E-12_rk ! electric constant

  !
  ! derived values in SI units
  !
  real(rk),parameter :: amc = 1.660538782E-27_rk ! atomic mass constant (kg)
  real(rk),parameter :: kboltz = 1.3806504e-23_rk  ! J/K
  real(rk),parameter :: avogadro = 6.02214179e23_rk ! 1/mol

  ! other numbers
  real(rk) :: pi
  real(rk) :: hartree ! 1 Hartree in J
  real(rk) :: one_over_4piep0
  real(rk) :: bohr ! a_0
  real(rk) :: mu0
  real(rk) :: epsilon0
  real(rk) :: planck
  ! numbers in atomic units
  real(rk) :: amu_au ! atomic mass units in at.u.
  real(rk) :: ang_au ! Angstrom in at.u. 
  real(rk) :: second_au ! Second in atomic time units

contains

  subroutine dlf_constants_init
    pi=4.E0_rk*atan(1.E0_rk)
    amu_au = amc/emass
    mu0 = 4.E0_rk * pi * 1.E-7_rk
    one_over_4piep0 = 1.E-7_rk * speed_of_light**2 !0.25E0_rk / pi / epsilon0
    epsilon0 = 0.25E0_rk / pi / one_over_4piep0
    hartree = emass * ( echarge**2 * one_over_4piep0 / hbar ) **2
    bohr = hbar**2 / (one_over_4piep0 * emass * echarge **2 )
    planck = hbar * 2.E0_rk * pi
    second_au = emass * echarge**4 * one_over_4piep0**2 / hbar**3
  end subroutine dlf_constants_init

  subroutine dlf_constants_get(tag,val)
    character(*) :: tag
    real(rk)     :: val
    select case (tag)
    case ("PI")
      val=pi      ! 3.1415926535898E+00
    case ("AMC")
      val=amc     ! 1.660538782E-27 
    case ("AMU")
      val=amu_au  ! 1.8228884842645E+03
    case ("ECHARGE")
      val=echarge ! 1.602176487E-19 C
    case ("HARTREE")
      val=hartree ! 4.3597439435066E-18 J
    case ("ANG_AU")
      val= bohr*1.E10_rk ! 5.2917720810086E-01
    case ("SOL")
      val= speed_of_light ! 2.9979245800000E+08
    case ("CM_INV_FOR_AMU") ! conversion between the square root of the second
                            ! derivative of the energy in Hartree with respect
                            ! to mass-weighted coordinates in AMU^1/2*A_0 and cm^-1
      val=sqrt(hartree/amc) / ( 2.E0_rk * pi * bohr * speed_of_light) / 100.E0_rk
    case("HBAR")
      val=hbar   ! 1.0545716280000E-34
    case("PLANCK")
      val=planck ! 6.6260689584181E-34
    case("KBOLTZ")
      val=kboltz ! 1.3806504000000E-23
    case("AVOGADRO")
      val=AVOGADRO ! 6.0221417900000E+23
    case("KBOLTZ_AU")
      val=kboltz/hartree ! 3.1668153407262E-06 
    case("SECOND_AU")
      val=second_au  ! 4.1341373379861E+16
    case("CM_INV_FROM_HARTREE")
      ! converts hartree to wave numbers (cm^-1)
      val=(hartree/planck)/speed_of_light*1.D-2  ! 219474.63160039327
    case default
      print*,"Tag not recognized:",tag
      print*,"Available tags (and their values):"
      call dlf_constants_report
      call dlf_fail("Wrong tag in dlf_constants_get")
    end select
  end subroutine dlf_constants_get
  
  subroutine dlf_constants_report
    write(*,1000) "Pi",pi
    write(*,1000) "hbar = h / (2pi)",hbar,"Js"
    write(*,1000) "h",planck,"Js"
    write(*,1000) "e",echarge,"C"
    write(*,1000) "Atomic mass unit (AMU)",amu_au,"m_e"
    write(*,1000) "Atomic mass constant (1/12 of the mass of one C12 atom)",amc,"kg"
    write(*,1000) "Hartree",hartree,"J"
    write(*,1000) "Bohr (a_0)",bohr,"m"
    write(*,1000) "Ang (ANG_AU)", bohr*1.E10_rk,"a_0"
    write(*,1000) "Speed of light",speed_of_light,"m/s"
    write(*,1000) "Epsilon0 (electric constant)",epsilon0,"F/m"
    write(*,1000) "1/(4 pi Epsilon0)",one_over_4piep0,"m^3/(H s^2)"
    write(*,1000) "cm^(-1) for AMU (CM_INV_FOR_AMU)",sqrt(hartree/amc) / &
        ( 2.E0_rk * pi * bohr * speed_of_light) / 100.E0_rk,""
    write(*,1000) "Boltzmann's constant (KBOLTZ)",kboltz,"J/K"
    write(*,1000) "Boltzmann's constant (KBOLTZ_AU)",kboltz/hartree,"Hartree/K"
    write(*,1000) "Avogadro constant (AVOGADRO)",AVOGADRO,"1/mol"
    write(*,1000) "Second in atomic units (SECOND_AU)",second_au,""
    write(*,1000) "Atomic time unit",1.E0_rk/second_au,"seconds"
    call dlf_fail("Costants")

    ! real number
1000 format (t1,'................................................', &
         t1,a,' ',t50,es20.13,1x,a)
  end subroutine dlf_constants_report


end module dlf_constants

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine write_xyz(unit,nat,znuc,coords)
  use dlf_parameter_module, only: rk
  use dlf_constants, only: dlf_constants_get
  implicit none
  integer,intent(in) :: unit
  integer,intent(in) :: nat
  integer,intent(in) :: znuc(nat)
  real(rk),intent(in):: coords(3,nat)
  integer            :: iat
  character(2)       :: str2
  real(rk)           :: ang_au
  character(2), external :: get_atom_symbol
! **********************************************************************
  call dlf_constants_get("ANG_AU",ang_au)
  write(unit,*) nat
  write(unit,*)
  do iat=1,nat
    str2 = get_atom_symbol(znuc(iat))
    write(unit,'(a2,3f15.7)') str2,coords(:,iat)*ang_au
  end do
  call flush(unit)
end subroutine write_xyz

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine write_xyz_active(unit,nat,znuc,spec,coords)
  use dlf_parameter_module, only: rk
  use dlf_constants, only: dlf_constants_get
  implicit none
  integer,intent(in) :: unit
  integer,intent(in) :: nat
  integer,intent(in) :: znuc(nat)
  integer,intent(in) :: spec(nat)
  real(rk),intent(in):: coords(3,nat)
  integer            :: iat,nact
  character(2)       :: str2
  real(rk)           :: ang_au
  character(2), external :: get_atom_symbol
! **********************************************************************
  call dlf_constants_get("ANG_AU",ang_au)
  nact=0
  do iat=1,nat
    if(spec(iat)/=-1) nact=nact+1
  end do
  write(unit,*) nact
  write(unit,*)
  do iat=1,nat
    if(spec(iat)==-1) cycle
    str2 = get_atom_symbol(znuc(iat))
    write(unit,'(a2,3f15.7)') str2,coords(:,iat)*ang_au
  end do
  call flush(unit)
end subroutine write_xyz_active

subroutine dlf_print_wavenumber(h_eigval,twavenum)
  ! get the eigenvalue of the hessian in mass-weighted coordinates 
  ! print the wavenumber in cm^-1 if twavenum is true
  ! print the crossover temperature for tunneling if the eigenvalue is negative
  use dlf_parameter_module, only: rk
  use dlf_global, only: stdout
  use dlf_constants, only: dlf_constants_get
  implicit none
  real(rk), intent(in) :: h_eigval
  logical , intent(in) :: twavenum
  real(rk) :: CM_INV_FOR_AMU, svar, kboltz_au,pi
  !
  if(twavenum) then
    call dlf_constants_get("CM_INV_FOR_AMU",CM_INV_FOR_AMU)
    svar=sqrt(abs(h_eigval)) * CM_INV_FOR_AMU
    if(h_eigval<0.D0) svar=-svar
    write(stdout,"('Frequency of transition mode',f10.3,' cm^-1 &
        &(negative value denotes imaginary frequency)')") &
        svar
  end if
  if(h_eigval<0.D0) then
    ! calculate crossover temperature
    call dlf_constants_get("AMU",svar)
    call dlf_constants_get("KBOLTZ_AU",kboltz_au)
    call dlf_constants_get("PI",pi)
    write(*,"('Crossover temperature for tunnelling',f15.5,' K')") &
        sqrt(abs(h_eigval)) / kboltz_au / (2.D0*pi) / sqrt(svar) !(1.66054D-27/9.10939D-31)
  end if
end subroutine dlf_print_wavenumber

! calculates the median (array is modified, though)
subroutine median(size,array_,med)
  use dlf_parameter_module, only: rk
  implicit none
  integer  ,intent(in) :: size
  real(rk) ,intent(in) :: array_(size)
  real(rk) ,intent(out):: med
  real(rk) :: array(size)
  real(rk) :: maxv
  integer  :: istep,sizeh
  !
  array=array_
  maxv=maxval(array)
  do istep=1,size/2
    med=minval(array)
    array(minloc(array))=maxv
  end do
  if(mod(size,2)==1) then
    med=minval(array)
  else
    med=0.5D0*(med+minval(array))
  end if
end subroutine median

!
!        Interface between CRYSTAL and DL-FIND
!
!
!
!
!   Copyright 2007 Johannes Kaestner (kaestner@theochem.uni-stuttgart.de),
!   Tom Keal (thomas.keal@stfc.ac.uk)
!   Joanne Carr (joanne.carr@stfc.ac.uk)
!
!   This file is part of DL-FIND.
!
!   DL-FIND is free software: you can redistribute it and/or modify
!   it under the terms of the GNU Lesser General Public License as
!   published by the Free Software Foundation, either version 3 of the
!   License, or (at your option) any later version.
!
!   DL-FIND is distributed in the hope that it will be useful,
!   but WITHOUT ANY WARRANTY; without even the implied warranty of
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!   GNU Lesser General Public License for more details.
!
!   You should have received a copy of the GNU Lesser General Public
!   License along with DL-FIND.  If not, see
!   <http://www.gnu.org/licenses/>.
!
!     ..................................................................
      subroutine dl_find_crystal(natoms)
      use dlfind_module, only: dlf_nframe, dlf_nweight, dlf_nmass, dlf_nz, &
                    & dlf_ncons, dlf_nconn, dlf_coords, dlf_n_po_scaling
      use basato_module ! for xa
      implicit none
      integer, intent(in) :: natoms
      integer             :: nvar, nvar2, nspec, master

      ! ****************************************************************

      dlf_coords(:) = reshape(xa(:3,:natoms), (/ 3*natoms /))

      nvar = 3*natoms
      nvar2 = dlf_nframe*nvar + dlf_nweight + dlf_nmass + dlf_n_po_scaling
      nspec = natoms + dlf_nz + 5*dlf_ncons + 2*dlf_nconn
      master = 1 ! expedient way of dealing with this with crystal, as the 
                 ! master variable was introduced to help gamess cope with I/O

      call dl_find(nvar, nvar2, nspec, master)

      write(6,*)'DL-FIND COMPLETED'

      return
      end subroutine dl_find_crystal

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_get_params(nvar,nvar2,nspec,coords,coords2,spec,ierr, &
    tolerance,printl,maxcycle,maxene,tatoms,icoord, &
    iopt,iline,maxstep,scalestep,lbfgs_mem,nimage,nebk,dump,restart,&
    nz,ncons,nconn,update,maxupd,delta,soft,inithessian,carthessian,tsrel, &
    maxrot,tolrot,nframe,nmass,nweight,timestep,fric0,fricfac,fricp, &
    imultistate, state_i,state_j,pf_c1,pf_c2,gp_c3,gp_c4,ln_t1,ln_t2, &
    printf,tolerance_e,distort,massweight,minstep,maxdump,task,temperature, &
    po_pop_size,po_radius,po_contraction,po_tolerance_r,po_tolerance_g, &
    po_distribution,po_maxcycle,po_init_pop_size,po_reset,po_mutation_rate, &
    po_death_rate,po_scalefac,po_nsave,ntasks,tdlf_farm,n_po_scaling, &
    neb_climb_test,neb_freeze_test,nzero, coupled_states, qtsflag, &
    imicroiter, maxmicrocycle, micro_esp_fit )

  use dlf_parameter_module, only: rk
  use dlfind_module
  implicit none
  integer   ,intent(in)      :: nvar 
  integer   ,intent(in)      :: nvar2
  integer   ,intent(in)      :: nspec
  real(float), intent(inout) :: coords(nvar)  ! start coordinates
  real(float), intent(inout) :: coords2(max(nvar2,1)) ! a real array that can be 
                                           ! used depending on the calculation
                                           ! e.g. a second set of coordinates
  integer   ,intent(inout)   :: spec(nspec)  ! specifications like fragment or frozen
  integer   ,intent(out)     :: ierr
  real(float)  ,intent(inout)   :: tolerance
  real(float)  ,intent(inout)   :: tolerance_e
  integer   ,intent(inout)   :: printl
  integer   ,intent(inout)   :: maxcycle
  integer   ,intent(inout)   :: maxene
  integer   ,intent(inout)   :: tatoms
  integer   ,intent(inout)   :: icoord
  integer   ,intent(inout)   :: iopt
  integer   ,intent(inout)   :: iline
  real(float)  ,intent(inout)   :: maxstep
  real(float)  ,intent(inout)   :: scalestep
  integer   ,intent(inout)   :: lbfgs_mem
  integer   ,intent(inout)   :: nimage
  real(float)  ,intent(inout)   :: nebk
  integer   ,intent(inout)   :: dump
  integer   ,intent(inout)   :: restart
  integer   ,intent(inout)   :: nz
  integer   ,intent(inout)   :: ncons
  integer   ,intent(inout)   :: nconn
  integer   ,intent(inout)   :: update
  integer   ,intent(inout)   :: maxupd
  real(float)  ,intent(inout)   :: delta
  real(float)  ,intent(inout)   :: soft
  integer   ,intent(inout)   :: inithessian
  integer   ,intent(inout)   :: carthessian
  integer   ,intent(inout)   :: tsrel
  integer   ,intent(inout)   :: maxrot
  real(float)  ,intent(inout)   :: tolrot
  integer   ,intent(inout)   :: nframe
  integer   ,intent(inout)   :: nmass
  integer   ,intent(inout)   :: nweight
  real(float)  ,intent(inout)   :: timestep
  real(float)  ,intent(inout)   :: fric0
  real(float)  ,intent(inout)   :: fricfac
  real(float)  ,intent(inout)   :: fricp
  integer   ,intent(inout)   :: imultistate
  integer   ,intent(inout)   :: state_i
  integer   ,intent(inout)   :: state_j
  real(float)  ,intent(inout)   :: pf_c1  
  real(float)  ,intent(inout)   :: pf_c2  
  real(float)  ,intent(inout)   :: gp_c3  
  real(float)  ,intent(inout)   :: gp_c4
  real(float)  ,intent(inout)   :: ln_t1  
  real(float)  ,intent(inout)   :: ln_t2  
  integer   ,intent(inout)   :: printf
  real(float)  ,intent(inout)   :: distort
  integer   ,intent(inout)   :: massweight
  real(float)  ,intent(inout)   :: minstep
  integer   ,intent(inout)   :: maxdump
  integer   ,intent(inout)   :: task
  real(float)  ,intent(inout)   :: temperature
  integer   ,intent(inout)   :: po_pop_size
  real(float)  ,intent(inout)   :: po_radius
  real(float)  ,intent(inout)   :: po_contraction
  real(float)  ,intent(inout)   :: po_tolerance_r
  real(float)  ,intent(inout)   :: po_tolerance_g
  integer   ,intent(inout)   :: po_distribution
  integer   ,intent(inout)   :: po_maxcycle
  integer   ,intent(inout)   :: po_init_pop_size
  integer   ,intent(inout)   :: po_reset
  real(float)  ,intent(inout)   :: po_mutation_rate
  real(float)  ,intent(inout)   :: po_death_rate
  real(float)  ,intent(inout)   :: po_scalefac
  integer   ,intent(inout)   :: po_nsave
  integer   ,intent(inout)   :: ntasks
  integer   ,intent(inout)   :: tdlf_farm
  integer   ,intent(inout)   :: n_po_scaling
  real(float)  ,intent(inout)   :: neb_climb_test
  real(float)  ,intent(inout)   :: neb_freeze_test
  integer   ,intent(inout)   :: nzero
  integer   ,intent(inout)   :: coupled_states
  integer   ,intent(inout)   :: qtsflag
  integer   ,intent(inout)   :: imicroiter
  integer   ,intent(inout)   :: maxmicrocycle
  integer   ,intent(inout)   :: micro_esp_fit

  ! local variables
! **********************************************************************

! Strategy: crystal's INPOPT reads in the DLFIND section of the input deck
!           and stores the corresponding variables in dlfind_module, with a
!           dlf_ prefix.
!           When dl_find is called, dlf_default_init sets initial values to 
!           junk in most cases, to recognise user input.
!           Then dlf_get_params is called to fill arguments with input values.
!           Then dlf_default_set assigns default values to stuff not assigned
!           via input.
!
!           So, here in dlf_get_params, dummy arguments corresponding to 
!           variables that will never be under user control can simply not be 
!           assigned if the defaults are what we want.
!           Also need to give initial values to the dlf_ variables that match 
!           the default_init ones, to safely cover an absent input directive.
!           Inconsistent options will be dealt with in or just after the input 
!           reading routine.

! A note on units: the array section containing the masses has them in atomic 
! mass units.  Coordinates are in bohr (atomic units) and energies are returned 
! from crystal in hartree (atomic units), with corresponding gradients.
! The temperature should be input in kelvin.
! The coords in dlf_put_coords are in bohr, so that crystal can do its own usual 
! conversions.
! The routine write_xyz in dlf_util.f90 does a conversion to Angstrom before writing.

! Things hardwired
  ierr = 0 ! not used here for error-checking
  tatoms = 1 ! could possibly use tatoms = 0 to fudge input of coords in terms 
             ! of symmetry allowed directions.  Need to investigate further...
  tdlf_farm = 0

! Things from CRYSTAL's internal data structures
  coords(:nvar) = dlf_coords(:nvar)
  nz = dlf_nz
  nmass = dlf_nmass

! Things defined by reading the dl-find section of the CRYSTAL input deck
  coords2(:) = 0.0D0
  if (nvar2 > 0 .and. allocated(dlf_coords2)) coords2(:nvar2) = dlf_coords2(:nvar2)
  nweight = dlf_nweight
  maxcycle= dlf_maxcycle
  maxene= dlf_maxene
  spec(:) = dlf_spec(:)

  printl= dlf_printl
  printf= dlf_printf
  tolerance= dlf_tolerance
  tolerance_e= dlf_tolerance_e
  iopt= dlf_iopt
  iline= dlf_iline
  maxstep= dlf_maxstep
  scalestep= dlf_scalestep
  lbfgs_mem= dlf_lbfgs_mem
  update= dlf_update
  maxupd= dlf_maxupd
  delta= dlf_delta
  inithessian = dlf_inithessian 
  carthessian= dlf_carthessian
  minstep =  dlf_minstep
  maxdump= dlf_maxdump
  nimage= dlf_nimage
  icoord= dlf_icoord
  soft= dlf_soft
  nebk= dlf_nebk

! new options, not yet implemented in CRYSTAL
  neb_climb_test= -1.0d0
  neb_freeze_test= -1.0d0

  maxrot= dlf_maxrot
  tolrot= dlf_tolrot
  tsrel = dlf_tsrel
  massweight = dlf_massweight
  nframe = dlf_nframe
  distort = dlf_distort
  imultistate = dlf_imultistate
  state_i = dlf_state_i
  state_j = dlf_state_j
  pf_c1 = dlf_pf_c1
  pf_c2 = dlf_pf_c2
  gp_c3 = dlf_gp_c3
  gp_c4 = dlf_gp_c4
  ln_t1 = dlf_ln_t1
  ln_t2 = dlf_ln_t2

  ncons= dlf_ncons
  nconn= dlf_nconn
  dump= dlf_dump
  restart= dlf_restart

  timestep= dlf_timestep
  fric0= dlf_fric0
  fricfac= dlf_fricfac
  fricp= dlf_fricp

  task = dlf_task

  temperature = dlf_temperature

  po_pop_size = dlf_po_pop_size
  po_radius = dlf_po_radius
  po_contraction = dlf_po_contraction
  po_tolerance_r = dlf_po_tolerance_r
  po_tolerance_g = dlf_po_tolerance_g
  po_distribution = dlf_po_distribution
  po_maxcycle = dlf_po_maxcycle
  po_init_pop_size = dlf_po_init_pop_size
  po_reset = dlf_po_reset
  po_mutation_rate = dlf_po_mutation_rate
  po_death_rate = dlf_po_death_rate
  po_scalefac = dlf_po_scalefac
  po_nsave = dlf_po_nsave
  n_po_scaling = dlf_n_po_scaling

  ntasks = dlf_ntasks
  tdlf_farm = 0
  nzero=0 ! new option, not yet implemented in crystal
  coupled_states=1 ! new option, not yet implemented in crystal

end subroutine dlf_get_params

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_get_gradient(nvar,coords,energy,gradient,iimage,status)
  use dlf_parameter_module, only: rk
  use gradient_memory, only : forze
  use parinf_module, only: inf
!  use unit11
!  use unit95

  implicit none
  integer   ,intent(in)    :: nvar
  real(rk)  ,intent(in)    :: coords(nvar)
  real(rk)  ,intent(out)   :: energy
  real(rk)  ,intent(out)   :: gradient(nvar)
  integer   ,intent(in)    :: iimage
  integer   ,intent(out)   :: status
  real(rk)                 :: dum_coords(nvar)
  logical                  :: err1, err2

  !external ftn

! **********************************************************************

! ??? how to deal with coords vs displacements in the array passed to ftn?
! Currently, ftn is coaxed into accepting coordinates rather than displacements...

  status = 0 ! status /= 0 means error
  err1 = .false.
  err2 = .false.
  ! the two reinits below are not needed for the I/O-to-disk main branch of crystal.
  ! If they are used with the DL branch, check that everything is updated that needs 
  ! to be before calling!  (e.g. coordinates)
  !call reinit95()
  !call reinit11()
  dum_coords(:) = coords(:)
  call ftn(dum_coords, energy, err1)

  if (inf(35) == 1) then ! flags SCF convergence failure: too many cycles
     if (inf(66) == 1) then
        gradient(:nvar) = -forze(:nvar)
     else
        status = 1
     end if
  else
     gradient(:nvar) = -forze(:nvar)
  end if
! Note that the call to crystal's totgra (libforce6.f), in which the array forze is allocated, 
! is skipped if inf(35) == 1 *unless* inf(66) /= 0 (see keyword POSTSCF in crystal's input.f90)

! A simple test has been used to check that this assignment of forze to gradient is 
! equivalent to calling gftn as below, for analytic gradients and symmdir .true.
! Just missing some print statements and the catch that will shut the program down if 
! symmetrised analytic gradients aren't available.
  !call gftn(uxst, gradient, err2, ftn)

  if (err1 .or. err2) status = 1 

end subroutine dlf_get_gradient

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_get_hessian(nvar,coords,hessian,status)
  !  get the hessian at a given geometry
  use dlf_parameter_module
  implicit none
  integer   ,intent(in)    :: nvar
  real(rk)  ,intent(in)    :: coords(nvar)
  real(rk)  ,intent(out)   :: hessian(nvar,nvar)
  integer   ,intent(out)   :: status

! **********************************************************************

! Dummy routine currently; numerical Hessian could be provided here if desired.

  call dlf_fail("dlf_get_hessian called but not coded currently")

end subroutine dlf_get_hessian

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_put_coords(nvar,mode,energy,coords,iam)
  use dlf_parameter_module
  use dlf_global, only: stdout
  use basato_module
  use parinf_module, only: lprint, iunit
  implicit none
  integer   ,intent(in)    :: nvar
  integer   ,intent(in)    :: mode
  integer   ,intent(in)    :: iam
  real(rk)  ,intent(in)    :: energy
  real(rk)  ,intent(in)    :: coords(nvar)

  integer                  :: i, j, ii, lpr
  logical                  :: od
  character(len=80)        :: fname
  character(len=60)        :: label
! **********************************************************************

! Note that what gets passed back to mainopt via OPTS(X) is nonsense 
! currently (actually it should still be a vector of zeros, unchanged 
! from the original call) as nothing has been coded yet to cover passing 
! back the optimized geometry.

! Only do this writing of files if I am the rank-zero processor
  if (iam /= 0) return

  if (mod(nvar,3) == 0) then
    !assume coords are atoms.  Here (for CRYSTAL) this means that we're not 
    ! imposing any symmetry restrictions.

    ! Need to make sure that xa(:3,:LIM016) in Includes/BASATO.INC is updated.
    ii = 0
    do i = 1, nvar/3
       do j = 1, 3
          ii = ii + 1
          xa(j,i) = coords(ii)
       end do
    end do

    if (mode==2) then
      !write(stdout,*)"Writing TS mode in xyz format to fort.33"
      !lpr=lprint(33)
      !lprint(33) = 1
      !call COOPRT ! to write xyz style coords to fort.33
      !            ! Note that this file is written to in append mode!
      !lprint(33)=lpr
      write(stdout,*)"writing TS mode in xyz format to tsmode.xyz" 
      open(unit=400,file="tsmode.xyz")
      write(400,*) nvar/3
      write(400,*)
      do i = 1, nvar/3
        write(400,'(3f12.7)') coords( (i-1)*3+1 : (i-1)*3+3 )
      end do
      close(400)
    else if (mode==3) then
      write(stdout,*)"Writing coordinates to TS.str"
      inquire(unit=iunit(34),opened=od)
      if (od) close(iunit(34))
      call EXTPRT("TS.str")
      write(stdout,*)"Writing current coordinates in xyz format to fort.33"
      lpr=lprint(33)
      lprint(33) = 1
      call COOPRT ! to write xyz style coords to fort.33
                  ! Note that this file is written to in append mode!
      lprint(33)=lpr
    else if (mode==4) then
      write(stdout,*)"Writing coordinates to minimum_+.str"
      inquire(unit=iunit(34),opened=od)
      if (od) close(iunit(34))
      call EXTPRT("minimum_+.str")
      write(stdout,*)"Writing current coordinates in xyz format to fort.33"
      lpr=lprint(33)
      lprint(33) = 1
      call COOPRT ! to write xyz style coords to fort.33
                  ! Note that this file is written to in append mode!
      lprint(33)=lpr
    else if (mode==5) then
      write(stdout,*)"Writing coordinates to minimum_-.str"
      inquire(unit=iunit(34),opened=od)
      if (od) close(iunit(34))
      call EXTPRT("minimum_-.str")
      write(stdout,*)"Writing current coordinates in xyz format to fort.33"
      lpr=lprint(33)
      lprint(33) = 1
      call COOPRT ! to write xyz style coords to fort.33
                  ! Note that this file is written to in append mode!
      lprint(33)=lpr
    else if (mode < 0) then
      write(label, *) abs(mode)
      fname = "coords_"//trim(adjustl(label))//".str"
      write(stdout,*)"Writing coordinates to ",trim(adjustl(fname))
      inquire(unit=iunit(34),opened=od)
      if (od) close(iunit(34))
      call EXTPRT(trim(adjustl(fname)))
      write(stdout,*)"Writing current coordinates in xyz format to fort.33"
      lpr=lprint(33)
      lprint(33) = 1
      call COOPRT ! to write xyz style coords to fort.33
                  ! Note that this file is written to in append mode!
      lprint(33)=lpr
    else
      write(stdout,*)"Writing coordinates to coords.str" 
      inquire(unit=iunit(34),opened=od)
      if (od) close(iunit(34))
      call EXTPRT("coords.str")
      write(stdout,*)"Writing current coordinates in xyz format to fort.33" 
      lpr=lprint(33)
      lprint(33) = 1
      call COOPRT ! to write xyz style coords to fort.33 
                  ! Note that this file is written to in append mode!
      lprint(33)=lpr
    end if
  else
    !print*,"Coords in put_coords: ",coords
  end if
end subroutine dlf_put_coords

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_error()
  implicit none
! **********************************************************************

! 1st argument 0 means stop on error, rather than print a warning or info
! Will also take care of the MPI_Abort()

  call ERRVRS(0,"dlf_error","Failure in DL-FIND")

end subroutine dlf_error

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_update()
  implicit none
! **********************************************************************
  ! only a dummy routine here.
end subroutine dlf_update


subroutine dlf_get_multistate_gradients(nvar,coords,energy,gradient,iimage,status)
  ! only a dummy routine up to now
  ! for conical intersection search
  use dlf_parameter_module
  implicit none
  integer   ,intent(in)    :: nvar
  integer   ,intent(in)    :: coords(nvar)
  real(rk)  ,intent(in)    :: energy(2)
  real(rk)  ,intent(in)    :: gradient(nvar,2)
  integer   ,intent(in)    :: iimage
  integer   ,intent(in)    :: status

  call dlf_fail("dlf_get_multistate_gradients called but not coded currently")

end subroutine dlf_get_multistate_gradients


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_put_procinfo(dlf_nprocs, dlf_iam, dlf_global_comm)

  implicit none

  integer, intent(in) :: dlf_nprocs ! total number of processors
  integer, intent(in) :: dlf_iam ! my rank, from 0, in mpi_comm_world
  integer, intent(in) :: dlf_global_comm ! world-wide communicator
! **********************************************************************

!!! variable in the calling program = corresponding dummy argument

! not needed as CRYSTAL will sort out the MPI stuff
  call dlf_fail("dlf_put_procinfo called in error")

end subroutine dlf_put_procinfo


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_get_procinfo(dlf_nprocs, dlf_iam, dlf_global_comm)
  use Numbers
  use PARAL1_MODULE, only: global_nproc, global_iam, global_comm
  implicit none

  integer :: dlf_nprocs ! total number of processors
  integer :: dlf_iam ! my rank, from 0, in mpi_comm_world
  integer :: dlf_global_comm ! world-wide communicator
! **********************************************************************

!!! dummy argument = corresponding variable in the calling program

  dlf_nprocs = global_nproc
  dlf_iam = global_iam
  dlf_global_comm = global_comm

end subroutine dlf_get_procinfo


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_put_taskfarm(dlf_ntasks, dlf_nprocs_per_task, dlf_iam_in_task, &
                        dlf_mytask, dlf_task_comm, dlf_ax_tasks_comm)

  implicit none

  integer, intent(in) :: dlf_ntasks          ! number of taskfarms
  integer, intent(in) :: dlf_nprocs_per_task ! no of procs per farm
  integer, intent(in) :: dlf_iam_in_task     ! my rank, from 0, in my farm
  integer, intent(in) :: dlf_mytask          ! rank of my farm, from 0
  integer, intent(in) :: dlf_task_comm       ! communicator within each farm
  integer, intent(in) :: dlf_ax_tasks_comm   ! communicator involving the 
                                             ! i-th proc from each farm
! **********************************************************************

!!! variable in the calling program = corresponding dummy argument 

! not needed as CRYSTAL will sort out the MPI stuff
  call dlf_fail("dlf_put_taskfarm called in error")

end subroutine dlf_put_taskfarm


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_get_taskfarm(dlf_ntasks, dlf_nprocs_per_task, dlf_iam_in_task, &
                        dlf_mytask, dlf_task_comm, dlf_ax_tasks_comm)
  use Numbers
  use PARAL1_MODULE, only: ntasks, nproc, iam, mytask, task_comms, ax_tasks_comms
  implicit none

  integer :: dlf_ntasks          ! number of taskfarms
  integer :: dlf_nprocs_per_task ! no of procs per farm
  integer :: dlf_iam_in_task     ! my rank, from 0, in my farm
  integer :: dlf_mytask          ! rank of my farm, from 0
  integer :: dlf_task_comm       ! communicator within each farm
  integer :: dlf_ax_tasks_comm   ! communicator involving the
                                 ! i-th proc from each farm
! **********************************************************************

!!! dummy argument = corresponding variable in the calling program

! we should only be in this routine AFTER make_task_farm in libxMPI.f 
! has been called (with its replacement of the iam, nproc for MPI_COMM_WORLD 
! with values for the taskfarms)

  dlf_ntasks = ntasks
  dlf_nprocs_per_task = nproc
  dlf_iam_in_task = iam
  dlf_mytask = mytask 
  dlf_task_comm = task_comms
  dlf_ax_tasks_comm = ax_tasks_comms

end subroutine dlf_get_taskfarm


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_output(dum_stdout, dum_stderr)
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr,stdout,keep_alloutput
  implicit none
  integer :: dum_stdout
  integer :: dum_stderr
  integer :: ierr

! sort out output units; particularly important on multiple processors
 
! set unit numbers for main output and error messages
  if (dum_stdout >= 0) stdout = dum_stdout 
  if (dum_stderr >= 0) stderr = dum_stderr

  if (glob%nprocs > 1) then
     ! write some info on the parallelization
     write(stdout,'(1x,a,i10,a)')"I have rank ",glob%iam," in mpi_comm_world"
     write(stdout,'(1x,a,i10)')"Total number of processors = ",glob%nprocs
     if (keep_alloutput) then
        write(stdout,'(1x,a)')"Keeping output from all processors"
     else
        write(stdout,'(1x,a)')"Not keeping output from processors /= 0"
     end if
  end if

end subroutine dlf_output

!  Copyright (C) 2017 The authors of Py-ChemShell
!
!  This file is part of Py-ChemShell.
!
!  Py-ChemShell is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as
!  published by the Free Software Foundation, either version 3 of the
!  License, or (at your option) any later version.
!
!  Py-ChemShell is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with Py-ChemShell.  If not, see
!  <http://www.gnu.org/licenses/>.

module ChemShellTaskfarmModule

    use iso_c_binding
    use mpi
    use ChemShellGAModule

    implicit none

!    include 'mpif.h'

    private
    public :: taskfarmType

    integer, parameter :: intType = sizeof(MPI_INTEGER)

    type taskfarmType
        private
        integer(kind=intType), public  :: debug
        integer(kind=intType), public  :: ncolours
        integer(kind=intType), public  :: nkeys
        integer(kind=intType), public  :: nsubsetkeys
        integer(kind=intType), public  :: colour
        integer(kind=intType), public  :: key
        integer(kind=intType), public  :: key_subset
        integer(kind=intType), public  :: comm_colour
        integer(kind=intType), public  :: comm_key
        integer(kind=intType), public  :: comm_subset
        integer(kind=intType), public  :: ga_memory
        type(GAType), pointer, private :: ga => null()
        contains
        procedure, public  :: initialise  => private_initialise
        procedure, public  :: finalise    => private_finalise
        procedure, public  :: summarise   => private_summarise
        procedure, public  :: synchronise => private_synchronise
        procedure, public  :: print       => private_print
        procedure, public  :: is_root      => private_is_root
        procedure, public  :: is_subset    => private_is_subset
        procedure, private :: private_initialise
        procedure, private :: private_finalise
        procedure, private :: private_print
        procedure, private :: private_is_root
        procedure, private :: private_is_subset
        procedure, private :: private_summarise
        procedure, private :: private_synchronise

    endtype taskfarmType
    
    contains

    ! taskfarming initialisation: see tcg2mpi.f and parallel_ga.f in Tcl-ChemShell
    integer(kind=intType) function private_initialise(this, ncolours, nsubsetkeys, debug) result(ierror)

        class(taskfarmType)  , intent(inout) :: this
        integer(kind=intType), intent(in)    :: ncolours
        integer(kind=intType), intent(in)    :: nsubsetkeys
        integer(kind=intType), intent(in)    :: debug

        integer(kind=intType)                :: rank, nprocs, i
! YL FIXME: these have to be 32-bit (because of GA?)
        integer(kind=intType)                :: group_all, group_subset, rank_subset
        integer(kind=intType), pointer       :: subset(:)

        call MPI_COMM_SIZE(MPI_COMM_WORLD, nprocs, ierror)
        call MPI_COMM_RANK(MPI_COMM_WORLD, rank  , ierror)

        this%debug = debug

        ! initialise GA
        ! GA does not need sub-workgroup communicator as we only reduce MM nprocs
        allocate(this%ga)

        ierror = this%ga%initialise(ncolours, this%ga_memory, debug)

        this%ncolours = this%ga%ncolours
        this%nkeys    = this%ga%nkeys
        this%colour   = this%ga%colour
        this%key      = this%ga%key
!        this%comm_colour = this%ga%comm_colour

        ! nowhere GA communicator is needed, so we use the communicator from MPI parallelism
        call MPI_COMM_SPLIT(MPI_COMM_WORLD, this%colour, this%key   , this%comm_colour, ierror)
        ! called "counterpart" in Tcl-ChemShell
        call MPI_COMM_SPLIT(MPI_COMM_WORLD, this%key   , this%colour, this%comm_key   , ierror)

        if(ierror.ne.0) then
            print *, ">>> FATAL ERROR: MPI_COMM_SPLIT() failed."
            stop
        endif

        ! size of sub-group processes
        ! legal range: 1 <= nsubsetkeys <= nkeys
        if(nsubsetkeys.lt.1.or.nsubsetkeys.gt.this%nkeys) then
            this%nsubsetkeys = this%nkeys
        else
            this%nsubsetkeys = nsubsetkeys
        endif

        allocate(subset(this%nsubsetkeys))
        subset = (/(i, i=0,this%nsubsetkeys-1)/)

        ! create a "group" of the colour's (workgroup's) all keys (processes in this workgroup)
        call MPI_COMM_GROUP(this%comm_colour, group_all, ierror)

        if(ierror.ne.0) then
            print *, ">>> FATAL ERROR: MPI_COMM_GROUP() failed."
            stop
        endif

        ! create a new group containing only the subset (a subset of processes in the workgroup)
        call MPI_GROUP_INCL(group_all, this%nsubsetkeys, subset, group_subset, ierror)
!        call MPI_GROUP_EXCL(group_all, this%nkeys-this%nsubsetkeys, subset, group_rest  , ierror)

        if(ierror.ne.0) then
            print *, ">>> FATAL ERROR: MPI_GROUP_INCL() failed."
            stop
        endif

        ! create a communicator of the subset
        call MPI_COMM_CREATE(this%comm_colour, group_subset, this%comm_subset, ierror)

        if(ierror.ne.0) then
            print *, ">>> FATAL ERROR: MPI_COMM_CREATE() failed."
            stop
        endif

        call MPI_GROUP_RANK(group_subset, rank_subset, ierror)

        if(ierror.ne.0) then
            print *, ">>> FATAL ERROR: MPI_GROUP_RANK() failed."
            stop
        endif

        ! YL 10/11/2017: replaced all MPI_COMM_NULL with MPI_UNDEFINED as in Open MPI the former causes hanging
        if(rank_subset.eq.MPI_UNDEFINED) then
            this%comm_subset = MPI_UNDEFINED
            this%key_subset  = MPI_UNDEFINED
        else
            this%key_subset  = rank_subset
        endif

        deallocate(subset)

    endfunction private_initialise
    integer(kind=intType) function private_summarise(this, level) result(ierror)

        class(taskfarmType), intent(in) :: this
        integer            , intent(in) :: level

        ierror = this%ga%summarise(level)

    endfunction private_summarise
    integer(kind=intType) function private_synchronise(this) result(ierror)

        class(taskfarmType), intent(inout) :: this

        call this%ga%synchronise()
        call MPI_BARRIER(this%comm_colour, ierror)

    endfunction private_synchronise
    integer(kind=intType) function private_finalise(this) result(ierror)

        class(taskfarmType), intent(inout) :: this

!        call MPI_GROUP_FREE(group_all)
!        call MPI_GROUP_FREE(group_subset)
        if(associated(this%ga)) then
            deallocate(this%ga)
        endif

        ierror = 0

    endfunction private_finalise
    integer(kind=intType) function private_print(this) result(ierror)

        class(taskfarmType), intent(in) :: this

        ierror = this%ga%print()
        call flush(6)

    endfunction private_print
    logical function private_is_root(this) result(result)

        class(taskfarmType), intent(in) :: this

        if(associated(this%ga)) then
            result = this%ga%is_root().or.this%key_subset.eq.0
        else
            print *, ">>> ERROR: taskfarm not yet initialised!"
            stop
        endif

    endfunction private_is_root
    logical function private_is_subset(this) result(result)

        class(taskfarmType), intent(in) :: this

        ! YL 10/11/2017: replaced all MPI_COMM_NULL with MPI_UNDEFINED as in Open MPI the former causes hanging
        if(this%key_subset.ne.MPI_UNDEFINED.and.this%comm_subset.ne.MPI_UNDEFINED) then
            result = this%key_subset.lt.this%nsubsetkeys
        else
            result = .false.
        endif

    endfunction private_is_subset
    ! convert any kind=4 or kind=8 integer to intType
    integer(kind=intType) function getCastInt(input) result(result)

        class(*), intent(in) :: input

        selecttype(tmp=>input)
            type is (integer(kind=4))
                result = tmp
            type is (integer(kind=8))
                result = tmp
!            type is (integer(c_int))
!                result = tmp
        endselect

    endfunction getCastInt


endmodule ChemShellTaskfarmModule

! **********************************************************************
! **               Line search or trust radius unit                   **
! **********************************************************************
!!****h* DL-FIND/scalestep
!!
!! NAME
!! scalestep
!!
!! FUNCTION
!! Line search or trust radius
!!
!! DATA
!! $Date$
!! $Rev$
!! $Author$
!! $URL$
!! $Id$
!!
!! COPYRIGHT
!!
!!  Copyright 2007 Johannes Kaestner (kaestner@theochem.uni-stuttgart.de),
!!  Tom Keal (thomas.keal@stfc.ac.uk)
!!
!!  This file is part of DL-FIND.
!!
!!  DL-FIND is free software: you can redistribute it and/or modify
!!  it under the terms of the GNU Lesser General Public License as 
!!  published by the Free Software Foundation, either version 3 of the 
!!  License, or (at your option) any later version.
!!
!!  DL-FIND is distributed in the hope that it will be useful,
!!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!!  GNU Lesser General Public License for more details.
!!
!!  You should have received a copy of the GNU Lesser General Public 
!!  License along with DL-FIND.  If not, see 
!!  <http://www.gnu.org/licenses/>.
!!
!!****
module dlf_scalestep_module
  use dlf_parameter_module, only: rk

  !types
  type trustradius_type
    real(rk) :: startrad
    real(rk) :: maxrad ! maximum trust radius, from glob%maxstep
    real(rk) :: radius
    real(rk) :: minrad
  end type trustradius_type

  ! variables
  ! tr - global trust radius
  ! trmic - microiterative trust radius
  type(trustradius_type),save :: tr, trmic

end module dlf_scalestep_module

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
module dlf_linesearch
  use dlf_parameter_module, only: rk
  implicit none
  ! module only to be used locally in scalestep.f90
  ! used for storage of line search data
  real(rk),allocatable,save :: oldgradient(:) ! glob%nivar
end module dlf_linesearch

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* scalestep/dlf_scalestep
!!
!! FUNCTION
!!
!! Do line search or a scaling of the step based on some trust radius.
!! the parameter glob%iline defines which algorithm to use
!!
!! SYNOPSIS
subroutine dlf_scalestep
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr,printl,stdout
  use dlf_linesearch, only: oldgradient
  use dlf_scalestep_module, only: tr
  implicit none
  !
  real(rk)  :: svar
  integer   :: ivar(1)
  integer   :: geomCoords
! **********************************************************************
  if (glob%icoord >= 10 .and. glob%icoord <= 19) then
     ! In the case of Lagrange-Newton coordinates, the change in the two
     ! extra coordinates (Lagrange multipliers) can be significantly
     ! larger than that of the geometrical coordinates.
     ! These coordinates should therefore not be included in the step
     ! scaling calculations, as otherwise the optimisation will grind to
     ! a halt.
     geomCoords = glob%nivar - 2
  else
     geomCoords = glob%nivar 
  endif

  select case (glob%iline)

! ======================================================================
! Simple scaling
! ======================================================================
  case (0)

    if(glob%icoord<200 .or. glob%icoord>=300) then
      glob%step(:)= glob%scalestep * glob%step(:)
      svar=maxval(abs(glob%step(1:geomCoords)))
      
      if(svar > glob%maxstep) then
        svar= glob%maxstep/svar
        if(printl>=4) write(stdout,'("Scaling step back by ",f10.5)') svar
        glob%step(:)= glob%step(:) * svar
      end if
    else
      ! Dimer: scale only first half of step (dimer midpoint)
      ivar=shape(glob%step)
      ivar=ivar/2
      glob%step(1:ivar(1))= glob%scalestep * glob%step(1:ivar(1))
      svar=maxval(abs(glob%step(1:ivar(1))))
      if(svar > glob%maxstep) then
        svar= glob%maxstep/svar
        glob%step(1:ivar(1))= glob%step(1:ivar(1)) * svar
      end if
    end if

! ======================================================================
! Trust radius approaches
! ======================================================================
  case(1,2)

    svar=dsqrt(sum(glob%step(1:geomCoords)**2))
    if(printl >= 2) then
      write(*,"(' Predicted step length ',es10.4)") svar
      write(*,"(' Trust radius          ',es10.4)") tr%radius
    end if
    if(svar > tr%radius) then
      svar= tr%radius/svar
      glob%step(:)= glob%step(:) * svar
    end if
    oldgradient(:)= glob%igradient(:)

! ======================================================================
! Line search
! ======================================================================
  case(3)

    ! the step may be scaled to whatever is suitable
    svar=dsqrt(sum(glob%step(1:geomCoords)**2))
    svar= tr%startrad/svar
    glob%step(:)= glob%step(:) * svar


! ======================================================================
! Wrong optimisation type setting
! ======================================================================
  case default
    write(stderr,*) "Line search ",glob%iline,"not implemented"
    call dlf_fail("Line search error error")

  end select
end subroutine dlf_scalestep
!!****



! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* scalestep/dlf_scalestep_microiter
!!
!! FUNCTION
!!
!! Do a scaling of the microiterative step based on some trust radius.
!!
!! Trust radius only at the moment
!!
!! SYNOPSIS
subroutine dlf_scalestep_microiter(nvar, step)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr,printl,stdout
  use dlf_scalestep_module, only: trmic
  implicit none
  !
  integer, intent(in) :: nvar
  real(rk), intent(inout) :: step(nvar)
  !
  real(rk)  :: svar
  integer   :: ivar(1)
! **********************************************************************

  svar=dsqrt(sum(step(1:nvar)**2.0d0))
  if(printl >= 2) then
     write(*,"(' Predicted step length ',es10.4)") svar
     write(*,"(' Trust radius          ',es10.4)") trmic%radius
  end if
  if(svar > trmic%radius) then
     svar= trmic%radius/svar
     step(:)= step(:) * svar
  end if

end subroutine dlf_scalestep_microiter
!!****



! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* scalestep/test_acceptance
!!
!! FUNCTION
!!
!! Scale the step based on the energy as acceptance criterion.
!! Used if glob%iline == 1.
!!
!! SYNOPSIS
subroutine test_acceptance
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr,stdout,printl
  use dlf_scalestep_module, only: tr
  use dlf_linesearch, only: oldgradient
  implicit none
  !
  real(rk)  :: svar,grad1,grad2
! **********************************************************************
  if (glob%iline.ne.1) &
    call dlf_fail("warning, test_acceptance should only be called for iline=1")

  if(.not.glob%toldenergy) then
    ! first step
    tr%radius=tr%startrad
    if(printl >=6) write(stdout,"(' Accepting step as it is the first')")
    glob%taccepted=.true.
    return
  end if

  if(glob%energy < glob%oldenergy) then
    ! accept step
    if(printl >=6) write(stdout,"(' Accepting step...')")
    if(printl >=6) write(stdout,"(' Energy ',es10.3,&
        &' old Energy ',es10.3)") glob%energy, glob%oldenergy

    ! include Wolfe conditions ... (two parameters are free to chose)
    ! oldgradient is set in dlf_scalestep
    grad1=dot_product(glob%step(:),oldgradient(:))
    if(glob%energy < glob%oldenergy + 1.D-4 * grad1) then
      !this was the Armijo condition
      grad2=dot_product(glob%step(:),glob%igradient(:))
      if(printl >=6) write(stdout,*) &
            "Armijo condition fulfilled"
      !if(grad2 >= grad1*0.6D0) then ! this is taken from the web. I think it is wrong
      if(abs(grad2) <= abs(grad1)*0.99D0) then
      !this was the curvature condition
        if(printl >=4) write(stdout,*) &
            "Wolfe conditions fulfilled, increasing trust radius"
        tr%radius= min(tr%radius * 2.D0,tr%maxrad)
      end if
    end if

    glob%taccepted=.true.

  else
    ! reject step

    if(printl >=2) write(stdout,"(' Rejecting step, energy ',es10.3,&
        &' higher')") glob%energy-glob%oldenergy
    if(printl >=6) write(stdout,"(' Energy ',es10.3,&
        &' old Energy ',es10.3)") glob%energy, glob%oldenergy

    svar=dsqrt(dot_product(glob%step(:),glob%step(:)))
    tr%radius= min(svar,tr%radius) * 0.5D0
    if(printl >=4) write(*,"(' Trust radius          ',es10.4)") tr%radius

    if (glob%imicroiter == 1) then
       call dlf_microiter_reset_macrostep
    else
       glob%step(:)= glob%step(:) * 0.5D0
       ! set back coordinates
       glob%icoords(:)= glob%icoords(:) - glob%step(:)
    end if

    glob%taccepted=.false.

    if(tr%radius < tr%minrad) then
      if(printl >=2) write(stdout,&
          "(' Step too small, restarting optimiser.')")
      call dlf_formstep_restart
      tr%radius=tr%maxrad
      glob%oldenergy=glob%energy
      glob%taccepted=.true.

      ! Removed reset of HDLCs. Doesn't work because step/itox
      ! called next before xtoi so itox will use icoords that are
      ! inconsistent with the new HDLC system.
      !
      !! reset hdlc coordinates if used
      !if(glob%icoord>=1 .and. glob%icoord<=4) then
      !  call dlf_hdlc_reset
      !  ! the arrays glob%spec,glob%znuc have to be changed when using 
      !  !  more instances of hdlc
      !  call dlf_hdlc_create(glob%nvar/3,glob%nicore,glob%spec,glob%micspec,&
      !      glob%znuc,1,glob%xcoords,glob%weight,glob%mass)
      !  ! recalculate iweight
      !  call dlf_hdlc_getweight(glob%nat,glob%nivar,glob%nicore,glob%micspec,&
      !      glob%weight,glob%iweight)
      !end if


    end if

  end if

  if(printl >=6) write(*,"(' Trust radius ',es10.3)") &
      tr%radius

end subroutine test_acceptance
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* scalestep/test_acceptance_microiter
!!
!! FUNCTION
!!
!! Scale the microiterative step based on the energy as acceptance criterion.
!!
!! TODO: Refactor - merge with standard routine?
!!
!! SYNOPSIS
subroutine test_acceptance_microiter(nvar, energy, igradient, &
     oldgradient, tmicoldenergy, oldenergy, step, icoords, taccepted, tswitch)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr,stdout,printl
  use dlf_scalestep_module, only: trmic
  implicit none
  !
  integer, intent(in) :: nvar
  real(rk), intent(in) :: energy
  real(rk), intent(in) :: igradient(nvar), oldgradient(nvar)
  logical, intent(in) :: tmicoldenergy
  real(rk), intent(inout) :: oldenergy
  real(rk), intent(inout) :: step(nvar), icoords(nvar)
  logical, intent(out) :: taccepted
  logical, intent(out) :: tswitch
  real(rk)  :: svar,grad1,grad2
! **********************************************************************
  tswitch = .false.

  if(.not. tmicoldenergy) then
    ! first step in this microiterative cycle
    if(printl >=6) write(stdout,"(' Accepting step as it is first in microiterative cycle')")
    taccepted=.true.
    return
  end if

  if(energy < oldenergy) then
    ! accept step
    if(printl >=6) write(stdout,"(' Accepting step...')")
    if(printl >=6) write(stdout,"(' Energy ',es10.3,&
        &' old Energy ',es10.3)") energy, oldenergy

    ! include Wolfe conditions ... (two parameters are free to chose)
    ! oldgradient is set in dlf_scalestep_microiter
    grad1=dot_product(step(:),oldgradient(:))
    if(energy < oldenergy + 1.D-4 * grad1) then
      !this was the Armijo condition
      grad2=dot_product(step(:),igradient(:))
      if(printl >=6) write(stdout,*) &
            "Armijo condition fulfilled"
      !if(grad2 >= grad1*0.6D0) then ! this is taken from the web. I think it is wrong
      if(abs(grad2) <= abs(grad1)*0.99D0) then
      !this was the curvature condition
        if(printl >=4) write(stdout,*) &
            "Wolfe conditions fulfilled, increasing trust radius"
        trmic%radius= min(trmic%radius * 2.D0,trmic%maxrad)
      end if
    end if

    taccepted=.true.

  else
    ! reject step

    if(printl >=2) write(stdout,"(' Rejecting step, energy ',es10.3,&
        &' higher')") energy - oldenergy
    if(printl >=6) write(stdout,"(' Energy ',es10.3,&
        &' old Energy ',es10.3)") energy, oldenergy

    svar=dsqrt(dot_product(step(:), step(:)))
    trmic%radius= min(svar,trmic%radius) * 0.5D0
    if(printl >=4) write(*,"(' Trust radius          ',es10.4)") trmic%radius


    step(:) = step(:) * 0.5D0

    ! set back coordinates
    icoords(:) = icoords(:) - step(:)

    taccepted=.false.

    if(trmic%radius < trmic%minrad) then
      if(printl >=2) write(stdout,&
          "(' Step too small, switching to macroiterations.')")
      trmic%radius = min(1.D-1,glob%maxstep)
      oldenergy = energy
      taccepted=.true.
      tswitch = .true.

      ! Probably shouldn't reset HDLC coordinates as we aren't
      ! restarting the optimiser
      !if(glob%icoord>=1 .and. glob%icoord<=4) then
        !if(printl >=2) write(stdout,"(' Resetting HDLC coordinates.')") 
        ! call dlf_hdlc_reset
        !! the arrays glob%spec,glob%znuc have to be changed when using 
        !!  more instances of hdlc
        !call dlf_hdlc_create(glob%nvar/3,glob%nicore,glob%spec,glob%micspec,glob%znuc,1, &
        !    glob%xcoords,glob%weight,glob%mass)
        !! recalculate iweight
        !call dlf_hdlc_getweight(glob%nat,glob%nivar,glob%nicore,glob%micspec,glob%weight,glob%iweight)
      !end if

    end if

  end if

  if(printl >=6) write(*,"(' Trust radius ',es10.3)") &
      trmic%radius

end subroutine test_acceptance_microiter
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* scalestep/test_acceptance_g
!!
!! FUNCTION
!!
!! Scale the step based on the gradient projection on the step as 
!! acceptance criterion.
!! Used if glob%iline == 2.
!!
!! SYNOPSIS
subroutine test_acceptance_g
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr,stdout,printl
  use dlf_scalestep_module, only: tr
  use dlf_linesearch, only: oldgradient
  implicit none
  !
  real(rk)  :: svar,proj
  real(rk)  :: oldproj,astep
! **********************************************************************
  if (glob%iline.ne.2) call &
      dlf_fail("test_acceptance_g should only be called for iline=2")

  if(.not.glob%toldenergy) then
    ! first step
    tr%radius=tr%startrad
    if(printl >=6) write(stdout,"(' Accepting step as it is the first')")
    oldgradient(:)=glob%igradient(:)
    return
  end if

  ! calculate projection of the new gradient on the old search direction
  proj=-dot_product(glob%igradient(:),glob%step(:))
  oldproj=-dot_product(oldgradient(:),glob%step(:))
  ! scaling
  svar=oldproj/(oldproj-proj)

  if(proj > 0.D0 .or. svar>0.9D0 ) then 
    ! accept step
    if(printl >=6) write(stdout,"(' Accepting step...')")
    if(printl >=6) write(stdout,"(' Projection of gradient on step: ',es10.3,&
        &' Energy ',es10.3)") proj,glob%energy

    ! We have nothing like Wolfe conditions here, thus we scale the 
    ! trust radius based on the gradient projections (to a minimum of 
    ! 0.9 and a maximum of 2)
    if(svar>0.9D0) tr%radius= tr%radius * min(svar,2.D0)

    glob%taccepted=.true.

    oldgradient(:)=glob%igradient(:)

  else
    ! reject step

    if(printl >=2) write(stdout,"(' Rejecting step...')")
    if(printl >=6) write(stdout,"(' Projection of gradient on step: ',es10.3,&
        &' oldproj ',es10.3)") proj,oldproj

    if(abs(oldproj-proj)>1.D-10) then
      svar=oldproj/(oldproj-proj) * 0.9D0 ! this factor is empirical
    else
      ! this may be the case if the step is very small
      svar=1.D-1
    end if
    if(svar<=-0.8D0) svar=-0.8D0 ! allow negative scaling
    if(printl >=2) write(stdout,"('scaling:',es10.3)") svar

    ! TODO Implement this?
    if (glob%imicroiter == 1) then
       call dlf_fail("Microiterative opt with test_acceptance_g not yet implemented")
    end if

    ! set back coordinates
    glob%icoords(:)= glob%icoords(:) - glob%step(:) * (1.D0-svar)

    glob%step(:)= glob%step(:) * svar

    astep = dsqrt(dot_product(glob%step(:),glob%step(:)))
    tr%radius= min( astep * 1.5D0 , tr%radius * svar )
    
    glob%taccepted=.false.

    if(tr%radius < tr%minrad) then ! < this does not seem too good
      if(printl >=2) write(stdout,&
          "(' Step too small, restarting optimiser.')")
      call dlf_formstep_restart
      tr%radius=tr%maxrad
      oldgradient(:)=glob%igradient(:)
      glob%taccepted=.true.
    end if

  end if
  tr%radius= min(tr%radius,tr%maxrad)

  if(printl >=6) write(*,"(' Trust radius ',es10.3)") &
      tr%radius

end subroutine test_acceptance_g
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine linesearch_init
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob
  use dlf_scalestep_module, only: tr, trmic
  use dlf_linesearch, only: oldgradient
  use dlf_allocate, only: allocate
  implicit none
! **********************************************************************
  ! Microiterative trust radius init
  ! TODO: Is there a more logical place for it to go?
  ! Note moved before iline test in case main trust radius 
  ! is constant.
  ! TODO: Should micro version be linked to iline?
  if (glob%imicroiter > 0) then
     trmic%startrad=min(1.D-1,glob%maxstep)
     trmic%maxrad=glob%maxstep
     trmic%minrad=1.D-7
     ! Initialise starting radius here - only once
     ! Following HDLCOpt, the trust radius from the last 
     ! microiterative cycle is retained for the next
     trmic%radius = trmic%startrad
  end if

  if (glob%iline/=1.and.glob%iline/=2.and.glob%iline/=3) return

  tr%startrad=min(1.D-1,glob%maxstep)
  tr%maxrad=glob%maxstep
  tr%minrad=1.D-7
  call allocate(oldgradient,glob%nivar)

end subroutine linesearch_init

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine linesearch_destroy
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob
  use dlf_linesearch, only: oldgradient
  use dlf_allocate, only: deallocate
  implicit none
  integer :: fail
! **********************************************************************
  if (glob%iline/=1.and.glob%iline/=2.and.glob%iline/=3) return
  if (allocated(oldgradient)) call deallocate(oldgradient)
end subroutine linesearch_destroy

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine linesearch
  ! do line search, glob%accepted is false as long as we are doing line 
  ! search and true if a new direction should be calculated
  ! THIS ROUTINE DOES NOT WORK WELL AT THE MOMENT
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr,stdout,printl
  use dlf_scalestep_module, only: tr
  use dlf_linesearch, only: oldgradient
  implicit none
  !
  real(rk)  :: svar,proj,newalpha,oldproj
  real(rk),save :: oldalpha,alpha
! **********************************************************************
  if (glob%imicroiter == 1) then
     call dlf_fail("Microiterative opt with linesearch not yet implemented")
  end if

  if (glob%iline.ne.3) &
    call dlf_fail("linesearch should only be called for iline=3")

  if(.not.glob%toldenergy) then
    ! ==================================================================
    ! first step
    ! ==================================================================

    tr%radius=tr%startrad
    if(printl >=6) write(stdout,"(' Accepting step as it is the first')")
    alpha=1.D0!tr%radius
    oldalpha=0.D0
    oldgradient=glob%igradient(:)
    return
  end if

  ! calculate projection of the new gradient on the old search direction
  proj=-dot_product(glob%igradient(:),glob%step(:))
  oldproj=-dot_product(oldgradient(:),glob%step(:))

  if(abs(proj) < 1.D-8 ) then ! hardcoded line search convergence criterion
    ! ==================================================================
    ! accept step
    ! ==================================================================
    if(printl >=6) write(stdout,"(' Line search finished')")
    if(printl >=6) write(stdout,"(' Projection of gradient on step: ',es10.3,&
        &' Energy ',es10.3)") proj,glob%energy

    glob%step(:)=glob%step(:)*alpha

    glob%taccepted=.true.

! debug print
print*,"qq Current accepted"
    write(*,'("qq Position ",2es15.5)') glob%icoords(:)
    write(*,'("qq Gradient ",2es15.5)') glob%igradient(:)
    write(*,'("qq Step     ",2es15.5)') glob%step(:)

    ! start values for the following line search
    alpha=1.D0
    oldalpha=0.D0

  else
    ! ==================================================================
    ! Start or continue line search
    ! ==================================================================

    if(printl >=6) write(*,"(' Projection of gradient on step: ',es10.3,&
        &' oldproj ',es10.3)") proj,oldproj

 write(*,"('qq Projection of gradient on step: ',es10.3,&
          &' energy ',es10.3)") proj,glob%energy

    write(*,'("qq Position ",2es15.5)') glob%icoords(:)
    write(*,'("qq Gradient ",2es15.5)') glob%igradient(:)
    write(*,'("qq Step     ",2es15.5)') glob%step(:)

    if(printl >=2) write(stdout,"(' Line search continuing')")
    if(printl >=6) write(stdout,"(' Projection of gradient on step: ',es10.3,&
        &' oldproj ',es10.3)") proj,oldproj

 write(*,"('qq Projection of gradient on step: ',es10.3,&
          &' energy ',es10.3)") proj,glob%energy

      svar=oldproj/(oldproj-proj) 
!!$    ! do not change the step size too drastically
!!$    svar=min(svar,2.D0)
!!$    svar=max(svar,0.5D0)
      newalpha=oldalpha+svar*(alpha-oldalpha)
      if(newalpha/alpha < 0.D0 ) then
        ! we predict a line minimum in the inverse of the search direction
        if(proj>0.d0) then
          newalpha=1.4D0*alpha
        end if
      else
        if(newalpha/alpha > 1.2D0 ) newalpha=1.2D0*alpha
        if(newalpha/alpha < 0.6D0 ) newalpha=0.6D0*alpha
      end if

      write(*,'("newal, alpha, frac",3f10.5)') newalpha,alpha,newalpha/alpha

      ! set back coordinates
      glob%icoords(:)= glob%icoords(:) + glob%step(:) * (newalpha-alpha)

      ! store alphas for next step
      oldalpha=alpha
      alpha=newalpha

    glob%taccepted=.false.

    write(*,'("qq Position ",2es15.5)') glob%icoords(:)

  end if

  oldgradient=glob%igradient(:)

  if(printl >=6) write(*,"(' Trust radius ',es10.3)") &
      tr%radius
  if(printl >=6) write(*,"(' Current scaling ',2es10.3)") &
      alpha,proj
  
end subroutine linesearch

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_checkpoint_linesearch_write
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob

  use dlf_linesearch, only: oldgradient
  use dlf_scalestep_module, only: tr

  use dlf_checkpoint, only: tchkform,write_separator
  implicit none
  integer :: fail
  ! YL 15/12/2020: we need avoid using file units ifunit, 101, or 102 to make Cray compiler happy
  !                see pp 141: http://103.251.184.12/wp-content/uploads/2018/01/Cray_Fortran_Reference_Manual_S-3901_86.pdf
  !                The values of INPUT_UNIT, OUTPUT_UNIT, and ERROR_UNIT defined in the ISO_Fortran_env module are
  !                ifunit, 101, and 102, respectively. These three unit numbers are reserved and may not be used for other purposes.
  !                The files connected to these units are the same files used by the companion C processor for standard input
  !                (stdin), output (stdout), and error (stderr). An asterisk (*) specified as the unit for a READ statement specifies unit
  !                ifunit. An asterisk specified as the unit for a WRITE statement, and the unit for PRINT statements is unit 101. All
  !                positive default integer values are available for use as unit numbers.
  integer, parameter :: ifunit = 104
! **********************************************************************
  if (glob%iline/=1.and.glob%iline/=2.and.glob%iline/=3) return
  if(tchkform) then
    open(unit=ifunit,file="dlf_linesearch.chk",form="formatted")
    call write_separator(ifunit,"Linesearch-Arrays")
    write(ifunit,*) oldgradient,tr
    call write_separator(ifunit,"END")
    close(ifunit)
  else
    open(unit=ifunit,file="dlf_linesearch.chk",form="unformatted")
    call write_separator(ifunit,"Linesearch-Arrays")
    write(ifunit) oldgradient,tr
    call write_separator(ifunit,"END")
    close(ifunit)
  end if
end subroutine dlf_checkpoint_linesearch_write

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_checkpoint_linesearch_read(tok)
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stdout

  use dlf_linesearch, only: oldgradient
  use dlf_scalestep_module, only: tr

  use dlf_checkpoint, only: tchkform,read_separator
  implicit none
  logical,intent(out) :: tok
  logical             :: tchk
  integer, parameter  :: ifunit = 104
! **********************************************************************
  tok=.true.
  if (glob%iline/=1.and.glob%iline/=2.and.glob%iline/=3) return
  tok=.false.

  ! check if checkpoint file exists
  INQUIRE(FILE="dlf_linesearch.chk",EXIST=tchk)
  if(.not.tchk) then
    write(stdout,10) "File dlf_linesearch.chk not found"
    return
  end if

  if(tchkform) then
    open(unit=ifunit,file="dlf_linesearch.chk",form="formatted")
  else
    open(unit=ifunit,file="dlf_linesearch.chk",form="unformatted")
  end if

  call read_separator(ifunit,"Linesearch-Arrays",tchk)
  if(.not.tchk) return 

  if(tchkform) then
    read(ifunit,*,end=201,err=200) oldgradient,tr
  else
    read(ifunit,end=201,err=200) oldgradient,tr
  end if
  call read_separator(ifunit,"END",tchk)
  if(.not.tchk) return 

  close(ifunit)
  tok=.true.
  return

  ! return on error
200 continue
  close(ifunit)
  write(stdout,10) "Error reading CG checkpoint file"
  return
201 continue
  close(ifunit)
  write(stdout,10) "Error (EOF) reading CG checkpoint file"
  return
10 format("Checkpoint reading WARNING: ",a)
end subroutine dlf_checkpoint_linesearch_read

!  Copyright (C) 2017 The authors of Py-ChemShell
!
!  This file is part of Py-ChemShell.
!
!  Py-ChemShell is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as
!  published by the Free Software Foundation, either version 3 of the
!  License, or (at your option) any later version.
!
!  Py-ChemShell is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with Py-ChemShell.  If not, see
!  <http://www.gnu.org/licenses/>.

module ChemShellDatatypesModule

    use iso_c_binding

    ! double precision
    integer, parameter :: rk = kind(0.d0)      

endmodule ChemShellDatatypesModule

      subroutine chemsh_input_file_info(input_filename, 
     $     rtdb_name, ostartup, ocontinue)
C$Id$
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
#include "cfileprefix.fh"
#include "util.fh"
#include "stdio.fh"
      character*(*) input_filename ! [input]
      character*(*) rtdb_name   ! [output]
      logical ostartup           ! [output]
      logical ocontinue          ! [output]
c
      character*(nw_max_path_len) ecce_file_name
      character*(nw_max_path_len) a_temporary_file
      logical status, odirective, echo
      logical bad_permanent_dir, bad_scratch_dir
      logical already
      integer nkeys, istart, iend
      parameter (nkeys = 7)
      logical iocheckk
      integer mitob1
      character*16 keys(nkeys), field
      data keys/'start','restart','continue',
     &    'scratch_dir','permanent_dir', 'ecce_print',
     $     'echo'/
c
c     Scan the input for start/restart directives and attempt
c     to figure out the name of the desired data base, if the
c     job is a startup or a restart, what the file_prefix is.
c
c     While we're doing this also scan for scratch_dir and permanent_dir
c
c     (start || restart) [<file_prefix> = 'from input file base'] \
c                        [rtdb <rtdb_file_name>]
c
c     scratch_dir <read rest of line as character string>
c     permanent_dir <read rest of line as character string>
c
c     Only process 0 reads ... everyone else jumps to the broadcast
c
      print *, "### calling MA_sizeof..."
      call flush(6)
      mitob1=MA_sizeof(MT_INT,1,MT_BYTE)
      print *, "### MA_sizeof called, mitob1 =", mitob1
      call flush(6)
      scratch_dir = ' '
      permanent_dir = ' '
      call util_set_default_scratch_dir(scratch_dir)
      call util_set_default_permanent_dir(permanent_dir)
      iocheckk=.true.
#if defined(NOFSCHECK) || defined(CRAYXT) || defined(BGP) || defined(BGQ)
c     on catamount all fs are parallel, therefore we need only node0
c     on BGP/BGQ all fs are parallel, therefore we need only node0
      iocheckk=ga_nodeid().eq.0
#endif     
c
      rtdb_name  = ' '
      print *, "### calling ga_nodeid..."
      call flush(6)
      
      if (ga_nodeid() .gt. 0) goto 10000
c
c     default is a startup with name extracted from that of the input
c     file unless a database of that name is present in which case
c     you get a restart.  Overriden by presenting start/restart.
c
      odirective = .false.      ! True if find a start/restart/continue
      ostartup   = .true.
      ocontinue  = .false.
      echo       = .false.
      call input_default_file_prefix(input_filename,file_prefix)
c
      print *, "### rewinding luin..."
      call flush(6)
      rewind LuIn
      print *, "### luin rewound."
      call flush(6)
      call inp_init(LuIn,LuOut)
      print *, "### inp_init called."
      call flush(6)
 10   if (inp_search(.false., keys, nkeys)) then ! While
         if (.not. inp_a(field)) call errquit('input_start: inp?',0,
     &       INPUT_ERR)
         if (inp_compare(.false.,'start',field)) then
            odirective = .true.
            ostartup = .true.
            ocontinue = .false.
            call util_read_start_dir(file_prefix, rtdb_name)
         else if (inp_compare(.false.,'continue',field)) then
            call errquit('continue directive is no longer supported',
     *        555, INPUT_ERR)
            odirective = .true.
            ostartup = .false.
            ocontinue = .true.
            call util_read_start_dir(file_prefix, rtdb_name)
         else if (inp_compare(.false.,'restart',field)) then
            odirective = .true.
            ostartup = .false.
            ocontinue = .false.
            call util_read_start_dir(file_prefix, rtdb_name)
         else if (inp_compare(.false.,'scratch_dir',field)) then
            status = inp_line(scratch_dir)
            istart = 0
            status = inp_strtok(scratch_dir,' ',istart, iend)
            scratch_dir(istart:iend) = ' '
         else if (inp_compare(.false.,'permanent_dir',field)) then
            status = inp_line(permanent_dir)
            istart = 0
            status = inp_strtok(permanent_dir,' ',istart, iend)
            permanent_dir(istart:iend) = ' '
         else if (inp_compare(.false.,'echo',field)) then
            echo = .true.
         else if (inp_compare(.false.,'ecce_print', field)) then
            if (inp_a(ecce_file_name)) then
               call ecce_print_file_open(ecce_file_name)
               call ecce_print_echo_input(input_filename)
            endif
         else
            call errquit('input_start_opt: wierd error',0, INPUT_ERR)
         endif
         goto 10                ! End while
      endif
      rewind LuIn
      call inp_init(LuIn,LuOut)
c
      if (echo) call input_echo(LuIn,LuOut)
c
      if (rtdb_name .eq. ' ')
     $     call util_file_name('db',.false.,.false.,rtdb_name)
c
      if (.not. odirective) then
c
c     No start/restart directive presented.  See if we can find a database,
c     if so, assume a restart.  Otherwise it must be a startup.
c
         inquire(file=rtdb_name,exist=status)
         ostartup = .not. status
      endif
c
      rewind LuIn
      call inp_init(LuIn,LuOut)
c
c     Broadcast start options to everyone else
c
10000 call ga_brdcst(Msg_StartUp, ostartup, mitob1, 0)
      call ga_brdcst(Msg_StartUp, ocontinue, mitob1, 0)
      call util_char_ga_brdcst(Msg_startup, file_prefix, 0)
      call util_char_ga_brdcst(Msg_startup, scratch_dir, 0)
      call util_char_ga_brdcst(Msg_startup, permanent_dir, 0)
*
* now confirm (on each node) that scratch_dir and permanent_dir
* can have files
*
      call ga_sync()
*check permanent directory
      if(iocheckk) then
        call util_file_name('dir_check_p',.false.,.true.,
     &                      a_temporary_file)
        inquire(file=a_temporary_file, exist=already)
        bad_permanent_dir = .true.
        if(already) then
          iend = inp_strlen(a_temporary_file)
          write(luout,*)' Warning: test file already existed: ',
     &                  a_temporary_file(1:iend)
C         Assume all is well in the world, since file might be 
C         chmod 000
          bad_permanent_dir = .false.
        else
          open(UNIT=42,FILE=a_temporary_file,STATUS="new",ERR=91111)
          close(UNIT=42,STATUS="delete")
          call util_file_unlink(a_temporary_file)
          bad_permanent_dir = .false.
        endif
91111   continue
*check scratch directory
        call util_file_name('dir_check_s',.true.,.true.,
     &                      a_temporary_file)
        inquire(file=a_temporary_file, exist=already)
        bad_scratch_dir = .true.
        if(already) then
          iend = inp_strlen(a_temporary_file)
          write(luout,*)' Warning: test file already existed: ',
     &                  a_temporary_file(1:iend)
C         Assume all is well in the world, since file might be
C         chmod 000
          bad_scratch_dir = .false.
        else
          open(UNIT=43,FILE=a_temporary_file,STATUS="new",ERR=91122)
          close(UNIT=43,STATUS="delete")
          call util_file_unlink(a_temporary_file)
          bad_scratch_dir = .false.
        endif
91122   continue
      else
        bad_permanent_dir=.false.
        bad_scratch_dir=.false.
      endif
*
      if (bad_permanent_dir) then
        iend = inp_strlen(permanent_dir)
        write(luout,*)' could not open a file in permanent directory: ',
     &      permanent_dir(1:iend)
      endif
      if (bad_scratch_dir) then
        iend = inp_strlen(scratch_dir)
        write(luout,*)' could not open a file in scratch directory: ',
     &      scratch_dir(1:iend)
      endif
      if (bad_permanent_dir.and.bad_scratch_dir) then
        write(luout,*)
     &      ' Both permanent and scratch directory not accessible'
        call errquit('******** Fatal Error ********',911, INPUT_ERR)
      else if (bad_permanent_dir) then
        call errquit
     &      ('Fatal Error: permanent directory not accessible',911,
     &       INPUT_ERR)
      else if (bad_scratch_dir) then
        call errquit
     &      ('Fatal Error: scratch directory not accessible',911,
     &       INPUT_ERR)
      else
        return
      endif
c
      endsubroutine chemsh_input_file_info

!  Copyright (C) 2017 The authors of Py-ChemShell
!
!  This file is part of Py-ChemShell.
!
!  Py-ChemShell is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as
!  published by the Free Software Foundation, either version 3 of the
!  License, or (at your option) any later version.
!
!  Py-ChemShell is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with Py-ChemShell.  If not, see
!  <http://www.gnu.org/licenses/>.

subroutine fit_bqs(nccore, ncbq, ncshell, &
                   npcore, npbq, npshell, &
                   radius_cluster, radius_active, &
                   bq_margin, bq_density, bq_layer, bq_fit_weight, ierr)

    use ChemShellClusterModule, only : PyOptions, get_ndims, cluster_origin, debug

  ! Fit point charges around a cluster to reproduce electrostatics
  ! of the periodic system it was cut from
  !
  ! The fit is to the active atoms only, so a radius for this 
  ! region must be specified
  !
  ! bq_margin specifies the distance between the outer edge of 
  ! the cluster and the shell of bqs
  !
  ! bq_density is related to the number of bqs added
  ! If bq_density=n, the number of bqs in the surrounding shell 
  ! is 4n^2 + 2 (3d case). 
  ! In the 2d case number of bqs determined by bq_density and bq_layer
  ! (extra rings of charges to accommodate the adsorption layer). 
  ! Extra fitting sites are added above the surface to ensure a good
  ! fit for the bq_layer charges.
  !
  ! In addition there are 6 bqs placed far away from the cluster
  ! to account for the 'floating zero' of the potential and electric
  ! field
  !
  implicit none

  integer, intent(in) :: nccore, ncbq, ncshell
  integer, intent(in) :: npcore, npbq, npshell
  double precision, intent(in) :: radius_cluster
  double precision, intent(in) :: radius_active, bq_margin, bq_layer
  integer, intent(in) :: bq_density
  integer, intent(out) :: ierr
  ! AJL, 12/06/18. 
  real(kind=8), intent(in) :: bq_fit_weight
  
  double precision, dimension(3) :: r
  double precision :: v
  double precision, dimension(3) :: e
  double precision :: distance, t, z
  integer :: i, j, k, l, m, n, p

!  double precision, dimension(3) :: cluster_origin

  ! Arrays for periodic information
  double precision, dimension(npcore) :: pot_core
  double precision, dimension(npshell) :: pot_shel
  double precision, dimension(3, npcore) :: efield_core
  double precision, dimension(3, npshell) :: efield_shel
  integer, dimension(npshell) :: point_core
  integer, dimension(npcore) :: point_shel  

  ! Arrays for cluster information
  double precision, dimension(3, nccore+ncshell) :: cart_coords
  double precision, dimension(3, nccore) :: r_cluster_core
  double precision, dimension(3, ncshell) :: r_cluster_shel
  double precision, dimension(nccore+ncshell) :: cart_charges
  double precision, dimension(nccore) :: charge_cluster_core
  double precision, dimension(ncshell) :: charge_cluster_shel  
  integer, dimension(ncshell) :: point_cluster_core
  integer, dimension(nccore+ncshell) :: xtal_map
  integer, dimension(nccore) :: point_uc_c
  integer, dimension(ncshell) :: point_uc_s
  logical, dimension(nccore) :: core_active
  integer :: n_active_core, n_active_shel, n_fitting_sites
  
  ! Potential, field and fitting
  double precision :: pot_zero, charge_zero
  double precision, dimension(3) :: e_zero, charge_delta
  double precision :: mean_error, abs_error, mean_square
  double precision, dimension(nccore) :: pot_error_c
  double precision, dimension(ncshell) :: pot_error_s
  double precision, dimension(3, nccore) :: e_error_c
  double precision, dimension(3, ncshell) :: e_error_s
  double precision :: pole_big, pole_small
  double precision :: pi_half_n, theta, pi_half_i, fi, sin_theta
  integer :: i4

  ! Extra Fitting Sites for 2d case
  integer :: maxefs, nefs
  double precision :: sgrid, maxvol
  integer :: xygrid, zgrid
  double precision, allocatable :: r_efs(:,:)
  double precision, allocatable :: pot_efs(:)
  double precision, allocatable :: efield_efs(:,:)
  double precision, allocatable :: pot_error_efs(:)
  double precision, allocatable :: e_error_efs(:,:)

  ! Arrays for addded point charges
  double precision, allocatable :: r_polar_bq(:,:)
  double precision, allocatable :: r_lsq_bq(:,:)  
  double precision, allocatable :: charge_polar_bq(:)
  double precision, allocatable :: charge_lsq_bq(:)
  integer :: n_polar_bq, n_lsq_bq, count_bq
  double precision :: radius_bq
  double precision :: step_z
  integer :: n_layer
  double precision :: zmin, zmax, sign_z
  double precision :: pole_huge, height, z0, midheight, width

  ! Least squares
  double precision, allocatable :: a(:,:), b(:), v_kernel(:), x_bq(:,:)
  double precision, allocatable :: work(:)
  double precision, dimension(1) :: qwork
  integer :: lwork
  double precision :: lsq_constraint, charge_weight, charge_calc, q_polar_tot

  logical :: shell_model

  double precision :: pi, pi_half

  integer, parameter :: periodic_frag = 1, cluster_frag = 2

  double precision :: distance_3, totalcharge

  integer :: ndim

  ierr = 0

  ndim = get_ndims()

  efield_core = 0.0d0
  pot_error_c = 0.0d0
  pot_error_s = 0.0d0
  e_error_c   = 0.0d0
  e_error_s   = 0.0d0

  if (debug > 0) then
     write(6,'(a)')    "------------------------------------"
     write(6,'(a,i4)') "cluster_fit_bqs debug level:", debug
     write(6,'(a)')    "------------------------------------"
  end if

  ! totalcharge is the target charge to fit
  call PyOptions%get('totalcharge', totalcharge)

  ! PGI does not like acos in parameter initialisation so initialise here
  pi = dacos(-1.d0)
  pi_half = 0.5d0 * pi

  ! Check there are no point charges already in the cluster
  if (ncbq .ne. 0 .or. npbq .ne. 0) then
     write(6,*) "fit_bqs: number of point charges must be zero"
     ierr = 1
     return
  end if

  if (ncshell .eq. 0) then
     shell_model = .false.
  else
     shell_model = .true.
  end if
 
  ! Get cluster cartesian coordinates from fragment
  ! Split into core and shell arrays
  call get_cart_coords(cluster_frag, cart_coords, nccore, ncshell, ierr)
  r_cluster_core = cart_coords(:, 1:nccore)
  if (shell_model) r_cluster_shel = cart_coords(:, nccore+1:nccore+ncshell)
  if (ierr .ne. 0) return

  ! Get charges of cartesian sites from fragment
  ! Split into core and shell arrays
  call get_cart_charges(cluster_frag, cart_charges, nccore+ncshell, ierr)
  if (ierr .ne. 0) return
  charge_cluster_core = cart_charges(1:nccore)
  if (shell_model) charge_cluster_shel = cart_charges(nccore+1:nccore+ncshell)

  ! Get pointers from shells to cores
  ! Then setup pointers in the other direction
  if (shell_model) then
     call get_point_core(cluster_frag, point_cluster_core, ncshell, ierr)
     if (ierr .ne. 0) return
  end if

  ! Get pointer from cores/shells to the unit cell (xtal map) 
  call get_xtal_map(cluster_frag, xtal_map, nccore, ncshell, ierr)
  if (ierr .ne. 0) return
  point_uc_c = xtal_map(1:nccore)
  if (shell_model) point_uc_s = xtal_map(nccore+1:nccore+ncshell)

  ! Get origin of cluster in cartesians
!  call get_cluster_origin(cluster_origin, ierr)
!  if(ierr .ne. 0) return

  ! Get electrostatic potential and electric field for periodic system
  call get_electrostatics(periodic_frag, pot_core, pot_shel, &
                          efield_core, efield_shel, & 
                          npcore, npshell, ierr)
  if (ierr .ne. 0) return
  if (debug > 3) then
     write(6,'(/a)') "Periodic electrostatic potential and electric field (x y z)"
     write(6,'(/a)') "CORES"
     do i = 1, npcore
        write(6,'(i6, 4f20.10)') i, pot_core(i), efield_core(1:3,i)
     end do
     if (shell_model) then
        write(6,'(/a)') "SHELLS"
        do i = 1, npshell
           write(6,'(i6, 4f20.10)') i, pot_shel(i), efield_shel(1:3,i)
        end do
     end if
  end if

  ! DETERMINE POSITION OF ADDED BQS

  ! Determine the number of added bqs and allocate memory
  select case (ndim)
  case (2)
     ! bqs at the poles
     n_polar_bq = 6
     ! No extra layers above the hemisphere to accommodate
     ! adsorption layer
     step_z = pi * (radius_cluster + bq_margin) * 2.d0 / (4 * bq_density - 1)
     n_layer = (bq_layer + bq_margin) / step_z + 1
     !n_lsq_bq = 16 + &
     n_lsq_bq =  &
          (2 * bq_density * (bq_density + 1) + 1) + &
          (4 * bq_density * n_layer)
  case (3)
     ! bqs at the poles
     n_polar_bq = 6
     ! bqs to be fitted by least squares 
     n_lsq_bq = 4 * (bq_density**2) + 2
  case default
     write(6,*) "fit_bqs: error, ndim=", ndim
     ierr = 1
     return
  end select
  allocate(r_polar_bq(3, n_polar_bq))
  allocate(r_lsq_bq(3, n_lsq_bq))
  allocate(charge_polar_bq(n_polar_bq))
  allocate(charge_lsq_bq(n_lsq_bq))
  allocate(a(n_lsq_bq,n_lsq_bq))
  allocate(b(n_lsq_bq))
  allocate(v_kernel(n_lsq_bq))
  allocate(x_bq(3,n_lsq_bq))
  count_bq = 0
  r_polar_bq = 0.0d0
  r_lsq_bq = 0.0d0
  charge_polar_bq = 0.0d0
  charge_lsq_bq = 0.0d0

  ! Polar bqs
  ! These charges will account for floating zero potential
  select case (ndim)
  case (2,3)
     ! Six charges at remote poles on the three cartesian axes
     pole_big = 10.d0 * radius_cluster
     do i = 1, 3
        count_bq = count_bq + 1
        r_polar_bq(i,count_bq) = pole_big
        count_bq = count_bq + 1
        r_polar_bq(i,count_bq) = -pole_big
     end do
  end select
  if (count_bq /= n_polar_bq) then
     write(6, '(a)') "fit_bqs: count_bq /= n_polar_bq"
     ierr = -1
     return
  end if

  ! bqs for least squares fit
  count_bq = 0
  radius_bq = radius_cluster + bq_margin
  pi_half_n = pi_half / bq_density  
  select case (ndim)
  case (2)
     ! Determine direction of z axis with respect to surface normal
     zmin = +1.d70
     zmax = -1.d70
     do i = 1, nccore
        if (r_cluster_core(3,i) < zmin) zmin = r_cluster_core(3,i)
        if (r_cluster_core(3,i) > zmax) zmax = r_cluster_core(3,i)
     enddo
     if (dabs(cluster_origin(3) - zmin) > dabs(zmax - cluster_origin(3))) then
        sign_z=+1.d0
     else
        sign_z=-1.d0
     endif
     ! Parameters
     pole_huge = radius_bq * 100.d0
     height = bq_layer + bq_margin
     z0=(radius_bq + height)/2
     midheight=-radius_bq + z0
     width=1.5*radius_bq
     ! Two charges on far axial poles
!!$     count_bq=count_bq+1
!!$     r_lsq_bq(1,count_bq)=0.d0
!!$     r_lsq_bq(2,count_bq)=0.d0
!!$     r_lsq_bq(3,count_bq)=-pole_huge
!!$     count_bq=count_bq+1
!!$     r_lsq_bq(1,count_bq)=0.d0
!!$     r_lsq_bq(2,count_bq)=0.d0
!!$     r_lsq_bq(3,count_bq)=pole_huge   
     ! Eight charges in the corners of a cube to get higher poles
!!$     count_bq=count_bq+1
!!$     r_lsq_bq(1,count_bq)=radius_bq
!!$     r_lsq_bq(2,count_bq)=radius_bq
!!$     r_lsq_bq(3,count_bq)=-radius_bq
!!$     count_bq=count_bq+1
!!$     r_lsq_bq(1,count_bq)=-radius_bq
!!$     r_lsq_bq(2,count_bq)=radius_bq
!!$     r_lsq_bq(3,count_bq)=-radius_bq
!!$     count_bq=count_bq+1
!!$     r_lsq_bq(1,count_bq)=radius_bq
!!$     r_lsq_bq(2,count_bq)=-radius_bq
!!$     r_lsq_bq(3,count_bq)=-radius_bq
!!$     count_bq=count_bq+1
!!$     r_lsq_bq(1,count_bq)=-radius_bq
!!$     r_lsq_bq(2,count_bq)=-radius_bq
!!$     r_lsq_bq(3,count_bq)=-radius_bq
!!$     count_bq=count_bq+1
!!$     r_lsq_bq(1,count_bq)=radius_bq
!!$     r_lsq_bq(2,count_bq)=radius_bq
!!$     r_lsq_bq(3,count_bq)=height
!!$     count_bq=count_bq+1
!!$     r_lsq_bq(1,count_bq)=-radius_bq
!!$     r_lsq_bq(2,count_bq)=radius_bq
!!$     r_lsq_bq(3,count_bq)=height
!!$     count_bq=count_bq+1
!!$     r_lsq_bq(1,count_bq)=radius_bq
!!$     r_lsq_bq(2,count_bq)=-radius_bq
!!$     r_lsq_bq(3,count_bq)=height
!!$     count_bq=count_bq+1
!!$     r_lsq_bq(1,count_bq)=-radius_bq
!!$     r_lsq_bq(2,count_bq)=-radius_bq
!!$     r_lsq_bq(3,count_bq)=height
!    Put extra 4 charges on horizontal axes and 2 extra charges on z axis
!!$     count_bq=count_bq+1
!!$     r_lsq_bq(1,count_bq)=width
!!$     r_lsq_bq(2,count_bq)=0.d0
!!$     r_lsq_bq(3,count_bq)=midheight
!!$     count_bq=count_bq+1
!!$     r_lsq_bq(1,count_bq)=-width
!!$     r_lsq_bq(2,count_bq)=0.d0
!!$     r_lsq_bq(3,count_bq)=midheight
!!$     count_bq=count_bq+1
!!$     r_lsq_bq(1,count_bq)=0.d0
!!$     r_lsq_bq(2,count_bq)=width
!!$     r_lsq_bq(3,count_bq)=midheight
!!$     count_bq=count_bq+1
!!$     r_lsq_bq(1,count_bq)=0.d0
!!$     r_lsq_bq(2,count_bq)=-width
!!$     r_lsq_bq(3,count_bq)=midheight
!!$     count_bq=count_bq+1
!!$     r_lsq_bq(1,count_bq)=0.d0
!!$     r_lsq_bq(2,count_bq)=0.d0
!!$     r_lsq_bq(3,count_bq)=-radius_bq-z0
!!$     count_bq=count_bq+1
!!$     r_lsq_bq(1,count_bq)=0.d0
!!$     r_lsq_bq(2,count_bq)=0.d0
!!$     r_lsq_bq(3,count_bq)=height+z0
     ! Build hemisphere of point charges around cluster
     ! Put one charge on the pole of the hemi_sphere
     count_bq=count_bq+1
     r_lsq_bq(1,count_bq)=0.d0
     r_lsq_bq(2,count_bq)=0.d0
     r_lsq_bq(3,count_bq)=-radius_bq
     ! Build hemi-spherical grid by mapping triangles on 4 octants
     do i = 1, bq_density
        theta = -pi + i*pi_half_n
        pi_half_i = pi_half / i
        i4 = 4*i - 1
        do j=0, i4
           count_bq = count_bq + 1
           fi = pi_half_i*j
           sin_theta = dsin(theta)
           r_lsq_bq(1,count_bq)=radius_bq*dcos(fi)*sin_theta
           r_lsq_bq(2,count_bq)=radius_bq*dsin(fi)*sin_theta
           r_lsq_bq(3,count_bq)=radius_bq*dcos(theta)
        enddo
     enddo
     ! Build cylinder on top of hemi-sphere to accomodate adsorption layer
     do i=1,n_layer
        z=step_z*i
        do j=0,i4
           count_bq=count_bq+1
           fi=pi_half_i*j
           r_lsq_bq(1,count_bq)=radius_bq*dcos(fi)
           r_lsq_bq(2,count_bq)=radius_bq*dsin(fi)
           r_lsq_bq(3,count_bq)=z
        enddo
     enddo
     ! Turn upside down if necessary
     do i = 1, count_bq
        r_lsq_bq(3,i) = sign_z * r_lsq_bq(3,i)
     enddo
  case (3)
     ! Build sphere of point charges around the cluster
     pole_small = 1.5 * radius_bq
     ! Build hemi-spherical grid by mapping triangles on 4 octants
     ! and reflect on the other hemi-sphere
     count_bq = 1
     r_lsq_bq(1,count_bq)=0.d0
     r_lsq_bq(2,count_bq)=0.d0
     r_lsq_bq(3,count_bq)=-radius_bq
     count_bq = 2
     r_lsq_bq(1,count_bq)=0.d0
     r_lsq_bq(2,count_bq)=0.d0
     r_lsq_bq(3,count_bq)=radius_bq
     do i = 1, bq_density
        theta = -pi + i*pi_half_n
        pi_half_i = pi_half / i
        i4 = 4*i - 1
        do j=0, i4
           count_bq = count_bq + 1
           fi = pi_half_i*j
           sin_theta = dsin(theta)
           r_lsq_bq(1,count_bq)=radius_bq*dcos(fi)*sin_theta
           r_lsq_bq(2,count_bq)=radius_bq*dsin(fi)*sin_theta
           r_lsq_bq(3,count_bq)=radius_bq*dcos(theta)
           if(i .ne. bq_density) then
              count_bq=count_bq+1
              r_lsq_bq(1,count_bq)=r_lsq_bq(1,count_bq-1)
              r_lsq_bq(2,count_bq)=r_lsq_bq(2,count_bq-1)
              r_lsq_bq(3,count_bq)=-r_lsq_bq(3,count_bq-1)
           endif
        enddo
     enddo
  end select
  if (count_bq /= n_lsq_bq) then
     write(6, '(a)') "fit_bqs: count_bq /= n_lsq_bq"
     ierr = -1
     return
  end if  

  ! Position bqs around given centre
  do i = 1, n_polar_bq
     r_polar_bq(1:3,i) = r_polar_bq(1:3,i) + cluster_origin(1:3)
  end do
  do i = 1, n_lsq_bq
     r_lsq_bq(1:3, i) = r_lsq_bq(1:3, i) + cluster_origin(1:3)
  enddo
  if (debug > 3) then
     write(6,'(/a)') "BQ POSITIONS"    
     write(6,'(/a)') "Polar bqs"
     write(6,'(/10X,2(A,20X),A)') "X", "Y", "Z"
     do i = 1, n_polar_bq
        write(6,'(3f20.10)') r_polar_bq(1:3, i)
     end do
     write(6,'(/a)') "Least squares bqs"
     write(6,'(/10X,2(A,20X),A)') "X", "Y", "Z"
     do i = 1, n_lsq_bq
        write(6,'(3f20.10)') r_lsq_bq(1:3, i)
     end do
  end if


  ! FIT BQS TO PERIODIC ELECTROSTATIC POTENTIAL

  ! Determine which atoms are active
  ! TODO - will need to be modified in the molecular case
  core_active = .false.
  n_active_core = 0
  n_active_shel = 0
  do i = 1, nccore
     r(1:3) = r_cluster_core(1:3, i) - cluster_origin(1:3)
     distance = sqrt(r(1)*r(1) + r(2)*r(2) + r(3)*r(3))
     if (distance < radius_active) then
        core_active(i) = .true.
        n_active_core = n_active_core + 1
     end if
  end do
  if (shell_model) then
     do i = 1, ncshell
        if (core_active(point_cluster_core(i))) then
           n_active_shel = n_active_shel + 1
        end if
     end do
  end if
  if (debug > 0) then
     write(6,'(/a)') "Origin (x y z) and active radius"
     write(6,'(/4f20.10)') cluster_origin, radius_active
!     write(6,'(/a)') "Active cores"
!     do i = 1, nccore
!        if(core_active(i)) write(6,'(i4)') i
!     enddo
  endif


  ! 2d case: add extra fitting sites above the surface 
  nefs = 0
  if (ndim == 2) then
     ! Cylinder with radius=radius_active and height=(bq_layer+bq_margin)
     ! The 2.5 bohr grid size is arbitrary but chosen to be roughly 
     ! the same density as atomic fitting sites.
     sgrid = 2.5d0
     xygrid = int(radius_active/sgrid)+1
     ! z starts from 2 bohr above the surface, not from 0
     zgrid = int((bq_layer+bq_margin)/sgrid)
     maxefs = ((xygrid*2)+1) * ((xygrid*2)+1) * zgrid
     allocate(r_efs(3,maxefs))
     allocate(pot_efs(maxefs))
     allocate(efield_efs(3,maxefs))
     allocate(pot_error_efs(maxefs))
     allocate(e_error_efs(3,maxefs))
     do k = 1, zgrid
        do j = -xygrid, xygrid
           do i = -xygrid, xygrid
              r(1) = i * sgrid
              r(2) = j * sgrid
              r(3) = k * sgrid
              distance = sqrt(r(1)*r(1) + r(2)*r(2))
              if (distance < radius_active) then
                 nefs = nefs + 1
                 r_efs(1:3, nefs) = r(1:3)
              end if
           end do
        end do
     end do
     ! Turn upside down if necessary 
     ! and position around given centre
     do i = 1, nefs
        r_efs(3, i) = sign_z * r_efs(3, i)
        r_efs(1:3, i) = r_efs(1:3, i) + cluster_origin(1:3)
     enddo
     ! Now find the periodic potential/efield to fit to at these locations
     call periodic_electrostatics_f(1, 2, npcore, npbq, npshell, nefs, &
          r_efs, nefs, pot_efs, efield_efs, ierr)
     if (ierr .ne. 0) then
        write(6,*) 'fit_bqs: unable to get extra fitting site electrostatics'
        return
     end if
     if(debug > 3) then
        write(6,'(/a)') "Extra fitting sites locations"
        ! TWKDEBUG
        write(6,*) nefs
        write(6,*) nefs
        do i = 1, nefs
           write(6,'(a,3f12.5)') &
                "H ", r_efs(1:3, i)*0.529177249d0
        end do
        write(6,'(/a)') "Extra fitting sites pot, efield"
        do i = 1, nefs
           write(6,'(i5,f12.5,2x,3f12.5)') &
                i, pot_efs(i), efield_efs(1:3, i)
        end do
     end if
  else
     ! 0-sized arrays
     allocate(r_efs(3,nefs))
     allocate(pot_efs(nefs))
     allocate(efield_efs(3,nefs))
     allocate(pot_error_efs(nefs))
     allocate(e_error_efs(3,nefs))
  end if

  n_fitting_sites = n_active_core + n_active_shel + nefs

  ! Set up ESP and electric field error arrays with periodic values
  do i=1,nccore
     if(core_active(i)) then
        n = point_uc_c(i)
        pot_error_c(i) = -pot_core(n)
        e_error_c(1:3,i) = -efield_core(1:3,n)
     endif
  enddo
  if (shell_model) then
     do i=1,ncshell
        if(core_active(point_cluster_core(i))) then
           m = point_uc_s(i)
           pot_error_s(i) = -pot_shel(m)
           e_error_s(1:3,i) = -efield_shel(1:3,m)
        endif
     enddo
  endif
  do i=1,nefs
     pot_error_efs(i) = -pot_efs(i)
     e_error_efs(1:3, i) = -efield_efs(1:3, i)
  end do

  ! ESP and electric field contributions from active atoms
  ! Values at core sites
  do i=1,nccore
     if(core_active(i)) then
        ! Contribution from other cores
        do j=1,nccore
           if(j.ne.i) then
              call cluster_add_ve(r_cluster_core(1:3,i), r_cluster_core(1:3,j), &
                   charge_cluster_core(j), pot_error_c(i), e_error_c(1:3,i))
           endif
        enddo
        ! Contribution from shells (except for attached shell)
        if(shell_model) then
           do j=1,ncshell
              if(point_cluster_core(j).ne.i) then
                 call cluster_add_ve(r_cluster_core(1:3,i), r_cluster_shel(1:3,j), &
                      charge_cluster_shel(j), pot_error_c(i), e_error_c(1:3,i))
              endif
           enddo
        endif
     endif
  enddo
  ! Values at shell sites
  if (shell_model) then
     do i=1,ncshell
        if(core_active(point_cluster_core(i))) then
           ! Contribution from cores (except for attached core)
           do j=1,nccore
              if(j.ne.point_cluster_core(i)) then
                 call cluster_add_ve(r_cluster_shel(1:3,i), r_cluster_core(1:3,j), &
                      charge_cluster_core(j), pot_error_s(i), e_error_s(1:3,i))
              endif
           enddo
           ! Contribution from other shells
           do j=1,ncshell
              if(j.ne.i) then
                 call cluster_add_ve(r_cluster_shel(1:3,i), r_cluster_shel(1:3,j), &
                      charge_cluster_shel(j), pot_error_s(i), e_error_s(1:3,i))
              endif
           enddo
        endif
     enddo
  endif
  ! Values at extra fitting sites
  do i = 1, nefs
     ! Contribution from cores
     do j=1,nccore
        call cluster_add_ve(r_efs(1:3,i), r_cluster_core(1:3,j), &
                   charge_cluster_core(j), pot_error_efs(i), e_error_efs(1:3,i))
     enddo
     ! Contribution from shells
     if (shell_model) then
        do j=1,ncshell
           call cluster_add_ve(r_efs(1:3,i), r_cluster_shel(1:3,j), &
                charge_cluster_shel(j), pot_error_efs(i), e_error_efs(1:3,i))
        enddo
     endif
  enddo
  call cluster_fit_errors(nccore, ncshell, n_fitting_sites, nefs, core_active, &
       point_cluster_core, pot_error_c, pot_error_s, pot_error_efs, &
       e_error_c, e_error_s, e_error_efs, &
       pot_zero, e_zero, mean_error, abs_error, mean_square)
  write(*,'(/a/a,i12)') &
          ' Fitting...', &
          ' Number of sites to fit     : ', n_fitting_sites
  write(*,'(/a)') ' Before fitting'
  write(*,'(a,g20.12)') &
          ' Mean error                 : ', mean_error,  &
          ' Absolute error             : ', abs_error,   &
          ' RMS                        : ', mean_square, & 
          ' Mean potential             : ', pot_zero,    &
          ' Mean field Ex              : ', e_zero(1),   &
          ' Mean field Ey              : ', e_zero(2),   &
          ' Mean field Ez              : ', e_zero(3) 

  ! Calculate error for on-site electrostatic potential with floating zero

  ! Calculate polar bq charges
  !     these charges should create potential and field of opposite sign
  !     to cancel mean potential and field errors.
  select case (ndim)
  case (2,3)
     charge_zero = -pot_zero*pole_big/6.d0
     charge_delta(1:3) = -e_zero(1:3)*pole_big*pole_big/2.d0
     count_bq = 0
     do i = 1, 3
        count_bq = count_bq + 1
        charge_polar_bq(count_bq) = charge_zero - charge_delta(i)
        count_bq = count_bq + 1
        charge_polar_bq(count_bq) = charge_zero + charge_delta(i)
     end do
  end select

  !   Recalculate potential and field errors
  !   in the presence of added charges
  do i=1,nccore
     if(core_active(i)) then
        do j=1, n_polar_bq
           call cluster_add_ve(r_cluster_core(1:3,i), r_polar_bq(1:3,j), &
                charge_polar_bq(j), pot_error_c(i), e_error_c(1:3,i))
        enddo
     endif
  enddo
  if (shell_model) then
     do i=1,ncshell
        if(core_active(point_cluster_core(i))) then
           do j=1, n_polar_bq
              call cluster_add_ve(r_cluster_shel(1:3,i), r_polar_bq(1:3,j), &
                   charge_polar_bq(j), pot_error_s(i), e_error_s(1:3,i))
           enddo
        endif
     enddo
  endif
  do i = 1, nefs
     do j = 1, n_polar_bq
        call cluster_add_ve(r_efs(1:3,i), r_polar_bq(1:3,j), &
             charge_polar_bq(j), pot_error_efs(i), e_error_efs(1:3,i))        
     end do
  end do

  if (n_polar_bq > 0) then
     call cluster_fit_errors(nccore, ncshell, n_fitting_sites, nefs, core_active, &
          point_cluster_core, pot_error_c, pot_error_s, pot_error_efs, &
          e_error_c, e_error_s, e_error_efs, &
          pot_zero, e_zero, mean_error, abs_error, mean_square)
     write(*,'(/a)') ' Excluding mean potential and field'
     write(*,'(a,g20.12)') &
          ' Mean error                 : ', mean_error,  &
          ' Absolute error             : ', abs_error,   &
          ' RMS                        : ', mean_square, &
          ' Mean potential             : ', pot_zero,    &
          ' Mean field Ex              : ', e_zero(1),   &
          ' Mean field Ey              : ', e_zero(2),   &
          ' Mean field Ez              : ', e_zero(3) 
  endif
  
  ! This section is marked "INSANE" in construct
  ! According to Alexey, in principle just the first run evaluation 
  ! based on the raw average potential and field should be sufficient
  ! as we are working with double precision, but in practice reiterating
  ! this calc helps to get much better values.
  select case (ndim)
  case(2,3)
     charge_zero=-pot_zero*pole_big/6.d0
     do i=1, n_polar_bq
        charge_polar_bq(i)=charge_polar_bq(i)+charge_zero
     enddo
  end select
  !   Recalculate potential and field errors
  !   in the presence of added charges
  do i=1,nccore
     if(core_active(i)) then
        do j = 1, n_polar_bq
           ! Note charge_zero
           call cluster_add_ve(r_cluster_core(1:3,i), r_polar_bq(1:3,j), &
                charge_zero, pot_error_c(i), e_error_c(1:3,i))
        enddo
     endif
  enddo
  if(shell_model) then
     do i=1,ncshell
        if(core_active(point_cluster_core(i))) then
           do j = 1, n_polar_bq
              ! Note charge_zero
              call cluster_add_ve(r_cluster_shel(1:3,i), r_polar_bq(1:3,j), &
                   charge_zero, pot_error_s(i), e_error_s(1:3,i))
           enddo
        endif
     enddo
  endif
  do i = 1, nefs
     do j = 1, n_polar_bq
        call cluster_add_ve(r_efs(1:3,i), r_polar_bq(1:3,j), &
             charge_zero, pot_error_efs(i), e_error_efs(1:3,i))        
     end do
  end do
  if (n_polar_bq > 0) then
     call cluster_fit_errors(nccore, ncshell, n_fitting_sites, nefs, core_active, &
          point_cluster_core, pot_error_c, pot_error_s, pot_error_efs, &
          e_error_c, e_error_s, e_error_efs, &
          pot_zero, e_zero, mean_error, abs_error, mean_square)
     write(*,'(/a)') ' Excluding mean potential and field, reiterated'
     write(*,'(a,g20.12)') &
          ' Mean error                 : ', mean_error,  &
          ' Absolute error             : ', abs_error,   &
          ' RMS                        : ', mean_square, &
          ' Mean potential             : ', pot_zero,    &
          ' Mean field Ex              : ', e_zero(1),   &
          ' Mean field Ey              : ', e_zero(2),   &
          ' Mean field Ez              : ', e_zero(3) 
  endif

  ! Build the least squares equations that find the bq charges that 
  ! minimize the error in the potential and electric field
  b = 0.d0
  a = 0.d0
  !AJL, 12/06/18: Commented out as now defined in python
  !charge_weight=1.0d-10
  charge_weight = bq_fit_weight
  lsq_constraint = -totalcharge + sum(charge_polar_bq)
  do l=1, nccore
     if(core_active(l)) then
        do i = 1, n_lsq_bq
           x_bq(1:3,i) = r_cluster_core(1:3,l)- r_lsq_bq(1:3,i)
           v_kernel(i)=1.d0/ &
                sqrt(x_bq(1,i)**2+x_bq(2,i)**2+x_bq(3,i)**2)
           t=v_kernel(i)*v_kernel(i)
           a(i,i)=a(i,i)+t*(1.d0+t)
           b(i)=b(i)+v_kernel(i)* &
                (pot_error_c(l)+t* &
                ( e_error_c(1,l)*x_bq(1,i)+ &
                e_error_c(2,l)*x_bq(2,i)+ &
                e_error_c(3,l)*x_bq(3,i) ) )
        enddo
        do i = 1, n_lsq_bq
           do j= i+1, n_lsq_bq
              t=v_kernel(i)*v_kernel(j)
              a(i,j)=a(i,j)+t*(1.d0+t*t* &
                   ( x_bq(1,i)*x_bq(1,j)+ &
                   x_bq(2,i)*x_bq(2,j)+ &
                   x_bq(3,i)*x_bq(3,j) ) )
           enddo
        enddo
     endif
  enddo
  do l=1, ncshell
     if(core_active(point_cluster_core(l))) then
        do i = 1, n_lsq_bq 
           x_bq(1:3,i) = r_cluster_shel(1:3,l) - r_lsq_bq(1:3,i)
           v_kernel(i)=1.d0/ &
                sqrt(x_bq(1,i)**2+x_bq(2,i)**2+x_bq(3,i)**2)
           t=v_kernel(i)*v_kernel(i)
           a(i,i)=a(i,i)+t*(1.d0+t)
           b(i)=b(i)+v_kernel(i)* &
                (pot_error_s(l)+t* &
                ( e_error_s(1,l)*x_bq(1,i)+ &
                e_error_s(2,l)*x_bq(2,i)+ &
                e_error_s(3,l)*x_bq(3,i) ) )
        enddo
        do i = 1, n_lsq_bq
           do j = i+1, n_lsq_bq
              t=v_kernel(i)*v_kernel(j)
              a(i,j)=a(i,j)+t*(1.d0+t*t* &
                   ( x_bq(1,i)*x_bq(1,j)+ &
                   x_bq(2,i)*x_bq(2,j)+ &
                   x_bq(3,i)*x_bq(3,j) ) )
           enddo
        enddo
     endif
  enddo
  do l = 1, nefs
     do i = 1, n_lsq_bq 
        x_bq(1:3,i) = r_efs(1:3,l) - r_lsq_bq(1:3,i)
        v_kernel(i)=1.d0/ &
             sqrt(x_bq(1,i)**2+x_bq(2,i)**2+x_bq(3,i)**2)
        t=v_kernel(i)*v_kernel(i)
        a(i,i)=a(i,i)+t*(1.d0+t)
        b(i)=b(i)+v_kernel(i)* &
             (pot_error_efs(l)+t* &
             ( e_error_efs(1,l)*x_bq(1,i)+ &
             e_error_efs(2,l)*x_bq(2,i)+ &
             e_error_efs(3,l)*x_bq(3,i) ) )
     enddo
     do i = 1, n_lsq_bq
        do j = i+1, n_lsq_bq
           t=v_kernel(i)*v_kernel(j)
           a(i,j)=a(i,j)+t*(1.d0+t*t* &
                ( x_bq(1,i)*x_bq(1,j)+ &
                x_bq(2,i)*x_bq(2,j)+ &
                x_bq(3,i)*x_bq(3,j) ) )
        enddo
     enddo
  enddo
  ! Full a matrix required for lapack call
  do i = 1, n_lsq_bq
     do j=1,i-1
        a(i,j) = a(j,i)
     end do
  end do
  ! Charge constraint added in least squares procedure
  ! lsq_constraint is the target total least squares charge of the bqs
  ! charge_weight is the weight given to the constraint in the penalty function
  ! AJL, 12/06/18. Commented out as now incoming from python
  !charge_weight = 1.0d-10
  charge_weight=bq_fit_weight
  lsq_constraint = -totalcharge + sum(charge_polar_bq)
  b = b + charge_weight*lsq_constraint
  a = a + charge_weight
  ! Solve the resulting system of linear equations using call to lapack
  ! First query workspace size 
  call dgels('N', n_lsq_bq, n_lsq_bq, 1, &
       a, n_lsq_bq, b, n_lsq_bq, &
       qwork, -1, ierr)
  lwork = int(qwork(1))
  ! Solve the equations
  ! Solution is returned in b
  allocate(work(lwork))
  call dgels('N', n_lsq_bq, n_lsq_bq, 1, &
       a, n_lsq_bq, b, n_lsq_bq, &
       work, lwork, ierr)
  deallocate(work)
  if (ierr .ne. 0) then
     write(6,*) 'fit_bqs: lapack least squares solver failed'
     return
  end if
  
  ! Output is actually the negative of the true charge
  charge_lsq_bq(1:n_lsq_bq) = -b(1:n_lsq_bq)

  write(6,'(/a)')    ' BQ fitting'
  write(6,'(a,i12)') ' Number of polar BQs        : ', n_polar_bq
  write(6,'(a,i12)') ' Number of least squares BQs: ', n_lsq_bq

  if (debug > 3) then
     write(*,'(/a/)') 'BQ CHARGES'
     write(*,'(a)') 'Polar bqs'
     do i = 1, n_polar_bq
        write(*,'(i4,f30.18)') i, charge_polar_bq(i)
     end do
     write(*,'(/a)') 'Least squares bqs'
     do i = 1, n_lsq_bq
        write(*,'(i4,f30.18)') i, charge_lsq_bq(i)
     enddo
  end if

  ! Calculate errors after fitting
  ! Note there is a sign error in the corresponding construct version
  ! Here the code is consistent with what is used for the polar charges
  do i=1, nccore
     if(core_active(i)) then
        ! Only the sphere bqs
        do j = 1, n_lsq_bq
           call cluster_add_ve(r_cluster_core(1:3,i), r_lsq_bq(1:3,j), &
                charge_lsq_bq(j), pot_error_c(i), e_error_c(1:3,i))
        enddo
     endif
  enddo
  if(shell_model) then
     do i=1, ncshell
        if(core_active(point_cluster_core(i))) then
           ! Only the sphere bqs
           do j = 1, n_lsq_bq
              call cluster_add_ve(r_cluster_shel(1:3,i), r_lsq_bq(1:3,j), &
                   charge_lsq_bq(j), pot_error_s(i), e_error_s(1:3,i))
           enddo
        endif
     enddo
  endif
  do i=1, nefs
     ! Only the sphere bqs
     do j = 1, n_lsq_bq
        call cluster_add_ve(r_efs(1:3,i), r_lsq_bq(1:3,j), &
             charge_lsq_bq(j), pot_error_efs(i), e_error_efs(1:3,i))
     end do
  end do
  call cluster_fit_errors(nccore, ncshell, n_fitting_sites, nefs, core_active, &
       point_cluster_core, pot_error_c, pot_error_s, pot_error_efs, &
       e_error_c, e_error_s, e_error_efs, &
       pot_zero, e_zero, mean_error, abs_error, mean_square)
  write(6,'(/a)') ' After fitting'
  write(6,'(a,g20.12)') &
       ' Mean error                 : ', mean_error, &
       ' Absolute error             : ', abs_error,  &
       ' RMS                        : ', mean_square
  ! Fitted charge does not include the polar charges
  charge_calc = sum(charge_lsq_bq)
  ! Added charge is the sum of the polar charges
  q_polar_tot = sum(charge_polar_bq)
  write(6,'(a,g20.12)') &
       ' Target total cluster charge: ', totalcharge, &
       ' Total least squares charge : ', charge_calc, &
       ' Total polar charge         : ', q_polar_tot, &
       ' Total BQs                  : ', charge_calc+q_polar_tot
  
  ! Write the cluster to the fragment object
  call set_cluster_bqs(n_polar_bq, n_lsq_bq, &
       r_polar_bq, r_lsq_bq, charge_polar_bq, charge_lsq_bq, &
       ierr)
  if (ierr .ne. 0) return

  ! Deallocate
  deallocate(r_polar_bq)
  deallocate(r_lsq_bq)
  deallocate(charge_polar_bq)
  deallocate(charge_lsq_bq)
  deallocate(a)
  deallocate(b)
  deallocate(v_kernel)
  deallocate(x_bq)
  deallocate(r_efs)
  deallocate(pot_efs)
  deallocate(efield_efs)
  deallocate(pot_error_efs)
  deallocate(e_error_efs)

end subroutine fit_bqs


subroutine cluster_add_ve(r0, ri, qi, vtot, etot)
  
  implicit none

  double precision, dimension(3), intent(in) :: r0, ri
  double precision, intent(in) :: qi

  double precision, intent(inout) :: vtot
  double precision, dimension(3), intent(inout) :: etot

  double precision, dimension(3) :: ri0
  double precision :: d2, d, v

  ri0(1:3) = r0(1:3) - ri(1:3)
  d2 = ri0(1)*ri0(1) + ri0(2)*ri0(2) + ri0(3)*ri0(3)
  d = sqrt(d2)
  v = qi / d
  vtot = vtot + v
  etot(1:3) = etot(1:3) + (v * ri0(1:3) / d2)

end subroutine cluster_add_ve


subroutine cluster_fit_errors(nccore, ncshell, n_fitting_sites, nefs, core_active, &
     point_cluster_core, pot_error_c, pot_error_s, pot_error_efs, &
     e_error_c, e_error_s, e_error_efs, &
     pot_zero, e_zero, mean_error, abs_error, mean_square)

  implicit none

  integer, intent(in) :: nccore, ncshell, n_fitting_sites, nefs
  logical, dimension(nccore), intent(in) :: core_active
  integer, dimension(ncshell), intent(in) :: point_cluster_core
  double precision, dimension(nccore), intent(in) :: pot_error_c
  double precision, dimension(ncshell), intent(in) :: pot_error_s
  double precision, dimension(nefs), intent(in) :: pot_error_efs
  double precision, dimension(3, nccore), intent(in) :: e_error_c
  double precision, dimension(3, ncshell), intent(in) :: e_error_s
  double precision, dimension(3, nefs), intent(in) :: e_error_efs

  double precision, intent(out) :: pot_zero
  double precision, dimension(3), intent(out) :: e_zero
  double precision, intent(out) :: mean_error, abs_error, mean_square

  integer :: i
  double precision :: d_active_tot

  ! Mean error of electrostatic potential
  pot_zero = 0.0d0
  ! Mean error of electric field components
  e_zero(1:3) = 0.0d0
  ! ME, MAE, RMSE of ESP and electric field together
  mean_error = 0.0d0
  abs_error = 0.0d0
  mean_square = 0.0d0
  
  do i = 1, nccore
     if (core_active(i)) then
        pot_zero = pot_zero + pot_error_c(i)
        e_zero(1:3) = e_zero(1:3) + e_error_c(1:3,i)
        mean_error = mean_error + pot_error_c(i) + &
             e_error_c(1,i) + e_error_c(2,i) + e_error_c(3,i) 
        abs_error = abs_error + abs(pot_error_c(i)) + &
             abs(e_error_c(1,i)) + abs(e_error_c(2,i)) + abs(e_error_c(3,i))
        mean_square = mean_square + pot_error_c(i)**2.0d0 +  &
             e_error_c(1,i)**2.0d0 + e_error_c(2,i)**2.0d0 + e_error_c(3,i)**2.0d0
     end if
  end do
  do i = 1, ncshell
     if (core_active(point_cluster_core(i))) then
        pot_zero = pot_zero + pot_error_s(i)
        e_zero(1:3) = e_zero(1:3) + e_error_s(1:3,i)
        mean_error = mean_error + pot_error_s(i) + &
             e_error_s(1,i) + e_error_s(2,i) + e_error_s(3,i) 
        abs_error = abs_error + abs(pot_error_s(i)) + &
             abs(e_error_s(1,i)) + abs(e_error_s(2,i)) + abs(e_error_s(3,i))
        mean_square = mean_square + pot_error_s(i)**2.0d0 +  &
             e_error_s(1,i)**2.0d0 + e_error_s(2,i)**2.0d0 + e_error_s(3,i)**2.0d0
     end if
  end do
  do i = 1, nefs
     pot_zero = pot_zero + pot_error_efs(i)
     e_zero(1:3) = e_zero(1:3) + e_error_efs(1:3,i)
     mean_error = mean_error + pot_error_efs(i) + &
          e_error_efs(1,i) + e_error_efs(2,i) + e_error_efs(3,i) 
     abs_error = abs_error + abs(pot_error_efs(i)) + &
             abs(e_error_efs(1,i)) + abs(e_error_efs(2,i)) + abs(e_error_efs(3,i))
     mean_square = mean_square + pot_error_efs(i)**2.0d0 +  &
          e_error_efs(1,i)**2.0d0 + e_error_efs(2,i)**2.0d0 + e_error_efs(3,i)**2.0d0    
  end do

  if(n_fitting_sites /= 0) then
     d_active_tot = dble(n_fitting_sites)
     pot_zero = pot_zero / d_active_tot
     e_zero(1:3) = e_zero(1:3) / d_active_tot
     mean_error = mean_error / d_active_tot
     abs_error = abs_error / d_active_tot
     mean_square = sqrt(mean_square / d_active_tot)
  endif

end subroutine cluster_fit_errors

! **********************************************************************
! **                                                                  **
! **                      DL-FIND main module                         **
! **                                                                  **
! **                    Johannes Kaestner 2006                        **
! **                                                                  **
! **                                                                  **
! **********************************************************************
!!****J* DL-FIND/main
!!
!! NAME
!! DL-FIND
!!
!! FUNCTION
!! Main unit of the optimiser DL-FIND
!!
!!
!! DATA
!! $Date$
!! $Revision$
!! $Author$
!! $URL$
!! $Id$
!!
!! COPYRIGHT
!!
!!  Copyright 2007 Johannes Kaestner (kaestner@theochem.uni-stuttgart.de),
!!  Tom Keal (thomas.keal@stfc.ac.uk)
!!
!!  This file is part of DL-FIND.
!!
!!  DL-FIND is free software: you can redistribute it and/or modify
!!  it under the terms of the GNU Lesser General Public License as 
!!  published by the Free Software Foundation, either version 3 of the 
!!  License, or (at your option) any later version.
!!
!!  DL-FIND is distributed in the hope that it will be useful,
!!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!!  GNU Lesser General Public License for more details.
!!
!!  You should have received a copy of the GNU Lesser General Public 
!!  License along with DL-FIND.  If not, see 
!!  <http://www.gnu.org/licenses/>.
!!
!!****
! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

!! Main layout:
!! external program calls dl_find
!!
!! dl-find
!!   |
!!   dlf_read_in
!!   |
!!   dlf_task (calls dlf_run once or several times)
!!       |
!!       dlf_run 
!!       (restart is at the moment handeled there. This does not work really IMPROVE)
!!          |
!!          dlf_init
!!          main optimisation cycle
!!   |<--   dlf_destroy
!!   |
!!   shut down
!!   |
!! return to calling program
!!
subroutine dl_find(nvarin,nvarin2,nspec,master&
#ifdef GAMESS
    ,core&
#endif
    )
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stdout
  use dlf_stat, only: stat
  use dlf_allocate, only: allocate_report,allocate,deallocate
  use dlf_store, only: store_delete_all
  implicit none
  integer   ,intent(in)    :: nvarin ! number of variables to read in
                                     !  3*nat
  integer   ,intent(in)    :: nvarin2! number of variables to read in
                                     !  in the second array (coords2)
  integer   ,intent(in)    :: nspec  ! number of values in the integer
                                     !  array spec
  integer   ,intent(in)    :: master ! 1 if this task is the master of
                                     ! a parallel run, 0 otherwise
#ifdef GAMESS
  real(rk) :: core(*) ! GAMESS memory, not used in DL-FIND
#endif
  ! 
! **********************************************************************

  ! Flag for dlf_fail - needs to be set before anything else
  glob%cleanup = 0

  ! read input parameters, set defaults
  call dlf_read_in(nvarin,nvarin2,nspec,master)

  ! task manager, main optimisation cycle
  call dlf_task( &
#ifdef GAMESS
    core&
#endif
    )

  ! shut down finally
  call dlf_deallocate_glob()

  ! deallocate arrays in formstep_set_tsmode
  call dlf_formstep_set_tsmode(1,-2,1.d0)

  ! delete dlf_store
  call store_delete_all

  call clock_stop("TOTAL")
  call time_report

  call allocate_report

end subroutine dl_find

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* main/dlf_read_in
!!
!! FUNCTION
!!
!! * Init clock
!! * Get input parameters from calling code
!! * set defaults
!! * call dlf_allocate_glob to allocate arrays globally to the optimiser
!!
!! SYNOPSIS
subroutine dlf_read_in(nvarin,nvarin2,nspec,master)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,pi,stdout,printl,printf
  use dlf_stat, only: stat
  use dlf_allocate, only: allocate,deallocate
  use dlf_store, only: store_initialise
  use dlf_constants, only: dlf_constants_init,dlf_constants_get
  implicit none
  integer   ,intent(in)    :: nvarin ! number of variables to read in
                                     !  3*nat
  integer   ,intent(in)    :: nvarin2! number of variables to read in
                                     !  in the second array (coords2)
  integer   ,intent(in)    :: nspec  ! number of values in the integer
                                     !  array spec
  integer   ,intent(in)    :: master ! 1 if this task is the master of
                                     ! a parallel run, 0 otherwise
  real(rk),allocatable :: tmpcoords(:),tmpcoords2(:)
  integer, allocatable :: spec(:)
  integer              :: ivar,nat,nframe,nmass,nweight,nz,tsrel
  integer              :: massweight,ierr
  real(rk)             :: svar
  integer              :: tdlf_farm
  integer              :: n_po_scaling
  integer              :: coupled_states
  integer              :: micro_esp_fit
! **********************************************************************

  pi=4.D0*datan(1.D0)

  call time_init
  call dlf_constants_init
    !call dlf_constants_get("NONE",svar) ! to cause printing of output
  call clock_start("TOTAL")

  if(nvarin<=0) call dlf_fail("A positive number of variables is needed")

  call allocate(tmpcoords,nvarin)
  call allocate(tmpcoords2,max(nvarin2,1))
  call allocate(spec,max(nspec,1))

  ! ====================================================================
  ! READ EXTERNAL PARAMETERS, SET DEFAULTS
  ! ====================================================================

  ! set parameters to something useless to recognise user input
  call dlf_default_init(nspec,spec)
  nz=0
  nweight=0

  ! ====================================================================
  ! The input arrays and their meaning:
  ! tmpcoords(nvarin) : one set of coordinates (main point)
  ! tmpcoords2(nvarin2) : a multi-purpose real array
  !    nframe*nat*3    entries of coordinates of nframe structures
  !    nweight         entries of weights (nat or 0)
  !    nmass           entries of atomic masses (nat or 0)
  !    n_po_scaling    entries of radii scaling factors in the parallel 
  !                    optimization (0 [meaning all radii set to the base 
  !                    value], or a pre-known nivar)
  !    i.e. nvarin2= nframe*nat*3 + nweight + nmass + n_po_scaling
  ! spec(nspec) : integer specification array
  !    nat     entries of freezing/residue number
  !    nz      entries of nuclear charges (same order as coords)
  !    5*ncons entries of constraints (typ, atom1,atom2, atom3, atom4)
  !    2*nconn entries of connections (atom1 atom2)
  !    nat     entries of microiterative region specification
  !    i.e. nspec= nat + nz + 5*ncons + 2*nconn + nat
  ! ====================================================================
  ! get input parameters
  ivar=1
  massweight=0
  tdlf_farm=1 ! set default value
  n_po_scaling=0 ! set default value
  coupled_states=1 ! set default value
  micro_esp_fit=0 ! set default value
  call dlf_get_params(nvarin,max(nvarin2,1),max(nspec,1), &
      tmpcoords,tmpcoords2,spec, ierr, &
      glob%tolerance,printl,glob%maxcycle,glob%maxene,&
      ivar,glob%icoord,glob%iopt,glob%iline,glob%maxstep, &
      glob%scalestep,glob%lbfgs_mem,glob%nimage,glob%nebk, &
      glob%dump,glob%restart,nz,glob%ncons,glob%nconn,&
      glob%update,glob%maxupd,glob%delta,glob%soft,glob%inithessian, &
      glob%carthessian,tsrel,glob%maxrot,glob%tolrot,nframe,nmass,nweight,&
      glob%timestep,glob%fric0,glob%fricfac,glob%fricp, &
      glob%imultistate, glob%state_i, glob%state_j, &
      glob%pf_c1, glob%pf_c2, glob%gp_c3, glob%gp_c4, glob%ln_t1, glob%ln_t2, &
      printf, glob%tolerance_e, glob%distort, massweight, glob%minstep, &
      glob%maxdump, glob%task, glob%temperature, &
      glob%po_pop_size, glob%po_radius_base, glob%po_contraction, &
      glob%po_tol_r_base, glob%po_tolerance_g, glob%po_distribution, &
      glob%po_maxcycle, glob%po_init_pop_size, glob%po_reset, &
      glob%po_mutation_rate, glob%po_death_rate, glob%po_scalefac, &
      glob%po_nsave,glob%ntasks,tdlf_farm,n_po_scaling, &
      glob%neb_climb_test, glob%neb_freeze_test, glob%nzero, &
      coupled_states, glob%qtsflag, &
      glob%imicroiter, glob%maxmicrocycle, micro_esp_fit)

  if(ierr/=0) call dlf_fail("Failed to read parameters")

  if (glob%ntasks <= 0) then
    write(stdout,'("glob%ntasks = ",i6)') glob%ntasks
    call dlf_fail("Number of task farms must be positive")
  end if

  ! call this subroutine even if glob%ntasks == 1 to sort out the 
  ! writing to files from each processor and the communicators
  call dlf_make_taskfarm(tdlf_farm)

  ! get logical variables (communication with c-code requires integers)
  glob%tatoms=(ivar==1)
  glob%tsrelative=(tsrel==1)
  glob%massweight=(massweight==1)
  glob%micro_esp_fit = (micro_esp_fit == 1)

  ! Do we need to calculate the interstate coupling gradient?
  ! If coupled_states is false, coupling = zero.
  if (glob%imultistate > 1 .and. coupled_states == 1) glob%needcoupling = 1

  ! set parameters that have not been set by the user to the default
  ! this routine defines the default values
  call dlf_default_set(nvarin)

  ! check consistency of the array sizes:
  nat=nvarin/3
  if(nspec/=nat+nz+5*glob%ncons+2*glob%nconn+nat) then
    write(stdout,'("nspec ",i6)') nspec
    write(stdout,'("nat   ",i6)') nat
    write(stdout,'("nz    ",i6)') nz
    write(stdout,'("ncons ",i6)') glob%ncons
    write(stdout,'("nconn ",i6)') glob%nconn
    write(stdout,'("nspec should be: nat + nz + 5*ncons + 2*nconn + nat")')
    call dlf_fail("Inconsistent size of array spec - interface error")
  end if

  if(glob%tatoms.and.(nvarin2/=nframe*nat*3+nweight+nmass &
      .or. (nweight/=0.and.nweight/=nat) &
      .or. (nmass/=0.and.nmass/=nat) &
      .or. (n_po_scaling < 0) ) ) then
    write(stdout,'("nvarin2      ",i6)') nvarin2
    write(stdout,'("nframe       ",i6)') nframe
    write(stdout,'("nat          ",i6)') nat
    write(stdout,'("nweight      ",i6)') nweight
    write(stdout,'("nmass        ",i6)') nmass
    write(stdout,'("n_po_scaling ",i6)') n_po_scaling
    write(stdout,'("varin2 should be: nframe*nat*3 + nweight + nmass + n_po_scaling")')
    write(stdout,'("nweight should be either 0 or nat")')
    write(stdout,'("nmass should be either 0 or nat")')
    call dlf_fail("Inconsistent size of array coords2 - interface error")
  end if

  ! check consistency of multistate calculations
  if (glob%imultistate > 0) call dlf_conint_check_consistency

  ! initialise printout
  if(master==0) then
    ! this is a slave, do not print anything!
    printl=-2
    printf=-2
  end if

  if(printl>=2) call dlf_printheader

  ! ====================================================================
  ! INITIALISE VARIOUS INSTANCES
  ! ====================================================================

  ! allocate storage
  call dlf_allocate_glob(nvarin,nvarin2,nspec,tmpcoords,tmpcoords2,spec,&
      nz,nframe,nmass,nweight,n_po_scaling)
  call deallocate(tmpcoords)
  call deallocate(tmpcoords2)
  call deallocate(spec)

  ! initialise (reset) all statistics counters
  stat%sene=0
  stat%pene=0
  call dlf_stat_reset

  ! initialise dlf_store
  call store_initialise

end subroutine dlf_read_in
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* main/dlf_run
!!
!! FUNCTION
!!
!! * Initialise coordinates, formstep, linesearch
!! * do main optimisation cycle
!! * Destroy coordinates, formstep, linesearch
!!
!! SYNOPSIS
subroutine dlf_run( &
#ifdef GAMESS
    core&
#endif
    )
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stdout,printl,printf
  use dlf_stat, only: stat
  use dlf_allocate, only: allocate,deallocate
  implicit none
#ifdef GAMESS
  real(rk) :: core(*) ! GAMESS memory, not used in DL-FIND
#endif
  integer  :: iimage,ivar,status,image_status,taskfarm_mode
  integer  :: icount, kiter
  real(rk) :: svar
  logical  :: tconv,trestarted,trerun_energy
  logical  :: needhessian ! do we need a Hessian?
  logical  :: testconv ! is convergence checked in coords_xtoi ?
  logical  :: trestarted_report,noeandg,fd_hess_running
  logical  :: tswitch
! **********************************************************************
  
  ! classical rate (i.e. rate w/o tunneling) should be calculated
  if(glob%iopt == 13) then
    call dlf_htst_rate()
    return ! nothing else to do
  end if

  iimage=1
  glob%toldenergy_conv=.false.

  ! if thermal analysis (hessian only) is called, make sure that mass-weighted
  ! cartesians are used!
  if(glob%iopt==11) then
    glob%massweight=.true.
    glob%icoord=0
    glob%distort=0.D0
  end if

  ! if qTST thermal analysis (hessian only) is called, make sure that mass-weighted
  ! cartesians are used!
  if(glob%iopt==12) then
    glob%massweight=.true.
    glob%icoord=190
    glob%distort=0.D0
  end if

  ! initialise coordinate transform, allocate memory for it
  call dlf_coords_init
  
  ! initialise search algorithm
  call dlf_formstep_init(needhessian)

  ! initialise line search
  call linesearch_init

  ! prepare for main optimisation cycle

  glob%taccepted=.true.
  tconv=.false.
  trerun_energy=.false.
  glob%dotask=.true.
  status=0

  ! define, if Energy and gradient calculations are to be performed
  noeandg=.false.
  if(glob%inithessian==5) noeandg=.true.
  if(glob%iopt==13) noeandg=.true.

  ! read checkpoint file 
  if(glob%restart==1) then
    call clock_start("CHECKPOINT")
    call dlf_checkpoint_read(status,trestarted)
    call clock_stop("CHECKPOINT")
    if(.not.trestarted) call dlf_fail("Restart attempt failed")
    trestarted_report=.true.
    ! Parallel NEB - assume that image restart info for external
    ! program is also available
    glob%serial_cycle = 0 
  else
    trestarted=.false.
    trestarted_report=.false.
    ! Parallel NEB - each workgroup should calculate all images
    ! on the first cycle, so that each image calc restarts from the
    ! result of the last (as would normally happen in serial)
    ! For some external programs it may not be important to do this, 
    ! so this could be made user-defined.
    glob%serial_cycle = 1
    if (glob%icoord==190) glob%serial_cycle = 0
  end if

  ! report at the start
  call dlf_report(trestarted_report)
  

  ! open trajectory file
  if(glob%tatoms.or.glob%nimage.gt.1) then
    call clock_start("XYZ")
    if(printf>=3) then
      if(stat%sene>0) THEN
        if (glob%iam == 0) then
          open(unit=330,file="path.xyz",position="APPEND")
          open(unit=331,file="path_active.xyz",position="APPEND")
          ! Only open for TS search methods
          if (glob%iopt == 10 .or. (glob%icoord >= 100 .and. glob%icoord < 300)) then
             open(unit=332,file="path_tsmode.xyz",position="APPEND")
          end if
          ! Only for microiterative optimisations
          if (glob%imicroiter > 0) then
             open(unit=333,file="path_micro.xyz",position="APPEND")
          end if
        end if
      ELSE
        if (glob%iam == 0) then
          open(unit=330,file="path.xyz")
          open(unit=331,file="path_active.xyz")
          ! Only open for TS search methods
          if (glob%iopt == 10 .or. (glob%icoord >= 100 .and. glob%icoord < 300)) then
             open(unit=332,file="path_tsmode.xyz")
          end if
          ! Only for microiterative optimisations
          if (glob%imicroiter > 0) then
             open(unit=333,file="path_micro.xyz")
          end if
        end if
      end if
    end if
    if(printf>=4.and.glob%iam == 0) then
      if(stat%sene>0) THEN
        open(unit=300,file="path_force.xyz",position="APPEND")
        !open(unit=301,file="paths.xyz",position="APPEND")
      ELSE
        open(unit=300,file="path_force.xyz")
        !open(unit=301,file="paths.xyz")
      end if
    end if
    call clock_stop("XYZ")
  else
    if (glob%iam == 0) then
       open(unit=330,file="path.inc")
       !open(unit=330,file="path.inc",position="append")
    end if
  end if

  ! ====================================================================
  ! MAIN OPTIMISATION CYCLE
  ! ====================================================================
  do ! exit conditions implemented via exit statements

    if (glob%iopt/10 == 5) then ! parallel optimisation
       call dlf_parallel_opt(trestarted_report, tconv &
#ifdef GAMESS
       ,core&
#endif
       )
       exit ! the MAIN OPTIMISATION CYCLE
    end if

    if(trestarted) then
       ! Task-farming: (at present) only workgroup 0 saves a checkpoint 
       ! file, and only partial checkpoint information is known to wg0
       ! until the end of the energy loop. Therefore
       ! restarts can only happen after the whole array is calculated.
       ! (see Q in dlf_checkpoint_write)
       if (glob%ntasks > 1) goto 1010
       ! Serial runs can potentially restart after 
       ! any energy evaluation
       goto 1000
       ! NB: serial and parallel checkpoint files are not compatible
    end if

    if(.not.trerun_energy) then
       if (glob%imicroiter < 2) then
          stat%ccycle = stat%ccycle+1
       else 
          stat%miccycle = stat%miccycle + 1
          stat%tmiccycle = stat%tmiccycle + 1
       end if
    end if
    stat%sene=stat%sene+1
    if(stat%ccycle > glob%maxcycle) then
      stat%ccycle= stat%ccycle-1
      stat%sene=stat%sene-1
      if(printl>0) write(stdout,"(&
          &'Stopping: maximum number of cycles reached')")
      exit
    end if

    ! ==================================================================
    ! EVALUATE THE ENERGY
    ! ==================================================================

    ! get out of main cycle if energy evaluated more often than glob%maxene
    if(stat%sene > glob%maxene) then
      stat%ccycle= stat%ccycle-1
      stat%sene=stat%sene-1
      if(printl>=2) write(stdout,"(&
          &'Stopping: maximum number of energy evaluations reached')")
      exit
    end if

    ! Parallel NEB: determine whether this workgroup should calculate a gradient
    !if (glob%icoord/100 == 1 .and. glob%ntasks > 1 .and. glob%iopt/=12 ) then
    call dlf_qts_get_int("TASKFARM_MODE",taskfarm_mode)
    call dlf_formstep_get_logical("FD_HESS_RUNNING",fd_hess_running)
    if (glob%icoord/100 == 1 .and. glob%ntasks > 1 .and. &
        (.not.fd_hess_running .or. taskfarm_mode==2)) then
       !taskfarm_mode: 1 for parallelization of QTS-FD-Hessians within each image
       !taskfarm_mode: 2 for parallelization of the images in QTS-Hessian calculations
       ! Parallel NEB
      call dlf_qts_get_int("IMAGE_STATUS",image_status)
      if(glob%icoord==190.and.taskfarm_mode==2) iimage=image_status
       glob%dotask = (mod(iimage-1,glob%ntasks) == glob%mytask)
       !  Serial first cycle
       if (glob%serial_cycle == 1) glob%dotask = .true.
    end if
    ! Note for parallel FD Hessian, dotask is set in dlf_fdhessian
    ! Other methods: always calculate gradient

    if (glob%dotask) then

       if(printl>=6) write(stdout,"('Calculating the energy',i5)") stat%sene
       stat%pene = stat%pene + 1
       call clock_start("EANDG")

       if (glob%imultistate == 0) then
         ! An ordinary single state gradient

         ! don't do any optimizations or energy evaluations in case only
         ! the rate has to be calculated from an existing qts hessian
         if(.not.noeandg) then

            ! ESP fit setting
            kiter = -1
            if (glob%micro_esp_fit) then
               ! TODO - at certain times kiter should still be -1, e.g.
               ! during initial Hessian calc in P-RFO
               if (glob%imicroiter == 1) kiter = 0
               if (glob%imicroiter == 2) kiter = 1
            end if

            call dlf_get_gradient(glob%nvar,glob%xcoords,glob%energy, &
                 glob%xgradient,iimage,kiter,&
#ifdef GAMESS
                 core,&
#endif
                 status)

            ! ESP fit corrections
            if (glob%micro_esp_fit .and. status == 0) then
               if (glob%imicroiter == 1) then
                  ! Macro step - calculate corrections to energy/gradient
                  ! Get ESP eandg
                  glob%macrocoords(:,:,iimage) = glob%xcoords
                  kiter = 1
                  call dlf_get_gradient(glob%nvar,glob%xcoords,glob%e0corr(iimage), &
                       glob%g0corr(:,:,iimage),iimage,kiter,&
#ifdef GAMESS
                       core,&
#endif
                       status)
                  ! e0corr = E0(full) - E0(esp fit)
                  glob%e0corr(iimage) = glob%energy - glob%e0corr(iimage)
                  ! g0corr = G0(full) - G0(esp fit)
                  ! Eq 5 in HDLCOpt paper
                  ! External program should ensure that g0corr for inner regions = 0
                  glob%g0corr(:,:,iimage) = glob%xgradient - glob%g0corr(:,:,iimage)
               else if (glob%imicroiter == 2) then
                  ! Micro step - apply corrections
                  ! Eq 6 in HDLCOpt paper
                  svar = glob%e0corr(iimage) + &
                       sum( glob%g0corr(:,:,iimage) &
                       * (glob%xcoords - glob%macrocoords(:,:,iimage)) )
                  glob%energy = glob%energy + svar
                  if (printl >= 4) write(stdout,'(a, 22x, f20.6)') &
                       "Microiterative energy correction: ", svar
                  ! Eq 4 in HDLCOpt paper
                  glob%xgradient = glob%xgradient + glob%g0corr(:,:,iimage)
               else
                  call dlf_fail("ESP fit only appropriate for microiterative opts")
               end if
            end if

         end if
       else
          ! Multiple state gradient calculation
          if (printl >= 6) write(stdout, '(a)') "Calculating multistate energies"
          call dlf_get_multistate_gradients(glob%nvar,glob%xcoords,glob%msenergy, &
               glob%msgradient,glob%mscoupling,glob%needcoupling,iimage,status)
          ! Make sure coupling is zero if it is required by algorithm but 
          ! coupled_states was false
          if (glob%needcoupling == 0) glob%mscoupling = 0.0d0
          ! Form the objective function and gradient from the individual
          ! state gradients
          if (printl >= 4) then
             write(stdout, '(a, f20.10)') "Lower state energy: ", glob%msenergy(1)
             write(stdout, '(a, f20.10)') "Upper state energy: ", glob%msenergy(2)
             write(stdout, '(a, f20.10)') "Energy difference:  ", &
                  abs(glob%msenergy(1) - glob%msenergy(2))
          endif
          if (printl >= 6) write(stdout, '(a)') "Forming objective function"
          call dlf_make_conint_gradient
       endif

       call clock_stop("EANDG")

       ! check of NaN in the energy (comparison of NaN with any number 
       ! returns .false. , pgf90 does not understand isnan() )
       if( abs(glob%energy) > huge(1.D0) ) then
          status=1
       else
          if (.not. abs(glob%energy) < huge(1.D0) ) status=1
       end if

       ! Parallel runs must share status
       ! so that all workgroups are given notice of failure
       ! (status should be shared before attempting to share other data)
       if (status/=0) then
          if (glob%ntasks > 1) then
             call dlf_tasks_int_sum(status, 1)
          else
             call dlf_report(trestarted_report)
          end if
          call dlf_fail("Energy evaluation failed")
       end if
 
       if(iimage==1) then
          if(printl>=2) write(stdout,'(1x,a,es16.9)') &
               "Energy calculation finished, energy: ", &
               glob%energy
       else
          if(printl>=2) write(stdout,'(1x,a,i4,a,es16.9)') &
               "Energy calculation of image ",iimage,&
               " finished, energy: ",glob%energy
       end if
       
    else ! .not. glob%dotask
       ! Multistate calculations should not reach this point
       if (glob%imultistate /= 0) then
          call dlf_fail("Multistate logic error")
       end if
       glob%energy = 0.d0
       glob%xgradient = 0.d0
       status = 0       
    end if

    ! send coordinates to the calling program
    if(printf>=1) then
      call dlf_put_coords(glob%nvar,1,glob%energy,glob%xcoords,glob%iam)
    end if

    ! write restart information (serial runs)
    if(stat%sene<=glob%maxdump .and. glob%ntasks == 1) then
      if(glob%dump>0) then
        if(mod(stat%sene,glob%dump)==0) then
          call clock_start("CHECKPOINT")
          if(printl>=6) write(stdout,"('Writing restart information')")
          call dlf_checkpoint_write(status)
          call clock_stop("CHECKPOINT")
        end if
      end if
    end if
    ! come here if (serial) checkpoint file successfully read
1000 trestarted=.false.

    ! ==================================================================
    ! TRANSFORM CARTESIANS TO INTERNALS (COORDS AND GRAD)
    ! ==================================================================
    call clock_start("COORDS")
    call dlf_coords_xtoi(trerun_energy,testconv,iimage,status)

    ! Microiterative opt - set up mic arrays (after macro step as well)
    if (glob%imicroiter > 0) then
       call dlf_microiter_itomic
    end if

    call clock_stop("COORDS")

    ! copied here to allow for qTS Hessian calculations.
    ! ==================================================================
    if(trerun_energy) cycle ! main optimisation cycle
    ! ==================================================================

    ! ==================================================================
    ! Multistate gradient: post-transformation
    ! ==================================================================
    if (glob%imultistate == 3) then
       call clock_start("EANDG")
       call dlf_make_ln_gradient_posttrans
       call clock_stop("EANDG")
    endif

    ! ==================================================================
    ! Calculate the Hessian if necessary
    ! ==================================================================
    ! glob%ihessian is allocated and deallocated in formstep_init and
    !  formstep_destroy
    if(needhessian) then
      if(glob%iopt/=12.and.glob%iopt/=9) then
        tconv = .false.
        ! Make sure the Hessian exists. This can imply energy cycles (trerun_energy)
        ! or a call to dlf_get_hessian
        call dlf_makehessian(trerun_energy,tconv &
#ifdef GAMESS
          ,core&
#endif
            )
        if (tconv) exit
      else
!if glob%iop=12
!        call dlf_qts_makehessian(trerun_energy)
      end if
    end if

    ! ==================================================================
    if(trerun_energy) cycle ! main optimisation cycle
    ! ==================================================================

    ! Parallel NEB: revert to parallel
    glob%serial_cycle = 0

    ! Restart information for task-farmed jobs
    if(stat%ccycle <= glob%maxdump .and. glob%ntasks > 1) then
      if(glob%dump>0) then
        if(mod(stat%ccycle,glob%dump)==0) then
          call clock_start("CHECKPOINT")
          if(printl>=6) write(stdout,"('Writing restart information')")
          call dlf_checkpoint_write(status)
          call clock_stop("CHECKPOINT")
        end if
      end if
    end if    
    ! come here if task-farmed checkpoint file read
1010 trestarted=.false.

    ! exit if only the hessian and thermal analysis should be calculated
    if(glob%iopt == 11) then
      call dlf_thermal
      exit ! no optimisation cycles
    end if

    ! exit if only the instanton rate should be calculated
    if(glob%iopt == 12) then
      call dlf_qts_rate()
      exit ! no optimisation cycles
    end if

    ! exit if test_delta is running
    if(glob%iopt == 9) then
      exit ! no optimisation cycles
    end if
    

    ! write trajectory
    if(printf>=3 .and. glob%iam == 0) then
      if (glob%imicroiter < 2) then
         ! Write out standard optimisation cycles
         ! and macroiterative steps
         call write_xyz(330,glob%nat,glob%znuc,glob%xcoords)
         call write_xyz_active(331,glob%nat,glob%znuc,glob%spec,glob%xcoords)
      end if
      if (glob%imicroiter > 0) then
         ! Full microiterative opt path including microiterative steps
         call write_xyz(333,glob%nat,glob%znuc,glob%xcoords)
      endif
    end if

    ! write forcetrajectory
    if(printf>=4.and.glob%iam == 0) then
      if (glob%imicroiter < 2) then
         call write_xyz(300,glob%nat,glob%znuc,-glob%xgradient)
      end if
    end if

    ! if trust-radius, test for step acceptance. 
    ! If rejected, do not form a new step and keep old energy.
    if (glob%imicroiter == 2) then
       call dlf_microiter_test_acceptance(tswitch)
       if (tswitch) then
          ! Reached minimum trust radius, switch to macro
          glob%imicroiter = 1
          call dlf_lbfgs_deselect
          ! Cycle to perform a new full eandg calculation
          ! TODO refactor to reach normal itox below
          call dlf_coords_itox(iimage)
          cycle
       end if
    else
       if (glob%iline==1) then
          call test_acceptance
       end if
       if (glob%iline==2) then
          call test_acceptance_g
       end if
       if (glob%iline==3) then
          call linesearch
       end if
    end if

  !  if(glob%icoord==190) then
  !    ! set convergence test to cartesian coordinates and gradients
  !    call dlf_qts_convergence
  !  end if

    ! ==================================================================
    ! TEST FOR CONVERGENCE
    ! ==================================================================
    if(glob%taccepted) then
       if (glob%imicroiter < 2) then
          stat%caccepted=stat%caccepted+1
       else 
          stat%tmicaccepted = stat%tmicaccepted + 1
       end if
      tconv=.false.
      if(.not.testconv) then
         if (glob%imicroiter < 2) then
            ! Standard convergence test
            call convergence_test(stat%ccycle,.true.,tconv)
            if (tconv) exit
         else
            ! Test convergence of microiterations
            call dlf_microiter_convergence(tconv)
            if (tconv) then
               if (printl>=2) then
                  write(stdout,"('Microiterations converged')")
                  write(stdout,"('Switching to macroiterations.')")
               end if
               glob%imicroiter = 1
               call dlf_lbfgs_deselect
               ! Cycle to perform a new full eandg calculation
               ! TODO refactor to reach normal itox below
               call dlf_coords_itox(iimage)
               cycle
            end if
         end if
      end if
    end if
    
    ! Exit microiterations if maxmicrocycle reached
    if (glob%imicroiter == 2 .and. stat%miccycle == glob%maxmicrocycle) then
       if(printl>0) then
          write(stdout,"('Maximum number of microiterative cycles reached')")
          write(stdout,"('Switching to macroiterations.')")
       end if
       glob%imicroiter = 1
       call dlf_lbfgs_deselect
       ! Cycle to perform a new full eandg calculation
       ! TODO refactor to reach normal itox below
       call dlf_coords_itox(iimage)
       cycle
    end if

    ! ==================================================================
    ! FORM AN OPTIMISATION STEP
    ! ==================================================================
    if(glob%taccepted .and. glob%imicroiter < 2) then
      call clock_start("FORMSTEP")
      call dlf_formstep
      call clock_stop("FORMSTEP")
    end if

    ! ==================================================================
    ! DO A LINE SEARCH OR A TRUST RADIUS STEP
    ! ==================================================================

    if(glob%taccepted .and. glob%imicroiter < 2) then
      
      ! scale the step 
      call dlf_scalestep

      call clock_start("COORDS")

      ! check the step in special cases
      ! Set step of frozen NEB images to zero
      if(glob%icoord/100==1) call dlf_neb_checkstep

      ! Check step in case of dimer
      if(glob%icoord/100==2) call dlf_dimer_checkstep
      
      ! For macroiterations only move the inner region
      if (glob%imicroiter == 1) call dlf_microiter_check_macrostep

      call clock_stop("COORDS")

      ! do the step
      glob%icoords(:)=glob%icoords(:) + glob%step(:)

    end if

    ! write steptrajectory
  !  if(printf>=4) then
  !    ! these are icoords - it will only work for cartesians without frozen atoms
       ! therefore commented out
  !    call write_xyz(301,glob%nivar/3,glob%znuc(1:glob%nivar/3),glob%step)
  !  end if

    if(glob%taccepted .and. glob%imicroiter < 2) then
       ! store old values
       glob%oldenergy=glob%energy
       glob%toldenergy=.true.
    end if

    ! ==================================================================
    ! MICROITERATIVE STEP
    ! ==================================================================

    ! Microiterative step
    if (glob%imicroiter == 2 .and. glob%taccepted) then

       ! Form the microiterative step
       call clock_start("FORMSTEP")
       call dlf_microiter_formstep
       call clock_stop("FORMSTEP")

       ! Scale the microiterative step
       call dlf_microiter_scalestep

       ! Set microiterative step of frozen NEB images to zero
       if(glob%icoord/100==1) call dlf_neb_checkstep

       ! Do the step and store old microiterative energy
       call dlf_microiter_step

    end if

    ! Switch from macro to microiterations if necessary
    ! Do not take a micro step yet - need to get a reference energy
    ! to test acceptance of first micro step.
    if (glob%imicroiter == 1 .and. glob%taccepted) call dlf_microiter_enter

    ! ==================================================================
    ! TRANSFORM INTERNAL COORDINATES TO CARTESIANS (COORDS ONLY)
    ! ==================================================================

    call clock_start("COORDS")
    call dlf_coords_itox(iimage)
    call clock_stop("COORDS")

  end do ! main simulation cycle

  ! Job finished, prepare for shutdown
  if (glob%iopt /= 11 .and. glob%iopt /= 12 .and. glob%iopt /= 9 ) then
    if(tconv) then
      if (printl > 0) then
         write(stdout,'(/,1x,a)') "Optimisation converged"
         write(stdout,'(1x,a)')   "----------------------"
         if (glob%imultistate == 0) then
            call convergence_get("VALE", svar)
            write(stdout,'(1x,a,f20.12,/)') "Final converged energy: ", svar
         else
            write(stdout,'(1x,a,f20.12)') &
                 "Final lower state energy: ", glob%msenergy(1)
            write(stdout,'(1x,a,f20.12)') &
                 "Final upper state energy: ", glob%msenergy(2)
            write(stdout,'(1x,a,f20.12,/)') "Final energy difference:  ", &
                 abs(glob%msenergy(1) - glob%msenergy(2))
         end if
      end if
    else
      if (printl > 0) then
         write(stdout,'(/,1x,a)') "WARNING: OPTIMISATION HAS NOT CONVERGED"
         write(stdout,'(1x,a,/)') "---------------------------------------"
      end if
    end if
  end if

  ! calculate the qts rate if converged
  if(glob%icoord==190.and.tconv.and.glob%iopt/=12.and.glob%havehessian) then
    if(printl>=2) then
      write(stdout,'(a)') "Calculating the Rate. WARNING: the rate information below was obtained"
      write(stdout,'(a)') " from updated Hessians. It is less accurate than a full rate calculation"
    end if
    call dlf_qts_rate()
  end if

  ! close trajectory files
  if(printf>=3 .and. glob%iam == 0) then
    close(330)
    close(331)
    if (glob%iopt == 10 .or. (glob%icoord >= 100 .and. glob%icoord < 300)) then
       close(332)
    end if
    if (glob%imicroiter > 0) close(333)
  end if
  ! close force trajectory files
  if(printf>=4.and.glob%iam == 0) then
    close(300)
    !close(301)
  end if
  ! again some rubbish for printing ...
  if(glob%icoord/100==1.and..not.glob%tatoms) then
    if (glob%iam == 0) then
       open(unit=330,file="path.inc")
       do ivar=1,glob%nimage
         write(330,"('sphere{<',f12.4,',',f12.4,',',f12.4,'> 0.04}')") &
             glob%icoords(ivar*2-1),1.D0,glob%icoords(ivar*2)
         if(ivar>1) then
           write(330,"('cylinder{<',f12.4,',',f12.4,',',f12.4,'>,"//&
               &"<',f12.4,',',f12.4,',',f12.4,'> 0.01} ')") &
               glob%icoords(ivar*2-1),1.D0,glob%icoords(ivar*2), &
               glob%icoords((ivar-1)*2-1),1.D0,glob%icoords((ivar-1)*2)
         end if
       end do

       close(330)
    end if
  end if

  ! ====================================================================
  ! CLOSE DOWN
  ! ====================================================================

  ! delete memory for line search 
  call linesearch_destroy

  ! delete memory for search algorithm
  call dlf_formstep_destroy

  ! delete memory for internal coordinates
  call dlf_coords_destroy

  !write report on this optimisation
  call dlf_report(trestarted_report)

end subroutine dlf_run
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* main/dlf_allocate_glob
!!
!! FUNCTION
!!
!! Allocate the arrays globally available to the optimiser,
!! set a few starting values.
!!
!! SYNOPSIS
subroutine dlf_allocate_glob(nvarin,nvarin2,nvarspec, &
    tmpcoords,tmpcoords2,spec,nz,nframe,nmass,nweight,n_po_scaling)
!! SOURCE
  use dlf_parameter_module, only: rk,ik
  use dlf_global, only: glob,stdout,printl
  use dlf_allocate, only: allocate
  use dlf_constants, only: dlf_constants_get
  implicit none
  integer, intent(in) :: nvarin
  integer, intent(in) :: nvarin2
  integer, intent(in) :: nvarspec
  real(rk),intent(in) :: tmpcoords(nvarin)
  real(rk),intent(in) :: tmpcoords2(nvarin2)
  integer, intent(in) :: spec(nvarspec)
  integer, intent(in) :: nz
  integer, intent(in) :: nframe
  integer, intent(in) :: nmass
  integer, intent(in) :: nweight
  integer, intent(in) :: n_po_scaling
  integer :: nat,ivar
  real(rk):: svar
! **********************************************************************
  if(glob%tinit) return ! this instance has been initialised
  glob%tcoords2=(nframe>0)
  if(glob%tatoms) then
    ! input contains atoms
    if(mod(nvarin,3)/=0) call dlf_fail("nvarin has to be 3*nat")
    nat=nvarin/3
    glob%nvar=nvarin
    if(printl>4) write(stdout,'(a,i5,a)') &
      "Input contains ",nat," atoms"
    glob%nat=nat

    call allocate( glob%xcoords,3,nat)

    if(glob%tcoords2) then
      call allocate( glob%xcoords2,3,nat,nframe)
      glob%xcoords2 = reshape(tmpcoords2(1:nat*3*nframe),(/3,nat,nframe/))
    end if

    call allocate( glob%xgradient,3,nat)
    call allocate( glob%spec,nat)
    !nuclear charges
    call allocate( glob%znuc,nat)
    if(nz==nat) then
      glob%znuc(:)=spec(nat+1:nat+nz)
    else
      glob%znuc(:)=1
    end if
    
    glob%xcoords = reshape(tmpcoords,(/3,nat/))
    glob%spec(:) = spec(1:nat)

    if(glob%ncons>0) then
      call allocate( glob%icons,5,glob%ncons)
      ivar=nat+nz
      glob%icons=reshape(spec(ivar+1:ivar+5*glob%ncons),(/5,glob%ncons/))
    else
      call allocate( glob%icons,5,1)
      glob%icons(:,:)=0
    end if

    ! user input connections - additional to the hdlc-primitive created
    if(glob%nconn>0) then
      call allocate( glob%iconn,2,glob%nconn)
      ivar=nat+nz+glob%ncons
      glob%iconn=reshape(spec(ivar+1:ivar+2*glob%nconn),(/2,glob%nconn/))
    else
      call allocate( glob%iconn,2,1)
      glob%iconn(:,:)=0
    end if

    ! microiterative specification
    call allocate(glob%micspec, nat)
    if (glob%imicroiter > 0) then
       ivar = nat + nz + 5*glob%ncons + 2*glob%nconn
       glob%micspec(:) = spec(ivar+1:ivar+nat)
       do ivar = 1, nat
          if (glob%micspec(ivar) < 0 .or. glob%micspec(ivar) > 1) then
             write(stdout,'(a,2i5)') 'Atom, Micspec: ', ivar, glob%micspec(ivar)
             call dlf_fail("Incorrect microiterative specification")
          end if
       end do
    else
       ! override inner atoms list for non-microiterative opt
       ! (logically, all atoms are in the core)
       glob%micspec(:) = 1
    end if
    ! ESP fit
    call allocate(glob%macrocoords,3,nat,glob%nimage)
    call allocate(glob%g0corr,3,nat,glob%nimage)
    call allocate(glob%e0corr,glob%nimage)
    glob%macrocoords = 0.0d0
    glob%g0corr = 0.0d0
    glob%e0corr = 0.0d0

    call allocate( glob%weight,nat)
    if(nweight>0) then
      glob%weight=tmpcoords2(nat*3*nframe+1:nat*3*nframe+nat)
    else
      glob%weight(:)=1.D0
    end if
    ! Set weight to zero for outer microiterative region 
    ! so it takes no part in dimer rotation, NEB spring force etc.
    do ivar = 1, nat
       if (glob%micspec(ivar) == 0) glob%weight(ivar) = 0.0d0
    end do

    call allocate( glob%mass,nat)
    if(nmass>0) then
      glob%mass=tmpcoords2(nat*3*nframe+nweight+1:nat*3*nframe+nweight+nat)
      ! use atomic mass unit (mass of the electron) only in case of quantum TS search
      if((glob%icoord==190.or.glob%icoord==390).and.&
          glob%iopt/=11.and.glob%iopt/=13) then
        glob%massweight=.true.
        
        call dlf_constants_get("AMU",svar)
        glob%mass=glob%mass*svar !*(1.66054D-27/9.10939D-31)
        
      end if
    else
      glob%mass(:)=1.D0
    end if

    if (glob%iopt/10==5) then ! parallel optimizers
       call allocate(glob%po_radius_scaling,max(1,n_po_scaling))
       if (n_po_scaling == 0) then 
          ! this is a shorthand for setting all elements of the glob%po_radius(:) and 
          ! glob%po_tolerance_r(:) arrays to their respective base values.
          glob%po_radius_scaling(:) = 1.0D0 ! there should only be one component anyway
       else
          ! n_po_scaling < 0 will be caught in dlf_read_in
          glob%po_radius_scaling(:) = tmpcoords2(nat*3*nframe + nweight + nmass + 1 : &
                                      nat*3*nframe + nweight + nmass + n_po_scaling)
       end if 
    end if

    ! multistate arrays for conical intersection search
    if (glob%imultistate > 0) then
       call allocate(glob%msenergy, 2)
       call allocate(glob%msgradient, 3, nat, 2)
       if (glob%imultistate > 1) then
          ! Set up coupling array for GP/LN regardless of whether
          ! it needs to be calculated. Will be set to zero if
          ! needcoupling is false.
          call allocate(glob%mscoupling, 3, nat)
       else
          ! dummy array just to avoid problems in argument list
          ! of dlf_get_multistate_gradients - I assume you can't
          ! send unallocated arrays to a C subroutine
          call allocate(glob%mscoupling, 1, 1)
       endif
    endif

  else
    ! input contains sequential variables (as the 2D-potentials)
    glob%nat=-1
    glob%nvar=nvarin
    if(printl>4) write(stdout,'(a,i5,a)') &
      "Input contains ",nvarin," degrees of freedom (no atoms)"
    call allocate( glob%xcoords,1,nvarin)
    if(glob%tcoords2) then
      call allocate( glob%xcoords2,1,nvarin,nframe)
      glob%xcoords2 = reshape(tmpcoords2,(/1,nvarin,nframe/))
    end if
    call allocate( glob%xgradient,1,nvarin)
    ! NOT TO BE USED
    call allocate( glob%spec,1)
    ! 02/03/2020
    glob%spec = 0
    call allocate( glob%icons,5,1)
    glob%icons(:,:)=0
    call allocate( glob%znuc,1)
    call allocate( glob%iconn,2,1)
    glob%iconn(:,:)=0
    call allocate( glob%weight,1)
    call allocate( glob%mass,1)

    glob%xcoords = reshape(tmpcoords,(/1,nvarin/))

  end if
  glob%toldenergy=.false.
  glob%tinit=.true.
end subroutine dlf_allocate_glob
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* main/dlf_deallocate_glob
!!
!! FUNCTION
!!
!! Deallocate global arrays
!!
!! SYNOPSIS
subroutine dlf_deallocate_glob
!! SOURCE
  use dlf_parameter_module, only: rk,ik
  use dlf_global, only: glob
  use dlf_allocate, only: deallocate
  implicit none
! **********************************************************************
  if(.not.glob%tinit) return ! this instance has not been initialised
  call deallocate( glob%xcoords )
  if(glob%tcoords2) then
    call deallocate( glob%xcoords2 )
  end if
  call deallocate( glob%xgradient )

  ! arrays only used for atoms
  call deallocate( glob%spec  )
  call deallocate( glob%icons )
  call deallocate( glob%znuc  )
  call deallocate( glob%iconn )
  ! YL 02/03/2020
  if(allocated(glob%micspec)) then
      call deallocate(glob%micspec)
  endif

  call deallocate( glob%mass )
  call deallocate( glob%weight )

  glob%tinit=.false.

  ! conical intersection search
    if (glob%imultistate > 0) then
       call deallocate(glob%msenergy)
       call deallocate(glob%msgradient)
       call deallocate(glob%mscoupling)
    endif

  ! parallel optimisation algorithms
  if (glob%iopt/10==5) call deallocate(glob%po_radius_scaling)

  ! YL 02/03/2020
  if(allocated(glob%macrocoords)) then
      call deallocate(glob%macrocoords)
  endif
  if(allocated(glob%g0corr)) then
      call deallocate(glob%g0corr)
  endif
  if(allocated(glob%e0corr)) then
      call deallocate(glob%e0corr)
  endif

end subroutine dlf_deallocate_glob
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* main/dlf_fail
!!
!! FUNCTION
!!
!! Shut down DL-FIND after a severe error. Calls dlf_error, which has
!! to be provided by the calling code.
!!
!! SYNOPSIS
subroutine dlf_fail(msg)
!! SOURCE
  use dlf_global, only: glob, stdout, stderr
  use dlf_store, only: store_delete_all
  implicit none
  character(*),intent(in) :: msg
  call flush(stdout)
  call flush(stderr)
  write(stderr,"(/,a,/,a,/)") "DL-FIND ERROR:",msg
  write(stdout,"(/,a,/,a,/)") "DL-FIND ERROR:",msg
  call flush(stdout)
  call flush(stderr)
  ! Clean up allocatable arrays.
  ! Otherwise they will stay allocated and DL-FIND
  ! cannot be called again by the external code.
  ! glob%cleanup prevents an infinite loop if one of the 
  ! destroy functions calls dlf_fail...
  glob%cleanup = glob%cleanup + 1
  if (glob%cleanup <= 1) then
     call linesearch_destroy
     call dlf_formstep_destroy
     call dlf_coords_destroy
     call dlf_deallocate_glob
     call dlf_formstep_set_tsmode(1,-2,1.0d0)
     call store_delete_all
  else
     call flush(stdout)
     call flush(stderr)
       write(stderr,"(/,a,/)") "dlf_fail: clean up failed"
       write(stdout,"(/,a,/)") "dlf_fail: clean up failed"
     call flush(stdout)
     call flush(stderr)
  end if
  ! Exit
  call dlf_error()
  ! this should not be reached, as dlf_error should not return
  stop
end subroutine dlf_fail
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* main/dlf_report
!!
!! FUNCTION
!!
!! Report information about the run to stdout. Called at the beginning 
!! and at the end of a calculations.
!!
!! SYNOPSIS
subroutine dlf_report(trestarted)
!! SOURCE
  use dlf_global, only: glob,stdout,printl
  use dlf_stat, only: stat
  implicit none
  logical ,intent(in) :: trestarted
  integer             :: ia3(3)
  integer             :: kk

! **********************************************************************


  ! Can't return as dlf_mpi_counters requires communication
  ! if(printl<=0) return
  if (printl <= 0) goto 111 ! to skip the report printing up to the 
                            ! call to dlf_mpi_counters

  write(stdout,'(/,a)') "DL-FIND Report:"
  write(stdout,'(a)')   "==============="

  ! ====================================================================
  ! Multistate calculations
  ! ====================================================================
  if (glob%imultistate == 1) then
     write(stdout,'(a)') &
          "Conical intersection algorithm: penalty function"
     write(stdout,1000) "Penalty function constant c1", &
          glob%pf_c1
     write(stdout,1000) "Penalty function constant c2", &
          glob%pf_c2
  end if
  if (glob%imultistate == 2) then
     write(stdout,'(a)') &
       "Conical intersection algorithm: gradient projection"
     write(stdout,1000) "Gradient projection constant c3", &
          glob%gp_c3
     write(stdout,1000) "Gradient projection constant c4", &
          glob%gp_c4
  end if
  if (glob%imultistate == 3) then
     write(stdout,'(a)') &
       "Conical intersection algorithm: Lagrange-Newton"
     write(stdout,1000) "Lagrange-Newton threshold t1", &
          glob%ln_t1
     write(stdout,1000) "Lagrange-Newton threshold t2", &
          glob%ln_t2
  end if
  if (glob%imultistate > 0) then
     write(stdout,2000) "Lower electronic state", &
          glob%state_i
     write(stdout,2000) "Upper electronic state", &
          glob%state_j
  end if

  ! ====================================================================
  ! Optimiser
  ! ====================================================================
  if(glob%iopt==0) write(stdout,'(a)') &
      "Optimisation algorithm: Steepest descent"
  if(glob%iopt==1) write(stdout,'(a)') &
      "Optimisation algorithm: Conjugate gradient"
  if(glob%iopt==2) write(stdout,'(a)') &
      "Optimisation algorithm: Conjugate gradient"
  if(glob%iopt==3) then
    write(stdout,'(a)') "Optimisation algorithm: L-BFGS"
    write(stdout,2000) "Number of steps in L-BFGS memory", &
         glob%lbfgs_mem
  end if
  if(glob%iopt==9) then 
    write(stdout,'(a)') &
      "Optimisation algorithm: no optimization. Test different deltas"
    write(stdout,'(a)') "    for the finite-difference calculation of Hessians."
  end if
  if (glob%iopt==51) write(stdout,'(a)') &
      "Optimisation algorithm: Stochastic search"
  if (glob%iopt==52) write(stdout,'(a)') &
      "Optimisation algorithm: Genetic algorithm"

  if(glob%iopt==10) write(stdout,'(a)') &
      "Optimisation algorithm: P-RFO"
  if(glob%iopt==11) then 
    write(stdout,'(a)') &
        "Optimisation algorithm: no optimisation, just calculate the"
    write(stdout,'(a)') "    Hessian and thermal corrections"
    if (glob%inithessian == 5) write(stdout,'(a)') &
        "Initial Hessian read from file"
    write(stdout,2000) "Modes assumed to have zero vibrational frequency",glob%nzero
    write(stdout,1000) "Temperature",glob%temperature,"K"
  end if
  if(glob%iopt==12) then 
    write(stdout,'(a)') &
        "Optimisation algorithm: no optimisation, just calculate the"
    write(stdout,'(a)') "    instanton reaction rate"
    write(stdout,2000) "Number of modes assumed to have zero vibrational frequency",glob%nzero
    if (glob%inithessian == 5) write(stdout,'(a)') &
        "Initial Hessian read from file"
  end if
  if(glob%iopt==13) then 
    write(stdout,'(a)') &
        "Calculation of the reaction rate (no tunnelling)"
  end if
  if(glob%iopt==20) write(stdout,'(a)') &
      "Optimisation algorithm: Newton-Raphson"
  if(glob%iopt==30) write(stdout,'(a)') &
      "Optimisation algorithm: Damped dynamics"
  if(glob%iopt==40) write(stdout,'(a)') &
      "Optimisation algorithm: Lagrange-Newton"

  ! Hessian options
  if(glob%iopt==10.or.glob%iopt==20.or.glob%iopt==40) then
    if (glob%inithessian == 0) write(stdout,'(a)') &
         "Initial Hessian from external program"
    if (glob%inithessian == 1) write(stdout,'(a)') &
         "Initial Hessian by one-point finite difference"
    if (glob%inithessian == 2) write(stdout,'(a)') &
         "Initial Hessian by two-point finite difference"
    if (glob%inithessian == 3) write(stdout,'(a)') &
         "Initial Hessian by diagonal one-point finite difference"
    if (glob%inithessian == 4) write(stdout,'(a)') &
         "Initial Hessian is identity matrix"
     if (glob%inithessian == 5) write(stdout,'(a)') &
         "Initial Hessian read from file"
    if(glob%update==0) write(stdout,'(a)') &
      "No Hessian updates"
    if(glob%update==1) write(stdout,'(a)') &
      "Hessian update mechanism: Powell"
    if(glob%update==2) write(stdout,'(a)') &
      "Hessian update mechanism: Bofill"
    if(glob%update==3) write(stdout,'(a)') &
      "Hessian update mechanism: BFGS"
    if(glob%icoord/=190) &
        write(stdout,2000) "Maximum Number of Hessian updates before recalc.", &
        glob%maxupd
    write(stdout,1000) "Finite difference for Hessian calculation", &
         glob%delta
    if(glob%soft>0.D0) then
      write(stdout,1000) "Eigenmodes below this value are considered soft", &
          glob%soft
    else
      write(stdout,'(a)') "No eigenmodes are considered soft"
    end if
    write(stdout, 1000) "Minimum step size for Hessian update", &
         glob%minstep
     
  end if
  if(glob%iopt==11 .or. glob%iopt==12) then
    write(stdout,1000) "Finite difference for Hessian calculation", &
         glob%delta
  end if

  ! Damped dynamics options
  if(glob%iopt==30) then
    write(stdout,1000) "Time step (a.u.)", &
          glob%timestep
    write(stdout,1000) "Start friction", &
          glob%fric0
    write(stdout,1000) "Friction decreasing factor if energy decreases", &
          glob%fricfac
    write(stdout,1000) "Friction to apply if energy increases", &
          glob%fricp
  end if

  ! Parallel optimisation options
  if(glob%iopt/10==5) then
    write(stdout,2000) "Working population size", &
          glob%po_pop_size
    write(stdout,1000) "Base sample radius", &
          glob%po_radius_base
    write(stdout,1000) "Tolerance on max component of mod g", &
          glob%po_tolerance_g
    write(stdout,2000) "Maximum number of cycles", &
          glob%po_maxcycle
    do kk = 1, SIZE(glob%po_radius_scaling,1)
       write(stdout,1000) "Scaling factor for radius component", &
       glob%po_radius_scaling(kk)
    end do
    if (glob%iopt==51) then
       write(stdout,'(a)') "Stochastic-search-specific options:"
       write(stdout,1000) "Radius contraction factor", &
          glob%po_contraction
       write(stdout,1000) "Base tolerance on radius", &
          glob%po_tol_r_base
       if (glob%po_distribution == 1) write(stdout,'(a)') &
          "Search strategy: uniform"
       if (glob%po_distribution == 2) write(stdout,'(a)') &
          "Search strategy: force_direction_bias"
       if (glob%po_distribution == 3) then 
          write(stdout,'(a)') "Search strategy: force_bias"
          write(stdout,1000) "Scaling factor for absolute gradient vector", &
             glob%po_scalefac
       end if
    else if (glob%iopt==52) then
       write(stdout,'(a)') "Genetic-algorithm-specific options:"
       write(stdout,2000) "Initial population size", &
          glob%po_init_pop_size
       write(stdout,2000) "Number of cycles before resetting population", &
          glob%po_reset
       write(stdout,1000) "Mutation rate", &
          glob%po_mutation_rate
       write(stdout,1000) "Death rate", &
          glob%po_death_rate
       write(stdout,2000) "Number of low-energy minima to store", &
          glob%po_nsave
    end if
  end if

  write(stdout,*)

  ! ====================================================================
  ! Line search / trust radius
  ! ====================================================================
  if (glob%iopt/10 /= 5) then ! we're not running a parallel optimisation 
     if(glob%iline==0) write(stdout,'(a)') &
         "Step length: simple scaled"
     if(glob%iline==1) write(stdout,'(a)') &
         "Trust radius based on energy"
     if(glob%iline==2) write(stdout,'(a)') &
         "Trust radius based on the gradient"
     if(glob%iline==3) write(stdout,'(a)') &
         "Line search"
     write(stdout,1000) "Maximum step length", glob%maxstep
     if(glob%iline==0 .or. glob%iopt == 0) write(stdout,1000) &
          "Scaling step by", glob%scalestep

     write(stdout,*)
  end if 

  ! ====================================================================
  ! Coordinate system
  ! ====================================================================

  ! direct coordinate system
  if(mod(glob%icoord,10)==0) then
    if(glob%massweight) then
      write(stdout,'(a)') "Coordinate system: Mass-weighted Cartesian coordinates"
    else
      write(stdout,'(a)') "Coordinate system: Cartesian coordinates"
    end if
  end if
  if(mod(glob%icoord,10)==1) write(stdout,'(a)') &
      "Coordinate system: Hybrid delocalised internal coordinates (HDLC)"
  if(mod(glob%icoord,10)==2) write(stdout,'(a)') &
      "Coordinate system: Hybrid delocalised total connection scheme (HDLC-TC)"
  if(mod(glob%icoord,10)==3) write(stdout,'(a)') &
      "Coordinate system: Delocalised internal coordinates (DLC)"
  if(mod(glob%icoord,10)==4) write(stdout,'(a)') &
      "Coordinate system: Delocalised total connection scheme (DLC-TC)"

  ! multi-image approaches
  if(glob%icoord/10==10) write(stdout,'(a)') &
        "Nudged elastic band with minimised start and endpoint"
  if(glob%icoord/10==11) write(stdout,'(a)') &
        "Nudged elastic band with start and endpoint minimised perpendicular to path"
  if(glob%icoord/10==12) write(stdout,'(a)') &
        "Nudged elastic band with frozen start and endpoint"
  if(glob%icoord>=100.and.glob%icoord<190) then
    write(stdout,2000) "Number of images",glob%nimage
    write(stdout,1000) "NEB spring constant",glob%nebk
    ! == 0.D0 for reals is dangerous. Maybe replace by <= 0.D0 or something?
    if (glob%neb_climb_test == 0.0d0) then
      write(stdout,'(a)') "No climbing image"
    else 
      write(stdout,1000) "Tolerance factor to spawn climbing image",glob%neb_climb_test
    endif
    if (glob%neb_freeze_test == 0.0d0) then
      write(stdout,'(a)') "No freezing of images during optimisation"
    else
      write(stdout,1000) "Tolerance factor to freeze images", glob%neb_freeze_test
    endif
  end if
  ! qTS search
  if(glob%icoord==190) then
    write(stdout,'(a)') &
        "Instanton (Quantum transition state) search"
    write(stdout,2000) "Number of images",glob%nimage
    write(stdout,1000) "Temperature",glob%temperature,"K"
    write(stdout,1000) "Fraction of adapted tau",glob%nebk
    if(glob%iopt==3) then
      if(glob%tolrot>90.D0) then
        write(stdout,'(a)') &
            "Mode following, mode estimated from tangent of the path"
      else
        write(stdout,'(a)') &
            "Dimer method, rotation by line search without extrapolation"
        write(stdout,1000) "Dimer distance (mid- to endpoint)",glob%delta
        ! glob%maxrot is not used in QTS dimer at the moment
        !write(stdout,2000) "Maximum number of dimer rotations",glob%maxrot
        write(stdout,1000) "Tolerance in rotation",glob%tolrot,"degrees"
      end if
    end if
    if(glob%tcoords2.and.abs(glob%distort)>0.D0) then
      write(stdout,'(a)') "Start configuration: distributing images along coords2"
      write(stdout,1000) "Spread along coords2: ",glob%distort
    end if
    write(stdout,2000) "Number of modes assumed to have zero vibrational frequency",glob%nzero

  end if

  ! Dimer method
  if(glob%icoord/100==2) then
    if(glob%icoord/10==20) write(stdout,'(a)') &
        "Dimer method, rotation by optimiser"
    if(glob%icoord/10==21) write(stdout,'(a)') &
        "Dimer method, rotation by line search without extrapolation"
    if(glob%icoord/10==22) write(stdout,'(a)') &
        "Dimer method, rotation by line search with extrapolation"
    write(stdout,1000) "Dimer distance (mid- to endpoint)",glob%delta
    write(stdout,2000) "Maximum number of dimer rotations",glob%maxrot
    write(stdout,1000) "Tolerance in rotation",glob%tolrot,"degrees"
    if(.not.glob%tcoords2) write(stdout,'(a)') &
        "Initial dimer direction randomised"

  end if

  ! Chain Method
  if(glob%icoord/100==3) then
    write(stdout,'(a)') "Chain method with augmented-Lagrange optimizer"
    write(stdout,1000) "Delta for finite-difference",glob%delta
    write(stdout,2000) "Number of images",glob%nimage
    write(stdout,1000) "Spring constant",glob%nebk
!    write(stdout,2000) "Functional (may change)",chain%functional
!    write(stdout,2000) "Lagrange parameters are updated every",&
!        lambda_intervall,"steps"
  end if

  write(stdout,*)

  ! ====================================================================
  ! System size
  ! ====================================================================

  if(glob%tatoms) &
      write(stdout,2000) "Number of atoms",glob%nat 
  if(glob%tcoords2) then
    ia3=shape(glob%xcoords2)
  else
    ia3=(/1,1,0/)
  end if
  ! input geometries are coords and coords2
  write(stdout,2000) "Number of input geometries",ia3(3)+1
  if(glob%tcoords2.and.abs(glob%distort)>0.D0) then
    write(stdout,1000) "Distorting start coordinates along coords2 by",&
        glob%distort
  end if

  write(stdout,2000) "Variables to be optimised",glob%nivar
  if (glob%imicroiter /= 0) then
     write(stdout, 2000) "Variables in inner (macroiterative) region",glob%nicore
  end if
  if(glob%dump>0) then
    write(stdout,2000) "Restart information is written every", &
        glob%dump,"steps"
  else
    write(stdout,'(a)') "No restart information is written"
  end if
  if(trestarted) then
    write(stdout,'(a)') "This run has been restarted from files."
  else
    write(stdout,'(a)') "This run has not been restarted."
  end if

  if(stat%ccycle > 0) then
    write(stdout,2000) "Number of energy evaluations on this processor",stat%pene
    if (glob%imicroiter == 0) then
       write(stdout,2000) "Number of steps",stat%ccycle
       write(stdout,2000) "Number of accepted steps / line searches",stat%caccepted
    else
       write(stdout,2000) "Number of macroiterative steps",stat%ccycle
       write(stdout,2000) "Number of accepted macroiterative steps",stat%caccepted
       write(stdout,2000) "Number of microiterative steps",stat%tmiccycle
       write(stdout,2000) "Number of accepted microiterative steps", stat%tmicaccepted
    end if
  else
    write(stdout,2000) "Maximum number of steps",glob%maxcycle
    write(stdout,2000) "Maximum number of energy evaluations",glob%maxene
    if (glob%imicroiter > 0) then
       write(stdout,2000) "Max no. of microiterative steps per macro step", &
            glob%maxmicrocycle
    end if
  end if

111 continue ! skip to here if printl is less than or equal to zero

  if (glob%ntasks > 1) call dlf_mpi_counters()

  if (printl > 0) write(stdout,*)
  call flush(stdout)

  ! real number
  1000 format (t1,'................................................', &
           t1,a,' ',t50,es10.3,1x,a)
  ! integer
  2000 format (t1,'................................................', &
           t1,a,' ',t50,i10,1x,a)
end subroutine dlf_report
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* main/dlf_printheader
!!
!! FUNCTION
!!
!! Print header to stdout
!!
!! SYNOPSIS
subroutine dlf_printheader
!! SOURCE
  use dlf_global, only: stdout
  implicit none
! TWK 21/12/2021 DL-FIND is no longer stored in an SVN repository
!  character(50)   :: svn_v
!  call dlf_svnversion(svn_v)
!  if(svn_v=="") then
!    ! svn not available, use the revision number of this file
!    svn_v="$Revision$"
!    svn_v= svn_v(11:)
!  end if

  write(stdout,'(/a)') &
      "***********************************************************************"      
  write(stdout,'(a)') &
      "**                                                                   **"      
  write(stdout,'(a)') &
      "**                       ---------------------                       **"
  write(stdout,'(a)') &
      "**                              DL-FIND                              **"      
  write(stdout,'(a)') &
      "**                       Geometry Optimisation                       **"      
  write(stdout,'(a)') &
      "**                       ---------------------                       **"
  write(stdout,'(a)') &
      "**                                                                   **"      
  write(stdout,'(a)') &
      "**                 J. Kaestner, J.M. Carr, T.W. Keal,                **"
  write(stdout,'(a)') &
      "**                W. Thiel, A. Wander and P. Sherwood                **"
  write(stdout,'(a)') &
      "**                                                                   **" 
  write(stdout,'(a)') &
      "**              J. Phys. Chem. A, 2009, 113 (43), 11856.             **"
  write(stdout,'(a)') &
      "**                                                                   **" 
  write(stdout,'(a)') &
      "**   Please include this reference in published work using DL-FIND.  **"
  write(stdout,'(a)') &
      "**                                                                   **" 
  write(stdout,'(a)') &
      "**               Copyright:  STFC Daresbury Laboratory               **"      
!                    g  f  e  d  c  b  a  C  a  b  c  d  e  f  g
!  write(stdout,'(a)') &
!      "**                          $Revision$                         **"      
!  write(stdout,'("**",27x,"Revision: ",a30,"**")') svn_v
  write(stdout,'(a)') &
      "**                                                                   **"      
  write(stdout,'(a/)') &
      "***********************************************************************"      
  call flush(stdout)
end subroutine dlf_printheader
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* main/dlf_default_init
!!
!! FUNCTION
!!
!! set input parameters to something useless to recognise user input
!! a few parameters are set here, see comments in the code below
!!
!! SYNOPSIS
subroutine dlf_default_init(nspec,spec)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,printl,printf
  implicit none
  integer,intent(in) :: nspec
  integer,intent(out):: spec(nspec)
! **********************************************************************
  printl=-1
  printf=-1
  glob%maxcycle=-1
  glob%maxene=-1
  glob%tolerance=-1.D0
  glob%tolerance_e=-1.D0  
  glob%toldenergy=.false.
  glob%tinit=.false.
  glob%tatoms=.false.
  glob%iopt=-1
  glob%iline=-1
  glob%maxstep=-1.D0
  glob%scalestep=-1.D0
  glob%maxdump=-1
  
  glob%lbfgs_mem=-1
  glob%update=-1
  glob%maxupd=-1
  glob%havehessian=.false.
  glob%delta=-1.D0
  glob%soft=1.D20
  glob%inithessian = -1
  glob%carthessian=-1
  glob%tsrelative=.false.
  glob%minstep=-1.D0
  
  glob%icoord=-1
  glob%nimage=-1
  glob%nebk=-1.D0
  glob%neb_climb_test=-1.D0
  glob%neb_freeze_test=-1.D0
  glob%maxrot=-1
  glob%tolrot=-1.D20
  spec(:)=0 ! for spec, the default is set here (as it may contain
            ! positive and negative values)
  glob%ncons=-1
  glob%nconn=-1
  glob%dump=-1
  glob%restart=-1

  glob%timestep=-1.D0
  glob%fric0=-1.D0
  glob%fricfac=-1.D0
  glob%fricp=-1.D0

  glob%imultistate = 0
  glob%needcoupling = 0
  glob%state_i = 1
  glob%state_j = 2
  glob%pf_c1 = 5.0d0
  glob%pf_c2 = 5.0d0
  glob%gp_c3 = 1.0d0
  glob%gp_c4 = 0.9d0
  glob%ln_t1 = 1.0d-4
  glob%ln_t2 = 1.0d0

  glob%distort = 0.D0 ! default given here

  glob%task = -1
  
  glob%temperature = -1.D0

  glob%po_pop_size= -1
  glob%po_radius_base= -1.0D0
  glob%po_contraction= -1.0D0
  glob%po_tol_r_base= -1.0D0
  glob%po_tolerance_g= -1.0D0
  glob%po_distribution= -1
  glob%po_maxcycle= -1
  glob%po_init_pop_size= -1
  glob%po_reset= -1
  glob%po_mutation_rate= -1.0D0
  glob%po_death_rate= -1.0D0
  glob%po_scalefac= -1.0D0
  glob%po_nsave= -1

  glob%ntasks= -1 ! why???  no real need for this not to be 1...

  glob%nzero=-1

  glob%qtsflag=-1

  glob%maxmicrocycle = -1
  glob%micro_esp_fit = .false.

end subroutine dlf_default_init
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* main/dlf_default_set
!!
!! FUNCTION
!!
!! set parameters that have not been set by the user to the default
!! this routine defines the default values
!!
!! SYNOPSIS
subroutine dlf_default_set(nvarin)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,printl,printf,stdout
  implicit none
  integer,   intent(in)  :: nvarin
! **********************************************************************
  if(printl < 0) printl=2
  if(printf<0) printf=2
  if(glob%maxcycle < 0) glob%maxcycle=100
  if(glob%maxene < 0) glob%maxene=100000

  if(glob%tolerance < 0.D0) glob%tolerance=4.5D-4
  if(glob%tolerance_e < 0.D0) glob%tolerance_e= glob%tolerance/ 450.D0
  if(glob%iopt < 0) glob%iopt=3 ! L-BFGS

  if(glob%iline < 0) then
    if(glob%iopt < 3 .or. glob%imultistate == 2) then
      glob%iline=2
    else
      glob%iline=0
      if(glob%iopt==3.and.glob%icoord<10) glob%iline=1
    end if
  end if
  if(glob%maxstep < 0.D0) glob%maxstep=0.5D0
  if(glob%scalestep < 0.D0) then
    !if(glob%iopt==3) then
      glob%scalestep=1.D0
    !else
    !  glob%scalestep=0.2D0
    !end if
  end if
  if(glob%lbfgs_mem<0) then
    glob%lbfgs_mem=max(nvarin,5)
    glob%lbfgs_mem=min(nvarin,50)
  end if
  if(glob%update<0) glob%update=2
  if(glob%maxupd<0) glob%maxupd=50
  if(glob%delta<0.D0) then
    glob%delta=0.01D0
    if(glob%icoord==190) then
      glob%delta=0.4D0
    end if
  end if
  if(glob%inithessian == -1) glob%inithessian = 0
  if(glob%carthessian==-1) glob%carthessian=0
  if(glob%minstep < 0.D0) glob%minstep = 1.D-5
  if(glob%maxdump < 0 ) glob%maxdump=100000

  if(glob%nimage<0) then
    if(glob%icoord>=100.and.glob%icoord<200) then
      !NEB
      glob%nimage=10
    else
      glob%nimage=1
    end if
  end if
  if(glob%icoord<0) then
    if(glob%nimage==1) then
      glob%icoord=0
    else
      glob%icoord=110 ! NEB with endpoints perpendicular to tau
    end if
  end if
  if(abs(glob%soft)>1.D19) then
    if ((glob%icoord >= 3 .and. glob%icoord <= 4) .or. &
        (glob%icoord >= 13 .and. glob%icoord <= 14)) then
      ! in case of internals only, there is nothing like soft modes
      glob%soft=-1.D0
    else
      glob%soft=5.D-3
    end if
  end if
  if(glob%nebk<0.D0) then
    glob%nebk=0.01D0
    if(glob%icoord==190) then
      glob%nebk=0.D0
    end if
  end if
  if(glob%neb_climb_test < 0.D0) glob%neb_climb_test = 3.0D0
  if(glob%neb_freeze_test < 0.D0) glob%neb_freeze_test = 1.0D0  

  if(glob%maxrot<0) glob%maxrot=10
  if(glob%tolrot<-1.D19) glob%tolrot=5.D0

  ! for "spec" the default is set in dlf_default_init!
  if(glob%ncons<0) glob%ncons=0
  if(glob%nconn<0) glob%nconn=0
  if(glob%dump<0) glob%dump=0
  if(glob%restart<0) glob%restart=0
  ! glob%weight and mass defaults are set in dlf_allocate_glob

  if(glob%timestep <=0.D0) glob%timestep= 1.D0
  if(glob%fric0 <=0.D0) glob%fric0= 0.3D0
  if(glob%fricfac <=0.D0) glob%fricfac=0.95D0
  if(glob%fricp <=0.D0) glob%fricp=0.3D0

  ! Conical intersection search parameters
  ! Note that <= 0 is allowed for ln_t1/ln_t2
  if (glob%pf_c1 .le. 0.D0) glob%pf_c1 = 5.0d0
  if (glob%pf_c2 .le. 0.D0) glob%pf_c2 = 5.0d0
  if (glob%gp_c3 .le. 0.D0) glob%gp_c3 = 1.0d0
  if (glob%gp_c4 .le. 0.D0) glob%gp_c4 = 0.9d0

  ! the default for glob%distort is in dlf_default_init

  if (glob%task < 0) glob%task = 0

  if(glob%temperature < 0.D0) glob%temperature=300.D0

  if (glob%po_pop_size < 1) glob%po_pop_size = 25
  if (glob%po_radius_base <= 0.0D0) glob%po_radius_base = 1.0D0
  if (glob%po_contraction <= 0.0D0) glob%po_contraction = 0.9D0
  if (glob%po_tol_r_base <= 0.0D0) glob%po_tol_r_base = 1.0D-8
  if (glob%po_tolerance_g <= 0.0D0) glob%po_tolerance_g = 1.0D-3
  if (glob%po_distribution < 0) glob%po_distribution = 3 ! force_bias
  if (glob%po_maxcycle <= 0) glob%po_maxcycle = 10000
  if (glob%po_init_pop_size < 1) glob%po_init_pop_size = 2*glob%po_pop_size
  if (glob%po_reset < 1) glob%po_reset = 500
  if (glob%po_mutation_rate < 0.0D0) glob%po_mutation_rate = 0.15D0
  if (glob%po_death_rate < 0.0D0) glob%po_death_rate = 0.5D0
  if (glob%po_scalefac <= 0.0D0) glob%po_scalefac = 10.0D0
  if (glob%po_nsave < 0) glob%po_nsave = 10

  if (glob%ntasks <= 0) glob%ntasks = 1

  ! Change any parameters that are incompatible with parallel optimisation
  if (glob%iopt/10==5) then
     !if (glob%icoord/=0) then ! change this in future!!!
     !   write(stdout,'(1x,a)') "Warning: parallel optimisation incompatible &
     !   &with icoord /= 0 currently; switching to Cartesians"
     !   glob%icoord=0
     !end if
     if (glob%iline/=0) then
        write(stdout,'(1x,a)') "Warning: parallel optimisation incompatible &
        &with iline /= 0; setting to zero" 
        glob%iline=0
     end if
  end if

  ! In principle could calculate the correct value for nzero
  ! based on molecular geometry and frozen atom information.
  ! For now safest to let the user switch it on manually.
  if(glob%nzero<0) glob%nzero = 0

  if(glob%qtsflag==-1) glob%qtsflag=0

  if(glob%maxmicrocycle < 0) glob%maxmicrocycle = 100

end subroutine dlf_default_set
!!****

!  Copyright (C) 2017 The authors of Py-ChemShell
!
!  This file is part of Py-ChemShell.
!
!  Py-ChemShell is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as
!  published by the Free Software Foundation, either version 3 of the
!  License, or (at your option) any later version.
!
!  Py-ChemShell is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with Py-ChemShell.  If not, see
!  <http://www.gnu.org/licenses/>.

subroutine periodic_electrostatics(grid_mode, ncores, nbqs, nshells, ngridpts, ierr)

  ! Calculate the electrostatic potential 
  ! and electric field for a periodic system's unit cell and store in field object
  
  ! grid_mode = 0: at the core and shell positions
  ! grid_mode = 1: at the positions specified by a grid field
  
  use ChemShellClusterModule, only : get_ndims, debug
  
  implicit none

  integer, intent(in) :: grid_mode, ncores, nbqs, nshells, ngridpts
  integer, intent(out) :: ierr

  integer :: ndim, nresults, soffset, send, i

  double precision, dimension(3, ncores+nshells) :: cart_coords
  double precision, dimension(3, ngridpts) :: cart_grid

  double precision, allocatable :: pot(:)
  double precision, allocatable :: efield(:,:)

  integer, parameter :: periodic_frag = 1, cluster_frag = 2

  integer, external :: set_grid_electrostatics

  ierr = 0

  ndim = get_ndims()

  ! Allocate results arrays and get grid coordinates if necessary
  if(debug.gt.0) write(6,*) 'Grid mode set to', grid_mode
  select case (grid_mode)
  case (0)
     cart_grid = 0.0d0
     nresults = ncores + nshells
  case (1)
     call get_grid_coords(ngridpts, cart_grid, ierr)
     if (ierr .ne. 0) return
     nresults = ngridpts
  end select
  allocate(pot(nresults))
  allocate(efield(3,nresults))

  if(debug.gt.0) write(6,*) 'Number of points for FIELD object=', nresults

  call periodic_electrostatics_f(grid_mode, ndim, ncores, nbqs, nshells, ngridpts, &
       cart_grid, nresults, pot, efield, ierr)
  if (ierr .ne. 0) return

  ! Write the potential and electric field to field objects
  select case (grid_mode)
  case (0)
     call get_cart_coords(periodic_frag, cart_coords, ncores, nshells, ierr)
     if (ierr .ne. 0) return
     soffset = ncores + 1
     send = ncores + nshells
     if(debug.gt.0) then
       print *
       print *, '--------------------------------'
       print *, 'Values of potentials:'
       do i = 1, nresults
         print *, pot(i)
       end do
       print *, '--------------------------------'
       print *
       print *, 'values of efield:',efield(:,:)
     end if
     call set_electrostatics(periodic_frag, cart_coords, pot(1:ncores), &
          pot(soffset:send), efield(1:3,1:ncores), efield(1:3,soffset:send), &
          ncores, nshells, ierr)
     if (ierr .ne. 0) return
  case (1)
     if(set_grid_electrostatics(ngridpts, cart_grid, pot, efield) .ne. 0) then
        write(6, *) ">>> ChemShell CLUSTER ERROR: set_grid_electrostatics called in periodic_electrostatics"
     end if
  end select

  deallocate(pot)
  deallocate(efield)

end subroutine periodic_electrostatics


subroutine periodic_electrostatics_f(grid_mode, ndim, ncores, nbqs, nshells, ngridpts, &
     cart_grid, nresults, pot, efield, ierr)
  !
  ! Calculate the electrostatic potential and electric field for a periodic system's
  ! unit cell
  !
  ! grid_mode = 0: at the core and shell positions
  ! grid_mode = 1: at the positions specified by supplied grid coordinates
  !
  ! Can be called directly from Fortran routines to avoid faffing around with field objects
  ! 
  implicit none

  integer, intent(in) :: grid_mode, ndim, ncores, nbqs, nshells, ngridpts, nresults
  double precision, dimension(3, ngridpts), intent(in) :: cart_grid
  double precision, dimension(nresults), intent(out) :: pot
  double precision, dimension(3,nresults), intent(out) :: efield
  integer, intent(out) :: ierr

  integer :: i, j, k, ishel, pshel, ashel, isite

  double precision :: a, b, c, alpha, beta, gamma, area, volume
  double precision, dimension(3, 3) :: vect, vecinv, cart_to_frac
  double precision, dimension(3, ncores+nshells) :: cart_coords
  double precision, dimension(3, ncores) :: f_core
  double precision, dimension(3, nshells) :: f_shel
  double precision, dimension(ncores+nshells) :: cart_charges
  double precision, dimension(ncores) :: charge_core
  double precision, dimension(nshells) :: charge_shel
  integer, dimension(nshells) :: point_core
  integer, dimension(ncores) :: point_shel
  double precision, dimension(3, ngridpts) :: f_grid

  double precision :: dum
  double precision, dimension(2) :: dum2
  double precision, dimension(3) :: dum3

  logical :: shell_model

  double precision :: two_pi

  integer, parameter :: periodic_frag = 1, cluster_frag = 2

  ierr = 0

  ! PGI does not like acos in parameter initialisation so initialise here
  two_pi = 2.d0*dacos(-1.d0)

  ! Check there are no point charges
  if (nbqs .ne. 0) then
     write(6,*) "periodic_electrostatics_f: number of point charges must be zero"
     ierr = 1
     return
  end if

  ! Check nresults is consistent with grid_mode
  if ((grid_mode == 0 .and. nresults /= ncores + nshells) .or. &
       (grid_mode == 1 .and. nresults /= ngridpts)) then
     write(6,*) "periodic_electrostatics_f: inconsistent nresults"
     ierr = 1
     return
  end if
     
  if (nshells .eq. 0) then
     shell_model = .false.
  else
     shell_model = .true.
  end if

  ! Get unit cell vectors from fragment
  vect = 0.0d0
  call get_cell_vectors(periodic_frag, vect, ierr)
  if (ierr .ne. 0) return

  ! Call construct routines to generate unit cell parameters
  ! as they will not necessarily be present in the fragment object
  select case (ndim)
  case (2)
     call lattice_parameters_2(vect(1:2, 1:2), area, a, b, gamma)
  case (3)
     call lattice_parameters_3(vect, volume, a, b, c, alpha, beta, gamma)
  case default
     write(6,*) "periodic_electrostatics: error, ndim=", ndim
     ierr = 1
     return
  end select

  ! Calculate inverse cell vector
  vecinv = 0.0d0
  select case (ndim)
  case (2)
     call inverse_2(vect(1:2, 1:2), vecinv(1:2, 1:2), dum)
  case (3)
     call inverse_3(vect, vecinv)
  case default
     write(6,*) "periodic_electrostatics: error, ndim=", ndim
     ierr = 1
     return
  end select

  ! The construct routine takes fractional coordinates of the unit cell
  ! as an input. ChemShell fractional coordinates refer only to the asymmetric
  ! unit. They also are not 'the closest to the origin' (see frac_to_cart).
  ! Therefore we take the final cartesian coordinates and convert back
  ! to fractional coordinates.

  ! Get cartesian coordinates from fragment
  call get_cart_coords(periodic_frag, cart_coords, ncores, nshells, ierr)  
  if (ierr .ne. 0) return

  ! Convert from cartesians to fractional coordinates
  select case (ndim)
  case (2)
     do i = 1, 2
        do j = 1, 2
           cart_to_frac(i,j) = vecinv(j,i)/two_pi
        end do
     end do
     do isite = 1, ncores
        f_core(1, isite) = cart_to_frac(1,1) * cart_coords(1, isite) &
             + cart_to_frac(2,1) * cart_coords(2, isite)
        f_core(2, isite) = cart_to_frac(1,2) * cart_coords(1, isite) &
             + cart_to_frac(2,2) * cart_coords(2, isite)
        ! Just store the z component
        f_core(3, isite) = cart_coords(3, isite)
     end do
     do isite = 1, nshells
        ishel = ncores + isite
        f_shel(1, isite) = cart_to_frac(1,1) * cart_coords(1, ishel) &
             + cart_to_frac(2,1) * cart_coords(2, ishel)
        f_shel(2, isite) = cart_to_frac(1,2) * cart_coords(1, ishel) &
             + cart_to_frac(2,2) * cart_coords(2, ishel)
        ! Just store the z component
        f_shel(3, isite) = cart_coords(3, ishel)
     end do
     if (grid_mode == 1) then
        do isite = 1, ngridpts
           f_grid(1, isite) = cart_to_frac(1,1) * cart_grid(1, isite) &
                + cart_to_frac(2,1) * cart_grid(2, isite)
           f_grid(2, isite) = cart_to_frac(1,2) * cart_grid(1, isite) &
                + cart_to_frac(2,2) * cart_grid(2, isite)
           ! Just store the z component
           f_grid(3, isite) = cart_grid(3, isite)
        end do
     end if
  case (3)
     do i = 1, 3
        do j = 1, 3
           cart_to_frac(i,j) = vecinv(j,i)/two_pi
        end do
     end do
     do isite = 1, ncores
        f_core(1, isite) = cart_to_frac(1,1) * cart_coords(1, isite) &
             + cart_to_frac(2,1) * cart_coords(2, isite) + cart_to_frac(3,1) * cart_coords(3, isite)
        f_core(2, isite) = cart_to_frac(1,2) * cart_coords(1, isite) &
             + cart_to_frac(2,2) * cart_coords(2, isite) + cart_to_frac(3,2) * cart_coords(3, isite)
        f_core(3, isite) = cart_to_frac(1,3) * cart_coords(1, isite) &
             + cart_to_frac(2,3) * cart_coords(2, isite) + cart_to_frac(3,3) * cart_coords(3, isite)
     end do
     do isite = 1, nshells
        ishel = ncores + isite
        f_shel(1, isite) = cart_to_frac(1,1) * cart_coords(1, ishel) &
             + cart_to_frac(2,1) * cart_coords(2, ishel) + cart_to_frac(3,1) * cart_coords(3, ishel)
        f_shel(2, isite) = cart_to_frac(1,2) * cart_coords(1, ishel) &
             + cart_to_frac(2,2) * cart_coords(2, ishel) + cart_to_frac(3,2) * cart_coords(3, ishel)
        f_shel(3, isite) = cart_to_frac(1,3) * cart_coords(1, ishel) &
             + cart_to_frac(2,3) * cart_coords(2, ishel) + cart_to_frac(3,3) * cart_coords(3, ishel)
     end do
     if (grid_mode == 1) then
        do isite = 1, ngridpts
           f_grid(1, isite) = cart_to_frac(1,1) * cart_grid(1, isite) &
                + cart_to_frac(2,1) * cart_grid(2, isite) + cart_to_frac(3,1) * cart_grid(3, isite)
           f_grid(2, isite) = cart_to_frac(1,2) * cart_grid(1, isite) &
                + cart_to_frac(2,2) * cart_grid(2, isite) + cart_to_frac(3,2) * cart_grid(3, isite)
           f_grid(3, isite) = cart_to_frac(1,3) * cart_grid(1, isite) &
                + cart_to_frac(2,3) * cart_grid(2, isite) + cart_to_frac(3,3) * cart_grid(3, isite)
        end do
     end if
  case default
     write(6,*) "periodic_electrostatics: error, ndim=", ndim
     ierr = 1
     return
  end select

  ! Get charges of cartesian sites from fragment
  ! Split into core and shell arrays
  call get_cart_charges(periodic_frag, cart_charges, ncores+nshells, ierr)
  if (ierr .ne. 0) return
  charge_core = cart_charges(1:ncores)
  if (shell_model) charge_shel = cart_charges(ncores+1:ncores+nshells)

  ! Get pointers from shells to cores
  ! Then setup pointers in the other direction
  point_shel = 0
  if (shell_model) then
     call get_point_core(periodic_frag, point_core, nshells, ierr)
     if (ierr .ne. 0) return
     do i = 1, nshells
        point_shel(point_core(i)) = i
     end do
  end if

  select case (grid_mode)
  case (0)
     ! Calculate potential and field for all atoms and shells
     select case (ndim)
     case (2)
        dum = 0.0d0
        dum2 = 0.0d0
        do i = 1, ncores
           call periodic_pot_2d(dum2, dum, i, .false., &
                shell_model, ncores, nshells, point_shel, &
                f_core, f_shel, charge_core, charge_shel, &
                a, b, gamma, &
                vect(1:2, 1:2), vecinv(1:2, 1:2), area, &
                pot(i), efield(:, i))
           efield(:, i) = -efield(:, i)
           if (shell_model) then
              pshel = point_shel(i)
              if (pshel .ne. 0) then
                 ashel = pshel + ncores
                 call periodic_pot_2d(dum2, dum, i, .true., &
                      shell_model, ncores, nshells, point_shel, &
                      f_core, f_shel, charge_core, charge_shel, &
                      a, b, gamma, &
                      vect(1:2, 1:2), vecinv(1:2, 1:2), area, &
                      pot(ashel), efield(:, ashel))
                 efield(:, ashel) = -efield(:, ashel)
              end if
           end if
        end do
     case (3)
        dum3 = 0.0d0
        do i = 1, ncores
           call periodic_pot_3d(dum3, i, .false., &
                shell_model, ncores, nshells, point_shel, &
                f_core, f_shel, charge_core, charge_shel, &
                a, b, c, alpha, beta, gamma, &
                vect, vecinv, volume, &
                pot(i), efield(:, i))
           efield(:, i) = -efield(:, i)
           if (shell_model) then
              pshel = point_shel(i)
              if (pshel .ne. 0) then 
                 ashel = pshel + ncores
                 call periodic_pot_3d(dum3, i, .true., &
                      shell_model, ncores, nshells, point_shel, &
                      f_core, f_shel, charge_core, charge_shel, &
                      a, b, c, alpha, beta, gamma, &  
                      vect, vecinv, volume, &
                      pot(ashel), efield(:, ashel)) 
                 efield(:, ashel) = -efield(:, ashel)
              end if
           end if
        end do
     case default
        write(6,*) "periodic_electrostatics: error, ndim=", ndim
        ierr = 1
        return
     end select
  case (1)
     ! Calculate potential and field at grid points
     select case (ndim)
     case (2)
        do i = 1, ngridpts
           call periodic_pot_2d(f_grid(1:2, i), f_grid(3, i), 0, .false., &
                shell_model, ncores, nshells, point_shel, &
                f_core, f_shel, charge_core, charge_shel, &
                a, b, gamma, &
                vect(1:2, 1:2), vecinv(1:2, 1:2), area, &
                pot(i), efield(:, i))
           efield(:, i) = -efield(:, i)
        end do
     case (3)
        do i = 1, ngridpts
           call periodic_pot_3d(f_grid(:, i), 0, .false., &
                shell_model, ncores, nshells, point_shel, &
                f_core, f_shel, charge_core, charge_shel, &
                a, b, c, alpha, beta, gamma, &
                vect, vecinv, volume, &
                pot(i), efield(:, i))
           efield(:, i) = -efield(:, i)
        end do
     case default
        write(6,*) "periodic_electrostatics: error, ndim=", ndim
        ierr = 1
        return
     end select
  end select

end subroutine periodic_electrostatics_f


subroutine periodic_pot_2d(f_probe,z_probe,j_site,calculate_shell,&
     shell_model, no_core, no_shel, point_shel, &
     f_core, f_shel, charge_core, charge_shel, &
     a_cell, b_cell, gamma_cell, &
     vector, vecinv, area, &
     potential, efield)

  use ChemShellClusterModule, only : get_ndims, debug
!
! Calculates electrostatic potential at point f_probe, z_probe 
! if j_site is not 0, potential and field are calculated
! at a lattice site number j_site
!
  implicit none

  external dconerfc

  integer :: accuracy
  parameter (accuracy=20)
  double precision :: float_nr_nd
  parameter (float_nr_nd=1.1d0)
  ! Cutoff for exp*erfc term
  double precision :: xbig
  parameter (xbig = 26.543d0)

  logical :: shell_model, calculate_shell
  double precision, dimension(2) :: f_probe
  double precision :: z_probe
  double precision :: potential, potential_real_0, potential_real_1, &
       potential_real_2, potential_reciprocal
  double precision, dimension(3) :: efield, efield_real_1, &
       efield_real_2, efield_reciprocal
! NB: cartesian z-coordinate stored in f_...(3,:)
! cf construct, where it is passed in via r_...(3,:) instead
  double precision, dimension(3, no_core) :: f_core
  double precision, dimension(3, no_shel) :: f_shel
  double precision, dimension(2, no_core) :: g_core
  double precision, dimension(2, no_shel) :: g_shel
  double precision, dimension(no_core) :: charge_core
  double precision, dimension(no_shel) :: charge_shel

  double precision :: a_cell, b_cell, gamma_cell
  double precision, dimension(2, 2) :: vector, vecinv
  double precision :: area

  double precision :: pi

  double precision :: ewald_const, ewald_const_2, accuracy_factor, &
       rec_const, two_const, r_ewald_cut, r_v

  double precision :: dconerfc, fconerfc, fconerfc_1

  double precision :: distance_2, dist, ew_dist
  double precision, dimension(2) :: f, r, f_q, r_q, f_r, r_r
  double precision :: z, z_q, r_q_abs, z_abs, z_r
  double precision :: r_q_2, qr_c, qr_s, func_1, func_2, func_3, func_4, ftmp
  double precision :: contr_c, contr_s, factor

  double precision :: arg1, arg2, arg3, ha_to_ev, force_convert

  integer :: j_site, no_core, no_shel
  integer, dimension(no_core) :: point_shel
  integer :: max_r_x, max_r_y
  integer :: max_q_x, max_q_y
  integer :: ch_stdout, ix, iy
  integer :: j, k, n

  data ch_stdout/6/

  ! Choice of extents of the supercell in reciprocal space.
  ! Seems to be independent of direct latice with aproproate choice of Ewald's
  ! constant. The current choice provides sufficient precision for real*8.
  data max_q_x/10/, max_q_y/10/

  ! Initialise
  pi = dacos(-1.d0)
  ha_to_ev=27.211654d0
  force_convert=51.42206048632d0
  potential=0.d0
  potential_real_1=0.d0
  potential_real_2=0.d0
  potential_reciprocal=0.d0
  do k=1,3
     efield(k)=0.d0
     efield_real_1(k)=0.d0
     efield_real_2(k)=0.d0
     efield_reciprocal(k)=0.d0
  enddo
  ! Choose Ewald constant and set other constants
  ewald_const_2=float_nr_nd*pi/area
  ewald_const=sqrt(ewald_const_2)
  !
  ! Factor for reciprocal term is increased by a factor of 2 
  ! on collapsing complex exponents to cosine
  !
  rec_const=2.d0*pi/area
  two_const=2.d0*ewald_const/sqrt(pi)
  !
  ! Calculate extensions of UC, which includes circle of radius 
  ! sqrt(-ln(10^accuracy))/ewald_const
  ! 
  accuracy_factor=10.d0**accuracy
  accuracy_factor=sqrt(log(accuracy_factor))
  r_ewald_cut=accuracy_factor/ewald_const
  r_v=r_ewald_cut/abs(sin(gamma_cell))
  max_r_x=r_v/a_cell+1
  max_r_y=r_v/b_cell+1

  if(debug > 0 .and. j_site.eq.1) then
     write(*,'(a,g16.8,a,g16.8,a,2i4)') &
          'Ewald constant: ',ewald_const_2*3.57106767, &
          '  Ewald cut-off: ',r_ewald_cut*0.529177d0, &
          ' max: ',max_r_x,max_r_y, &
          'q sum factor:         ',rec_const
  endif

  if(j_site.ne.0) then
     n=point_shel(j_site)
     if(calculate_shell) then
        do k=1,2
           f_probe(k)=f_shel(k,n)
        enddo
        z_probe=f_shel(3,n)
     else
        do k=1,2
           f_probe(k)=f_core(k,j_site)
        enddo
        z_probe=f_core(3,j_site)
     endif
  endif
  ! Centre cell around f_probe
  ! with fractional coordinates named g_core & g_shel
  do j=1,no_core
     do k=1,2
        f(k)=f_core(k,j)
     enddo
     z=f_core(3,j)
     call translate_2(vector,f_probe,f,r)
     do k=1,2
        g_core(k,j)=f(k)
     enddo
     if(shell_model) then
        n=point_shel(j)
        if(n.ne.0) then
           do k=1,2
              g_shel(k,n)=f_shel(k,n)+(g_core(k,j)-f_core(k,j))
           enddo
        endif
     endif
  enddo
  ! 1st uc contribution in real space
  do j=1,no_core
     if(j.ne.j_site) then
        do k=1,2
           f(k)=g_core(k,j)
           f_r(k)=f_probe(k)-f(k)
        enddo
        z=f_core(3,j)
        z_r=z_probe-z
        call transform_2(vector,f_r,r_r)
        dist=distance_2(vector,f_probe,z_probe,f,z)
        ! this check is relevant for very large UC
        if(dist.lt.r_ewald_cut) then
           ew_dist=ewald_const*dist

           if (debug > 1 .and. j_site == 1) then
              write(*,'(3x,i4,a,5g20.12)') &
                   j,' c ',charge_core(j),dist*0.529177d0, &
                   (f_r(k),k=1,2),z_r*0.529177d0
           endif
           
           func_1=dconerfc(ew_dist)/dist
           potential_real_1=potential_real_1+ &
                charge_core(j)*func_1
           func_2=(two_const*exp(-ew_dist*ew_dist)+func_1)* &
                charge_core(j)/(dist*dist)
           do k=1,2
              efield_real_1(k)=efield_real_1(k)-func_2*r_r(k)
           enddo
           efield_real_1(3)=efield_real_1(3)-func_2*z_r
           if(shell_model) then
              n=point_shel(j)
              if(n.ne.0) then
                 do k=1,2
                    f(k)=g_shel(k,n)
                    f_r(k)=f_probe(k)-f(k)
                 enddo
                 z=f_shel(3,n)
                 z_r=z_probe-z
                 call transform_2(vector,f_r,r_r)
                 dist=distance_2(vector,f_probe,z_probe,f,z)

                 if (debug > 1) then
                    write(*,'(3x,i4,a,5f16.10)') &
                         j,' s ',charge_shel(n),dist*0.529177d0, &
                         (f_r(k),k=1,2),z_r*0.529177d0
                 end if

                 ew_dist=ewald_const*dist
                 func_1=dconerfc(ew_dist)/dist
                 potential_real_1=potential_real_1+ &
                      charge_shel(n)*func_1
                 func_2=(two_const*exp(-ew_dist*ew_dist)+func_1)* &
                      charge_shel(n)/(dist*dist)
                 do k=1,2
                    efield_real_1(k)=efield_real_1(k)-func_2*r_r(k)
                 enddo
                 efield_real_1(3)=efield_real_1(3)-func_2*z_r
              endif
           endif
        endif
     else
        ! removing self interaction in Madelung potential and field.
        ! if shell is not directly on core, mutual contributions are subtracted
        ! from both potential and field, otherwise only from potential.
        if(shell_model) then
           n=point_shel(j)
           if(n.ne.0) then
              if(calculate_shell) then
                 do k=1,2
                    f_r(k)=g_shel(k,n)-g_core(k,j)
                 enddo
                 z_r=f_shel(3,n)-f_core(3,j)
                 call transform_2(vector,f_r,r_r)
                 dist=sqrt(r_r(1)*r_r(1)+r_r(2)*r_r(2)+z_r*z_r)
                 if(dist.gt.1.d-7) then
                    ew_dist=ewald_const*dist
                    factor=charge_core(j)*ewald_const    
                    potential_real_0= &
                         -charge_shel(n)*two_const+ &
                         factor*fconerfc(ew_dist)
                    potential_real_1=potential_real_1+ &
                         potential_real_0
                    factor=factor*ewald_const/dist
                    do k=1,2
                       efield_real_1(k)=efield_real_1(k)+ &
                            factor*fconerfc_1(ew_dist)*r_r(k)
                    enddo
                    efield_real_1(3)=efield_real_1(3)+ &
                         factor*fconerfc_1(ew_dist)*z_r
                 else
                    potential_real_0= &
                         -(charge_core(j)+charge_shel(n))*two_const
                    potential_real_1=potential_real_1+ &
                         potential_real_0
                 endif
              else
                 do k=1,2
                    f_r(k)=g_core(k,j)-g_shel(k,n)
                 enddo
                 z_r=f_core(3,j)-f_shel(3,n)
                 call transform_2(vector,f_r,r_r)
                 dist=sqrt(r_r(1)*r_r(1)+r_r(2)*r_r(2)+z_r*z_r)
                 if(dist.gt.1.d-7) then
                    ew_dist=ewald_const*dist
                    factor=charge_shel(n)*ewald_const
                    potential_real_0= &
                           -charge_core(j)*two_const+ &
                           factor*fconerfc(ew_dist)
                    potential_real_1=potential_real_1+ &
                         potential_real_0
                    factor=factor*ewald_const/dist
                    do k=1,2
                       efield_real_1(k)=efield_real_1(k)+ &
                            factor*fconerfc_1(ew_dist)*r_r(k)
                    enddo
                    efield_real_1(3)=efield_real_1(3)+ &
                         factor*fconerfc_1(ew_dist)*z_r
                 else
                    potential_real_0= &
                         -(charge_core(j)+charge_shel(n))*two_const
                    potential_real_1=potential_real_1+ &
                         potential_real_0
                 endif
              endif
           else
              potential_real_0= &
                   -charge_core(j)*two_const
              potential_real_1=potential_real_1+ &
                   potential_real_0
           endif
        else
           potential_real_0= &
                -charge_core(j)*two_const
           potential_real_1=potential_real_1+ &
                potential_real_0
        endif
     endif
  enddo
  ! Contributions of adjacent cells in real space
  do j=1,no_core
     do ix=-max_r_x,max_r_x
        do iy=-max_r_y,max_r_y
           if(ix.ne.0.or.iy.ne.0) then
              f(1)=g_core(1,j)+ix
              f(2)=g_core(2,j)+iy
              z=f_core(3,j)
              do k=1,2
                 f_r(k)=f_probe(k)-f(k)
              enddo
              z_r=z_probe-z
              call transform_2(vector,f_r,r_r)
              dist=distance_2(vector,f_probe,z_probe,f,z)
              ! only do summation in the sphere of r_ewald_cut radius
              if(dist.le.r_ewald_cut) then
                 ew_dist=ewald_const*dist
                 func_1=dconerfc(ew_dist)/dist
                 potential_real_2=potential_real_2+ &
                      charge_core(j)*func_1
                 func_2=(two_const*exp(-ew_dist*ew_dist)+func_1)* &
                      charge_core(j)/(dist*dist)
                 do k=1,2
                    efield_real_2(k)= &
                         efield_real_2(k)-func_2*r_r(k)
                 enddo
                 efield_real_2(3)= &
                      efield_real_2(3)-func_2*z_r
                 if(shell_model) then
                    n=point_shel(j)
                    if(n.ne.0) then
                       f(1)=g_shel(1,n)+ix
                       f(2)=g_shel(2,n)+iy
                       z=f_shel(3,n)
                       do k=1,2
                          f_r(k)=f_probe(k)-f(k)
                       enddo
                       z_r=z_probe-z
                       call transform_2(vector,f_r,r_r)
                       dist=distance_2(vector,f_probe,z_probe,f,z)
                       ew_dist=ewald_const*dist
                       func_1=dconerfc(ew_dist)/dist
                       potential_real_2=potential_real_2+ &
                            charge_shel(n)*func_1
                       func_2=(two_const*exp(-ew_dist*ew_dist)+ &
                            func_1)*charge_shel(n)/(dist*dist)
                       do k=1,2
                          efield_real_2(k)=efield_real_2(k)- &
                               func_2*r_r(k)
                       enddo
                       efield_real_2(3)=efield_real_2(3)- &
                            func_2*z_r
                    endif
                 endif
              endif
           endif
        enddo
     enddo
  enddo
  ! Contribution from reciprocal lattice q vectors
  ! case y/=0
  do j=1,no_core
     do ix=-max_q_x,max_q_x
        do iy=1,max_q_y
           f_q(1)=float(ix)
           f_q(2)=float(iy)
           do k=1,2
              f_r(k)=f_probe(k)-g_core(k,j)
           enddo
           z_r=z_probe-f_core(3,j)
           call transform_2(vector,f_r,r_r)
           call transform_2(vecinv,f_q,r_q)
           qr_c=0.d0
           do k=1,2
              qr_c=qr_c+r_q(k)*r_r(k)
           enddo
           r_q_abs=sqrt(r_q(1)*r_q(1)+r_q(2)*r_q(2))
           z_abs=abs(z_r)
           arg1=r_q_abs*z_abs
           arg2=r_q_abs*0.5d0/ewald_const
           arg3=ewald_const*z_abs
           func_3 = exp(-arg1)*dconerfc(arg2-arg3)
           func_4 = -func_3
           ! Threshold avoids NaN caused by large arg1 values
           ! xbig is the value at which erfc=0 using calerf
           if (arg2 + arg3 < xbig) then
              ftmp = exp(arg1)*dconerfc(arg2+arg3)
              func_3 = func_3 + ftmp
              func_4 = func_4 + ftmp
           end if
           func_4 = func_4 * r_q_abs
           contr_c=charge_core(j)*func_3/r_q_abs
           potential_reciprocal=potential_reciprocal+ &
                contr_c*cos(qr_c)
           do k=1,2
              efield_reciprocal(k)=efield_reciprocal(k)- &
                   contr_c*sin(qr_c)*r_q(k)
           enddo
           efield_reciprocal(3)=efield_reciprocal(3)+ &
                charge_core(j)*func_4*cos(qr_c)
           if(shell_model) then
              n=point_shel(j)
              if(n.ne.0) then
                 do k=1,2
                    f_r(k)=f_probe(k)-g_shel(k,n)
                 enddo
                 call transform_2(vector,f_r,r_r)
                 qr_s=0.d0
                 do k=1,2
                    qr_s=qr_s+r_q(k)*r_r(k)
                 enddo
                 contr_s=charge_shel(n)*func_3/r_q_abs
                 potential_reciprocal=potential_reciprocal+ &
                      contr_s*cos(qr_s)
                 do k=1,2
                    efield_reciprocal(k)= &
                         efield_reciprocal(k)- &
                         contr_s*sin(qr_s)*r_q(k)
                 enddo
                 efield_reciprocal(3)=efield_reciprocal(3)+ &
                      charge_shel(n)*func_4*cos(qr_s)
              endif
           endif
           
           if (debug > 1) then 
              if(shell_model.and.n.ne.0) then
                 if(ix.eq.1.and.iy.eq.1) then
                    write(*,'(a,2g16.8/a,2g16.8/a,i2,3g20.12)') &
                         'f_q:',(f_q(k),k=1,2), &
                         'r_q:',(r_q(k),k=1,2), &
                         'j, qr_c, qr_s, r_q_2:', &
                         j,qr_c,qr_s,r_q_2, &
                         'contr_c:',contr_c
                 endif
              endif
           endif
           
        enddo
     enddo
     ! case y=0
     do ix=1,max_q_x
        f_q(1)=float(ix)
        f_q(2)=float(iy)
        do k=1,2
           f_r(k)=f_probe(k)-g_core(k,j)
        enddo
        z_r=z_probe-f_core(3,j)
        call transform_2(vector,f_r,r_r)
        call transform_2(vecinv,f_q,r_q)
        qr_c=0.d0
        do k=1,2
           qr_c=qr_c+r_q(k)*r_r(k)
        enddo
        r_q_abs=sqrt(r_q(1)*r_q(1)+r_q(2)*r_q(2))
        z_abs=abs(z_r)
        arg1=r_q_abs*z_abs
        arg2=r_q_abs*0.5d0/ewald_const
        arg3=ewald_const*z_abs
        func_3 = exp(-arg1)*dconerfc(arg2-arg3)
        func_4 = -func_3
        ! Threshold avoids NaN caused by large arg1 values
        ! xbig is the value at which erfc=0 using calerf
        if (arg2 + arg3 < xbig) then
           ftmp = exp(arg1)*dconerfc(arg2+arg3)
           func_3 = func_3 + ftmp
           func_4 = func_4 + ftmp
        end if
        func_4 = func_4 * r_q_abs
        contr_c=charge_core(j)*func_3/r_q_abs
        potential_reciprocal=potential_reciprocal+ &
             contr_c*cos(qr_c)
        do k=1,2
           efield_reciprocal(k)=efield_reciprocal(k)- &
                contr_c*sin(qr_c)*r_q(k)
        enddo
        efield_reciprocal(3)=efield_reciprocal(3)+ &
             charge_core(j)*func_4*cos(qr_c)
        if(shell_model) then
           n=point_shel(j)
           if(n.ne.0) then
              do k=1,2
                 f_r(k)=f_probe(k)-g_shel(k,n)
              enddo
              call transform_2(vector,f_r,r_r)
              qr_s=0.d0
              do k=1,2
                 qr_s=qr_s+r_q(k)*r_r(k)
              enddo
              contr_s=charge_shel(n)*func_3/r_q_abs
              potential_reciprocal=potential_reciprocal+ &
                   contr_s*cos(qr_s)
              do k=1,2
                 efield_reciprocal(k)= &
                      efield_reciprocal(k)- &
                      contr_s*sin(qr_s)*r_q(k)
              enddo
              efield_reciprocal(3)=efield_reciprocal(3)+ &
                   charge_shel(n)*func_4*cos(qr_s)
           endif
        endif
     enddo
  enddo
  ! rec_const=2*Pi/Area
  potential_reciprocal=potential_reciprocal*rec_const
  do k=1,3
     efield_reciprocal(k)=efield_reciprocal(k)*rec_const
  enddo
  potential=potential_real_1+ &
       potential_real_2+ &
       potential_reciprocal
  do k=1,3
     efield(k)=efield_real_1(k)+ &
          efield_real_2(k)+ &
          efield_reciprocal(k)
  enddo

  if (debug > 0) then  
     if (calculate_shell) then
        write(*,'(/a,i5)') "Shell of core ", j_site
     else
        write(*,'(/a,i5)') "Core ", j_site
     endif
     write(*,'(a,f26.18)') &
          'Potential (V):               ', &
          potential*ha_to_ev, &
          '   real 0 (V):               ', &
          potential_real_0*ha_to_ev, &
          '   real 1 (V):               ', &
          potential_real_1*ha_to_ev, &
          '   real 2 (V):               ', &
          potential_real_2*ha_to_ev, &
          '   reciprocal (V):           ', &
          potential_reciprocal*ha_to_ev
     write(*,'(a,3f26.18)') &
          'Derivative (V/A):            ', &
          (efield(k)*force_convert,k=1,3), &
          '   real 1  (V/A):            ', &
          (efield_real_1(k)*force_convert,k=1,3), &
          '   real 2  (V/A):            ', &
          (efield_real_2(k)*force_convert,k=1,3), &
          '   reciprocal (V/A):         ', &
          (efield_reciprocal(k)*force_convert,k=1,3)
  endif

  return
end subroutine periodic_pot_2d


subroutine periodic_pot_3d(f_probe, j_site, calculate_shell, &
  shell_model, no_core, no_shel, point_shel, &
  f_core, f_shel, charge_core, charge_shel, &
  a_cell, b_cell, c_cell, alpha_cell, beta_cell, gamma_cell, &
  vector, vecinv, volume, &
  potential, efield)
  !
  ! If j_site = 0, calculate electrostatic potential and field at point f_probe 
  ! if j_site != 0, potential and field are calculated at lattice site j_site
  !
  ! Adapted from the routine pot_3d in Construct v84
  ! 
  implicit none

  external dconerfc

  integer :: accuracy
  parameter (accuracy=20)
  double precision :: float_nr_nd
  parameter (float_nr_nd=1.1d0)

  logical :: shell_model, calculate_shell       
  double precision, dimension(3) :: f_probe(3)
  double precision :: potential, potential_real_0, potential_real_1, &
       potential_real_2, potential_reciprocal
  double precision, dimension(3) :: efield, efield_real_1, &
       efield_real_2, efield_reciprocal
  double precision, dimension(3, no_core) :: f_core, g_core
  double precision, dimension(3, no_shel) :: f_shel, g_shel
  double precision, dimension(no_core) :: charge_core
  double precision, dimension(no_shel) :: charge_shel
  
  double precision :: a_cell, b_cell, c_cell, &
       alpha_cell, beta_cell, gamma_cell
  double precision, dimension(3, 3) :: vector, vecinv
  double precision :: volume

  double precision :: pi

  double precision :: ewald_const, ewald_const_2, accuracy_factor, &
       q_const, rec_const, two_const, r_ewald_cut, r_v
  double precision :: dconerfc, fconerfc, fconerfc_1
  double precision :: distance_3, dist, ew_dist
  double precision, dimension(3) :: f, r, f_q, r_q, f_r, r_r
  double precision :: r_q_2, qr_c, qr_s, func_1, func_2, func_3
  double precision :: contr_c, contr_s, factor
  integer :: j_site, no_core, no_shel
  integer, dimension(no_core) :: point_shel
  integer :: max_r_x, max_r_y, max_r_z
  integer :: max_q_x, max_q_y, max_q_z
  integer :: ch_stdout, ix, iy, iz
  integer :: j, k, n
 
  data ch_stdout/6/

  ! Choice of extents of the supercell in reciprocal space.
  ! Seems to be independent of direct latice with aproproate choice of Ewald's
  ! constant. The current choice provides sufficient precision for real*8.
  data max_q_x/8/, max_q_y/8/, max_q_z/8/
  
  ! Initialise
  pi = dacos(-1.d0)
  potential=0.d0
  potential_real_1=0.d0
  potential_real_2=0.d0
  potential_reciprocal=0.d0
  do k=1,3
     efield(k)=0.d0
     efield_real_1(k)=0.d0
     efield_real_2(k)=0.d0
     efield_reciprocal(k)=0.d0
  enddo
  ! Choose Ewald constant and set other constants
  ewald_const_2=float_nr_nd*pi/volume**(2.d0/3.d0)
  ewald_const=sqrt(ewald_const_2)
  q_const=-1.d0/(4.d0*ewald_const_2)
  !
  ! Factor for reciprocal term is increased by a factor of 2 
  ! on collapsing complex exponents to cosine
  !
  rec_const=8.d0*pi/volume
  two_const=2.d0*ewald_const/sqrt(pi)
  !
  ! Calculate extensions of UC, which includes sphere of radius 
  ! sqrt(-ln(10^accuracy))/ewald_const
  ! 
  accuracy_factor=10.d0**accuracy
  accuracy_factor=sqrt(log(accuracy_factor))
  r_ewald_cut=accuracy_factor/ewald_const
  r_v=r_ewald_cut/volume
  max_r_x=r_v*b_cell*c_cell*abs(sin(alpha_cell))+1
  max_r_y=r_v*a_cell*c_cell*abs(sin( beta_cell))+1
  max_r_z=r_v*a_cell*b_cell*abs(sin(gamma_cell))+1
  ! IFDEBUG
  !if(j_site.eq.1) then
  !   write(*,*) 'VOLUME: ', volume
  !   write(*,'(a,g16.8,a,g16.8,a,3i4)') &
  !        'Ewald constant: ',ewald_const_2*3.57106767, &
  !        '  Ewald cut-off: ',r_ewald_cut*0.529177d0, &
  !        ' max: ',max_r_x,max_r_y,max_r_z 
     !          'q exp constant:       ',q_const, &
     !          'q sum factor:         ',rec_const
  !endif
  ! ENDDEBUG
  if(j_site.ne.0) then
     n=point_shel(j_site)
     do k=1,3
        if(calculate_shell) then
           f_probe(k)=f_shel(k,n)
        else
           f_probe(k)=f_core(k,j_site)
        endif
     enddo
  endif
  ! Centre cell around f_probe
  ! with fractional coordinates named g_core & g_shel
  do j=1,no_core
     do k=1,3
        f(k)=f_core(k,j)
     enddo
     call translate_3(vector,f_probe,f,r)
     do k=1,3
        g_core(k,j)=f(k)
        f_r(k)=f(k)-f_probe(k)
     enddo
     if(shell_model) then
        n=point_shel(j)
        if(n.ne.0) then
           do k=1,3
              g_shel(k,n)=f_shel(k,n)+(g_core(k,j)-f_core(k,j))
           enddo
        endif
     endif
  enddo
  ! 1st uc contribution in real space
  do j=1,no_core
     if(j.ne.j_site) then
        do k=1,3
           f(k)=g_core(k,j)
           f_r(k)=f_probe(k)-f(k)
        enddo
        call transform_3(vector,f_r,r_r)
        dist=distance_3(vector,f_probe,f)
        ! this check is relevant for very large UC
        if(dist.lt.r_ewald_cut) then
           ew_dist=ewald_const*dist
! IFDEBUG
!           if(j_site.eq.1) then
!              write(*,'(3x,i4,a,5g20.12)') &
!                   j,' c ',charge_core(j),dist*0.529177d0, &
!                   (f_r(k),k=1,3)
!           endif
! ENDDEBUG
           func_1=dconerfc(ew_dist)/dist
           potential_real_1=potential_real_1 + &
                charge_core(j)*func_1
           func_2=(two_const*exp(-ew_dist*ew_dist)+func_1) * &
                charge_core(j)/(dist*dist)
           do k=1,3
              efield_real_1(k)=efield_real_1(k)-func_2*r_r(k)
           enddo
           if(shell_model) then
              n=point_shel(j)
              if(n.ne.0) then
                 do k=1,3
                    f(k)=g_shel(k,n)
                    f_r(k)=f_probe(k)-f(k)
                 enddo
                 call transform_3(vector,f_r,r_r)
                 dist=distance_3(vector,f_probe,f)
! IFDEBUG
!                 write(*,'(3x,i4,a,5f16.10)') &
!                      j,' s ',charge_shel(n),dist*0.529177d0, &
!                      (f_r(k),k=1,3)
! ENDDEBUG
                 ew_dist=ewald_const*dist
                 func_1=dconerfc(ew_dist)/dist
                 potential_real_1=potential_real_1 + &
                      charge_shel(n)*func_1
                 func_2=(two_const*exp(-ew_dist*ew_dist)+func_1)* &
                      charge_shel(n)/(dist*dist)
                 do k=1,3
                    efield_real_1(k)=efield_real_1(k)-func_2*r_r(k)
                 enddo
              endif
           endif
        endif
     else
! removing self interaction in Madelung potential and field.
! if shell is not directly on core, mutual contributions are subtracted
! from both potential and field, otherwise only from potential.
        if(shell_model) then
           n=point_shel(j)
           if(n.ne.0) then
              if(calculate_shell) then
                 do k=1,3
                    f_r(k)=g_shel(k,n)-g_core(k,j)
                 enddo
                 call transform_3(vector,f_r,r_r)
                 dist=sqrt(r_r(1)*r_r(1)+r_r(2)*r_r(2)+r_r(3)*r_r(3))
                 if(dist.gt.1.d-7) then
                    ew_dist=ewald_const*dist
                    factor=charge_core(j)*ewald_const                    
                    potential_real_0= &
                         -charge_shel(n)*two_const+ &
                         factor*fconerfc(ew_dist)
                    potential_real_1=potential_real_1+ &
                         potential_real_0
                    factor=factor*ewald_const/dist
                    do k=1,3
                       efield_real_1(k)=efield_real_1(k)+ &
                            factor*fconerfc_1(ew_dist)*r_r(k)
                    enddo
                 else
                    potential_real_0= &
                         -(charge_core(j)+charge_shel(n))*two_const
                    potential_real_1=potential_real_1+ &
                         potential_real_0
                 endif
              else
                 do k=1,3
                    f_r(k)=g_core(k,j)-g_shel(k,n)
                 enddo
                 call transform_3(vector,f_r,r_r)
                 dist=sqrt(&
                      r_r(1)*r_r(1)+r_r(2)*r_r(2)+r_r(3)*r_r(3))
                 if(dist.gt.1.d-7) then
                    ew_dist=ewald_const*dist
                    factor=charge_shel(n)*ewald_const
                    potential_real_0= &
                         -charge_core(j)*two_const+ &
                         factor*fconerfc(ew_dist)
                    potential_real_1=potential_real_1+ &
                         potential_real_0
                    factor=factor*ewald_const/dist
                    do k=1,3
                       efield_real_1(k)=efield_real_1(k)+ &
                            factor*fconerfc_1(ew_dist)*r_r(k)
                    enddo
                 else
                    potential_real_0= &
                         -(charge_core(j)+charge_shel(n))*two_const
                    potential_real_1=potential_real_1+ &
                         potential_real_0
                 endif
              endif
           else
              potential_real_0= &
                   -charge_core(j)*two_const
              potential_real_1=potential_real_1+ &
                   potential_real_0
           endif
        else
           potential_real_0= &
                -charge_core(j)*two_const
           potential_real_1=potential_real_1+ &
                potential_real_0
        endif
     endif
  enddo
! Contributions of adjacent cells in real space
  do j=1,no_core
     do ix=-max_r_x,max_r_x
        do iy=-max_r_y,max_r_y
           do iz=-max_r_z,max_r_z
              if(ix.ne.0.or.iy.ne.0.or.iz.ne.0) then
                 f(1)=g_core(1,j)+ix
                 f(2)=g_core(2,j)+iy
                 f(3)=g_core(3,j)+iz
                 do k=1,3
                    f_r(k)=f_probe(k)-f(k)
                 enddo
                 call transform_3(vector,f_r,r_r)
                 dist=distance_3(vector,f_probe,f)
! only do summation in the sphere of r_ewald_cut radius
                 if(dist.le.r_ewald_cut) then
                    ew_dist=ewald_const*dist
                    func_1=dconerfc(ew_dist)/dist
                    potential_real_2=potential_real_2+ &
                         charge_core(j)*func_1
                    func_2=(two_const*exp(-ew_dist*ew_dist)+func_1)* &
                         charge_core(j)/(dist*dist)
                    do k=1,3
                       efield_real_2(k)= &
                            efield_real_2(k)-func_2*r_r(k)
                    enddo
                    if(shell_model) then
                       n=point_shel(j)
                       if(n.ne.0) then
                          f(1)=g_shel(1,n)+ix
                          f(2)=g_shel(2,n)+iy
                          f(3)=g_shel(3,n)+iz
                          do k=1,3
                             f_r(k)=f_probe(k)-f(k)
                          enddo
                          call transform_3(vector,f_r,r_r)
                          dist=distance_3(vector,f_probe,f)
                          ew_dist=ewald_const*dist
                          func_1=dconerfc(ew_dist)/dist
                          potential_real_2=potential_real_2+ &
                               charge_shel(n)*func_1
                          func_2=(two_const*exp(-ew_dist*ew_dist)+ &
                               func_1)*charge_shel(n)/(dist*dist)
                          do k=1,3
                             efield_real_2(k)=efield_real_2(k)- &
                                  func_2*r_r(k)
                          enddo
                       endif
                    endif
                 endif
              endif
           enddo
        enddo
     enddo
  enddo
! Contribution from reciprocal lattice q vectors
! with zero components along x and y axes and z=0, treated separately
  do j=1,no_core
     do ix=-max_q_x,max_q_x
        do iy=-max_q_y,max_q_y
           do iz=1,max_q_z
              f_q(1)=float(ix)
              f_q(2)=float(iy)
              f_q(3)=float(iz)
              do k=1,3
                 f_r(k)=f_probe(k)-g_core(k,j)
              enddo
              call transform_3(vector,f_r,r_r)
              call transform_3(vecinv,f_q,r_q)
              qr_c=0.d0
              do k=1,3
                 qr_c=qr_c+r_q(k)*r_r(k)
              enddo
              r_q_2=r_q(1)*r_q(1)+r_q(2)*r_q(2)+r_q(3)*r_q(3)
              func_3=exp(q_const*r_q_2)/r_q_2
              contr_c=charge_core(j)*func_3
              potential_reciprocal=potential_reciprocal+ &
                   contr_c*cos(qr_c)
              do k=1,3
                 efield_reciprocal(k)=efield_reciprocal(k)- &
                      contr_c*sin(qr_c)*r_q(k)
              enddo
              if(shell_model) then
                 n=point_shel(j)
                 if(n.ne.0) then
                    do k=1,3
                       f_r(k)=f_probe(k)-g_shel(k,n)
                    enddo
                    call transform_3(vector,f_r,r_r)
                    qr_s=0.d0
                    do k=1,3
                       qr_s=qr_s+r_q(k)*r_r(k)
                    enddo
                    contr_s=charge_shel(n)*func_3
! q_const=-1/(2*Ewald_const)**2
                    potential_reciprocal=potential_reciprocal+ &
                         contr_s*cos(qr_s)
                    do k=1,3
                       efield_reciprocal(k)= &
                            efield_reciprocal(k)- &
                            contr_s*sin(qr_s)*r_q(k)
                    enddo
                 endif
              endif
! IFDEBUG
!                  if(shell_model.and.n.ne.0) then
!                     if(ix.eq.0.and.iy.eq.0.and.iz.eq.1) then
!                        write(*,'(a,3g16.8/a,3g16.8/a,i2,3g20.12)')
!     &                       'f_q:',(f_q(k),k=1,3),
!     &                       'r_q:',(r_q(k),k=1,3),
!     &                       'j, qr_c, qr_s, r_q_2:',
!     &                       j,qr_c,qr_s,r_q_2,
!     &                       'contr_c,contr_s:',contr_c,contr_s
!                     endif
!                  endif
! ENDDEBUG
           enddo
        enddo
     enddo
! z=0 case y/=0
     do ix=-max_q_x,max_q_x
        do iy=1,max_q_y
           f_q(1)=float(ix)
           f_q(2)=float(iy)
           f_q(3)=0.d0
           do k=1,3
              f_r(k)=f_probe(k)-g_core(k,j)
           enddo
           call transform_3(vector,f_r,r_r)
           call transform_3(vecinv,f_q,r_q)
           qr_c=0.d0
           do k=1,3
              qr_c=qr_c+r_q(k)*r_r(k)
           enddo
           r_q_2=r_q(1)*r_q(1)+r_q(2)*r_q(2)+r_q(3)*r_q(3)
           func_3=exp(q_const*r_q_2)/r_q_2
           contr_c=charge_core(j)*func_3
           potential_reciprocal=potential_reciprocal+ &
                contr_c*cos(qr_c)
           do k=1,3
              efield_reciprocal(k)=efield_reciprocal(k)- &
                   contr_c*sin(qr_c)*r_q(k)
           enddo
           if(shell_model) then
              n=point_shel(j)
              if(n.ne.0) then
                 do k=1,3
                    f_r(k)=f_probe(k)-g_shel(k,n)
                 enddo
                 call transform_3(vector,f_r,r_r)
                 qr_s=0.d0
                 do k=1,3
                    qr_s=qr_s+r_q(k)*r_r(k)
                 enddo
                 contr_s=charge_shel(n)*func_3
! q_const=-1/(2*Ewald_const)**2
                 potential_reciprocal=potential_reciprocal+ &
                      contr_s*cos(qr_s)
                 do k=1,3
                    efield_reciprocal(k)= &
                         efield_reciprocal(k)- &
                         contr_s*sin(qr_s)*r_q(k)
                 enddo
              endif
           endif
! IFDEBUG
!               if(shell_model.and.n.ne.0) then
!                  if(ix.eq.1.and.iy.eq.1) then
!                     write(*,'(a,3g16.8/a,3g16.8/a,i2,3g20.12)')
!     &                    'f_q:',(f_q(k),k=1,3),
!     &                    'r_q:',(r_q(k),k=1,3),
!     &                    'j, qr_c, qr_s, r_q_2:',
!     &                    j,qr_c,qr_s,r_q_2,
!     &                    'contr_c:',contr_c
!                  endif
!               endif
! ENDDEBUG
        enddo
     enddo
! z=0 and y=0
     do ix=1,max_q_x
        f_q(1)=float(ix)
        f_q(2)=0.d0
        f_q(3)=0.d0
        do k=1,3
           f_r(k)=f_probe(k)-g_core(k,j)
        enddo
        call transform_3(vector,f_r,r_r)
        call transform_3(vecinv,f_q,r_q)
        qr_c=0.d0
        do k=1,3
           qr_c=qr_c+r_q(k)*r_r(k)
        enddo
        r_q_2=r_q(1)*r_q(1)+r_q(2)*r_q(2)+r_q(3)*r_q(3)
        func_3=exp(q_const*r_q_2)/r_q_2
        contr_c=charge_core(j)*func_3
        potential_reciprocal=potential_reciprocal+ &
             contr_c*cos(qr_c)
        do k=1,3
           efield_reciprocal(k)=efield_reciprocal(k)- &
                contr_c*sin(qr_c)*r_q(k)
        enddo
        if(shell_model) then
           n=point_shel(j)
           if(n.ne.0) then
              do k=1,3
                 f_r(k)=f_probe(k)-g_shel(k,n)
              enddo
              call transform_3(vector,f_r,r_r)
              qr_s=0.d0
              do k=1,3
                 qr_s=qr_s+r_q(k)*r_r(k)
              enddo
              contr_s=charge_shel(n)*func_3
 ! q_const=-1/(2*Ewald_const)**2
              potential_reciprocal=potential_reciprocal+ &
                   contr_s*cos(qr_s)
              do k=1,3
                 efield_reciprocal(k)= &
                      efield_reciprocal(k)- &
                      contr_s*sin(qr_s)*r_q(k)
              enddo
           endif
        endif
     enddo
  enddo
! rec_const=8.d0*Pi/Volume
  potential_reciprocal=potential_reciprocal*rec_const
  do k=1,3
     efield_reciprocal(k)=efield_reciprocal(k)*rec_const
  enddo
  potential=potential_real_1+ &
       potential_real_2+ &
       potential_reciprocal
  do k=1,3
     efield(k)=efield_real_1(k)+ &
          efield_real_2(k)+ &
          efield_reciprocal(k)
  enddo
  return
end subroutine periodic_pot_3d

!  Copyright (C) 2017 The authors of Py-ChemShell
!
!  This file is part of Py-ChemShell.
!
!  Py-ChemShell is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as
!  published by the Free Software Foundation, either version 3 of the
!  License, or (at your option) any later version.
!
!  Py-ChemShell is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with Py-ChemShell.  If not, see
!  <http://www.gnu.org/licenses/>.

integer function lsdalton_chemsh_comm() result(communicator)

    use ChemShellParallelModule, only : chemsh_parallel

    communicator = chemsh_parallel%comm_workgroup

endfunction lsdalton_chemsh_comm

subroutine lsdaltonjumpout
! TWK TODO should be able to eliminate this call from LSDalton
! TWK TODO now that the Fortran STOP for replicas has been removed
! TWK TODO see LSDalton src/lsutil/lsmpiType.f90

    print *, "Warning: unexpected call to lsdaltonjumpout"

endsubroutine lsdaltonjumpout

! ***************************************************************************
! *   Copyright (C) 2007 - 2015 by J.A.Purton                               *
! *   john.purton[@]stfc.ac.uk                                              *
! *                                                                         *
! *   Contributors:                                                         *
! *   -------------                                                         *
! *   A.V.Brukhno - Free Energy Diff, planar pore & algorithm optimizations *
! *   andrey.brukhno[@]stfc.ac.uk abrukhno[@]gmail.com                      *
! *                                                                         *
! *   T.L.Underwood - Lattice/Phase-Switch MC method & optimizations        *
! *   t.l.Underwood[@]bath.ac.uk                                            *
! *                                                                         *
! *   J.Grant - Complexi constant for Ewald refactor and general use        *
! *   j.grant[@]bath.ac.uk                                                  *
! ***************************************************************************

module constants_module

    use kinds_f90

    implicit none

    real(kind = wp), parameter :: BOLTZMAN = 0.831451115_wp ! boltzman constant
    real(kind = wp), parameter ::  PRSFACT = 0.163882576_wp ! conversion factor from katm to internal units

    integer, parameter :: MAXMESH = 10004 ! number of points along mesh
    integer, parameter :: MAXINTH = huge(MAXMESH)
    integer, parameter :: MAXINT1 = huge(MAXMESH)-1
    integer, parameter :: MAXINT2 = huge(MAXMESH)-2
    integer, parameter :: MAXINT3 = huge(MAXMESH)-3
    integer, parameter :: MAXINT4 = huge(MAXMESH)-4
    integer, parameter :: MAXINTL = 2147483647
    integer, parameter :: MAXINTS = 32767
    
    !TU: Starting point for range of integers signifying a 1-4 dihedral pair
    !TU: in exclusion lists
    integer, parameter :: EXCDIH = huge(MAXMESH)/2

    real(kind = wp), parameter ::  PI = 3.14159265358979323846264338328_wp
    real(kind = wp), parameter ::  TWOPI  = 2.0_wp * PI
    real(kind = wp), parameter ::  ROOTPI = 1.77245385090551602729816748334_wp
    real(kind = wp), parameter ::  RTWOPI = 1.0_wp / TWOPI
    real(kind = wp), parameter ::  TORADIANS = PI / 180.0_wp

    real(kind = wp), parameter ::  THIRD = 1.0_wp / 3.0_wp
    real(kind = wp), parameter ::  HALF  = 0.5_wp
    real(kind = wp), parameter ::  DHALF = HALF-1.e-12_wp
    real(kind = wp), parameter ::  DZERO = 1.e-12_wp
    real(kind = wp), parameter ::  FZERO = 1.e-6_wp

!the bits for fh correction - the exponentials are fiddled later
    real(kind = wp), parameter ::  PLANCK = 6.62606597_wp
    real(kind = wp), parameter ::  HBAR   = PLANCK / TWOPI
    real(kind = wp), parameter ::  AVAG   = 6.02214_wp         
    real(kind = wp), parameter ::  BOLT   = 1.3806488_wp

! complexi for use in Ewald refactor and generally
    complex(kind = wp), parameter :: COMPLEXI = (0.0_wp,1.0_wp)    
    complex(kind = wp), parameter :: COMPLEXTWOPI = TWOPI * (0.0_wp,1.0_wp)    

!STRIP_SIZE is the size of the buffer in strip mining
    integer, parameter :: STRIP_SIZE = 32
    
!internal conversion units
    real(kind = wp), parameter ::  CTOINTERNAL = 138935.4835_wp
    real(kind = wp), parameter ::  CTOEV = 14.3997584_wp
    real(kind = wp), parameter ::  EVTOINTERNAL = 9648.530821_wp
    real(kind = wp), parameter ::  KCALTOINTERNAL = 418.4_wp
    real(kind = wp), parameter ::  KJTOINTERNAL = 100.00_wp
    real(kind = wp), parameter ::  KTOINTERNAL = 0.831451115_wp
    real(kind = wp), parameter ::  INTERNALTOEV = 1.0364305e-4_wp

    real(kind = wp), parameter ::  RCORE  = 0.001_wp
    real(kind = wp), parameter ::  RCORE2 = 0.000001_wp

    integer, parameter :: uctrl = 55  ! control file
    integer, save :: uout  = 66 ! output file
    integer, parameter :: ucfg  = 77  ! config file
    integer, parameter :: uarch = 8  ! archive file
    integer, parameter :: urevc = 9  ! revcon file
    integer, parameter :: ustat = 10 ! statistics file
    integer, parameter :: urest = 11 ! restart file
    integer, parameter :: ufld  = 12 ! field file
    integer, parameter :: uplt  = 13 ! data file (PTFILE)
    integer, parameter :: utbl  = 14 ! potential table files
    integer, parameter :: urevi = 15 ! revive file
    integer, parameter :: uzdn  = 16 ! z-density
    integer, parameter :: urdf  = 17 ! rdfs
    integer, parameter :: ueng  = 18 ! energies of atoms
    integer, parameter :: udsp  = 19 ! displacements
    integer, parameter :: ufed  = 20 !AB: FED data file
    integer, parameter :: upsmc = 22 !TU: PSMC data (NB: unit 21 is taken by 'unpt', for 'VOLDAT' - see 'vol_moves.f90')
    integer, parameter :: utm   = 23 !TU: FED TM I/O
    integer, parameter :: uzch  = 26 !AB: charge z-densities
    integer, parameter :: utraj = 30 !AB: trajectory file (for conversion)
    integer, parameter :: uorient = 31 !TU: Periodic dump of molecular orientations 
    integer, parameter :: uyaml  = 32 !TU: YAML data file
    integer, parameter :: uyaml2 = 33 !TU: 2nd YAML data file - required for the Gibbs ensemble 
    integer, parameter :: uarch2 = 34 !TU: 2nd archive file - required for the Gibbs ensemble
    integer, parameter :: udcd   = 35 !TU: DCD trajectory file
    integer, parameter :: udcd2  = 36 !TU: 2nd DCD trajectory file - required for the Gibbs ensemble
    integer, parameter :: uscan = 40 !scp: output for scan

! AB: NPT move types

    integer, parameter :: NPT_OFF  = 0 ! no NPT move
    integer, parameter :: NPT_VEC  =-3 ! NPT for cell matrix - sampling cell vectors, not allowed in slit
    integer, parameter :: NPT_LOG  =-2 ! NPT for orthorhombic/cubic cell - sampling ln(V), same in slit
    integer, parameter :: NPT_INV2 =-4 ! NPT for orthorhombic       cell - sampling inverse linear dimension(s), same in slit
    integer, parameter :: NPT_INV  =-1 ! NPT for cubic              cell - sampling inverse linear dimension(s)
    integer, parameter :: NPT_LIN  = 1 ! NPT for cubic              cell - sampling linear dimension(s)
    integer, parameter :: NPT_LIN2 = 2 ! NPT for orthorhombic       cell - sampling linear dimension(s), specific in slit
    integer, parameter :: NPT_VOL  = 3 ! NPT for orthorhombic/cubic cell - sampling the volume uniformly, same in slit
    integer, parameter :: NPT_GIBBS = 10 ! Volume moves for orthorhombic/cubic cells in Gibbs ensemble (coupled boxes) - sampling volume uniformly
    integer, parameter :: NPT_ORTHOANI = 11 ! NPT for orthorhombic with anisotropic moves - sampling ln(V)

! AB: Trajectory file types

    integer, parameter :: VTK      = -1 ! Legacy VTK (for visualising atom orientations)
    integer, parameter :: DLM      = 0 ! DL_MONTE  (legacy; native)
    integer, parameter :: DLP      = 1 ! DL_POLY   (legacy; hybrid)
    integer, parameter :: DLP2     = 2 ! DL_POLY-2 (Classic)
    integer, parameter :: DLP2DCD  = 3 ! DL_POLY-2 (Classic) + DCD (Charmm; binary)
    integer, parameter :: DLP4     = 4 ! DL_POLY-4 (Latest)
    integer, parameter :: DLP4DCD  = 5 ! DL_POLY-4 (Latest)  + DCD (Charmm; binary)
    integer, parameter :: DCD      = 6 ! DCD  (only Charmm; binary)
    
! AB: below are constants added for 2D-slit extension (see slit_module.f90)

    integer, parameter :: SLIT_EXT0 = 0 ! slit with no wall having short-range interactions
    integer, parameter :: SLIT_EXT1 = 1 ! slit with one wall having short-range interactions
    integer, parameter :: SLIT_EXT2 = 2 ! slit with two walls having short-range interactions

! AB: slit cell types (must be < 0):
    integer, parameter :: SLIT_SOFT1 = -1 ! slit with one soft wall  (no Coulomb)
    integer, parameter :: SLIT_SOFT2 = -2 ! slit with two soft walls (no Coulomb)
    integer, parameter :: SLIT_HARD2 = -3 ! slit with two hard walls (no Coulomb)

! AB: slit MFA types (coultype = -2 for all):
    integer, parameter :: MFA_OFF  = 0 ! no MFA correction (NO/Explicit Coulomb)
    integer, parameter :: MFA_RECT = 1 ! MFA outside rectangular in-box cut-off (-1 from scratch; 1 from input)
    integer, parameter :: MFA_CYLD = 2 ! MFA outside cylindrical in-box cut-off (-2 from scratch; 2 from input)
    !integer, parameter :: MFA_SPHR = 3 ! MFA outside spherical   in-box cut-off (-3 from scratch; 3 from input)

! AB: collective cell types (for quicker checks):
    integer, parameter :: SLIT_EXT1_MFA0 = -10 ! slit with one soft wall, direct in-box Coulomb
    integer, parameter :: SLIT_EXT1_MFA1 = -11 ! slit with one soft wall, MFA outside rectangular in-box cut-off
    integer, parameter :: SLIT_EXT1_MFA2 = -12 ! slit with one soft wall, MFA outside cylindrical in-box cut-off
    integer, parameter :: SLIT_EXT1_MFA3 = -13 ! slit with one soft wall, MFA outside spherical   in-box cut-off

    integer, parameter :: SLIT_EXT2_MFA0 = -20 ! slit with two soft walls, direct in-box Coulomb
    integer, parameter :: SLIT_EXT2_MFA1 = -21 ! slit with two soft walls, MFA outside rectangular in-box cut-off
    integer, parameter :: SLIT_EXT2_MFA2 = -22 ! slit with two soft walls, MFA outside cylindrical in-box cut-off
    integer, parameter :: SLIT_EXT2_MFA3 = -23 ! slit with two soft walls, MFA outside spherical   in-box cut-off

    integer, parameter :: SLIT_HARD_MFA0 = -30 ! slit with two hard walls, direct in-box Coulomb
    integer, parameter :: SLIT_HARD_MFA1 = -31 ! slit with two hard walls, MFA outside rectangular in-box cut-off
    integer, parameter :: SLIT_HARD_MFA2 = -32 ! slit with two hard walls, MFA outside cylindrical in-box cut-off
    integer, parameter :: SLIT_HARD_MFA3 = -33 ! slit with two hard walls, MFA outside spherical   in-box cut-off

! AB: below are constants added for FED calculation (fed_interface_module.f90)

    ! FED FLAVOR IDENTIFIERS
    integer, parameter :: FED_NO = 0 ! NO FED 
    integer, parameter :: FED_GN = 1 ! generic
    integer, parameter :: FED_PS = 3 ! Phase Switch   / PSMC
    integer, parameter :: FED_HW = 4 ! Histogram Reweighting / HRMC
    !integer, parameter :: FED_?? = ??

    ! FED METHODOLY IDENTIFIERS
    integer, parameter :: FED_US = 1 ! Umbrella Sampling
    integer, parameter :: FED_EE = 2 ! Expanded/Extended Ensemble (iterative)
    integer, parameter :: FED_WL = 3 ! Wang-Landau on-the-fly feedback (iterative)
    integer, parameter :: FED_TM = 4 ! Transition Matrix 
    !integer, parameter :: FED_?? = ??

    ! IDENTIFIERS for NATURALLY EVOLVING order parameter (reaction coordinates)
    ! - depend on structure & need re-calculation every time!
    integer, parameter :: FED_PAR_PSMC    = -6 ! PSMC order parameter - difference in energy between passive and active boxes
    integer, parameter :: FED_PAR_PSMC_HS = -5 ! PSMC order parameter - difference in number of hard-sphere overlaps
    integer, parameter :: FED_PAR_ORDR2   = -4 ! Structure/order 2
    integer, parameter :: FED_PAR_ORDR1   = -3 ! Structure/order 1
    integer, parameter :: FED_PAR_DIST2   = -2 ! COM-distance 2
    integer, parameter :: FED_PAR_DIST1   = -1 ! COM-distance 1

    ! IDENTIFIERS for MANUALLY CONTROLLED order parameters (reaction coordinates)
    ! - a priory known/imposed within a range, or well-defined based on system macro-state
    integer, parameter :: FED_PAR_NONE  = 0 ! NO FED - NO PARAMETER
    integer, parameter :: FED_PAR_TEMP  = 1 ! Temperature
    integer, parameter :: FED_PAR_BETA  = 2 ! Beta = 1/(k_B*T)
    integer, parameter :: FED_PAR_LAMB  = 3 ! Kirkwood Lambda - Hamiltonian/coupling factor/scaling
    integer, parameter :: FED_PAR_VOLM  = 4 ! Volume
    integer, parameter :: FED_PAR_DENS  = 5 ! Density
    integer, parameter :: FED_PAR_NMOLS = 6 ! Total number of molecules in the system
    integer, parameter :: FED_PAR_LCS2  = 7 ! Liquid crystal scalar order parameter - 2nd order Legendre polynomial
    integer, parameter :: FED_PAR_LCS4  = 8 ! Liquid crystal scalar order parameter - 4th order Legendre polynomial
    integer, parameter :: FED_PAR_EXTRA = 9 ! Some other macro-state parameter - ???


!TU: IDENTIFIERS for MOLECULE ORIENTATION class

    integer, parameter :: ORIENTATION_NONE = 0 ! No orientation, e.g. for single-atom molecules
    integer, parameter :: ORIENTATION_LIN  = 1 ! Linear molecule: orientation completely determined by only one vector
    integer, parameter :: ORIENTATION_GEN  = 2 ! General molecule 

    
!TU: Atom type identifiers
        
    integer, parameter :: ATM_TYPE_CORE  = 1   ! "core"  / "c"
    integer, parameter :: ATM_TYPE_SEMI  = 2   ! "semi"  / "s"
    integer, parameter :: ATM_TYPE_METAL = 3   ! "metal" / "m"
    integer, parameter :: ATM_TYPE_SPIN  = 4   ! "spin"  / "p"

    
end module

! **********************************************************************
! **                   Nudged elastic band method                     **
! **********************************************************************
!!****h* coords/neb
!!
!! NAME
!! neb
!!
!! FUNCTION
!! Nudged Elastic band method
!!
!!
!! DATA
!! $Date$
!! $Rev$
!! $Author$
!! $URL$
!! $Id$
!!
!! COPYRIGHT
!!
!!  Copyright 2007 Johannes Kaestner (kaestner@theochem.uni-stuttgart.de),
!!  Tom Keal (thomas.keal@stfc.ac.uk)
!!
!!  This file is part of DL-FIND.
!!
!!  DL-FIND is free software: you can redistribute it and/or modify
!!  it under the terms of the GNU Lesser General Public License as 
!!  published by the Free Software Foundation, either version 3 of the 
!!  License, or (at your option) any later version.
!!
!!  DL-FIND is distributed in the hope that it will be useful,
!!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!!  GNU Lesser General Public License for more details.
!!
!!  You should have received a copy of the GNU Lesser General Public 
!!  License along with DL-FIND.  If not, see 
!!  <http://www.gnu.org/licenses/>.
!!
!! SYNOPSIS
module dlf_neb
  use dlf_parameter_module, only: rk
  type neb_type
    integer    :: nimage              ! total number of images
    integer    :: iimage              ! current image
    integer    :: varperimage         ! number of variables to be 
                                      !   optimised per image
    integer    :: coreperimage        ! number of variables in inner 
                                      !   microiterative region per image
    integer    :: step                ! number of iterations done
    integer    :: maximage            ! number of the image closest to 
                                      !   the climbing image
    integer    :: mode                ! 0: endpoints free, 
                                      ! 1: endpoints move perp. to tau
                                      ! 2: endpoints frozen
    real(rk)   :: k                   ! force constant
    logical    :: tclimb              ! a climbing images is used
    real(rk)   :: tolfreeze           ! gradient tolerance for freezing 
                                      !   images
    real(rk)   :: tolclimb            ! gradient tolerance for starting 
                                      !   climbing image process
    logical    :: allfrozen           ! all images but climbing image 
                                      !   are frozen
    real(rk),allocatable :: ene(:)    ! (nimage) energies of the images
    integer ,allocatable :: cstart(:) ! (nimage) start position of image
                                      !   coordinate array
    integer ,allocatable :: cend(:)   ! (nimage) end position of image 
                                      !   coordinate array

    ! needed for freezing windows
    logical              :: tfreeze   ! decide if windows to be frozen
    logical ,allocatable :: frozen(:) ! (nimage) image not recalculated 
                                      !   due to small gradient
    real(rk),allocatable :: gradt(:)  ! (nimage*varperimage) true 
                                      !   internal gradient
    real(rk),allocatable :: tau(:)    ! (nimage*varperimage) Tangent 
                                      !   vectors

    ! Cartesian coordinates of each image are required for HDLCs
    real(rk),allocatable :: xcoords(:,:) ! (3*glob%nat,nimage) Cartesian
                                      !  coordinates of each image
    logical              :: optcart   ! use internals only for initial 
                                      !   path, then Cartesians
  end type neb_type
  integer,parameter   :: unitp=1000 ! base unit for path xyz files
  logical,parameter   :: xyzall=.true. ! xyz files of all atoms or only active atoms?
  integer,parameter   :: maxxyzfile=300 ! larger than 9999 will require modification of file names
  type(neb_type),save :: neb
  real(rk)  :: beta_hbar,ene_ins_ext
  ! temp: using L-BFGS with a memory of only 2 converges reasonably well with the string method
  logical, parameter:: string=.false.
end module dlf_neb
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* neb/dlf_neb_init
!!
!! FUNCTION
!!
!! Initialise NEB calculations:
!! * allocate arrays concerning internal coordinates
!! * set default values for the calculation
!! * define the starting chain (call dlf_neb_definepath for that)
!!
!! SYNOPSIS
subroutine dlf_neb_init(nimage,icoord)
!! SOURCE
  use dlf_parameter_module, only: rk,ik
  use dlf_global, only: glob,stderr,stdout,printf,printl
  use dlf_neb, only: neb,unitp,xyzall,maxxyzfile
  use dlf_allocate, only: allocate,deallocate
  implicit none
  integer, intent(in)  :: nimage
  integer, intent(in)  :: icoord ! choice of NEB details
  integer              :: iimage,ivar,iat
  real(rk)             :: tolg
  character(20)        :: filename
  real(rk), allocatable :: tmpcoords(:,:)
  integer              :: useimage(nimage)
  integer              :: iarr3(3),nframe,iframe
! **********************************************************************
  neb%nimage=nimage
  neb%iimage=1
  neb%k=glob%nebk
  neb%step=0

  neb%tfreeze=.true.
  if(icoord==190) neb%tfreeze=.false.

  ! check nimage
  if(nimage<3) call dlf_fail("More than 2 images have to be used in NEB")

  ! check coords2
  if(.not.glob%tcoords2) then
    call dlf_fail("Second set of coordinates required for NEB!")
  end if

  iarr3=shape(glob%xcoords2)
  nframe=iarr3(3)
  if(nframe>nimage-2.and.icoord/=190) then
    nframe=nimage-2
    write(stdout,'("Warning: too many frames input in NEB. Only the &
        &first",i4," frames are used")') nframe
  end if
  if(nframe>nimage-1.and.icoord==190) then
    if(printl>=2) write(stdout,'("Warning: too may frames input in qTS. The middle &
        &",i4," frames will be removed")') nframe-nimage
    do ivar=nimage/2,nimage
      glob%xcoords2(:,:,ivar)=glob%xcoords2(:,:,ivar+nframe-nimage)
    end do
  end if

 ! set mode
  if( (icoord<100 .or. icoord>199))&
       call dlf_fail("Wrong icoord in NEB")
  neb%mode=(icoord-100)/10
  ! catch qTS
  if(neb%mode==9) neb%mode=0

  if(neb%mode>5) call dlf_fail("Mode in NEB has to be 0-5")
  neb%optcart=.false.
  if(neb%mode>2) then
    neb%optcart=.true.
    neb%mode=neb%mode-3
  end if

  ivar=mod(icoord,10)
  select case (ivar)
  ! Cartesian coordinates
  case (0)
    ! define the number of internal variables (covering all images)
    call dlf_direct_get_nivar(0, neb%varperimage)
    call dlf_direct_get_nivar(1, neb%coreperimage)

    ! calculate iweights
    call allocate( glob%iweight,neb%varperimage*nimage)
    ! first image
    ivar=1
    if(glob%tatoms) then
    do iat=1,glob%nat
      if(glob%spec(iat)>=0) then
        glob%iweight(ivar:ivar+2)=glob%weight(iat)
        ivar=ivar+3
      else if(glob%spec(iat)==-1) then
      else if(glob%spec(iat)>=-4) then
        glob%iweight(ivar:ivar+1)=glob%weight(iat)
        ivar=ivar+2
      else
        glob%iweight(ivar)=glob%weight(iat)
        ivar=ivar+1
      end if
    end do
    if(ivar-1/=neb%varperimage) then
      call dlf_fail("Error in Cartesian iweight calculation in NEB")
    end if
    ! copy weights to all other images
    do iimage=2,nimage
      ivar=neb%varperimage*(iimage-1)+1
      glob%iweight(ivar:ivar+neb%varperimage-1)=glob%iweight(1:neb%varperimage)
    end do
    else
      glob%iweight(:)=1.D0
    end if

  ! HDLC
  case(1:4)
    call dlf_hdlc_init(glob%nat,glob%spec,mod(glob%icoord,10),glob%ncons, &
        glob%icons,glob%nconn,glob%iconn)

    call dlf_hdlc_get_nivar(0, neb%varperimage)
    call dlf_hdlc_get_nivar(1, neb%coreperimage)

    ! create hdlc with start and endpoint as coordinates
    call allocate(tmpcoords,3,(1+nframe)*glob%nat)
    tmpcoords(:,1:glob%nat)=glob%xcoords(:,:)
    tmpcoords(:,glob%nat+1:(1+nframe)*glob%nat)= &
        reshape(glob%xcoords2(:,:,:),(/3,nframe*glob%nat/))
    call dlf_hdlc_create(glob%nat,neb%coreperimage,glob%spec,glob%micspec,&
        glob%znuc,1+nframe,tmpcoords,glob%weight,glob%mass)
    call deallocate(tmpcoords)

    ! calculate iweights
    call allocate( glob%iweight,neb%varperimage*nimage)
    ! first image
    call dlf_hdlc_getweight(glob%nat,neb%varperimage,neb%coreperimage,glob%micspec,&
         glob%weight,glob%iweight(1:neb%varperimage))
    ! copy weights to all other images
    do iimage=2,nimage
      ivar=neb%varperimage*(iimage-1)+1
      glob%iweight(ivar:ivar+neb%varperimage-1)=glob%iweight(1:neb%varperimage)
    end do


  case default
    write(stderr,'("Coordinate type ",i2," not supported in NEB")') icoord
  end select

  glob%nivar=neb%varperimage*nimage
  glob%nicore = neb%coreperimage * nimage

  call allocate( glob%icoords,glob%nivar)
  call allocate( glob%igradient,glob%nivar)
  call allocate( glob%step,glob%nivar) 
  call allocate( neb%ene,nimage)
  call allocate( neb%cstart,nimage)
  call allocate( neb%cend,nimage)
  ! strictly only necessary for HDLCs
  if(glob%tatoms) then
    call allocate( neb%xcoords,3*glob%nat,nimage)
  else
    call allocate( neb%xcoords,glob%nvar,nimage)
  end if

  call allocate(neb%frozen,nimage)
  neb%frozen(:)=.false.
  call allocate(neb%gradt,glob%nivar)
  call allocate(neb%tau,glob%nivar)

  ! set the positions of the images in the internal arrays
  do iimage=1,nimage
    neb%cstart(iimage)=(iimage-1)*neb%varperimage+1
    neb%cend(iimage)=neb%cstart(iimage)+neb%varperimage-1
  end do
  ! initialise energy array
  neb%ene(:) = 0.0d0

  ! ====================================================================
  ! Define the starting path: linear transit guess
  ! ====================================================================

  ! align the input coordinates to closest overlap
  useimage(:)=0
  useimage(1)=1
  if(glob%tatoms) then
    neb%xcoords(:,1)=reshape(glob%xcoords(:,:),(/3*glob%nat/))
    do iframe=1,min(nframe,nimage-1)
      if(glob%nat>1) call dlf_cartesian_align(glob%nat,glob%xcoords,glob%xcoords2(:,:,iframe))
      neb%xcoords(:,1+iframe)=reshape(glob%xcoords2(:,:,iframe),(/3*glob%nat/))
      useimage(1+iframe)=1
    end do
    
    if(icoord/=190) then
      ! future climbing image - coords for first image:
      neb%xcoords(:,nimage)=reshape(glob%xcoords(:,:),(/3*glob%nat/))
      ! set i- and x-coordinates of all images
      call dlf_neb_definepath(nimage,useimage)
      ! future climbing image again:
      neb%xcoords(:,nimage)=reshape(glob%xcoords(:,:),(/3*glob%nat/))
    else
      call dlf_qts_init() ! here only possible w/o alloc_tau
      if(glob%iopt/=12) call dlf_qts_definepath(nimage,useimage)
    end if
  else
    neb%xcoords(:,1)=reshape(glob%xcoords(:,:),(/glob%nvar/))
    do iframe=1,nframe
      neb%xcoords(:,1+iframe)=reshape(glob%xcoords2(:,:,iframe),(/glob%nvar/))
      useimage(1+iframe)=1
    end do
    
    neb%xcoords(:,nimage)=reshape(glob%xcoords(:,:),(/glob%nvar/))

    ! set i- and x-coordinates of all images
    call dlf_neb_definepath(nimage,useimage)

    neb%xcoords(:,nimage)=reshape(glob%xcoords(:,:),(/glob%nvar/))
  end if
  
  if(neb%optcart) then
    ! use the path guessed in internal coordinates, but optimise in
    ! Cartesians
    glob%icoord=glob%icoord-mod(glob%icoord,10)-30
    call dlf_direct_get_nivar(0, ivar)
    call dlf_hdlc_destroy
    write(stdout,"('Initial path set. Switching to Cartesian coordinates.')")
    if(ivar/=neb%varperimage) then
      neb%varperimage=ivar
      glob%nivar=neb%varperimage*nimage
      call deallocate( glob%icoords)
      call deallocate( glob%igradient)
      call deallocate( glob%step) 
      call deallocate( glob%iweight)
      call allocate( glob%icoords,glob%nivar)
      call allocate( glob%igradient,glob%nivar)
      call allocate( glob%step,glob%nivar) 
      call allocate( glob%iweight,glob%nivar)
      if(neb%tfreeze) then
        call deallocate(neb%gradt)
        call allocate(neb%gradt,glob%nivar)
        call deallocate(neb%tau)
        call allocate(neb%tau,glob%nivar)
      end if
      do iimage=1,nimage
        neb%cstart(iimage)=(iimage-1)*neb%varperimage+1
        neb%cend(iimage)=neb%cstart(iimage)+neb%varperimage-1
      end do

    end if ! (ivar/=neb%varperimage)

    ! calculate iweights
    ! first image
    ivar=1
    do iat=1,glob%nat
      if(glob%spec(iat)>=0) then
        glob%iweight(ivar:ivar+2)=glob%weight(iat)
        ivar=ivar+3
      else if(glob%spec(iat)==-1) then
      else if(glob%spec(iat)>=-4) then
        glob%iweight(ivar:ivar+1)=glob%weight(iat)
        ivar=ivar+2
      else
        glob%iweight(ivar)=glob%weight(iat)
        ivar=ivar+1
      end if
    end do
    if(ivar-1/=neb%varperimage) then
      call dlf_fail("Error in Cartesian iweight calculation in NEB")
    end if
    ! copy weights to all other images
    do iimage=2,nimage
      ivar=neb%varperimage*(iimage-1)+1
      glob%iweight(ivar:ivar+neb%varperimage-1)=glob%iweight(1:neb%varperimage)
    end do

  end if

  if(icoord==190) then
    ! set tau depending on the coordinates
    call qts_tau_from_path()
  end if

  ! set x-coordinates of the first image
  ! nothing to do ...
  neb%gradt(:)=0.D0
  glob%igradient(:)=0.D0

  ! open units for writing the path xyz files
  if(printf>=4) then
    do iimage=1,nimage
      if(iimage>maxxyzfile) exit
      if(iimage<10) then
        write(filename,'("000",i1)') iimage
      else if(iimage<100) then
        write(filename,'("00",i2)') iimage
      else if(iimage<1000) then
        write(filename,'("0",i3)') iimage
      else
        write(filename,'(i4)') iimage
      end if
      filename="neb_"//trim(adjustl(filename))//".xyz"
      if (glob%iam == 0) open(unit=unitp+iimage,file=filename)
    end do

    ! write initial xyz coordinates
    if (glob%iam == 0) then
      do iimage=1,nimage
        if(iimage>maxxyzfile) exit
        if(xyzall) then
          call write_xyz(unitp+iimage,glob%nat,glob%znuc,neb%xcoords(:,iimage))
        else
          call write_xyz_active(unitp+iimage,glob%nat,glob%znuc,glob%spec,neb%xcoords(:,iimage))
        end if
      end do
    end if
  end if

  ! initialise climbing image, freezing
  call convergence_get("TOLG",tolg)
  ! set freezing criterion
  neb%tolfreeze= glob%neb_freeze_test * tolg 
  neb%tolclimb=  glob%neb_climb_test * tolg 
  neb%tclimb=.false.
  if(icoord/=190) neb%frozen(neb%nimage)=.true.
  neb%allfrozen=.false.
  
  ! commented out so climbing image can be switched off altogether.
  ! TODO will need extra code to handle convergence/result in this case
  ! if(neb%tolclimb< neb%tolfreeze) neb%tolclimb=neb%tolfreeze

end subroutine dlf_neb_init
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* neb/dlf_neb_destroy
!!
!! FUNCTION
!!
!! deallocate arrays concerning internal coordinates
!!
!! SYNOPSIS
subroutine dlf_neb_destroy
!! SOURCE
  use dlf_parameter_module, only: rk,ik
  use dlf_global, only: glob,stderr,printf
  use dlf_neb, only: neb,unitp,maxxyzfile
  use dlf_allocate, only: deallocate
  implicit none
  integer :: iimage
! **********************************************************************

  if(glob%icoord==190) then
    call dlf_qts_destroy() 
  end if

 ! deallocate arrays
  if (allocated(glob%icoords)) call deallocate( glob%icoords)
  if (allocated(glob%igradient)) call deallocate( glob%igradient)
  if (allocated(glob%step)) call deallocate( glob%step)
  if (allocated(glob%iweight)) call deallocate( glob%iweight)
  if (allocated(neb%ene)) call deallocate(neb%ene)
  if (allocated(neb%cstart)) call deallocate(neb%cstart)
  if (allocated(neb%cend)) call deallocate(neb%cend)
  if (allocated(neb%xcoords)) call deallocate(neb%xcoords)

  if (allocated(neb%frozen)) call deallocate(neb%frozen)
  if (allocated(neb%gradt)) call deallocate(neb%gradt)
  if (allocated(neb%tau)) call deallocate(neb%tau)

  select case (mod(glob%icoord,10))
  ! HDLC
  case(1:4)
    call dlf_hdlc_destroy()
  end select

  ! close units for writing the path xyz files
  if(printf>=4 .and. glob%iam == 0) then
    do iimage=1,neb%nimage
      if(iimage>maxxyzfile) exit
      close(unit=unitp+iimage)
    end do
  end if

end subroutine dlf_neb_destroy
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* neb/dlf_neb_xtoi
!!
!! FUNCTION
!!
!! transform Cartesian coordinates into the NEB array
!!
!! This does not only SET the internal (NEB) coordinates, but also sets
!! the xcoords of the next image from neb%xcoords:
!! * First image : i-coordinates and gradient are set to x-coordinates 
!!   and gradient. x-coordinates are set to second image
!! * Nth image : i-coordinates and gradient are set to x-coordinates 
!!   and gradient. x-coordinates are set to N+1's image
!! * Last image : i-coordinates and gradient are set to x-coordinates 
!!   and gradient. Spring forces are added (calls 
!!   dlf_neb_improved_tangent_neb for that). trerun_energy=false
!!
!! SYNOPSIS
subroutine dlf_neb_xtoi(trerun_energy,external_iimage)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr,stdout,printf
  use dlf_neb, only: neb,unitp,xyzall,ene_ins_ext,maxxyzfile
  implicit none
  logical, intent(out)  :: trerun_energy
  integer, intent(out)  :: external_iimage ! Which image is the next to calculate
  integer               :: status ! For parallel NEB tested here
  integer               :: cstart,cend,jimage,iimage
  logical               :: tok
! **********************************************************************
  ! start and endpoint of current image in array icoords and igradient
  cstart=neb%cstart(neb%iimage)
  cend=neb%cend(neb%iimage)

  ! Parallel NEB: X->I transformation is potentially costly so parallelised
  if (glob%dotask) then
     call dlf_direct_xtoi(glob%nvar,neb%varperimage,neb%coreperimage,&
          glob%xcoords,glob%xgradient,glob%icoords(cstart:cend),&
          glob%igradient(cstart:cend))
     neb%ene(neb%iimage)=glob%energy

     ! store true gradient (to calculate the work even if this image is frozen)
     neb%gradt(cstart:cend)=glob%igradient(cstart:cend)
  else
     ! Explicitly set to zero to ensure that the allreduce at the end of the
     ! cycle gives the correct result
     glob%icoords(cstart:cend) = 0.d0
     glob%igradient(cstart:cend) = 0.d0
     neb%ene(neb%iimage) = 0.d0
     neb%gradt(cstart:cend) = 0.d0
  end if

  ! write xyz file
  if(printf>=4.and.glob%tatoms.and.neb%iimage<=maxxyzfile .and. glob%iam == 0) then
    if(xyzall) then
      call write_xyz(unitp+neb%iimage,glob%nat,glob%znuc,glob%xcoords(:,:))
    else
      call write_xyz_active(unitp+neb%iimage,glob%nat,glob%znuc,glob%spec,glob%xcoords(:,:))
    end if
  end if

  if(neb%iimage<neb%nimage) then

    neb%iimage=neb%iimage+1
    trerun_energy=.true.

    if(neb%tfreeze) then
      do jimage=neb%iimage,neb%nimage
        if(neb%frozen(jimage)) then
          ! icoords did not vary
          ! set gradient
          cstart=neb%cstart(jimage)
          cend=neb%cend(jimage)
          glob%igradient(cstart:cend)=0.D0
          neb%iimage=jimage

          ! Parallel NEB: this is to avoid multiple counting at the end
          if (.not. glob%dotask) then
             glob%icoords(cstart:cend) = 0.d0
             neb%ene(neb%iimage) = 0.d0
             neb%gradt(cstart:cend) = 0.d0           
          end if

          ! write xyz file
          ! coords i->x
          if(printf>=4.and.glob%tatoms.and.neb%iimage<=maxxyzfile) then
            glob%xcoords=reshape(neb%xcoords(:,jimage),(/3,glob%nat/))
            if (glob%iam == 0) then
               if(xyzall) then
                 call write_xyz(unitp+neb%iimage,glob%nat,glob%znuc,&
                                glob%xcoords(:,:))
               else
                 call write_xyz_active(unitp+neb%iimage,glob%nat,glob%znuc,&
                                       glob%spec,glob%xcoords(:,:))
               end if
            end if
          end if
          
        else
          neb%iimage=jimage
          exit
        end if
      end do
      if(neb%iimage==neb%nimage.and.neb%frozen(neb%iimage)) trerun_energy=.false.
    end if
    
    if(trerun_energy) then
      cstart=neb%cstart(neb%iimage)
      cend=neb%cend(neb%iimage)
      external_iimage=neb%iimage
      if(glob%tatoms) then
        glob%xcoords=reshape(neb%xcoords(:,neb%iimage),(/3,glob%nat/))
      else
        glob%xcoords=reshape(neb%xcoords(:,neb%iimage),(/1,glob%nvar/))
      end if
      !-------------
      return
      !-------------
    end if
  end if

  ! ====================================================================
  ! LAST IMAGE, ALL GRADIENTS ARE GATHERED
  ! ====================================================================

  ! Parallel NEB: check no gradient evaluations in other workgroups failed
  ! and make all coordinates and gradients available to all workgroups
  if (glob%ntasks > 1) then
    ! If it has reached here all gradients have succeeded in this workgroup
    status = 0
    call dlf_tasks_int_sum(status, 1)
    if (status > 0) then
      call dlf_fail("Task-farmed gradient evaluations failed")
    end if
    if (glob%serial_cycle == 0) then
      call dlf_tasks_real_sum(glob%icoords, glob%nivar)
      call dlf_tasks_real_sum(glob%igradient, glob%nivar)
      call dlf_tasks_real_sum(neb%ene, neb%nimage)
      call dlf_tasks_real_sum(neb%gradt, glob%nivar)
    end if
  end if
  
  if(glob%icoord==190) then

    ! freeze boundary points
    if(neb%tfreeze) then
      neb%frozen(1)=.true.
      glob%igradient(neb%cstart(1):neb%cend(1))=0.D0
      neb%frozen(neb%nimage)=.true.
      glob%igradient(neb%cstart(neb%nimage):neb%cend(neb%nimage))=0.D0
    end if

    if(glob%iopt/=12) then
       tok=.true.
       call dlf_qts_trans_force(trerun_energy,tok)
       ! tok always returns true for the time being ...

       if(.not.tok) then
          call  dlf_fail("No quantum transition state could be found")
       end if

!!$    tok=.true.
!!$    call dlf_qts_r(trerun_energy,tok)
!!$
!!$    if(.not.tok) then
!!$      call  dlf_fail("No quantum transition state could be found")

    end if
    
    if(trerun_energy) then
      ! run all E&G calculations once more
      ! after dlf_qts_trans_force, icoords are set, but not neb%xcoords
      ! this loop is not parallelized yet - IMPROVE (but dimer should not be used anyway...)
      do iimage=1,neb%nimage
        cstart=neb%cstart(iimage)
        cend=neb%cend(iimage)
        call dlf_direct_itox(glob%nvar,neb%varperimage,neb%coreperimage, &
            glob%icoords(cstart:cend),neb%xcoords(:,iimage),tok)

        if(.not.tok) then
          ! This should never happen, as qTS can only be used in mass-weighted
          ! cartesians
          call dlf_fail("Error in i->x coordinate conversion after qTS")
        end if

      end do

      ! set counter to first image
      neb%iimage=1
      glob%xcoords=reshape(neb%xcoords(:,neb%iimage),(/3,glob%nat/))
      external_iimage=neb%iimage
    end if

  else !(icoord==190)

     if (glob%imicroiter < 2) then
        ! Standard NEB or macroiterative step

        ! For convergence testing when there is no climbing image,
        ! set global energy to the energy of the highest image
        glob%energy = neb%ene(1)
        do jimage=2, neb%nimage-1
           if (neb%ene(jimage) > glob%energy) glob%energy = neb%ene(jimage)
        end do
    
        call dlf_neb_improved_tangent_neb
     else
        ! Microiterative step
        ! There are no spring forces in environment region, so 
        ! simply use the true gradient set above
        ! (with frozen images set to 0 as above).
        
        ! For convergence testing in the microiterative cycles,
        ! take the average of all energy images
        glob%energy = 0.0d0
        do jimage = 1, neb%nimage
           glob%energy = glob%energy + neb%ene(jimage)
        end do
        glob%energy = glob%energy / neb%nimage
     end if

     trerun_energy=.false.

  end if
  
  ! this is not used, as no image is calculated until neb_itox is called
  external_iimage=1 

end subroutine dlf_neb_xtoi
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* neb/dlf_neb_improved_tangent_neb
!!
!! FUNCTION
!!
!! transform the forces according to the 
!! IMPROVED-TANGENT NUDGED ELASTIC BAND by
!! G. Henkelman and H. Jonsson J. Chem. Phys. 113, 9978 (2000)
!! including a climbing image as an additional image once the maximum
!! perpendicular gradient is below tolclimb
!!
!! SYNOPSIS
subroutine dlf_neb_improved_tangent_neb
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr,stdout,pi,printl,printf
  use dlf_neb, only: neb,unitp,xyzall,string
  implicit none
  integer               :: cstart,cend
  integer               :: iimage,jimage,ivar
  logical,parameter     :: dbg=.false.
  real(rk)              :: emin,emax,svar,svar2
  logical               :: tclimbnext,tchk
  ! bookkeeping
  character(20)         :: str
  real(rk)              :: ftan(neb%nimage) ! tangential force
  real(rk)              :: fper(neb%nimage) ! perpendicular force
  real(rk)              :: path(neb%varperimage,neb%nimage) ! path(:,2)
                                            ! is the vector img2->img3
                                            ! including weights
  real(rk)              :: dist(neb%nimage) ! distance between images
  real(rk)              :: ang(neb%nimage)  ! angles between image-connections
  real(rk)              :: ang13(neb%nimage)! angles between further image-connections
  real(rk)              :: dwork(neb%nimage)! Delta work (grad x path) from 
                                            ! last to present image
  real(rk)              :: delta(neb%nimage)
  logical               :: tmass
  integer               :: iat
! **********************************************************************
  
  neb%step=neb%step+1

  if(neb%tfreeze) then
    neb%frozen(1:neb%nimage-1)=.false.
  end if

  ftan(:)=0.D0
  fper(:)=0.D0
  ang(:)=0.D0
  ang13(:)=0.D0
  dwork(:)=0.D0
  dist(:)=0.D0
  path(:,:)=0.D0

  ! ====================================================================
  ! Calculate distances and angles
  ! ====================================================================
  ! path, dist, and work
  do iimage=1,neb%nimage-1

    cstart=neb%cstart(iimage)
    cend=neb%cend(iimage) 

    if(iimage<neb%nimage-1) then
      path(:,iimage)= (glob%icoords(cstart+neb%varperimage:cend+neb%varperimage)- &
          glob%icoords(cstart:cend)) * glob%iweight(1:neb%varperimage)
      dist(iimage)=dsqrt(sum(path(:,iimage)**2))
      dwork(iimage+1)=sum( (neb%gradt(cstart:cend)+ &
            neb%gradt(cstart+neb%varperimage:cend+neb%varperimage)) * &
          path(:,iimage) ) * 0.5D0
    else
      dist(iimage)=0.D0
    end if
  end do

  !angles
  do iimage=2,neb%nimage-2
    cstart=neb%cstart(iimage)
    cend=neb%cend(iimage) 
    svar=sum(path(:,iimage-1) * path(:,iimage)) / (dist(iimage-1) * &
        dist(iimage))
    if(svar>=1.D0) then
      ang(iimage)=0.D0
    else
      ang(iimage)=acos(svar)
    end if
    
    if(iimage<neb%nimage-2) then
      svar=sum(path(:,iimage-1) * path(:,iimage+1)) / (dist(iimage-1) * &
          dist(iimage+1))
      if(svar>=1.D0) then
        ang13(iimage)=0.D0
      else
        ang13(iimage)=acos(svar)
      end if
    end if
  end do

  ! ==================================================================
  ! Calculate the tangent vector tau
  ! ==================================================================
  if(1==2.and.string) then
    call string_get_tau
  else
  do iimage=1,neb%nimage-1
    cstart=neb%cstart(iimage)
    cend=neb%cend(iimage) 

    if(iimage==1) then
      ! Tau+
      neb%tau(cstart:cend)=path(:,iimage)
    else if(iimage==neb%nimage-1) then
      ! Tau-
      neb%tau(cstart:cend)=path(:,iimage-1)
    else
      if(neb%ene(iimage+1)>neb%ene(iimage) .and. &
          neb%ene(iimage)>neb%ene(iimage-1)) then
        ! Tau+
        neb%tau(cstart:cend)=path(:,iimage)
        if(dbg) print*,"Image",iimage," Tau+"
      else if(neb%ene(iimage+1)<neb%ene(iimage) .and. &
          neb%ene(iimage)<neb%ene(iimage-1)) then
        ! Tau-
        neb%tau(cstart:cend)=path(:,iimage-1)
        if(dbg) print*,"Image",iimage," Tau-"
      else
        
        if(dbg) print*,"Image",iimage," Tau+-"
        ! iimage is either a minimum or a maximum
        emin=min(abs(neb%ene(iimage+1)-neb%ene(iimage)), &
            abs(neb%ene(iimage-1)-neb%ene(iimage)))
        emax=max(abs(neb%ene(iimage+1)-neb%ene(iimage)), &
            abs(neb%ene(iimage-1)-neb%ene(iimage)))
        if(neb%ene(iimage+1)<neb%ene(iimage-1)) then
          ! interchange them
          svar=emin
          emin=emax
          emax=svar
        end if

        ! catch the erratic case emin=emax=0
        if(emin==emax.and.emin==0.D0) then
          emin=1.D0
          emax=1.D0
        end if

        neb%tau(cstart:cend)=emax*path(:,iimage) + emin*path(:,iimage-1)

      end if
    end if
    ! improve - blas
    neb%tau(cstart:cend)=neb%tau(cstart:cend)/sqrt(sum(neb%tau(cstart:cend)**2))
  end do
  end if

  ! ====================================================================
  ! Calculate tangent vector of the climbing image
  ! ====================================================================
  if(neb%maximage>0) then
    cstart=neb%cstart(neb%nimage)
    cend=neb%cend(neb%nimage) 
    ! find image that is closest to the climbing image
    ivar=-1    ! in the end: number of closest image
    jimage=-1  ! in the end: number of 2nd-closest image
    emax=1.D90 ! in the end: distance CI -- closest
    svar=1.D90 ! in the end: distance CI -- 2nd-closest
    do iimage=1,neb%nimage-1
      ! should this be weighted ??
      svar2=sum((glob%icoords(cstart:cend)-glob%icoords( &
          neb%cstart(iimage):neb%cend(iimage)))**2)
      if(svar2<emax) then
        ! 2nd closest
        jimage=ivar
        svar=emax
        ! closest
        ivar=iimage
        emax=svar2
      else if (svar2<svar) then
        ! 2nd closest
        jimage=iimage
        svar=svar2        
      end if
    end do
    neb%maximage=ivar

    ! take weighted average of the two tau (weight is the distance of the other image)
    neb%tau(cstart:cend)= &
        svar*neb%tau(neb%cstart(ivar):neb%cend(ivar)) + &
        emax*neb%tau(neb%cstart(jimage):neb%cend(jimage))
    neb%tau(cstart:cend)=neb%tau(cstart:cend)/sqrt(sum(neb%tau(cstart:cend)**2))

    dist(neb%nimage)=dsqrt(emax)

    if(printl>=2) then
      write(stdout,'("Climbing image in cycle ",i7," is closest to &
          &image ",i4," (next: ",i4,")")') &
          neb%step,neb%maximage,jimage
    end if
    if(printl>=4) write(stdout,'("Distance to 2nd closest image is",f10.5)') sqrt(svar)

  else

    if(printl>=2) then
      write(stdout,'("No climbing image used in cycle ",i7)') neb%step
    end if

  end if

  ! ====================================================================
  ! Calculate the Forces
  ! ====================================================================
  tclimbnext=.true.
  do iimage=2, neb%nimage-2

    cstart=neb%cstart(iimage)
    cend=neb%cend(iimage) 

    ! make sure frozen images can be unfrozen if required
    glob%igradient(cstart:cend)=neb%gradt(cstart:cend)

    ! ================================================================
    ! project out the parallel component of the true force
    ! ================================================================
    ! improve - blas
    if(dbg) print*,"Image",iimage,"F_t||=",sum(glob%igradient(cstart:cend)*neb%tau(cstart:cend))
    glob%igradient(cstart:cend)=glob%igradient(cstart:cend)- &
        sum(glob%igradient(cstart:cend)*neb%tau(cstart:cend))*neb%tau(cstart:cend)
    fper(iimage)=dsqrt(sum((glob%igradient(cstart:cend))**2)/dble(neb%varperimage))

    if((.not.neb%tclimb).and.maxval(abs(glob%igradient(cstart:cend))) > &
        neb%tolclimb) then
      tclimbnext=.false.
    end if

    ! ==================================================================
    ! decide on freezing
    ! ==================================================================
    ! this is now done on the unweighted gradient. Is this a good idea?
    if(neb%tfreeze.and.maxval(abs(glob%igradient(cstart:cend)))<=neb%tolfreeze) then
      neb%frozen(iimage)=.true.
      glob%igradient(cstart:cend)=0.D0
    else

      ! ================================================================
      ! add the parallel component of the spring force
      ! ================================================================

      if(.not.string) then
        glob%igradient(cstart:cend)=glob%igradient(cstart:cend)+ &
            neb%k*(dist(iimage-1)-dist(iimage))*neb%tau(cstart:cend)
      end if

    end if
    ftan(iimage)=neb%k*(dist(iimage-1)-dist(iimage))
    if(string) ftan(iimage)=0.D0

  end do
  
  ! ==================================================================
  ! string method: add step(s) for L-BFGS to learn
  ! ==================================================================
  !delta=0.00001D0
!!$  call random_number(delta)
!!$  delta=(delta-0.5D0)*0.01D0
!!$  print*,"delta",delta
!!$  if(string.and.1==1) then
!!$     do iimage=2, neb%nimage-2
!!$        cstart=neb%cstart(iimage)
!!$        cend=neb%cend(iimage) 
!!$        ! move this image
!!$        glob%icoords(cstart:cend)=glob%icoords(cstart:cend)    +delta*neb%tau(cstart:cend)
!!$        glob%igradient(cstart:cend)=glob%igradient(cstart:cend)+delta*2.D0*neb%k*neb%tau(cstart:cend)
!!$        jimage=iimage-1
!!$        cstart=neb%cstart(jimage)
!!$        cend=neb%cend(jimage) 
!!$        glob%igradient(cstart:cend)=glob%igradient(cstart:cend)-delta*neb%k*neb%tau(cstart:cend)
!!$        jimage=iimage+1
!!$        cstart=neb%cstart(jimage)
!!$        cend=neb%cend(jimage) 
!!$        glob%igradient(cstart:cend)=glob%igradient(cstart:cend)-delta*neb%k*neb%tau(cstart:cend)
!!$     end do
!!$     call dlf_lbfgs_step(glob%icoord,glob%igradient,glob%step)
!!$     do iimage=2, neb%nimage-2
!!$        cstart=neb%cstart(iimage)
!!$        cend=neb%cend(iimage) 
!!$        ! move this image back
!!$        glob%icoords(cstart:cend)=glob%icoords(cstart:cend)    -delta*neb%tau(cstart:cend)
!!$        glob%igradient(cstart:cend)=glob%igradient(cstart:cend)-delta*2.D0*neb%k*neb%tau(cstart:cend)
!!$        jimage=iimage-1
!!$        cstart=neb%cstart(jimage)
!!$        cend=neb%cend(jimage) 
!!$        glob%igradient(cstart:cend)=glob%igradient(cstart:cend)+delta*neb%k*neb%tau(cstart:cend)
!!$        jimage=iimage+1
!!$        cstart=neb%cstart(jimage)
!!$        cend=neb%cend(jimage) 
!!$        glob%igradient(cstart:cend)=glob%igradient(cstart:cend)+delta*neb%k*neb%tau(cstart:cend)
!!$     end do
!!$  end if

  ! spawn a climbing image next cycle if all gradients are below neb%tolclimb
  if(tclimbnext) neb%tclimb=.true.

  if(neb%maximage>0) then
    ! ==================================================================
    ! climbing image
    ! ==================================================================
    iimage=neb%nimage
    cstart=neb%cstart(iimage)
    cend=neb%cend(iimage) 

    ! send information on energy, gradient, and step to convergence tester
    call convergence_set_info("of NEB climbing image",neb%varperimage,&
        neb%ene(iimage),glob%igradient(cstart:cend),glob%step(cstart:cend))
    
    
    ! send information to set_tsmode
    call dlf_formstep_set_tsmode(1,-1,neb%ene(iimage)) ! send energy
    call dlf_formstep_set_tsmode(glob%nvar,0,neb%xcoords(:,iimage)) ! TS-geometry
    call dlf_formstep_set_tsmode(neb%varperimage,11,neb%tau(cstart:cend)) ! TS-mode
    
    ! modify gradient
    ! improve - blas
    ftan(iimage)=sum(glob%igradient(cstart:cend)*neb%tau(cstart:cend))
    glob%igradient(cstart:cend)=glob%igradient(cstart:cend) - &
        2.D0 * ftan(iimage) * neb%tau(cstart:cend)
    fper(iimage)=sqrt(sum(( glob%igradient(cstart:cend)- &
        1.D0*ftan(iimage)*neb%tau(cstart:cend))**2)/dble(neb%varperimage))
  else
     ! No climbing image, so set approximate tsmode info using the highest
     ! energy image.
     ! Note the convergence info will be set in the main routine as usual
     ! using information from ALL images
     iimage = 1
     do jimage = 2, neb%nimage - 1
        if (neb%ene(jimage) > neb%ene(iimage)) iimage = jimage
     end do
     cstart = neb%cstart(iimage)
     cend = neb%cend(iimage)
     call dlf_formstep_set_tsmode(1,-1,neb%ene(iimage)) ! send energy
     call dlf_formstep_set_tsmode(glob%nvar,0,neb%xcoords(:,iimage)) ! TS-geometry
     call dlf_formstep_set_tsmode(neb%varperimage,11,neb%tau(cstart:cend)) ! TS-mode     
  end if

  ! ====================================================================
  ! check first and last image
  ! ====================================================================
  if(neb%mode==2) then
    if(.not.neb%tfreeze) call dlf_fail("NEB: mode=2 and tfreeze=false is invalid")
    neb%frozen(1)=.true.
    neb%frozen(neb%nimage-1)=.true.
    glob%igradient(neb%cstart(1):neb%cend(1))=0.D0
    glob%igradient(neb%cstart(neb%nimage-1):neb%cend(neb%nimage-1))=0.D0
  else 
    if (neb%mode==1) then
      ! first image
      cstart=neb%cstart(1)
      cend=neb%cend(1) 
      glob%igradient(cstart:cend)=glob%igradient(cstart:cend)- &
          sum(glob%igradient(cstart:cend)*neb%tau(cstart:cend))*neb%tau(cstart:cend)
      fper(1)=sqrt(sum(glob%igradient(cstart:cend)**2)/dble(neb%varperimage))

      ! last image
      cstart=neb%cstart(neb%nimage-1)
      cend=neb%cend(neb%nimage-1) 
      glob%igradient(cstart:cend)=glob%igradient(cstart:cend)- &
          sum(glob%igradient(cstart:cend)*neb%tau(cstart:cend))*neb%tau(cstart:cend)
      fper(neb%nimage-1)=sqrt(sum(glob%igradient(cstart:cend)**2)/dble(neb%varperimage))
    end if
    if(neb%mode==0) then
      cstart=neb%cstart(1)
      cend=neb%cend(1) 
      fper(1)=sqrt(sum(glob%igradient(cstart:cend)**2)/dble(neb%varperimage))
      cstart=neb%cstart(neb%nimage-1 )
      cend=neb%cend(neb%nimage-1 ) 
      fper(neb%nimage-1 )=sqrt(sum(glob%igradient(cstart:cend)**2)/dble(neb%varperimage))
    end if
    if(neb%tfreeze) then
      iimage=1
      cstart=neb%cstart(iimage)
      cend=neb%cend(iimage)
      if(maxval(abs(glob%igradient(cstart:cend)))<=neb%tolfreeze) then
        neb%frozen(iimage)=.true.
        glob%igradient(cstart:cend)=0.D0
      end if
      iimage=neb%nimage-1
      cstart=neb%cstart(iimage)
      cend=neb%cend(iimage)
      if(maxval(abs(glob%igradient(cstart:cend)))<=neb%tolfreeze) then
        neb%frozen(iimage)=.true.
        glob%igradient(cstart:cend)=0.D0
      end if
    end if
  end if

  ! ====================================================================
  ! check if all images (but the climbing image) are frozen
  ! ====================================================================
  if(neb%allfrozen) then
    cstart=neb%cstart(1)
    cend=neb%cend(neb%nimage-1)
    ! set complete gradient but frozen image to 0
    glob%igradient(cstart:cend)=0.D0 
  else
    tchk=.true.
    do iimage=1,neb%nimage-1
      if(.not.neb%frozen(iimage)) tchk=.false.
    end do
    if(tchk) then
      ! first time that all are frozen
      neb%allfrozen=.true.

      if(neb%frozen(neb%nimage)) then

        if(printl>=2) then
          write(stdout,"('All images are frozen and no climbing image &
              &exists.')")
          write(stdout,"('Either the climbing image threshold &
              &was not reached or the path is monotonic.')")
          write(stdout,"('Maximum gradient component converged to the frozen &
              &image tolerance of ',es10.4)") neb%tolfreeze
        end if

        ! set complete gradient to 0
        glob%igradient(:)=0.D0 
        glob%step(:)=0.D0 

        ! send information on energy, gradient, and step to convergence tester - 
        ! all set to zero
        call convergence_set_info("",neb%varperimage,&
            glob%oldenergy_conv,glob%igradient(cstart:cend),glob%step(cstart:cend))

      else
        if(printl>=2) write(stdout,"('All images but the climbing image are frozen')")
        
        if(neb%maximage<0) call dlf_fail("All images frozen and no climbing image present")
      
        cstart=neb%cstart(1)
        cend=neb%cend(neb%nimage-1)
        ! set complete gradient but frozen image to 0
        glob%igradient(cstart:cend)=0.D0 
        
        call dlf_formstep_restart
      end if
    end if
      
  end if

  ! ====================================================================
  ! write some report
  ! ====================================================================
  if(printl>=2) then
    write(stdout,"('NEB Report')")
    write(stdout,"('             Energy       F_tang    F_perp     Dist&
        &     Angle 1-3 Ang 1-2 Sum ')")
    do iimage=1,neb%nimage-1
      str=""
      !if(iimage<neb%nimage-2.and.iimage>1.and.&
      !    ang(iimage)+ang(iimage+1)>ang13(iimage)*1.2D0) &
      !    str="!"
      if(neb%frozen(iimage)) str=trim(str)//" frozen"
      !if(iimage==neb%maximage) str=trim(str)//" Climbing image"
      write(stdout,"('Img ',i4,f15.7,3f10.5,3f8.2,2x,a)") &
          iimage,neb%ene(iimage),ftan(iimage),fper(iimage),dist(iimage), &
          ang(iimage)*180.D0/pi,ang13(iimage)*180.D0/pi,&
          (ang(iimage)+ang(min(iimage+1,neb%nimage-1)))*180.D0/pi,str
    end do
    if(neb%maximage>0) then
      iimage=neb%nimage
      write(stdout,"('Cimg',i4,f15.7,3f10.5,3f8.2)") &
          neb%maximage,neb%ene(iimage),ftan(iimage),fper(iimage),dist(iimage), &
          ang(iimage)*180.D0/pi,ang13(iimage)*180.D0/pi,&
          (ang(iimage)+ang(min(iimage+1,neb%nimage-1)))*180.D0/pi
    end if
    write(stdout,"('Total path length ',f10.5)") sum(dist(1:neb%nimage-2))
  end if

  ! write information files
  if(printl>=2.and.printf>=2) then
    tmass=(neb%varperimage==glob%nat*3)
    ! list of energies (and work?)
    if (glob%iam == 0) then
      open(unit=501,file="nebinfo")
      if(tmass) then
        write(501,"('# Path length     Energy      Work       Effective Mass')")
      else
        write(501,"('# Path length     Energy      Work')")
      end if
    end if
    do iimage=1,neb%nimage-1
      if(iimage==1) then
        svar=0.D0
      else
        svar=sum(dist(1:iimage-1))
      end if
      if (glob%iam == 0) then
        if(tmass) then
          ! neb%tau is normalized tangent
          svar2=0.D0 ! reduced mass
          do iat=1,glob%nat
            svar2=svar2+sum((neb%tau(neb%cstart(iimage)+(iat-1)*3:&
                neb%cstart(iimage)+(iat-1)*3+2))**2)/glob%mass(iat)
          end do
          svar2=1.D0/svar2
          write(501,"(f10.5,3f15.10)") svar,neb%ene(iimage)-neb%ene(1),sum(dwork(1:iimage)),svar2
        else
          write(501,"(f10.5,2f15.10)") svar,neb%ene(iimage)-neb%ene(1),sum(dwork(1:iimage))
        end if
      end if
    end do
    if (glob%iam == 0) close(501)
    
    ! nebpath.xyz
    if (glob%iam == 0) open(unit=501,file="nebpath.xyz")
    do iimage=1,neb%nimage-1
      ! here, always write the whole system
      !if(xyzall) then
      if (glob%iam == 0) call write_xyz(501,glob%nat,glob%znuc,&
                                        neb%xcoords(:,iimage))
      !else
      !  call write_xyz_active(501,glob%nat,glob%znuc,glob%spec,neb%xcoords(:,iimage))
      !end if
      ! write chemshell fragments as well (or any other format used by dlf_put_coords)
      svar=neb%ene(iimage)
      ! The commented out line ensured that the final energy given to chemshell
      ! was that of the climbing image. A better solution is not to save the energy
      ! in put_coords if the mode < 0
      ! if(neb%maximage>0) svar=neb%ene(neb%nimage)
      call dlf_put_coords(glob%nat,-iimage,svar,neb%xcoords(:,iimage),glob%iam)
    end do
    if (glob%iam == 0) close(501)
  end if

end subroutine dlf_neb_improved_tangent_neb
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* neb/dlf_neb_checkstep
!!
!! FUNCTION
!!
!! Set step of frozen images to zero
!!
!! In case of large angles between the images, it sets the images back 
!! to a line connecting the neighbouring images.
!!
!! SYNOPSIS
subroutine dlf_neb_checkstep
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stdout,pi
  use dlf_neb, only: neb,string
  implicit none
  integer               :: iimage,jimage,mimage
  real(rk)              :: svar,angle12(neb%nimage),angle13(neb%nimage)
  logical               :: treduce(neb%nimage)
! **********************************************************************
  !if(.not.neb%tfreeze) return
  do iimage=1,neb%nimage
    if(neb%frozen(iimage)) then
      glob%step(neb%cstart(iimage):neb%cend(iimage))=0.D0
    end if
  end do
  
  if(glob%icoord==190) return ! do nothing in case of qTS search

  if (glob%imicroiter == 2) return ! do not correct paths during microiterations

  ! calculate the angles:
  angle12(:)=0.D0
  angle13(:)=0.D0
  do iimage=2,neb%nimage-2
    call angle(iimage-1,iimage,iimage,iimage+1,angle12(iimage))
    if(iimage<neb%nimage-2) &
        call angle(iimage-1,iimage,iimage+1,iimage+2,angle13(iimage))
  end do
  treduce(:)=.false.
  do iimage=2,neb%nimage-2
    ! do not consider angles of images next to frozen endpoints
    if(neb%mode==2.and.iimage==2) cycle
    if(neb%mode==2.and.iimage==neb%nimage-2) cycle

    if(angle12(iimage) > 90.D0/180.D0*pi ) treduce(iimage)=.true.
  end do

!  if(.not.string) then ! it turned out not to be a good idea to reduce the images in string ...
  do iimage=2,neb%nimage-2
    if(.not.treduce(iimage)) cycle
    if(iimage==neb%maximage) cycle
    PRINT*,"-------- Path corrections -----------"
    do jimage=iimage+1,neb%nimage-2
      if(.not.treduce(jimage)) exit
      if(jimage==neb%maximage) exit
      treduce(jimage)=.false. ! will be covered now
    end do
    print*,"Resetting images",iimage," to ",jimage-1
    ! This does not appear to cause problems for microiterative opts
    ! (at least, no more than the problems it causes for standard opts)
    ! but keeping an eye on it...
    do mimage=iimage,jimage-1
      svar=dble(mimage - (iimage-1))/dble(jimage - (iimage-1))
      glob%step(neb%cstart(mimage):neb%cend(mimage))= &
          (1.D0-svar) * (&
          glob%icoords(neb%cstart(iimage-1):neb%cend(iimage-1)) + &
          glob%step(neb%cstart(iimage-1):neb%cend(iimage-1)) ) + &
          svar * ( &
          glob%icoords(neb%cstart(jimage):neb%cend(jimage)) + &
          glob%step(neb%cstart(jimage):neb%cend(jimage))) &
          -glob%icoords(neb%cstart(mimage):neb%cend(mimage))
    end do
  END do
!  end if
  
  treduce(:)=.false.
  if(string.and.(.not.neb%allfrozen)) call string_reparametrise(treduce)

contains 

  subroutine angle(img1,img2,img3,img4,ang)
    implicit none
    integer,intent(in)     :: img1,img2,img3,img4
    real(rk),intent(out)   :: ang
    real(rk)               :: svar
    integer                :: img,iarr(4)
    real(rk)               :: path(neb%varperimage,2)
  ! ********************************************************************
    iarr(:)=(/img1,img2,img3,img4/)
    do img=2,4,2
      path(:,img/2)=(glob%icoords(neb%cstart(iarr(img)):neb%cend(iarr(img))) + &
                     glob%step   (neb%cstart(iarr(img)):neb%cend(iarr(img))) - &
                     glob%icoords(neb%cstart(iarr(img-1)):neb%cend(iarr(img-1))) - &
                     glob%step   (neb%cstart(iarr(img-1)):neb%cend(iarr(img-1))) ) * &
                     glob%iweight(1:neb%varperimage)
    end do
    svar=sum(path(:,1)*path(:,2))/dsqrt(sum(path(:,1)**2)) &
        / dsqrt(sum(path(:,2)**2))
    if(svar>=1.D0) then
      ang=0.D0
    else
      ang=acos(svar)
    end if
  end subroutine angle

end subroutine dlf_neb_checkstep
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* neb/dlf_neb_itox
!!
!! FUNCTION
!!
!! transform NEB array to Cartesian coordinates
!!
!! All images will be transformed to xyz coordinates here. If 
!! unsuccessful the algorithm will fall back to Cartesian coordinates.
!! This however, will end the usage of constraints!
!!
!! Initiate the climbing image if required
!!
!! SYNOPSIS
subroutine dlf_neb_itox(external_iimage)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stdout,printf,printl
  use dlf_allocate, only: allocate,deallocate
  use dlf_neb, only: neb,unitp,xyzall,maxxyzfile
  implicit none
  integer ,intent(out)  :: external_iimage
  integer               :: cstart,cend,iimage,mx(1),ivar
  logical               :: tok,tfail
  real(rk), allocatable :: xtmp(:,:)
  integer , allocatable :: useimage(:)
  real(rk)              :: svar,svar2
! **********************************************************************

  ! ====================================================================
  ! Determine the initial position of the climbing image
  ! ====================================================================
  if(neb%tclimb .and. neb%frozen(neb%nimage) .and. glob%imicroiter < 2) then
    ! initialise climbing image
    mx=maxloc(neb%ene(2:neb%nimage-2))
    ivar=mx(1)+1 ! maximum image

    cstart=neb%cstart(neb%nimage)
    cend=neb%cend(neb%nimage) 

    ! make sure no climbing image is spawned if there is no maximum on the path
    if(ivar==2 .and. neb%ene(1)>neb%ene(ivar)) neb%tclimb=.false.
    if(ivar==neb%nimage-2 .and. neb%ene(neb%nimage-1)>neb%ene(ivar)) neb%tclimb=.false.

    if(neb%tclimb) then

      if(printl>=4) write(stdout,'("Spawning climbing image")')

      !Comment: The climbing image is set according to the energies before the 
      !         step but the geometry after the step. This may lead to 
      !         difficulties if the step is large.
      
      ! interpolate maximum from nearby 3 images
      svar=(-(neb%ene(ivar-1)-neb%ene(ivar))-(neb%ene(ivar+1)-neb%ene(ivar)))/(-2.D0)
      if(svar>0.d0) then
        ! the parabola through the three points has a minimum, no maximum.
        ! In this case, use the geometry of ivar as initial climbing image
        glob%icoords(cstart:cend)=glob%icoords(neb%cstart(ivar):neb%cend(ivar))
        glob%xcoords(:,neb%nimage)=glob%xcoords(:,ivar)
        if(printl>=4) write(stdout,'("Initial climbing image is identical&
            & to image",i4)') ivar
      else
        svar2=(neb%ene(ivar+1)-neb%ene(ivar-1))/2.D0 - 2.D0*svar
        svar=-svar2/(2.D0*svar)
        
        if(svar>1.D0) then
          ! interpolate between images ivar and ivar+1
          glob%icoords(cstart:cend)= &
              (2.D0-svar) * glob%icoords(neb%cstart(ivar):neb%cend(ivar)) + &
              (svar-1.D0) * glob%icoords(neb%cstart(ivar+1):neb%cend(ivar+1))
          neb%xcoords(:,neb%nimage)= &
              (2.D0-svar) * neb%xcoords(:,ivar) + &
              (svar-1.D0) * neb%xcoords(:,ivar+1)
          if(printl>=4) write(stdout,'("Initial climbing image is ",f5.1,"% of&
              & image ",i4," and ",f5.1,"% of image ",i4)') (2.D0-svar)*100.D0,&
              ivar,(svar-1.D0)*100.D0,ivar+1
        else
          ! interpolate between images ivar-1 and ivar
          glob%icoords(cstart:cend)= &
              (1.D0-svar) * glob%icoords(neb%cstart(ivar-1):neb%cend(ivar-1)) + &
              svar * glob%icoords(neb%cstart(ivar):neb%cend(ivar))
          neb%xcoords(:,neb%nimage)= &
              (1.D0-svar) * neb%xcoords(:,ivar-1) + &
              svar * neb%xcoords(:,ivar)
          if(printl>=4) write(stdout,'("Initial climbing image is ",f5.1,"% of&
              & image ",i4," and ",f5.1,"% of image ",i4)') (1.D0-svar)*100.D0,&
              ivar-1,svar*100.D0,ivar
        end if
      end if ! (svar>0.d0)
      call dlf_formstep_restart
      neb%frozen(neb%nimage)=.false.
      neb%maximage=ivar
    else
      if(printl>=4) write(stdout,'("No climbing image spawned because the energy &
          &maximum is an endpoint of the path")')
    end if !(neb%tclimb) 
  end if ! (neb%tclimb .and. neb%frozen(neb%nimage))
  if(neb%iimage/=neb%nimage) print*,"Warning, NEB images have been tampered with!"

  if (glob%tatoms) then
     call allocate( xtmp,3*glob%nat,neb%nimage)
  else
     call allocate( xtmp,glob%nvar,neb%nimage)
  end if
  tfail=.false.
  xtmp(:,:)=neb%xcoords(:,:) ! starting guess and frozen structures
  do iimage=1,neb%nimage
    if(neb%tfreeze) then
      if(neb%frozen(iimage)) cycle
    end if
    cstart=neb%cstart(iimage)
    cend=neb%cend(iimage)
    call dlf_direct_itox(glob%nvar,neb%varperimage,neb%coreperimage, &
      glob%icoords(cstart:cend),xtmp(:,iimage),tok)
    if(.not.tok) then
      tfail=.true.
      exit
    end if
  end do
  if(tfail) then
    ! reset and restart
    call allocate(useimage,neb%nimage)
    useimage(:)=1
    if(printl>=2) write(stdout, &
        "('HDLC coordinate breakdown. Recalculating HDLCs and &
        &restarting optimiser and NEB.')")
    call dlf_hdlc_reset
    call dlf_hdlc_create(glob%nat,neb%coreperimage,glob%spec,glob%micspec,&
        glob%znuc,neb%nimage,neb%xcoords,glob%weight,glob%mass)

    ! calculate iweights
    ! first image
    call dlf_hdlc_getweight(glob%nat,glob%nivar,neb%coreperimage,glob%micspec,&
        glob%weight,glob%iweight(1:neb%varperimage))
    ! copy weights to all other images
    do iimage=2,neb%nimage
      ivar=neb%varperimage*(iimage-1)+1
      glob%iweight(ivar:ivar+neb%varperimage-1)=glob%iweight(1:neb%varperimage)
    end do

    call dlf_formstep_restart

    ! recalculate NEB images
    call dlf_neb_definepath(neb%nimage,useimage)    

    call deallocate(useimage)
  else
    ! all coordinate conversion were successful
    neb%xcoords(:,:)=xtmp
  end if
  call deallocate(xtmp)

  ! now all images are present in xcoords (neb%xcoords)

  ! find first non-frozen image to calculate the energy on
  if(neb%tfreeze) then
    do iimage=1,neb%nimage
      if(neb%frozen(iimage)) then
        cstart=neb%cstart(iimage)
        cend=neb%cend(iimage)
        glob%igradient(cstart:cend)=0.D0

        ! Parallel NEB: this is to avoid multiple counting at the end of xtoi
        if (glob%mytask /= 0) then
           glob%icoords(cstart:cend) = 0.d0
           neb%ene(iimage) = 0.d0
           neb%gradt(cstart:cend) = 0.d0           
        end if
        
        ! write xyz file
        if(printf>=4.and.glob%tatoms.and.neb%iimage<=maxxyzfile .and. glob%iam == 0) then
          if(xyzall) then
            call write_xyz(unitp+iimage,glob%nat,glob%znuc,neb%xcoords(:,iimage))
          else
            call write_xyz_active(unitp+iimage,glob%nat,glob%znuc,glob%spec,neb%xcoords(:,iimage))
          end if
        end if
      else
        neb%iimage=iimage
        exit
      end if
    end do
  else
    neb%iimage=1
  end if

  external_iimage=neb%iimage
  if(glob%tatoms) then
     glob%xcoords=reshape(neb%xcoords(:,neb%iimage),(/3,glob%nat/))
  else
     glob%xcoords=reshape(neb%xcoords(:,neb%iimage),(/1,glob%nvar/))
  end if

end subroutine dlf_neb_itox
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* neb/dlf_neb_definepath
!!
!! FUNCTION
!!
!! Define a NEB path in internal coordinates using input guesses or old
!! structures in x-coordinates
!!
!! useimage(iimage)=0 -> this image is interpolated, x-information is 
!! not used
!!
!! images are not reordered, the first image has to be "used", the 
!! later ones are uniformly distributed
!!
!! at the end, we have icoords and consistent xcoords - or an error termination
!!
!! INPUTS
!!
!! neb%xcoords glob%spec
!!
!!
!! OUTPUTS
!! 
!! glob%icoords
!!
!! SYNOPSIS
subroutine dlf_neb_definepath(nimage,useimage)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stdout,printl
  use dlf_allocate, only: allocate,deallocate
  use dlf_neb, only: neb,unitp
  implicit none
  integer ,intent(in)   :: nimage
  integer ,intent(inout):: useimage(nimage)
  integer               :: xok(nimage)
  integer               :: iimage,jimage,kimage,cstart,cend,lowok,ivar
  integer               :: maxuse,iat,nuse,map(nimage)
  real(rk)              :: svar,dist(nimage),lastdist
  logical               :: tok,tchk
! **********************************************************************
  glob%igradient=0.D0
  glob%icoords=0.D0
  dist(:)=0.D0 ! dist is a cumulative distance from the first image
  maxuse=1
  nuse=0 ! number of images to use to construct the path

  ! get internal coordinates of well-defined images
  lastdist=0.D0
  do iimage=1,nimage
    if(useimage(iimage)==0) cycle
    cstart=neb%cstart(iimage)
    cend=neb%cend(iimage)
    !print*," ((((((((((((((((((((( IMAGE",iimage," )))))))))))))))))))))))))))"
    call dlf_direct_xtoi(glob%nvar,neb%varperimage,neb%coreperimage,neb%xcoords(:,iimage), &
        glob%xgradient,glob%icoords(cstart:cend),glob%igradient(cstart:cend))
    ! distance to last used image
    if(iimage>1) then
      svar=sqrt(sum(( &
          glob%iweight(1:neb%varperimage)*( &
          glob%icoords(cstart:cend) - glob%icoords(neb%cstart(maxuse):neb%cend(maxuse))) &
          ) **2 ) ) 
      !svar=svar+sum(dist)
      dist(iimage)=svar+lastdist
      lastdist=dist(iimage)
    end if
    maxuse=iimage
    if(maxuse<nimage) nuse=nuse+1
  end do

  ! make sure only images 1 to nimage-1 are used to interpolate
  if(maxuse>=nimage) maxuse=nimage-1

  ! if all images are well-defined, return
  if(minval(useimage)==1) return

  if(dist(maxuse)<1.D-3) call dlf_fail("Start and endpoint too close in NEB")

  ! print alignment of images along the distance
  if(printl>=4) then
    write(stdout,'("Constructing initial NEB path from input images")')
    write(stdout,'("Length of the initial path: ",f10.5)') dist(maxuse)
    write(stdout,'("Using ",i3," input images to construct a path of ",&
        &i3," total images")') nuse,nimage-1
    lastdist=0.D0
    do iimage=1,maxuse
      if(useimage(iimage)==0) cycle
      write(stdout,'("Image ",i3," along path: ",f10.5," dist to prev. &
          &image:",f10.5)') iimage,dist(iimage),dist(iimage)-lastdist
      lastdist=dist(iimage)
    end do
  end if

  ! if all requested images are provided by the user, do not interpolate
  if(nuse/=nimage-1) then
    ! distribute defined images as equally as possible according to dist
    map(:)=0 ! map(iimage) is the number, iimage should have after distribution
    do iimage=maxuse,2,-1

      if(useimage(iimage)==0) cycle

      svar=1.D0+dist(iimage)/dist(maxuse)*dble(nimage-2)
      map(iimage)=nint(svar)
      !print*,"Image",iimage,"svar",svar,"map(iimage)",map(iimage)
      if(map(iimage)>=nimage) then
        call dlf_fail("Problem with image distribution in NEB.")
      end if
    end do

    ! assign images
    do iimage=maxuse,2,-1

      tok=.true.
      do jimage=maxuse,2,-1
        if(jimage==iimage) cycle
        if(map(jimage)==map(iimage)) tok=.false.
      end do
      if(.not.tok) then
        ! see if map(iimage)=iimage would be OK
        tok=.true.
        do jimage=maxuse,2,-1
          if(map(jimage)==iimage) tok=.false.
        end do
        if(tok) map(iimage)=iimage
      end if
      if(.not.tok) then
        ! Drop current image
        map(iimage)=0
        useimage(iimage)=0
        if(printl>=2) write(stdout,'("Dropping input image ",i3," because &
            &there are too may input images in this area")') iimage
        cycle
      end if

      ! swap images
      if(printl>=4) then
        write(stdout,'("Using input image",i4," as image",i4)') iimage,&
            map(iimage)
      end if

      if(map(iimage)==iimage) cycle

      ! move image
      ivar=map(iimage)
      ! move icoords
      glob%icoords(neb%cstart(ivar):neb%cend(ivar))= &
          glob%icoords(neb%cstart(iimage):neb%cend(iimage))
      ! move xcoords
      neb%xcoords(:,ivar)=neb%xcoords(:,iimage)
      ! move use info
      useimage(ivar)=1
      useimage(iimage)=0

    end do

  end if

  if(printl>=4) then
    do iimage=1,nimage-1
      if(useimage(iimage)==1) then
        write(stdout,'("Image",i3," is obtained from input")') iimage
      else
        write(stdout,'("Image",i3," is interpolated")') iimage
      end if
    end do
  end if

  ! linear transit between defined images
  if(useimage(1)==0) call dlf_fail("First image undefined in NEB")
  if(useimage(nimage-1)==0) call dlf_fail("Last image undefined in NEB")
  do iimage=1,nimage-1
    if(useimage(iimage)==0) cycle
    ! iimage is defined
    do jimage=iimage+1,nimage-1
      if(useimage(jimage)/=0) exit
    end do
    if(jimage==iimage+1) cycle
    ! interpolate from iimage to jimage
    do kimage=iimage+1,jimage-1
      cstart=neb%cstart(kimage)
      cend=neb%cend(kimage)
      svar=dble(kimage-iimage)/dble(jimage-iimage) ! 0..1
      glob%icoords(cstart:cend)= &
          (1.D0-svar)*glob%icoords( neb%cstart(iimage) : neb%cend(iimage) ) + &
          svar*glob%icoords( neb%cstart(jimage) : neb%cend(jimage) )
    end do
  end do
  ! now all icoords are defined

  ! find consistent xcoords
  xok=0
  xok(1)=1
  xok(nimage-1)=1
  !do iimage=2,nimage-2
  iimage=1
  do while (iimage<nimage-2)
    iimage=iimage+1
    cstart=neb%cstart(iimage)
    cend=neb%cend(iimage)
    ! try to convert internals back to Cartesians. These are rather large steps,
    ! thus the DLC converter may have difficulties. Catch them!
    ! First, guess the Cartesian coordinates from the previous image and 
    ! the next defined (used) image
    if(useimage(iimage)==0) then
      ! find the next "used" image
      do jimage=iimage+1,nimage-1
        if(useimage(jimage)/=0) exit
      end do
      svar=1.D0/dble(jimage-iimage+1)
      neb%xcoords(:,iimage)=(1.D0-svar)*neb%xcoords(:,iimage-1) &
          + svar*neb%xcoords(:,jimage)
    end if
    !print*," ((((((((((((((((((((( IMAGE",iimage," i->x )))))))))))))))))))))))))))"
    call dlf_direct_itox(glob%nvar,neb%varperimage,neb%coreperimage, &
        glob%icoords(cstart:cend),neb%xcoords(:,iimage),tok)
    if(tok) then
      xok(iimage)=1
    else
      !print*,"Failed at image ",iimage
      ! jump to next defined image
      iimage=jimage
    end if
  end do
  !print*,"JK Converted:",xok
  !print*,"iimage",iimage

  if(minval(xok(1:nimage-1))<1) then
    ! at least one image could not be converted. Try from last image back
!    lowok=iimage-1
    do iimage=nimage-2,2,-1
      if(xok(iimage)==1) cycle
      cstart=neb%cstart(iimage)
      cend=neb%cend(iimage)
      ! find the next defined image
      do jimage=iimage-1,2,-1
        if(xok(jimage)==1) exit
      end do
      svar=1.D0/dble(iimage-jimage+1)
      neb%xcoords(:,iimage)=(1.D0-svar)*neb%xcoords(:,iimage+1) &
          + svar*neb%xcoords(:,jimage)
      !print*," ((((((((((((((((((((( IMAGE",iimage," i->x back))))))))))))))))))))))))"
      call dlf_direct_itox(glob%nvar,neb%varperimage,neb%coreperimage, &
          glob%icoords(cstart:cend),neb%xcoords(:,iimage),tok)
      if(tok) then
        xok(iimage)=1
      else
        !print*,"Failed at image ",iimage
        exit
      end if
    end do
  end if

  if(minval(xok(1:nimage-1))<1) then
    write(stdout,"('Image conversion success: ',10i4)") xok
    call dlf_fail("Failed converting images to Cartesians")
  end if

  ! Set xcoords of frozen atoms of all images to those in image 1
  ! This may be improved by specifying a different image (TS?)
  IF(glob%tatoms) then
    do iimage=2,nimage-1
      do iat=1,glob%nat
        if(glob%spec(iat)/=-1) cycle
        ivar=3*(iat-1)+1
        neb%xcoords(ivar:ivar+2,iimage)=neb%xcoords(ivar:ivar+2,1)
      end do
    end do
  end IF

  ! Another test to see if the conversion works with the input created above
  do iimage=2,nimage-2
    cstart=neb%cstart(iimage)
    cend=neb%cend(iimage)
    call dlf_direct_itox(glob%nvar,neb%varperimage,neb%coreperimage, &
        glob%icoords(cstart:cend),neb%xcoords(:,iimage),tok)
    if(.not.tok) then
      !print*,"Failed at image ",iimage
      call dlf_fail("NEB internal image initialisation &
          &failed in final test.")
    end if
  end do

end subroutine dlf_neb_definepath
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* neb/string_get_tau
!!
!! FUNCTION
!!
!! Define the string path as bsplines and calculate the tangents
!!
!! INPUTS
!!
!! glob%icoords 
!!
!! OUTPUTS
!! 
!! neb%tau
!!
!! SYNOPSIS
subroutine string_get_tau
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stdout,printl
  use dlf_neb, only: neb,unitp
  use dlf_bspline, only: spline_init, spline_create, spline_get, &
      spline_destroy
  implicit none
  integer  :: ivar,iimage,cstart,cend
  real(rk) :: stringpos(neb%nimage-1) ! 0..1
  real(rk) :: stringval(neb%nimage-1), svar
! **********************************************************************
  call spline_init(neb%nimage-1,neb%varperimage)

  ! define x-values of the splines
  do iimage=1,neb%nimage-1
    stringpos(iimage)=dble(iimage-1)/dble(neb%nimage-2)
  end do

  do ivar=1,neb%varperimage

    ! define y-value of the spline
    do iimage=1,neb%nimage-1
      stringval(iimage)=glob%icoords(neb%cstart(iimage)+ivar-1)
    end do

    call spline_create(ivar,stringpos,stringval)

    ! get derivatives of the spline
    do iimage=1,neb%nimage-1
      call spline_get(ivar,stringpos(iimage),svar, &
          neb%tau(neb%cstart(iimage)+ivar-1),svar)
    end do
  end do

  call spline_destroy

  ! normalise tau
  do iimage=1,neb%nimage-1
    cstart=neb%cstart(iimage)
    cend=neb%cend(iimage) 
    neb%tau(cstart:cend)=neb%tau(cstart:cend)/sqrt(sum(neb%tau(cstart:cend)**2))
  end do

end subroutine string_get_tau
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* neb/string_reparametrise
!!
!! FUNCTION
!!
!! Reparametrise the string path: the input images (beads on the string)
!! are glob%icoords+glob%step. 
!! 
!! Modify glob%step to make them evenly distributed along the path
!!
!! The string is defined with equally-spaced alpha (ranging from 0 to 1)
!! but will have different spacing in i-coordinate space. Then, alpha 
!! values for equal i-coordinate spacing are calculated, and the step is
!! modified.
!!
!! INPUTS
!!
!! glob%icoords, glob%step
!!
!! OUTPUTS
!! 
!! glob%step
!!
!! SYNOPSIS
subroutine string_reparametrise(treduce)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stdout,printl
  use dlf_neb, only: neb,unitp
  use dlf_bspline, only: spline_init, spline_create, spline_get, &
      spline_destroy
  use dlf_stat ! REMOVE JK
  implicit none
  logical,intent(in) :: treduce(neb%nimage)
  integer  :: ivar,iimage,cstart,cend
  real(rk) :: stringpos(neb%nimage-1) ! 0..1
  real(rk) :: stringval(neb%nimage-1), svar
  integer, parameter :: npoint=300 ! number of points interpolated
  real(rk) :: length(npoint) ! length of the string up to that point
  real(rk) :: energy(npoint) ! energy of the string (interpolated)
  real(rk) :: length_img(neb%nimage-1) ! ength of the string up to that
                                       ! image
  integer  :: ipoint,low,high,jimage,count
  real(rk) :: step,alpha,yvar,yvar2,dyvar,new_length,ene
  integer :: step_print
  real(rk):: svar2
  real(rk) :: tmp_step(glob%nivar),tmp_grad(glob%nivar),tmp_tau(neb%varperimage)
! **********************************************************************
  step_print=40

  if(printl>=4) write(stdout,'(a)') "Reparametrising string"

  count=0
  do iimage=1,neb%nimage-1
    if(.not.treduce(iimage)) then
      count=count+1
    else
      write(*,'("Image",i4," is reset to string")') iimage
    end if
  end do
  print*,"Number of images considered for the string:",count

!  call spline_init(neb%nimage-1,neb%varperimage)
!  call spline_init(count,neb%varperimage)
  call spline_init(count,neb%varperimage+1)

  ! define x-values of the splines - equally spaced
  count=0
  do iimage=1,neb%nimage-1
    if(.not.treduce(iimage)) then
      count=count+1
      stringpos(count)=dble(iimage-1)/dble(neb%nimage-2)
    end if
  end do

  do ivar=1,neb%varperimage+1

    ! define y-value of the spline: coordinates and energy
    count=0
    do iimage=1,neb%nimage-1
      if(.not.treduce(iimage)) then
        count=count+1
        if(ivar<=neb%varperimage) then
          stringval(count)=glob%icoords(neb%cstart(iimage)+ivar-1) + &
              glob%step(neb%cstart(iimage)+ivar-1)
        else
          stringval(count)=neb%ene(iimage)
        end if
      end if
    end do

    call spline_create(ivar,stringpos,stringval)

  end do

  ! energy
  do ipoint=1,npoint
    alpha=dble(ipoint-1)/dble(npoint-1)
    call spline_get(neb%varperimage+1,alpha,energy(ipoint),dyvar,svar)
 !   print*,ipoint,energy(ipoint)
  end do


  ! calculate the length of the string (arc length)
  length(1)=0.D0
  step=1.D0/dble(npoint-1)
  do ipoint=2,npoint
    length(ipoint)=0.D0
    alpha=dble(ipoint-1)/dble(npoint-1)
    do ivar=1,neb%varperimage
      call spline_get(ivar,alpha,yvar,dyvar,svar)
      call spline_get(ivar,alpha-step,yvar2,dyvar,svar)
      length(ipoint)=length(ipoint)+(yvar2-yvar)**2
    end do
    ene=0.5D0*(energy(ipoint)+energy(ipoint-1))-minval(energy)
    ene=ene/(maxval(energy)-minval(energy)) ! 0..1
    svar=0.0D0 ! energy weighting parameter 0=no weighting
    length(ipoint)=length(ipoint-1)+dsqrt(length(ipoint)) * &
        ! weighting
        (1.D0-svar+ene*2.D0*svar)

!    length(ipoint)=length(ipoint-1)+dsqrt(length(ipoint))
  end do

  if(printl>=4) write(stdout,'("Length of the string ",f10.5)') &
      length(npoint)

  ! calculate current positions of the images along the string
  ! only important for frozen images - will be wrong for reduced ones
  length_img(:)=0.D0
  do iimage=1,neb%nimage-1
    ! int rounds to the lower value
    ipoint=int(dble(iimage-1)/dble(neb%nimage-2)*dble(npoint-1))+1  ! point left of the image
    svar=dble(iimage-1)/dble(neb%nimage-2)*dble(npoint-1)-dble(ipoint-1)
    if(ipoint==npoint) then
      length_img(iimage)=length(npoint)
    else
      length_img(iimage)=(1.d0-svar)*length(ipoint)+svar*length(ipoint+1)
    end if
  end do

  if(printl>=6) write(stdout,'("Positions of images along the string: ",6f10.5)') &
       length_img(:)

  ! set non-frozen images to the optimum position on the string
  low=1
  high=neb%nimage-1
  svar2=0.D0
  do iimage=1,neb%nimage-1
    if(neb%frozen(iimage)) then
      low=iimage
    else
      high=neb%nimage-1
      do jimage=iimage+1,neb%nimage-1
        if(neb%frozen(jimage)) then
          high=jimage
          exit
        end if
      end do
      ! position of iimage on the arc - equal arc lenth spacing
      svar=dble(iimage-low)/dble(high-low)
      new_length=(1.D0-svar)*length_img(low)+svar*length_img(high)
      ! new_length is now the lenght value at which the image should be placed

      ! find the string variable (0..1) that corresponds to this length value
      do ipoint=1,npoint
        if(length(ipoint)>=new_length) exit
      end do

      ! the new image should be located at string(alpha):
      if(ipoint>1) then
        svar=(new_length-length(ipoint-1))/(length(ipoint)-length(ipoint-1))
        alpha=(dble(ipoint-2)+svar)/dble(npoint-1) 
      else
        alpha=0.D0
      end if

      ! recalculate the step
      do ivar=1,neb%varperimage
        call spline_get(ivar,alpha,yvar,dyvar,svar)
        svar2=svar2+(yvar - &
            glob%icoords(neb%cstart(iimage)+ivar-1))**2
        glob%step(neb%cstart(iimage)+ivar-1) = yvar - &
            glob%icoords(neb%cstart(iimage)+ivar-1)
      end do
    end if
  end do
  
  do iimage=1,neb%nimage-1
    svar=sqrt(sum((glob%step(neb%cstart(iimage):neb%cend(iimage)))**2))
    write(*,"('Img ',i3,' Step lenth:',f10.5)") iimage,svar
  end do

  call spline_destroy

end subroutine string_reparametrise
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_checkpoint_neb_write
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr
  use dlf_neb, only: neb
  use dlf_checkpoint, only: tchkform,write_separator
  implicit none
  ! YL 15/12/2020: we need avoid using file units ifunit, 101, or 102 to make Cray compiler happy
  !                see pp 141: http://103.251.184.12/wp-content/uploads/2018/01/Cray_Fortran_Reference_Manual_S-3901_86.pdf
  !                The values of INPUT_UNIT, OUTPUT_UNIT, and ERROR_UNIT defined in the ISO_Fortran_env module are
  !                ifunit, 101, and 102, respectively. These three unit numbers are reserved and may not be used for other purposes.
  !                The files connected to these units are the same files used by the companion C processor for standard input
  !                (stdin), output (stdout), and error (stderr). An asterisk (*) specified as the unit for a READ statement specifies unit
  !                ifunit. An asterisk specified as the unit for a WRITE statement, and the unit for PRINT statements is unit 101. All
  !                positive default integer values are available for use as unit numbers.
  integer, parameter :: ifunit = 104
! **********************************************************************
  if(tchkform) then

    open(unit=ifunit,file="dlf_neb.chk",form="formatted")

    call write_separator(ifunit,"NEB Sizes")
    write(ifunit,*) neb%nimage,neb%varperimage
    call write_separator(ifunit,"NEB Parameters")
    write(ifunit,*) neb%iimage,neb%step,neb%maximage,neb%mode,neb%k &
        ,neb%optcart
    call write_separator(ifunit,"NEB Arrays")
    write(ifunit,*) neb%ene,neb%frozen,neb%gradt,neb%xcoords,neb%frozen
    call write_separator(ifunit,"END")


  else

    open(unit=ifunit,file="dlf_neb.chk",form="unformatted")

    call write_separator(ifunit,"NEB Sizes")
    write(ifunit) neb%nimage,neb%varperimage
    call write_separator(ifunit,"NEB Parameters")
    write(ifunit) neb%iimage,neb%step,neb%maximage,neb%mode,neb%k &
        ,neb%optcart
    call write_separator(ifunit,"NEB Arrays")
    write(ifunit) neb%ene,neb%frozen,neb%gradt,neb%xcoords,neb%frozen
    call write_separator(ifunit,"END")

  end if

  close(ifunit)
    
end subroutine dlf_checkpoint_neb_write

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_checkpoint_neb_read(tok)
  use dlf_parameter_module, only: rk
  use dlf_global, only: stdout,printl
  use dlf_neb, only: neb
  use dlf_checkpoint, only: tchkform, read_separator
  implicit none
  logical,intent(out) :: tok
  logical             :: tchk
  integer             :: nimage,varperimage
  integer, parameter  :: ifunit = 104
! **********************************************************************
  tok=.false.

  ! check if checkpoint file exists
  INQUIRE(FILE="dlf_neb.chk",EXIST=tchk)
  if(.not.tchk) then
    write(stdout,10) "File dlf_neb.chk not found"
    return
  end if

  if(tchkform) then
    open(unit=ifunit,file="dlf_neb.chk",form="formatted")
  else
    open(unit=ifunit,file="dlf_neb.chk",form="unformatted")
  end if

  call read_separator(ifunit,"NEB Sizes",tchk)
  if(.not.tchk) return    

  if(tchkform) then
    read(ifunit,*,end=201,err=200) nimage,varperimage
  else
    read(ifunit,end=201,err=200) nimage,varperimage
  end if

  if(neb%nimage/=nimage) then
    write(stdout,10) "Different numbers of NEB images"
    close(ifunit)
    return
  end if
  
  if(neb%varperimage/=varperimage) then
    write(stdout,10) "Different numbers of variables per NEB image"
    close(ifunit)
    return
  end if
  
  call read_separator(ifunit,"NEB Parameters",tchk)
  if(.not.tchk) return    

  if(tchkform) then
    read(ifunit,*,end=201,err=200) neb%iimage,neb%step, &
        neb%maximage,neb%mode,neb%k,neb%optcart
  else
    read(ifunit,end=201,err=200) neb%iimage,neb%step, &
        neb%maximage,neb%mode,neb%k,neb%optcart
  end if

  call read_separator(ifunit,"NEB Arrays",tchk)
  if(.not.tchk) return    

  if(tchkform) then
    read(ifunit,*,end=201,err=200) neb%ene,neb%frozen,neb%gradt &
        ,neb%xcoords,neb%frozen
  else
    read(ifunit,end=201,err=200) neb%ene,neb%frozen,neb%gradt &
        ,neb%xcoords,neb%frozen
  end if

  call read_separator(ifunit,"END",tchk)
  if(.not.tchk) return

  close(ifunit)
  tok=.true.

  if(printl >= 6) write(stdout,"('NEB checkpoint file successfully read')")

  return

  ! return on error
  close(ifunit)
200 continue
  write(stdout,10) "Error reading file"
  return
201 continue
  write(stdout,10) "Error (EOF) reading file"
  return

10 format("Checkpoint reading WARNING: ",a)
end subroutine dlf_checkpoint_neb_read

!!****

!  Copyright (C) 2017 The authors of Py-ChemShell
!
!  This file is part of Py-ChemShell.
!
!  Py-ChemShell is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as
!  published by the Free Software Foundation, either version 3 of the
!  License, or (at your option) any later version.
!
!  Py-ChemShell is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with Py-ChemShell.  If not, see
!  <http://www.gnu.org/licenses/>.

module ChemShellLSDaltonModule

    use, intrinsic :: iso_c_binding
    use DL_PY2F
    use ChemShellParallelModule, only : chemsh_parallel

    private

    public register_lsdalton, interface_lsdalton, lsdalton_wrap
    public PyFrag, PyShells, nshells

    type(dictType) , pointer :: PyFrag, PyShells
    integer                  :: nshells

    integer(c_int) :: c_debug
    integer(c_int) :: lsdalton_handle
    integer        :: lsdalton_task

    contains

      
    subroutine register_lsdalton(debug) bind(c, name="f_register_lsdalton")

        integer(c_int), intent(in) :: debug

        type(c_funptr) :: lsdalton_pointer

        c_debug = debug

        lsdalton_pointer = c_funloc(lsdalton_wrap)
        lsdalton_handle = chemsh_parallel%get_function_handle(lsdalton_pointer)

    endsubroutine register_lsdalton

    ! called by master process only
    subroutine interface_lsdalton(fragPtr) bind(c)
 
        implicit none
 
        type(PyType)  , intent(in) :: fragPtr
 
        integer                    :: ierror
        type(PyType)  , pointer    :: shellsPtr
 
        lsdalton_task = 0 !task 
 
        ! set up dict of fragObj
        allocate(PyFrag, source=ptr2dict(fragPtr))
        call PyFrag%get('shells', shellsPtr)
 
        ! set up dict of shellsObj and save nshells
        allocate(PyShells, source=ptr2dict(shellsPtr))
        call PyShells%get('npts', nshells)
 
        if(chemsh_parallel%is_parallel()) then
           ierror = chemsh_parallel%exec_function(lsdalton_handle, c_debug)
        else
           ierror = lsdalton_wrap()
        endif
 
        deallocate(PyFrag, PyShells)
 
    endsubroutine interface_lsdalton

    ! also called by slave processes
    integer function lsdalton_wrap() result(ierror)

        call lsdalton()

!TWKDEBUG
        ierror = 0

    endfunction lsdalton_wrap

endmodule ChemShellLSDaltonModule

!  Copyright (C) 2017 The authors of Py-ChemShell
!
!  This file is part of Py-ChemShell.
!
!  Py-ChemShell is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as
!  published by the Free Software Foundation, either version 3 of the
!  License, or (at your option) any later version.
!
!  Py-ChemShell is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with Py-ChemShell.  If not, see
!  <http://www.gnu.org/licenses/>.

subroutine cluster_adjust_charge(nccore, ncbq, ncshell, &
                                 npcore, npbq, npshell, &
                                 ierr)
  !
  ! Adjust charges at the cluster surface taking coordination into account
  !

  use ChemShellClusterModule, only : PyCell, PyOptions, debug

  implicit none

  integer, intent(in) :: nccore, ncbq, ncshell
  integer, intent(in) :: npcore, npbq, npshell
  integer, intent(out) :: ierr

  integer :: i, j, k, l, m, n, p, ci
  double precision :: tot_charge

  ! Size of connectivity table entries in fragment
  integer, parameter :: max_coord = 14

  ! Arrays for crystal information
  double precision, dimension(npcore+npshell) :: crystal_charges
  double precision, dimension(npcore) :: charge_core
  double precision, dimension(npshell) :: charge_shel
  integer, dimension(npcore) :: znum_core
  integer, dimension(npshell) :: point_core
  integer, dimension(npcore) :: point_shel  
  integer, dimension(npcore) :: coordination
  integer, dimension(max_coord, npcore) :: point_neighbour
  double precision, dimension(3, max_coord, npcore) :: v_neighbour

  ! Arrays for cluster information
  double precision, dimension(nccore+ncshell) :: cluster_charges
  double precision, dimension(nccore) :: charge_cluster_core
  double precision, dimension(ncshell) :: charge_cluster_shel  
  integer, dimension(ncshell) :: point_cluster_core
  integer, dimension(nccore) :: point_cluster_shel
  integer, dimension(nccore+ncshell) :: xtal_map
  integer, dimension(nccore) :: point_uc_c
  integer, dimension(ncshell) :: point_uc_s
  integer, dimension(nccore) :: coordination_in_cluster
  integer, dimension(max_coord, nccore) :: point_cluster_neighbour

  ! Species table/valence model
  integer :: no_species
  integer, dimension(npcore) :: species_core
  double precision, dimension (npcore) :: species_charge
  integer, dimension(npcore) :: species_coord
  integer, dimension(npcore) :: species_znum
  double precision, dimension (max_coord, npcore) :: species_neighbour_charge
  integer, dimension(max_coord, npcore) :: species_neighbour_coord  
  integer, dimension(max_coord) :: coord_neighbour
  double precision, dimension(max_coord) :: q_neighbour
  double precision, parameter :: tol_q = 1.0d-6
  logical :: new_species, neighbour_charge_ok
  integer, dimension(npcore) :: core_species
  integer, dimension(npcore, npcore) :: species_species
  double precision, dimension(npcore, npcore) :: valence

  double precision, pointer   :: twodimdblbuff(:,:)
  
  logical :: shell_model

  integer, parameter :: periodic_frag = 1, cluster_frag = 2
  double precision, parameter :: d_min = 0.1d0

  character(len=:), pointer :: adjust_mode
  integer :: ndim

  ierr = 0

  call PyOptions%get('adjust_charge', adjust_mode)
  call PyCell%get('ndimensions', ndim)
  
  if (debug > 0) then
     write(6,'(a)')    "--------------------------------------"
     write(6,'(a,i4)') "cluster_adjust_charge debug level:", debug
     write(6,'(a)')    "--------------------------------------"
  end if

  ! no action required
  if (trim(adjust_mode).eq.'') then
     write(6,*)
     write(6,*) " >>> ChemShell CLUSTER: charge adjustment not requested"
     return
  end if
  ! Check there are no point charges
  if (ncbq .ne. 0 .or. npbq .ne. 0) then
     write(6,*) " >>> ChemShell CLUSTER ERROR: number of point charges must be zero for charge adjustment"
     ierr = 1
     return
  end if
  ! valence model is for bulk systems only
  if (ndim /= 3 .and.trim(adjust_mode).eq.'valence_model') then
     write(6,*) " >>> ChemShell CLUSTER ERROR: valence model scheme only valid for bulk systems"
     ierr = 1
     return     
  end if

  if (npshell .eq. 0) then
     shell_model = .false.
  else
     shell_model = .true.
  end if

  ! Get crystal fragment information

  ! Get charges of cartesian sites from crystal fragment
  ! Split into core and shell arrays
!  call get_cart_charges(periodic_frag, crystal_charges, ierr)
  call get_cart_charges(periodic_frag, crystal_charges, npcore+npshell,ierr)
  if (ierr .ne. 0) return
  charge_core = crystal_charges(1:npcore)
  if (shell_model) charge_shel = crystal_charges(npcore+1:npcore+npshell)

  ! Get pointers from shells to cores
  ! Then setup pointers in the other direction
  if (shell_model) then
     call get_point_core(periodic_frag, point_core, npshell, ierr)
     if (ierr .ne. 0) return
     point_shel = 0
     do i = 1, npshell
        point_shel(point_core(i)) = i
     end do
  end if

  ! Determine coordination number and neighbours for all atoms in the unit cell
  coordination(:) = 0
  call periodic_neighbour_list(npcore, coordination, &
       point_neighbour, v_neighbour, ierr)
  if (ierr .ne. 0) return
  if (debug > 0) then
     write(6,'(/a)') "Crystal neighbour list"
     do i = 1, npcore
        write(6,'(i4,a,i4)') i, ":", coordination(i)
        do j = 1, coordination(i)
           write(6,'(2x,i4,2x,3f12.7)') point_neighbour(j,i), v_neighbour(1:3,j,i)
        end do
        write(6,*)
     end do
     write(6,*)
  end if

  ! Determine species table consisting of groups of atoms which 
  ! share the same atomic number, charge, coordination and neighbour charges
  if(trim(adjust_mode).eq.'valence_model'.or.trim(adjust_mode).eq.'print_species') then
     ! Initialisation
     call get_znum(periodic_frag, znum_core, npcore, ierr)
     no_species = 0
     ! Build species table
     do i = 1, npcore
        ! Sort charges of neighbouring ions by value
        ci = coordination(i)
        do j = 1, ci
           k = point_neighbour(j, i)
           coord_neighbour(j) = coordination(k)
           q_neighbour(j) = charge_core(k)
           if (shell_model .and. point_shel(k) /= 0) then
              q_neighbour(j) = q_neighbour(j) + charge_shel(point_shel(k))
           end if
        end do
        call sortvec(ci, q_neighbour, coord_neighbour)
        ! Check if the species exists and add to the list of species if not
        new_species = .true.
        tot_charge = charge_core(i)
        if (shell_model .and. point_shel(i) /= 0) then
           tot_charge = tot_charge + charge_shel(point_shel(i))
        end if
        do j = 1, no_species
           if (dabs(tot_charge - species_charge(j)) > tol_q) cycle
           if (znum_core(i) /= species_znum(j)) cycle
           if (ci /= species_coord(j)) cycle
           neighbour_charge_ok = .true.
           do k = 1, ci
              if (dabs(q_neighbour(k) - species_neighbour_charge(k, j)) > tol_q) then
                 neighbour_charge_ok = .false.
                 exit
              end if
           end do
           if (.not. neighbour_charge_ok) cycle
           ! Species already exists
           species_core(i) = j
           new_species = .false.
           exit
        end do
        if (new_species) then
           no_species = no_species + 1
           species_core(i) = no_species 
           species_charge(no_species) = tot_charge
           species_coord(no_species) = ci
           species_znum(no_species) = znum_core(i)
           do j = 1, ci
              species_neighbour_charge(j, no_species) = q_neighbour(j)
              species_neighbour_coord(j, no_species) = coord_neighbour(j)
           end do
        end if
     end do ! loop over cores
     ! Determine coordination between species to help the user
     ! construct the valence matrix
     do i = 1, no_species
        do j = 1, npcore
           if (species_core(j) == i) then
              core_species(i) = j
              exit
           end if
        end do
     end do
     species_species(:,:) = 0
     do i = 1, no_species
        j = core_species(i)
        l = species_coord(i)
        do k = 1, l
           p = species_core(point_neighbour(k,j))
           species_species(i,p) = species_species(i,p) + 1
        end do
     end do
     ! Print out species information
     write(6,'(a)') 'Crystal species list'
     write(6,'(a,4x,a,6x,a,8x,a)') &
          '    No    Z ','q','Coord','Charges on neighbours'
     do i = 1, no_species
        write(6, '(/3x,i3,2x,i3,f10.4,2x,i3,2x,5f10.4/(28x,5f10.4))') &
             i, species_znum(i), species_charge(i), &
             species_coord(i), &
             (species_neighbour_charge(j,i), j=1,species_coord(i))
     enddo
     write(6,'(/a)') 'Table of species coordination'
     do i = 1, no_species
        write(6,'(3x,10i5)') (species_species(i,j), j=1, no_species)
     end do
  end if

  ! If called by periodic_species, no further calculations required
  if(trim(adjust_mode).eq.'print_species') return

  ! Get cluster fragment information

  ! Get pointers from shells to cores
  ! Then setup pointers in the other direction
  if (shell_model) then
     call get_point_core(cluster_frag, point_cluster_core, ncshell, ierr)
     if (ierr .ne. 0) return
     point_cluster_shel = 0
     do i = 1, ncshell
        point_cluster_shel(point_cluster_core(i)) = i
     end do
  end if

  ! Get coordination of atoms in cluster
  call get_cluster_connectivity(nccore, point_cluster_neighbour, ierr)
  if (ierr .ne. 0) return
  do i = 1, nccore
     coordination_in_cluster(i) = 0
     do j = 1, max_coord
        if (point_cluster_neighbour(j,i) /= 0) then
           coordination_in_cluster(i) = coordination_in_cluster(i) + 1
        end if
     end do
  end do
  if (debug > 0) then
     write(6,'(/a)') "Coordination in cluster"
     do i = 1, nccore
        write(6,'(i4,a,i2,a)', advance='no') i, ": (", coordination_in_cluster(i), ")  "
        do j = 1, max_coord
           if (point_cluster_neighbour(j,i) /= 0) then
              write(6,'(i4)', advance='no') point_cluster_neighbour(j,i)
           end if
        end do
        write(6,*)
     end do
     write(6,*)
  end if
  
  ! Get pointer from cores/shells to the unit cell (xtal map) 
  call get_xtal_map(cluster_frag, xtal_map, nccore, ncshell, ierr)
  if (ierr .ne. 0) return
  point_uc_c = xtal_map(1:nccore)
  if (shell_model) point_uc_s = xtal_map(nccore+1:nccore+ncshell)
  if (debug > 0) then
     write(6,'(/a)') "XTAL MAP"
     write(6,'(/a)') "CORES"
     do i = 1, nccore
        write(6,'(2i6)') i, point_uc_c(i)
     end do
     if (shell_model) then
        write(6,'(/a)') "SHELLS"
        do i = 1, ncshell
           write(6,'(2i6)') i, point_uc_s(i)
        end do
     end if
  end if  

  ! Set cluster charges
  charge_cluster_core(1:nccore) = 0
  charge_cluster_shel(1:ncshell) = 0
  select case(trim(adjust_mode))
  case ('coordination_scaled')
     ! This is the standard scheme in the surface subroutine of construct
     ! But it seems equally applicable to the bulk case
     do i = 1, nccore
        j = point_uc_c(i)
        if (coordination(j) /= 0) then
           charge_cluster_core(i) = charge_core(j) * &
                coordination_in_cluster(i) / coordination(j)
        else
           charge_cluster_core(i) = charge_core(j)
        end if
     end do
     if (shell_model) then
        do i = 1, ncshell
           j = point_uc_s(i)
           k = point_cluster_core(i)
           l = point_uc_c(k)
           if (coordination(l) /= 0) then
              charge_cluster_shel(i) = charge_shel(j) * &
                   coordination_in_cluster(k) / coordination(l)
           else
              charge_cluster_shel(i) = charge_shel(j)
           end if
        end do
     end if
  case('valence_model')
     ! The valence model scheme is only applicable to the bulk case

!     call get_valence_matrix(no_species, valence(1:no_species, 1:no_species), ierr)
     allocate(twodimdblbuff(no_species,no_species))
     call PyOptions%get('valence_matrix', twodimdblbuff)

     valence(1:no_species,1:no_species) = twodimdblbuff
         
     if (ierr .ne. 0) return
     do i = 1, nccore
        tot_charge = 0.0d0
        j = point_uc_c(i)
        m = species_core(j)
        ! Cations are fully coordinated in the valence model, while
        ! anions should have their charge adjusted according to their
        ! coordination
        if (species_charge(m) < 0.0d0) then
           ! Loop over neighbours, adding charge contributions
           ! according to the valence matrix
           do l = 1, max_coord
              p = point_cluster_neighbour(l,i)
              if (p /= 0) then
                 n = species_core(point_uc_c(p))
                 ! In construct, valence.dat is input as a column-major list
                 ! But in chemshell, matrices are input as row-major lists
                 ! To avoid the user having to transpose the input, 
                 ! we instead transpose the internal valence matrrix
                 !  - so rows are core i, and columns are neighbouring cores
                 tot_charge = tot_charge + valence(m,n)
              end if
           end do
           charge_cluster_core(i) = charge_core(j) * &
                tot_charge / species_charge(m)
        else
           charge_cluster_core(i) = charge_core(j)
        end if
        if (shell_model) then
           k = point_cluster_shel(i)
           if (k /= 0) then
              l = point_uc_s(k)
              charge_cluster_shel(k) = charge_shel(l) * &
                   charge_cluster_core(i) / charge_core(j)
           end if
        end if
     end do
  case default
     write(6,*) " >>> cluster_adjust_charge ERROR: unknown adjust_charge ", trim(adjust_mode)
     ierr = 1
     return 
  end select
  if (debug > 3) then
     write(6,'(/a)') "Adjusted cluster charges"
     write(6,'(/a)') "CORES"
     do i = 1, nccore
        write(6,'(i6, 3f12.7)') i, charge_cluster_core(i)
     end do
     write(6,'(/a)') "SHELLS"
     do i = 1, ncshell
        write(6,'(i6, 3f12.7)') i, charge_cluster_shel(i)
     end do
     write(6,*)    
  end if
  
  ! Write the new charges to the cluster fragment
  cluster_charges(1:nccore) = charge_cluster_core
  if (shell_model) cluster_charges(nccore+1:nccore+ncshell) = charge_cluster_shel

  call set_cart_charges(cluster_frag, cluster_charges, nccore+ncshell, ierr)
  if (ierr .ne. 0) return

end subroutine cluster_adjust_charge


subroutine sortvec(ne,q,l)
  implicit none
  ! Sort vector q in ascending order
  integer :: ne,m,n,ium,l(ne)
  double precision :: q(ne), dum
  do m=2,ne
     dum=q(1)
     ium=l(1)
     do n=2,ne-m+2
        if(dum.gt.q(n)) then
           q(n-1)=q(n)
           q(n)=dum
           l(n-1)=l(n)
           l(n)=ium
        else
           dum=q(n)
           ium=l(n)
        endif
     enddo
  enddo
  return
end subroutine sortvec

!  Copyright (C) 2017 The authors of Py-ChemShell
!
!  This file is part of Py-ChemShell.
!
!  Py-ChemShell is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as
!  published by the Free Software Foundation, either version 3 of the
!  License, or (at your option) any later version.
!
!  Py-ChemShell is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with Py-ChemShell.  If not, see
!  <http://www.gnu.org/licenses/>.

! YL 01/08/2018: this file should contain ONLY methods called by the CONSTRUCT code

subroutine get_frac_coords(periodic_frag, frac_coords, ierror)

    use ChemShellClusterModule
    
    integer, intent(inout) :: periodic_frag, ierror
    real   , intent(inout) :: frac_coords(:,:)

    print *, "### PLACEHOLDER: get_frac_coords"

endsubroutine get_frac_coords
integer function set_grid_electrostatics(ngridpts, cart_grid, pot, efield) result(ierror)

    integer              , intent(inout) :: ngridpts
    real(kind=8)         , intent(inout) :: cart_grid(3,ngridpts)
    real(kind=8), pointer, intent(inout) :: pot(:)
    real(kind=8), pointer, intent(inout) :: efield(:)

    print *, "### PLACEHOLDER: set_grid_electrostatics"

    ierror = 0

endfunction set_grid_electrostatics
! pass the values back to Python
integer function set_cluster_origin(origin) result(ierror)

    use ChemShellClusterModule

    real(kind=8), intent(in) :: origin(3)

    call PyOptions%set('origin', origin)

    ierror = 0

endfunction set_cluster_origin
! YL FIXME: not in use
subroutine get_cluster_origin(origin, ierror)

    use ChemShellClusterModule

    implicit none
    
    real(kind=8), intent(out) :: origin(3)
    integer     , intent(out) :: ierror

    ! TODO Store and recover the origin already chosen in cluster_cut
    ! TODO It should not be possible to change it at fitting stage!

    ! YL 15/11/2019: merged origin_atom and origin_point
    ! cluster cutting needs fractional origin, so this is wrong:
    call PyOptions%get('origin', origin(1:3))

    ierror = 0

endsubroutine get_cluster_origin
subroutine get_unit_cell(periodic_frag, a, b, c, alpha, beta, gamma, ierror)

    integer, intent(inout) :: periodic_frag
    real, intent(inout) :: a, b, c, alpha, beta, gamma
    integer, intent(inout) :: ierror

    print *, "### FORTRAN: get_unit_cell"

endsubroutine get_unit_cell
subroutine get_valence_matrix(no_species, valence, ierror)
    integer, intent(inout) :: no_species
    real   , intent(inout) :: valence(:,:)
    integer, intent(inout) :: ierror

    print *, "### FORTRAN: get_valence_matrix"

endsubroutine get_valence_matrix
subroutine set_cart_coords(periodic_frag, some_switch, cart_coords, ierror)
    integer, intent(inout) :: periodic_frag, some_switch
    real(kind=8), intent(inout) :: cart_coords(:,:)
    integer, intent(inout) :: ierror

    print *, "### FORTRAN: set_cart_coords"

endsubroutine set_cart_coords
subroutine get_cart_coords(switch, coords, ncores, nshells, ierror)

    use ChemShellClusterModule, only: PyFrag, PyCluster, PyShells
    use DL_PY2F
   
    implicit none

    integer     , intent(in)  :: switch
    integer     , intent(in)  :: ncores,nshells
    integer     , intent(out) :: ierror
    real(kind=8), intent(out) :: coords(3,ncores+nshells)

    integer                   :: i
    real(kind=8)              :: shellcoords(3,nshells)
    type(PyType), pointer     :: shellsPtr

!real(kind=8), pointer              :: twodimdbl(:,:)
! YL TODO: use twodimdbl to receive coordinates and shell positions, respectively

    selectcase(switch)
        case(1)
            !get coord matrix (FRAG_get_coord_matrix)
            !print *,'Extracting atom coordinates...'
            call PyFrag%get('xyz', coords(1:3,1:ncores))
            if(nshells > 0) then
                !print *,'Extracting shells..., switch =', switch
                call PyFrag%get('shells', shellsPtr)
                if(associated(PyShells)) deallocate(PyShells)
                allocate(PyShells, source=ptr2dict(shellsPtr))
                call PyShells%get('coords', shellcoords)
                coords(:,ncores+1:ncores+nshells) = shellcoords(:,1:nshells)
            endif 
        case(2)
            call PyCluster%get('xyz', coords(1:3,1:ncores))
            if(nshells > 0) then
                !print *,'Extracting shells..., switch =', switch
                call PyCluster%get('shells', shellsPtr)
                if(associated(PyShells)) deallocate(PyShells)
                allocate(PyShells, source=ptr2dict(shellsPtr))
                call PyShells%get('coords', shellcoords)
                coords(:,ncores+1:ncores+nshells) = shellcoords(:,1:nshells)
            endif
        case default
            print *,"Invalid mode switch in get_cart_coords"
            STOP
    endselect
!    deallocate(PyShells)
    ierror = 0

endsubroutine get_cart_coords
subroutine get_grid_coords(ngridpts, cart_grid, ierror)

    use ChemShellClusterModule

    implicit none

    integer, intent(inout) :: ngridpts
    real   , intent(inout) :: cart_grid(3,ngridpts)
    integer, intent(inout) :: ierror


    ierror =-1

    print *, "### FORTRAN: get_grid_coords"

    ierror = 0

endsubroutine get_grid_coords
subroutine set_cart_charges(dummy, cart_charges, ncent, ierror)

    use ChemShellClusterModule, only: PyCluster, PyShells
    use DL_PY2F

    implicit none  
  
    ! FIXME fragment mode missing
    integer, intent(in) :: dummy
    integer, intent(in) :: ncent
    real(kind=8), intent(in) :: cart_charges(ncent)
    integer, intent(inout) :: ierror
    integer  :: ncores, nshells
    type(PyType), pointer  :: shellsPtr

    ! core charges
    call PyCluster%get('npts', ncores)
    call PyCluster%set('charges', cart_charges(1:ncores))
    ! shell charges
    call PyCluster%get('nshells', nshells)
    if(nshells > 0) then
        call PyCluster%get("shells", shellsPtr)
        if(associated(PyShells)) deallocate(PyShells)
        allocate(PyShells, source=ptr2dict(shellsPtr))
        call PyShells%set("charges", cart_charges(ncores+1:ncent))
    endif
    ierror = 0

endsubroutine set_cart_charges
subroutine get_cart_charges(switch, charges, ncent, ierror)

    use ChemShellClusterModule, only: PyFrag, PyCluster, PyShells
    use DL_PY2F
    implicit none

    integer     , intent(in)  :: switch
    integer     , intent(in)  :: ncent
    real(kind=8), intent(out) :: charges(ncent)
    integer     , intent(out) :: ierror
    integer                   :: ncores, nshells
    type(PyType), pointer  :: shellsPtr

    selectcase(switch)
    case(1)
        ! cores
        call PyFrag%get('npts', ncores)
        call PyFrag%get('charges', charges(1:ncores))
        ! shells
        call PyFrag%get('nshells', nshells)
        if(nshells > 0) then
            call PyFrag%get("shells", shellsPtr)
            if(associated(PyShells)) deallocate(PyShells)
            allocate(PyShells, source=ptr2dict(shellsPtr))
            call PyShells%get("charges", charges(ncores+1:ncent))
        endif
    case(2)
        ! cores
        call PyCluster%get('npts', ncores)
        call PyCluster%get('charges', charges(1:ncores))
        ! shells
        call PyCluster%get('nshells', nshells)
        if(nshells > 0) then
            call PyCluster%get("shells", shellsPtr)
            if(associated(PyShells)) deallocate(PyShells)
            allocate(PyShells, source=ptr2dict(shellsPtr))
            call PyShells%get("charges", charges(ncores+1:ncent))
        endif
    case default
        print *,"Invalid mode switch in get_cart_coords"
        STOP
    endselect

    ierror = 0

endsubroutine get_cart_charges
subroutine get_xtal_map(cluster_frag, xtal_map, ncores,nshells,ierror)
    use ChemShellClusterModule
    use DL_PY2F

    implicit none
    
    integer, intent(in)    :: cluster_frag
    integer,intent(in)     :: nshells
    integer,intent(in)     :: ncores
    integer, intent(inout) :: xtal_map(ncores+nshells)
    integer, intent(inout) :: ierror

    type(PyType), pointer  :: shellsPtr
    
!   From interface.c: 
!  /* Notes:
!      - map was used in xtal to indicate which asymmetric cell sites
!        correspond to the resulting primitive cell sites. As there is
!        no symmetry, here it simply counts from 1 upwards 
!      - charges are not handled by frac_to_cart. Copy straight from 
!        xatoms, etc. instead
!  */
    
    call pyCluster%get('map',xtal_map(1:ncores))
    if(nshells > 0) then
       call PyCluster%get("shells", shellsPtr)
       if(associated(PyShells)) deallocate(PyShells)
       allocate(PyShells, source=ptr2dict(shellsPtr))
       call PyShells%get('map', xtal_map(ncores+1:ncores+nshells))
    endif
 
    ierror = 0

endsubroutine get_xtal_map
subroutine get_cell_vectors(periodic_frag, vect, ierror)

    use ChemShellClusterModule
    use DL_PY2F
 
    implicit none
   
    integer                , intent(inout) :: periodic_frag
    real(kind=8)           , intent(out)   :: vect(3,3)
    integer                , intent(out)   :: ierror
   
!    type(PyType)  , pointer                :: cellPtr 

! YL: it is odd that allocating PyCell fails here but succeeds in ClusterCreateModule%init()
!    call PyFrag%get('cell', cellPtr)
!    allocate(PyCell, source=ptr2dict(cellPtr))

    call PyCell%get('vectors', vect)

    ierror = 0

endsubroutine get_cell_vectors
subroutine set_cart_unit_cell(periodic_frag, vect, cart_coords, ierror)

    integer, intent(inout) :: periodic_frag
    real   , intent(inout) :: vect(3,3)
    real   , intent(inout) :: cart_coords(:,:)
    integer, intent(inout) :: ierror
    
    print *, "### FORTRAN: set_cart_unit_cell"

endsubroutine set_cart_unit_cell
subroutine get_point_core(ifrag, point_core, nshells, ierror)

    use ChemShellClusterModule, only : PyFrag, PyCluster, PyShells
    use DL_PY2F

    implicit none

    integer, intent(in)    :: ifrag
    integer, intent(in)    :: nshells
    integer, intent(inout) :: point_core(nshells)
    integer, intent(inout) :: ierror

    integer                :: i
    integer                :: shellarray(nshells)
    real(kind=8)       :: charges(nshells)
    type(PyType), pointer  :: shellsPtr

    ierror = 1
    
    selectcase(ifrag)
        case(1)
           ! periodic fragment
           call PyFrag%get("shells", shellsPtr)
        case(2)
           ! cluster
           call PyCluster%get("shells", shellsPtr)
        case default
            print *,"Invalid fragment number in get_point_core"
            STOP       
    endselect
     
    if(associated(PyShells)) deallocate(PyShells)
    allocate(PyShells, source=ptr2dict(shellsPtr))

    call PyShells%get("charges", charges)

    call PyShells%get("coreatoms", shellarray) 

    ! shift by 1 to Fortran convention 
    point_core(:) = shellarray(:) + 1

    ierror = 0

endsubroutine get_point_core
subroutine get_znum(periodic_frag, znum_core, ncores,ierror)

    use ChemShellClusterModule, only : PyFrag

    implicit none
    integer, intent(in)    :: periodic_frag
    integer, intent(inout) :: ierror
    integer,intent(in)     :: ncores
    integer(kind=8)        :: znums(ncores)
    integer,intent(inout)  :: znum_core(ncores)
    
    call PyFrag%get('znums',znums) 
    znum_core(:) = int(znums(:))
    ierror = 0 

endsubroutine get_znum
subroutine set_cluster_bqs(n_polar_bq,      &
                           n_lsq_bq,        &
                           r_polar_bq,      &
                           r_lsq_bq,        &
                           charge_polar_bq, &
                           charge_lsq_bq,   &
                           ierror)

    use ChemShellClusterModule
    use DL_PY2F

    implicit none

    integer, intent(in) :: n_polar_bq
    integer, intent(in) :: n_lsq_bq
    real(kind=8), intent(in) :: r_polar_bq(3,n_polar_bq)
    real(kind=8), intent(in) :: r_lsq_bq(3,n_lsq_bq)
    real(kind=8), intent(in) :: charge_polar_bq(n_polar_bq)
    real(kind=8) , intent(in) :: charge_lsq_bq(n_lsq_bq)
    real(kind=8) :: bq_array(3,n_polar_bq+n_lsq_bq)
    integer, intent(inout) :: ierror
    type(PyType), pointer     :: bqPtr
    integer :: nbqs

    ierror = 1

    call PyCluster%get('bqs', bqPtr)
    allocate(PyBQs, source=ptr2dict(bqPtr))
    call PyBQs%get('npts', nbqs)
    write(*, '(/1X,A,I12)') 'Number of point charges    : ', nbqs

    !Set the coordinates
    bq_array(:,1:n_polar_bq) = r_polar_bq(:,:)
    bq_array(:,n_polar_bq+1:nbqs) = r_lsq_bq(:,:)
    call PyBQs%set('xyz', bq_array)

    !set the charges
    bq_array(1,1:n_polar_bq) = charge_polar_bq(:)
    bq_array(1,n_polar_bq+1:nbqs) = charge_lsq_bq(:)    
    call PyBQs%set('charges', bq_array(1,:))

    deallocate(PyBQs)

    ierror = 0

endsubroutine set_cluster_bqs
subroutine set_electrostatics(periodic_frag, &
                              cart_coords,   &
                              pot_core,      &
                              pot_shel,      &
                              efield_core,   &
                              efield_shel,   &
                              ncores,nshells,ierror)

    use ChemShellClusterModule
    implicit none
    integer     , intent(in)    :: ncores,nshells
    integer     , intent(in)    :: periodic_frag
    real(kind=8), intent(in)    :: cart_coords(3,ncores+nshells)
    real(kind=8), intent(in)    :: pot_core(ncores)
    real(kind=8), intent(in)    :: pot_shel(nshells)
    real(kind=8), intent(in)    :: efield_core(3,ncores)
    real(kind=8), intent(in)    :: efield_shel(3,nshells)
    integer     , intent(inout) :: ierror
    integer                            :: npoints
    real(kind=8), allocatable      :: efield_tmp(:,:)
    real(kind=8), allocatable      :: pot_tmp(:)

    call pyField%get('npts', npoints)
    call pyField%set('xyz' , cart_coords)
    
    allocate(efield_tmp(1:3,1:npoints)) 
    allocate(pot_tmp(1:npoints))

    efield_tmp(1:3,1:ncores) = efield_core(1:3,1:ncores)
    pot_tmp(1:ncores)        = pot_core(1:ncores)

    if(nshells > 0) then
        efield_tmp(1:3,1+ncores:npoints) = efield_shel(1:3,1:nshells)
        pot_tmp(1+ncores:npoints)        = pot_shel(1:nshells)
    endif 

    call pyField%set('efield',efield_tmp)
    call pyField%set('pot',pot_tmp)

    deallocate(efield_tmp)
    deallocate(pot_tmp)
    ierror = 0

endsubroutine set_electrostatics
subroutine get_electrostatics(periodic_frag, &
                              pot_core,      &
                              pot_shel,      &
                              efield_core,   &
                              efield_shel,   &
                              ncores,nshells,ierror)

    use ChemShellClusterModule

    implicit none

    integer, intent(in)             :: periodic_frag
    integer, intent(in)             :: ncores,nshells
    real(kind=8)  , intent(out) :: pot_core(ncores)
    real(kind=8)  , intent(out) :: pot_shel(nshells)
    real(kind=8)  , intent(out) :: efield_core(3,ncores)
    real(kind=8)  , intent(out) :: efield_shel(3,nshells)
    integer       , intent(inout)          :: ierror

    integer                       :: i, j, npoints
    real(kind=8), allocatable   :: efield_tmp(:,:)
    real(kind=8), allocatable   :: pot_tmp(:)

    call pyField%get('npts', npoints)
    write(*, '(/A)')    ' Electrostatics'
    write(*, '(A,I12)') ' Number of points           : ', npoints
    if(nshells == 0) then
        call pyField%get('efield', efield_core(1:3,1:ncores))
        call pyField%get('pot'   , pot_core)
    else
        allocate(efield_tmp(1:3,1:npoints))
        allocate(pot_tmp(1:npoints))

        efield_tmp = 0.0
        pot_tmp    = 0.0

        call pyField%get('efield', efield_tmp)
        efield_core(1:3,1:ncores)  = efield_tmp(1:3,1:ncores)
        efield_shel(1:3,1:nshells) = efield_tmp(1:3,1+ncores:npoints)
        call pyField%get('pot'   , pot_tmp)
        pot_core(1:ncores)  = pot_tmp(1:ncores)
        pot_shel(1:nshells) = pot_tmp(1+ncores:npoints)

        deallocate(efield_tmp)
        deallocate(pot_tmp)

    endif

    ierror = 0 

endsubroutine get_electrostatics
subroutine periodic_neighbour_list(natoms_frag,          &
                                   coordination,    &
                                   point_neighbour, &
                                   v_neighbour,     &
                                   ierror)

    use ChemShellClusterModule

    implicit none
    
    integer, intent(in)    :: natoms_frag
    integer, intent(out)   :: coordination(natoms_frag)
    integer, intent(out)   :: point_neighbour(14,natoms_frag)
    real(kind=8), intent(inout) :: v_neighbour(3,14,natoms_frag)
    integer, intent(out)   :: ierror

    integer(kind=8), pointer   :: nneighbours(:)
    integer(kind=8), pointer   :: neighbours(:,:)
    real(kind=8)   , pointer   :: neighb_vectors(:,:)

    ierror = 1

    ! neighbours list
    allocate(nneighbours(natoms_frag))
    allocate(neighbours(MAXCONN, natoms_frag))
    allocate(neighb_vectors(3, MAXCONN*natoms_frag))

    call PyOptions%get('nneighbours', nneighbours)
    call PyOptions%get('neighbours', neighbours)
    call PyOptions%get('neighb_vectors', neighb_vectors)

    ! Neighbours are set at initialisation so simply read them in
    coordination    = nneighbours
    point_neighbour = neighbours
    v_neighbour     = reshape(neighb_vectors, (/3, 14, natoms_frag/))

    deallocate(nneighbours, neighbours, neighb_vectors)

    ierror = 0

endsubroutine periodic_neighbour_list
subroutine get_cluster_connectivity(ncores, connectivity, ierror)

    use ChemShellClusterModule

    implicit none

    integer, intent(in)  :: ncores    
    integer, intent(out) :: connectivity(14, ncores)
    integer, intent(out) :: ierror

    integer                :: i
 
    ! YL 05/05/2018: FIXME
    connectivity = 0
    call PyCluster%get('conn', connectivity) 

    ! Convert to construct Fortran convention
    connectivity = connectivity + 1
    
 !   do i = 1,ncores 
 !       print *,connectivity(:, i) 
 !   enddo

    ierror = 0

endsubroutine get_cluster_connectivity
subroutine setCluster(cart_cluster_cores, cart_cluster_shells,       &
                      charges_cluster_cores, charges_cluster_shells, &
                      map_cluster_cores, map_cluster_shells,         &
                      coreatoms, ierror)

    use ChemShellClusterModule
    use DL_PY2F

    implicit none

    real(kind=8)         , intent(in)  :: cart_cluster_cores(3,*)
    real(kind=8)         , intent(in)  :: cart_cluster_shells(3,*)
    real(kind=8)         , intent(in)  :: charges_cluster_cores(*)
    real(kind=8)         , intent(in)  :: charges_cluster_shells(*)
    integer              , intent(in)  :: coreatoms(*)
    integer              , intent(in)  :: map_cluster_cores(*)
    integer              , intent(in)  :: map_cluster_shells(*)
    integer              , intent(out) :: ierror

    integer     , pointer              :: znums_frag(:), znums_cluster(:)
!    real(kind=8) :: displace(3,max_shel)

    type(PyType), pointer              :: shellsPtr
    integer                            :: i
    integer                            :: natoms_frag, nshells_frag, natoms_cluster, nshells_cluster

    ierror = -1

    call pyFrag%get('npts'   , natoms_frag)
    call pyFrag%get('nshells', nshells_frag)
    call pyCluster%get('npts'   , natoms_cluster)
    call pyCluster%get('nshells', nshells_cluster)

    if(nshells_frag > 0) then
        call PyCluster%get('shells', shellsPtr)
        if(associated(PyShells)) deallocate(PyShells)
        allocate(PyShells, source=ptr2dict(shellsPtr))
    endif

    ! map fragment's znums to cluster's znums
    allocate(znums_frag(natoms_frag))
    allocate(znums_cluster(natoms_cluster))
    call pyFrag%get('znums', znums_frag) 
    znums_cluster(1:natoms_cluster) = znums_frag(map_cluster_cores(1:natoms_cluster))

    ! put the coordinates into the cluster fragment 
    call PyCluster%set('xyz'    , cart_cluster_cores(1:3,1:natoms_cluster))
    call PyCluster%set('charges', charges_cluster_cores(1:natoms_cluster))
    call PyCluster%set('znums'  , znums_cluster)
    call PyCluster%set('map'    , map_cluster_cores(1:natoms_cluster))

    if(nshells_frag > 0) then
        call PyShells%set('coords'   , cart_cluster_shells(1:3,1:nshells_cluster))
        ! YL 05/05/2018: do NOT set displacements for they will be calculated in Python
!        call PyShells%set('displace' , displace(1:3,1:nshells_cluster))
        call PyShells%set('charges'  , charges_cluster_shells(1:nshells_cluster))
        call PyShells%set('coreatoms', coreatoms(1:nshells_cluster)-1)
        call PyShells%set('map'      , map_cluster_shells(1:nshells_cluster))
    endif

    deallocate(znums_frag, znums_cluster)

    ierror = 0

endsubroutine setCluster
!  Copyright (C) 2017 The authors of Py-ChemShell
!
!  This file is part of Py-ChemShell.
!
!  Py-ChemShell is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as
!  published by the Free Software Foundation, either version 3 of the
!  License, or (at your option) any later version.
!
!  Py-ChemShell is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with Py-ChemShell.  If not, see
!  <http://www.gnu.org/licenses/>.

! YL: better call this module ClusterOptionsModule to store fragment and other information

!    private
!    public init, finalise
!    public get_cluster_size
!    public PyFrag, PyCluster, PyOptions, PyCell, PyField, PyBQs, PyShells
!!    public nneighbours, neighbours, neighb_vectors
!
!    integer(kind=8)            :: ncores
!!    integer(kind=8), pointer   :: nneighbours(:)
!!    integer(kind=8), pointer   :: neighbours(:,:)
!    integer(kind=8), parameter :: MAXCONN = 14
!!    real(kind=8)   , pointer   :: neighb_vectors(:,:)
!    type(dictType) , pointer   :: PyFrag, PyCluster, PyOptions, PyCell, PyField, PyBQs, PyShells


!    type, bind(c) :: frag_pass
        ! This type must match the frag_pass C struct on the python side
!        integer(c_int) :: nat
!        type(c_ptr)    :: ncores, nshells 
!    end type frag_pass
!    type :: fragment
     ! This is our Fortran fragment data structure
!        integer(c_int), dimension(:)  ,pointer  :: ncores
!        integer(c_int), dimension(:)  ,pointer  :: nshells
     !   real(c_double), dimension(:,:),pointer  :: pos
     !   real(c_double), dimension(:)  ,pointer  :: charge
!    end type fragment


!    contains

! **********************************************************************
! **                     Test for convergence                         **
! **********************************************************************
!!****h* DL-FIND/convergence
!!
!! NAME
!! convergence
!!
!! FUNCTION
!! Test if the optimisation is converged
!!
!!
!! DATA
!! $Date$
!! $Rev$
!! $Author$
!! $URL$
!! $Id$
!!
!! COPYRIGHT
!!
!!  Copyright 2007 Johannes Kaestner (kaestner@theochem.uni-stuttgart.de),
!!  Tom Keal (thomas.keal@stfc.ac.uk)
!!
!!  This file is part of DL-FIND.
!!
!!  DL-FIND is free software: you can redistribute it and/or modify
!!  it under the terms of the GNU Lesser General Public License as 
!!  published by the Free Software Foundation, either version 3 of the 
!!  License, or (at your option) any later version.
!!
!!  DL-FIND is distributed in the hope that it will be useful,
!!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!!  GNU Lesser General Public License for more details.
!!
!!  You should have received a copy of the GNU Lesser General Public 
!!  License along with DL-FIND.  If not, see 
!!  <http://www.gnu.org/licenses/>.
!!
!!****
module dlf_convergence
  use dlf_parameter_module, only: rk
  real(rk),save     :: tole    ! Energy tolerance
  real(rk),save     :: tolg    ! Maximum gradient tolerance
  real(rk),save     :: tolrmsg ! RMS gradient tolerance
  real(rk),save     :: tols    ! Maximum step tolerance
  real(rk),save     :: tolrmss ! RMS step tolerance
  ! for external providing:
  logical ,save     :: texternal=.false. ! energy, grad, and step set externally
  character(30),save:: message="" 
  real(rk),save     :: vale    ! Energy value
  real(rk),save     :: valg    ! Maximum gradient value
  integer ,save     :: locg(1) ! location of the maximum grad val
  real(rk),save     :: valrmsg ! RMS gradient value
  real(rk),save     :: vals    ! Maximum step value
  integer ,save     :: locs(1) ! location of the maximum step val
  real(rk),save     :: valrmss ! RMS step value
end module dlf_convergence

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* convergence/convergence_test
!!
!! FUNCTION
!!
!! test for convergence and print convergence information
!! gradient and step information is obtained from convergence_set_info
!!
!! If convergence_set_info has not been called previously, it is called
!! from here with the glob%... arrays as input
!!
!! INPUTS
!!
!! glob%tolerance, glob%tolerance_e
!!
!! SYNOPSIS
subroutine convergence_test(icycle,tene,tconv)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stdout,printl
  use dlf_convergence
  implicit none
  integer,intent(in)  :: icycle ! just for printing
  logical,intent(in)  :: tene   ! store current energy as old energy?
  logical,intent(out) :: tconv  ! converged?
  !
  logical  :: le,lrmss,ls,lrmsg,lg
  real(rk) :: svar
! **********************************************************************

  ! This is initialisation in reality
  if(glob%tolerance<0.D0) call dlf_fail("Convergence tolerance < 0")
  tolg=glob%tolerance

  tole=glob%tolerance_e

  tolrmsg= tolg / 1.5D0
  tols=    tolg * 4.D0
  tolrmss= tolg * 8.D0/3.D0

  ! get values from glob%... arrays
  if(.not.texternal) call convergence_set_info("", &
      glob%nivar,glob%energy,glob%igradient,glob%step)
  texternal=.false.

  if(printl>0) write(stdout,'(3a,i5)') &
      "Testing convergence ",trim(message)," in cycle",icycle


  if(glob%toldenergy_conv) then

    ! energy convergence
    svar=abs(vale-glob%oldenergy_conv)
    le=(svar < tole)
    if(printl>0) then
      if(le) then
        write(stdout,1000) "Energy",svar,tole,"yes"
      else 
        write(stdout,1000) "Energy",svar,tole,"no"
      end if
    end if

    ! Maximum step convergence
    ls=(vals < tols)
    if(printl>0) then
      if(ls) then
        write(stdout,1001) "Max step",vals,tols,"yes",locs(1)
      else
        write(stdout,1001) "Max step",vals,tols,"no",locs(1)
      end if
    end if
    
    ! RMS step convergence
    lrmss=(valrmss < tolrmss)
    if(printl>0) then
      if(lrmss) then
        write(stdout,1000) "RMS step",valrmss,tolrmss,"yes"
      else
        write(stdout,1000) "RMS step",valrmss,tolrmss,"no"
      end if
    end if
    
  else
    if(tene) then
      le=.true.
      ls=.true.
      lrmss=.true.
      glob%toldenergy_conv=.true.
    end if
  end if
  if(tene) glob%oldenergy_conv=vale

  ! Maximum gradient convergence
  lg=(valg < tolg)
  if(printl>0) then
    if(lg) then
      write(stdout,1001) "Max grad",valg,tolg,"yes",locg(1)
    else
      write(stdout,1001) "Max grad",valg,tolg,"no",locg(1)
    end if
  end if

  ! RMS gradient convergence
  lrmsg=(valrmsg < tolrmsg)
  if(printl>0) then
    if(lrmsg) then
      write(stdout,1000) "RMS grad",valrmsg,tolrmsg,"yes"
    else
      write(stdout,1000) "RMS grad",valrmsg,tolrmsg,"no"
    end if
  end if

  ! overall convergence
  !tconv=(le.and.lg.and.lrmsg)
  if(tene) then
    tconv=(le.and.lg.and.lrmsg.and.ls.and.lrmss)
  else
    tconv=(lg.and.lrmsg.and.ls.and.lrmss)
  end if

  ! for qTS: ignore step and energy
  if(glob%icoord==190) then
    tconv=(lg)
  end if

  if (printl > 0 .and. tconv) write(stdout,'(a)') "Convergence reached"

  ! send convergence information to task module
  call dlf_task_set_l("CONVERGED",tconv)

! formats
1000 format (a10,2x,es10.4," Target: ",es10.4," converged? ",a4)
1001 format (a10,2x,es10.4," Target: ",es10.4," converged? ",a4,&
          &" component",i6)
end subroutine convergence_test
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* convergence/convergence_get
!!
!! FUNCTION
!!
!! Provides the currently set tolerance to other modules
!!
!! SYNOPSIS
subroutine convergence_get(name,val)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob
  use dlf_convergence
  implicit none
  character(*),intent(in)  :: name
  real(rk)    ,intent(out) :: val
! **********************************************************************
  if(name=="TOLG") then
    val=glob%tolerance
  else if (name=="VALE") then
    val=vale
  else
    call dlf_fail("Wrong name in conv_get")
  end if
end subroutine convergence_get
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* convergence/convergence_set_info
!!
!! FUNCTION
!!
!! used to provide complete convergence info externally (from other
!! modules), rather than using the glob%... arrays
!!
!! SYNOPSIS
subroutine convergence_set_info(msg,nvar,energy,gradient,step)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_convergence
  implicit none
  character(*),intent(in)  :: msg
  integer     ,intent(in)  :: nvar
  real(rk)    ,intent(in)  :: energy
  real(rk)    ,intent(in)  :: gradient(nvar)
  real(rk)    ,intent(in)  :: step(nvar)
! **********************************************************************
  message=msg
  texternal=.true.
  vale=energy
  valg=maxval(abs(gradient(:)))
  locg=maxloc(abs(gradient(:)))
  valrmsg=sqrt(sum(gradient(:)**2)/dble(nvar))
  vals=maxval(abs(step(:)))
  locs=maxloc(abs(step(:)))
  valrmss=sqrt(sum(step(:)**2)/dble(nvar))

end subroutine convergence_set_info
!!****
    

!character(:) function get_dlf_home() bind(c)
!
!  return "~/home/dl_field/4.2/lib"
!
!endfunction
!character(:) function get_output_dir() bind(c)
!
!  return "_dl_field_output"
!
!endfunction
integer(c_int) function chemsh_get_nqmatoms() bind(c, name='chemsh_get_nqmatoms') result(c_nqmatoms)

    use, intrinsic :: iso_c_binding
    use ChemShellDLFieldModule, only : nqmatoms

    c_nqmatoms = nqmatoms

endfunction chemsh_get_nqmatoms
integer(c_int) function chemsh_get_nexcludes() bind(c, name='chemsh_get_nexcludes') result(c_nexcludes)

    use, intrinsic :: iso_c_binding
    use ChemShellDLFieldModule, only : nexcludes

    c_nexcludes = nexcludes

endfunction chemsh_get_nexcludes
integer(c_int) function chemsh_get_natoms() bind(c, name='chemsh_get_natoms') result(c_natoms)

    use, intrinsic :: iso_c_binding
    use DL_PY2F
    use ChemShellDLFieldModule, only : natoms

!    type(PyType)            :: fragPtr
!    type(dictType), pointer :: PyFrag
!    real(kind=8)            :: intbuff(natoms)
!
!    call PyOptions%get('frag', fragPtr)
!    allocate(PyFrag, source=ptr2dict(fragPtr))
!    call PyFrag%get('natoms', natoms)

    c_natoms = natoms

endfunction chemsh_get_natoms
integer(c_int) function chemsh_get_qmatoms(c_qmatoms) bind(c, name='chemsh_get_qmatoms') result(ierror)

    use, intrinsic :: iso_c_binding
    use ChemShellDLFieldModule, only : PyOptions, nqmatoms

    integer(c_int) :: c_qmatoms(nqmatoms)

    integer        :: intbuff(nqmatoms)

    ierror = 1

    if(nqmatoms.eq.0) then
        return
    endif

    call PyOptions%get('qmatoms', intbuff)

    ! YL: DL_POLY starts from 1 rather than 0
    c_qmatoms(:) = intbuff(:) + 1

    ierror = 0

endfunction chemsh_get_qmatoms
integer(c_int) function chemsh_get_exclude(c_iexclude, c_excludes) bind(c, name='chemsh_get_exclude') result(ierror)

    use, intrinsic :: iso_c_binding
    use ChemShellDLFieldModule, only : PyOptions, nexcludes

    integer(c_int), value :: c_iexclude
    integer(c_int)        :: c_excludes(2)

    integer        :: intbuff(2,nexcludes)

    ierror = 1

    if(nexcludes.eq.0) then
        return
    endif

    call PyOptions%get('exclude', intbuff)

    ! YL: DL_POLY starts from 1 rather than 0
    c_excludes(:) = intbuff(:,c_iexclude+1) + 1

    ierror = 0

endfunction chemsh_get_exclude
integer(c_int) function chemsh_get_charges(c_charges) bind(c, name='chemsh_get_charges') result(ierror)

    use, intrinsic :: iso_c_binding
    use DL_PY2F
    use ChemShellDLFieldModule, only : PyOptions, natoms

    real(c_double)          :: c_charges(natoms)

    type(PyType)  , pointer :: fragPtr
    type(dictType), pointer :: PyFrag
    real(kind=8)            :: dblbuff(natoms)

    integer :: intbuff

    call PyOptions%get('frag', fragPtr)
    allocate(PyFrag, source=ptr2dict(fragPtr))
    call PyFrag%get('charges', dblbuff)
    call PyFrag%get('npts', intbuff)

    c_charges(:) = dblbuff(:)

    deallocate(PyFrag)
    ierror = 0

endfunction chemsh_get_charges
logical(c_bool) function is_chemsh() bind(c, name='is_chemsh') result(ischemsh)

    use, intrinsic :: iso_c_binding

    ischemsh = .true.

endfunction is_chemsh
logical(c_bool) function chemsh_atom_in_qmatoms(iatom) bind(c, name='chemsh_atom_in_qmatoms') result(in_qmatoms)

    use, intrinsic :: iso_c_binding
    use ChemShellDLFieldModule, only : PyOptions, nqmatoms

    integer(c_int), value :: iatom
    integer               :: j, intbuff(nqmatoms)

    in_qmatoms = .false.

    if(nqmatoms.eq.0) then
        return
    endif

    call PyOptions%get('qmatoms', intbuff)

    ! YL: DL_POLY starts from 1 rather than 0
    intbuff(:) = intbuff(:) + 1

    do j = 1, nqmatoms
        if(intbuff(j).eq.iatom) then
            in_qmatoms = .true.
            return
        endif
    enddo

endfunction chemsh_atom_in_qmatoms

! *******************************************************************************
! *   Copyright (C) 2007 - 2015 by J.A.Purton                                   *
! *   john.purton[@]stfc.ac.uk                                                  *
! *                                                                             *
! *   Contributors:                                                             *
! *   -------------                                                             *
! *   A.V.Brukhno (C) 2015-2018                                                 *
! *   andrey.brukhno[@]stfc.ac.uk abrukhno[@]gmail.com                          *
! *   - overall optimizations (general MC scheme, energy calculus and MC steps) *
! *   - Free Energy Difference (FED) & order parameters (fed_*_module.f90)      *
! *   - Replica Exchange (RE) & RE-FED extension (rep_exchange_module.f90)      *
! *   - VdW and general potential forms (vdw_*_module.f90 etc)                  *
! *   - User-defined analytical short-ranged VdW forms (vdw_*.f90 & user_*.inc) *
! *   - planar pore 'slit' & 'slab' constraints (slit_module.f90)               *
! *   - planar pore external potentials (external_potential_module.f90)         *
! *   - mean-field approximation (MFA) for long-range electrostatics in slit    *
! *   - refactor of exclusion lists and neighbour lists, incl. optimizations    *
! *   - refactor of atom and molecule selection to avoid 'empty' MC attempts    *
! *   - Cavity-Bias GCMC: optimised sampling on a 3D grid or mesh               *
! *                                                                             *
! *   T.L.Underwood (C) 2015-2020                                               *
! *   t.l.Underwood[@]bath.ac.uk                                                *
! *   - Lattice/Phase-Switch  MC methodology (psmc_*.f90)                       *
! *   - transition matrix (TM) FED MC methodology                               *
! *   - algorithm optimizations (gcmc_*_module.90, MC steps etc)                *
! *   - random number generator debugging & optimization                        *
! *   - FED-GCMC, the counterpart of FED-NPT, samping is done in N instead of V *
! *   - Gibbs Ensemble revision, debugging and optimization                     *
! *   - orientation-dependent potentials (Gay-Berne) (spin_module.f90)          *
! *   - long-range VdW correction                                               *
! *   - general bug fixes                                                       *
! *                                                                             *
! *   R.J.Grant (C) 2016-17                                                     *
! *   r.j.grant[@]bath.ac.uk                                                    *
! *   - extra potential forms (VDW, vdw_direct_module.f90)                      *
! *   - Ewald sums optimization (field.f90, mc_moves.f90, lattice_module.f90)   *
! *   - initial neighbour-list optimization (field.f90 etc)                     *
! *   - initial exclusion-list optimization (field.f90 etc)                     *
! *                                                                             *
! *******************************************************************************

!> @brief
!> - DL_MONTE-2 main program unit
!> @usage 
!> - @stdusage 
!> - @stdspecs
!> @using 
!> - `constants_module`
!> - `control_type`
!> - `control_module, only : initialise_defaults, read_control`
!> - `comms_omp_module`
!> - `comms_mpi_module`
!> - `parallel_loop_module, only : initialise_communication, initialise_loops`
!> - `field_module, only : readfield`

module DLMONTEModule

    private
    
    public :: dl_monte

    integer :: dlp_comm_world
    
    contains
    
    !> The main program of DL_MONTE-2
    subroutine dl_monte(comm_chemsh)
    
    !    use kinds_f90
        use constants_module
        use control_type
        use comms_omp_module
        use comms_mpi_module
        use control_module
        use parallel_loop_module, only : initialise_communication, initialise_loops
        use field_module, only : readfield
    
        implicit none
    
        ! ChemShell MPI communicator
    
        integer, intent(in) :: comm_chemsh
    
        type(control) :: job
    
        integer :: n_configs
        real(kind = wp) :: shortrangecut, vdwrcut, energyunit
    
        uout = 66

        ! YL: initialise ChemShell parallel communication
        call init_chemsh_comms(comm_chemsh)
        call init_omp_comms()
    
        !AB: define the only 'master' for the time being
        !AB: if replica-exchange is invoked, workgroups are created with 'master' defined per workgroup
        !master = (idnode == 0)
    
        call initialise_communication_chemshell()
    
        !open output file
        if( master ) open(uout, file='OUTPUT.000')
    
        if( master ) then
    
            write(uout,'(/,22(19x,a,/),3(19x,a,i10,a,/),36(19x,a,/))')&
                "===================================================================", &
                "* * *                                                         * * *", &
                "* * *            D L - M O N T E - v e r. 2.0 (7)             * * *", &
                "* * *                                                         * * *", &
                "* * *           STFC / CCP5 - Daresbury Laboratory            * * *", &
                "* * *                 program library  package                * * *", &
                "* * *                                                         * * *", &
                "* * *     general purpose Monte Carlo simulation software     * * *", &
                "* * *                                                         * * *", &
                "* * *     version:  2.07  / January 2020                      * * *", & !10
                "* * *     author :  J. A. Purton (2007-2015)                  * * *", &
                "* * *     website:  https://gitlab.com/dl_monte               * * *", &
                "* * *     -----------------------------------------------     * * *", &
                "* * *     co-authors:                                         * * *", &
                "* * *     -------------                                       * * *", &
                "* * *     A. V. Brukhno   - Free Energy Diff, planar pores    * * *", &
                "* * *     T. L. Underwood - Lattice/Phase-Switch MC methods   * * *", &
                "* * *     R. J. Grant     - extra potentials, optimizations   * * *", &
                "* * *     -----------------------------------------------     * * *", &
                "* * *                                                         * * *", & !20
                "* * *     current execution:                                  * * *", &
                "* * *     ==================                                  * * *", &
                "* * *     number of nodes/CPUs/cores: ",mxnode,"              * * *", &
                "* * *     number of threads per node: ",thread_num,"              * * *", &
                "* * *     number of threads employed: ",  mxthread,"              * * *", &
                "* * *                                                         * * *", &
                "* * * ======================================================= * * *", &
                "* * * Publishing data obtained with DL_MONTE? - please cite:  * * *", &
                "* * * ------------------------------------------------------- * * *", &
                "* * *                                                         * * *", & !30
                "* * *  A. V. Brukhno et al., Molecular Simulation 2019,       * * *", &
                "* * *  DOI: 10.1080/08927022.2019.1569760,                    * * *", &
                "* * *  `DL_MONTE: a multipurpose code for Monte Carlo         * * *", &
                "* * *  simulation`                                            * * *", &
                "* * *                                                         * * *", &
                "* * *  J. A. Purton, J. C. Crabtree & S. C. Parker,           * * *", &
                "* * *  Molecular Simulation 2013, 39 (14-15), 1240-1252       * * *", &
                "* * *  `DL_MONTE: A general purpose program for parallel      * * *", &
                "* * *  Monte Carlo simulation`                                * * *", &
                "* * *                                                         * * *", & !40
                "* * * ------------------------------------------------------- * * *", &
                "* * * if using Lattice-Switch method, please also cite:       * * *", &
                "* * * ------------------------------------------------------- * * *", &
                "* * *              Bruce A.D., Wilding N.B. and G.J. Ackland, * * *", &
                "* * *                         Phys. Rev. Lett. 1997, 79, 3002 * * *", &
                "* * *    `Free Energy of Crystalline Solids: A Lattice-Switch * * *", &
                "* * *                                      Monte Carlo Method`* * *", &
                "* * * ------------------------------------------------------- * * *", &
                "* * * if using Planar Pore (slit) geometry, please also cite: * * *", &
                "* * * ------------------------------------------------------- * * *", & !50
                "* * *                                         Broukhno A. V., * * *", &
                "* * *     `Free Energy and Surface Forces in polymer systems: * * *", &
                "* * *                          Monte Carlo Simulation Studies`* * *", &
                "* * *                           PhD Thesis, Lund, Sweden 2003 * * *", &
                "* * *                                                         * * *", &
                "* * *    Brukhno A. V., Akinshina A., Coldrick Z., Nelson A., * * *", &
                "* * *                                             and Auer S. * * *", &
                "* * *                              Soft Matter. 2011, 7, 1006 * * *", &
                "* * *               `Phase phenomena in supported lipid films * * *", &
                "* * *                        under varying electric potential`* * *", & !60
                "==================================================================="
                !"===================================================================", &
                !"******************************************************************"
    
        endif
    
        !get the forcefield and species
        call readfield(n_configs, shortrangecut, vdwrcut, energyunit)
    
        if (master) open(uctrl,file='CONTROL', status = 'old')
    
        call initialise_defaults(job, n_configs, shortrangecut, vdwrcut, energyunit)
        call read_control(job)
    
        if (master) close(uctrl)
    
        !setup parallel loop counters for reciprocal and two body interactions
        call initialise_loops(job%coultype, job%distribgvec, job%lparallel_atom)
    
        !start the simulation
        call run(job, n_configs)
        
        call dealloc_control(job)
    
        !AB: only master(s) close/open the files
        if( master ) then
            write(uout,*) 'normal exit '
            close(uout)
        endif
        call flush(6)
    
!        call exit_mpi_comms()
!        stop
    
    endsubroutine dl_monte
    subroutine run(job, n_confs)
    
        use constants_module,  only : uout
        use montecarlo_module, only : normalmc
        use control_type
        implicit none
    
        type(control), intent(inout) :: job
    !scp    integer, intent(in) :: n_confs : 
    !A dummy argument with the INTENT(IN) attribute shall not appear in a variable definition context 
        integer :: n_confs
    
        if( trim(adjustL(job % simulationmode)) == "trajconv" ) then
    
            !include "traj_convert.f90"
    
            call traj_convert(job, n_confs)
    
            return
    
        else if (job % useddmc) then
    
    !       call ddmc(job)
    
            call cry(uout,'(/,1x,a,/)', &
                     "ERROR: simulation mode 'DMC' is not implemented yet "//&
                    &" - nothing to do !!!",999)
    
        else
    
            call normalmc(job, n_confs)
    
        endif
    
    endsubroutine run
    subroutine init_chemsh_comms(comm_chemsh)
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    !
    ! dl_poly_3 subroutine for initialisation communication harness
    ! determining the MPI precision, and node identification and count
    !
    ! copyright - daresbury laboratory
    ! author    - i.t.todorov may 2004
    !
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    
!        use mpi
        use kinds_f90
        use comms_mpi_module

        Implicit None

        integer       :: comm_chemsh
        ! YL: from comms_mpi_module-PRL.f90
!        integer, save :: mpi_wp, idnode, mxnode
!        logical, save :: master, is_serial, is_parallel
!        integer       :: ierr
    
        !Call MPI_INIT(ierr)
        call MPI_COMM_DUP(comm_chemsh, dlp_comm_world, ierr)
    
        If      (wp == Selected_Real_Kind(6,30))  Then
           mpi_wp = MPI_REAL
        Else If (wp == Selected_Real_Kind(14,300))  Then
    
    ! MPI_REAL8 is apparently not in the strict MPI2 standard
    ! It is just an optional data type in the FORTRAN Bindings
           mpi_wp = MPI_DOUBLE_PRECISION
        Else If (wp == Selected_Real_Kind(30,300)) Then
           mpi_wp = MPI_REAL16
        Else
           Call error(1000)
        End If
    
        Call MPI_COMM_RANK(dlp_comm_world, idnode, ierr)
        Call MPI_COMM_SIZE(dlp_comm_world, mxnode, ierr)
    
        !AB: initially there is only one 'master'
        !AB: more are defined in parallel_loop_module::setup_workgroups()
        master = ( mxnode==1.or.idnode==0 )
    
        is_serial   = ( mxnode == 1 )
        is_parallel = .not.is_serial
    
    endsubroutine init_chemsh_comms
    !> standard/default initialisation of MPI_COMM_WORLD
    ! this routine is not called from anywhere (why ???)
    subroutine initialise_communication_chemshell()
   
!        use kinds_f90
        use parallel_loop_module
        use comms_omp_module, only : idthread, mxthread
!        use comms_mpi_module, only : master, idnode, mxnode, mpi_comm_group, mpi_comm_master
        use comms_mpi_module
   
        implicit none
   
        tb_start_atm = 1
        tb_step_atm = 1
        tb_start_mol = 1
        tb_step_mol = 1
        rcp_start = 1
        rcp_step = 1
   
        idgrp = 0
        grp_rank = 1
        wkgrp_size = 1
   
        if (mxnode > 1) then
   
            idgrp = 0
            grp_rank = idnode
            wkgrp_size = mxnode
   
            mpi_comm_group  = dlp_comm_world
            ! YL: I don't get the purpose to fake the master node using MPI_COMM_NULL. we keep it here for now 
            mpi_comm_master = MPI_COMM_NULL
   
        endif
   
        !set all processors to slave (except for single processor jobs or node 0) - this will be changed later
        master = .false.
        if (mxnode == 1 .or. idnode == 0) master = .true.
   
    endsubroutine initialise_communication_chemshell
endmodule DLMONTEModule

!  Copyright (C) 2017 The authors of Py-ChemShell
!
!  This file is part of Py-ChemShell.
!
!  Py-ChemShell is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as
!  published by the Free Software Foundation, either version 3 of the
!  License, or (at your option) any later version.
!
!  Py-ChemShell is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with Py-ChemShell.  If not, see
!  <http://www.gnu.org/licenses/>.

! YL below are very dangeous hacks!! could cause unpredictable consequences
logical function tce_imaginary() result(result)
    result = .false.
endfunction
logical function ncc_driver() result(result)
    result = .false.
endfunction
subroutine offl_mic_ccsd_t_singles_l_1
endsubroutine
subroutine residual() bind(c)
endsubroutine
subroutine c3db_rc_pfft3_queue_cilled
endsubroutine
subroutine magnus_exp_bch
endsubroutine

!!****h* utilities/dlf_allocate
!!
!! NAME
!! allocate
!!
!! FUNCTION
!! The allocation module
!!
!! This module should replace allocate and deallocate statements
!! it can only cover inctrinsic types, no derived types.
!!
!! it does compile and work with:
!!    g95
!!    ifort
!!    gfortran
!!
!! It does not work with:
!!    pgf95
!!
!! The preprocessor option OLDALLOC allows to fall back to traditional
!! f90 allcoation (to make the code run with pgf95). All calls to 
!! "call allocate(A,B)" are then replaced by an sed script (in the makefile)
!! by "allocate(A(B))"
!!
!! It allows for some bookkeeping of the storage, and a report of how much
!! memory had been used.
!!
!! In principle it can be used to define something like a high watermark
!! to make it impossible to allocate more memory than the watermark.
!!
!! DATA
!!  $Date$
!!  $Rev$
!!  $Author$
!!  $URL$
!!  $Id$
!!
!! COPYRIGHT
!!
!!  Copyright 2007 Johannes Kaestner (kaestner@theochem.uni-stuttgart.de),
!!  Tom Keal (thomas.keal@stfc.ac.uk)
!!
!!  This file is part of DL-FIND.
!!
!!  DL-FIND is free software: you can redistribute it and/or modify
!!  it under the terms of the GNU Lesser General Public License as 
!!  published by the Free Software Foundation, either version 3 of the 
!!  License, or (at your option) any later version.
!!
!!  DL-FIND is distributed in the hope that it will be useful,
!!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!!  GNU Lesser General Public License for more details.
!!
!!  You should have received a copy of the GNU Lesser General Public 
!!  License along with DL-FIND.  If not, see 
!!  <http://www.gnu.org/licenses/>.
!!
!! SOURCE
module dlf_allocate

#ifdef OLDALLOC 

contains

  ! only dummies. These subroutines should never be called
  subroutine allocate_report
  end subroutine allocate_report
  subroutine allocate
  end subroutine allocate
  subroutine deallocate
  end subroutine deallocate

#else 

  use dlf_parameter_module, only: rk
  implicit none

  Public :: allocate
  Public :: deallocate
  Public :: allocate_report

  interface allocate
    module procedure allocate_r1
    module procedure allocate_r2
    module procedure allocate_r3
    module procedure allocate_i1
    module procedure allocate_i2
    module procedure allocate_l1
  end interface

  interface deallocate
    module procedure deallocate_r1
    module procedure deallocate_r2
    module procedure deallocate_r3
    module procedure deallocate_i1
    module procedure deallocate_i2
    module procedure deallocate_l1
  end interface

  private
  integer           :: fail
  logical,parameter :: tretry=.true. ! In case of an error, do the (de)allocate again.
        ! This will kill the program, but provide the error message from the compiler
  integer,save      :: stdout=6
  integer,save      :: stderr=0
  logical,save      :: verbose=.false.
  integer,save      :: current(4)=0 ! real, integer, logical, complex
  integer,parameter :: a_kind(4)=(/kind(1.D0),kind(1),kind(.true.),2*kind((1.D0,1.D0)) /) 
  integer,save      :: storage=0
  integer,save      :: maxstorage=0

contains
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
! %%                        Real Arrays                               %%
! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* dlf_allocate/allocate
!!
!! FUNCTION
!!
!! Allocate an array of type real or integer or logical.
!! In case of a real array, up to three dimensions are currently allowed,
!! two in integer arrays, and one in logical arrays
!!
!! SYNOPSIS
!  to be called by something like
!  call allocate (array,ubound1,ubound2)
!
!  the module then splits this to 
!  subroutine allocate_r1(array,ubound)
!  subroutine allocate_r2(array,ubound1,ubound2), ...
!
!! SOURCE
! ----------------------------------------------------------------------
  subroutine allocate_r1(array,ubound)
    real(rk),allocatable :: array(:)
    integer ,intent(in)  :: ubound

    if(verbose) write(stdout,"('Allocating real(:) array. Size:',i8)")&
        ubound

    allocate(array(ubound),stat=fail)

    if(fail/=0) then
      write(stderr,"('Allocation error in allocate_r1')")
      if(tretry) allocate(array(ubound))
      call allocate_error(fail)
    end if

    call allocate_add(1,ubound)

  end subroutine allocate_r1

! ----------------------------------------------------------------------
  subroutine allocate_r2(array,ubound1,ubound2)
    real(rk),allocatable :: array(:,:)
    integer ,intent(in)  :: ubound1,ubound2

    if(verbose) write(stdout,"('Allocating real(:,:) array. Size:',i8)")&
        ubound1*ubound2

    allocate(array(ubound1,ubound2),stat=fail)

    if(fail/=0) then
      write(stderr,"('Allocation error in allocate_r2')")
      if(tretry) allocate(array(ubound1,ubound2))
      call allocate_error(fail)
    end if

    call allocate_add(1,ubound1*ubound2)

  end subroutine allocate_r2

! ----------------------------------------------------------------------
  subroutine allocate_r3(array,ubound1,ubound2,ubound3)
    real(rk),allocatable :: array(:,:,:)
    integer ,intent(in)  :: ubound1,ubound2,ubound3

    if(verbose) write(stdout,"('Allocating real(:,:,:) array. Size:',i8)")&
        ubound1*ubound2*ubound3

    allocate(array(ubound1,ubound2,ubound3),stat=fail)

    if(fail/=0) then
      write(stderr,"('Allocation error in allocate_r3')")
      if(tretry) allocate(array(ubound1,ubound2,ubound3))
      call allocate_error(fail)
    end if

    call allocate_add(1,ubound1*ubound2*ubound3)

  end subroutine allocate_r3
!!****

!!****f* dlf_allocate/deallocate
!!
!! FUNCTION
!!
!! Deallocate an array of type real or integer or logical.
!! In case of a real array, up to three dimensions are currently allowed,
!! two in integer arrays, and one in logical arrays
!!
!! SYNOPSIS
!  to be called by something like
!  call deallocate (array)
!
!  the module then splits this to 
!  subroutine deallocate_r1(array)
!  subroutine deallocate_r2(array), ...
!
!! SOURCE
! ----------------------------------------------------------------------
  subroutine deallocate_r1(array)
    real(rk),allocatable :: array(:)
    integer              :: ubound

    ubound=size(array)
    if(verbose) write(stdout,"('Dellocating real(:) array. Size:',i8)")&
        ubound

    deallocate(array,stat=fail)

    if(fail/=0) then
      write(stderr,"('Deallocation error in deallocate_r1')")
      if(tretry) deallocate(array)
      call allocate_error(fail)
    end if

    call allocate_sub(1,ubound)

  end subroutine deallocate_r1

! ----------------------------------------------------------------------
  subroutine deallocate_r2(array)
    real(rk),allocatable :: array(:,:)
    integer              :: ubound

    ubound=size(array)
    if(verbose) write(stdout,"('Dellocating real(:,:) array. Size:',i8)")&
        ubound

    deallocate(array,stat=fail)

    if(fail/=0) then
      write(stderr,"('Deallocation error in deallocate_r2')")
      if(tretry) deallocate(array)
      call allocate_error(fail)
    end if

    call allocate_sub(1,ubound)

  end subroutine deallocate_r2

! ----------------------------------------------------------------------
  subroutine deallocate_r3(array)
    real(rk),allocatable :: array(:,:,:)
    integer              :: ubound

    ubound=size(array)
    if(verbose) write(stdout,"('Dellocating real(:,:,:) array. Size:',i8)")&
        ubound

    deallocate(array,stat=fail)

    if(fail/=0) then
      write(stderr,"('Deallocation error in deallocate_r3')")
      if(tretry) deallocate(array)
      call allocate_error(fail)
    end if

    call allocate_sub(1,ubound)

  end subroutine deallocate_r3
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
! %%                      Integer Arrays                              %%
! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

! ----------------------------------------------------------------------
  subroutine allocate_i1(array,ubound)
    integer ,allocatable :: array(:)
    integer ,intent(in)  :: ubound

    if(verbose) write(stdout,"('Allocating integer(:) array. Size:',i8)")&
        ubound

    allocate(array(ubound),stat=fail)

    if(fail/=0) then
      write(stderr,"('Allocation error in allocate_i1')")
      if(tretry) allocate(array(ubound))
      call allocate_error(fail)
    end if

    call allocate_add(2,ubound)

  end subroutine allocate_i1

! ----------------------------------------------------------------------
  subroutine allocate_i2(array,ubound1,ubound2)
    integer ,allocatable :: array(:,:)
    integer ,intent(in)  :: ubound1,ubound2

    if(verbose) write(stdout,"('Allocating integer(:,:) array. Size:',i8)")&
        ubound1*ubound2

    allocate(array(ubound1,ubound2),stat=fail)

    if(fail/=0) then
      write(stderr,"('Allocation error in allocate_i2')")
      if(tretry) allocate(array(ubound1,ubound2))
      call allocate_error(fail)
    end if

    call allocate_add(2,ubound1*ubound2)

  end subroutine allocate_i2

! ----------------------------------------------------------------------
  subroutine deallocate_i1(array)
    integer ,allocatable :: array(:)
    integer              :: ubound

    ubound=size(array)
    if(verbose) write(stdout,"('Deallocating integer(:) array. Size:',i8)")&
        ubound

    deallocate(array,stat=fail)

    if(fail/=0) then
      write(stderr,"('Deallocation error in deallocate_i1')")
      if(tretry) deallocate(array)
      call allocate_error(fail)
    end if

    call allocate_sub(2,ubound)

  end subroutine deallocate_i1

! ----------------------------------------------------------------------
  subroutine deallocate_i2(array)
    integer ,allocatable :: array(:,:)
    integer              :: ubound

    ubound=size(array)
    if(verbose) write(stdout,"('Deallocating integer(:,:) array. Size:',i8)")&
        ubound

    deallocate(array,stat=fail)

    if(fail/=0) then
      write(stderr,"('Deallocation error in deallocate_i2')")
      if(tretry) deallocate(array)
      call allocate_error(fail)
    end if

    call allocate_sub(2,ubound)

  end subroutine deallocate_i2

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
! %%                      Logical Arrays                              %%
! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

! ----------------------------------------------------------------------
  subroutine allocate_l1(array,ubound)
    logical ,allocatable :: array(:)
    integer ,intent(in)  :: ubound

    if(verbose) write(stdout,"('Allocating logical(:) array. Size:',i8)")&
        ubound

    allocate(array(ubound),stat=fail)

    if(fail/=0) then
      write(stderr,"('Allocation error in allocate_l1')")
      if(tretry) allocate(array(ubound))
      call allocate_error(fail)
    end if

    call allocate_add(3,ubound)

  end subroutine allocate_l1

! ----------------------------------------------------------------------
  subroutine deallocate_l1(array)
    logical ,allocatable :: array(:)
    integer              :: ubound

    ubound=size(array)
    if(verbose) write(stdout,"('Deallocating logical(:) array. Size:',i8)")&
        ubound

    deallocate(array,stat=fail)

    if(fail/=0) then
      write(stderr,"('Deallocation error in deallocate_l1')")
      if(tretry) deallocate(array)
      call allocate_error(fail)
    end if

    call allocate_sub(3,ubound)

  end subroutine deallocate_l1

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  subroutine allocate_error(fail)
    integer, intent(in) :: fail
    print*,"Error number",fail
    ! g95: 211 - allocated
    !      210 - Operating system error: Cannot allocate memory
    ! ifort: 151 allocated
    !        179 too large Cannot allocate array - overflow on array size calculation.
    call dlf_mpi_abort()
    call exit(1)
  end subroutine allocate_error

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  subroutine allocate_add(type,a_size)
    integer,intent(in) :: type
    integer,intent(in) :: a_size

    if(type>4.or.type<1) then
       call dlf_mpi_abort()
       stop "Wrong type in allocate_add"
    end if
    current(type)=current(type)+a_size
    storage=storage + a_size * a_kind(type)
    if(storage>maxstorage) maxstorage=storage
    if(verbose) write(stdout,'("Current storage: ",i8," Max. Storage: ",&
        &i8)') storage,maxstorage
  end subroutine allocate_add

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  subroutine allocate_sub(type,a_size)
    integer,intent(in) :: type
    integer,intent(in) :: a_size

    if(type>4.or.type<1) then
       call dlf_mpi_abort()
       stop "Wrong type in allocate_sub"
    end if

    current(type)=current(type)-a_size
    storage=storage - a_size * a_kind(type)
    if(verbose) write(stdout,'("Current storage: ",i8," Max. Storage: ",&
        &i8)') storage,maxstorage
  end subroutine allocate_sub

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* dlf_allocate/allocate_report
!!
!! FUNCTION
!!
!! Report on maximum and currently allocated memory
!!
!! SYNOPSIS
  subroutine allocate_report
!! SOURCE
    if(storage/=0) then
      write(stdout,1000) "Current memory usage",dble(storage)/1024.D0,&
          "kB"
      write(stdout,"(a,i8)") "Currently allocated real values    ",current(1)
      write(stdout,"(a,i8)") "Currently allocated integer values ",current(2)
      write(stdout,"(a,i8)") "Currently allocated logical values ",current(3)
      write(stdout,"(a,i8)") "Currently allocated complex values ",current(4)
    end if
    write(stdout,1000) "Maximum memory usage",dble(maxstorage)/1024.D0,&
        "kB"
    call flush(stdout)
    call dlf_mpi_memory(storage,maxstorage)
    ! real number
1000 format (t1,'................................................', &
         t1,a,' ',t50,es10.4,1x,a)
  end subroutine allocate_report
!!****

#endif

end module dlf_allocate

!  Copyright (C) 2017 The authors of Py-ChemShell
!
!  This file is part of Py-ChemShell.
!
!  Py-ChemShell is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as
!  published by the Free Software Foundation, either version 3 of the
!  License, or (at your option) any later version.
!
!  Py-ChemShell is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with Py-ChemShell.  If not, see
!  <http://www.gnu.org/licenses/>.

subroutine getfilenames(infile, outfile, len)
    character(len=len), intent(out) :: infile, outfile
    integer           , intent(in)  :: len

    integer, external :: ipg_nnodes

    ! FIXME: dynamically obtain the names
    infile  = "_gamess-uk.in"
    outfile = "_gamess-uk.out"

endsubroutine getfilenames
integer function gamess_chemsh_comm() result(communicator)

    use ChemShellParallelModule, only : chemsh_parallel

    ! chemsh_comm_workgroup in TCS's src/interface_gamess_2/link_gamess.c
    communicator = chemsh_parallel%comm_workgroup

endfunction gamess_chemsh_comm
! always required by GAMESS-UK/ChemShell interface: see int default_heap_() in TCS's src/chemsh/chem.c and GAMESS-UK's m4/machscf.m
integer function default_heap() result(heap)

    heap = 20000000

endfunction default_heap
! TO IMPLEMENT
subroutine gamessjumpout(icode)

    integer :: icode
    integer :: ijunk
    integer(kind=8) :: gms_jmp_buf

!    call longjmp(gms_jmp_buf,ijunk)
    print *, "### gamessjumpout..."

endsubroutine gamessjumpout

! **********************************************************************
! **        Driver file for dl_find                                   **
! ** isystem:                                                         **
! **  1 - Mueller-Brown potential (2 Dim)                             **
! **  2 - 3 Lennard-Jones Atoms (9 Dim)                               **
! **  3 - 100 Lennard-Jones Atoms (300 Dim)                           **
! **  4 - Eckart Barrier (1 Dim)                                      **
! **  5 - Quartic potential (1 Dim)                                   **
! **  6 - Vibrational sufaces by molpro                               **
! **  7 - A potential for which the MEP splits in two (2 Dim)         **
! **        (by Judith Rommel)                                        **
! **  8 - A polynomial potential in more dimensions                   **
! **                                                                  **
! **********************************************************************

!! COPYRIGHT
!!
!!  Copyright 2007 Johannes Kaestner (kaestner@theochem.uni-stuttgart.de),
!!  Tom Keal (thomas.keal@stfc.ac.uk)
!!
!!  This file is part of DL-FIND.
!!
!!  DL-FIND is free software: you can redistribute it and/or modify
!!  it under the terms of the GNU Lesser General Public License as 
!!  published by the Free Software Foundation, either version 3 of the 
!!  License, or (at your option) any later version.
!!
!!  DL-FIND is distributed in the hope that it will be useful,
!!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!!  GNU Lesser General Public License for more details.
!!
!!  You should have received a copy of the GNU Lesser General Public 
!!  License along with DL-FIND.  If not, see 
!!  <http://www.gnu.org/licenses/>.
!!

module driver_module
  use dlf_parameter_module, only: rk
 ! use vib_pot !uncommented to have a running system
  integer,parameter :: isystem=3 ! decide which system to run on
! variables for non-continuous differentiable MEP potential
  real(rk) :: smallbarvar !parameter to control the hight of the small barrier
end module driver_module

module driver_parameter_module
  use dlf_parameter_module
  ! variables for Mueller-Brown potential
  real(rk) :: acappar(4),apar(4),bpar(4),cpar(4),x0par(4),y0par(4)
  ! variables for Lennard-Jones potentials
  real(rk),parameter :: epsilon=1.D-1
  real(rk),parameter :: sigma=1.D0
!!$  ! variables for the Eckart potential (1D), taken from Andri's thesis
  real(rk),parameter :: Va= -0.191D0*0.0367493254D0 !2nd factor is conversion to E_h from eV
  real(rk),parameter :: Vb=  1.343D0*0.0367493254D0 !2nd factor is conversion to E_h from eV
  real(rk),parameter :: alpha= 5.762D0/1.889725989D0 !2nd factor is for conversion from Angstrom to Bohr (a.u.)

  ! modified Eckart potential to have a comparison
!!$  REAL(8), PARAMETER :: Va= -0.091D0*0.0367493254D0  !2nd factor is conversion to E_h from eV
!!$  REAL(8), PARAMETER :: Vb=  1.343D0*0.0367493254D0  !2nd factor is conversion to E_h from eV
!!$  REAL(8), PARAMETER :: alpha =20.762D0/1.889725989D0 
!!$  real(rk),parameter :: Va= -0.191D0*0.0367493254D0 !2nd factor is conversion to E_h from eV
!!$  real(rk),parameter :: Vb=  1.343D0*0.0367493254D0 !2nd factor is conversion to E_h from eV
!!$  real(rk),parameter :: alpha= 20.762D0/1.889725989D0 !2nd factor is for conversion from Angstrom to Bohr (a.u.)

  ! "fitted" to Glum SN-1-Glu, E->D
!  real(rk),parameter :: Va= 0.D0 ! symmetric (real: almost symmetric)
!  real(rk),parameter :: Vb= 4.D0*74.81D0/2625.5D0 ! 4*barrier for symmetric
!  real(rk),parameter :: alpha= 2.38228D0 

!!$  ! Eckart for comparison with scattering
!!$  real(rk),parameter :: Va= -100.D0
!!$  real(rk),parameter :: Vb= 373.205080756888D0
!!$  real(rk),parameter :: alpha= 7.07106781186547D0

  real(rk) :: xvar,yvar
  ! quartic potential
  real(rk),parameter :: V0=1.D0
  real(rk),parameter :: X0=5.D0
  ! polymul
  integer ,parameter :: num_dim=3 ! should be a multiple of 3
  real(rk),parameter :: Ebarr=80.D0/2526.6D0  ! >0
  real(rk) :: dpar(num_dim)
!!$  real(rk),parameter :: vdamp=15.D0 ! change of frequencies towards TS. +inf -> no change
end module driver_parameter_module

program main
  use driver_module
  use driver_parameter_module
  !use vib_pot
  implicit none
  integer :: ivar

  call dlf_mpi_initialize() ! only necessary for a parallel build; 
                            ! can be present for a serial build
  call dlf_output(6,0)

  call driver_init

  select case (isystem)
  case (1)
    !call system ("rm -f dimer.xy")
    !do ivar=1,100
!      call dl_find(3,1,1,1) ! no frame in coords2
      call dl_find(3,4,1,1) ! one frame in coords2
!      call dl_find(3,16,1,1) ! 5 frames in coords2
!      call dl_find(3,58,1,1) ! 19 frames in coords2
    !  call system ("echo '' >> dimer.xy")
    !end do
  case (2)
   ! call dl_find(12,1,4)
    call dl_find(12,16,8,1) ! 1 frame + masses
  case (3)
    !call dl_find(99,1,33)
    !call dl_find(30,1,15)

    ! LJ-particle surface with one atom hopping on it
    call dl_find(21,35,14,1) ! 1 frame + weigths + masses

  case (4,5)
    call dl_find(3,4,2,1)

  case (6)
    call dl_find(12,16,8,1) ! 1 frame + masses
    !call read_pot_destroy
  case (7)
    call dl_find(3,4,1,1) ! one frame in coords2

  case (8)
   call dl_find(num_dim,num_dim+num_dim/3,num_dim/3,1) ! one frame + masses in coords2

  case default
    call dlf_mpi_finalize() ! only necessary for a parallel build;
                            ! can be present for a serial build

    stop "Wrong isystem"
  end select

  call dlf_mpi_finalize() ! only necessary for a parallel build;
                          ! can be present for a serial build


end program main

! **********************************************************************
! subroutines that have to be provided to dl_find from outside
! **********************************************************************

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_get_params(nvar,nvar2,nspec,coords,coords2,spec,ierr, &
    tolerance,printl,maxcycle,maxene,tatoms,icoord, &
    iopt,iline,maxstep,scalestep,lbfgs_mem,nimage,nebk,dump,restart,&
    nz,ncons,nconn,update,maxupd,delta,soft,inithessian,carthessian,tsrel, &
    maxrot,tolrot,nframe,nmass,nweight,timestep,fric0,fricfac,fricp, &
    imultistate, state_i,state_j,pf_c1,pf_c2,gp_c3,gp_c4,ln_t1,ln_t2, &
    printf,tolerance_e,distort,massweight,minstep,maxdump,task,temperature, &
    po_pop_size,po_radius,po_contraction,po_tolerance_r,po_tolerance_g, &
    po_distribution,po_maxcycle,po_init_pop_size,po_reset,po_mutation_rate, &
    po_death_rate,po_scalefac,po_nsave,ntasks,tdlf_farm,n_po_scaling, &
    neb_climb_test, neb_freeze_test, &
    nzero, coupled_states, qtsflag,&
    imicroiter, maxmicrocycle, micro_esp_fit)
  use dlf_parameter_module, only: rk
  use driver_parameter_module
  use driver_module
  !use vib_pot
  implicit none
  integer   ,intent(in)      :: nvar 
  integer   ,intent(in)      :: nvar2
  integer   ,intent(in)      :: nspec
  real(rk)  ,intent(inout)   :: coords(nvar) ! start coordinates
  real(rk)  ,intent(inout)   :: coords2(nvar2) ! a real array that can be used
                                               ! depending on the calculation
                                               ! e.g. a second set of coordinates
  integer   ,intent(inout)   :: spec(nspec)  ! specifications like fragment or frozen
  integer   ,intent(out)     :: ierr
  real(rk)  ,intent(inout)   :: tolerance
  real(rk)  ,intent(inout)   :: tolerance_e
  integer   ,intent(inout)   :: printl
  integer   ,intent(inout)   :: maxcycle
  integer   ,intent(inout)   :: maxene
  integer   ,intent(inout)   :: tatoms
  integer   ,intent(inout)   :: icoord
  integer   ,intent(inout)   :: iopt
  integer   ,intent(inout)   :: iline
  real(rk)  ,intent(inout)   :: maxstep
  real(rk)  ,intent(inout)   :: scalestep
  integer   ,intent(inout)   :: lbfgs_mem
  integer   ,intent(inout)   :: nimage
  real(rk)  ,intent(inout)   :: nebk
  integer   ,intent(inout)   :: dump
  integer   ,intent(inout)   :: restart
  integer   ,intent(inout)   :: nz
  integer   ,intent(inout)   :: ncons
  integer   ,intent(inout)   :: nconn
  integer   ,intent(inout)   :: update
  integer   ,intent(inout)   :: maxupd
  real(rk)  ,intent(inout)   :: delta
  real(rk)  ,intent(inout)   :: soft
  integer   ,intent(inout)   :: inithessian
  integer   ,intent(inout)   :: carthessian
  integer   ,intent(inout)   :: tsrel
  integer   ,intent(inout)   :: maxrot
  real(rk)  ,intent(inout)   :: tolrot
  integer   ,intent(inout)   :: nframe
  integer   ,intent(inout)   :: nmass
  integer   ,intent(inout)   :: nweight
  real(rk)  ,intent(inout)   :: timestep
  real(rk)  ,intent(inout)   :: fric0
  real(rk)  ,intent(inout)   :: fricfac
  real(rk)  ,intent(inout)   :: fricp
  integer   ,intent(inout)   :: imultistate
  integer   ,intent(inout)   :: state_i
  integer   ,intent(inout)   :: state_j
  real(rk)  ,intent(inout)   :: pf_c1  
  real(rk)  ,intent(inout)   :: pf_c2  
  real(rk)  ,intent(inout)   :: gp_c3  
  real(rk)  ,intent(inout)   :: gp_c4
  real(rk)  ,intent(inout)   :: ln_t1  
  real(rk)  ,intent(inout)   :: ln_t2  
  integer   ,intent(inout)   :: printf
  real(rk)  ,intent(inout)   :: distort
  integer   ,intent(inout)   :: massweight
  real(rk)  ,intent(inout)   :: minstep
  integer   ,intent(inout)   :: maxdump
  integer   ,intent(inout)   :: task
  real(rk)  ,intent(inout)   :: temperature
  integer   ,intent(inout)   :: po_pop_size
  real(rk)  ,intent(inout)   :: po_radius
  real(rk)  ,intent(inout)   :: po_contraction
  real(rk)  ,intent(inout)   :: po_tolerance_r
  real(rk)  ,intent(inout)   :: po_tolerance_g
  integer   ,intent(inout)   :: po_distribution
  integer   ,intent(inout)   :: po_maxcycle
  integer   ,intent(inout)   :: po_init_pop_size
  integer   ,intent(inout)   :: po_reset
  real(rk)  ,intent(inout)   :: po_mutation_rate
  real(rk)  ,intent(inout)   :: po_death_rate
  real(rk)  ,intent(inout)   :: po_scalefac
  integer   ,intent(inout)   :: po_nsave
  integer   ,intent(inout)   :: ntasks
  integer   ,intent(inout)   :: tdlf_farm
  integer   ,intent(inout)   :: n_po_scaling
  real(rk)  ,intent(inout)   :: neb_climb_test
  real(rk)  ,intent(inout)   :: neb_freeze_test
  integer   ,intent(inout)   :: nzero
  integer   ,intent(inout)   :: coupled_states
  integer   ,intent(inout)   :: qtsflag
  integer   ,intent(inout)   :: imicroiter
  integer   ,intent(inout)   :: maxmicrocycle
  integer   ,intent(inout)   :: micro_esp_fit
  ! local variables
  real(rk)                   :: svar
  integer                    :: iat,jat
  interface
    subroutine read_rand(arr)
      use dlf_parameter_module, only: rk
      use dlf_global, only : glob
      real(rk)  :: arr(:)
    end subroutine read_rand
  end interface
! **********************************************************************
  ierr=0
  tsrel=1

  print*,"External sizes:",nvar,nvar2,nspec
  ! Minima of Mueller-Brown potential:
  ! left:   -0.5582236346340204   1.4417258418038705   energy:  -0.6919788547639341
  ! middle: -0.050010822944531706 0.4666941048659066   energy:  -0.38098027419650493
  ! right:   0.623499404927291    0.028037758526434815 energy:  -0.5102203967776056
  ! TS:
  ! main:   -0.8220015634663578   0.624312796202859    energy:  -0.19181529956913862
  ! other:   0.21248658127591744  0.2929883285085865   energy:  -0.34079688732228874

!!$  spec(1)=-1
!!$  spec(2)=-34
!!$  spec(3)=-4
!!$  spec(:)=1
!!$  spec(3)=-34
!!$  spec(1:3)=2
!!$  spec(6)=2
!!$  spec(9:10)=0
  ncons=1
  ! cosntraint
!!$  spec(11)=1
!!$  spec(12)=1
!!$  spec(13)=2
!!$  spec(14:15)=0

  ncons=0
  nconn=0

  coords(:)=-1.D0
  spec(:)=0
  
!!$  ! Near Saddle point:
! coords=(/ -0.6D0, 0.6D0 /) 

  coords2(:)=-1.D0
  if(isystem==1) then

    nzero=0
    coords=(/ -0.8220015634663578D0,   0.624312796202859D0, 0.D0 /)! main saddle point

!    coords=(/ -0.050010822944531706D0, 0.4666941048659066D0 , 0.D0 /)! middle minimum
!!$!    coords=(/ 0.623499404927291D0, 0.028037758526434815D0 , 0.D0 /)! right minimum
!!$!    coords=(/ 0.05D0,   0.7D0, 0.D0 /)
!!$    ! Main TS and direction
!!$    nframe=1
!!$    coords2(1:3)=(/ 0.8D0 ,  -0.5D0,  0.D0 /)

    ! Main minima
!    coords=(/ -0.5582236346340204D0,   1.4417258418038705D0, 0.D0 /)
    nframe=1
    coords2(1:3)=(/ 0.623499404927291D0,    0.028037758526434815D0, 0.D0 /)

!!$    ! 6 points converged at 0.8 T_c, but with non-doubled path
!!$    nframe=5
    ! pairwise identical
!!$    coords=(/  -0.4493311064542917D0 , 0.5419479158349173D0 , 0.D0 /)
!!$    coords2(1:nframe*3)=(/ &
!!$        -0.5952499491610727D0 , 0.7072076082065596D0 , 0.D0 , &
!!$        -0.74556821224306D0 , 1.1707853456208879D0 , 0.D0 , &
!!$        -0.74556821224306D0 , 1.1707853456208879D0 , 0.D0 , &
!!$        -0.5952499491610727D0 , 0.7072076082065596D0 , 0.D0 , &
!!$        -0.4493311064542917D0 , 0.5419479158349173D0 , 0.D0 /)
!!$    ! turning points non-doubled
!!$    coords=(/ -0.3578971447649985D0 , 0.501608351688023D0 , 0.D0 /)
!!$    coords2(1:nframe*3)=(/ &
!!$        -0.43170926134006843D0 , 0.5293693376680748D0 , 0.D0 , &
!!$        -0.5875518956609882D0 , 0.6297820581123532D0 , 0.D0 ,&
!!$        -0.7976650261570393D0 , 0.8923927204798402D0 , 0.D0 ,&
!!$        -0.5875518956609882D0 , 0.6297820581123532D0 , 0.D0 ,&
!!$        -0.43170926134006843D0 , 0.5293693376680748D0 , 0.D0 /)


!!$    ! 20 points approx. converged at 7.D4 K This was used for the P-RFO convergence tests
!!$    coords=(/    -0.8426643D0 , 0.9151530D0 , 0.D0 /)
!!$    nframe=19
!!$    coords2(1:nframe*3)=(/ &
!!$        -0.8341730D0 , 0.9016234D0 , 0.D0, &
!!$        -0.8167761D0 , 0.8750182D0 , 0.D0, &
!!$        -0.7902620D0 , 0.8368417D0 , 0.D0, &
!!$        -0.7552811D0 , 0.7902725D0 , 0.D0, &
!!$        -0.7140001D0 , 0.7401491D0 , 0.D0, &
!!$        -0.6694554D0 , 0.6916154D0 , 0.D0, &
!!$        -0.6245622D0 , 0.6483821D0 , 0.D0, &
!!$        -0.5814185D0 , 0.6121439D0 , 0.D0, &
!!$        -0.5412253D0 , 0.5829760D0 , 0.D0, &
!!$        -0.5046521D0 , 0.5601122D0 , 0.D0, &
!!$        -0.4719413D0 , 0.5424788D0 , 0.D0, &
!!$        -0.4431635D0 , 0.5290462D0 , 0.D0, &
!!$        -0.4182906D0 , 0.5188846D0 , 0.D0, &
!!$        -0.3972339D0 , 0.5112838D0 , 0.D0, &
!!$        -0.3798929D0 , 0.5056672D0 , 0.D0, &
!!$        -0.3661631D0 , 0.5016168D0 , 0.D0, &
!!$        -0.3559567D0 , 0.4988193D0 , 0.D0, &
!!$        -0.3491923D0 , 0.4970686D0 , 0.D0, &
!!$        -0.3458243D0 , 0.4962209D0 , 0.D0 &
!!$        /)

    ! right minimum for rates
!    coords=(/0.623499404927291D0,    0.028037758526434815D0, 0.D0 /)

!!$    ! 20 points approx. converged at 9.D4 K
!!$    coords=(/    -0.8426643D0 , 0.9151530D0 , 0.D0 /)
!!$    nframe=19
!!$    coords2(1:nframe*3)=(/ &
!!$        -0.8862898D0 , 0.7529666D0 , 0.D0, &
!!$        -0.8830748D0 , 0.7491050D0 , 0.D0, &
!!$        -0.8767162D0 , 0.7415692D0 , 0.D0, &
!!$        -0.8673471D0 , 0.7307005D0 , 0.D0, &
!!$        -0.8551798D0 , 0.7169933D0 , 0.D0, &
!!$        -0.8405764D0 , 0.7011254D0 , 0.D0, &
!!$        -0.8239636D0 , 0.6838182D0 , 0.D0, &
!!$        -0.8059024D0 , 0.6658717D0 , 0.D0, &
!!$        -0.7869926D0 , 0.6480244D0 , 0.D0, &
!!$        -0.7678376D0 , 0.6309045D0 , 0.D0, &
!!$        -0.7490010D0 , 0.6149905D0 , 0.D0, &
!!$        -0.7309768D0 , 0.6006029D0 , 0.D0, &
!!$        -0.7141770D0 , 0.5879203D0 , 0.D0, &
!!$        -0.6989314D0 , 0.5770092D0 , 0.D0, &
!!$        -0.6854953D0 , 0.5678584D0 , 0.D0, &
!!$        -0.6740516D0 , 0.5604040D0 , 0.D0, &
!!$        -0.6647626D0 , 0.5545798D0 , 0.D0, &
!!$        -0.6577119D0 , 0.5502927D0 , 0.D0, &
!!$        -0.6529801D0 , 0.5474803D0 , 0.D0, &
!!$        -0.6506084D0 , 0.5460899D0 , 0.D0 &
!!$        /)

    nmass=1
    coords2(nvar2)=1.0078250321D0 ! mass: last entry in coords2, here using mass of protium
!    coords2(nvar2)=10.00 ! mass: last entry in coords2, here using mass of more 


!    print*,"nspec",nspec
    spec(1)=-4

  end if
  if(isystem==2) then
    ! minimum distance is 1.1224620
!!$    coords(:)=0.D0
!!$    coords(4)=-1.D0
!!$    coords(7)=0.6D0
!!$    coords(8)=1.D0
!!$
!!$    coords2(:)=0.D0
!!$    coords2(4)=-1.D0
!!$    coords2(7)=0.6D0
!!$    coords2(8)=-1.D0

    ! Arrangements of 4 LJ-Particles:
    ! Square with a=1.1126198 is a 2nd order Saddle point
    ! Rombus (60.27 deg) with a=1.1202310 (1.124800) is a 1st order Saddle point

    ! This is a rombus quite near to the TS
    svar=1.1224620D0 ! very good
    svar=1.0D0 
    coords(:)=0.D0
    coords(4:6)  =(/svar,0.D0,0.D0/)
    coords(7:9)  =(/svar*0.5D0, svar*0.5D0*dsqrt(3.D0), 0.D0/)
    coords(10:12)=(/svar*1.5D0, svar*0.5D0*dsqrt(3.D0), 0.D0/)

    coords(12)=1.D0

    ! Two points quite near to a TS:
    svar=1.1224620D0*0.9D0
!!$    coords(:)=0.D0
!!$    coords(4:6)  =(/svar,0.D0,0.D0/)
!!$    coords(7:9)  =(/svar*0.5D0, svar*0.5D0*dsqrt(3.D0), 0.D0/)
!!$    coords(10:12)=(/svar*1.5D0, svar*0.5D0*dsqrt(3.D0), 0.1D0/)
    coords2(:)=0.D0
    coords2(4:6)  =(/svar,0.D0,0.D0/)
    coords2(7:9)  =(/svar*0.5D0, svar*0.5D0*dsqrt(3.D0), 0.D0/)
    coords2(10:12)=(/svar*1.5D0, svar*0.5D0*dsqrt(3.D0), -0.3D0/)
    nframe=1

!!$    coords2(:)=0.D0
!!$    coords2(1:2)=(/-svar,svar*sqrt(3.D0)/)
!!$    coords2(7:8)=(/svar,svar*sqrt(3.D0)/)

!!$    ! four atoms in nearly a square
!!$    coords(:)=0.D0
!!$    coords(3)=0.d0
!!$    coords(4)=1.0D0
!!$    coords(8)=1.0D0
!!$    coords(10)=1.0D0
!!$    coords(11)=1.0D0
!!$    coords(12)=0.610D0

    ! masses
    nmass=4
    coords2(13:14)=1.D0
    coords2(15:16)=10.D0

  end if
  if(isystem==3) then
    ! one hopping atom on a 2*3 surface
    svar=1.1224620D0
    do iat=0,1
      do jat=0,2
        coords(3+iat*9+jat*3+1)=dble(jat)*svar
        coords(3+iat*9+jat*3+2)=dble(iat)*svar
        coords(3+iat*9+jat*3+3)=0.D0
      end do
    end do
    ! TS energy with 4 frozen atoms: -0.01156076358016981
    ! hopping atom (atom 1) 
    coords(1)=svar*0.7D0
    coords(2)=svar*0.5D0
    coords(3)=svar*0.7D0
    !coords(9)=-0.3D0
    !coords(18)=-0.3D0

    ! stationary point with all atoms free:
!!$    coords(:) = (/&
!!$        1.1848983D0,   0.5065666D0,   0.5943077D0,&
!!$        0.2522962D0,   0.1414045D0,   0.0995254D0,&
!!$        1.2142701D0,   0.1259186D0,  -0.4664030D0,&
!!$        2.0938589D0,  -0.0116502D0,   0.2075193D0,&
!!$        0.2244601D0,   1.0502398D0,   0.7566075D0,&
!!$        0.7204213D0,   1.1023797D0,  -0.2424304D0,&
!!$        1.8302904D0,   1.0137577D0,  -0.1634031D0 /)


    nmass=7
    nframe=1
    coords2(:)=1.D0
    coords2(1:nvar)=coords(:)
    !coords2(nvar+1:2*nvar)=coords(:)
    ! hop atom other minimum
    coords2(1)=coords2(1)+svar
    !coords2(9)=coords2(9)+0.1D0
    !coords2(3)=coords2(3)+0.2D0
    ! for dimer:
    !coords2(1)=coords2(1)+0.6D0*svar
    !coords2(3)=coords2(3)+0.2D0
    !coords2(nvar+1)=coords2(nvar+1)+svar
    spec(:)=-1 ! NEB: -1
    spec(1)=1
    spec(3)=1
    spec(6)=1
    spec(:)=0 ! all free for now

    ! microiterative: last two are inner region
    spec(13:14)=1

    ! weights
    nweight=7
    !coords2(22:28) are weights
!    coords2(22:28)=1.0d0
!    coords2(24)=1.d0

    ! masses
    !coords2(29:35) are masses
    coords2(29:35)=10.D0
!    coords2(29:29)=1.D0

  end if

  ! Eckart barrier
  if(isystem==4) then

    coords=0.D0
    coords2=0.D0

   ! coords(1)=-2.0D0

    nframe=1
    coords2(1:3)=(/ 1.D0 ,  0.D0,  0.D0 /)

    nzero=0
    nmass=1
    coords2(nvar2)=1.0078250321D0 ! mass: last entry in coords2, here using mass of protium
  !  coords2(nvar2)=2.013553212D0 ! mass: last entry in coords2, here using mass of deuterium
  !  coords2(nvar2)=3.D0
!    coords2(nvar2)=0.5D0/1.8228884842645E+03 ! mass: leads to a mass of 0.5 in atomic units

    spec(1)=-34
  end if

  ! Quartic potential
  if(isystem==5) then

    coords=0.D0
    coords2=0.D0

    ! Saddle point:
  !  coords(1)=2.D0/3.D0

    nframe=1
    coords2(1:3)=(/ 1.D0 ,  0.D0,  0.D0 /)

    nzero=0
    nmass=1
   ! coords2(nvar2)=1.0078250321D0 ! mass: last entry in coords2, here using mass of protium
    coords2(nvar2)=0.5D0/1.8228884842645E+03 ! mass: leads to a mass of 1 in atomic units
    spec(1)=-34

  end if

  ! Vibrational potential
  if(isystem==6) then

!N          0.0000000000        0.0000000000       -0.0000061916
!H          0.0000000000        0.0000000000        1.8816453413
!H          0.0000000000        1.6294938353       -0.9407796566
!H          0.0000000000       -1.6294938353       -0.9407796566

    ! reference geometry
    coords=(/ 0.0000000000D0,        0.0000000000D0,       -0.0000061916D0, &
              0.0000000000D0,        0.0000000000D0,        1.8816453413D0, &
              0.0000000000D0,        1.6294938353D0,       -0.9407796566D0, &
              0.0000000000D0,       -1.6294938353D0,       -0.9407796566D0 /)
 
!!$    ! distorted, but probably consistent with the reference:
!!$    coords=(/  0.0080835D0,   0.0000000D0,  -0.0000062D0,&
!!$        -0.5176180D0,   0.0000000D0,   1.8816453D0,&
!!$        -0.5181795D0,   1.6294938D0,  -0.9407797D0,&
!!$        -0.5181795D0,  -1.6294938D0,  -0.9407797D0 /)

!!$    !minimum geometry - 1D
!!$    coords=(/  -0.0934927D0,   0.0000000D0,  -0.0000000D0, &
!!$        0.4308739D0,  -0.0000000D0,   1.8815559D0,&
!!$        0.4313413D0,   1.6294751D0,  -0.9407780D0,&
!!$        0.4313413D0,  -1.6294751D0,  -0.9407780D0 /)


    

    nframe=1
    coords2(1:nvar)=coords

    nzero=6
    nmass=4
!    coords2(nvar+1)=14.0030740048D0
    !OH3+
    coords2(nvar+1)=15.99491461956D0
    coords2(nvar+2:nvar2)=1.0078250321D0
    spec(1:4)=0 ! all atoms active
    nz=4
    spec(5)=7 ! Nuclear charge
    spec(6:8)=1 ! Nuclear charge

    printl=4
    ! read in potential data
    !call read_pot_init(nvar/3)

  end if

  if(isystem==7) then

    nzero=0
    coords=(/ -1.D0,   0.D0, 0.D0 /)! main saddle point
!    coords=(/ -1.D0,   0.01D0, 0.D0 /)!  main saddle point distorted startvalue

!   coords=(/ -2.D0, 0.D0 , 0.D0 /)! left minimum
!    coords=(/ -2.D0, 0.2D0 , 0.D0 /)! left minimum distorted startvalue
!    coords=(/ 1.D0, 0.D0, 0.D0 /)! second saddle point
!    coords=(/ 1.D0, 1.D0 , 0.D0 /)! right minimum, perpendicular to second saddle point
!!$    coords=(/ 1.D0, 0.3670625D0, 0.D0 /)! right minimum, perpendicular to second saddle point

   ! Main TS and direction
    nframe=1
    coords2(1:3)=(/ -0.8D0 ,  0.1D0,  0.D0 /)

!More than one frame
!!$    coords=(/ -2.D0, 0.D0 , 0.D0 /)! left minimum
!!$    nframe=19
!!$    coords2(1:nframe*3)=(/ &
!!$         -1.7D0, 0.D0 , 0.D0, &
!!$         -1.4D0, 0.D0 , 0.D0, &
!!$         -1.2D0, 0.D0 , 0.D0, &
!!$         -1.0D0, 0.D0 , 0.D0, & ! main saddle point
!!$         -0.8D0, 0.D0 , 0.D0, &       
!!$         -0.6D0, 0.D0 , 0.D0, &
!!$         -0.4D0, 0.D0 , 0.D0, &
!!$         -0.2D0, 0.D0 , 0.D0, &
!!$          0.0D0, 0.D0 , 0.D0, &
!!$          0.2D0, 0.D0 , 0.D0, &
!!$          0.4D0, 0.D0 , 0.D0, &
!!$          0.6D0, 0.D0 , 0.D0, &
!!$          0.8D0, 0.D0 , 0.D0, &
!!$          1.D0, 0.0D0 , 0.D0, & ! second saddle point
!!$          1.D0, 0.2D0 , 0.D0, &
!!$          1.D0, 0.4D0 , 0.D0, &
!!$          1.D0, 0.6D0 , 0.D0, &
!!$          1.D0, 0.8D0 , 0.D0, &
!!$          1.D0, 1.0D0 , 0.D0  &
!!$        /)

!More than one frame
!!$    coords=(/ -2.D0, 0.D0 , 0.D0 /)! left minimum
!!$    nframe=10
!!$    coords2(1:nframe*3)=(/ &
!!$        -1.4D0, 0.D0 , 0.D0, &
!!$         -1.2D0, 0.D0 , 0.D0, &
!!$         -1.0D0, 0.D0 , 0.D0, & ! main saddle point
!!$         -0.8D0, 0.D0 , 0.D0, &       
!!$         -0.6D0, 0.D0 , 0.D0, &
!!$         -0.4D0, 0.2D0 , 0.D0, &
!!$         -0.2D0, 0.D0 , 0.D0, &
!!$          0.0D0, 0.D0 , 0.D0, &
!!$          0.2D0, 0.D0 , 0.D0, &
!!$          0.2D0, 0.2D0 , 0.D0 &
!!$          /)


    nmass=1
    coords2(nvar2)=1.0078250321D0 ! mass: last entry in coords2, here using mass of protium
!    coords2(nvar2)=10.00 ! mass: last entry in coords2, here using mass of more 


    print*,"nspec",nspec
    spec(1)=-4
  end if

  ! polymul
  if(isystem==8) then

    coords=0.D0
    coords2=0.D0
    coords(1)=1.D0
!    call random_number(coords)

  !  coords(1)=-2.0D0

    nframe=1
    !coords2(1:num_dim)=(/ 1.D0 ,  0.D0,  0.D0 /)

    nzero=0
    nmass=num_dim/3
    coords2(num_dim/3+1:num_dim+num_dim/3)=1.0078250321D0 ! mass: last entry in coords2, here using mass of protium
  !  coords2(nvar2)=2.013553212D0 ! mass: last entry in coords2, here using mass of deuterium
  !  coords2(nvar2)=3.D0

    !spec(1)=-34
    spec(:)=0

  end if

!*************END case of isystem checking******************

  tolerance=4.5D-5 ! negative: default settings
  printl=4
  printf=4
  maxcycle=100 !200
  maxene=100000

  tolrot=1.D2
!  tolrot=0.1D0
!  maxrot=100 !was 100

  task=0 !1011

  distort=0.D0 !0.4 

  ! YL 02/03/2020: toggle 3-D cartesian coordinates or sequenctial variables
  tatoms=0

  icoord=0 !0 cartesian coord !210 Dimer !190 qts search !120 NEB frozen endpoint
  massweight=0

! TO DO (urgent): better dtau for endpoints (interpolate energy) when reading dist

  imicroiter=1 ! means: use microiterative optimization

  iopt=3 ! 20 !3 or 20 later change to 12
  temperature = 2206.66844626D0*0.99D0 ! K ! T_c for the MB-potential for hydrogen is 2206.668 K
  !temperature = 0.8D0*333.40829D0  ! K ! T_c 20102.83815 K
  !temperature = 500.D0
  ! Cubic potential (isystem=5: Crossover temperature for tunnelling  1846563.59447 K)
  temperature = 0.99D0 * 1846563.59447D0
  ! eckart potential (scatter) Tc: 3186172.17493753 K
  temperature = 0.9D0*3186172.17493753D0
  temperature= 0.7D0 * 275.13301D0 
! T_c for 162 DOF: 511.06618

  iline=0
  maxstep=0.1D0
  scalestep=1.0D0
  lbfgs_mem=100
  nimage=39 !*k-k+1
  nebk=1.0D0 ! for QTS calculations with variable tau, nebk transports the parameter alpha (0=equidist. in tau)
  qtsflag=0 ! 1: Tunneling splittings, 11/10: read image hessians

  !"accurate" etunnel for 0.4 Tc: 0.3117823831234522

  ! Hessian
  delta=1.D-2
  soft=-6.D-4
  update=2
  maxupd=0
  inithessian=0
  minstep=1.D0 **2 ! 1.D-5
  minstep=1.D-5

!!$  ! variables for exchange by sed
!!$  iopt=IOPT_VAR
!!$  nimage=NIMAGE_VAR
!!$  temperature = TFAC ! K ! T_c for the MB-potential for hydrogen is 2206.668 K
!!$  nebk= NEBK_VAR


  ! damped dynamics
  fric0=0.1D0
  fricfac=1.0D0
  fricp=0.1D0

  dump=0
  restart=0

  ! Parallel optimization

  po_pop_size=25
  po_radius=0.5D0
  po_init_pop_size=50
  po_contraction=0.95D0
  po_tolerance_r=1.0D-8
  po_tolerance_g=1.0D-6
  po_distribution=3
  po_maxcycle=100000
  po_reset=500
  po_mutation_rate=0.15D0
  po_death_rate=0.5D0
  po_scalefac=10.0D0
  po_nsave=10
  n_po_scaling=0 ! meaning that the base radii values for the sampling and tolerance 
                 ! are used for all components of the working coordinate vector.
                 ! Remember to change the second arg in the call to dl_find if a 
                 ! non-zero value for n_po_scaling is desired, and also to add the 
                 ! necessary values to the coords2 array...

  ! Taskfarming 
  ! (the two lines below, with any values assigned, 
  ! may be safely left in place for a serial build) 
  ntasks = 1
  tdlf_farm = 1

  tatoms=1
  
!  call test_ene

end subroutine dlf_get_params

subroutine test_update
  use dlf_parameter_module, only: rk
  use dlf_allocate, only: allocate,deallocate
  use dlf_global, only: glob,printl
  implicit none
  integer(4) :: varperimage,nimage,iimage,ivar4
  real(rk), allocatable:: coords(:,:),grad(:,:) ! varperimage,nimage
  real(rk), allocatable:: hess(:,:,:) ! varperimage,varperimage,nimage
  real(rk), allocatable:: fhess(:,:) ! 2*varperimage*nimage,2*varperimage*nimage
  real(rk), allocatable:: eigval(:),eigvec(:,:)
  real(rk), allocatable:: vec0(:)
  real(rk), allocatable:: determinant(:)
  real(rk), allocatable:: tmphess(:,:)
  real(rk) :: svar
  integer :: ivar,jvar,vp8,target_image,step,lastimage,jimage,turnimg
  logical :: havehessian,fracrecalc
  integer, parameter :: ifunit = 105
  integer, parameter :: ifunit2 = 106

  open(unit=ifunit2,file="grad_coor.bin",form="unformatted")
  read(ifunit2) varperimage,nimage
  print*,"varperimage,nimage",varperimage,nimage
  vp8=varperimage

!!$  call allocate(coords,int(varperimage,kind=8),int(nimage,kind=8))
!!$  call allocate(grad,int(varperimage,kind=8),int(nimage,kind=8))
!!$  call allocate(determinant,int(nimage,kind=8))

  do iimage=1,nimage
    read(ifunit2) ivar4
    print*,"Reading coords/grad of image",ivar4
    read(ifunit2) grad(:,iimage)
    read(ifunit2) coords(:,iimage)
  end do
  close(ifunit2)
  print*,"Coords sucessfully read"

  ! print coords and grad
  iimage=2
  print*,"Coords and grad for image ",iimage
  do ivar=1,vp8
    write(6,"(i6,1x,2es18.9)") &
        ivar,coords(ivar,iimage),grad(ivar,iimage)
  end do

  open(unit=ifunit,file="hessian.bin",form="unformatted")
  ! Hessian in mass-weighted coordinates on the diagnal blocks - everything else should be zero
  read(ifunit) iimage,ivar4!neb%varperimage,neb%nimage
  if(iimage/=varperimage.or.ivar4/=nimage) then
    print*,"Dimensions read",iimage,ivar4
    call dlf_fail("ERROR: wrong dimensions in hessian.bin!")
  end if
  ivar=2*varperimage*nimage
  print*,"File Hessian size",ivar
  call allocate(fhess,ivar,ivar)
  read(ifunit) fhess
  close(ifunit)
  print*,"Hessian sucessfully read"

  ! map hessian to different array:
!!$  call allocate(hess,int(varperimage,kind=8),int(varperimage,kind=8),int(nimage,kind=8))
  do iimage=1,nimage
    print*,"Image",iimage,"Hessian positions",(iimage-1)*varperimage+1,iimage*varperimage
    hess(:,:,iimage)=fhess((iimage-1)*varperimage+1:iimage*varperimage,(iimage-1)*varperimage+1:iimage*varperimage)
  end do
  call deallocate(fhess)

  call allocate(eigval,vp8)
  call allocate(eigvec,vp8,vp8)
  ! now we have all we need

  print*,"# Distance from previous image"
  do iimage=2,nimage
    print*,iimage,sqrt(sum( (coords(:,iimage)-coords(:,iimage-1))**2))
  end do

  print*,"# Determinant of Hessian"
  do iimage=1,nimage
    do ivar=1,vp8
      do jvar=ivar+1,vp8
        if(abs(hess(ivar,jvar,iimage)-hess(jvar,ivar,iimage))>1.D-20) &
            print*,"Unsymmetric:",ivar,jvar,iimage,hess(ivar,jvar,iimage),hess(jvar,ivar,iimage)
      end do
    end do
    call dlf_matrix_diagonalise(vp8,hess(:,:,iimage),eigval,eigvec)
    !write(6,"(i6,1x,9es12.3)") iimage,product(eigval(8:vp8)),eigval(1:8)
    do ivar=1,6
      eigval(minloc(abs(eigval)))=1.D0
    end do
    determinant(iimage)=product(eigval)
    write(6,"(i6,1x,9es12.3)") iimage,product(eigval),eigval(1:8)
  end do
  
  print*,"maxval(hess(:,:,nimage-1)-hess(:,:,nimage))",maxval(hess(:,:,nimage-1)-hess(:,:,nimage))

!!$  ! Richtungsableitung
!!$  call allocate(vec0,vp8)!int(varperimage,kind=8))
!!$  do iimage=2,nimage-1
!!$    ! eigval is Vector along which the derivative is taken
!!$    eigval=coords(:,iimage+1)-coords(:,iimage-1)
!!$    svar=sqrt(sum(eigval**2))
!!$    eigval=eigval/svar
!!$    vec0=matmul(hess(:,:,iimage),eigval)
!!$    do ivar=1,vp8
!!$      write(6,"(2i6,1x,2es18.9,1x,f10.5)") &
!!$          iimage,ivar,(grad(ivar,iimage+1)-grad(ivar,iimage-1))/svar,vec0(ivar),&
!!$          vec0(ivar)/((grad(ivar,iimage+1)-grad(ivar,iimage-1))/svar)
!!$    end do
!!$  end do

  !
  ! now test updates
  !
  call allocate(tmphess,vp8,vp8)
  havehessian=.true.
  fracrecalc=.false.
  printl=2
  glob%maxupd=30000

  target_image=1 !nimage
  ! update hessians to the one of the first image
  print*,"Updating Hessians to that of image",target_image
  print*,"Sum-of-squares difference"
  do iimage=1,nimage
    tmphess(:,:)=hess(:,:,iimage)
    call dlf_hessian_update(vp8, &
        coords(:,target_image),coords(:,iimage),&
        grad(:,target_image),grad(:,iimage), &
        tmphess, havehessian, fracrecalc)
    if(.not.havehessian) then
      print*,"Problem with hessian update, image",iimage
      havehessian=.true.
    end if
    print*,iimage,sum( (tmphess-hess(:,:,target_image))**2),&
        sum( (hess(:,:,iimage)-hess(:,:,target_image))**2)
  end do

  print*,"Minstep",glob%minstep
  print*,"Updating Hessians to that of image",target_image
  print*,"Determinant"
  open(file="determinant",unit=10)
  do iimage=1,nimage
    tmphess(:,:)=hess(:,:,iimage)
    call dlf_hessian_update(vp8, &
        coords(:,target_image),coords(:,iimage),&
        grad(:,target_image),grad(:,iimage), &
        tmphess, havehessian, fracrecalc)
    if(.not.havehessian) then
      print*,"Problem with hessian update, image",iimage
      havehessian=.true.
    end if
    call dlf_matrix_diagonalise(vp8,tmphess,eigval,eigvec)
    !write(6,"(i6,1x,9es12.3)") iimage,product(eigval(8:vp8)),eigval(1:8)
    do ivar=1,6
      eigval(minloc(abs(eigval)))=1.D0
    end do

    print*,iimage,product(eigval),determinant(iimage),determinant(target_image)
    write(10,*) iimage,product(eigval),determinant(iimage),determinant(target_image)
  end do
  close(10)

  print*,"Updating Hessians to that of image",target_image
  print*,"Determinant - incremental"
  open(file="determinant_incr",unit=10)
  do iimage=1,nimage
    tmphess(:,:)=hess(:,:,iimage)
    step=1
    if(iimage>target_image) step=-1
    lastimage=iimage
    do jimage=iimage+step,target_image,step
      !print*,"updating",lastimage," to ",jimage
      call dlf_hessian_update(vp8, &
          coords(:,jimage),coords(:,lastimage),&
          grad(:,jimage),grad(:,lastimage), &
          tmphess, havehessian, fracrecalc)

      if(.not.havehessian) then
        print*,"Problem with hessian update, image",iimage
        havehessian=.true.
      end if
      lastimage=jimage
    end do
    call dlf_matrix_diagonalise(vp8,tmphess,eigval,eigvec)
    !write(6,"(i6,1x,9es12.3)") iimage,product(eigval(8:vp8)),eigval(1:8)
    do ivar=1,6
      eigval(minloc(abs(eigval)))=1.D0
    end do

    print*,iimage,product(eigval),determinant(iimage),determinant(target_image)
    write(10,*) iimage,product(eigval),determinant(iimage),determinant(target_image)
  end do
  close(10)

  print*,"Updating Hessians to that of image",target_image
  print*,"Determinant - incremental turning around"
  turnimg=20
  open(file="determinant_turn",unit=10)
  do iimage=1,nimage
    tmphess(:,:)=hess(:,:,iimage)
    lastimage=iimage
    ! first upwards to turnimg
    do jimage=iimage+1,turnimg
      print*,"updating",lastimage," to ",jimage
      call dlf_hessian_update(vp8, &
          coords(:,jimage),coords(:,lastimage),&
          grad(:,jimage),grad(:,lastimage), &
          tmphess, havehessian, fracrecalc)

      if(.not.havehessian) then
        print*,"Problem with hessian update, image",iimage
        havehessian=.true.
      end if
      lastimage=jimage
    end do
    step=1
    if(lastimage>target_image) step=-1
    do jimage=lastimage+step,target_image,step
      print*,"updating",lastimage," to ",jimage
      call dlf_hessian_update(vp8, &
          coords(:,jimage),coords(:,lastimage),&
          grad(:,jimage),grad(:,lastimage), &
          tmphess, havehessian, fracrecalc)

      if(.not.havehessian) then
        print*,"Problem with hessian update, image",iimage
        havehessian=.true.
      end if
      lastimage=jimage
    end do
    call dlf_matrix_diagonalise(vp8,tmphess,eigval,eigvec)
    !write(6,"(i6,1x,9es12.3)") iimage,product(eigval(8:vp8)),eigval(1:8)
    do ivar=1,6
      eigval(minloc(abs(eigval)))=1.D0
    end do

    print*,iimage,product(eigval),determinant(iimage),determinant(target_image)
    write(10,*) iimage,product(eigval),determinant(iimage),determinant(target_image)
  end do
  close(10)

!!$  do ivar=1,vp8
!!$    WRITE(*,'(33f10.5)') hess(ivar,:,1)*1.D6
!!$  end do
!!$
!!$  do ivar=1,vp8
!!$    write(6,"(i6,1x,es18.9)") &
!!$            ivar,eigval(ivar)
!!$  end do

  call deallocate(coords)
  call deallocate(grad)
  
  call dlf_fail("stop in test_update")
end subroutine test_update

! just a test routine
subroutine test_ene
  use dlf_parameter_module, only: rk
  implicit none
  integer :: ivar,ivar2,status
  integer :: samples
  real(rk) :: halfSamples
  real(rk) :: coords(3),grad(3),hess(3,3),ene
  coords(:)=0.D0
!  open(file="energy",unit=13)
  open(file="energy-2d.dat",unit=13)
  samples = 100
  halfSamples = dble(samples) * 0.25D0
  do ivar2=1,samples
    do ivar=1,samples
      coords(1)=dble(ivar-samples/2)/halfSamples
      coords(2)=dble(ivar2-samples/2)/halfSamples
      call dlf_get_gradient(3,coords,ene,grad,1,-1,status)
      call dlf_get_hessian(3,coords,hess,status)
     write(13,*) coords(1),coords(2),ene,grad(1),grad(2),hess(1,1),hess(2,2),hess(2,1)
!     write(13,*) coords(1),coords(2),ene,grad(1)
    end do
    write(13,*) ""
  end do
  close(13)
  call dlf_fail("stop in test_ene")
end subroutine test_ene

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_get_gradient(nvar,coords,energy,gradient,iimage,kiter,status)
  !  Mueller-Brown Potential
  !  see K Mueller and L. D. Brown, Theor. Chem. Acta 53, 75 (1979)
  !  taken from JCP 111, 9475 (1999)
  use dlf_parameter_module, only: rk
  use driver_module
  use driver_parameter_module
  !use vib_pot
  implicit none
  integer   ,intent(in)    :: nvar
  real(rk)  ,intent(in)    :: coords(nvar)
  real(rk)  ,intent(out)   :: energy
  real(rk)  ,intent(out)   :: gradient(nvar)
  integer   ,intent(in)    :: iimage
  integer   ,intent(in)    :: kiter
  integer   ,intent(out)   :: status
  !
  ! variables for Mueller-Brown potential
  real(rk) :: x,y,svar,svar2
  integer  :: icount
  ! variables for Lennard-Jones potentials
  real(rk) :: acoords(3,nvar/3)
  real(rk) :: agrad(3,nvar/3)
  real(rk) :: r
  integer  :: nat,iat,jat
  ! additional variables non-cont. diff MEP potential
  real(rk) :: t ! variation of the depth of the flater saddle point

! **********************************************************************
!  call test_update
  status=1
  select case (isystem)
  case (1)
    !print*,"coords in energy eval",coords
    x =  coords(1)
    y =  coords(2)

    energy=0.D0
    gradient=0.D0
    do icount=1,4
      svar= apar(icount)*(x-x0par(icount))**2 + &
          bpar(icount)*(x-x0par(icount))*(y-y0par(icount)) + &
          cpar(icount)*(y-y0par(icount))**2 
      svar2= acappar(icount) * dexp(svar)
      energy=energy+ svar2
      gradient(1)=gradient(1) + svar2 * &
          (2.D0* apar(icount)*(x-x0par(icount))+bpar(icount)*(y-y0par(icount)))
      gradient(2)=gradient(2) + svar2 * &
          (2.D0* cpar(icount)*(y-y0par(icount))+bpar(icount)*(x-x0par(icount)))
    end do
    energy=energy+0.692D0
    ! write(*,'("x,y,func",2f10.5,es15.7)') x,y,energy
  case (2,3)

    ! one could use a Lennard-Jones particle with slightly different
    ! parameters as "Excited state": epsilon=0.9D-3, sigma=1.1D0 to search for
    ! conical intersections

    acoords=reshape(coords,(/3,nvar/3/))
    energy=0.D0
    agrad(:,:)=0.D0
    do iat=1,nvar/3
      do jat=iat+1,nvar/3
        r=sum((acoords(:,iat)-acoords(:,jat))**2)
        ! Lennard-Jones Potential
        energy=energy+4.D0*epsilon * ((sigma**2/r)**6-(sigma**2/r)**3)
        svar = -4.D0*epsilon * (12.D0*sigma**12/r**7-6.D0*sigma**6/r**4)
        agrad(1,iat)=agrad(1,iat)+ svar * (acoords(1,iat)-acoords(1,jat))
        agrad(2,iat)=agrad(2,iat)+ svar * (acoords(2,iat)-acoords(2,jat))
        agrad(3,iat)=agrad(3,iat)+ svar * (acoords(3,iat)-acoords(3,jat))
        agrad(1,jat)=agrad(1,jat)- svar * (acoords(1,iat)-acoords(1,jat))
        agrad(2,jat)=agrad(2,jat)- svar * (acoords(2,iat)-acoords(2,jat))
        agrad(3,jat)=agrad(3,jat)- svar * (acoords(3,iat)-acoords(3,jat))
      end do
    end do
    gradient=reshape(agrad,(/nvar/))

  case(4)

    energy=0.D0
    gradient=0.D0
    xvar= coords(1)
    yvar= (Vb+Va)/(Vb-Va)*exp(alpha*xvar)
    
    energy=Va*yvar/(1.D0+yvar)+Vb*yvar/(1.D0+yvar)**2
    svar=1.D0+yvar
    gradient(1)=alpha*yvar * ( &
        Va/svar + (Vb-Va*yvar)/svar**2 - 2.D0*Vb*yvar/svar**3)
    
  case(5)
!!$    !assign parameters for Eckart potential (see Andri's thesis) ???
!!$    xvar= coords(1)
!!$    energy=V0*(xvar**2/x0**2-1.D0)**2
!!$    gradient=0.D0
!!$    gradient(1)= V0 * 4.D0 / x0**2 * (xvar**3/x0**2-xvar)
    
    ! 3rd order polynomial as also used in the 1D-scattering code
    xvar=coords(1)*1.5D0
    energy=50.D0*(-2.D0*xvar**3+3.D0*xvar**2)
    gradient=0.D0
    gradient(1)= 50.D0*(-6.D0*xvar**2+6.D0*xvar) * 1.5D0

    
  case(6)
    
    !Vibrational potential
    !call vib_get_gradient(coords,energy,gradient)
    call dlf_fail("Vibrational calculations not linked")

  case(7)
    !print*,"coords in energy eval",coords
    x =  coords(1)
    y =  coords(2)
    t =  smallbarvar 
    
    energy=0.D0
    gradient=0.D0
    
    energy = 10.D0*dexp(-2.D0*(x+1.D0)**2)*(dexp(-2.D0*(y-1.D0)**2)+(dexp(-2.D0*(y+1.D0)**2)))- &
        3.D0*dexp(-2.D0*(y**2+(x+2.D0)**2)) - 1.6D0*dexp(-2.D0*(x-1.D0)**2)* &
        (dexp(-2.D0*(y+t)**2)+dexp(-2.D0*(y-t)**2))
    gradient(1)= -4.D0*(10.D0*dexp(-2.D0*(x+1.D0)**2)*(dexp(-2.D0*(y-1.D0)**2)+ & 
        (dexp(-2.D0*(y+1.D0)**2)))*(x+1.D0)-3.D0*dexp(-2.D0*(y**2+(x+2.D0)**2))*(x+2.D0)- &
        1.6D0*dexp(-2.D0*(x-1.D0)**2)*(dexp(-2.D0*(y+t)**2)+ &
        dexp(-2.D0*(y-t)**2))*(x-1.D0))
    gradient(2)= -4.D0*(10.D0*dexp(-2.D0*(x+1.D0)**2)*(dexp(-2.D0*(y-1.D0)**2)* &
        (y-1.D0)+(dexp(-2.D0*(y+1.D0)**2)*(y+1.D0)))-3.D0*dexp(-2.D0*(y**2+(x+2.D0)**2))*y- &
        1.6D0*dexp(-2*(x-1)**2)*(dexp(-2*(y+t)**2)*(y+t)+ &
        dexp(-2.D0*(y-t)**2)*(y-t)))
    
  case(8)
    ! polymul (Polynomial in multiple dimensions)
    ! E=E1+E2+...+En
    ! E1= (-2Ebarr) x1**3 + (3Ebarr) x1**2
    ! Ei=xi**2 * 1/2 * d_i (1-x1/5)  | i>1
    gradient=0.D0
    energy= -2.D0 * Ebarr * coords(1)**3 + 3.D0 * Ebarr * coords(1)**2
    gradient(1)=-6.D0 * Ebarr * coords(1)**2 + 6.D0 * Ebarr * coords(1)
    do icount=2,num_dim
!!$      ! finite vdamp
!!$      energy=energy+coords(icount)**2*0.5D0 * dpar(icount) * (1.D0-coords(1)/vdamp)
!!$      gradient(1)=gradient(1) -0.5D0*dpar(icount)*coords(icount)**2/vdamp
!!$      gradient(icount)=coords(icount) * dpar(icount) * (1.D0-coords(1)/vdamp)
      ! vdamp=infinity
      energy=energy+coords(icount)**2*0.5D0 * dpar(icount) 
      gradient(icount)=coords(icount) * dpar(icount)
    end do
    
  end select
  status=0
end subroutine dlf_get_gradient

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_get_hessian(nvar,coords,hessian,status)
  !  get the hessian at a given geometry
  use dlf_parameter_module
  use driver_module
  use driver_parameter_module
  !use vib_pot
  implicit none
  integer   ,intent(in)    :: nvar
  real(rk)  ,intent(in)    :: coords(nvar)
  real(rk)  ,intent(out)   :: hessian(nvar,nvar)
  integer   ,intent(out)   :: status
  real(rk) :: acoords(3,nvar/3),r,svar,svar2
  integer  :: posi,posj,iat,jat,m,n
  ! variables for Mueller-Brown potential
  real(rk) :: x,y
  integer  :: icount
  ! variables non-cont. diff. potential
  real(rk) :: t
! **********************************************************************
  hessian(:,:)=0.D0
  status=1
  select case (isystem)
  case(1)

    x =  coords(1)
    y =  coords(2)

    hessian=0.D0
    do icount=1,4
      svar= apar(icount)*(x-x0par(icount))**2 + &
          bpar(icount)*(x-x0par(icount))*(y-y0par(icount)) + &
          cpar(icount)*(y-y0par(icount))**2 
      svar2= acappar(icount) * dexp(svar)
      !energy=energy+ svar2
!!$      gradient(1)=gradient(1) + svar2 * &
!!$          (2.D0* apar(icount)*(x-x0par(icount))+bpar(icount)*(y-y0par(icount)))
!!$      gradient(2)=gradient(2) + svar2 * &
!!$          (2.D0* cpar(icount)*(y-y0par(icount))+bpar(icount)*(x-x0par(icount)))
      hessian(1,1)=hessian(1,1)+svar2 * &
          (2.D0* apar(icount)*(x-x0par(icount))+bpar(icount)*(y-y0par(icount)))**2 + &
          svar2 * 2.D0 * apar(icount)
      hessian(2,2)=hessian(2,2)+svar2 * &
          (2.D0* cpar(icount)*(y-y0par(icount))+bpar(icount)*(x-x0par(icount)))**2 + &
          svar2 * 2.D0 * cpar(icount)
      hessian(1,2)=hessian(1,2) + svar2 * &
          (2.D0* apar(icount)*(x-x0par(icount))+bpar(icount)*(y-y0par(icount)))* &
          (2.D0* cpar(icount)*(y-y0par(icount))+bpar(icount)*(x-x0par(icount))) + &
          svar2 * bpar(icount)
    end do
    hessian(2,1)=hessian(1,2)
    status=0

  case(2,3)
    acoords=reshape(coords,(/3,nvar/3/))
    do iat=1,nvar/3
      do jat=iat+1,nvar/3
        r=sum((acoords(:,iat)-acoords(:,jat))**2)
        ! Lennard-Jones Potential
        svar = 96.D0*epsilon * (7.D0*sigma**12/r**8-2.D0*sigma**6/r**5) ! coeff of x1x2
        svar2= epsilon * (-2.D0*sigma**12/r**7+sigma**6/r**4) ! for x1x1
        posi=(iat-1)*3+1
        posj=(jat-1)*3+1
        ! off-diag
        hessian(posi,posi+1)  =hessian(posi,posi+1)  + svar * (acoords(1,iat)-acoords(1,jat)) * (acoords(2,iat)-acoords(2,jat))
        hessian(posi,posi+2)  =hessian(posi,posi+2)  + svar * (acoords(1,iat)-acoords(1,jat)) * (acoords(3,iat)-acoords(3,jat))
        hessian(posi+1,posi)  =hessian(posi+1,posi)  + svar * (acoords(2,iat)-acoords(2,jat)) * (acoords(1,iat)-acoords(1,jat))
        hessian(posi+1,posi+2)=hessian(posi+1,posi+2)+ svar * (acoords(2,iat)-acoords(2,jat)) * (acoords(3,iat)-acoords(3,jat))
        hessian(posi+2,posi)  =hessian(posi+2,posi)  + svar * (acoords(3,iat)-acoords(3,jat)) * (acoords(1,iat)-acoords(1,jat))
        hessian(posi+2,posi+1)=hessian(posi+2,posi+1)+ svar * (acoords(3,iat)-acoords(3,jat)) * (acoords(2,iat)-acoords(2,jat))

        do m=0,2
          do n=0,2
            if(m==n) cycle
  hessian(posi+m,posj+n)=hessian(posi+m,posj+n)- svar * (acoords(M+1,iat)-acoords(M+1,jat)) * (acoords(N+1,iat)-acoords(N+1,jat))
  hessian(posj+m,posi+n)=hessian(posj+m,posi+n)- svar * (acoords(M+1,iat)-acoords(M+1,jat)) * (acoords(N+1,iat)-acoords(N+1,jat))
          end do
        end do
        ! Diag for different atoms ...
        do m=0,2
          hessian(posi+m,posj+m)=hessian(posi+m,posj+m) - 24.D0*(svar2+1.D0/24.D0*svar* (acoords(m+1,iat)-acoords(M+1,jat))**2)
          hessian(posj+m,posi+m)=hessian(posj+m,posi+m) - 24.D0*(svar2+1.D0/24.D0*svar* (acoords(m+1,iat)-acoords(M+1,jat))**2)
        end do

        hessian(posj,posj+1)  =hessian(posj,posj+1)  + svar * (acoords(1,iat)-acoords(1,jat)) * (acoords(2,iat)-acoords(2,jat))
        hessian(posj,posj+2)  =hessian(posj,posj+2)  + svar * (acoords(1,iat)-acoords(1,jat)) * (acoords(3,iat)-acoords(3,jat))
        hessian(posj+1,posj)  =hessian(posj+1,posj)  + svar * (acoords(2,iat)-acoords(2,jat)) * (acoords(1,iat)-acoords(1,jat))
        hessian(posj+1,posj+2)=hessian(posj+1,posj+2)+ svar * (acoords(2,iat)-acoords(2,jat)) * (acoords(3,iat)-acoords(3,jat))
        hessian(posj+2,posj)  =hessian(posj+2,posj)  + svar * (acoords(3,iat)-acoords(3,jat)) * (acoords(1,iat)-acoords(1,jat))
        hessian(posj+2,posj+1)=hessian(posj+2,posj+1)+ svar * (acoords(3,iat)-acoords(3,jat)) * (acoords(2,iat)-acoords(2,jat))
        ! diag
        hessian(posi,posi)    =hessian(posi,posi)    + 24.D0*(svar2+1.D0/24.D0*svar* (acoords(1,iat)-acoords(1,jat))**2)
        hessian(posi+1,posi+1)=hessian(posi+1,posi+1)+ 24.D0*(svar2+1.D0/24.D0*svar* (acoords(2,iat)-acoords(2,jat))**2)
        hessian(posi+2,posi+2)=hessian(posi+2,posi+2)+ 24.D0*(svar2+1.D0/24.D0*svar* (acoords(3,iat)-acoords(3,jat))**2)

        hessian(posj,posj)    =hessian(posj,posj)    + 24.D0*(svar2+1.D0/24.D0*svar* (acoords(1,iat)-acoords(1,jat))**2)
        hessian(posj+1,posj+1)=hessian(posj+1,posj+1)+ 24.D0*(svar2+1.D0/24.D0*svar* (acoords(2,iat)-acoords(2,jat))**2)
        hessian(posj+2,posj+2)=hessian(posj+2,posj+2)+ 24.D0*(svar2+1.D0/24.D0*svar* (acoords(3,iat)-acoords(3,jat))**2)
      end do
    end do
    status=0
    status=1 ! 1= not possible
  case(4)
    ! Eckart
    xvar= coords(1)
    yvar= (Vb+Va)/(Vb-Va)*exp(alpha*xvar)
    svar=1.D0+yvar
    hessian(1,1)=alpha**2*yvar * ( Va/svar + (Vb-Va*yvar)/svar**2 - 2.D0*Vb*yvar/svar**3) + &
        alpha**2 * yvar**2 / svar**2 * ( -2.D0*Va + (-4.D0*Vb+2.D0*Va*yvar)/svar +6.D0*Vb*yvar/svar**2)
!!$    ! debug output - test of hessian-at-maximum-equations.
!!$    print*,"Hessian calculated, 1,1:",hessian(1,1)+alpha**2*vb/8.D0,hessian(1,1),-alpha**2*vb/8.D0
!!$    print*,"Hessian short           ",hessian(1,1)+alpha**2*(Va+Vb)**2*(Vb-Va)/8.D0/Vb**3    ,&
!!$        hessian(1,1),-alpha**2*(Va+Vb)**3*(Vb-Va)/8.D0/Vb**3
!!$    print*,va,hessian(1,1)+0.08085432314993411D0,"leading"
!!$    print*,"should be zero",Va/svar + (Vb-Va*yvar)/svar**2 - 2.D0*Vb*yvar/svar**3
    status=0 ! 0=OK 1=not available 
  case(5)
!!$    ! Quartic
!!$    xvar= coords(1)
!!$    hessian(1,1)=V0 * 4.D0 / x0**2 * (3.D0*xvar**2/x0**2-1.D0)
!!$    status=0 
    
    ! 3rd order polynomial as also used in the 1D-scattering code
    xvar=coords(1)*1.5D0
    !gradient(1)= 50.D0*(-6.D0*xvar**2+6.D0*xvar) * 1.5D0
    hessian(1,1)=50.D0*(-12.D0*xvar+6.D0) * 1.5D0**2
    status=0 

  case(6)
    !Vibrational potential
    !call vib_get_hessian(coords,hessian)
    !status=0 
  case(7)

    x =  coords(1)
    y =  coords(2)
    t =  smallbarvar 
    hessian=0.D0


!!$    energy = 10.D0*dexp(-2.D0*(x+1.D0)**2)*(dexp(-2.D0*(y-1.D0)**2)+(dexp(-2.D0*(y+1.D0)**2)))- &
!!$       dexp(-2.D0*(y**2+(x+2.D0)**2)) - 1.6D0*dexp(-2.D0*(x-1.D0)**2)* &
!!$       (dexp(-2.D0*(y+t)**2)+dexp(-2.D0*(y-t)**2))

    hessian(1,1)=-4.D0*(10.D0*(dexp(-2.D0*(y-1.D0)**2)+dexp(-2.D0*(y+1.D0)**2))*(dexp(-2.D0*(x+1.D0)**2)*&
        (-4.D0*(x+1.D0)**2+1.D0))-3.D0*dexp(-2.D0*(y**2+(x+2.D0)**2))*(-4.D0*(x+2.D0)**2+1.D0)-1.6D0* &
        (dexp(-2.D0*(x-1.D0)**2)*(-4.D0*(x-1.D0)**2+1.D0))*(dexp(-2.D0*(y+t)**2)+dexp(-2.D0*(y-t)**2)))
    
    hessian(2,2)=-4.D0*(10.D0*dexp(-2.D0*(x+1.D0)**2)*(dexp(-2.D0*(y-1.D0)**2)*(-4.D0*(y-1.D0)**2+1.D0))- &
        3.D0*dexp(-2.D0*(y**2+(x+2.D0)**2))*(-4.D0*y**2+1.D0)-1.6D0*dexp(-2.D0*(x-1.D0)**2)* &
        (dexp(-2.D0*(y+t)**2)*(-4.D0*(y+t)**2+1.D0)+dexp(-2.D0*(y-t)**2)*(-4.D0*(y-t)**2+1.D0)))
    
    hessian(1,2)= 8.D0*(10.D0*dexp(-2.D0*(x+1.D0)**2)*(x+1.D0)*(dexp(-2.D0*(y-1.D0)**2)*(y-1.D0)+ &
        (dexp(-2.D0*(y+1.D0)**2)*(y+1.D0)))-3.D0*dexp(-2.D0*(y**2+(x+2.D0)**2))*(x+2.D0)*y- &
        1.6D0*dexp(-2.D0*(x-1.D0)**2)*(dexp(-2.D0*(y+t)**2)*(y+t)+dexp(-2.D0*(y-t)**2)*(y-t))*(x-1.D0))

    hessian(2,1)=hessian(1,2)

    status=0

  case(8)
    ! polymul (Polynomial in multiple dimensions)
    ! E=E1+E2+...+En
    ! E1= (-2Ebarr) x1**3 + (3Ebarr) x1**2
    ! Ei=xi**2 * 1/2 * d_i (1-x1/5)  | i>1
    hessian=0.D0
    hessian(1,1)=-12.D0 * Ebarr * coords(1) + 6.D0 * Ebarr
!!$    ! finite vdamp
!!$    do iat=2,num_dim
!!$      hessian(1,iat)=-2.D0/vdamp * coords(iat)
!!$      hessian(iat,1)=-2.D0/vdamp * coords(iat)
!!$    end do
    do iat=2,num_dim
!!$      ! finite vdamp
!!$      hessian(iat,iat)=dpar(iat) * (1.D0-coords(1)/vdamp)
      ! vdamp = infinity
      hessian(iat,iat)=dpar(iat)
    end do
    
    status=0

  end select

end subroutine dlf_get_hessian

! initialize parameters for the test potentials
subroutine driver_init
  use driver_parameter_module
  implicit none
  real(rk) :: ebarr_
  integer :: icount
  ! assign parameters for MB potential
  ebarr_=0.5D0
  acappar(1)=-200.D0*ebarr_/106.D0
  acappar(2)=-100.D0*ebarr_/106.D0
  acappar(3)=-170.D0*ebarr_/106.D0
  acappar(4)=  15.D0*ebarr_/106.D0
  apar(1)=-1.D0
  apar(2)=-1.D0
  apar(3)=-6.5D0
  apar(4)=0.7D0
  bpar(1)=0.D0
  bpar(2)=0.D0
  bpar(3)=11.D0
  bpar(4)=0.6D0
  cpar(1)=-10.D0
  cpar(2)=-10.D0
  cpar(3)=-6.5D0
  cpar(4)=0.7D0
  x0par(1)=1.D0
  x0par(2)=0.D0
  x0par(3)=-0.5D0
  x0par(4)=-1.D0
  y0par(1)=0.D0
  y0par(2)=0.5D0
  y0par(3)=1.5D0
  y0par(4)=1.D0
  ! parameters for polymul
  dpar(1)=0.D0
  do icount=2,num_dim
    dpar(icount)=1.D-4+(dble(icount-2)/dble(num_dim-2))**2*0.415D0
  end do
end subroutine driver_init

! classical flux of the Eckart potential 
! returns log(flux)
subroutine driver_clrate(beta_hbar,flux)
  use driver_parameter_module
  implicit none
  real(rk),intent(in) :: beta_hbar
  real(rk),intent(out):: flux
  real(rk) :: vmax,pi
  pi=4.D0*atan(1.D0)
  vmax=(Va+Vb)**2/(4.D0*Vb)
  print*,"V_max=",vmax
  flux=-beta_hbar*vmax-log(2.D0*pi*beta_hbar)
  
end subroutine driver_clrate

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_put_coords(nvar,mode,energy,coords,iam)
  use dlf_parameter_module
  implicit none
  integer   ,intent(in)    :: nvar
  integer   ,intent(in)    :: mode
  integer   ,intent(in)    :: iam
  real(rk)  ,intent(in)    :: energy
  real(rk)  ,intent(in)    :: coords(nvar)
  integer                  :: iat
! **********************************************************************

! Only do this writing of files if I am the rank-zero processor
  if (iam /= 0) return

  if(mod(nvar,3)==0) then
    !assume coords are atoms
    if(mode==2) then
      open(unit=20,file="tsmode.xyz")
    else
      open(unit=20,file="coords.xyz")
    end if
    write(20,*) nvar/3
    write(20,*) 
    do iat=1,nvar/3
      write(20,'("H ",3f12.7)') coords((iat-1)*3+1:(iat-1)*3+3)
    end do
    close(20)
  else
    !print*,"Coords in put_coords: ",coords
  end if
end subroutine dlf_put_coords

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_error()
  implicit none
! **********************************************************************
  call dlf_mpi_abort() ! only necessary for a parallel build;
                       ! can be present for a serial build
  call exit(1)
end subroutine dlf_error

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_update()
  implicit none
! **********************************************************************
  ! only a dummy routine here.
end subroutine dlf_update


subroutine dlf_get_multistate_gradients(nvar,coords,energy,gradient,iimage,status)
  ! only a dummy routine up to now
  ! for conical intersection search
  use dlf_parameter_module
  implicit none
  integer   ,intent(in)    :: nvar
  integer   ,intent(in)    :: coords(nvar)
  real(rk)  ,intent(in)    :: energy(2)
  real(rk)  ,intent(in)    :: gradient(nvar,2)
  integer   ,intent(in)    :: iimage
  integer   ,intent(in)    :: status
end subroutine dlf_get_multistate_gradients


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_put_procinfo(dlf_nprocs, dlf_iam, dlf_global_comm)

  implicit none

  integer, intent(in) :: dlf_nprocs ! total number of processors
  integer, intent(in) :: dlf_iam ! my rank, from 0, in mpi_comm_world
  integer, intent(in) :: dlf_global_comm ! world-wide communicator
! **********************************************************************

!!! variable in the calling program = corresponding dummy argument

end subroutine dlf_put_procinfo


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_get_procinfo(dlf_nprocs, dlf_iam, dlf_global_comm)

  implicit none

  integer :: dlf_nprocs ! total number of processors
  integer :: dlf_iam ! my rank, from 0, in mpi_comm_world
  integer :: dlf_global_comm ! world-wide communicator
! **********************************************************************

!!! dummy argument = corresponding variable in the calling program

end subroutine dlf_get_procinfo


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_put_taskfarm(dlf_ntasks, dlf_nprocs_per_task, dlf_iam_in_task, &
                        dlf_mytask, dlf_task_comm, dlf_ax_tasks_comm)

  implicit none

  integer, intent(in) :: dlf_ntasks          ! number of taskfarms
  integer, intent(in) :: dlf_nprocs_per_task ! no of procs per farm
  integer, intent(in) :: dlf_iam_in_task     ! my rank, from 0, in my farm
  integer, intent(in) :: dlf_mytask          ! rank of my farm, from 0
  integer, intent(in) :: dlf_task_comm       ! communicator within each farm
  integer, intent(in) :: dlf_ax_tasks_comm   ! communicator involving the 
                                             ! i-th proc from each farm
! **********************************************************************

!!! variable in the calling program = corresponding dummy argument 

end subroutine dlf_put_taskfarm


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_get_taskfarm(dlf_ntasks, dlf_nprocs_per_task, dlf_iam_in_task, &
                        dlf_mytask, dlf_task_comm, dlf_ax_tasks_comm)

  implicit none

  integer :: dlf_ntasks          ! number of taskfarms
  integer :: dlf_nprocs_per_task ! no of procs per farm
  integer :: dlf_iam_in_task     ! my rank, from 0, in my farm
  integer :: dlf_mytask          ! rank of my farm, from 0
  integer :: dlf_task_comm       ! communicator within each farm
  integer :: dlf_ax_tasks_comm   ! communicator involving the
                                 ! i-th proc from each farm
! **********************************************************************

!!! dummy argument = corresponding variable in the calling program

end subroutine dlf_get_taskfarm


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_output(dum_stdout, dum_stderr)
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr,stdout,keep_alloutput
  implicit none
  integer :: dum_stdout
  integer :: dum_stderr
  integer :: ierr
  logical :: topened
  character(len=10) :: suffix

! sort out output units; particularly important on multiple processors
 
! set unit numbers for main output and error messages
  if (dum_stdout >= 0) stdout = dum_stdout 
  if (dum_stderr >= 0) stderr = dum_stderr

  if (glob%iam /= 0) then
     inquire(unit=stdout, opened=topened, iostat=ierr)
     if (topened .and. ierr == 0) close(stdout)
     if (keep_alloutput) then ! hardwired in dlf_global_module.f90
        write(suffix,'(i10)') glob%iam
        open(unit=stdout,file='output.proc'//trim(adjustl(suffix)))
     else
        open(unit=stdout,file='/dev/null')
     end if
  endif

  if (glob%nprocs > 1) then
     ! write some info on the parallelization
     write(stdout,'(1x,a,i10,a)')"I have rank ",glob%iam," in mpi_comm_world"
     write(stdout,'(1x,a,i10)')"Total number of processors = ",glob%nprocs
     if (keep_alloutput) then
        write(stdout,'(1x,a)')"Keeping output from all processors"
     else
        write(stdout,'(1x,a)')"Not keeping output from processors /= 0"
     end if
  end if

end subroutine dlf_output


! **********************************************************************
! **********************************************************************
! The following routine either writes random numbers to a file, or reads
! them. This is to have equal starting conditions for different compilers
subroutine read_rand(arr)
  use dlf_parameter_module, only: rk
  use dlf_global, only : glob
  real(rk)  :: arr(:)
  integer, parameter :: si1=12
  integer, parameter :: si2=3000
  logical,parameter :: readf=.true.
  real(rk) :: ar(si2)
  integer :: l(1),length
  l=ubound(arr)
  length=l(1)
  if(readf) then
    if(length<=si1) then
      open(unit=201,file="random1.bin",form="unformatted")
    else if(length<=si2) then
      open(unit=201,file="random2.bin",form="unformatted")
    else
      call dlf_mpi_finalize() ! only necessary for a parallel build;
                              ! can be present for a serial build
      stop "Too many coordinates to be read from random.bin file"
    end if
    read(201) ar(1:length)
    close(201)
    arr=ar(1:length)
  else
    if (glob%iam == 0) then
       call random_number(ar)
       open(unit=201,file="random1.bin",form="unformatted")
       write(201) ar(1:si1)
       close(201)
       open(unit=201,file="random2.bin",form="unformatted")
       write(201) ar(1:si2)
       close(201)
    end if
  end if
end subroutine read_rand

subroutine driver_eck(vb_,alpha_)
  use dlf_parameter_module
  use driver_parameter_module
  real(rk),intent(out) :: vb_,alpha_
  vb_=vb
  alpha_=alpha
end subroutine driver_eck

!  Copyright (C) 2017 The authors of Py-ChemShell
!
!  This file is part of Py-ChemShell.
!
!  Py-ChemShell is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as
!  published by the Free Software Foundation, either version 3 of the
!  License, or (at your option) any later version.
!
!  Py-ChemShell is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with Py-ChemShell.  If not, see
!  <http://www.gnu.org/licenses/>.

module gulp_datatypes
    integer, parameter :: i4 = selected_int_kind(5)
    integer, parameter :: dp = kind(1.0d0)
endmodule

! Dummy routines to link against a library that 
! support ChemShell builds

!----------------------------------------------------------------      
subroutine getGulpFileNames(input, output, len)

    use gulp_datatypes
  
    implicit none
  
    character(*), intent(out) :: input
    character(*), intent(out) :: output
    integer(i4) , intent(in)  :: len
  
    ! TODO remove hardwired names, take from interface options instead
    input  = "_gulp.gin"
    output = "_gulp.gout"
  
endsubroutine getGulpFileNames
!----------------------------------------------------------------      

!----------------------------------------------------------------    
! do not get confused: here "root" does not refer to the "root" in Py-ChemShell task farming (see NWChem interface)
logical function opc_root() result(result)

  use ChemShellParallelModule, only : chemsh_parallel

  implicit none

  result = chemsh_parallel%is_root()

endfunction opc_root
!----------------------------------------------------------------      

! **********************************************************************
! **                                                                  **
! **            Conical intersection optimisation routines            **
! **                                                                  **
! **                          Tom Keal, 2007                          **
! **                                                                  **
! **********************************************************************
!!****h* DL-FIND/conint
!!
!! NAME
!! conint
!!
!! FUNCTION
!! Routines for conical intersection optimisations
!!
!! COMMENTS
!! Three optimisation algorithms are implemented: penalty function (pf),
!! gradient projection (gp), and Lagrange-Newton (ln).
!!
!! A detailed comparison of these algorithms can be found in:
!!
!! Thomas W. Keal, Axel Koslowski, Walter Thiel, "Comparison of 
!! algorithms for conical intersection optimisation using semiempirical
!! methods", Theo. Chem. Acc. (2007). doi: 10.1007/s00214-007-0331-5
!!
!! The nomenclature used here is the same as in the above paper.
!! Equation numbers refer to this paper.
!!
!! DATA
!!  $Date$
!!  $Rev$
!!  $Author$
!!  $URL$
!!  $Id$
!!
!! COPYRIGHT
!!
!!  Copyright 2007 Tom Keal (thomas.keal@stfc.ac.uk)
!!
!!  This file is part of DL-FIND.
!!
!!  DL-FIND is free software: you can redistribute it and/or modify
!!  it under the terms of the GNU Lesser General Public License as 
!!  published by the Free Software Foundation, either version 3 of the 
!!  License, or (at your option) any later version.
!!
!!  DL-FIND is distributed in the hope that it will be useful,
!!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!!  GNU Lesser General Public License for more details.
!!
!!  You should have received a copy of the GNU Lesser General Public 
!!  License along with DL-FIND.  If not, see 
!!  <http://www.gnu.org/licenses/>.
!!
!! SOURCE
module dlf_conint
  use dlf_parameter_module, only: rk
  type conint_type
     ! Gradients for the Lagrange-Newton method
     ! Gradient average (g_i + g_j) / 2
     real(rk), allocatable :: xGradMean(:,:)
     real(rk), allocatable :: iGradMean(:)
     real(rk), allocatable :: iGradMeanOld(:)
     ! Gradient difference in cartesians and internals
     real(rk), allocatable :: xGradDiff(:,:)
     real(rk), allocatable :: iGradDiff(:)
     real(rk), allocatable :: iGradDiffOld(:)
     ! Gradient of the interstate coupling in internals
     real(rk), allocatable :: iCoupling(:) 
     real(rk), allocatable :: iCouplingOld(:)
     ! Flag for activation of extrapolatable functions
     logical :: extrap
     ! Flag to indicate if old gradients were orthogonalised
     logical :: oldIsOrthog
  end type conint_type
  type(conint_type), save :: conint
end module dlf_conint
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* conint/dlf_conint_check_consistency
!!
!! FUNCTION
!!
!! Check that no incompatible sets of input options have been specified
!! for a multistate calculation.
!!
!! The allowed options vary significantly between multistate methods.
!!
!! For the penalty function (imultistate=1) and gradient projection 
!! methods (imultistate=2), the optimisation algorithm and coordinate
!! system is essentially independent of the method. However, there is 
!! no well-defined objective function for the gradient projection 
!! method, so no routines that assume that an objective function exists
!! can be used (e.g. an energy-based trust radius).
!!
!! For the Lagrange-Newton method (imultistate=3), the Lagrange-Newton
!! optimiser must be used (iopt=40) with a special coordinate system
!! (icoord=10:19).
!!
!! INPUTS
!!
!! glob%imultistate
!! glob%icoord
!! glob%iopt
!! glob%iline 
!! glob%inithessian
!!
!! OUTPUTS
!! 
!! none
!!
!! SYNOPSIS
subroutine dlf_conint_check_consistency
!! SOURCE
  use dlf_global, only: glob, stderr

  select case (glob%imultistate)
  case (1)
     ! Penalty function checks
     if (glob%icoord > 9) call dlf_fail("A standard coordinate system &
          &must be used with the penalty function method")
     if (glob%iopt == 30 .or. glob%iopt == 40) call dlf_fail("The &
          &selected optimiser is not compatible with the penalty & 
          &function method")
     if (glob%nzero /= 0) call dlf_fail("Soft mode skipping with &
          &nzero is not compatible with the penalty function method")
     if (glob%imicroiter > 0) call dlf_fail("Microiterative &
          &conical intersection search is not yet implemented")
  case (2)
     ! Gradient projection checks
     if (glob%icoord > 9) call dlf_fail("A standard coordinate system &
          &must be used with the gradient projection method")
     if (glob%iopt == 30 .or. glob%iopt == 40) call dlf_fail("The &
          &selected optimiser is not compatible with the gradient &
          &projection method")
     if (glob%iline == 1) call dlf_fail("Energy-based trust radius &
          &not possible with the gradient projection method")
     if (glob%nzero /= 0) call dlf_fail("Soft mode skipping with &
          &nzero is not compatible with the gradient projection method")
     if (glob%imicroiter > 0) call dlf_fail("Microiterative &
          &conical intersection search is not yet implemented")
  case (3)
     ! Lagrange-Newton checks
     if (glob%iopt /= 40) call dlf_fail("The Lagrange-Newton optimiser &
          &must be used with the Lagrange-Newton method")
     if (glob%icoord < 10 .or. glob%icoord > 19) call dlf_fail("A &
          &Lagrange-Newton coordinate system must be used with the &
          &Lagrange-Newton method")
     if (glob%inithessian == 0) call dlf_fail("The Hessian for the &
          &Lagrange-Newton method cannot be calculated externally")
     if (glob%nzero /= 0) call dlf_fail("Soft mode skipping with &
          &nzero is not supported with the Lagrange-Newton method")   
     if (glob%imicroiter > 0) call dlf_fail("Microiterative &
          &conical intersection search is not yet implemented")  
  case default
    write(stderr, '(a,i4,a)') &
         "Multistate calculation", glob%imultistate, "not implemented"
    call dlf_fail("Multistate calculation option error")
  end select

end subroutine dlf_conint_check_consistency
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* conint/dlf_make_conint_gradient
!!
!! FUNCTION
!!
!! Call the appropriate routine for constructing the optimiser 
!! gradient from the individual state gradients.
!!
!! INPUTS
!!
!! glob%imultistate
!!
!! OUTPUTS
!! 
!! none
!!
!! SYNOPSIS
subroutine dlf_make_conint_gradient
!! SOURCE
  use dlf_global, only: glob, stderr

  select case (glob%imultistate) 
  case (1)
     call dlf_make_pf_gradient
  case (2)
     call dlf_make_gp_gradient
  case (3)
     call dlf_make_ln_gradient_pretrans
  case default
    write(stderr, '(a,i4,a)') &
         "Multistate calculation", glob%imultistate, "not implemented"
    call dlf_fail("Multistate calculation option error")
  end select

end subroutine dlf_make_conint_gradient
!!****
!!
! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* conint/dlf_make_pf_gradient
!!
!! FUNCTION
!!
!! Construct penalty function gradient from individual state gradients.
!!
!! INPUTS
!!
!! glob%msenergy
!! glob%msgradient
!! glob%pf_c1
!! glob%pf_c2
!!
!! OUTPUTS
!! 
!! glob%energy
!! glob%xgradient
!!
!! SYNOPSIS
subroutine dlf_make_pf_gradient
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob, stdout, printl
  implicit none
  real(rk) :: wdiff, gscale
  integer :: ivar
  real(rk) :: c1h, c2h

  if (printl >= 6) write(stdout, '(a)') &
       "Calculating penalty function gradient"

! Convert c1 from (kcal/mol)^(-1) to Eh^(-1)
  c1h = glob%pf_c1 * 627.511525d0
! Convert c2 from kcal/mol to Eh
  c2h = glob%pf_c2 / 627.511525d0

! Calculate objective function for the penalty function method (Eq. 4)
! Stored in glob%energy for use by the optimiser.
  wdiff = 1.0d0 + &
       ((glob%msenergy(2) - glob%msenergy(1)) ** 2.0d0) / &
       (c2h ** 2.0d0)

  glob%energy = 0.5d0 * (glob%msenergy(1) + glob%msenergy(2)) + &
       c1h * (c2h ** 2.0d0) * dlog(wdiff)

! Calculate the gradient of the objective function (gradient of Eq. 4)
! Stored in glob%xgradient for use by the optimiser (after 
! transformation to the desired coordinate system).
  gscale = 2.0d0 * c1h * & 
       (glob%msenergy(2) - glob%msenergy(1)) / wdiff

  glob%xgradient = (0.5d0 + gscale) * glob%msgradient(:,:,2) + &
                   (0.5d0 - gscale) * glob%msgradient(:,:,1)

  if (printl >=6) then
     write(stdout, '(a,/,f20.10)') "PF energy:", glob%energy
     write(stdout, '(a)') "PF gradient:"
     do ivar = 1, glob%nat
        write(stdout,'(3f20.10)') glob%xgradient(:, ivar)
     end do
  end if

end subroutine dlf_make_pf_gradient
!!****
!!
! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* conint/dlf_make_gp_gradient
!!
!! FUNCTION
!!
!! Construct gradient projection gradient from individual state
!! gradients.
!!
!! INPUTS
!!
!! glob%msenergy 
!! glob%msgradient
!! glob%gp_c3
!! glob%gp_c4
!!
!! OUTPUTS
!! 
!! glob%energy
!! glob%xgradient
!!
!! SYNOPSIS
subroutine dlf_make_gp_gradient
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob, stdout, printl
  implicit none
  real(rk), external :: ddot
  real(rk) :: gradDiff(3, glob%nat)
  real(rk) :: normGradDiff, normCoupling
  real(rk) :: projectedCoupling
  real(rk) :: tildeCoupling(3, glob%nat) ! orthonormalised coupling
  real(rk) :: f1(3, glob%nat)
  real(rk) :: f2(3, glob%nat)
  real(rk) :: tiny = 1.0d-10
  integer  :: ivar
  integer  :: i3nat

  if (printl >= 6) write(stdout, '(a)') &
       "Calculating gradient projection gradient"

  i3nat = 3 * glob%nat

! There is no 'energy' associated with the gradient projection algorithm
  glob%energy = 0.0d0

! Calculate gradient projection gradient
! Important note: for consistency the gradient difference and energy 
! difference are defined here as they are defined in the paper (Eqs. 2 
! and 5), and not as in the original MNDO implentation where the signs 
! of both were reversed.
! The two implementations are mathematically equivalent.

! Gradient difference is defined as g(I) - g(J)
! This is to be consistent with the paper (Eq. 2) 
! Note it is not consistent with the original MNDO implementation,
! where the sign is reversed
  gradDiff = glob%msgradient(:,:,1) - glob%msgradient(:,:,2)

! Normalise the gradient difference (but avoid division by zero).
  normGradDiff = sqrt(ddot(i3nat, gradDiff, 1, gradDiff, 1))
  if (normGradDiff > tiny) gradDiff = (1.D0 / normGradDiff) * gradDiff

! Now we can calculate f1 (Eq. 5)
! Note again the sign of the energy difference is consistent with the 
! paper but opposite to that in the MNDO implementation.
  f1 = 2.0d0 * (glob%msenergy(1) - glob%msenergy(2)) * gradDiff

! Compute projection of coupling vector along gradient difference vector
  projectedCoupling = ddot(i3nat, glob%mscoupling, 1, gradDiff, 1)

! Orthogonalise coupling vector: h(IJ) - <g(IJ)|h(IJ)> g(IJ)
  tildeCoupling = glob%mscoupling - (projectedCoupling * gradDiff)

! Normalise
  normCoupling = sqrt(ddot(i3nat, tildeCoupling, 1, tildeCoupling, 1))
  if (normCoupling > tiny) &
       tildeCoupling = (1.D0 / normCoupling) * tildeCoupling

! The gradient difference and coupling vectors are now orthonormal, 
! so we can calculate the projected gradient
!
! The projection matrix is defined as (Eq. 6):
! P = 1 - [g(IJ) * g(IJ,transposed)] - [h(IJ) * h(IJ,transposed)]
!
! And the projected gradient (Eq. 7):
! f2 = P * g(J)
!    = g(J) - [g(IJ) * g(IJ,transposed) * g(J)] 
!           - [h(IJ) * h(IJ,transposed) * g(J)] 
! 
! The last multiplication in the second and third terms is actually a 
! dot product.
  f2 = glob%msgradient(:,:,2) &
       - (gradDiff * ddot(i3nat, gradDiff, 1, &
                          glob%msgradient(1,1,2), 1)) &
       - (tildeCoupling * ddot(i3nat, tildeCoupling, 1, &
                               glob%msgradient(1,1,2), 1))

! Now form the gradient for the optimiser (Eq. 8)
! g = c3*[c4*f1 + (1-c4)*f2]
  glob%xgradient = glob%gp_c3 * ((glob%gp_c4 * f1) + &
                                 ((1.D0 - glob%gp_c4) * f2))

! Warning (when comparing the MNDO and DL-FIND implementations)...
! The orthonormalisation procedure when carried out in ChemShell units
! leads to fairly significant variation compared to when carried out 
! in MNDO units. This is a numerical issue rather than an implementation
! difference.

  if (printl >= 6) then
     write(stdout, '(a,/,f20.10)') "GP energy:", glob%energy
     write(stdout, '(a)') "Normalised gradient difference:"
     do ivar = 1, glob%nat
        write(stdout,'(3f20.10)') gradDiff(:, ivar)
     end do
     write(stdout, '(a)') "Orthonormal interstate coupling:"
     do ivar = 1, glob%nat
        write(stdout,'(3f20.10)') tildeCoupling(:, ivar)
     end do
     write(stdout, '(a)') "GP gradient:"
     do ivar = 1, glob%nat
        write(stdout,'(3f20.10)') glob%xgradient(:, ivar)
     end do
  end if

end subroutine dlf_make_gp_gradient
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* conint/dlf_ln_allocate
!!
!! FUNCTION
!!
!! Allocates conint arrays and initialises extra coordinates required
!! for the Lagrange-Newton method
!!
!! INPUTS
!!
!! glob%nat
!! glob%nivar
!!
!! OUTPUTS
!!
!! glob%icoords(glob%nivar - 1:glob%nivar)
!! conint%extrap
!! conint%oldIsOrthog
!! 
!! SYNOPSIS
subroutine dlf_ln_allocate
!! SOURCE
  use dlf_global, only: glob
  use dlf_conint, only: conint
  use dlf_allocate, only: allocate

  call allocate(conint%xGradMean, 3, glob%nat)
  call allocate(conint%iGradMean, glob%nivar - 2)
  call allocate(conint%iGradMeanOld, glob%nivar - 2)
  call allocate(conint%xGradDiff, 3, glob%nat)
  call allocate(conint%iGradDiff, glob%nivar - 2)
  call allocate(conint%iGradDiffOld, glob%nivar - 2)
  call allocate(conint%iCoupling, glob%nivar - 2)
  call allocate(conint%iCouplingOld, glob%nivar - 2)

  glob%icoords(glob%nivar - 1:glob%nivar) = 0.0d0

  conint%extrap = .false.
  conint%oldIsOrthog = .false.

end subroutine dlf_ln_allocate
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* conint/dlf_make_ln_gradient_pretrans
!!
!! FUNCTION
!!
!! Builds the unchanging part of the Lagrange-Newton gradient,
!! i.e. (gi + gj)/2. This is transformed by the usual xtoi procedure.
!!
!! The other parts of the gradient, gij and hij, are transformed 
!! separately and added after coordinate transformation.
!!
!! Rationale: 
!! * The internal forms of gij and hij are directly required to form the
!!   constraint part of the Hessian
!! * The gradient used for updating the non-constraint part of the
!!   Hessian only uses (gi + gj)/2 until it reaches the seam, when
!!   the information from g and h is used as well
!!
!! We also calculate xGradDiff here (cartesian gij) for use in 
!! dlf_coords_xtoi.
!!
!! INPUTS
!!
!! glob%msgradient
!!
!! OUTPUTS
!! 
!! glob%energy
!! conint%xGradMean
!! conint%xGradDiff
!!
!! SYNOPSIS
subroutine dlf_make_ln_gradient_pretrans
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob, stdout, printl
  use dlf_conint, only: conint
  implicit none
  integer  :: ivar

  if (printl >= 6) write(stdout, '(a)') &
       "Calculating base Lagrange-Newton gradients"

! There is no 'energy' associated with the Lagrange-Newton algorithm
  glob%energy = 0.0d0

! The unchanging part of the Lagrange-Newton gradient: (gi + gj) / 2
  conint%xGradMean = (glob%msgradient(:,:,1) + glob%msgradient(:,:,2)) &
       / 2.0d0

! Gradient difference vector (gij = gi - gj) in Cartesians
  conint%xGradDiff = glob%msgradient(:,:,1) - glob%msgradient(:,:,2)

  if (printl >= 6) then
     write(stdout, '(a,/,f20.10)') "LN energy:", glob%energy
     write(stdout, '(a)') "Mean of state gradients:"
     do ivar = 1, glob%nat
        write(stdout,'(3f20.10)') conint%xGradMean(:, ivar)
     end do
     write(stdout, '(a)') "Difference of state gradients:"
     do ivar = 1, glob%nat
        write(stdout,'(3f20.10)') conint%xGradDiff(:, ivar)
     end do
  end if

end subroutine dlf_make_ln_gradient_pretrans
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* conint/dlf_ln_xtoi
!!
!! FUNCTION
!!
!! Convert the base LN gradient (gi+gj)/2, the gradient difference,
!! and the interstate coupling gradient from Cartesians to internals.
!!
!! INPUTS
!!
!! glob%nvar
!! glob%nivar
!! glob%xcoords
!! conint%xGradMean
!! conint%xGradDiff
!! conint%mscoupling 
!!
!! OUTPUTS
!!
!! glob%icoords(1:glob%nivar - 2)
!! conint%iGradMean
!! conint%iGradDiff
!! conint%iCoupling
!!
!! SYNOPSIS
subroutine dlf_ln_xtoi
!! SOURCE
  use dlf_global, only: glob, stdout, printl
  use dlf_conint, only: conint
  implicit none
  integer :: ivar

  call dlf_direct_xtoi(glob%nvar, glob%nivar - 2, glob%nicore, glob%xcoords, &
       conint%xGradMean, glob%icoords(1:glob%nivar - 2), &
       conint%iGradMean)
  ! The following is a hack to transform the gradient
  ! difference vector and interstate coupling vector from cartesians
  ! to internals.
  ! Unfortunately coordinate and gradient transformation routines are 
  ! not separate, so we transform the same coordinates three times...
  call dlf_direct_xtoi(glob%nvar, glob%nivar - 2, glob%nicore, glob%xcoords, &
       conint%xGradDiff, glob%icoords(1:glob%nivar - 2), &
       conint%iGradDiff)
  call dlf_direct_xtoi(glob%nvar, glob%nivar - 2, glob%nicore, glob%xcoords, &
       glob%mscoupling, glob%icoords(1:glob%nivar - 2), &
       conint%iCoupling)

  if (printl >= 6) then
     write(stdout, '(a)') "Mean of state gradients in internals:"
     do ivar = 1, glob%nivar - 2
        write(stdout,'(f20.10)') conint%iGradMean(ivar)
     end do     
     write(stdout, '(a)') "Difference of state gradients in internals:"
     do ivar = 1, glob%nivar - 2
        write(stdout,'(f20.10)') conint%iGradDiff(ivar)
     end do     
     write(stdout, '(a)') "Interstate coupling gradient in internals:"
     do ivar = 1, glob%nivar - 2
        write(stdout,'(f20.10)') conint%iCoupling(ivar)
     end do     
  end if

end subroutine dlf_ln_xtoi
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* conint/dlf_make_ln_gradient_posttrans
!!
!! FUNCTION
!!
!! Build the full Lagrange-Newton gradient in internal coordinates.
!!
!! INPUTS
!!
!! glob%nivar
!! glob%msenergy
!! conint%extrap
!! conint%iGradDiff
!! conint%iGradDiffOld
!! conint%iCoupling
!! conint%iCouplingOld
!! conint%iGradMean
!! glob%icoords(glob%nivar-1:glob%nivar)
!!
!! OUTPUTS
!! 
!! conint%extrap
!! conint%iGradDiff
!! conint%iCoupling
!! glob%igradient
!!
!! SYNOPSIS
subroutine dlf_make_ln_gradient_posttrans
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob, stdout, printl
  use dlf_conint, only: conint 
  implicit none
  real(rk), external :: ddot
  real(rk) :: extrapThresholdOn 
  real(rk) :: extrapThresholdOff
  real(rk) :: deltaE
  real(rk) :: gDotG, hDotH, hDotG, tan4Theta
  real(rk) ::  twoTheta, cos2Theta, sin2Theta
  real(rk) :: o1(glob%nivar - 2), o2(glob%nivar - 2)
  real(rk) :: nrmO1, nrmO2, nrmGOld, nrmHOld
  real(rk) :: spO1GOld, spO2GOld, spO1HOld, spO2HOld
  real(rk) :: cO1GOld, cO2GOld, cO1HOld, cO2HOld
  logical :: transposed
  real(rk) :: cGGold, cHHold
  real(rk) :: signG, signH
  real(rk) :: orthoTest
  integer  :: ivar
  integer  :: lnnivar

  if (printl >= 6) write(stdout, '(a)') &
       "Calculating full Lagrange-Newton gradient"

  ! Number of coordinates (not including Lagrange multipliers)
  lnnivar = glob%nivar - 2

  ! Thresholds for switching the orthogonalisation procedure on/off
  ! Convert user-defined values from kcal/mol to Eh
  extrapThresholdOn = glob%ln_t1 / 627.511525d0
  extrapThresholdOff = glob%ln_t2 / 627.511525d0

  ! Energy difference between states
  deltaE = glob%msenergy(1) - glob%msenergy(2)

  ! Determine if the energy gap is small enough to switch on 
  ! extrapolatable functions
  if (.not. conint%extrap .and. abs(deltaE) < extrapThresholdOn) then
     conint%extrap = .true.
     if (printl >= 4) then
        write(stdout, '(a)') "Conical intersection seam found: &
          &using extrapolatable functions."
        write(stdout, '(a, f20.10)') "Energy gap between states:", &
             abs(deltaE)
        write(stdout, '(a, f20.10)') "Below threshold of:       ", &
             extrapThresholdOn
     end if
  end if
  ! Determine if the energy gap is too large to continue using
  ! extrapolatable functions
  if (conint%extrap .and. abs(deltaE) > extrapThresholdOff) then
     conint%extrap = .false.
     if (printl >= 4) then
        write(stdout, '(a)') "Conical intersection seam lost: &
             &extrapolatable functions off."
        write(stdout, '(a, f20.10)') "Energy gap between states:", &
             abs(deltaE)
        write(stdout, '(a, f20.10)') "Above threshold of:       ", &
             extrapThresholdOff
     end if
  end if

  ! Start of orthogonalisation routine
  if (conint%extrap) then

     if (printl >= 6) write(stdout, '(a)') &
          "Orthogonalising gradient difference and coupling vectors"

     ! Halve the gradient difference vector
     ! and the gradient difference vector from the previous iteration
     conint%iGradDiff = conint%iGradDiff / 2.0d0
     conint%iGradDiffOld = conint%iGradDiffOld / 2.0d0

     ! Calculate the orthogonalisation angle (Eq. 18)
     ! Note that g here is actually 1/2g
     ! and there is a minus sign missing from Eq. 18
     ! (and the same equation in the earlier Yarkony papers)
     gDotG = ddot(lnnivar, conint%iGradDiff, 1, conint%iGradDiff, 1)
     hDotH = ddot(lnnivar, conint%iCoupling, 1, conint%iCoupling, 1)
     hDotG = ddot(lnnivar, conint%iCoupling, 1, conint%iGradDiff, 1)
     tan4Theta = -(2.0d0 * hDotG) / (hDotH - gDotG)
     twoTheta = atan(tan4Theta) / 2.0d0
     cos2Theta = cos(twoTheta)
     sin2Theta = sin(twoTheta)

     ! Orthogonalise the vectors (Eq. 17)
     o1 = cos2Theta * conint%iGradDiff + sin2Theta * conint%iCoupling
     o2 = -sin2Theta * conint%iGradDiff + cos2Theta * conint%iCoupling

     ! Test for transpositions and sign changes by comparing angles
     nrmO1 = sqrt(ddot(lnnivar, o1, 1, o1, 1))
     nrmO2 = sqrt(ddot(lnnivar, o2, 1, o2, 1))
     nrmGOld = sqrt(ddot(lnnivar, conint%iGradDiffOld, 1, &
          conint%iGradDiffOld, 1))
     nrmHOld = sqrt(ddot(lnnivar, conint%iCouplingOld, 1, &
          conint%iCouplingOld, 1))

     spO1GOld = ddot(lnnivar, o1, 1, conint%iGradDiffOld, 1)
     spO2GOld = ddot(lnnivar, o2, 1, conint%iGradDiffOld, 1) 
     spO1HOld = ddot(lnnivar, o1, 1, conint%iCouplingOld, 1)
     spO2HOld = ddot(lnnivar, o2, 1, conint%iCouplingOld, 1)

     ! cos(angle)
     cO1GOld = spO1GOld / (nrmO1 * nrmGOld)
     cO2GOld = spO2GOld / (nrmO2 * nrmGOld)
     cO1HOld = spO1HOld / (nrmO1 * nrmHOld)
     cO2HOld = spO2HOld / (nrmO2 * nrmHOld)

     ! First, check for transpositions
     if (abs(cO2GOld) > abs(cO1GOld)) then
        ! Transposition detected
        transposed = .true.
        cGGOld = cO2GOld
        cHHOld = cO1HOld
     else
        ! No transposition detected
        transposed = .false.
        cGGOld = cO1GOld
        cHHOld = cO2HOld
     endif

     ! Now check for sign changes in the transposition-corrected
     ! vectors
     if (cGGOld < 0.0d0) then
        ! Sign change in the gradient difference vector
        signG = -1.0d0
     else
        ! No sign change in the gradient difference vector
        signG = 1.0d0
     endif
     if (cHHOld < 0.0d0) then
        ! Sign change in the interstate coupling gradient
        signH = -1.0d0
     else 
        ! No sign change in the interstate coupling gradient
        signH = 1.0d0
     endif
     
     ! Copy the orthogonalised, transposition-corrected, 
     ! sign change-corrected vectors back, overwriting the original
     ! vectors (which are no longer needed)
     if (.not. transposed) then
        conint%iGradDiff = signG * o1
        conint%iCoupling = signH * o2
     else
        conint%iGradDiff = signG * o2
        conint%iCoupling = signH * o1
     endif

     ! Double the gradient difference vector again
     conint%iGradDiff = conint%iGradDiff * 2.0d0
     conint%iGradDiffOld = conint%iGradDiffOld * 2.0d0

     orthoTest = ddot(lnnivar, conint%iGradDiff, 1, conint%iCoupling, 1)

     if (printl >= 6) then
        write(stdout, '(a)') "Orthogonalised gradient difference:"
        do ivar = 1, glob%nivar - 2
           write(stdout,'(f20.10)') conint%iGradDiff(ivar)
        end do
        write(stdout, '(a)') "Orthogonalised interstate coupling:"
        do ivar = 1, glob%nivar - 2
           write(stdout,'(f20.10)') conint%iCoupling(ivar)
        end do
        write(stdout, '(a, f20.10)') &
             "Check of orthogonality: dot product: ", orthoTest
     end if


  endif ! End of orthogonalisation routine

  ! Construct the gradient of the Lagrangian (Eq. 16)
  ! del(Lij) = (gi + gj)/2 + xi1.gij + xi2.hij  
  ! The first term is already calculated from make_ln_gradient_pretrans
  ! The Lagrange multipliers xi1 and xi2 are the last two array
  ! elements of glob%icoords.
  glob%igradient(1:lnnivar) = conint%iGradMean(1:lnnivar) + &
       glob%icoords(lnnivar + 1) * conint%iGradDiff(1:lnnivar) + &
       glob%icoords(lnnivar + 2) * conint%iCoupling(1:lnnivar)

  ! Calculate the final two gradients (corresponding to the 
  ! constraints).
  ! If orthogonalisation is not switched on, the final two gradients
  ! are exactly as in Eq. 13.
  ! If orthogonalisation is switched on, the orthogonalisation procedure
  ! should also be applied to the final two gradients:
  !  - Halve the first gradient (energy difference), like we halved g.
  !  - Apply the rotation matrix from Eq. 17, i.e.
  !
  !  |  cos(2th)  sin(2th) | | (1/2)dE |  =  |  (1/2).cos(2th).dE |
  !  | -sin(2th)  cos(2th) | |    0    |     | -(1/2).sin(2th).dE | 
  !
  !  - If g and h were transposed, or there were sign changes, apply the
  !    same corrections to these gradients.
  !  - Double the first gradient again.

  ! Note: this treatment of the residual energy is an improvement on 
  ! the treatment described in the MNDO implementation paper, in which 
  ! transpositions and sign changes were taken into account, but the 
  ! orthogonalisation matrix was not applied. In practice, the two 
  ! approaches rarely differ in terms of convergence cycles (as the 
  ! original treatment is usually a good approximation to the current
  ! treatment).
  !
  ! In principle, the threshold for switching on orthogonalisation is 
  ! no longer required with the new treatment, as the constraint 
  ! equations with orthogonalised g and h now hold at any point, not 
  ! just points on the seam.
  ! However, the only difference this would make in practice is to 
  ! include orthogonalised g and h information into the Hessian at all 
  ! times, and whether this is advantageous or not is a moot point.
  ! Advantages of removing thresholds:
  !  - The algorithm is considerably simplified.
  !  - No disruption on crossing the threshold (fixes the problem cases
  !    s-transoid butadiene and penta-3,5-dieniminium from the MNDO 
  !    implementation paper).
  !  - Use of the full Hessian may force the optimiser to find the seam
  !    more quickly.
  ! Disadvantages of removing thresholds:
  !  - Use of the full Hessian may force the optimiser to find the seam
  !    too quickly! (i.e. a high energy seam). This happens in the case
  !    of diazomethane, greatly increasing the number of iterations 
  !    required to find the true MECP.
  !  - In most cases, removing the threshold slightly increases the 
  !    number of iterations required to reach convergence. 
  ! The best solution may be to make the thresholds user-definable.
  if (.not. conint%extrap) then
     glob%igradient(lnnivar + 1) = deltaE
     glob%igradient(lnnivar + 2) = 0.0d0
  else if (transposed) then
     glob%igradient(lnnivar + 1) = -1.0d0 * sin2Theta * deltaE * signG
     glob%igradient(lnnivar + 2) = 0.5d0 * cos2Theta * deltaE * signH
  else
     glob%igradient(lnnivar + 1) = cos2Theta * deltaE * signG
     glob%igradient(lnnivar + 2) = -0.5d0 * sin2Theta * deltaE * signH
  endif

  if (printl >= 6) then
     write(stdout, '(a)') "LN gradient:"
     do ivar = 1, glob%nivar
        write(stdout,'(f20.10)') glob%igradient(ivar)
     end do
  end if

end subroutine dlf_make_ln_gradient_posttrans
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* conint/dlf_conint_make_ln_hess
!!
!! FUNCTION
!!
!! Make the Lagrange-Newton Hessian
!! Called from dlf_makehessian and analogous to it.
!!
!! In the Lagrange-Newton method the top left (nivar-2)*(nivar-2) 
!! Hessian is treated in a standard way. In order for this to work 
!! all the Hessian update routines called must be independent of glob.
!!
!! The rest of the Hessian contains constraint gradients corresponding
!! to the gradient difference and interstate coupling gradient vectors.
!!
!! INPUTS
!!
!! glob%nivar
!! conint%iGradMean
!! conint%iGradMeanOld
!! conint%extrap
!! conint%oldIsOrthog
!! glob%icoords
!! conint%iGradDiff
!! conint%iGradDiffOld
!! conint%iCoupling
!! conint%iCouplingOld
!!
!! OUTPUTS
!! 
!! glob%havehessian
!! glob%ihessian
!! tconv
!!
!! SYNOPSIS
subroutine dlf_conint_make_ln_hess(trerun_energy,tconv)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stdout,printl
  use dlf_stat, only: stat
  use dlf_conint, only: conint 
  use dlf_hessian, only: oldc,fd_hess_running
  implicit none
  logical, intent(inout) :: trerun_energy
  logical, intent(inout) :: tconv
  integer                :: status
  logical,save           :: fracrecalc ! behaves as in makehessian,
                                       ! possibly not relevant here
  integer                :: iimage ! not used here
  integer :: ivar
  integer :: lnnivar
  ! Gradients for Hessian update
  real(rk) :: updGradient(glob%nivar - 2)
  real(rk) :: updGradientOld(glob%nivar - 2)
  logical  :: was_updated
! **********************************************************************
  ! lnnivar is the dimension of the optimisation problem without the
  ! constraints. All Hessian construction, updating etc. should only
  ! apply to the lnnivar * lnnivar part of the Hessian
  lnnivar = glob%nivar - 2

  ! Gradients for Hessian update (not used for any other purpose)
  updGradient = conint%iGradMean
  updGradientOld = conint%iGradMeanOld
  if (conint%extrap .and. conint%oldIsOrthog) then
     ! If both the old and the new gradient difference/couplings
     ! have been orthogonalised, they are slowly varying and can be 
     ! included in the Hessian update.
     ! Note that the Lagrange multipliers of the current iteration are
     ! always used.
     updGradient = updGradient + &
          glob%icoords(lnnivar + 1) * conint%iGradDiff + &
          glob%icoords(lnnivar + 2) * conint%iCoupling
     updGradientOld = updGradientOld + &
          glob%icoords(lnnivar + 1) * conint%iGradDiffOld + &
          glob%icoords(lnnivar + 2) * conint%iCouplingOld
  endif
  call dlf_hessian_update(lnnivar, glob%icoords(1:lnnivar), & 
       oldc(1:lnnivar), updGradient, updGradientOld, &
       glob%ihessian(1:lnnivar, 1:lnnivar), glob%havehessian, &
       fracrecalc,was_updated)
  
  if(glob%havehessian) then
       ! Fill in the last two rows/columns of the hessian
       ! with gradient difference/coupling after a Hessian update
       glob%ihessian(1:lnnivar, lnnivar + 1) = &
            conint%iGradDiff(1:lnnivar)
       glob%ihessian(lnnivar + 1, 1:lnnivar) = &
            conint%iGradDiff(1:lnnivar)
       glob%ihessian(1:lnnivar, lnnivar + 2) = &
            conint%iCoupling(1:lnnivar)
       glob%ihessian(lnnivar + 2, 1:lnnivar) = &
            conint%iCoupling(1:lnnivar)
       ! The last 2 x 2 matrix of zeroes
       glob%ihessian(lnnivar + 1:lnnivar + 2, lnnivar + 1:lnnivar + 2) &
            = 0.0d0
       if (printl >= 6) then
          write(stdout, '(a)') "Hessian update gradient 1:"
          do ivar = 1, lnnivar
             write(stdout,'(f20.10)') updGradient(ivar)
          end do
          write(stdout, '(a)') "Hessian update gradient 2:"
          do ivar = 1, lnnivar
             write(stdout,'(f20.10)') updGradientOld(ivar)
          end do
          write(stdout, '(a)') "Lagrange-Newton Hessian:"
          do ivar = 1, glob%nivar
             write(stdout,'(12f10.5)') glob%ihessian(ivar,:)
          end do
       end if

  else
    ! We don't have a Hessian yet

    if(.not. fd_hess_running) then
      ! test for convergence before calculating the Hessian
      call convergence_test(stat%ccycle,.false.,tconv)
      if(tconv) return
      if (glob%inithessian == 4) then
         ! Initial Hessian is the identity matrix
         glob%ihessian = 0.0d0
         do ivar = 1, lnnivar
            glob%ihessian(ivar, ivar) = 1.0d0
         end do
         glob%havehessian = .true.
      end if
      if (glob%inithessian == 0) then
         call dlf_fail("External Hessian is incompatible with &
              &Lagrange-Newton")
      end if
    end if !(.not. fd_hess_running)

    if(.not.glob%havehessian) then
       ! For finite difference Hessians, it is not safe to use 
       ! extrapolatable functions (as the seam may be lost during 
       ! the finite difference procedure), so we call with iGradMean
       ! instead of updGradient
      if (glob%inithessian == 3) then
         ! Simple diagonal Hessian a la MNDO
         call dlf_diaghessian(lnnivar, glob%energy, &
              glob%icoords(1:lnnivar), conint%iGradMean, &
              glob%ihessian(1:lnnivar, 1:lnnivar), glob%havehessian)
      else
         ! Finite Difference Hessian calculation in internal coordinates
         call dlf_fdhessian(lnnivar, fracrecalc, glob%energy, &
              glob%icoords(1:lnnivar), conint%iGradMean, &
              glob%ihessian(1:lnnivar, 1:lnnivar), glob%havehessian)
      end if
      ! check if FD-Hessian calculation currently running
      trerun_energy=(fd_hess_running) 
      if(trerun_energy) then
        call clock_start("COORDS")
        call dlf_coords_itox(iimage)
        call clock_stop("COORDS")
      end if
    end if !(.not.glob%havehessian)

    if(glob%havehessian) then
       ! Fill in the last two rows/columns of the hessian
       ! with gradient difference/coupling
       glob%ihessian(1:lnnivar, lnnivar + 1) = &
            conint%iGradDiff(1:lnnivar)
       glob%ihessian(lnnivar + 1, 1:lnnivar) = &
            conint%iGradDiff(1:lnnivar)
       glob%ihessian(1:lnnivar, lnnivar + 2) = &
            conint%iCoupling(1:lnnivar)
       glob%ihessian(lnnivar + 2, 1:lnnivar) = &
            conint%iCoupling(1:lnnivar)
       ! The last 2 x 2 matrix of zeroes
       glob%ihessian(lnnivar + 1:lnnivar + 2, lnnivar + 1:lnnivar + 2) &
            = 0.0d0
       if (printl >= 6) then
          write(stdout, '(a)') "Lagrange-Newton Hessian:"
          do ivar = 1, glob%nivar
             write(stdout,'(12f10.5)') glob%ihessian(ivar,:)
          end do
       end if
    endif !(glob%havehessian)

  end if ! the first (glob%havehessian)

end subroutine dlf_conint_make_ln_hess
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* conint/dlf_ln_savegrads
!!
!! FUNCTION
!!
!! Save the Lagrange-Newton gradients for the next step
!! Called from dlf_formstep
!!
!! INPUTS
!!
!! conint%iGradMean
!! conint%iGradDiff
!! conint%iCoupling
!! conint%extrap
!!
!! OUTPUTS
!! 
!! conint%iGradMeanOld
!! conint%iGradDiffOld
!! conint%iCouplingOld
!! conint%oldIsOrthog
!!
!! SYNOPSIS
subroutine dlf_ln_savegrads
!! SOURCE
  use dlf_conint, only: conint 
  implicit none

  conint%iGradMeanOld = conint%iGradMean
  conint%iGradDiffOld = conint%iGradDiff
  conint%iCouplingOld = conint%iCoupling

  if (conint%extrap) then
     conint%oldIsOrthog = .true.
  else
     conint%oldIsOrthog = .false.
  endif

end subroutine dlf_ln_savegrads
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* conint/dlf_checkpoint_conint_write
!!
!! FUNCTION
!!
!! Write checkpoint file for the conint module (only necessary for the
!! Lagrange-Newton method).
!!
!! INPUTS
!!
!! conint%...
!!
!! OUPUTS
!!
!! file: dlf_conint.chk
!!
!! SYNOPSIS
subroutine dlf_checkpoint_conint_write
!! SOURCE
   use dlf_global, only: glob
   use dlf_conint, only: conint
   use dlf_checkpoint, only: tchkform, write_separator
   implicit none
  ! YL 15/12/2020: we need avoid using file units ifunit, 101, or 102 to make Cray compiler happy
  !                see pp 141: http://103.251.184.12/wp-content/uploads/2018/01/Cray_Fortran_Reference_Manual_S-3901_86.pdf
  !                The values of INPUT_UNIT, OUTPUT_UNIT, and ERROR_UNIT defined in the ISO_Fortran_env module are
  !                ifunit, 101, and 102, respectively. These three unit numbers are reserved and may not be used for other purposes.
  !                The files connected to these units are the same files used by the companion C processor for standard input
  !                (stdin), output (stdout), and error (stderr). An asterisk (*) specified as the unit for a READ statement specifies unit
  !                ifunit. An asterisk specified as the unit for a WRITE statement, and the unit for PRINT statements is unit 101. All
  !                positive default integer values are available for use as unit numbers.
  integer, parameter :: ifunit = 104

   select case (glob%imultistate)
   case (0)
      ! Not a multistate calculation
   case (1, 2)
      ! No checkpoint required
   case (3)
      if (tchkform) then
         open(unit=ifunit, file="dlf_conint.chk", form="formatted")
      else
         open(unit=ifunit, file="dlf_conint.chk", form="unformatted")
      end if
      call write_separator(ifunit, "LN data")
      if (tchkform) then
         write(ifunit,*) conint%xGradMean, conint%iGradMean, &
              conint%iGradMeanOld, conint%xGradDiff, &
              conint%iGradDiffOld, conint%iCoupling, &
              conint%iCouplingOld, conint%extrap, conint%oldIsOrthog
      else
         write(ifunit) conint%xGradMean, conint%iGradMean, &
              conint%iGradMeanOld, conint%xGradDiff, &
              conint%iGradDiffOld, conint%iCoupling, &
              conint%iCouplingOld, conint%extrap, conint%oldIsOrthog
      end if
      call write_separator(ifunit, "END LN data")
      close(ifunit)
   end select

end subroutine dlf_checkpoint_conint_write
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* conint/dlf_checkpoint_conint_read
!!
!! FUNCTION
!!
!! Read checkpoint file for the conint module (only necessary for the
!! Lagrange-Newton method).
!!
!! INPUTS
!!
!! file: dlf_conint.chk
!!
!! OUPUTS
!!
!! conint%...
!!
!! SYNOPSIS
subroutine dlf_checkpoint_conint_read(tok)
!! SOURCE
   use dlf_global, only: glob, stdout
   use dlf_conint, only: conint
   use dlf_checkpoint, only: tchkform, read_separator
   implicit none
   logical, intent(out) :: tok
   logical :: tchk
   integer, parameter :: ifunit = 104

   tok = .false.

   select case (glob%imultistate)
   case (0)
      ! Not a multistate calculation
      tok = .true.
   case (1, 2)
      ! No checkpoint required
      tok = .true.
   case (3)
      ! check if checkpoint file exists
      inquire(file="dlf_conint.chk", exist=tchk)
      if(.not.tchk) then
         write(stdout,10) "File dlf_conint.chk not found"
         return
      end if
      if (tchkform) then
         open(unit=ifunit, file="dlf_conint.chk", form="formatted")
      else
         open(unit=ifunit, file="dlf_conint.chk", form="unformatted")
      end if
      call read_separator(ifunit, "LN data", tchk)
      if (.not. tchk) return
      if (tchkform) then
         read(ifunit,*,end=201,err=200) conint%xGradMean, conint%iGradMean, &
              conint%iGradMeanOld, conint%xGradDiff, &
              conint%iGradDiffOld, conint%iCoupling, &
              conint%iCouplingOld, conint%extrap, conint%oldIsOrthog
      else
         read(ifunit,end=201,err=200) conint%xGradMean, conint%iGradMean, &
              conint%iGradMeanOld, conint%xGradDiff, &
              conint%iGradDiffOld, conint%iCoupling, &
              conint%iCouplingOld, conint%extrap, conint%oldIsOrthog
      end if
      call read_separator(ifunit, "END LN data", tchk)
      if (.not. tchk) return
      close(ifunit)
      tok = .true.
   end select
   return

   ! return on error
200 continue
   write(stdout,10) "Error reading conint checkpoint file"
   return
201 continue
   write(stdout,10) "Error (EOF) reading conint checkpoint file"
   return

10 format("Checkpoint reading WARNING: ",a)

end subroutine dlf_checkpoint_conint_read
!!****

!  Copyright (C) 2020 The authors of Py-ChemShell
!
!  This file is part of Py-ChemShell.
!
!  Py-ChemShell is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as
!  published by the Free Software Foundation, either version 3 of the
!  License, or (at your option) any later version.
!
!  Py-ChemShell is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with Py-ChemShell.  If not, see
!  <http://www.gnu.org/licenses/>.

module DLMONTEModule
public :: dl_monte, dl_monte_energy, dl_monte_gradients, dl_monte_global_indices
real(kind=8)             :: dl_monte_energy
real(kind=8)   , pointer :: dl_monte_gradients(:,:)
integer(kind=4), pointer :: dl_monte_global_indices(:)
contains
subroutine dl_monte(workgroup)
    integer, intent(in) :: workgroup
endsubroutine dl_monte
endmodule DLMONTEModule

!  Copyright (C) 2017 The authors of Py-ChemShell
!
!  This file is part of Py-ChemShell.
!
!  Py-ChemShell is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as
!  published by the Free Software Foundation, either version 3 of the
!  License, or (at your option) any later version.
!
!  Py-ChemShell is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with Py-ChemShell.  If not, see
!  <http://www.gnu.org/licenses/>.

module ChemShellGULPModule

    use, intrinsic :: iso_c_binding
    use DL_PY2F
    use ChemShellParallelModule, only : chemsh_parallel

    private

    public register_gulp, interface_gulp, gulp_wrap
    public PyFrag, PyShells, nshells

    type(dictType) , pointer :: PyFrag, PyShells
    integer                  :: nshells

    integer(c_int) :: c_debug
    integer(c_int) :: gulp_handle

    contains

      
    subroutine register_gulp(debug) bind(c, name="f_register_gulp")

        integer(c_int), intent(in) :: debug

        type(c_funptr) :: gulp_pointer

        c_debug = debug

        gulp_pointer = c_funloc(gulp_wrap)
        gulp_handle = chemsh_parallel%get_function_handle(gulp_pointer)

    endsubroutine register_gulp
    ! called by master process only
    integer(c_int) function interface_gulp(fragPtr) result(ierror) bind(c)
 
        implicit none
 
        type(PyType)  , intent(in) :: fragPtr
 
        type(PyType)  , pointer    :: shellsPtr

        ierror = 1
 
        ! set up dict of fragObj
        allocate(PyFrag, source=ptr2dict(fragPtr))
        call PyFrag%get('shells', shellsPtr)
 
        ! set up dict of shellsObj and save nshells
        allocate(PyShells, source=ptr2dict(shellsPtr))
        call PyShells%get('npts', nshells)
 
        if (chemsh_parallel%is_parallel()) then
            ierror = chemsh_parallel%exec_function(gulp_handle, c_debug)
        else
            ierror = gulp_wrap()
        endif
 
        call PyFrag%finalise()
        call PyShells%finalise()
        deallocate(PyFrag, PyShells)

    endfunction interface_gulp
    ! also called by replica processes
    integer(kind=4) function gulp_wrap() result(ierror)

        use ChemShellParallelModule, only : chemsh_parallel

        integer(kind=4) :: gulp_linked, communicator

        gulp_linked = 1

        communicator = chemsh_parallel%comm_subset

        ! YL 24/04/2020: can't catch ierror because GULP "stop"s when there's an error
        if(chemsh_parallel%is_subset()) then
            call gulpmain(ierror, gulp_linked, communicator)
        endif

    endfunction gulp_wrap

endmodule ChemShellGULPModule

!  Copyright (C) 2017 The authors of Py-ChemShell
!
!  This file is part of Py-ChemShell.
!
!  Py-ChemShell is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as
!  published by the Free Software Foundation, either version 3 of the
!  License, or (at your option) any later version.
!
!  Py-ChemShell is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with Py-ChemShell.  If not, see
!  <http://www.gnu.org/licenses/>.

module ChemShellCP2KModule

    use, intrinsic :: iso_c_binding
    use DL_PY2F
    use ChemShellParallelModule, only : chemsh_parallel

    private

    public register_cp2k, interface_cp2k, cp2k_wrap

!    type(dictType)  , pointer :: PyFrag, PyOptions
    type(dictType)    , pointer :: PyOptions

    integer(c_int)              :: c_debug
    integer(c_int)              :: cp2k_handle

    ! YL 06/03/2021: for gfortran-<9 theses pointers are not allowed to be
    !                initialised with => null()
    character(len=:)  , pointer :: ptr_input
    character(len=:)  , pointer :: ptr_output
    character(len=255)          :: cp2k_input, cp2k_output
    integer                     :: linput, loutput
    logical           , save    :: initialise = .true.

    contains

      
    subroutine register_cp2k(debug) bind(c, name="f_register_cp2k")

        integer(c_int), intent(in) :: debug

        type(c_funptr)             :: cp2k_pointer

        c_debug = debug

        cp2k_pointer = c_funloc(cp2k_wrap)
        cp2k_handle = chemsh_parallel%get_function_handle(cp2k_pointer)

    endsubroutine register_cp2k
    ! called by master process only
    integer(c_int) function interface_cp2k(fragPtr, optionsPtr) result(ierror) bind(c)
 
        implicit none
 
        type(PyType), intent(in) :: fragPtr
        type(PyType), intent(in) :: optionsPtr
 
        ierror = 1
 
        ! set up dict of Python objects
!        allocate(PyFrag   , source=ptr2dict(fragPtr))
        allocate(PyOptions, source=ptr2dict(optionsPtr))

        ! YL 01/03/2021: we only have one Python interpreter (master) within a workgroup so that
        !                these DL_PY2F operations are only done on the master; for using the values
        !                we still need to broadcast them to the replicas (see cp2k_wrap())
        cp2k_input  = repeat(' ', 255)
        cp2k_output = repeat(' ', 255)
        nullify(ptr_input, ptr_output)
        call PyOptions%get("input" , ptr_input)
        call PyOptions%get("output", ptr_output)
        ! the character pointers cannot be directed broadcast
        linput  = len(trim(ptr_input))
        loutput = len(trim(ptr_output))
        ! YL 03/03/2021: when compiled with ifort there are a lot of trailing symbles and
        !                we have to remove them cleanly; with gfortran we don't really need
        !                to do so
        cp2k_input (1:linput)  = ptr_input (1:linput)
        cp2k_output(1:loutput) = ptr_output(1:loutput)
 
        if (chemsh_parallel%is_parallel()) then
           call flush(6)
           ierror = chemsh_parallel%exec_function(cp2k_handle, c_debug)
        else
           ierror = cp2k_wrap()
        endif
 
        if(associated(PyOptions)) then
            call PyOptions%finalise()
            deallocate(PyOptions)
        endif

    endfunction interface_cp2k
    ! also called by replica processes
    integer function cp2k_wrap() result(ierror)

        use ChemShellParallelModule, only : chemsh_parallel

        implicit none

        integer(kind=4) :: communicator

        ierror = 1

        communicator = chemsh_parallel%comm_workgroup

        ! YL 01/03/2021: the replicas have known the character lengths yet
        ierror = chemsh_parallel%broadcast(linput , 1, 0)
        ierror = chemsh_parallel%broadcast(loutput, 1, 0)
        ! YL 01/03/2021: now we are ready to broadcast the filenames
        ierror = chemsh_parallel%broadcast(cp2k_input (1:linput ), linput , 0)
        ierror = chemsh_parallel%broadcast(cp2k_output(1:loutput), loutput, 0)
        call flush(6)
        call cp2k(cp2k_input(1:linput), cp2k_output(1:loutput), initialise, chemsh_parallel%is_root(), communicator)

        ! during a geometry optimisation or MD simulation we only initialise CP2K once
        initialise = .false.

        ierror = 0

    endfunction cp2k_wrap

endmodule ChemShellCP2KModule

!  Copyright (C) 2017 The authors of Py-ChemShell
!
!  This file is part of Py-ChemShell.
!
!  Py-ChemShell is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as
!  published by the Free Software Foundation, either version 3 of the
!  License, or (at your option) any later version.
!
!  Py-ChemShell is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with Py-ChemShell.  If not, see
!  <http://www.gnu.org/licenses/>.


! you.lu@stfc.ac.uk
! YL: rewritten 2021 according to NWChem 7.0.2

module ChemShellNWChemModule

    use iso_c_binding
    use DL_PY2F

    implicit none

    private

    public :: interface_nwchem, register_nwchem
    public :: chemsh_nwchem_input, chemsh_nwchem_output
    public :: fragmovecs, NWChemObj

    integer(c_int) :: c_debug

    type NWChemType
        private
        integer                   :: debug
        integer                   :: dft
        integer                   :: rtdb
        integer                   :: natoms
        integer                   :: nbqs
        integer                   :: necps
        integer                   :: nstates
        character(len=:), pointer :: name
        real(kind=8), allocatable, public :: excitation_energies(:)
        real(kind=8), allocatable, public :: excitation_oscillator_s(:)
        real(kind=8), allocatable, public :: excitation_wavelengths(:)
        character(len=1), allocatable, public :: excitation_symmetries(:)
        character(len=1), allocatable, public :: excitation_spins(:)
        contains
            procedure, public  :: run => private_run
            procedure, private :: private_run
    endtype NWChemType

    type(NWChemType)          :: NWChemObj
    type(dictType)  , pointer :: PyTheory, PyFrag, PyBQs, PyResult, PyECPs
    integer(c_int)            :: nwchem_handle
    integer                   :: nwchem_task

    logical                   :: fragmovecs
    logical                   :: calc_grads

    character(len=:), pointer :: chemsh_nwchem_input, chemsh_nwchem_output

    contains

    subroutine register_nwchem(debug) bind(c, name='f_register_nwchem')

        use ChemShellParallelModule, only : chemsh_parallel

        implicit none

        integer(c_int), intent(in) :: debug

        type(c_funptr) :: nwchem_pointer

        c_debug = debug

        nwchem_pointer = c_funloc(wrap_nwchem)
        nwchem_handle  = chemsh_parallel%get_function_handle(nwchem_pointer)

    endsubroutine register_nwchem
    integer(c_int) function interface_nwchem(theoryPtr, resultPtr, calcGradients, debug) result(ierror) bind(c)

        implicit none

        type(PyType)              , intent(in) :: theoryPtr
        type(PyType)              , intent(in) :: resultPtr
        logical(c_bool)           , intent(in) :: calcGradients
        integer(c_int)            , intent(in) :: debug

        type(PyType)    , pointer              :: fragPtr, bqsPtr, ecpsPtr
        integer                                :: natoms, nbqs, necps, nstates
        integer                                :: code
        integer         , external             :: nodeid
        character(len=:), pointer              :: method
        character(len=8), pointer              :: names(:)

        character(len=:), pointer              :: cbuff
        logical(c_bool)                        :: clbuff

        ierror = 1

        ! YL 06/08/2019: sometimes we need to switch it off e.g. if numerical
        !                gradients are required in Py-ChemShell
        calc_grads = calcGradients

        ! initialise dict of theory object
        allocate(PyTheory, source=ptr2dict(theoryPtr))
        
        ! initialise dict of resultObj
        allocate(PyResult, source=ptr2dict(resultPtr))

        ! set up dict of fragObj
        call PyTheory%get('frag' , fragPtr)
        call PyTheory%get('necps', necps)
        call PyTheory%get('nstates', nstates)
        if(necps.gt.0) then
            call PyTheory%get('ecps', ecpsPtr)
            allocate(PyECPs, source=ptr2dict(ecpsPtr))
        endif
        allocate(PyFrag, source=ptr2dict(fragPtr))

        ! number of atoms
        ! YL: changed meaning of natoms and nbqs to stay consistent with PCS definitions:
        ! natoms does NOT contain nbqs; and in PCS QM nbqs already contains nshells
        call PyFrag%get('npts'   , natoms)
        call PyFrag%get('nbqs'   , nbqs)

        ! N.B.: natoms include separate ECPs in NWChem
        NWChemObj%natoms  = natoms + necps
        NWChemObj%nbqs    = nbqs
        NWChemObj%necps   = necps
        NWChemObj%nstates = nstates
        NWChemObj%debug   = debug
        allocate(NWChemObj%excitation_energies(nstates))
        allocate(NWChemObj%excitation_oscillator_s(nstates))
        allocate(NWChemObj%excitation_wavelengths(nstates))
        allocate(NWChemObj%excitation_symmetries(nstates))
        allocate(NWChemObj%excitation_spins(nstates))

        call PyFrag%get('bqs', bqsPtr)
        allocate(PyBQs, source=ptr2dict(bqsPtr))

        ! input/output filenames
        ! YL NOTE: the filenames are unavailable for the slave nodes
        call PyTheory%get('input' , chemsh_nwchem_input)
        call PyTheory%get('output', chemsh_nwchem_output)

        ! fragment molecular orbitals
        call PyTheory%get('fragmovecs', cbuff)
        ! not string value given to key "fragmovecs"
        if(len_trim(cbuff).eq.255) then
            call PyTheory%get('fragmovecs', clbuff)
            fragmovecs = clbuff
        ! a string value, e.g. "atoms"
        else
            fragmovecs = .true.
        endif

! YL: bytes array are still unavailable in py2f
!        allocate(names(natoms))
!        call PyFrag%get('names', names)

        call PyTheory%get('method', method)

        ierror = NWChemObj%run()

        deallocate(PyTheory, PyResult, PyFrag, PyBQs)
        ! YL 26/07/2021: on some systems, e.g., ARCHER2, it crashes randomly if PyECPs isn't deallocated
        if(necps.gt.0) then
            deallocate(PyECPs)
        endif

    endfunction interface_nwchem
    integer function private_run(this) result(ierror)

        use ChemShellParallelModule, only : chemsh_parallel

        implicit none

        class(NWChemType), intent(inout) :: this

        if (chemsh_parallel%is_parallel()) then
            ierror = chemsh_parallel%exec_function(nwchem_handle, c_debug)
        else
            ierror = wrap_nwchem()
        endif

    endfunction private_run
    ! also called by replica processes
    integer function wrap_nwchem() result(ierror)! bind(c)

        use ChemShellParallelModule, only : chemsh_parallel

        implicit none

        real(kind=8)            :: energy
        real(kind=8), pointer   :: coords(:,:)     => null()
        real(kind=8), pointer   :: charges(:)      => null()
        real(kind=8), pointer   :: bq_coords(:,:)  => null()
        real(kind=8), pointer   :: bq_charges(:)   => null()
        real(kind=8), pointer   :: bq_grads(:,:)  => null()
!        real(kind=8), pointer   :: ecp_coords(:,:) => null()
!        real(kind=8), pointer   :: ecp_charges(:)  => null()
        real(kind=8), pointer   :: gradients(:,:)  => null()
        integer                 :: rtdb, i, j
        integer                 :: natoms, nbqs, necps, nstates, debug
        integer                 :: ncoords, ncharges
        integer     , external  :: chemshell_nwchem

        ! size of integer
        integer     , parameter :: nbytes = 8
        real(kind=8), allocatable :: dummies(:)

        ierror = 1

        if(chemsh_parallel%is_root()) then
            rtdb    = NWChemObj%rtdb
            ! N.B.: natoms includes separate ECPs in NWChem
            natoms  = NWChemObj%natoms
            nbqs    = NWChemObj%nbqs
            necps   = NWChemObj%necps
            nstates = NWChemObj%nstates
            debug   = NWChemObj%debug
        endif

        ! broadcast the code and rtdb label
        ! NB: in ChemShell we only pass in number of *bytes* rather than number of data
        ierror = chemsh_parallel%broadcast(natoms, nbytes, 0)
        ierror = chemsh_parallel%broadcast(nbqs  , nbytes, 0)
        ierror = chemsh_parallel%broadcast(debug , nbytes, 0)
        ! YL 09/03/2021: not every compiler initialise integers as 0 so we must broadcast necps, too
        ierror = chemsh_parallel%broadcast(necps , nbytes, 0)
        call flush(6)

        ! initialise
        ! set geometry
        ! N.B.: natoms includes separate ECPs in NWChem
        allocate(coords(3, natoms))
        allocate(charges(natoms))
        allocate(bq_coords(3, nbqs))
        allocate(bq_charges(nbqs))
!        allocate(ecp_coords(3, necps))
!        allocate(ecp_charges(necps))

        ncoords = nbytes*natoms*3

        ! broadcast coords, bq_coords, charges, and bq_charges
        if(chemsh_parallel%is_root()) then
            call PyFrag%get('xyz'    , coords(:,1:natoms-necps))
            call PyFrag%get('charges', charges(1:natoms-necps))
            call PyBQs%get('npts', nbqs)
            if(nbqs.gt.0) then
                call PyBQs%get('xyz'    , bq_coords)
                call PyBQs%get('charges', bq_charges)
            endif
            if(necps.gt.0) then
                call PyECPs%get('xyz'    , coords(:,natoms-necps+1:natoms))
                call PyECPs%get('charges', charges(natoms-necps+1:natoms))
            endif
        endif
        ierror = chemsh_parallel%broadcast(coords , nbytes*natoms*3, 0)
        ierror = chemsh_parallel%broadcast(charges, nbytes*natoms  , 0)
        call flush(6)
        if(nbqs.gt.0) then
            ierror = chemsh_parallel%broadcast(bq_coords , nbytes*nbqs*3  , 0)
            ierror = chemsh_parallel%broadcast(bq_charges, nbytes*nbqs    , 0)
        endif

        ! gradients and BQ gradients
        allocate(gradients(3, natoms))
        allocate(bq_grads(3, nbqs))

        ierror = chemshell_nwchem(natoms,     &
                                  nbqs,       &
                                  coords,     &
                                  charges,    &
                                  bq_coords,  &
                                  bq_charges, &
                                  bq_grads,   &
                                  energy,     &
                                  gradients,  &
                                  rtdb,       &
                                  debug)

        ! NWChem returned OK
        if(ierror.ne.0) then
            print *, ">>> NWChem has failed: error code =", ierror
            call flush(6)
        endif

        ierror = chemsh_parallel%broadcast(rtdb, nbytes, 0)
        NWChemObj%rtdb = rtdb
        ! unset geometry
        deallocate(coords, charges, bq_coords, bq_charges)
        if(chemsh_parallel%is_root()) then
            ! energy
            ! YL 01/08/2021: cast to a precision of 1D-12 to minimise numerical errors which lead
            !                to unstable geometry optimisations (for gfortran, e.g., on ARCHER2)
            energy = anint(energy*(10.d0**12), 8)/(10.d0**12)
            call PyResult%set('energy', (/ energy /))
            ! gradients
            if(calc_grads) then
                ! YL 01/08/2021: cast to a precision of 1D-12 to minimise numerical errors which lead
                !                to unstable geometry optimisations (for gfortran, e.g., on ARCHER2)
                gradients = anint(gradients*(10.d0**12), 8)/(10.d0**12)
                ! YL 26/07/2021: on some systems it is safer than call PyResult%set('gradients', gradients)
                call PyResult%set('gradients', gradients(1:3,1:natoms-necps))
            endif
            ! BQ gradients
            if(nbqs.gt.0) then
                ! YL 01/08/2021: cast to a precision of 1D-12 to minimise numerical errors which lead
                !                to unstable geometry optimisations (for gfortran, e.g., on ARCHER2)
                bq_grads = anint(bq_grads*(10.d0**12), 8)/(10.d0**12)
                call PyBQs%set('gradients', bq_grads)
            endif
            if(necps.gt.0) then
!                do i = 1, 3
!                    do j = natoms-necps+1, natoms
!                        gradients(i,j) = anint(gradients(i,j)*(10.d0**12), 8)/(10.d0**12)
!                    enddo
!                enddo
                call PyECPs%set('gradients', gradients(1:3,natoms-necps+1:natoms))
            endif
            if(nstates.gt.0) then
                allocate(dummies(nstates))
                dummies = 0.0
                ! YL 16/12/2023: we use some dummy data to align with the Python result datatype
                call PyResult%set('excitations', transpose(reshape((/ NWChemObj%excitation_energies    , &
                                                                      NWChemObj%excitation_oscillator_s, &
                                                                      NWChemObj%excitation_wavelengths , &
                                                                      dummies, dummies /),               &
                                                                   (/nstates,5/))))
                deallocate(dummies)
            endif
        endif
        deallocate(gradients, bq_grads)
        if(allocated(NWChemObj%excitation_energies)) then
            deallocate(NWChemObj%excitation_energies)
        endif
        if(allocated(NWChemObj%excitation_oscillator_s)) then
            deallocate(NWChemObj%excitation_oscillator_s)
        endif
        if(allocated(NWChemObj%excitation_wavelengths)) then
            deallocate(NWChemObj%excitation_wavelengths)
        endif
        if(allocated(NWChemObj%excitation_symmetries)) then
            deallocate(NWChemObj%excitation_symmetries)
        endif
        if(allocated(NWChemObj%excitation_spins)) then
            deallocate(NWChemObj%excitation_spins)
        endif
!        deallocate(ecp_coords, ecp_charges)

    endfunction wrap_nwchem

endmodule ChemShellNWChemModule

!! COPYRIGHT
!!
!!  Copyright 2007 Johannes Kaestner (kaestner@theochem.uni-stuttgart.de),
!!  Tom Keal (thomas.keal@stfc.ac.uk), Alex Turner, Salomon Billeter,
!!  Stephan Thiel, Max-Planck Institut fuer Kohlenforshung, Muelheim, 
!!  Germany.
!!
!!  This file is part of DL-FIND.
!!
!!  DL-FIND is free software: you can redistribute it and/or modify
!!  it under the terms of the GNU Lesser General Public License as 
!!  published by the Free Software Foundation, either version 3 of the 
!!  License, or (at your option) any later version.
!!
!!  DL-FIND is distributed in the hope that it will be useful,
!!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!!  GNU Lesser General Public License for more details.
!!
!!  You should have received a copy of the GNU Lesser General Public 
!!  License along with DL-FIND.  If not, see 
!!  <http://www.gnu.org/licenses/>.
!!
MODULE dlfhdlc_matrixlib
!  USE global
  use dlf_parameter_module, only: rk
  use dlf_global, only: printl,stdout
  use dlf_allocate, only: allocate, deallocate
  IMPLICIT NONE

!------------------------------------------------------------------------------
! Constituents of a matrix object:
!   nv:    number of elements
!   np(1): number of rows
!   np(2): number of columns
!   tag:   name
!   data(np(1),np(2)): data
!------------------------------------------------------------------------------

  TYPE matrix
    INTEGER nv
    INTEGER np(2)
    CHARACTER (len=20) :: tag
    REAL (rk), allocatable :: data(:,:)
  END TYPE matrix

  TYPE int_matrix
    INTEGER np(2)
    CHARACTER (len=20) :: tag
    INTEGER, allocatable :: data(:,:)
  END TYPE int_matrix

CONTAINS

!------------------------------------------------------------------------------
! Basic matrix algebra
!------------------------------------------------------------------------------

!******************************************************************************

  INTEGER FUNCTION matrix_add(c,a,b)
    IMPLICIT NONE

! args
    TYPE (matrix) :: a, b
    TYPE (matrix) :: c

! begin
    ! use this line if compiled with bounds check (JK)
    c%data=reshape(a%data,shape(c%data))+reshape(b%data,shape(c%data))
    ! otherwhise use this
!    c%data=a%data + b%data
    matrix_add = 0
  END FUNCTION matrix_add

!******************************************************************************

  INTEGER FUNCTION matrix_transpose(a)
    IMPLICIT NONE

! args
    TYPE (matrix) :: a

! local vars
    INTEGER i, idum, j, n
    REAL (rk) scr
    TYPE (matrix) :: b

! begin, row or column vector - comment out for bounds check!
    IF ((a%np(1)==1) .OR. (a%np(2)==1)) THEN
      idum = a%np(1)
      a%np(1) = a%np(2)
      a%np(2) = idum

! square matrix
    ELSE IF (a%np(1)==a%np(2)) THEN
      n = a%np(1)
      DO i = 1, n
        DO j = i + 1, n
          scr = a%data(j,i)
          a%data(j,i) = a%data(i,j)
          a%data(i,j) = scr
        END DO
      END DO

! generic case
    ELSE
      idum=matrix_copy(a,b)
      idum=matrix_destroy(a)
      a=matrix_create(b%np(2),b%np(1),b%tag)
      DO i = 1, a%np(1)
        DO j = 1, a%np(2)
          a%data(i,j) = b%data(j,i)
        END DO
      END DO
      idum = matrix_destroy(b)
    END IF
    matrix_transpose = 0
  END FUNCTION matrix_transpose

!******************************************************************************

  INTEGER FUNCTION matrix_multiply(alpha,a,b,beta,c)
    IMPLICIT NONE

! args
    TYPE (matrix) :: a, b
    TYPE (matrix) :: c
    REAL (rk) alpha, beta

! local vars
    INTEGER nlink

! begin
    nlink = a%np(2)

    IF (nlink/=b%np(1)) THEN
      WRITE (stdout,'(a,i4,i4)') 'Mismatch dimensions - nlink', a%np(2), &
        b%np(1)
      CALL hdlc_errflag('Matrix error','abort')
    END IF

    IF (a%np(1)/=c%np(1)) THEN
      WRITE (stdout,'(a,i4,i4)') 'Mismatch dimensions - nrow(a) nrow(c)', &
        a%np(1), c%np(1)
      CALL hdlc_errflag('Matrix error','abort')
    END IF

    IF (b%np(2)/=c%np(2)) THEN
      WRITE (stdout,'(a,i4,i4)') 'Mismatch dimensions - ncol(b) ncol(c)', &
        b%np(2), c%np(2)
      CALL hdlc_errflag('Matrix error','abort')
    END IF
    CALL dgemm('N','N',c%np(1),c%np(2),nlink,alpha,a%data,a%np(1),b%data, &
      b%np(1),beta,c%data,c%np(1))

    matrix_multiply = 0
  END FUNCTION matrix_multiply

!******************************************************************************

!//////////////////////////////////////////////////////////////////////////////
! Matrix diagonalisation
!
! Object oriented approach: the dimensions of the passed arrays determine the
! behaviour of the routine:
!
! n     = order of the problem (dimensions of a)
! nval  = number of eigenvalues required (leading dimension of evalues)
! nvect = number of eigenvectors required (trailing dimension of evect)
! 
! Condition: n >= nval >= nvect
! If nvect or nval are less than the order of a, the lowest or the highest
! eigenvalues are taken if increasing or decreasing, respectively
!//////////////////////////////////////////////////////////////////////////////

  INTEGER FUNCTION matrix_diagonalise(a,evect,evalues,increasing)
    IMPLICIT NONE

! args
    LOGICAL increasing
    TYPE (matrix) :: a, evect, evalues

! local vars
    INTEGER n, nval, nvect

! begin, derive sizes from the matrix objects and bomb if inconsistent
    n = a%np(1)
    IF (a%np(2)/=n) THEN
      WRITE (stdout,'(a)') 'Matrix not square in matrix_diagonalise'
      WRITE (stdout,'(a,a)') 'Name of the matrix: ', a%tag
      matrix_diagonalise = -1
      RETURN
    END IF
    nval = evalues%np(1)
    IF (nval>n) THEN
      WRITE (stdout,'(a)') &
        'More eigenvalues requested than the order of the matrix'
      WRITE (stdout,'(a,a,a)') 'Names of the matrices: ', a%tag, evalues%tag
      matrix_diagonalise = -1
      RETURN
    END IF
    nvect = evect%np(2)
    IF (nvect>nval) THEN
      WRITE (stdout,'(a)') 'More eigenvectors requested than eigenvalues'
      WRITE (stdout,'(a,a,a,a)') 'Names of the matrices: ', a%tag, &
        evalues%tag, evect%tag
      matrix_diagonalise = -1
      RETURN
    END IF

! the dirty work is done in array_diagonalise
    matrix_diagonalise = array_diagonalise(a%data,evect%data,evalues%data,n, &
      nval,nvect,increasing)
    RETURN
  END FUNCTION matrix_diagonalise

!******************************************************************************

! array_diagonalise provides a non-object-oriented entry

  INTEGER FUNCTION array_diagonalise(a,evect,evalues,n,nval,nvect,increasing)
    IMPLICIT NONE

! args
    LOGICAL increasing
    INTEGER n, nval, nvect
    REAL (rk), DIMENSION (n,n) :: a
    REAL (rk), DIMENSION (nval) :: evalues
    REAL (rk), DIMENSION (n,nvect) :: evect

! externals
    INTEGER, EXTERNAL :: ilaenv
    REAL (rk), EXTERNAL :: dlamch

! local vars
    CHARACTER jobz
    INTEGER i, ierr, il, iu, lwork, nfound
    INTEGER :: nb, nb1, nb2
    INTEGER, DIMENSION (:), ALLOCATABLE :: ifail, iwork
    REAL (rk) :: abstol, dummy, vwork(nval)
    REAL (rk), DIMENSION (:), ALLOCATABLE :: evalwork, work
    REAL (rk), DIMENSION (:,:), ALLOCATABLE :: awork, evecwork

! begin

! copy the matrix to a work array as it would be destroyed otherwise
    call allocate (awork,n,n)
    awork = a

! full diagonalisation is required
    IF (nval==n) THEN
!       lwork = 3*n ! this is rather a minimum: unblocked algorithm
      nb = ilaenv(1,'dsytrd','L',n,-1,-1,-1)
      IF (nb<0 .AND. printl>=2) THEN
        WRITE (stdout,'(A,I5)') &
          'Matrix diagonaliser: ILAENV for dsytrd failed: returned ', nb
      END IF
      lwork = n*(nb+2)
      call allocate (work,lwork)

      IF (nvect==0) THEN
        jobz = 'N'
      ELSE
        jobz = 'V'
      END IF

! diagonaliser DSYEV and error check
      CALL dsyev(jobz,'L',n,awork,n,evalues,work,lwork,ierr)
      IF (ierr/=0 .AND. printl>=2) THEN
        WRITE (stdout,'(A,I5)') 'Matrix diagonaliser DSYEV failed: returned ', &
          ierr
      END IF

! clean up
      call deallocate (work)
!        if (increasing) then
!           do i = 1,nvect
!              do j = 1,n
!                 evect(j,i) = awork(j,i)
!              end do
!           end do
!        else
!           do i = 1,nvect
!              do j = 1,n
!                 evect(j,i) = awork(j,n-i+1)
!              end do
!           end do
!           k = n
!           do i = 1,n/2
!              vwork = evalues(i)
!              evalues(i) = evalues(k)
!              evalues(k) = vwork
!              k = k - 1
!           end do
!        end if

      IF (increasing) THEN
        evect = awork(:,1:nvect)
      ELSE
        evect = awork(:,n:n-nvect+1:-1)
        vwork = evalues
        evalues = vwork(nval:1:-1)
      END IF


! partial diagonalisation is required
    ELSE
!       lwork = 8*n ! this is rather a minimum: unblocked algorithm
      nb1 = ilaenv(1,'dsytrd','L',n,-1,-1,-1)
      IF (nb1<0 .AND. printl>=2) THEN
        WRITE (stdout,'(A,I5)') &
          'Matrix diagonaliser: ILAENV for dsytrd failed: returned ', nb1
      END IF

      nb2 = ilaenv(1,'dormtr','LLN',n,n,-1,-1)
      IF (nb2<0 .AND. printl>=2) THEN
        WRITE (stdout,'(A,I5)') &
          'Matrix diagonaliser: ILAENV for dormtr failed: returned ', nb2
      END IF

      nb = max(nb1,nb2)
      lwork = n*(nb+3)

      abstol = 2.0D0*dlamch('S') ! this is for maximum accuracy
      call allocate (work,lwork)
      call allocate (iwork,5*n)
      call allocate (evalwork,n)
      call allocate (evecwork,n,nval) ! note that this may be larger than nvect
      call allocate (ifail,n)
      IF (nvect==0) THEN
        jobz = 'N'
      ELSE
        jobz = 'V'
      END IF
      IF (increasing) THEN
        il = 1
        iu = nval
      ELSE
        il = n - nval + 1
        iu = n
      END IF

! diagonaliser DSYEVX and error check
      CALL dsyevx(jobz,'I','L',n,awork,n,dummy,dummy,il,iu,abstol,nfound, &
        evalwork,evecwork,n,work,lwork,iwork,ifail,ierr)
      IF (ierr/=0 .AND. printl>=2) THEN
        WRITE (stdout,'(A,I5)') 'Matrix diagonaliser DSYEVX failed: returned ' &
          , ierr
        IF (printl>=5) THEN
          WRITE (stdout,'(A)') 'Detailed error message (IFAIL):'
          WRITE (stdout,'(16I5)') (ifail(i),i=1,n)
        END IF
      END IF

! clean up
      call deallocate (iwork)
      call deallocate (work)
!        if (increasing) then
!           do i = 1,nvect
!              do j = 1,n
!                 evect(j,i) = evecwork(j,i)
!              end do
!           end do
!           do i = 1,nval
!              evalues(i) = evalwork(i)
!           end do
!        else
!           do i = 1,nvect
!              do j = 1,n
!                 evect(j,i) = evecwork(j,nval-i+1)
!              end do
!           end do
!           do i = 1,nval
!              evalues(i) = evalwork(nval-i+1)
!           end do
!        end if

      IF (increasing) THEN
        evect = evecwork(:,1:nvect)
        evalues = evalwork(1:nval)
      ELSE
        evect = evecwork(:,nval:nval-nvect+1:-1)
        evalues = evalwork(nval:1:-1)
      END IF

      call deallocate (ifail)
      call deallocate (evecwork)
      call deallocate (evalwork)
    END IF

! clear working space
    call deallocate (awork)
    array_diagonalise = ierr
    RETURN
  END FUNCTION array_diagonalise

!******************************************************************************

!//////////////////////////////////////////////////////////////////////////////
! Matrix inversion
!
! Object oriented entry: matrix_invert (a, det, lcdet)
! Array entry:           array_invert  (a, det, lcdet, n)
!
! Leading dimension assumed equal the order of the matrix to be inverted
! Calculate the determinant of lcdet is set
!//////////////////////////////////////////////////////////////////////////////

  INTEGER FUNCTION matrix_invert(a,det,lcdet)
    IMPLICIT NONE

! args
    LOGICAL lcdet
    REAL (rk) det
    TYPE (matrix) :: a

! local vars
    INTEGER n

! begin
    n = a%np(1)
    IF (a%np(2)/=n) THEN
      CALL hdlc_errflag('Matrix not square in invert','abort')
      matrix_invert = -1
      RETURN
    ELSE
      matrix_invert = array_invert(a%data,det,lcdet,n)
    END IF
  END FUNCTION matrix_invert

!******************************************************************************

  INTEGER FUNCTION array_invert(a,det,lcdet,n)
    IMPLICIT NONE

! args
    LOGICAL lcdet
    INTEGER n
    REAL (rk) det
    REAL (rk), DIMENSION (n,n) :: a

! local vars
    INTEGER info, job, r
    REAL (rk), DIMENSION (2) :: dd
    INTEGER, DIMENSION (:), ALLOCATABLE :: ipvt
    REAL (rk), DIMENSION (:), ALLOCATABLE :: work

! begin
    r = n
    IF (lcdet) THEN
      job = 11
    ELSE
      job = 01
    END IF

! allocate memory
    call allocate (ipvt,n)

! get factors, replaces LINPACK: call dgefa (a, r, n, ipvt, info)
    CALL dgetrf(n,n,a,r,ipvt,info)

! test for singularity
    IF (info/=0) THEN
      WRITE (stdout,'(a)') &
        'Warning: attempt to invert a (probably) singular matrix'
      IF (printl>=5) WRITE (stdout,'(A,I5)') 'Info from DGETRF is: ', &
        info
      WRITE (stdout,'(a)') &
        'Matrix is left unchanged and determinant is set to zero'
      IF (lcdet) THEN
        dd(1) = 0.0D0
        dd(2) = 0.0D0
        det = dd(1)*10.0D0**dd(2)
      END IF
      array_invert = info
      call deallocate (ipvt)
      RETURN
    END IF

! determinant, replaces LINPACK: call dgedi (a, r, n, ipvt, dd, work, job)
    IF (lcdet) CALL dgedet(a,r,n,ipvt,dd,job)

    call allocate (work,64*n)
    CALL dgetri(n,a,r,ipvt,work,64*n,info)

    IF (info/=0 .AND. printl>=5) THEN
      WRITE (stdout,'(A,I5)') 'Warning from matrix inverter: DGETRI returned ' &
        , info
    END IF

! deallocate work space
    call deallocate (work)
    call deallocate (ipvt)

! recompute determinant
    IF (lcdet) det = dd(1)*10.0D0**dd(2)
    array_invert = info
  END FUNCTION array_invert

!******************************************************************************

  INTEGER FUNCTION matrix_scale(a,fact)
    IMPLICIT NONE

! args
    TYPE (matrix) :: a
    REAL (rk) fact

! begin
    a%data = fact*a%data
    matrix_scale = 0

  END FUNCTION matrix_scale

!******************************************************************************

  FUNCTION matrix_absmax(a)
    IMPLICIT NONE
    REAL (rk) matrix_absmax

! args
    TYPE (matrix) :: a

! local vars
    INTEGER i, j
    REAL (rk) t

! begin
    t = 0.0D0
    DO j = 1, a%np(2)
      DO i = 1, a%np(1)
        t = max(t,abs(a%data(i,j)))
      END DO
    END DO
    matrix_absmax = t

  END FUNCTION matrix_absmax

!******************************************************************************

  FUNCTION matrix_length(a)
    IMPLICIT NONE
    REAL (rk) matrix_length

! args
    TYPE (matrix) :: a

! local vars
    INTEGER i, j
    REAL (rk) element, sum

! begin
    sum = 0.0D0
    DO j = 1, a%np(2)
      DO i = 1, a%np(1)
        element = a%data(i,j)
        sum = sum + element*element
      END DO
    END DO
!   fac = 1.0D0 / (a%np(1)*a%np(2))
    matrix_length = sqrt(sum)

  END FUNCTION matrix_length

!------------------------------------------------------------------------------
! Supplements to library functions
!------------------------------------------------------------------------------

!//////////////////////////////////////////////////////////////////////////////
! calculate the determinant of a matrix using the factors computed by DGETRF
!
! this subroutine is cut out from LINPACK: SUBROUTINE DGEDI
!
! on entry:
!   a       the output from DGETRF (LAPACK ) / DGEFA (LINPACK).
!   lda     the leading dimension of the matrix a.
!   n       the order of the matrix a.
!   ipvt    the pivot vector from DGETRF / DGEFA.
!
! on return:
!   a       unchanged.
!   ipvt    unchanged.
!   det     determinant of original matrix. determinant = det(1) * 10.0**det(2)
!           with  1.0 .le. abs(det(1)) .lt. 10.0  or  det(1) .eq. 0.0 .
!//////////////////////////////////////////////////////////////////////////////

  SUBROUTINE dgedet(a,lda,n,ipvt,det,job)

    IMPLICIT NONE

! args
    INTEGER lda, n, ipvt(*), job
    REAL (rk) a(lda,*), det(*)

! local vars
    INTEGER i
    REAL (rk) one, ten, zero

! begin
    IF (job<10) RETURN
    zero = 0.0D0
    one = 1.0D0
    ten = 10.0D0
    det(1) = one
    det(2) = zero

! loop over diagonal elements of a
    DO i = 1, n
      IF (ipvt(i)/=i) det(1) = -det(1)
      det(1) = a(i,i)*det(1)

! exit if product is zero
      IF (det(1)==zero) RETURN

! cast result into the form determinant = det(1) * ten**det(2)
      DO WHILE (abs(det(1))<one)
        IF (det(2)<-1000.0D0) THEN
          CALL hdlc_errflag('Problems getting determinant','warn')
          det(1) = zero
          det(2) = zero
          RETURN
        END IF
        det(1) = ten*det(1)
        det(2) = det(2) - one
      END DO
      DO WHILE (abs(det(1))>=ten)
        det(1) = det(1)/ten
        det(2) = det(2) + one
      END DO
    END DO
  END SUBROUTINE dgedet

!------------------------------------------------------------------------------
! Creation and destruction etc.
!------------------------------------------------------------------------------

!!$  FUNCTION int_matrix_create(nr,nc,name)
!!$    IMPLICIT NONE
!!$    TYPE (int_matrix) :: int_matrix_create
!!$    INTEGER, INTENT (IN) :: nr, nc
!!$    CHARACTER*(*) name
!!$    TYPE (int_matrix), POINTER :: temp
!!$
!!$    allocate (temp)
!!$    temp%np(1) = nr
!!$    temp%np(2) = nc
!!$    temp%tag = name
!!$    allocate (temp%data(temp%np(1),temp%np(2)))
!!$    int_matrix_create => temp
!!$  END FUNCTION int_matrix_create

  FUNCTION int_matrix_create(nr,nc,name)
    use dlf_parameter_module, only: ik
    IMPLICIT NONE
    TYPE (int_matrix)    :: int_matrix_create
    INTEGER, INTENT (IN) :: nr, nc
    CHARACTER(*)         ::  name

    int_matrix_create%np(1) = nr
    int_matrix_create%np(2) = nc
    call allocate(int_matrix_create%data,nr,nc)

  END FUNCTION int_matrix_create

!!$  FUNCTION int_matrix_destroy(a)
!!$    IMPLICIT NONE
!!$    INTEGER int_matrix_destroy
!!$    TYPE (int_matrix), POINTER :: a
!!$
!!$    deallocate (a%data)
!!$    deallocate (a)
!!$    int_matrix_destroy = 0
!!$  END FUNCTION int_matrix_destroy

  FUNCTION int_matrix_destroy(a)
    use dlf_parameter_module, only: ik
    IMPLICIT NONE
    INTEGER int_matrix_destroy
    TYPE (int_matrix) :: a

    if(allocated(a%data)) then
      call deallocate (a%data)
    end if
    int_matrix_destroy = 0
  END FUNCTION int_matrix_destroy

  FUNCTION int_matrix_dimension(a,i)
    IMPLICIT NONE
    TYPE (int_matrix) :: a
    INTEGER int_matrix_dimension, i

    int_matrix_dimension = a%np(i)
  END FUNCTION int_matrix_dimension

  FUNCTION matrix_dimension(a,i)
    IMPLICIT NONE
    TYPE (matrix) :: a
    INTEGER matrix_dimension, i

    matrix_dimension = a%np(i)
  END FUNCTION matrix_dimension

! will have to be handeled somehow ..
!!$  FUNCTION matrix_data_array(a)
!!$    IMPLICIT NONE
!!$    TYPE (matrix), POINTER :: a
!!$    REAL (rk), DIMENSION (:,:), POINTER :: matrix_data_array
!!$
!!$    matrix_data_array => a%data
!!$  END FUNCTION matrix_data_array

!!$  FUNCTION matrix_create(nr,nc,name)
!!$    IMPLICIT NONE
!!$    TYPE (matrix), POINTER :: matrix_create
!!$    INTEGER, INTENT (IN) :: nr, nc
!!$    CHARACTER*(*) name
!!$    TYPE (matrix), POINTER :: temp
!!$
!!$    allocate (temp)
!!$    temp%nv = nr*nc
!!$    temp%np(1) = nr
!!$    temp%np(2) = nc
!!$    temp%tag = name
!!$    allocate (temp%data(temp%np(1),temp%np(2)))
!!$    matrix_create => temp
!!$  END FUNCTION matrix_create

  FUNCTION matrix_create(nr,nc,name)
    use dlf_parameter_module, only: rk
    IMPLICIT NONE
    TYPE (matrix) :: matrix_create
    INTEGER, INTENT (IN) :: nr, nc
    CHARACTER(*) :: name
    integer :: idum

    !if(allocated(matrix_create%data)) idum= matrix_destroy(matrix_create)
    matrix_create%nv = nr*nc
    matrix_create%np(1) = nr
    matrix_create%np(2) = nc
    matrix_create%tag = name
    call allocate (matrix_create%data,matrix_create%np(1),matrix_create%np(2))
    !print*,"Allocating matrix  =",name,nr,nc
  END FUNCTION matrix_create

  INTEGER FUNCTION matrix_set_column(a,size,data,col)
    IMPLICIT NONE
    TYPE (matrix) :: a
    integer,   intent(in)       :: size
    REAL (rk),   intent(in)     :: data(size)
    INTEGER,   intent(in)       :: col
    INTEGER                     :: i

    matrix_set_column = 0
    if(col>a%np(2)) return
    if(col<1) return
    DO i = 1, a%np(1)
      if(i>size) cycle
      a%data(i,col) = data(i)
    END DO
  END FUNCTION matrix_set_column

  INTEGER FUNCTION matrix_set_row(a,size,data,row)
    IMPLICIT NONE
    TYPE (matrix) :: a
    integer,   intent(in)       :: size
    REAL (rk),   intent(in)     :: data(size)
    INTEGER,   intent(in)       :: row
    INTEGER                     :: i

    matrix_set_row = 0
    if(row>a%np(1)) return
    if(row<1) return
    DO i = 1, a%np(2)
      if(i>size) cycle
      a%data(row,i) = data(i)
    END DO
  END FUNCTION matrix_set_row

  INTEGER FUNCTION matrix_set(a,size,data)
    IMPLICIT NONE
    TYPE (matrix) :: a
    integer,   intent(in) :: size
    REAL (rk), intent(in) :: data(size)
    INTEGER i, j, k

    k = 0
    DO j = 1, a%np(2)
      DO i = 1, a%np(1)
        k = k + 1
        if(k>size) exit
        a%data(i,j) = data(k)
      END DO
    END DO
    matrix_set = 0
  END FUNCTION matrix_set

  INTEGER FUNCTION matrix_get(a,size,data)
    IMPLICIT NONE
    TYPE (matrix) :: a
    integer,   intent(in)  :: size
    REAL (rk), intent(out) :: data(size)
    INTEGER i, j, k

    k = 0
    DO j = 1, a%np(2)
      DO i = 1, a%np(1)
        k = k + 1
        if(k>size) exit
        data(k) = a%data(i,j)
      END DO
    END DO
    matrix_get = 0
  END FUNCTION matrix_get

  INTEGER FUNCTION matrix_get_column(a,size,data,col)
    IMPLICIT NONE
    TYPE (matrix) :: a
    integer,   intent(in)  :: size
    REAL (rk), intent(out) :: data(size)
    INTEGER col, i
    
    matrix_get_column = 0
    if(col>a%np(2)) return
    if(col<1) return
    DO i = 1, a%np(1)
      if(i>size) cycle
      data(i) = a%data(i,col)
    END DO
  END FUNCTION matrix_get_column

  INTEGER FUNCTION matrix_get_row(a,size,data,row)
    IMPLICIT NONE
    TYPE (matrix) :: a
    integer,   intent(in)  :: size
    REAL (rk), intent(out) :: data(size)
    INTEGER row, i

    matrix_get_row = 0
    if(row>a%np(1)) return
    if(row<1) return
    DO i = 1, a%np(2)
      if(i>size) cycle
      data(i) = a%data(row,i)
    END DO
  END FUNCTION matrix_get_row

  INTEGER FUNCTION int_matrix_set_column(a,size,data,col)
    IMPLICIT NONE
    TYPE (int_matrix) :: a
    integer,   intent(in)  :: size
    integer,   intent(in)  :: data(size)
    INTEGER col, i

    int_matrix_set_column = 0
    if(col>a%np(2)) return
    if(col<1) return
  
    DO i = 1, a%np(1)
      if(i>size) cycle
      a%data(i,col) = data(i)
    END DO
  END FUNCTION int_matrix_set_column

  INTEGER FUNCTION int_matrix_set_element(a,data,row,col)
    ! this fuction is not used at the moment
    IMPLICIT NONE
    TYPE (int_matrix) :: a
    INTEGER data, col, row

    a%data(row,col) = data
    int_matrix_set_element = 0
  END FUNCTION int_matrix_set_element

  INTEGER FUNCTION matrix_assign_unit(a)
    IMPLICIT NONE
    TYPE (matrix) :: a
    INTEGER i

    a%data = 0.0D0
    DO i = 1, a%np(1)
      a%data(i,i) = 1.0D0
    END DO
    matrix_assign_unit = 0
  END FUNCTION matrix_assign_unit

  INTEGER FUNCTION matrix_copy(x,y)
    IMPLICIT NONE
    TYPE (matrix) :: x, y
    INTEGER       :: length,idum

    length = x%np(1)*x%np(2)
    if(allocated(y%data)) then
      if(y%np(1)*y%np(2)/=length) idum=matrix_destroy(y)
    end if
    IF ( .NOT. allocated(y%data)) THEN
!      y = matrix_create(x%np(2),x%np(1),x%tag) ! orig: why this order?
      y = matrix_create(x%np(1),x%np(2),x%tag)
    END IF
    CALL dcopy(length,x%data,1,y%data,1)
    matrix_copy = 0
  END FUNCTION matrix_copy

  INTEGER FUNCTION matrix_print(a)
    IMPLICIT NONE
    TYPE (matrix) :: a
!
    LOGICAL ohi

    ! check if allocated
    if(.not.allocated(a%data)) then
      CALL hdlc_errflag('matrix not allocated in matrix_print','abort')
    end if
!
    WRITE (stdout,*) ' '
    WRITE (stdout,'(a,a)') 'Contents of matrix: ', a%tag
    WRITE (stdout,*) '---------------------------------------'
!
    ohi = .FALSE.
    CALL prmat(a%data,a%np(1),a%np(2),a%np(1),ohi)
!
    matrix_print = 0
!
  CONTAINS
    SUBROUTINE prmat(v,m,n,ndim,ohi)
! m = number of columns
! n = number of rows
! ndim = leading dimension
! ohi print high precision
      INTEGER n, m, ndim
      REAL (rk) v(ndim,*)
      LOGICAL ohi
      INTEGER imin, imax, max, i, j

      ohi = .FALSE.

      max = 12
      IF (ohi) max = 7
      imax = 0
!
100   imin = imax + 1
      imax = imax + max
      IF (imax>n) imax = n
      WRITE (stdout,9008)
      IF ( .NOT. ohi) WRITE (stdout,8028) (i,i=imin,imax)
      IF (ohi) WRITE (stdout,9028) (i,i=imin,imax)
      WRITE (stdout,9008)
      DO j = 1, m
        IF (ohi) WRITE (stdout,9048) j, (v(j,i),i=imin,imax)
        IF ( .NOT. ohi) WRITE (stdout,8048) j, (v(j,i),i=imin,imax)
      END DO
      IF (imax<n) GO TO 100
      RETURN
9008  FORMAT (1X)
9028  FORMAT (6X,7(6X,I3,6X))
9048  FORMAT (I5,1X,7F15.10)
8028  FORMAT (6X,12(3X,I3,3X))
8048  FORMAT (I5,1X,12F9.5)
    END SUBROUTINE prmat
  END FUNCTION matrix_print

  INTEGER FUNCTION matrix_destroy(a)
    use dlf_parameter_module, only: rk
    IMPLICIT NONE
    TYPE (matrix) :: a

    if(allocated(a%data)) then
      call deallocate (a%data)
      !print*,"Deallocating matrix=",a%tag,a%np(1),a%np(2)
    end if
    matrix_destroy = 0
  END FUNCTION matrix_destroy

!------------------------------------------------------------------------------
! Checkpointing: dump to / undump from unit iunit
!------------------------------------------------------------------------------

  SUBROUTINE hdlc_wr_matrix(iunit,a,lform,lerr)
    IMPLICIT NONE
    LOGICAL lform, lerr
    INTEGER iunit
    TYPE (matrix) :: a
    INTEGER i, j

    lerr = .FALSE.
    IF (lform) THEN
      WRITE (iunit,*,err=98) a%nv, a%np(1), a%np(2)
      WRITE (iunit,'(a)',err=98) a%tag
      WRITE (iunit,*,err=98) ((a%data(i,j),i=1,a%np(1)),j=1,a%np(2))
    ELSE
      WRITE (iunit,err=98) a%nv, a%np(1), a%np(2)
      WRITE (iunit,err=98) a%tag
      WRITE (iunit,err=98) ((a%data(i,j),i=1,a%np(1)),j=1,a%np(2))
    END IF
    RETURN
98  lerr = .TRUE.
  END SUBROUTINE hdlc_wr_matrix

  SUBROUTINE hdlc_rd_matrix(iunit,a,lform,lerr)
    IMPLICIT NONE
    LOGICAL lform, lerr
    INTEGER iunit
    TYPE (matrix) :: a
    INTEGER i, j

    lerr = .FALSE.
! JK included the allocate (pgf requirement)
!    allocate (a)
    IF (lform) THEN
      READ (iunit,*,err=98) a%nv, i, j
      READ (iunit,'(a)',err=98) a%tag
    ELSE
      READ (iunit,err=98) a%nv, i, j
      READ (iunit,err=98) a%tag
    END IF

    if(i/=a%np(1) .or. j/=a%np(2)) then
!!$      ! more secure version: terminate if dimensions do not match
!!$      write(*,*) "Error reading matrix from checkpoint file"
!!$      write(*,'("Expecting dimensions ",2i5)') a%np(1),a%np(2)
!!$      write(*,'("Read dimensions      ",2i5)') i,j
!!$      lerr=.true.
!!$      return

      ! alternative: reallocate matrix and read it
      a%nv = i*j
      a%np(1) = i
      a%np(2) = j
      call deallocate (a%data)
      call allocate (a%data, a%np(1), a%np(2))

    end if

    IF (lform) THEN
      READ (iunit,*,err=98) ((a%data(i,j),i=1,a%np(1)),j=1,a%np(2))
    ELSE
      READ (iunit,err=98) ((a%data(i,j),i=1,a%np(1)),j=1,a%np(2))
    END IF
    RETURN
98  lerr = .TRUE.
  END SUBROUTINE hdlc_rd_matrix

END MODULE dlfhdlc_matrixlib

!  Copyright (C) 2017 The authors of Py-ChemShell
!
!  This file is part of Py-ChemShell.
!
!  Py-ChemShell is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as
!  published by the Free Software Foundation, either version 3 of the
!  License, or (at your option) any later version.
!
!  Py-ChemShell is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with Py-ChemShell.  If not, see
!  <http://www.gnu.org/licenses/>.

!TODO unify rk and kind=8

subroutine dlf_get_params(nvar,            &
                          nvar2,           &
                          nspec,           &
                          coords,          &
                          coords2,         &
                          spec,            &
                          ierr,            &
                          tolerance,       &
                          printl,          &
                          maxcycle,        &
                          maxene,          &
                          ivar,            &
                          icoord,          &
                          iopt,            &
                          iline,           &
                          maxstep,         &
                          scale_step,      &
                          lbfgs_mem,       &
                          nimages,         &
                          nebk,            &
                          dump,            &
                          restart,         &
                          nz,              &
                          ncons,           &
                          nconn,           &
                          update,          &
                          maxupdate,       &
                          delta,           &
                          soft,            &
                          inithessian,     &
                          carthessian,     &
                          tsrelative,      &
                          maxrot,          &
                          tolrot,          &
                          nframes,         &
                          nmass,           &
                          nweight,         &
                          timestep,        &
                          fric0,           &
                          fricfac,         &
                          fricp,           &
                          imultistate,     &
                          state_i,         &
                          state_j,         &
                          pf_c1,           &
                          pf_c2,           &
                          gp_c3,           &
                          gp_c4,           &
                          ln_t1,           &
                          ln_t2,           &
                          printf,          &
                          tolerance_e,     &
                          distort,         &
                          massweight,      &
                          minstep,         &
                          maxdump,         &
                          task,            &
                          temperature,     &
                          po_pop_size,     &
                          po_radius,       &
                          po_contraction,  &
                          po_tolerance_r,  &
                          po_tolerance_g,  &
                          po_distribution, &
                          po_maxcycle,     &
                          po_init_pop_size,&
                          po_reset,        &
                          po_mutation_rate,&
                          po_death_rate,   &
                          po_scalefac,     &
                          po_nsave,        &
                          ntasks,          &
                          tdlf_farm,       &
                          n_po_scaling,    &
                          neb_climb_test,  &
                          neb_freeze_test, &
                          nzero,           &
                          coupled_states,  &
                          qtsflag,         &
                          imicroiter,      &
                          maxmicrocycle,   &
                          micro_esp_fit)

    use iso_c_binding
    use ChemShellParallelModule, only: chemsh_parallel
    use dlf_parameter_module   , only: rk
    use ChemShellDLFModule     , only: PyFrag, PyFrag2, PyOptions

    implicit none

    ! options (defined in chemsh/tasks/opt/opt.py) are pointers while others are not
    integer , intent(in)    :: nvar
    integer , intent(in)    :: nvar2
    integer , intent(in)    :: nspec
    real(rk), intent(inout) :: coords(nvar)
    real(rk), intent(inout) :: coords2(nvar2)
    integer , intent(inout) :: spec(nspec)
    integer , intent(out)   :: ierr
    real(rk), intent(out)   :: tolerance
    integer , intent(out)   :: printl
    integer , intent(out)   :: maxcycle
    integer , intent(out)   :: maxene
    integer , intent(out)   :: ivar
    integer , intent(inout) :: icoord
    integer , intent(inout) :: iopt
    integer , intent(inout) :: iline
    real(rk), intent(out)   :: maxstep
    real(rk), intent(out)   :: scale_step
    integer , intent(out)   :: lbfgs_mem
    integer , intent(out)   :: nimages
    real(rk), intent(out)   :: nebk
    integer , intent(out)   :: dump
    integer , intent(out)   :: restart
    integer , intent(inout) :: nz
    integer , intent(inout) :: ncons
    integer , intent(inout) :: nconn
    integer , intent(inout) :: update
    integer , intent(out)   :: maxupdate
    real(rk), intent(out)   :: delta
    real(rk), intent(out)   :: soft
    integer , intent(out)   :: inithessian
    integer , intent(inout) :: carthessian
    integer , intent(out)   :: tsrelative
    integer , intent(out)   :: maxrot
    real(rk), intent(out)   :: tolrot
    integer , intent(inout) :: nframes
    integer , intent(inout) :: nmass
    integer , intent(inout) :: nweight
    real(rk), intent(out)   :: timestep
    real(rk), intent(out)   :: fric0
    real(rk), intent(out)   :: fricfac
    real(rk), intent(out)   :: fricp
    integer , intent(inout) :: imultistate
    integer , intent(out)   :: state_i
    integer , intent(out)   :: state_j
    real(rk), intent(out)   :: pf_c1
    real(rk), intent(out)   :: pf_c2
    real(rk), intent(out)   :: gp_c3
    real(rk), intent(out)   :: gp_c4
    real(rk), intent(out)   :: ln_t1
    real(rk), intent(out)   :: ln_t2
    integer , intent(inout) :: printf
    real(rk), intent(out)   :: tolerance_e
    real(rk), intent(out)   :: distort
    integer , intent(inout) :: massweight
    real(rk), intent(out)   :: minstep
    integer , intent(inout) :: maxdump
    integer , intent(inout) :: task
    real(rk), intent(out)   :: temperature
    integer , intent(out)   :: po_pop_size
    real(rk), intent(out)   :: po_radius
    real(rk), intent(out)   :: po_contraction
    real(rk), intent(out)   :: po_tolerance_r
    real(rk), intent(out)   :: po_tolerance_g
    integer , intent(out)   :: po_distribution
    integer , intent(out)   :: po_maxcycle
    integer , intent(out)   :: po_init_pop_size
    integer , intent(out)   :: po_reset
    real(rk), intent(out)   :: po_mutation_rate
    real(rk), intent(out)   :: po_death_rate
    real(rk), intent(out)   :: po_scalefac
    integer , intent(out)   :: po_nsave
    integer , intent(inout) :: ntasks
    integer , intent(inout) :: tdlf_farm
    integer , intent(inout) :: n_po_scaling
    real(rk), intent(out)   :: neb_climb_test
    real(rk), intent(out)   :: neb_freeze_test
    integer , intent(out)   :: nzero
    integer , intent(out)   :: coupled_states
    integer , intent(inout) :: qtsflag
    integer , intent(inout) :: imicroiter
    integer , intent(out)   :: maxmicrocycle
    integer , intent(out)   :: micro_esp_fit

    integer                   :: debug, i, iat, istart, ityp, natoms, natoms2, iparameterise
    integer                   :: nresidues, ncartcons
    integer                   :: save_path

    real(kind=8)    , pointer :: onedimdbl(:), twodimdbl(:,:)
    integer(kind=8) , pointer :: onedimint(:), twodimint(:,:)

    character(len=255)        :: algorithm, coordinate
    character(len=:), pointer :: trust_radius

    ! parameterisation mode
    logical                   :: parameterise

    ! print level
    call PyOptions%get("save_path", save_path)
    if(save_path.eq.1) then
        printf = 4
    else
        printf = 2
    endif
    call PyOptions%get("debug", debug)
    ! TWK 20/12/2021 Set default DL-FIND print level to 2 as in Tcl-ChemShell
    printl = debug + 2
    ! printf should be no smaller than printl
    printf = max(printf, printl)

    ! get natoms
    call PyFrag%get('npts', natoms)

    ierr = 0

    ! let ChemShell set up MPI for DL_FIND 
    ntasks = chemsh_parallel%nworkgroups
    tdlf_farm = 0

! >>> COORDS

    call PyOptions%get("parameterise", iparameterise)
    parameterise = iparameterise.eq.1
    ! atom mode
    if(.not.parameterise) then
        nz     = natoms
        nweight = 0
        ! YL: copying is unavoidable without modifying DLF
        allocate(twodimdbl(3,natoms))
        call PyFrag%get('xyz', twodimdbl)
        coords  = reshape(twodimdbl, (/nvar/))
        deallocate(twodimdbl)
        ivar = 1
    ! parameter mode
    else
        nz     = 0
        allocate(onedimdbl(nvar))
        call PyOptions%get("parameters", onedimdbl)
        coords  = onedimdbl
        deallocate(onedimdbl)
        ivar = 0
    endif

! <<< END OF COORDS

    ! remember: nvarin=natoms*3 and nvarin2=3*natoms*nframes+natoms
    nmass  = natoms
    ntasks = 1
    nconn  = 0
    nresidues = 0

    ! not in use but needed
    task = 0
    po_distribution = 3

    ! TODO
    temperature = 300.0
    qtsflag = 0

    ! number of frames
    call PyOptions%get("nframes", nframes)

    if(.not.parameterise) then
        ! Set up DL-FIND integer specification array
        !    nat     entries of freezing/residue number
        !    nz      entries of nuclear charges (same order as coords)
        !    5*ncons entries of HDLC constraints (typ, atom1,atom2, atom3, atom4)
        !    2*nconn entries of connections (atom1 atom2)
        !    nat     entries of microiterative region specification
        ! i.e. nspec= nat + nz + 5*ncons + 2*nconn + nat
        spec(:) = 0
        allocate(onedimint(natoms))
        ! frozen centres
        call PyFrag%get("frozen", onedimint)
        spec(1:natoms) = onedimint(:)
        ! TWK 17/08/2022 process HDLC residue numbers
        ! Make sure not to overwrite frozen atoms
        ! TODO: delete residues entirely if they become too small (<3 atoms)
        ! as a result of removing frozen atoms from them
        call PyOptions%get("nresidues", nresidues)
        if (nresidues > 0) then
            call PyOptions%get("resIDs", onedimint)
            do i = 1, natoms
                if (spec(i) /= -1) then
                    spec(i) = onedimint(i) + 1
                end if
            end do
        end if
        ! TWK 19/08/2022 process constraints used with Cartesian coordinates
        ! Again make sure not to overwrite frozen atoms, which take precedence.
        call PyOptions%get("ncartcons", ncartcons)
        if (ncartcons > 0) then
            allocate(twodimint(5,ncartcons))
            call PyOptions%get("constraints", twodimint)
            do i = 1, ncartcons
                iat = twodimint(2, i) + 1
                if (spec(iat) /= -1) then
                    spec(iat) = twodimint(1, i)
                end if
            end do
            deallocate(twodimint)
        end if
        ! atomic numbers
        call PyFrag%get("znums", onedimint)
        spec(1+natoms:natoms+natoms) = onedimint(:)
        ! TWK 19/08/2022 process constraints used with HDLC coordinates
        call PyOptions%get("ncons", ncons)
        if (ncons > 0) then
            allocate(twodimint(5,ncons))
            call PyOptions%get("constraints", twodimint)
            istart = 1+natoms+natoms
            do i = 1, ncons
                ityp = twodimint(1,i)
                spec(istart) = ityp 
                ! DL-FIND atom numbers are offset by 1 from Py-ChemShell
                ! BUT we must leave the empty entries at 0...
                spec(istart+1:istart+1+ityp) = twodimint(2:ityp+2,i) + 1
                istart = istart + 5 
            end do
            deallocate(twodimint)
        end if
        ! TODO: connections, microiterative specs
        deallocate(onedimint)
    else
        spec = 0
    endif

! COORDS2

    coords2 = 0.0

    ! auxiliary array ("coords2" in Tcl-ChemShell)
    if(nframes > 0.and.associated(PyFrag2)) then
        call PyFrag2%get("npts", natoms2)
        allocate(twodimdbl(3,natoms2))
        call PyFrag2%get("xyz", twodimdbl)
        if (debug > 0) then
            write(*,'(/" DL_FIND auxiliary coordinates (a.u.):"/)')
            do i = 1, natoms2
                write(*,'(3F16.9)') twodimdbl(:,i)
            enddo
        end if
!        coords2(nvar*nframes+1:) = theory%frag%masses
        coords2(:nvar*nframes) = reshape(twodimdbl, (/nvar*nframes/))
        deallocate(twodimdbl)

    endif

    if(.not.parameterise) then
        ! TODO: to implement nweights
        ! weights
        allocate(onedimdbl(natoms))
        call PyFrag%get("masses", onedimdbl)
        coords2(nvar*nframes+1:) = onedimdbl
        deallocate(onedimdbl)
    endif

! END OF COORDS2
! OPTIONS

    call PyOptions%get("pf_c1", pf_c1)
    call PyOptions%get("tolerance"       , tolerance)
!    call PyOptions%get("printl"          , printl)    ! set by `debug`
    call PyOptions%get("maxcycle"        , maxcycle)
    call PyOptions%get("maxene"          , maxene)
    ! 3D coordinates or sequetial variables mode (1 for atoms mode)
    call PyOptions%get("icoord"          , icoord)
    call PyOptions%get("iopt"            , iopt)
    call PyOptions%get("maxstep"         , maxstep)
    call PyOptions%get("scale_step"      , scale_step)
    call PyOptions%get("lbfgs_mem"       , lbfgs_mem)
    call PyOptions%get("nimages"         , nimages)
    call PyOptions%get("nebk"            , nebk)
    call PyOptions%get("dump"            , dump)
    call PyOptions%get("restart"         , restart)
!    call PyOptions%get("nz"              , nz)
    call PyOptions%get("ncartcons"       , ncartcons)
    call PyOptions%get("ncons"           , ncons)
!    call PyOptions%get("nconn"           , nconn)
    call PyOptions%get("update"          , update)
    call PyOptions%get("maxupdate"       , maxupdate)
    call PyOptions%get("delta"           , delta)
    call PyOptions%get("soft"            , soft)
    call PyOptions%get("init_hessian"    , inithessian)
    call PyOptions%get("cart_hessian"    , carthessian)
    call PyOptions%get("tsrelative"      , tsrelative)
    call PyOptions%get("maxrot"          , maxrot)
    call PyOptions%get("tolrot"          , tolrot)
!    call PyOptions%get("nmass"           , nmass)
!    call PyOptions%get("nweight"         , nweight)
    call PyOptions%get("timestep"        , timestep)
    call PyOptions%get("fric0"           , fric0)
    call PyOptions%get("fricfac"         , fricfac)
    call PyOptions%get("fricp"           , fricp)
!    call PyOptions%get("imultistate"     , imultistate)
    call PyOptions%get("state_i"         , state_i)
    call PyOptions%get("state_j"         , state_j)
    call PyOptions%get("pf_c1"           , pf_c1)
    call PyOptions%get("pf_c2"           , pf_c2)
    call PyOptions%get("gp_c3"           , gp_c3)
    call PyOptions%get("gp_c4"           , gp_c4)
    call PyOptions%get("ln_t1"           , ln_t1)
    call PyOptions%get("ln_t2"           , ln_t2)
    call PyOptions%get("tolerance_e"     , tolerance_e)
    call PyOptions%get("distort"         , distort)
!    call PyOptions%get("massweight"      , massweight)
    call PyOptions%get("minstep"         , minstep)
!    call PyOptions%get("maxdump"         , maxdump)
!    call PyOptions%get("task"            , task)
    call PyOptions%get("temperature"     , temperature)
    call PyOptions%get("po_pop_size"     , po_pop_size)
    call PyOptions%get("po_radius"       , po_radius)
    call PyOptions%get("po_contraction"  , po_contraction)
    call PyOptions%get("po_tolerance_r"  , po_tolerance_r)
    call PyOptions%get("po_tolerance_g"  , po_tolerance_g)
    call PyOptions%get("po_distribution" , po_distribution)
    call PyOptions%get("po_maxcycle"     , po_maxcycle)
    call PyOptions%get("po_init_pop_size", po_init_pop_size)
    call PyOptions%get("po_reset"        , po_reset)
    call PyOptions%get("po_mutation_rate", po_mutation_rate)
    call PyOptions%get("po_death_rate"   , po_death_rate)
    call PyOptions%get("po_scalefac"     , po_scalefac)
    call PyOptions%get("po_nsave"        , po_nsave)
!    call PyOptions%get("ntasks"          , ntasks)
!    call PyOptions%get("tdlf_farm"       , tdlf_farm)
!    call PyOptions%get("n_po_scaling"    , n_po_scaling)
    call PyOptions%get("neb_climb_test"  , neb_climb_test)
    call PyOptions%get("neb_freeze_test" , neb_freeze_test)
    call PyOptions%get("nzero"           , nzero)
    call PyOptions%get("coupled_states"  , coupled_states)
!    call PyOptions%get("qtsflag"         , qtsflag)
!    call PyOptions%get("imicroiter"      , imicroiter)
    call PyOptions%get("maxmicrocycle"   , maxmicrocycle)
    call PyOptions%get("micro_esp_fit"   , micro_esp_fit)
    call PyOptions%get("trust_radius"    , trust_radius)

    if (debug > 0) then
        write(*, '(1X,A)') ">>> DL_FIND specifications:"
        select case(iopt)
            case(0)
                algorithm = "steepest descent"
            case(1)
                algorithm = "conjugate gradient"
            case(2)
                algorithm = "conjugate gradient with CG restart"
            case(3)
                algorithm = "L-BFGS"
            case(9)
                algorithm = "delta test for finite-difference in gradients"
            case(10)
                algorithm = "P-RFO"
            case(11)
                algorithm = "just Hessian and thermal analysis"
            case(12)
                algorithm = "Hessian of all images and qTS rate"
            case(13)
                algorithm = "rate without tunnelling"
            case(20)
                algorithm = "Newton-Raphson (quasi-Newton)"
            case(30)
                algorithm = "damped dynamics"
            case(51)
                algorithm = "random (stochastic) search"
            case(52)
                algorithm = "genetic algorithm"
            case default
        end select
        write(*, '(5X,A,A,1X,A,I2,A)') "algorithm : ", trim(algorithm), "(iopt =", iopt, ")"
        select case(icoord)
            case(0)
                coordinate = "Cartesian"
            case(1)
                coordinate = "HDLC"
            case(2)
                coordinate = "HDLC-TC (total connection)"
            case(3)
                coordinate = "DLC"
            case(4)
                coordinate = "DLC-TC (total connection)"
        end select
        write(*, '(5X,A,A,1X,A,I2,A)') "coordinate: ", trim(coordinate), "(icoord =", icoord, ")"
    end if

    ! trust radius method
    selectcase(trim(trust_radius))
        case("constant")
            iline = 0
        case("scaled")
            iline = 0
        case("energy")
            iline = 1
        case("gradient")
            iline = 2
        case("line_search")
            iline = 3
        case("line")
            iline = 3
    endselect

    if(debug > 3) then 
       print *
       print *, ">>> DL-FIND specifications:"
       print *
       print *, "    nvar     : ", nvar
       print *, "    nvar2    : ", nvar2
       print *, "    nspec    : ", nspec
       print *, "    icoord   : ", icoord
       print *, "    iopt     : ", iopt
       print *, "    iline    : ", iline
       print *, "    nimages  : ", nimages
       print *, "    nframes  : ", nframes
       print *, "    tolerance: ", tolerance
       print *
    endif

    if(debug > 4) then
        print *, " >>> DL_FIND parameters:"
        print *, " coords(nvar)   = ", coords
        print *, " coords2(nvar2) = ", coords2
        print *, " spec(nspec)         = ", spec
        print *, " ierr                = ", ierr
        print *, " printl              = ", printl
        print *, " maxcycle            = ", maxcycle
        print *, " maxene              = ", maxene
        print *, " maxstep             = ", maxstep
        print *, " scale_step          = ", scale_step
        print *, " lbfgs_mem           = ", lbfgs_mem
        print *, " nebk                = ", nebk
        print *, " dump                = ", dump
        print *, " restart             = ", restart
        print *, " nz                  = ", nz
        print *, " ncons               = ", ncons
        print *, " nconn               = ", nconn
        print *, " update              = ", update
        print *, " maxupdate           = ", maxupdate
        print *, " delta               = ", delta
        print *, " soft                = ", soft
        print *, " inithessian         = ", inithessian
        print *, " carthessian         = ", carthessian
        print *, " tsrelative          = ", tsrelative
        print *, " maxrot              = ", maxrot
        print *, " tolrot              = ", tolrot
        print *, " nmass               = ", nmass
        print *, " nweight             = ", nweight
        print *, " timestep            = ", timestep
        print *, " fric0               = ", fric0
        print *, " fricfac             = ", fricfac
        print *, " fricp               = ", fricp
        print *, " imultistate         = ", imultistate
        print *, " state_i             = ", state_i
        print *, " state_j             = ", state_j
        print *, " pf_c1               = ", pf_c1
        print *, " pf_c2               = ", pf_c2
        print *, " gp_c3               = ", gp_c3
        print *, " gp_c4               = ", gp_c4
        print *, " ln_t1               = ", ln_t1
        print *, " ln_t2               = ", ln_t2
        print *, " printf              = ", printf
        print *, " tolerance_e         = ", tolerance_e
        print *, " distort             = ", distort
        print *, " massweight          = ", massweight
        print *, " minstep             = ", minstep
        print *, " maxdump             = ", maxdump
        print *, " task                = ", task
        print *, " temperature         = ", temperature
        print *, " po_pop_size         = ", po_pop_size
        print *, " po_radius           = ", po_radius
        print *, " po_contraction      = ", po_contraction
        print *, " po_tolerance_r      = ", po_tolerance_r
        print *, " po_tolerance_g      = ", po_tolerance_g
        print *, " po_distribution     = ", po_distribution
        print *, " po_maxcycle         = ", po_maxcycle
        print *, " po_init_pop_size    = ", po_init_pop_size
        print *, " po_reset            = ", po_reset
        print *, " po_mutation_rate    = ", po_mutation_rate
        print *, " po_death_rate       = ", po_death_rate
        print *, " po_scalefac         = ", po_scalefac
        print *, " po_nsave            = ", po_nsave
        print *, " ntasks              = ", ntasks
        print *, " tdlf_farm           = ", tdlf_farm
        print *, " n_po_scaling        = ", n_po_scaling
        print *, " neb_climb_test      = ", neb_climb_test
        print *, " neb_freeze_test     = ", neb_freeze_test
        print *, " nzero               = ", nzero
        print *, " coupled_states      = ", coupled_states
        print *, " qtsflag             = ", qtsflag
        print *, " imicroiter          = ", imicroiter
        print *, " maxmicrocycle       = ", maxmicrocycle
        print *, " micro_esp_fit       = ", micro_esp_fit
    endif

endsubroutine dlf_get_params
! YL 07/02/2021: kiter is always -1
subroutine dlf_get_gradient(nvar,      &
                            coords,    &
                            energy,    &
                            gradients, &
                            iimage,    &
                            kiter,     &
                            status)

    use iso_c_binding
    use dlf_parameter_module, only: rk
    use ChemShellDLFModule  , only: PyFrag, PyResult, PyCallback, PyOptions, PySetParams, ierror
    use dlf_convergence     , only: valg, valrmsg, vals, valrmss

    implicit none
    integer          , intent(in)  :: nvar
    real(rk), target , intent(in)  :: coords(nvar)
    real(rk)         , intent(out) :: energy
    real(rk)         , intent(out) :: gradients(nvar)
    integer          , intent(in)  :: iimage
    integer          , intent(in)  :: kiter
    integer          , intent(out) :: status

    integer                        :: i, debug, natoms, iparameterise
    real(rk), pointer              :: onedimdbl(:), twodimdbl(:,:)
    real(rk), pointer              :: temp(:)
    integer(kind=8), pointer       :: onedimint(:)

    real :: start_time, end_time

    logical                        :: parameterise

    status = 0

    call PyOptions%get("debug", debug)

    call PyOptions%get("parameterise", iparameterise)
    parameterise = iparameterise.eq.1
    
    ! atomic mode
    if(.not.parameterise) then

        call PyFrag%get('npts' , natoms)

        allocate(onedimint(natoms))
        call PyFrag%get("znums", onedimint)

        if(debug > 3) then
            allocate(twodimdbl(3,natoms))
            call PyFrag%get('xyz', twodimdbl)
            write(*,'(/" DL_FIND original coords (a.u.):"/)')
            write(*,'(3X,"index",1X,"Z-number",12X,"X",15X,"Y",15X,"Z"/)')
            do i = 1, natoms
                write(*,'(1X,I6,3X,I6,3X,3F16.9)') i-1, onedimint(i), twodimdbl(:,i)
            enddo
            call flush(6)
            deallocate(twodimdbl)
        endif

        ! update coords
        call PyFrag%set('xyz', reshape(coords, (/3,natoms/)))
 
        ! CALLBACK
        if(debug > 0) then
            write(*,'(/" >>> DL_FIND module is calling callback function for gradients evaluation..."/)')
        endif
        
        call cpu_time(start_time)

        ! energy of the previous step
        allocate(onedimdbl(1))
        call PyResult%get('energy', onedimdbl)
        energy = onedimdbl(1)
        ! save the energy, max grad, max step, RMS grad, RMS step
        call PyResult%set('convergences', (/energy,valg,vals,valrmsg,valrmss/))

        ! do calculations on the Python side
        ierror = PyCallback()
        call flush(5)
        call flush(6)
        if(ierror.ne.0) then
    !        print *, ">>> ERROR: DL_FIND failed to run callback function. Exiting..."
            call exit(ierror)
        endif
        call cpu_time(end_time)
        if (debug > 4) then
            print *, ">>> DL_FIND: PyCallback() costs ", end_time - start_time, " seconds"
        endif
        ! END OF CALLBACK 

        ! note the shape!
        allocate(twodimdbl(3,natoms))
    
        call PyResult%get('energy'   , onedimdbl)
        call PyResult%get('gradients', twodimdbl)

        ! update energy and gradients
        ! note: energy in Python is an array!
        energy = onedimdbl(1)

        ! can use c_f_pointer to reshape without copying, too
        ! call c_f_pointer(c_loc(twodimdbl), onedimdbl, [nvar])
        ! gradients = onedimdbl(:)

        if(debug > 3) then 
            write(*,'(/" DL_FIND energy (a.u.) of updated coordinates:"/)')
            write(*,'(4XF16.9)') energy
        endif

        if(debug > 3) then 
            write(*,'(/" DL_FIND gradients (a.u.) of updated coordinates:"/)')
            write(*,'(3X,"index",1X,"Z-number",12X,"X",15X,"Y",15X,"Z"/)')
        endif
    
        do i = 1, natoms
            gradients(i*3-2:i*3) = twodimdbl(:,i)
            if(debug > 3) then
                ! atomic numbers
                write(*,'(1X,I6,3X,I6,3X,3F16.9)') i-1, onedimint(i), gradients(i*3-2:i*3)
            endif
        enddo

        if(debug > 3) then
            write(*,'(//)')
        endif
        call flush(6)

        deallocate(onedimdbl, twodimdbl)
        deallocate(onedimint)

    ! parameterisation mode
    else

        allocate(onedimdbl(nvar))
        call PyOptions%get('parameters', onedimdbl)
        write(*,'(/" DL_FIND original parameters:"/)')
        do i = 1, nvar
            write(*,'(3X,I6,F20.12)') i-1, onedimdbl(i)
        enddo

        ! update parameters
        call PyOptions%set('parameters', coords)
        call flush(6)
        if(PySetParams() /= 0) then
            write(*, '(A)') ">>> ChemShell ERROR: DL_FIND failed to run PySetParams(). Exiting..."
            status = 1
        endif

        ! CALLBACK
        write(*,'(/" >>> DL_FIND is running the callback function for derivatives evaluation..."/)')
        ! do calculations on the Python side

        call cpu_time(start_time)
        call flush(6)

        ! run callback function to calculate the gradients
        if(PyCallback() /= 0) then
            print *, ">>> ERROR: DL_FIND failed to run callback function. Exiting..."
            status = 1
            stop
        endif

        call cpu_time(end_time)
        if(debug > 3) then 
            write (*, '(1X,A,F12.3,1X,A)') ">>> DL_FIND: CPU time for the callback function is", end_time-start_time, "s"
        endif
        call PyOptions%get('derivatives', onedimdbl)
        gradients(:) = onedimdbl(:)

        if(debug > 3) then 
            write(*,'(/" DL_FIND derivatives of updated parameters:"/)')
            write(*,'(3X,"index",7X,"derivative"/)')
            do i = 1, nvar
                write(*,'(1X,I6,3X,F16.9)') i-1, onedimdbl(i)
            enddo
            write(*,'(//)')
            call flush(6)
        endif
        deallocate(onedimdbl)

        ! note: energy in Python is an array!
        allocate(onedimdbl(1))
        call PyResult%get('energy', onedimdbl)
        energy = onedimdbl(1)

        deallocate(onedimdbl)
        ! END OF CALLBACK

    endif

endsubroutine dlf_get_gradient
! TODO: to implement Hessian array to feed DL_FIND
subroutine dlf_get_hessian(nvar, coords, hessian, status)

    use iso_c_binding
    use DLF_Parameter_Module, only: rk
    use ChemShellDLFModule  , only: PyFrag, PyCallback, ierror

    integer              , intent(in)  :: nvar
    real(rk)    , target , intent(in)  :: coords(nvar)
    real(rk)             , intent(out) :: hessian(nvar)
    integer              , intent(out) :: status
    
    integer                            :: natoms
    real(kind=8), pointer              :: twodimdbl(:,:)

    hessian = 0.0

    call PyFrag%get('npts', natoms)

    allocate(twodimdbl(3,natoms))
    call PyFrag%get('xyz', twodimdbl)
    write(*,'(/" DL_FIND dlf_get_hessian: original coords (a.u.):"/)')
    do i = 1, natoms
        write(*,'(3F16.9)') twodimdbl(:,i)
    enddo
    deallocate(twodimdbl)
    
    call PyFrag%set('xyz', reshape(coords, (/3,natoms/)))
    ! CALLBACK 
    write(*,'(/" >>> DL_FIND module is calling callback function for Hessian evaluation..."/)')
    ! do calculations on the Python side
    call cpu_time(start_time)
    ierror = PyCallback()
    if(ierror.ne.0) then
!        print *, ">>> ERROR: DL_FIND failed to run callback function. Exiting..."
        call exit(ierror)
    endif
    call cpu_time(end_time)
    print *, ">>> DL_FIND: PyCallback() costs ", end_time - start_time, " seconds"

! AD HOC
    status = 1
    ! END OF CALLBACK 

endsubroutine dlf_get_hessian
subroutine dlf_get_multistate_gradients()

    print *, "### PLACEHOLDER: dlf_get_multistate_gradients"

endsubroutine dlf_get_multistate_gradients
subroutine dlf_put_coords(nvar, mode, e0, coords0, iam)

    use dlf_parameter_module, only: rk
    use ChemShellDLFModule  , only: PyFrag, PyFrag2, PyResult, PyOptions

    implicit none

    integer                  , intent(in) :: nvar
    integer                  , intent(in) :: mode
    real(kind=8)             , intent(in) :: e0
    real(kind=8)             , intent(in) :: coords0(*)
    integer                  , intent(in) :: iam        ! a dummy argument

    real(rk)                              :: energy(1)
    integer                               :: i, natoms, natoms2, iparamterise
    real(kind=rk)   , pointer             :: coords(:,:)
    real(kind=8)    , pointer             :: onedimdbl(:)
    integer(kind=rk), pointer             :: znums(:)

    logical                               :: paramterise
    integer                               :: debug

    call PyOptions%get("debug", debug)
    call PyOptions%get("parameterise", iparamterise)
    paramterise = iparamterise.eq.1

    ! final energy
    if(mode>0) then
        energy = e0
        call PyResult%set('energy', energy)
    endif

    ! atomic mode
    if(.not.paramterise) then

        call PyFrag%get('npts', natoms)
        selectcase(mode)
            ! TODO
            case(:-1)
            ! update coordinates of frag
            case(1)
                call PyFrag%set('xyz', reshape(coords0(:nvar), (/3,natoms/)))
            ! update coordinates of frag2
            case(2)
                if(associated(PyFrag2)) then
                    ! YL: natoms2 here is the sum of frag2's natoms (TS and product)
                    ! YL 18/09/2018: as of new GNU compilers (7 or later?) setting values with part of the array (see dl_py2f.f90) causes segfault of mismatched array shapes, so use the full coordinates
!                    call PyFrag2%get('npts', natoms2)
                    ! YL 06/01/2022: it was reshape(coords0(:nvar), (/3,natoms2/)) here and might cause an overflow because the calling routine dlf_formstep_set_tsmode() in DL_FIND passes in an array of size nvar; in fact we only need to set the TS coordinates (verified to work with both Intel and GNU)
                    call PyFrag2%set('xyz', reshape(coords0(:nvar), (/3,natoms/)))
                endif
            ! same as mode 1
            case(3:5)
                call PyFrag%set('xyz', reshape(coords0(:nvar), (/3,natoms/)))
        endselect

        allocate(znums(natoms))
        call PyFrag%get('znums', znums)
    
        allocate(coords(3,natoms))
        call PyFrag%get('xyz', coords)

        if(debug > 3) then 
            write(*,'(//" DL_FIND has updated the Cartesian coords (a.u.):"/)')
            write(*,'(3X,"index",1X,"Z-number",12X,"X",15X,"Y",15X,"Z"/)')
            do i = 1, natoms
                write(*,'(1X,I6,3X,I6,3X,3F16.9)') i-1, znums(i), coords(:,i)
            end do
            write(*,'(//)')
            call flush(6)
        endif
    
        deallocate(znums, coords)

    ! parameter mode
    else

        allocate(onedimdbl(nvar))
        call PyOptions%get('parameters', onedimdbl)

        write(*,'(//" DL_FIND has updated the parameters:"/)')
        do i = 1, nvar
            write(*,'(3X,I6,F20.12)') i-1, onedimdbl(i)
        enddo
        write(*,'(//)')

        deallocate(onedimdbl)

    endif

endsubroutine dlf_put_coords

  
subroutine dlf_put_thermal()
endsubroutine dlf_put_thermal


subroutine dlf_error()

    write(*, *) ">>> ChemShell DL_FIND ERROR"
    ! DLF will quit without an error signal so cause this here
    call exit(1)
    ! TODO: return control to python with error message

endsubroutine dlf_error
subroutine dlf_update()
    print *, "### PLACEHOLDER: dlf_update"
endsubroutine dlf_update
subroutine dlf_get_taskfarm(nworkgroups, workgroupsize, workgroupnode, workgroupid, workgroup_comm, counterparts_comm)

    use ChemShellParallelModule, only : chemsh_parallel

    integer, intent(out) :: nworkgroups
    integer, intent(out) :: workgroupsize
    integer, intent(out) :: workgroupnode
    integer, intent(out) :: workgroupid
    integer, intent(out) :: workgroup_comm
    integer, intent(out) :: counterparts_comm
    
    nworkgroups       = chemsh_parallel%nworkgroups
    workgroupsize     =  1
    workgroupnode     = chemsh_parallel%node
    workgroupid       = chemsh_parallel%workgroup
    workgroup_comm    = -1
    counterparts_comm = chemsh_parallel%comm_node

endsubroutine dlf_get_taskfarm
subroutine dlf_put_taskfarm(nworkgroups, workgroupsize, workgroupnode, workgroupid, workgroup_comm, counterparts_comm)

    integer :: nworkgroups
    integer :: workgroupsize
    integer :: workgroupnode
    integer :: workgroupid
    integer :: workgroup_comm
    integer :: counterparts_comm

    print *, "### DL_FIND: dlf_put_taskfarm...."

endsubroutine dlf_put_taskfarm
subroutine dlf_put_procinfo(nprocs, rank, global_comm)

    integer, intent(in) :: nprocs
    integer, intent(in) :: rank
    integer, intent(in) :: global_comm

    print *, "### DL_FIND: dlf_put_procinfo..."

endsubroutine dlf_put_procinfo
subroutine dlf_get_procinfo(nprocs, rank, global_comm)

    use ChemShellParallelModule

    integer, intent(out) :: nprocs
    integer, intent(out) :: rank
    integer, intent(out) :: global_comm

    nprocs      = chemsh_parallel%nworkgroups
    rank        = chemsh_parallel%workgroup
    global_comm = chemsh_parallel%comm_node

endsubroutine dlf_get_procinfo

!! COPYRIGHT
!!
!!  Copyright 2007 Johannes Kaestner (kaestner@theochem.uni-stuttgart.de),
!!  Tom Keal (thomas.keal@stfc.ac.uk), Alex Turner, Salomon Billeter,
!!  Stephan Thiel, Max-Planck Institut fuer Kohlenforshung, Muelheim, 
!!  Germany.
!!
!!  This file is part of DL-FIND.
!!
!!  DL-FIND is free software: you can redistribute it and/or modify
!!  it under the terms of the GNU Lesser General Public License as 
!!  published by the Free Software Foundation, either version 3 of the 
!!  License, or (at your option) any later version.
!!
!!  DL-FIND is distributed in the hope that it will be useful,
!!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!!  GNU Lesser General Public License for more details.
!!
!!  You should have received a copy of the GNU Lesser General Public 
!!  License along with DL-FIND.  If not, see 
!!  <http://www.gnu.org/licenses/>.
!!
MODULE dlfhdlc_primitive
  use dlf_parameter_module, only: rk
  use dlf_global, only: printl,stdout,pi
  USE dlfhdlc_matrixlib
  IMPLICIT NONE

CONTAINS

!------------------------------------------------------------------------------
! subroutine connect_prim
!
! Automatically constructs a connection pattern for the system
!
! Method
! ======
!
! This method goes in two stages.  First a simple covalent radius method is
! employed, second the shortest branched path that internconnects every atom
! is found. The result is the fusion of these two connection patterns.
!
! The covalent interconnection method uses a fixed radius for each row of the
! periodic table, this is a bit crude. A connection is made when the square of
! the sum of the atomic radii is greater than 0.8 times the square of the
! inter atomic distance.
!
! The minimum distance method can be described as a two bucket algorithm.
! The is a 'known' bucket and an 'unknown' bucket.
!
! Initially, one atom is placed in the known and the rest in unknown.
! The algorithm cycles by finding the mimium distance between any atom in
! the known and unknown buckets.  For each cycle, a connection is made
! between the atoms found to have this shortest distance, and the atom
! of the connection that is in the unknows, and the unknown atom is placed
! into the known bucket.
!
! Once all the atoms are in the known bucket, the connection pattern is 
! finished.
!
! The routine can be called multiple times with different structures. The final
! connection pattern will then be the union of the connection patterns of all
! structures
!
! Parameters
! =========
!
! natom               (in)  number of atoms, integer
! types   (natom)     (in)  integer array of nuclear charges
! xyz matrix(3,natom) (in)  cartesian coordiantes in AU
! nconn               (out) number of connections found
! iconn   (2,nconn)   (out) pointer to connections list
!------------------------------------------------------------------------------
! the pointer here can only be resolved by a dry routine that
! first calculates nconn and then by the same way iconn

  SUBROUTINE connect_prim(natom,maxcon,types,nconn,iconn,xyz)

    IMPLICIT NONE
! args
    INTEGER natom, nconn
    INTEGER, DIMENSION (natom) :: types
    INTEGER, POINTER, DIMENSION (:,:) :: iconn
    TYPE (matrix) :: xyz

! local vars
    LOGICAL, ALLOCATABLE, DIMENSION (:) :: lconn
    INTEGER i, ii, idum, j, jj, k, maxcon, nico
    REAL (rk) dx, dy, dz, rad, radk, rr, s1, x, y, z
    REAL (rk), ALLOCATABLE, DIMENSION (:,:) :: xcoords
    LOGICAL tmp

! begin, get coordinates and allocate temporary space
    call allocate (xcoords,3,natom)
    idum = matrix_get(xyz,3*natom,xcoords)
    !nconn = 0
    !maxcon = natom
    !allocate (iconn(2,maxcon)) ! pointer allocation done in the calling routine

! loop over primary atom i, get covalent radius and coordinates
    DO i = 1, natom
      rad = covrad(types(i))
      IF (printl>=5) WRITE (stdout,'(5x,a,i4,a,i2,a,f10.4)') 'Atom ', i, &
        ', type: ', types(i), ', radius: ', rad
      x = xcoords(1,i)
      y = xcoords(2,i)
      z = xcoords(3,i)

! loop over secondary atom k, get threshold distance
      DO k = 1, i - 1
        tmp = not_connected(i,k,iconn,nconn)
        if(.not.tmp) cycle ! they are already connected

        radk = rad + covrad(types(k))
        dx = x - xcoords(1,k)
        dy = y - xcoords(2,k)
        dz = z - xcoords(3,k)
        rr = 0.8D0*(dx*dx+dy*dy+dz*dz)

! atoms i and k are covalently bound, connect them
        IF (rr<radk*radk) THEN
          nconn = nconn + 1

! allocate more space if required
          IF (nconn>maxcon) THEN
            CALL conn_grow(iconn,maxcon,maxcon+natom,maxcon)
            maxcon = maxcon + natom
          END IF
          iconn(1,nconn) = i
          iconn(2,nconn) = k
          IF (printl>=5) WRITE (stdout,'(5x,a,i5,a,i5,a,f10.4,a,f10.4)') &
            'Covalent bond ', i, ' - ', k, ': ', sqrt(rr/0.8D0), &
            ', cov. distance: ', radk
        END IF
      END DO ! k = 1,i-1
    END DO ! i = 1,natom

! done covalent connections
! now insert connections from the branched minimum distance path

! allocate space to hold information which atom is already connected
    nico = 0
    call allocate (lconn,natom)
    DO i = 2, natom
      lconn(i) = .FALSE.
    END DO
    lconn(1) = .TRUE.

! jump here if more connections need to be made
10  CONTINUE
    s1 = -1.0D0
    DO i = 1, natom
      IF (lconn(i)) THEN
        DO j = 1, natom
          IF ( .NOT. lconn(j)) THEN
            dx = xcoords(1,i) - xcoords(1,j)
            dy = xcoords(2,i) - xcoords(2,j)
            dz = xcoords(3,i) - xcoords(3,j)
            rr = dx*dx + dy*dy + dz*dz
            IF (rr<s1 .OR. s1==-1.0D0) THEN
              s1 = rr
              jj = j
              ii = i
            END IF
          END IF ! if (.not. lconn(j))
        END DO ! j = 1,natom
      END IF ! if (lconn(i))
    END DO ! i = 1,natom

! check if shortest distance is not yet included in the connections list
    lconn(jj) = .TRUE.
    nico = nico + 1
    tmp = not_connected(ii,jj,iconn,nconn)
    IF (tmp) THEN
      IF (printl>=4) THEN
        WRITE (stdout,'(5x,a,i5,i5)') 'Adding inter fragment connction ', jj, &
          ii
      END IF
      nconn = nconn + 1

! allocate more space if required
      IF (nconn>maxcon) THEN
        CALL conn_grow(iconn,maxcon,maxcon+natom,maxcon)
        maxcon = maxcon + natom
      END IF
      iconn(1,nconn) = jj
      iconn(2,nconn) = ii
    END IF ! (not_connected (ii, jj, iconn, nconn))

! check if all done
    IF (nico/=natom-1) GO TO 10

! free flags array and tidy up size of returned memory
    call deallocate (lconn)
    CALL conn_grow(iconn,maxcon,nconn,nconn)
! maxcon reset to ensure that it is consistent with the new size of iconn
    maxcon = nconn
    call deallocate (xcoords)

  END SUBROUTINE connect_prim

!//////////////////////////////////////////////////////////////////////////////
! Used by connect_prim only: Returns covalent radius from nuclear charge
! Currently: fixed radius for all atoms of a row
!//////////////////////////////////////////////////////////////////////////////

  FUNCTION covrad(nuccg)
    IMPLICIT NONE
    REAL (rk) covrad
! args
    INTEGER nuccg
! local vars
    INTEGER i, irelem
    REAL (rk) radius
! begin
    irelem = 0
!!$    DO i = 1, ctrl%nrad
!!$      IF (ctrl%irad(i)==nuccg) irelem = i
!!$    END DO
    IF (irelem==0) THEN
      IF (nuccg<=2) THEN
        radius = 1.0D0 ! H..He
      ELSE IF (nuccg<=10) THEN
        radius = 1.6D0 ! Li..Ne
      ELSE IF (nuccg<=18) THEN
        radius = 2.5D0 ! Na..Ar
      ELSE IF (nuccg<=36) THEN
        radius = 3.0D0 ! K..Kr
      ELSE IF (nuccg<=54) THEN
        radius = 4.0D0 ! Rb..Xe
      ELSE
        radius = 5.0D0 ! Cs....
      END IF
    ELSE
!      radius = ctrl%vrad(irelem)
    END IF
    covrad = radius
  END FUNCTION covrad

!//////////////////////////////////////////////////////////////////////////////
! Used by connect_prim only: Check if ii - jj is not contained in iconn
!//////////////////////////////////////////////////////////////////////////////

  FUNCTION not_connected(ii,jj,iconn,nconn)
    IMPLICIT NONE
! retval
    LOGICAL not_connected
! args
    INTEGER ii, jj, nconn
    INTEGER iconn(2,nconn)
! local vars
    INTEGER i
! begin
    not_connected = .TRUE.
    DO i = 1, nconn
      IF ((iconn(1,i)==ii .AND. iconn(2,i)==jj) .OR. (iconn(1, &
          i)==jj .AND. iconn(2,i)==ii)) THEN
        not_connected = .FALSE.
        RETURN
      END IF
    END DO
  END FUNCTION not_connected

!//////////////////////////////////////////////////////////////////////////////
! Used by connect_prim only: Copy the connectivity into a larger list
!//////////////////////////////////////////////////////////////////////////////

  SUBROUTINE conn_grow(iconn,old_size,new_size,copy_size)
    IMPLICIT NONE
! args
    INTEGER old_size, new_size, copy_size
    INTEGER, POINTER, DIMENSION (:,:) :: iconn
! local vars
    INTEGER, POINTER, DIMENSION (:,:) :: iconn_new
    INTEGER i
! begin
    allocate (iconn_new(2,new_size)) !pointer
    DO i = 1, copy_size
      iconn_new(1,i) = iconn(1,i)
      iconn_new(2,i) = iconn(2,i)
    END DO
    DEallocate (iconn) ! pointer
    iconn => iconn_new
  END SUBROUTINE conn_grow

!//////////////////////////////////////////////////////////////////////////////
! end routines used by connect_prim
!//////////////////////////////////////////////////////////////////////////////

!------------------------------------------------------------------------------
! subroutine connect_all
!
! Alternative to connect_prim and valcoor. Every atom is connected to every
! atom. No angular coordinates required.
!
! Arguments
! natom             (in)  number of atoms, integer
! nconn             (out) number of connections found
! iconn   (2,nconn) (out) pointer to connections list
!------------------------------------------------------------------------------

  SUBROUTINE connect_all(natom,nconn,iconn)
    IMPLICIT NONE

! args
    INTEGER natom, nconn
    INTEGER, POINTER, DIMENSION (:,:) :: iconn

! local vars
    INTEGER i, j

! begin
    allocate (iconn(2,natom*(natom-1)/2)) !pointer
    nconn = 0
    DO i = 1, natom
      DO j = 1, i - 1
        nconn = nconn + 1
        iconn(1,nconn) = i
        iconn(2,nconn) = j
      END DO
    END DO
    IF (printl>=2) THEN
      WRITE (stdout,'(/,a,/)') 'Generating total connection'
      WRITE (stdout,'(5x,a,i5,a,/)') 'System has ', nconn, ' connections'
    END IF
  END SUBROUTINE connect_all

!------------------------------------------------------------------------------
! subroutine ci_conn
!
! Check in user connections and create a connections (integer) matrix. Note
! that all sequence numbers are relative to the start of the residue at exit.
!
! Arguments:
! con    int_matrix(2,*) (out) connections matrix, relative
! nconn                  (in)  number of calculated connections
! iconn  (2,nconn)       (in)  calculated connections, relative
! nincon                 (in)  number of user connections
! incon  (2,nincon)      (in)  user connections, absolute
! nat                    (in)  number of atoms in the residue
! at                     (in)  array of atom indices
!------------------------------------------------------------------------------

  SUBROUTINE ci_conn(con,nconn,iconn,nincon,incon,nat,at)
    IMPLICIT NONE

! args
    INTEGER nconn, nincon, start, finish
    INTEGER, DIMENSION (2,nconn) :: iconn
    INTEGER, DIMENSION (2,nincon) :: incon
    TYPE (int_matrix) :: con
    integer  :: nat
    integer  :: at(nat)

! local vars
    INTEGER i, j, ninres,iat
    INTEGER, DIMENSION (:,:), ALLOCATABLE :: incon_tmp
    integer :: in1,in2

! begin, allocate scratch
    call allocate (incon_tmp,2,nincon)

! check if input connections are in this residue
    ninres = 0
    DO j = 1, nincon
      in1=0
      do iat=1,nat
        if(incon(1,j)==at(iat)) in1=iat
      end do
      IF (in1>0) then
        in2=0
        do iat=1,nat
          if(incon(2,j)==at(iat)) in2=iat
        end do
        IF (in2>0) then
!!$          IF (printl>=2) THEN
!!$            WRITE (stdout,'(5x,a,i4,a,i4)') 'Adding user stretch', &
!!$              ctrl%incon(1,j), ' - ', ctrl%incon(2,j)
!!$          END IF
          ninres = ninres + 1
          incon_tmp(1,ninres) = in1
          incon_tmp(2,ninres) = in2
        ELSE
          IF (printl>=6) WRITE (stdout,'(a,i4,a,i4,a,/)') &
              'Warning: user stretch ', incon(1,j), ' - ', incon(2,j), &
              'crosses the residue boundary'
        END IF
      END IF
    END DO

! create the matrix and check in the calculated connections
    con = int_matrix_create(2,nconn+ninres,'connections')
    DO i = 1, nconn
      j = int_matrix_set_column(con,2,iconn(1:2,i),i)
    END DO

! check in the user connections
    DO i = 1, ninres
      j = int_matrix_set_column(con,2,incon_tmp(1:2,i),i+nconn)
    END DO
    call deallocate (incon_tmp)
  END SUBROUTINE ci_conn

!------------------------------------------------------------------------------
! subroutine valcoor
!
! Alexander J Turner Oct 1997
!
! This algorithm will make a fully redundant set of interanal coordinates.
! It defines rotation about bonds but not dihedral angles.
!
! The rotational orientation of atoms should be handled using
! rotation coordinates along the connection axes.
!
! Oct. 1997
! Changed to handle Quasi style matrix objects and to generate
! redundant co-ordinates. This is a derivative of valcoor.f in
! GRACE - I.H.Williams and A.J.Turner - University of Bath
! U.K. 1997
!
! June 1999
! Rewritten object and memory management - Zurich, SB
!
! On input
! ========
! natom : number of atoms
! nconn : Number of connections
! x,y,z : simple cartesian arrays
! iconn : 2 by n array - integer: column one is connected to column two
!
! On output
! ========
! ibend : 4 by nbend  - pointer to integer array
! irots : 3 by nnrots - pointer to integer array
! x,y,z,iconn - unchanged
!
! Definition of ibend and irots
! =============================
! ibend : bends are between ibend(1,i) and ibend(2,i) about ibend(3,1)
!     ibend(1,i) is zero - no bend defined
!       : linear bend ibend(1,i)-ibend(2,i)-ibend(3,i) 
!     ibend(4,i)=-2 => relative to xy plane
!     ibend(4,i)=-1 => relative to yz plane
!
! irots : Diherdal angle 1-2-3 w.r.t 2-3-4 , auto generated dihedrals
!     will either be proper or inproper 
!     *** FOR HISTORICAL REASONS - THESE ARE OFTEN REFERRED ***
!               TO AS ROTATIONS IN THIS CODE
!  
! nrots : Number of auto-dihedrals
! nbend : Number of bends
!
! Comments:
! =========
! The algorithm uses dynamic storage for valence information
! The scratch storage is in four dynamically allocated parts
!   ivale - an array giving the valence of each atom
!   ipvle - an array of pointers into ipple
!      ipple(ipvle+i-1) points to the start of the record of
!      atom numbers in the valence of atom i
!   ipple  - the array used to store
!      the atoms in an atoms valence shell, the pointers
!      stored from ipvle point into this array 
!   ipcvl  - counters for atomic valence collection
!
! Arguments:
! ==========
! See the comments to the fields of hdlc_obj (hdlclib.f90)
! in:  nconn, iconn, natom, x, y, z
! out: nbend, ibend, nrots, irots
!------------------------------------------------------------------------------

  SUBROUTINE valcoor(nconn,iconn,natom,x,y,z,nbend,ibend,nrots,irots)

    IMPLICIT NONE

! args
    INTEGER nconn, natom, nbend, nrots
    INTEGER, POINTER, DIMENSION (:,:) :: iconn
    INTEGER, pointer, DIMENSION (:,:) :: ibend
    INTEGER, POINTER, DIMENSION (:,:) :: irots
    REAL (rk), pointer, DIMENSION (:) :: x, y, z

! local vars
    LOGICAL notline,tmp
    INTEGER i, ib, ib1, ib2, ib3, icent, ileft, ip, ibp, j, k, l,jj
    INTEGER maxbend, maxrots
    INTEGER, DIMENSION (:), ALLOCATABLE :: ivale, ipvle, ipcvl, ipple, index
    REAL (rk) :: angle, tx, ty, tz, ax, ay, az, ex, ey, ez, dx, dy, dz, r

! begin
    IF (printl>=5) THEN
      WRITE (stdout,'(5X,A,/)') 'Generating primitive internal coordinates'
    END IF

! get some scratch space
    call allocate (ivale,natom)
    call allocate (ipvle,natom)
    call allocate (ipcvl,natom)

!//////////////////////////////////////////////////////////////////////////////
! compute the valence of each atom
!
! ivale stores the total valence of each atom
! ipvle(i) points to the start of the valence of atom i in ipcvl(*)
!//////////////////////////////////////////////////////////////////////////////

    DO i = 1, natom
      ivale(i) = 0
    END DO
    DO i = 1, nconn
      j = iconn(1,i)
      if (j<=0 .OR. j>natom) then
        print*,"Connection no",i
        print*,"Connection between atoms",iconn(1,i),iconn(2,i)
        print*,"Number of atoms",natom
        CALL hdlc_errflag('Error: atom of connection out of range','stop')
      end if
      ivale(j) = ivale(j) + 1
      j = iconn(2,i)
      ivale(j) = ivale(j) + 1
    END DO

! get the number of bends, ib counts the total number of valence records
    nbend = 0
    ib = 0
    DO i = 1, natom
      ib = ib + ivale(i)
      DO j = 1, ivale(i) - 1
        nbend = nbend + j
      END DO
    END DO
    maxbend = nbend
    call allocate (ipple,ib)
    allocate (ibend(4,max(maxbend,1))) ! pointer
    ipvle(1) = 1

! set pointers for valence records (formerly valcoor2)
    nbend = 0
    DO i = 2, natom
      ipvle(i) = ipvle(i-1) + ivale(i-1)
    END DO

! set counters for atomic valence collection to -1
    DO i = 1, natom
      ipcvl(i) = -1
    END DO

! record the valence atoms around each atom from connection list
    DO i = 1, nconn
      j = iconn(1,i)
      k = iconn(2,i)

! increment record counter for atom j
      ipcvl(j) = ipcvl(j) + 1

! acquire pointer to records for j
      l = ipvle(j) + ipcvl(j)

! set that element to the atom to which it is connected
      ipple(l) = k

! repeat for other atom
      j = iconn(2,i)
      k = iconn(1,i)

! increment record counter for j
      ipcvl(j) = ipcvl(j) + 1

! acquire pointer to records for j
      l = ipvle(j) + ipcvl(j)

! set that element to the atom to which it is connected
      ipple(l) = k
    END DO

! print the valence
    IF (printl>=5) THEN
      WRITE (stdout,'(5X,A,/)') 'Valence of atomic centres'
      DO i = 1, natom
        j = ipvle(i)
        k = ivale(i)
        WRITE (stdout,'(5x,A,I5,A,8(1X,I5))') 'Atom no ', i, ' has valence =', &
          (ipple(j+l),l=0,k-1)
      END DO
      WRITE (stdout,'(/)')
    END IF

!//////////////////////////////////////////////////////////////////////////////
! Generate bends
!
! Loop scanning atomic centres. It looks for bends and also puts in linear
! bends and wags etc.
!
! I scans each atom
! J scans the valence atoms around the I'th atom
! K scans the 'other' valence atoms around the I'th atom so bends are made
!
! Other variables used
!
! ib     : The number of bends allocated about a given centre
! ib1    : The valence atom from which bends are coming
! ib2    : The valence atom to which bends are going
! ib3    : The waging atom ib3 wags in plane of ib1-i-ib2
! ip     : Pointer to valence records for I'th atom
! ibp    : Pointer to the bend record that is being written 
! nbend  : Number of allocated bends in total
! maxbend: Ammount of space allocated for bends
!//////////////////////////////////////////////////////////////////////////////

    DO i = 1, natom
      ib = 0
      IF (printl>=5) THEN
        WRITE (stdout,'(7X,A,I5)') 'Scanning bends around ', i
      END IF

! pointer to start of valence info of atom i and loop through atoms j
      ip = ipvle(i)
      DO j = 1, ivale(i) - 1

! set ib1 to the atom connected to atom i from which bends are to be made
        ib1 = ipple(ip+j-1)
        IF (printl>=5) THEN
          WRITE (stdout,'(7X,A,I5)') 'Making bends from atom ', ib1
        END IF

! loop through all atoms higher in order than atom j and make bends
        DO k = j + 1, ivale(i)
          nbend = nbend + 1

! detect a potential problem in the code
          IF (nbend>maxbend) THEN
            CALL hdlc_errflag( &
              'Insufficient bends allocated in valcoor - code error','abort')
          END IF

! increment bond counter
          ib = ib + 1

! set ib2 to the atom connected to atom i to which bends are to be made
          ib2 = ipple(ip+k-1)

! ibp is a pointer to the present bend record: make bend
          ibp = nbend
          ibend(1,ibp) = ib1
          ibend(2,ibp) = i
          ibend(3,ibp) = ib2
          ibend(4,ibp) = 0

!//////////////////////////////////////////////////////////////////////////////
! check for linearity
!//////////////////////////////////////////////////////////////////////////////

          angle = vangled(x(ib1),x(i),x(ib2),y(ib1),y(i),y(ib2),z(ib1),z(i), &
            z(ib2))
          IF (printl>=5) THEN
            WRITE (stdout,'(7X,A5,I5,A2,3I5,A8,F12.7)') 'Bend ', nbend, ': ', &
              ib1, i, ib2, ' angle: ', angle
          END IF

! make an l_function if the centre is bi-valent & > 179 deg
          IF (angle>=175.0D0) THEN
            IF (ivale(i)==2) THEN
              IF (printl>=4) THEN
                WRITE (stdout,'(7X,A,I5)') 'Making linear about ', i
              END IF

! test linear function for being perp to xy plane:
! translate one point in z
! take angle between point and other two points
! must be 5<angle<175 or yz plane signaled (istra(nline,4)=-1)

              angle = vangled(x(ib1),x(ib2),x(ib2),y(ib1),y(ib2),y(ib2), &
                z(ib1),z(ib2),z(ib2)+1.0D0)
              IF (printl>=5) THEN
                WRITE (stdout,'(7X,A,F8.3)') 'Tester angle = ', angle
              END IF
              IF (angle<=5.0D0 .OR. angle>=175.0D0) THEN
                ibend(4,ibp) = -2
              ELSE
                ibend(4,ibp) = -1
              END IF

! note: removed if (.not.internal) then (remove the bend) endif
            ELSE ! if (ivale(i).eq.2) then ...
              IF (printl>=5) WRITE (stdout,'(7X,A)') &
                'Bend ignored, linear non bivalent'
              ibend(1,ibp) = 0
              nbend = nbend - 1
            END IF ! if (ivale(i).eq.2) then ... else
          END IF ! if (angle.ge.175.0D0)
        END DO ! do k=j+1,ivale(i)
      END DO ! do j = 1,ivale(i)-1

!//////////////////////////////////////////////////////////////////////////////
! check for planar systems
!//////////////////////////////////////////////////////////////////////////////

      IF (ivale(i)>2) THEN

! acquire pointer to start of valence info for this atom
        ip = ipvle(i)
        tx = 1.0D0
        ty = 1.0D0
        tz = 1.0D0

! loop through all valence atoms dotting the perps to the normalised vectors
        DO j = 1, ivale(i) - 1

! set ib1 to the atom connected to atom i from which bends are to be made
          ib1 = ipple(ip+j-1)
          ax = x(ib1) - x(i)
          ay = y(ib1) - y(i)
          az = z(ib1) - z(i)
          r = sqrt(ax*ax+ay*ay+az*az)
          ax = ax/r
          ay = ay/r
          az = az/r
          ib1 = ipple(ip+j)
          ex = x(ib1) - x(i)
          ey = y(ib1) - y(i)
          ez = z(ib1) - z(i)
          r = sqrt(ex*ex+ey*ey+ez*ez)
          ex = ex/r
          ey = ey/r
          ez = ez/r
          dx = (ay*ez-az*ey)
          dy = (az*ex-ax*ez)
          dz = (ax*ey-ay*ex)
          r = sqrt(dx*dx+dy*dy+dz*dz)
          tx = tx*dx/r
          ty = ty*dy/r
          tz = tz*dz/r
        END DO
        IF (printl>=5) THEN
          WRITE (stdout,'(7X,A,I5,A,F12.8)') 'Dot-product about ', i, ' is ', &
            tx + ty + tz
        END IF

! if dot greater than 5% off 1 put in dihedral instead of bend
        IF (abs(tx+ty+tz)>0.95D0) THEN
          IF (printl>=4) THEN
            WRITE (stdout,'(7X,A)') 'System near planar - making improper'
          END IF

! construct improper from last bend - i.e. nbend
          k = -1
          DO j = 1, ivale(i)
            ib1 = ipple(ip+j-1)
            IF (ib1/=ibend(1,nbend) .AND. ib1/=ibend(3,nbend)) k = ib1
          END DO
          IF (k==-1) THEN
            CALL hdlc_errflag('Failed to contruct internals','abort')
          END IF
          ibend(4,nbend) = k

! swap 1 and 3 if 2-3-4 is co-linear
          dx = x(ibend(2,nbend)) - x(ibend(3,nbend))
          dy = y(ibend(2,nbend)) - y(ibend(3,nbend))
          dz = z(ibend(2,nbend)) - z(ibend(3,nbend))
          r = sqrt(dx*dx+dy*dy+dz*dz)
          tx = dx/r
          ty = dy/r
          tz = dz/r
          dx = x(ibend(3,nbend)) - x(ibend(4,nbend))
          dy = y(ibend(3,nbend)) - y(ibend(4,nbend))
          dz = z(ibend(3,nbend)) - z(ibend(4,nbend))
          r = sqrt(dx*dx+dy*dy+dz*dz)
          tx = tx*dx/r
          ty = ty*dy/r
          tz = tz*dz/r
          IF (tx+ty+tz>0.095D0) THEN
            k = ibend(3,nbend)
            ibend(3,nbend) = ibend(1,nbend)
            ibend(1,nbend) = k
          END IF
        END IF ! (abs(tx+ty+tz).gt.0.95D0)
      END IF ! (ivale(i).gt.2)
    END DO ! i = 1,natom (end of valcoor2)

!//////////////////////////////////////////////////////////////////////////////
! generate dihedrals and improper dihedrals
!//////////////////////////////////////////////////////////////////////////////

! initialise (formerly valcoor3)
    call deallocate (ipple)
    call allocate (index,natom)
    maxrots = nbend*3
    allocate (irots(4,max(1,maxrots))) !pointer
    IF (printl>=6) WRITE (stdout,'(7X,A,I5)') 'Guessing maxrots at ', &
      maxrots
    DO i = 1, natom
      index(i) = -1
    END DO

! set index(i) to point to records of bends about i
    k = 0
    DO i = 1, nbend
      IF (ibend(2,i)/=k) THEN
        k = ibend(2,i)
        IF (ibend(1,i)/=0) index(k) = i
      END IF
    END DO

! sort all bends so if one end is univalent and the other bivalent, the
! bivalent is the far end
    DO i = 1, nbend
      IF (index(ibend(3,i))==-1 .AND. ibend(4,i)>=0) THEN
        k = ibend(3,i)
        ibend(3,i) = ibend(1,i)
        ibend(1,i) = k
      END IF
    END DO
    DO i = 1, natom
      index(i) = -1
    END DO
    k = -1
    DO i = 1, nbend
      IF (ibend(2,i)/=k) THEN
        k = ibend(2,i)
        IF (ibend(1,i)/=0) index(k) = i
      END IF
    END DO

! main loop through bends constructing dihedrals
    nrots = 0
    DO i = 1, nbend
      IF (ibend(4,i)<0) GO TO 300 ! skip if linear
!WT write (stdout,'(1X,A,2I5)') ' nbend,i ', nbend,i

! flag this is a new bend and not due to expansion of a dihedral
      notline = .TRUE.

! k points to the bend record of the far end of bend i
      ileft = ibend(2,i)
      icent = ibend(3,i)
      k = index(icent)

! follow linears until a real bend (loop point for a 'do until' type loop)
100   CONTINUE

! if the atom ibend(3,i) is univalent, you cannot make a dihedral -> break
      IF (k==-1) GO TO 300

! expand the dihedral (follow the bond) if atom is linear bivalent
      IF (ibend(4,k)<0) THEN

! test for three membered ring, break if found
        IF ((ibend(3,i)==ibend(3,k) .OR. ibend(1,i)==ibend(1,k) .OR. ibend(1, &
          i)==ibend(3,k) .OR. ibend(3,i)==ibend(1,k)) .AND. notline) GO TO 300
        notline = .FALSE.

! test which way around the bend is
        ileft = ibend(2,k)
        IF (ileft/=max(ibend(1,k),ibend(3,k))) THEN
          icent = max(ibend(1,k),ibend(3,k))
          k = index(icent)
          GO TO 100
        ELSE
          icent = min(ibend(1,k),ibend(3,k))
          k = index(icent)
          GO TO 100
        END IF
      END IF ! (ibend(4,k).lt.0)

! cycle over all bends around icent
      DO WHILE (ibend(2,k)==icent)

! test for three membered ring, break if found
        IF ((ibend(3,i)==ibend(3,k) .OR. ibend(1,i)==ibend(1,k) .OR. ibend(1, &
          i)==ibend(3,k) .OR. ibend(3,i)==ibend(1,k)) .AND. notline) GO TO 300

! test added by Martin Graf
! test for identical central atom on creating dihedral MG
        IF (ibend(2,k)==ibend(2,i)) GO TO 300

        ! test added by Johannes Kaestner >>>>
        ! Do not include dihedral if one of its center atoms is part of an
        ! improper
        ! Have to remove it as it leads to an underdetermined system if
        ! not all atoms next to the planar atom are monovalent.
!!$        tmp=.false.
!!$        do jj=1,nbend
!!$          if(ibend(4,jj)<=0) cycle
!!$          if(ibend(2,jj)==ibend(3,i).or. &
!!$              ibend(2,jj)==ibend(2,i)) then
!!$            tmp=.true.
!!$            if(printl>=6) write(stdout,'("Deleting Dihedral due to &
!!$                &overlay with improper")')
!!$          end if
!!$        end do
!!$        if(tmp) go to 300
        ! <<<< JK

! test if bend k is valid and matching bend i
        IF (ibend(1,k)/=0 .AND. ibend(4,k)==0 .AND. (ibend(1, &
            k)==ileft .OR. ibend(3,k)==ileft)) THEN
          nrots = nrots + 1

! allocate more space if required
          IF (nrots>maxrots) THEN
            CALL rots_grow(irots,maxrots,maxrots+nbend*9,maxrots)
            maxrots = maxrots + nbend*9
          END IF

! store the dihedral (formerly valcoor4)
          IF (ibend(1,k)==ileft) THEN
            irots(4,nrots) = ibend(3,k)
          ELSE
            irots(4,nrots) = ibend(1,k)
          END IF
          DO j = 1, 3
            irots(j,nrots) = ibend(j,i)
          END DO

! to ensure identical dihedrals are not included
          DO j = 1, nrots - 1
            IF (irots(1,j)==irots(4,nrots)) THEN
              IF (irots(2,j)==irots(3,nrots) .AND. irots(3,j)==irots(2,nrots)) &
                  THEN
                nrots = nrots - 1
              END IF
            END IF
          END DO
        END IF ! valid and matching bend

! end cycle over all bends around icent
        k = k + 1
        IF (k>maxbend) EXIT
      END DO ! WHILE (ibend(2,k)==icent)

! Added by Johannes Kaestner (JK):
! try the first atom of ibend(:,i). This is necessary in special cases, like
! \|   |/
! -4   3-
!   \ /
!    1
!    |
!    2
!   / \
! -5   6-
! /|   |\
! Try it out with linear molecules! It may cause problems there.
      if(icent==ibend(3,i)) then
        ileft=ibend(2,i)
        icent=ibend(1,i)
        k = index(icent)
        go to 100
      end if
! end of addtion by JK

! loss of indentation due to end of loop to 200
300   CONTINUE
    END DO ! do i = 1,nbend (end of valcoor3)

! deallocate scratch space
    call deallocate (ivale)
    call deallocate (ipvle)
    call deallocate (ipcvl)
    call deallocate (index)

  END SUBROUTINE valcoor

!//////////////////////////////////////////////////////////////////////////////
! Copy the torsions list into a larger list
! Also used by ck_angle_cons if extra torsion/bond angle primitives are needed
!//////////////////////////////////////////////////////////////////////////////

  SUBROUTINE rots_grow(irots,old_size,new_size,copy_size)
    IMPLICIT NONE
! args
    INTEGER old_size, new_size, copy_size
    INTEGER, POINTER, DIMENSION (:,:) :: irots
! local vars
    INTEGER, POINTER, DIMENSION (:,:) :: irots_new
    INTEGER i
! begin
    allocate (irots_new(4,new_size)) !pointer
    DO i = 1, copy_size
      irots_new(1,i) = irots(1,i)
      irots_new(2,i) = irots(2,i)
      irots_new(3,i) = irots(3,i)
      irots_new(4,i) = irots(4,i)
    END DO
    deallocate (irots) !pointer
    irots => irots_new
  END SUBROUTINE rots_grow

!//////////////////////////////////////////////////////////////////////////////
! end routines used by valcoor
!//////////////////////////////////////////////////////////////////////////////

!------------------------------------------------------------------------------
! subroutine valcoor_print
!
! Arguments:
! See the comments to the fields of hdlc_obj (hdlclib.f90)
! in:  nconn, iconn, natom, x, y, z, nbend, ibend, nrots, irots
!------------------------------------------------------------------------------

  SUBROUTINE valcoor_print(nconn,iconn,nbend,ibend,nrots,irots,x,y,z,natom)
    IMPLICIT NONE

! args
    INTEGER nconn, nbend, nrots, natom
    INTEGER iconn(2,nconn), ibend(4,nbend), irots(4,nrots)
    REAL (rk) :: x(natom), y(natom), z(natom)

! local vars
    INTEGER i, j, k
    REAL (rk) :: dx, dy, dz, r

! begin
    IF (printl>=4) THEN
      WRITE (stdout,'(/,3X,A)') 'The Cartesian coordinates'
      DO i = 1, natom
        WRITE (stdout,'(5X,I5,1X,F20.14,1X,F20.14,1X,F20.14)') i, x(i), y(i), &
          z(i)
      END DO
    END IF

    IF (printl>=4) THEN
      write (stdout,'(/,3X,A)') 'The primitive internal coordinates'
      k = 0

      IF (printl>=4) WRITE (stdout,'(/)')
      write (stdout,'(5X,A,I5,A)') 'The system has ', nconn, ' stretches'
      IF (printl>=4) THEN
        DO i = 1, nconn
          k = k + 1
          dx = x(iconn(1,i)) - x(iconn(2,i))
          dy = y(iconn(1,i)) - y(iconn(2,i))
          dz = z(iconn(1,i)) - z(iconn(2,i))
          r = sqrt(dx*dx+dy*dy+dz*dz)
          write (stdout,'(5X,i5,A,2(I5,1X),12X,A,F13.8)') k, ' Stre ', &
              (iconn(j,i), j=1,2), ' = ', r
        END DO
        WRITE (stdout,'(/)')
      END IF ! (printl.ge.2)

      write (stdout,'(5X,A,I5,A)') 'The system has ', nbend, &
          ' bends and impropers'
      IF (printl>=4) THEN
        DO i = 1, nbend
          k = k + 1
          IF (ibend(4,i)==0) THEN
            r = vangled(x(ibend(1,i)),x(ibend(2,i)),x(ibend(3,i)),y(ibend(1, &
              i)),y(ibend(2,i)),y(ibend(3,i)),z(ibend(1,i)),z(ibend(2, &
              i)),z(ibend(3,i)))
            write (stdout,'(5X,I5,A,3(I5,1X),6X,A,F13.8,a,f13.8)') k, ' Bend ', &
                (ibend(j,i), j=1,3), ' = ', r,' deg = ',r*pi/180.D0
          ELSE IF (ibend(4,i)==-1) THEN
            write (stdout,'(5X,I5,A,3(I5,1X),A)') k, ' Line ', &
                (ibend(j,i), j=1,3), ' wrt xy'
          ELSE IF (ibend(4,i)==-2) THEN
            write (stdout,'(5X,I5,A,3(I5,1X),A)') k, ' Line ', &
                (ibend(j,i), j=1,3), ' wrt yz'
          ELSE
            r = vdihedrald(x(ibend(1,i)),y(ibend(1,i)),z(ibend(1, &
              i)),x(ibend(2,i)),y(ibend(2,i)),z(ibend(2,i)),x(ibend(3, &
              i)),y(ibend(3,i)),z(ibend(3,i)),x(ibend(4,i)),y(ibend(4, &
              i)),z(ibend(4,i)))
            WRITE (stdout,'(5X,I5,A,4(I5,1X),A,F13.8,a,f13.8)') k, ' Impr ', &
              (ibend(j,i),j=1,4), ' = ', r,' deg = ',r*pi/180.D0
          END IF ! (ibend(4,i).eq.0)
        END DO ! i = 1,nbend
        WRITE (stdout,'(/)')
      END IF ! (printl.ge.2)

      write (stdout,'(5X,A,I5,A)') 'The system has ', nrots, ' dihedrals'
      IF (printl>=4) THEN
        DO i = 1, nrots
          k = k + 1
          r = vdihedrald(x(irots(1,i)),y(irots(1,i)),z(irots(1,i)),x(irots(2, &
            i)),y(irots(2,i)),z(irots(2,i)),x(irots(3,i)),y(irots(3, &
            i)),z(irots(3,i)),x(irots(4,i)),y(irots(4,i)),z(irots(4,i)))
          write (stdout,'(5X,I5,A,4(I5,1X),A,F13.8,a,f13.8)') k, ' Dihe ', &
              (irots(j,i), j=1,4), ' = ', r,' deg = ',r*pi/180.D0
        END DO
        WRITE (stdout,'(/)')
      END IF ! (printl.ge.2)
    END IF ! (printl.gt.1)
    CALL dlf_flushout()
  END SUBROUTINE valcoor_print

!------------------------------------------------------------------------------
! Utilities by Alex Turner (originally dlc_angle_utils)
!------------------------------------------------------------------------------

  SUBROUTINE rots_dlc(noint,ii,b,ib,c)
!
! Alexander J Turner
!
! Diagram:
!
!   p
!   |\ A
! C | \
!   s--q-----r
!    D   E
!
!  What it does:
!
! Computes the cartesian force on  A
! given a unit moment about axis   E
!
! It is intended for the generation of B matrix elements
!
! Method:
!
! Force on p is perpendicular to plane r,q,p
! Force on p is proportional to |C|
!
! C = A - (A.E x E/|E|)
!
! Direction perpendicular to p = ((AyEz-AzEy),(AzEx-AxEz),(AxEy-AyEx))
! Call this vector Z
!
! P.S. The use of case in this subroutine is just for human reading
!      Uppercase => vector , lowercase => scalar or point
!
    IMPLICIT NONE
    INTEGER i, ib(4,*), iaind, jaind, kaind, m
    INTEGER noint, ii
!
    REAL (rk) :: b(3,4,*), c(*), dzero, done, eps
    REAL (rk) :: dx, dy, dz
    REAL (rk) :: ex, ey, ez
    REAL (rk) :: tx, ty, tz
    REAL (rk) :: ax, ay, az
    REAL (rk) :: cx, cy, cz
    REAL (rk) :: zx, zy, zz
    REAL (rk) :: magae, mage, fact, magc
    PARAMETER (eps=1.0D-6)
!
    DATA dzero/0.0D0/, done/1.0D0/
!
! Set up position in B matrix pointers
! Zero bmat for premeture return
!
    ib(1,noint) = ii
    ib(2,noint) = 0
    ib(3,noint) = 0
    ib(4,noint) = 0
    b(1,1,noint) = dzero
    b(2,1,noint) = dzero
    b(3,1,noint) = dzero
!
! Get Vectors
!
    ex = c(4) - c(7)
    ey = c(5) - c(8)
    ez = c(6) - c(9)

    ax = c(1) - c(4)
    ay = c(2) - c(5)
    az = c(3) - c(6)
!
! Get A.E / |E|
!
    mage = sqrt(ex*ex+ey*ey+ez*ez)
    magae = ax*ex + ay*ey + az*ez
    fact = -1.0D0*magae/mage
!
! If E is small - return nothing
!
    IF (abs(mage)<eps) RETURN
!
! Scale E by factor
!
    tx = ex*fact
    ty = ey*fact
    tz = ez*fact
!
! Get C
!
    cx = ax - tx
    cy = ay - ty
    cz = az - tz
!
! Get magnitude of C - and thus force
!
    magc = sqrt(cx*cx+cy*cy+cz*cz)
!
! If C is small - angle linear - zero force, or numerical problems can occur
!
    IF (magc<eps) RETURN
!
! Get Z
!
    zx = (ay*ez-az*ey)
    zy = (az*ex-ax*ez)
    zz = (ax*ey-ay*ex)
!
! Normalise and times by magC
!
    fact = magc/sqrt(zx*zx+zy*zy+zz*zz)
    zx = zx*fact
    zy = zy*fact
    zz = zz*fact
!
! Put it into B
!
    b(1,1,noint) = zx
    b(2,1,noint) = zy
    b(3,1,noint) = zz
!
! All done
!
    RETURN
  END SUBROUTINE rots_dlc
!
! ------------------------------------------------------------
!
  FUNCTION dlc_free_rot(pxa,pxb,pxc,pya,pyb,pyc,pza,pzb,pzc,poxa,poxb,poxc, &
      poya,poyb,poyc,poza,pozb,pozc)
    IMPLICIT NONE
    REAL (rk) :: dlc_free_rot
!
! Alexander J Turner
! Feb 1998
!
! Compute the magnitude of the rotation of an atom about the axis of a bond,
! given that the vector of the bond is constant
!
    REAL (rk) :: xa, xb, xc, ya, yb, yc, za, zb, zc, oxa, oxb, oxc, oya, oyb, &
      oyc, oza, ozb, ozc, dx, dy, dz, s, pxa, pya, pza, pxb, pyb, pzb, pxc, &
      pyc, pzc, poxa, poya, poza, poxb, poyb, pozb, poxc, poyc, pozc
    REAL (rk) :: dzero, theta1, theta2, theta3, theta4
    PARAMETER (dzero=0.0D0)

!
! Move by refernece pxa ... to by value oxa ....
!
    xa = pxa
    xb = pxb
    xc = pxc
    ya = pya
    yb = pyb
    yc = pyc
    za = pza
    zb = pzb
    zc = pzc
    oxa = poxa
    oxb = poxb
    oxc = poxc
    oya = poya
    oyb = poyb
    oyc = poyc
    oza = poza
    ozb = pozb
    ozc = pozc
!
! move A,B,C by B->origin
!
    dx = -oxb
    dy = -oyb
    dz = -ozb

    oxa = oxa - dx
    oya = oya - dy
    oza = oza - dz

    oxc = oxc - dx
    oyc = oyc - dy
    ozc = ozc - dz

    oxb = dzero
    oyb = dzero
    oyb = dzero

    xa = xa - dx
    ya = ya - dy
    za = za - dz

    xc = xc - dx
    yc = yc - dy
    zc = zc - dz

    xb = dzero
    yb = dzero
    yb = dzero
!
! Translate A' B'->C'
!
! oxa=oxa-xc
! oya=oya-yc
! oza=oza-zc
!
    dlc_free_rot = -vdihedral(xa,ya,za,oxc,oyc,ozc,oxb,oyb,ozb,oxa,oya,oza)
!      if(abs(dlc_free_rot).gt.1.0d-1) then
!         write(stdout,*)
!         write(stdout,*)'Dihed ',dlc_free_rot
!         write(stdout,*)'XY Theta: ',theta1
!         write(stdout,*)'XZ Theta: ',theta2
!         write(stdout,*)'Old c ',oxc,oyc,ozc
!         write(stdout,*)'New c',xc,yc,zc
!         write(stdout,*)'Old b ',oxb,oyb,ozb
!         write(stdout,*)'New b',xb,yb,zb
!         write(stdout,*)'Old a ',oxa,oya,oza
!         write(stdout,*)'New a',xa,ya,za
!      endif
!
    RETURN
  END FUNCTION dlc_free_rot
!
! ------------------------------------------------------------
!
  FUNCTION vdihedral(xi,yi,zi,xj,yj,zj,xk,yk,zk,xl,yl,zl)
    IMPLICIT NONE
    REAL (rk) :: vdihedral
    REAL (rk) :: xi, yi, zi, xj, yj, zj, xk, yk, zk, xl, yl, zl
    REAL (rk) :: fx, fy, fz, fr2, fr, hx, hy, hz, hr2, hr, ex, ey, ez, er2, er
    REAL (rk) :: rik, th1, th2, th3, phi, gx, gy, gz, gr2, gr, grr, gxr, gyr, &
      gzr
    REAL (rk) :: frr, fxr, fyr, fzr, cst, hrr, hxr, hyr, hzr, err, exr, eyr, &
      ezr
    REAL (rk) :: ax, ay, az, bx, by, bz, ra2, rb2, ra, rb, rar, rbr, axr, ayr, &
      azr
    REAL (rk) :: bxr, byr, bzr, cx, cy, cz
    REAL (rk) :: cut, one
    PARAMETER (cut=1.0D-8)
    PARAMETER (one=1.0D0)

    vdihedral = 0.0D0
!
! BOND DISTANCES
!
    fx = xi - xj
    fy = yi - yj
    fz = zi - zj
    fr2 = fx*fx + fy*fy + fz*fz
    IF (fr2<cut) RETURN
!
    hx = xl - xk
    hy = yl - yk
    hz = zl - zk
    hr2 = hx*hx + hy*hy + hz*hz
    IF (hr2<cut) RETURN
!
    ex = xi - xk
    ey = yi - yk
    ez = zi - zk
    er2 = ex*ex + ey*ey + ez*ez
    IF (er2<cut) RETURN
!
    gx = xj - xk
    gy = yj - yk
    gz = zj - zk
    gr2 = gx*gx + gy*gy + gz*gz
    IF (gr2<cut) RETURN
!
! DIHEDRAL VALUES
!
! AX perp to F-G
! BX perp to H-G
!
    ax = fy*gz - fz*gy
    ay = fz*gx - fx*gz
    az = fx*gy - fy*gx
    bx = hy*gz - hz*gy
    by = hz*gx - hx*gz
    bz = hx*gy - hy*gx
!
    ra2 = ax*ax + ay*ay + az*az
    rb2 = bx*bx + by*by + bz*bz
    ra = sqrt(ra2)
    rb = sqrt(rb2)
    IF (ra<=0.01D0) THEN
!      write(stdout,'(a)')'Warning: Dihedral near linear'
!      write(stdout,'(4(x,g13.5))')xi,yi,zi
!      write(stdout,'(4(x,g13.5))')xj,yj,zj
!      write(stdout,'(4(x,g13.5))')xk,yk,zk
!      write(stdout,'(4(x,g13.5))')xl,yl,zl
!      RA=0.01D0
      RETURN
    END IF
    rar = 1.0D0/ra
    IF (rb<=0.01D0) THEN
!       write(stdout,'(a)')'Warning: Dihedral near linear'
!       RB=0.01D0
      RETURN
    END IF
    rbr = 1.0D0/rb
!
! Normalise
!
    axr = ax*rar
    ayr = ay*rar
    azr = az*rar
    bxr = bx*rbr
    byr = by*rbr
    bzr = bz*rbr
!
    cst = axr*bxr + ayr*byr + azr*bzr
    IF (abs(cst)>=1.0D0) cst = sign(one,cst)
    phi = acos(cst)
    cx = ayr*bzr - azr*byr
    cy = azr*bxr - axr*bzr
    cz = axr*byr - ayr*bxr
    IF (gx*cx+gy*cy+gz*cz>0.0D0) phi = -phi
    vdihedral = phi
!   vdihedral=0.0D0
!   write(stdout,*)phi
  END FUNCTION vdihedral
!
! ------------------------------------------------------------
!
  FUNCTION vangled(x1,x2,x3,y1,y2,y3,z1,z2,z3)
    IMPLICIT NONE
    REAL (rk) :: vangled
    REAL (rk) :: d21, d23, d13
    REAL (rk) :: x1, x2, x3, y1, y2, y3, z1, z2, z3
    REAL (rk) :: two, eps, sd21, sd23, sd13

    PARAMETER (two=2.0D0)
    PARAMETER (eps=1.0D-6)
!
! Alexander J Turner - June 1997
! Used by valence, it returns the angle 1 and 3 about 2
! by cosine law in degrees
!
    d21 = (x1-x2)**two + (y1-y2)**two + (z1-z2)**two
    d23 = (x3-x2)**two + (y3-y2)**two + (z3-z2)**two
    d13 = (x1-x3)**two + (y1-y3)**two + (z1-z3)**two
!
! Allow for angle near 0 deg not causing numerical problems
!
    IF (d21<eps .OR. d23<eps .OR. d21<eps) THEN
      vangled = 0.0D0
      RETURN
    END IF
!
! Allow for angle near 180 deg not causing numberical problems
!
    sd21 = sqrt(d21)
    sd23 = sqrt(d23)
    sd13 = sqrt(d13)
!
    IF (abs(sd13-sd21-sd23)<eps) THEN
      vangled = 180.0D0
    ELSE
      vangled = 180.D0/pi*acos((d21+d23-d13)/(2.0D0*sd21*sd23))
    END IF
!
    RETURN
  END FUNCTION vangled
!
! ------------------------------------------------------------
!
  FUNCTION vangle(x1,x2,x3,y1,y2,y3,z1,z2,z3)
    IMPLICIT NONE
    REAL (rk) :: vangle
    REAL (rk) :: x1, x2, x3, y1, y2, y3, z1, z2, z3
!
    vangle = vangled(x1,x2,x3,y1,y2,y3,z1,z2,z3)
    vangle = vangle*pi/180.D0
    RETURN
  END FUNCTION vangle
!
! ------------------------------------------------------------
!
  FUNCTION vdihedrald(xi,yi,zi,xj,yj,zj,xk,yk,zk,xl,yl,zl)
    IMPLICIT NONE
    REAL (rk) vdihedrald
    REAL (rk) :: xi, yi, zi, xj, yj, zj, xk, yk, zk, xl, yl, zl

    vdihedrald = vdihedral(xi,yi,zi,xj,yj,zj,xk,yk,zk,xl,yl,zl)
    vdihedrald = vdihedrald*180.D0/pi
    RETURN
  END FUNCTION vdihedrald
END MODULE dlfhdlc_primitive

! dummy module to draw potential energy surfaces ...
! uses an analytic function and writes a povray surface consisting of
! smooth triangles
! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dl_find(nvar)
  ! called dl_find even though it does not find anything ...
  use dlf_parameter_module
  implicit none
  integer   ,intent(in)    :: nvar
  !
  real(rk)  :: coords(nvar),gradient(nvar),energy
  real(8)             :: xstart,xend,ystart,yend,del
  integer(4)          :: nx,ny,ix,iy,status
  real(8)   ,allocatable :: func(:,:,:),nvec(:,:,:)
  real(8)             :: xv,yv,svar,svar2,point3(9),nvec3(9),e1,e2
  integer(4)          :: iunit
! **********************************************************************
  if(nvar.ne.2) then
    print*,"Erorr: drawing is only possible in 2 dimensions!"
    call dlf_error
  end if

!!$  coords(1)=-0.822D0
!!$  coords(2)=0.624D0
!!$  call dlf_get_gradient(nvar,coords,energy,gradient,status)
!!$  print*,"energy",energy
!!$  return
  

  xstart=-1.5D0
  xend=   1.5D0
  ystart=-0.5D0
  yend=   2.0D0
  nx=30
  ny=30

  allocate(func(3,nx,ny))
  allocate(nvec(3,nx,ny))

  ! DEfine function grid
  func(:,:,:)=0.D0
  do ix=1,nx
    xv=xstart+dble(ix-2)/dble(nx-3)*(xend-xstart)
    do iy=1,ny
      yv=ystart+dble(iy-2)/dble(ny-3)*(yend-ystart)
      func(1,ix,iy)=xv
      func(2,ix,iy)=yv
    end do
  end do

  ! define function
  do ix=1,nx
    do iy=1,ny
      coords=func(1:2,ix,iy)
      call dlf_get_gradient(nvar,coords,energy,gradient,status)
      if(status/=0) call dlf_error()
      func(3,ix,iy)=min(energy,2.D0)
      !write(*,'("x,y,func",2f10.5,3es15.7)') func(1:3,ix,iy),gradient
    end do
  end do

  print*,"Maximum:",maxval(func(3,:,:))
  print*,"Minimum:",minval(func(3,:,:))
  
  call normalvecotrs(nx,ny,func,nvec)

  iunit=12
  open(unit=iunit,file="surface.inc")
  do ix=2,nx-2
    do iy=2,ny-2
      point3(1:3)=func(:,ix,iy)
      nvec3(1:3) =nvec(:,ix,iy)
      point3(4:6)=func(:,ix,iy+1)
      nvec3(4:6) =nvec(:,ix,iy+1)
      point3(7:9)=func(:,ix+1,iy+1)
      nvec3(7:9) =nvec(:,ix+1,iy+1)
      call WRITE_POV_SMOOTHTRIANGLE(Iunit,POINT3,NVEC3)
      point3(1:3)=func(:,ix,iy)
      nvec3(1:3) =nvec(:,ix,iy)
      point3(4:6)=func(:,ix+1,iy)
      nvec3(4:6) =nvec(:,ix+1,iy)
      point3(7:9)=func(:,ix+1,iy+1)
      nvec3(7:9) =nvec(:,ix+1,iy+1)
      call WRITE_POV_SMOOTHTRIANGLE(Iunit,POINT3,NVEC3)
    end do
  end do
  close(iunit)

  deallocate(func)
  deallocate(nvec)

end subroutine dl_find

! HELPER ROUTINES TO DRAW FUNCTIONS ...

subroutine normalvecotrs(nx,ny,func,nvec)
  implicit none
  integer(4)      ,intent(in) :: nx,ny
  real(8)         ,intent(in) :: func(3,nx,ny)
  real(8)         ,intent(out):: nvec(3,nx,ny)
  integer(4)                  :: ix,iy
  real(8)                     :: v1(3),v2(3),v3(3),v4(3),v5(3),v6(3),v7(3),v8(3),vp(3)
  real(8)                     :: svar
! **********************************************************************
  do ix=2,nx-1
    do iy=2,ny-1
      v1=func(:,ix+1,iy+1)-func(:,ix,iy)
      v2=func(:,ix+1,iy  )-func(:,ix,iy)
      v3=func(:,ix+1,iy-1)-func(:,ix,iy)
      v4=func(:,ix  ,iy-1)-func(:,ix,iy)
      v5=func(:,ix-1,iy-1)-func(:,ix,iy)
      v6=func(:,ix-1,iy  )-func(:,ix,iy)
      v7=func(:,ix-1,iy+1)-func(:,ix,iy)
      v8=func(:,ix  ,iy+1)-func(:,ix,iy)

      call crossproduct(v1,v2,vp)
      nvec(:,ix,iy)=nvec(:,ix,iy)+vp
      call crossproduct(v2,v3,vp)
      nvec(:,ix,iy)=nvec(:,ix,iy)+vp
      call crossproduct(v3,v4,vp)
      nvec(:,ix,iy)=nvec(:,ix,iy)+vp
      call crossproduct(v4,v5,vp)
      nvec(:,ix,iy)=nvec(:,ix,iy)+vp
      call crossproduct(v5,v6,vp)
      nvec(:,ix,iy)=nvec(:,ix,iy)+vp
      call crossproduct(v6,v7,vp)
      nvec(:,ix,iy)=nvec(:,ix,iy)+vp
      call crossproduct(v7,v8,vp)
      nvec(:,ix,iy)=nvec(:,ix,iy)+vp
      call crossproduct(v8,v1,vp)
      nvec(:,ix,iy)=nvec(:,ix,iy)+vp

      svar=sqrt(sum(nvec(:,ix,iy)**2))
      nvec(:,ix,iy)=nvec(:,ix,iy)/svar
    end do
  end do
end subroutine normalvecotrs


! ......................................................................
SUBROUTINE WRITE_POV_SMOOTHTRIANGLE(IFILE,POINT,NVEC)
! USE THE XYZ POINTS AND NORMAL VECTORS TO WRITE TRIANGLES   
  IMPLICIT NONE
  INTEGER(4)  ,INTENT(IN)   :: IFILE
  REAL(8)     ,INTENT(IN)   :: POINT(9)
  REAL(8)     ,INTENT(IN)   :: NVEC(9)
  REAL(8)                   :: NL(3),V1(3),V2(3),svar
!  INTEGER(4)                :: I
! **********************************************************************
! CALCULATE REAL NORMAL VECTOR OF THE TRIANGLE

  V1=POINT(1:3)-POINT(7:9)
  V2=POINT(1:3)-POINT(4:6)
  CALL CROSSPRODUCT(V2,V1,NL)

! write the energy in Y-direction  
  write(ifile,"('smooth_triangle{<',f9.4,',',f9.4,',',f9.4,'>, ')") &
      point(1),point(3),point(2)
  svar=sum(nvec(1:3)*nl)
  if(svar.gt.0.D0) then
    write(ifile,"('                <',f9.4,',',f9.4,',',f9.4,'>, ')") &
        nvec(1),nvec(3),nvec(2)
  else
    write(ifile,"('                <',f9.4,',',f9.4,',',f9.4,'>, ')") &
        -nvec(1),-nvec(3),-nvec(2)
  end if

  write(ifile,"('                <',f9.4,',',f9.4,',',f9.4,'>, ')") &
      point(4),point(6),point(5)
  svar=sum(nvec(4:6)*nl)
  if(svar.gt.0.D0) then
    write(ifile,"('                <',f9.4,',',f9.4,',',f9.4,'>, ')") &
        nvec(4),nvec(6),nvec(5)
  else
    write(ifile,"('                <',f9.4,',',f9.4,',',f9.4,'>, ')") &
        -nvec(4),-nvec(6),-nvec(5)
  end if

  write(ifile,"('                <',f9.4,',',f9.4,',',f9.4,'>, ')") &
      point(7),point(9),point(8)
  svar=sum(nvec(7:9)*nl)
  if(svar.gt.0.D0) then
    write(ifile,"('                <',f9.4,',',f9.4,',',f9.4,'>')") &
        nvec(7),nvec(9),nvec(8)
  else
    write(ifile,"('                <',f9.4,',',f9.4,',',f9.4,'>')") &
        -nvec(7),-nvec(9),-nvec(8)
  end if
  write(ifile,"('}')") 
  
END SUBROUTINE WRITE_POV_SMOOTHTRIANGLE

SUBROUTINE CROSSPRODUCT(A,B,C)
! CALC C = A X B
  IMPLICIT NONE
  REAL(8),INTENT(IN) :: A(3),B(3)
  REAL(8),INTENT(OUT):: C(3)
! **********************************************************************
  C(1)=A(2)*B(3)-A(3)*B(2)
  C(2)=A(3)*B(1)-A(1)*B(3)
  C(3)=A(1)*B(2)-A(2)*B(1)
END SUBROUTINE CROSSPRODUCT

!! COPYRIGHT
!!
!!  Copyright 2007 Johannes Kaestner (kaestner@theochem.uni-stuttgart.de),
!!  Tom Keal (thomas.keal@stfc.ac.uk), Alex Turner, Salomon Billeter,
!!  Stephan Thiel, Max-Planck Institut fuer Kohlenforshung, Muelheim, 
!!  Germany.
!!
!!  This file is part of DL-FIND.
!!
!!  DL-FIND is free software: you can redistribute it and/or modify
!!  it under the terms of the GNU Lesser General Public License as 
!!  published by the Free Software Foundation, either version 3 of the 
!!  License, or (at your option) any later version.
!!
!!  DL-FIND is distributed in the hope that it will be useful,
!!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!!  GNU Lesser General Public License for more details.
!!
!!  You should have received a copy of the GNU Lesser General Public 
!!  License along with DL-FIND.  If not, see 
!!  <http://www.gnu.org/licenses/>.
!!

MODULE dlfhdlc_constraint
!  USE global
  use dlf_parameter_module, only: rk
  use dlf_global, only: printl,stdout!,pi
  use dlf_allocate, only: allocate, deallocate
  USE dlfhdlc_matrixlib
  IMPLICIT NONE

!------------------------------------------------------------------------------
! General:
!
! - Reference:
!   Implements J. Baker, J. Chem. Phys. 105 (1996) 192.
!
! - Procedure:
!   1. (done in <interface>.f90:hdlc_get_params)
!      Read in constraints (search.f90:search)
!   2. assign_cons
!      Assign constraints to particular residues and renumber atoms
!      (search.f90:search, after dlc_connect -> assign_cons)
!   3. ci_cons
!      Check in required connections (hdlclib.f90:hdlc_create after
!      hdlc_con_checkin -> ci_cons)
!   4. ck_angle_cons
!      Check in required bends and rots (hdlclib.f90:hdlc_create before
!      end if ! (associated(con)) -> ck_angle_cons)
!   5. ortho_cons
!      Project and orthogonalise active space to constraints
!      (dlc_manager.f:dlc_manager after dlc_make_ut -> ortho_cons)
!   6. split_cons
!      Separate between active and constrained coordinate values
!      (prfossa.f: optef_main after dlc_get_dlc_values and
!      dlc_get_dlc_gradients -> split_cons)
!   7. rest_cons
!      Restore Ut from constrained Ut and unprojected constraints
!      (prfossa.f: optef_main -> rest_cons)
!
! - Data to be passed between steps:
!        context scope  form symbol name description
!   1-2: global  local  a)               constraints specification
!   2-3: residue arg    b)               constraints specification
!   3-5: residue object c)               int. coord. seq. nbrs. of constr.
!   4-5: residue object c)               do.
!   5-6: residue object --   Ut,ncons    transposed V matrix, nbrs. of cns.
!   6-7: residue object d)               constraints values, number
!
! - Form specification:
!   a) iconstr(4,nconstr): i, j, k, l
!      vconstr(nconstr): value
!      atom sequence numbers global
!      k=l=0 -> bond, l=0 -> bond angle, all >0 -> torsion
!      type: array, double(5,ncnstr)
!   b) cns(7,ncons): i, j, k, l, itype, iseq, value; matrix
!      itype = 1: bond; i, j specified
!      itype = 2: bond angle; i, j, k specified
!      itype = 3: torsion; i, j, k, l specified
!      iseq is undefined: see c)
!      value is defined by (see d):
!        sequence number (mcnstr.eq.0)
!        target value (mcnstr.eq.1)
!      i, j, k, l are relative to the residue, ncons is stored per residue
!      object, as is icons(7,ncons) as well
!      type: matrix, (7,N), double
!   c) see b) but iseq points to the internal coordinate to be constrained
!      types: icons: array, (6,N), integer, vcons: array, (N), double
!   d) see b) but ivalue points to the target value in constraints(ivalue)
!      if extended Lagrangean is chosen, ivalue is kept from before
!   constraints(nconsvals) is stored globally
!
! - Notes:
!   * U/natoms <-> V/natoms/ncons/ (C/C_proj)?
!   * ncons has to be subtracted from n6 at each occurrence of if(internal)
!   * Correspondence between 'rows' and 'columns' by Alex Turner, Fortran
!     and mathematics is straightforward: the place of the index is always
!     the same, no matter whether the faster index or not.
!     First index: row, second index: column; a(row,column)
!
! changes by Johannes Kaestner (JK): bondlength-difference implemented (Jan 2005)
!  this is implemented with some drawbacks: the input is { diffbond at1 at2 at3 -1 }
!  -1 is required as no information on the keyword is transferred from hdlcopt2.tcl
!  to constraint.f90. Additionally, the bond indices are transferred in icons(4,:) and 
!  icons(6,:). Usually, icons(6,:) should be used, but two indices are required here.
!------------------------------------------------------------------------------

CONTAINS

!------------------------------------------------------------------------------
! subroutine get_cons_regions
!
! Arguments:
! nconstr:           number of constraints provided (in)
! iconstr(4,ncnstr): constraints as read in, format a (in)
! nat:               number of atoms (in)
! spec(nat):         residue/frozen atom specification (in)
! micspec(nat):      microiterative specification (in)
! nincons:           number of constraints in inner region (out) 
! noutcons:          number of constraints in outer region (out)
!
! Description: determine whether constraints apply to the inner or outer 
!              microiterative region for the purpose of counting the number
!              of internal coordinates in each region.
!              Also checks that no constraints have been set on frozen atoms
!------------------------------------------------------------------------------

  subroutine get_cons_regions(nconstr, iconstr, nat, spec, micspec, nincons, noutcons)
    ! arguments
    integer, intent(in) :: nconstr
    integer, dimension (5,nconstr), intent(in) :: iconstr ! type, atom1, atom2, atom3, atom4
    integer, intent(in) :: nat
    integer, intent(in) :: spec(nat)
    integer, intent(in) :: micspec(nat)
    integer, intent(out):: nincons
    integer, intent(out):: noutcons
    ! local vars
    integer :: kc, ncat, i, icat, iregion

    nincons = 0
    noutcons = 0

    do kc = 1, nconstr
       ! determine number of atoms to check
       select case (iconstr(1,kc))
       case (1)
          ncat = 2 ! Bond
       case (2)
          ncat = 3 ! Angle
       case (3)
          ncat = 4 ! Torsion
       case (4) 
          ncat = 1 ! Cartesian
       case (5)
          ncat = 3 ! Bond difference
       case default
          WRITE (stdout,'(A,I5,A,I5,A)') 'Constraint ', kc, ' type ', iconstr(1,kc), &
               ' not recognised!'
          CALL hdlc_errflag('Constraints error','stop')
       end select

       ! Determine whether constraint is in inner or outer region
       iregion = -1
       do i = 2, ncat + 1
          icat = iconstr(i,kc)
          if (spec(icat) == -1) then
             write(stdout,'(A,I5,A,I5)') 'Constraint ', kc, ' includes frozen atom ', icat
             write(stdout,'(A,5I5)') 'iconstr=', iconstr(1:5,kc)
             call hdlc_errflag('Constraints error','stop')
          end if
          if (iregion == -1) then
             iregion = micspec(icat)
          else if (iregion /= micspec(icat)) then
             write(stdout,'(A,I5,A)') 'Constraint ', kc, ' crosses inner/outer boundary!'
             write(stdout,'(A,5I5)') 'iconstr=', iconstr(1:5,kc)
             call hdlc_errflag('Constraints error','stop')
          end if
       end do

       if (iregion == 1) then
          nincons = nincons + 1
       else if (iregion == 0) then
          noutcons = noutcons + 1
       else
          write(stdout,'(A,I5,A,I5)') 'Constraint ', kc, ' iregion=', iregion
          write(stdout,'(A,5I5)') 'iconstr=', iconstr(1:5,kc)          
          call hdlc_errflag('Constraints error','stop')
       end if
    end do
     
   end subroutine get_cons_regions

!------------------------------------------------------------------------------
! subroutine assign_cons
!
! Arguments:
! cns(7,ncns):       matrix of constraints of one residue, format b (out)
! iconstr(4,ncnstr): constraints as read in, format a (in)
! nconstr:           number of constraints provided (in)
! mconstr:           type of constraints (in)
! vconstr(nconstr):  target or actual values (in)
! nat:               number of atoms (in)
! at:                array of atom indices (in)
! ncns:              number of constraints assigned in this residue (out)
!
! Description: step 2 of the procedure described above
!------------------------------------------------------------------------------

  SUBROUTINE assign_cons(cns,iconstr,nconstr,vconstr,mconstr,nat,at, &
      internal,ncns)

! args
    LOGICAL internal
    INTEGER nconstr, mconstr
    INTEGER, DIMENSION (5,nconstr) :: iconstr ! type, atom1, atom2, atom3, atom4
    REAL (rk), DIMENSION (nconstr) :: vconstr
    TYPE (matrix) :: cns
    integer, intent(in) :: nat
    integer, intent(in) :: at(nat)
    integer, intent(out):: ncns

! local vars
    LOGICAL li, lj, lk, ll
    INTEGER i, iatom, j, k, kc, l, m, mcomp, type,iat
    REAL (rk), DIMENSION (:,:), ALLOCATABLE :: icns_tmp
    integer :: ni,nj,nk,nl

! begin, allocate three times more space for the Cartesian components
    IF (printl>=5) WRITE (stdout,'(3X,A,/)') 'Looking for constraints'
    ncns = 0
    call allocate (icns_tmp,7,nconstr*3)

! loop over constraints and check if they affect the current residue
    DO kc = 1, nconstr
      i = iconstr(2,kc)
      j = iconstr(3,kc)
      k = iconstr(4,kc)
      l = iconstr(5,kc)

      li=.false.
      lj=.false.
      lk=.false.
      ll=.false.
      ni=0; nj=0; nk=0; nl=0;
      do iat=1,nat
        if(at(iat)==i) then
          li=.true.
          ni=iat
        end if
        if(at(iat)==j) then
          lj=.true.
          nj=iat
        end if
        if(at(iat)==k) then
          lk=.true.
          nk=iat
        end if
        if(at(iat)==l) then
          ll=.true.
          nl=iat
        end if
      end do
      IF (li .OR. lj .OR. lk .OR. ll) THEN
        IF (iconstr(1,kc)==3 .and. li .AND. lj .AND. lk .AND. ll) THEN
          type = 3 ! torsion
        ELSE IF (iconstr(1,kc)==2 .and. li .AND. lj .AND. lk) THEN
          type = 2 ! angle (bend)
        ELSE IF (iconstr(1,kc)==1 .AND. li .AND. lj) THEN
          type = 1 ! bond
        ELSE IF (iconstr(1,kc)==4 .and. (l<=0) .AND. (k<=0) &
            .AND. (j<=0) .AND. li) THEN
          type = 4 ! cartesian
! type 5 included by JK
        ELSE IF (iconstr(1,kc)==5 .and. li .AND. lj .AND. lk) THEN
          type = 5 ! bond difference
        ELSE
          WRITE (stdout,'(A,I5,A,I5,A,I5,A,I5,A)') 'Constraint ', i, ' - ', j, &
            ' - ', k, ' - ', l, ' crosses residue boundary!'
          CALL hdlc_errflag('Constraints error','stop')
        END IF

! found an internal constraint
        IF (type/=4) THEN
          ncns = ncns + 1
          IF (printl>=2) THEN
            IF (type<5) THEN ! included by JK
              WRITE (stdout,'(3X,A,4I7,/)') 'Found constraint between atoms ', &
                (iconstr(m+1,kc),m=1,type+1)
            else
              WRITE (stdout,'(3X,A,4I7,/)') 'Found constraint between atoms ', &
                (iconstr(m+1,kc),m=1,3)
            END IF
          END IF
          icns_tmp(1,ncns)=real(ni,rk)
          icns_tmp(2,ncns)=real(nj,rk)
          icns_tmp(3,ncns)=real(nk,rk)
          icns_tmp(4,ncns)=real(nl,rk)
!!$          DO m = 1, 4
!!$            IF (iconstr(m+1,kc)/=0) THEN
!!$              icns_tmp(m,ncns) = real((iconstr(m+1,kc)-(start-1)),rk)
!!$            ELSE
!!$              icns_tmp(m,ncns) = 0.0D0
!!$            END IF
!!$          END DO
! JK
          IF (type==5) icns_tmp(4,ncns) = 0.0D0
          icns_tmp(5,ncns) = real(type,rk)
          icns_tmp(6,ncns) = 0.0D0
          IF (mconstr>=1) THEN
            icns_tmp(7,ncns) = vconstr(kc)
          ELSE
            icns_tmp(7,ncns) = 0.0D0
          END IF

! found Cartesian constraints
        ELSE ! (type .ne. 4)
          IF (internal) THEN
            WRITE (stdout,'(A,I5,A)') 'Constraint ', i, &
              ': no Cartesian components can be constrained with DLC'
            CALL hdlc_errflag('Constraints error','stop')
          END IF
          ncns = ncns + 1
          iatom = iconstr(2,kc) !1 + int((iconstr(2,kc)-1)/3)
          mcomp = -iconstr(4,kc) !iconstr(2,kc) - 3*(iatom-1)
          IF (printl>=2) THEN
            WRITE (stdout,'(3X,A,4I5,/)') 'Found constrained Cartesian, atom ' &
              , iatom, ', component ', mcomp
          END IF
          icns_tmp(1,ncns) = real(mcomp+ni,rk)
          DO m = 2, 4
            icns_tmp(m,ncns) = 0.0D0
          END DO
          icns_tmp(5,ncns) = real(type,rk)
          icns_tmp(6,ncns) = 0.0D0
          IF (mconstr>=1) THEN
            icns_tmp(7,ncns) = vconstr(kc)
          ELSE
            icns_tmp(7,ncns) = 0.0D0
          END IF
        END IF ! (type .le. 3) ... else
      END IF ! (li .or. lj .or. lk .or. ll)
    END DO ! kc = 1,nconstr
    cns = matrix_create(7,ncns,'constraints')
    DO kc = 1, ncns
      i = matrix_set_column(cns,7,icns_tmp(1:7,kc),kc)
    END DO
    call deallocate (icns_tmp)
  END SUBROUTINE assign_cons

!------------------------------------------------------------------------------
! subroutine ci_cons
!
! Description:
! Step 3 of the procedure described above. The constraints provided in cns are
! copied to icons, and all connections not yet occurring in iconn are added.
! For bonds, the bond sequence number is stored in icons(iseq,*).
! The target value of the constraints is copied to vcons. This only matters if
! the extended Lagrangean method is chosen.
!
! Arguments:
! cns   matrix(7,ncons) (in)  constraint specification for the residue
! ncons                 (in)  number of constraints provided in cns
! icons (6,ncons)       (out) constraint specification copied from cns
! vcons (ncons)         (out) constraint values copied from cns
! nconn                 (i/o) number of connections between atoms in the res.
! iconn (2,nconn)       (i/o) connections list, new pointer returned
!------------------------------------------------------------------------------

  SUBROUTINE ci_cons(cns,ncons,icons,vcons,nconn,iconn)

! args
    TYPE (matrix) :: cns
    INTEGER ncons, nconn
    INTEGER, POINTER, DIMENSION (:,:) :: icons, iconn
    REAL (rk), POINTER, DIMENSION (:) :: vcons

! local vars
    INTEGER, allocatable, DIMENSION (:,:) :: iconn_tmp
    INTEGER, pointer, DIMENSION (:,:) :: iconn_new
    INTEGER el, k, kc
    INTEGER ibnd, jbnd, kconn, kibnd, kjbnd, ktype, nconn_new

! begin, allocate space to hold potential new connections
    nconn_new = nconn
    ! 3*ncons is the maximum number of required additional bonds
    !  (if all constraints are torsions and no bonds defined ...)
    call allocate (iconn_tmp,2,3*ncons)

! copy the constraints
    DO kc = 1, ncons
      DO el = 1, 6
        icons(el,kc) = int(cns%data(el,kc))
      END DO
      vcons(kc) = cns%data(7,kc)

! check all constraints including angles and torsions
      ktype = icons(5,kc)
      jbnd = icons(1,kc)
      IF (printl>=4) THEN
        IF (ktype<5) THEN
          WRITE (stdout,'(5X,A,I1,A,4I5)') 'Considering constraint (type ', &
            ktype, '): ', (icons(k,kc),k=1,ktype+1)
        ELSE
          WRITE (stdout,'(5X,A,I1,A,4I5)') 'Considering constraint (type ', &
            ktype, '): ', (icons(k,kc),k=1,3)
        END IF
      END IF
      DO k = 1, ktype
        IF (ktype==5 .AND. k>=3) EXIT ! catch bond difference
        IF (ktype==4) exit ! no bonds needed for cartesian constraints
        ibnd = jbnd
        jbnd = icons(1+k,kc)

! check if the connection ibnd - jbnd already occurs
        DO kconn = 1, nconn
          kibnd = iconn(1,kconn)
          IF (ibnd==kibnd .OR. jbnd==kibnd) THEN
            kjbnd = iconn(2,kconn)
            IF (ibnd==kjbnd .OR. jbnd==kjbnd) THEN

! connection is already defined - store its sequence number and break the loop
              IF (ktype==1) THEN
                icons(6,kc) = kconn
                IF (printl>=4) THEN
                  WRITE (stdout,'(7X,A,I4)') '... constraining bond ', kconn
                END IF
              END IF
              IF (ktype==5) THEN
! jk: take care of bond difference
! the positive contribution is stored in icons(6,ic)
! the negative contribution is stored in icons(4,ic)      
                IF (k==1) THEN
                  icons(6,kc) = kconn
                  IF (printl>=4) THEN
                    WRITE (stdout,'(7X,A,I4)') '... positive part of diffbond: ', kconn
                  END IF
                ELSE ! the case if k=2
                  icons(4,kc) = kconn
                  IF (printl>=4) THEN
                    WRITE (stdout,'(7X,A,I4)') '... negative part of diffbond: ', kconn
                  END IF
                END IF
              END IF
              GO TO 10
            END IF
          END IF
        END DO ! kconn = 1,nconn

! connection is not yet defined - do it now
        nconn_new = nconn_new + 1
        iconn_tmp(1,nconn_new-nconn) = ibnd
        iconn_tmp(2,nconn_new-nconn) = jbnd
        IF (ktype==1) THEN
          icons(6,kc) = nconn_new
          IF (printl>=4) THEN
            WRITE (stdout,'(9X,A,I4,A,I4,A,I4,/)') '... adding stretch ', &
              ibnd, ' - ', jbnd, ' to constrain it as bond ', nconn_new
          END IF
        ELSE
          IF (printl>=4) THEN
            WRITE (stdout,'(9X,A,I4,A,I4,/)') '... adding stretch ', ibnd, &
              ' - ', jbnd
          END IF
        END IF
        IF (ktype==5) THEN
! jk: take care of bond difference
! the positive contribution is stored in icons(6,ic)
! the negative contribution is stored in icons(4,ic)      
          IF (k==1) THEN
            icons(6,kc) = nconn_new
          ELSE ! the case if k=2
            icons(4,kc) = nconn_new
          END IF
        END IF

! jump here if the connection is already defined
10      CONTINUE
      END DO ! do k = 1,ktype
    END DO ! kc = 1,ncons
! add new connections to the old ones and reset pointers
    IF (nconn_new>nconn) THEN
      ALLOCATE (iconn_new(2,nconn_new))
      DO k = 1, nconn
        iconn_new(1,k) = iconn(1,k)
        iconn_new(2,k) = iconn(2,k)
      END DO
      DO k = 1, nconn_new - nconn
        iconn_new(1,k+nconn) = iconn_tmp(1,k)
        iconn_new(2,k+nconn) = iconn_tmp(2,k)
      END DO
      IF (associated(iconn)) DEALLOCATE (iconn)
      iconn => iconn_new
    END IF
    call deallocate (iconn_tmp)
    nconn = nconn_new
  END SUBROUTINE ci_cons

!------------------------------------------------------------------------------
! subroutine ck_angle_cons
!
! Description:
! Step 4 of the procedure described above. The angles to be constrained must
! have been found already. Check their sequence numbers and store them.
! Only bond angles are scanned (ibend(4,*).eq.0), no impropers or linears.
!
! Arguments:
! ncons           (in)  number of constraints
! icons (6,ncons) (i/o) constraint specification
! nconn           (in)  number of connections between atoms in the res.
! nbend           (i/o) number of bends
! ibend (4,nbend) (i/o) bends list
! nrots           (i/o) number of torsions
! irots (4,nrots) (i/o) torsions list
!------------------------------------------------------------------------------

  SUBROUTINE ck_angle_cons(ncons,icons,nconn,ibend,nbend,irots,nrots)

! to allocate additional memory for missing torsions and bond angles
    use dlfhdlc_primitive, only : rots_grow

! args
    INTEGER ncons, nconn, nbend, nrots
    INTEGER, pointer, dimension (:,:) :: ibend, irots
    INTEGER, POINTER, DIMENSION (:,:) :: icons

! local vars
    INTEGER k, kangle, kc, ktype, ni
    integer maxbend, maxrots

! begin
    DO kc = 1, ncons
      ktype = icons(5,kc)

! bends
      IF (ktype==2) THEN

        DO kangle = 1, nbend
          IF (ibend(4,kangle)==0) THEN
            IF (ibend(2,kangle)==icons(2,kc)) THEN
              IF ((ibend(1,kangle)==icons(1,kc) .AND. ibend(3, &
                  kangle)==icons(3,kc)) .OR. (ibend(1,kangle)==icons(3, &
                  kc) .AND. ibend(3,kangle)==icons(1,kc))) THEN
                GO TO 10
              END IF
            END IF
          END IF
        END DO

! angle not found - add it to the list of primitive coordinates
        IF (printl>=4) WRITE (stdout,'(A,I5,A,I5,A,I5,A)') &
          'Constrained angle ', icons(1,kc), &
          ' - ', icons(2,kc), ' - ', icons(3,kc), &
          ' not found - adding to primitive list'
        ! Allocate additional space for the new bend if necessary
        maxbend = size(ibend,2)
        if (maxbend == nbend) then
           ! We can reuse rots_grow here because ibend has the same
           ! first dimension size as irots (4).
           call rots_grow(ibend,maxbend,maxbend+1,maxbend)
        endif
        nbend = nbend + 1
        kangle = nbend
        ibend(1:3, kangle) = icons(1:3, kc)
        ibend(4, kangle) = 0

! angle found
10      CONTINUE
        ni = kangle
        DO k = 1, kangle
          IF (ibend(4,k)<0 .AND. ibend(1,k)/=0) ni = ni + 1
        END DO
        IF (printl>=4) WRITE (stdout,'(5X,A,I3,A,4I5)') &
          'Constraining angle ', ni, ': ', (icons(k,kc),k=1,3)
        icons(6,kc) = ni + nconn

! torsions
      ELSE IF (ktype==3) THEN

        DO kangle = 1, nrots

          IF (irots(2,kangle)==icons(2,kc)) THEN
            IF (irots(1,kangle)==icons(1,kc) .AND. irots(3,kangle)==icons(3,kc &
              ) .AND. irots(4,kangle)==icons(4,kc)) GO TO 20
          ELSE IF (irots(2,kangle)==icons(3,kc)) THEN
            IF (irots(1,kangle)==icons(4,kc) .AND. irots(3,kangle)==icons(2,kc &
              ) .AND. irots(4,kangle)==icons(1,kc)) GO TO 20
          END IF
        END DO

! torsion not found - add it to the list of primitive coordinates
        IF (printl>=4) WRITE (stdout,'(A,I5,A,I5,A,I5,A,I5,A)') &
          'Constrained torsion ', &
          icons(1,kc), ' - ', icons(2,kc), ' - ', icons(3,kc), ' - ', &
          icons(4,kc), ' not found - adding to primitive list'
        ! Allocate additional space for the new torsion if necessary
        maxrots = size(irots,2)
        if (maxrots == nrots) then
          call rots_grow(irots,maxrots,maxrots+1,maxrots)
        endif
        nrots = nrots + 1
        kangle = nrots
        irots(1:4,kangle) = icons(1:4,kc)

! torsion found - add stretches, bends and linears to the sequence number
20      CONTINUE
        ni = kangle
        DO k = 1, nbend
          IF (ibend(4,k)<0 .AND. ibend(1,k)/=0) ni = ni + 1
        END DO
        IF (printl>=4) WRITE (stdout,'(5X,A,I3,A,4I5)') &
          'Constraining torsion ', kangle, ': ', (icons(k,kc),k=1,4)
        icons(6,kc) = ni + nconn + nbend

! Cartesians - add stretches, bends and linears to the sequence number
      ELSE IF (ktype==4) THEN ! (ktype.eq.2) .. elseif (ktype.eq.3)
        ni = icons(1,kc)
        kangle = ni
        DO k = 1, nbend
          IF (ibend(4,k)<0 .AND. ibend(1,k)/=0) ni = ni + 1
        END DO
        IF (printl>=4) WRITE (stdout,'(5X,A,I3)') &
          'Constraining Cartesian ', kangle
        icons(6,kc) = ni + nconn + nbend
      END IF ! (ktype.eq.2) .. elseif (ktype.eq.4)
    END DO ! kc = 1,ncons
  END SUBROUTINE ck_angle_cons

!------------------------------------------------------------------------------
! subroutine ortho_cons
!
! Implements the method for adding constraints to natural DLC
! described by Baker et al.
! based on Schmidt orthogonalisation of the column vectors of U to the
! projected constraint vectors C
!
! The np-dimensional space of the internal, primitive, local coordinates is
! represented as in 
!
! Input:
!   Ut(m,np): Transpose of the nonredundant eigenspace of G
!     m rows: nonredundant eigenvectors of G represented using
!     np columns: primitive, local, internal coordinates
!   nc: number of internal coordinates to be constrained
!
! Output:
!   Ut(m-nc,np): Transpose of the active, nonredundant eigenspace of G
!   Ut(m-nc..m,np): Transpose of the constrained eigenspace of G
!     m rows: see above, orthogonal to the space {C(k), k=1..nc} projected
!
! Temporarily used:
!   C(np,nc): Constraints
!     np rows: primitive, local, internal coordinates
!     nc columns: constraint vectors represented using
!   np: number of primitive internal coordinates
!   m: dimension of the nonredundant eigenspace of G
!
! Description: step 5 of the procedure described above
!------------------------------------------------------------------------------


  SUBROUTINE ortho_cons(ut_mat,nc,icons)

! args
    INTEGER       :: nc, icons(6,nc)
    TYPE (matrix) :: ut_mat

! local vars
    INTEGER j, m, np
    TYPE (matrix) :: c_mat, v_mat
    REAL (rk), DIMENSION (:), ALLOCATABLE :: work

! begin, find dimensions, allocate space, np is always .gt. m
    m = matrix_dimension(ut_mat,1)
    np = matrix_dimension(ut_mat,2)
    c_mat = matrix_create(np,nc,'C matrix')
    v_mat = matrix_create(np,m+nc,'V matrix')
    call allocate (work,np+m)

! set constraints matrix and project constrained coordinates
    CALL gen_cons(c_mat%data,icons,nc,np)
    CALL proj_cons(c_mat%data,ut_mat%data,work,m,nc,np)

! now we have Ut and Cp, start orthogonalisation
    CALL merge_cons(v_mat,c_mat,ut_mat,work,m,nc,np)
    CALL ortho_mat(v_mat%data,work,m,nc,np)

! move the constraints to the end of the non-zero vectors and transpose
    CALL move_cons(v_mat,ut_mat,work,m,nc,np)

! replace projected by unprojected constraints
    CALL gen_cons(c_mat%data,icons,nc,np)
    CALL unproj_cons(ut_mat,c_mat,work,m,nc,np)
    j = matrix_destroy(c_mat)
    j = matrix_destroy(v_mat)
    call deallocate (work)

  END SUBROUTINE ortho_cons

!------------------------------------------------------------------------------
! subroutine split_cons
!
! Is called by the 'method routine' hdlc_split_cons of hdlc_manager, but is
! implemented separately.
! matrix_set copies the data rather than setting the handle to the data
!
! Arguments:
! hdlc:    matrix of full HDLC coordinates (in)
!          matrix of active HDLC coordinates (out)
! lstore:  constrained HDLC coordinates are stored to vcons if (lstore) (in)
! natom:   number of atoms in the residue (in)
! ncons:   number of constraints in the residue (in)
! vcons:   (ncons) values of the constrained coordinates (out)
!
! Description: step 6 of the procedure described above
!------------------------------------------------------------------------------

  SUBROUTINE split_cons(hdlc,lstore,linternal,natom,ncons,vcons)

! args
    LOGICAL lstore, linternal
    INTEGER natom, ncons
    REAL (rk), DIMENSION (ncons) :: vcons
    TYPE (matrix) :: hdlc

! local vars
    INTEGER idum, ncoords, nactive
    REAL (rk), DIMENSION (:), ALLOCATABLE :: dhdlc

! begin
    ncoords = 3*natom
    if(linternal) ncoords = ncoords - 6
    nactive = ncoords - ncons

! move all data to temp array
    call allocate (dhdlc,ncoords)
    idum = matrix_get(hdlc,ncoords,dhdlc)
    idum = matrix_destroy(hdlc)

! store data to new HDLC matrix and residue%vcons if requested
    hdlc = matrix_create(nactive,1,'HDLC active')
    idum = matrix_set(hdlc,ncoords,dhdlc)
    IF (lstore) THEN
      CALL copy_coords(vcons,dhdlc(nactive+1),ncons)
    END IF
    call deallocate (dhdlc)

! end split_cons
  END SUBROUTINE split_cons

!------------------------------------------------------------------------------
! subroutine rest_cons
!
! Is called by the 'method routine' hdlc_rest_cons of hdlc_manager, but is
! implemented separately.
! matrix_set copies the data rather than setting the handle to the data
!
! Arguments:
! hdlc:    matrix of active HDLC coordinates (in)
!          matrix of full HDLC coordinates (out)
! natom:   number of atoms in the residue (in)
! ncons:   number of constraints in the residue (in)
! vcons:   (ncons) values of the constrained coordinates (in)
!
! Description: step 7 of the procedure described above
!------------------------------------------------------------------------------

  SUBROUTINE rest_cons(hdlc,linternal,natom,ncons,vcons)

! args
    INTEGER natom, ncons
    logical linternal
    REAL (rk), DIMENSION (ncons) :: vcons
    TYPE (matrix) :: hdlc

! local vars
    INTEGER idum, ncoords, nactive
    REAL (rk), DIMENSION (:), ALLOCATABLE :: dhdlc

! begin
    ncoords = 3*natom
    if(linternal) ncoords = ncoords - 6
    nactive = ncoords - ncons

! move all data from old HDLC matrix and vcons to temp array
    call allocate (dhdlc,ncoords)
    idum = matrix_get(hdlc,ncoords,dhdlc)
    idum = matrix_destroy(hdlc)
    CALL copy_coords(dhdlc(nactive+1),vcons,ncons)

! store data to new HDLC
    hdlc = matrix_create(ncoords,1,'HDLC all')
    idum = matrix_set(hdlc,ncoords,dhdlc)
    call deallocate (dhdlc)

! end split_cons
  END SUBROUTINE rest_cons

!------------------------------------------------------------------------------
! Helpers
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
! This tiny helper is self explaining
!------------------------------------------------------------------------------

  SUBROUTINE copy_coords(target,source,length)

! args
    INTEGER length
    REAL (rk), DIMENSION (length) :: target, source

! local vars
    INTEGER i

! begin
    DO i = 1, length
      target(i) = source(i)
    END DO

! end copy_coords
  END SUBROUTINE copy_coords

!------------------------------------------------------------------------------
! subroutine gen_cons
!
! Generates a constraints matrix in the primitive internal basis from the
! specification in icons(iseq,*)
!
! Arguments:
! cdat(np,nc): constraints matrix (out)
! icons(6,nc): constraints specification (in)
! nc:          number of constraints (in)
! np:          dimension of the primitive space
!------------------------------------------------------------------------------

  SUBROUTINE gen_cons(cdat,icons,nc,np)

! args
    INTEGER nc, np, icons(6,nc)
    REAL (rk), DIMENSION (np,nc) :: cdat

! local vars
    INTEGER ip, ic
! begin
    DO ic = 1, nc
      DO ip = 1, np
        cdat(ip,ic) = 0.0D0
      END DO
      cdat(icons(6,ic),ic) = 1.0D0
! jk: take care of bond difference
! the positive contribution is stored in icons(6,ic)
! the negative contribution is stored in icons(4,ic)      
      IF (icons(5,ic)==5) THEN
        cdat(icons(4,ic),ic) = -dsqrt(2.D0)
        cdat(icons(6,ic),ic) = dsqrt(2.D0)
      END IF
    END DO

! end gen_cons
  END SUBROUTINE gen_cons

!------------------------------------------------------------------------------
! subroutine proj_cons
!
! Projects the vectors in the matrix c into the space spanned by utmat
!
! Arguments:
! cdat(np,nc): unprojected constraints matrix (in) / projected matrix (out)
! utdat(m,np): m-dimensional space of vectors of dimension np (in)
! work(m):     scratch array, used for dp_{ic,j} (in)
! m:           dimension of the space spanned by utmat (nonredundant) (in)
! nc:          number of constraints (in)
! np:          dimension of the space in which utmat is represented (in)
!------------------------------------------------------------------------------

  SUBROUTINE proj_cons(cdat,utdat,work,m,nc,np)

! args
    INTEGER nc, np, m
    REAL (rk), DIMENSION (m) :: work
    REAL (rk), DIMENSION (np,nc) :: cdat
    REAL (rk), DIMENSION (m,np) :: utdat

! local vars
    INTEGER ic, ip, j

! begin, dp_{ic,j} = <C_ic|U_j>
    DO ic = 1, nc
      DO j = 1, m
        work(j) = 0.0D0
        DO ip = 1, np
          work(j) = work(j) + utdat(j,ip)*cdat(ip,ic)
        END DO
      END DO

! C_ic = 0
      DO ip = 1, np
        cdat(ip,ic) = 0.0D0
      END DO

! C_ic = sum_j dp_{ic,j}*U_j
      DO j = 1, m
        DO ip = 1, np
          cdat(ip,ic) = cdat(ip,ic) + work(j)*utdat(j,ip)
        END DO
      END DO
    END DO ! ic = 1,nc

! end proj_cons
  END SUBROUTINE proj_cons

!------------------------------------------------------------------------------
! subroutine merge_cons
!
! Composes a new matrix V out of [C,Ut]
!
! Arguments:
! v_mat:  matrix (np,m+nc) of [cmat,utmat transposed] (out)
! c_mat:  matrix (np,nc) of projected constraints (in)
! ut_mat: matrix (m,np) of U transposed (in)
! work:   work array(np) (in)
! m:      dimension of the space spanned by utmat (nonredundant) (in)
! nc:     number of constraints (in)
! np:     dimension of the space in which utmat is represented (in)
!------------------------------------------------------------------------------

  SUBROUTINE merge_cons(v_mat,c_mat,ut_mat,work,m,nc,np)

! args
    INTEGER m, nc, np
    TYPE (matrix) :: v_mat, c_mat, ut_mat
    REAL (rk), DIMENSION (np) :: work

! local vars
    INTEGER i, idum, j

! begin
    DO i = 1, nc
      idum = matrix_get_column(c_mat,size(work),work,i)
      idum = matrix_set_column(v_mat,size(work),work,i)
    END DO
    j = nc
    DO i = 1, m
      j = j + 1
      idum = matrix_get_row(ut_mat,size(work),work,i)
      idum = matrix_set_column(v_mat,size(work),work,j)
    END DO

! end merge_cons
  END SUBROUTINE merge_cons

!------------------------------------------------------------------------------
! subroutine ortho_mat
!
! Applies Schmidt orthogonalisation to the columns of vmat
! Taken from mankyopt: orthog.F
!
! Arguments:
! v_dat(np,nc+m): [cmat,utmat transposed] (in), orthogonalised (out)
! work(np):       work array (in)
! m, nc, np:      see above (in)
!------------------------------------------------------------------------------

  SUBROUTINE ortho_mat(v_dat,work,m,nc,np)

! args
    INTEGER m, nc, np
    REAL (rk), DIMENSION (np,nc+m) :: v_dat
    REAL (rk), DIMENSION (np) :: work

! local vars
    INTEGER i, j, k, nelem, nvec
    REAL (rk) dnorm, scapro, tol

! data
    DATA tol/1.0D-10/

! begin, orthogonalise vectors i = 2,nvec
    nvec = m + nc
    nelem = np
    DO i = 1, nvec
      DO j = 1, nelem
        work(j) = 0.0D0
      END DO

! make vector i orthogonal to vectors  k = 1,i-1
      DO k = 1, i - 1
        scapro = 0.0D0
        DO j = 1, nelem
          scapro = scapro + v_dat(j,i)*v_dat(j,k)
        END DO
        DO j = 1, nelem
          work(j) = work(j) + v_dat(j,k)*scapro
        END DO
      END DO

! subtract the collinear vector to make vector i orthogonal to k = 1,i-1
      DO j = 1, nelem
        v_dat(j,i) = v_dat(j,i) - work(j)
      END DO

! normalise vector i
      dnorm = 0.0D0
      DO j = 1, nelem
        dnorm = dnorm + v_dat(j,i)*v_dat(j,i)
      END DO
      IF (abs(dnorm)<tol) THEN
        dnorm = 0.0D0
      ELSE
        dnorm = 1.0D0/dsqrt(dnorm)
      END IF
      DO j = 1, nelem
        v_dat(j,i) = v_dat(j,i)*dnorm
      END DO
    END DO

! report resulting matrix
!   do i = 1,nvec
!      work(i) = 0.0D0
!      do j = 1,nelem
!         work(i) = work(i) + v_dat(j,i)*v_dat(j,i)
!      end do
!   end do

! end ortho_mat
  END SUBROUTINE ortho_mat

!------------------------------------------------------------------------------
! subroutine move_cons
!
! Moves the constraints behind the active space in the V matrix, transposes
! V and stores it in Ut
!
! Arguments: see merge_cons
!------------------------------------------------------------------------------

  SUBROUTINE move_cons(v_mat,ut_mat,work,m,nc,np)

! args
    INTEGER m, nc, np
    TYPE (matrix) :: v_mat, ut_mat
    REAL (rk), DIMENSION (np) :: work

! local vars
    INTEGER is, it, i
    REAL (rk) dnorm, tol

! data
    DATA tol/1.0D-10/

! begin
    DO is = 1, nc
      i = matrix_get_column(v_mat,size(work),work,is)
      i = matrix_set_row(ut_mat,size(work),work,m-nc+is)
    END DO
    it = 0
    DO is = nc + 1, nc + m
      i = matrix_get_column(v_mat,size(work),work,is)
      dnorm = 0.0D0
      DO i = 1, np
        dnorm = dnorm + work(i)*work(i)
      END DO
      IF (dnorm>tol) THEN
!         write(stdout,'("JK dnorm ",g15.7," tol ",g15.7)') dnorm,tol
        it = it + 1
        IF (it>m-nc) THEN
          WRITE (stdout,'(A,I5)') 'Too many active vectors, required: ', &
            m - nc
!            write(stdout,'("JK dnorm ",g15.7," tol ",g15.7)') dnorm,tol
          CALL hdlc_errflag('Constraints error','abort')
        ELSE
          i = matrix_set_row(ut_mat,size(work),work,it)
        END IF
      END IF
    END DO

! end move_cons
  END SUBROUTINE move_cons

!------------------------------------------------------------------------------
! subroutine unproj_cons
!
! Replaces projected constraints by the unprojected ones in the matrix
! U transposed
!
! Arguments: see merge_cons
!------------------------------------------------------------------------------

  SUBROUTINE unproj_cons(ut_mat,c_mat,work,m,nc,np)

! args
    INTEGER m, nc, np
    TYPE (matrix) :: ut_mat, c_mat
    REAL (rk), DIMENSION (np) :: work

! local vars
    INTEGER is, i

! begin
    DO is = 1, nc
      i = matrix_get_column(c_mat,size(work),work,is)
      i = matrix_set_row(ut_mat,size(work),work,m-nc+is)
    END DO

! end unproj_cons
  END SUBROUTINE unproj_cons

END MODULE dlfhdlc_constraint

!  Copyright (C) 2017 The authors of Py-ChemShell
!
!  This file is part of Py-ChemShell.
!
!  Py-ChemShell is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as
!  published by the Free Software Foundation, either version 3 of the
!  License, or (at your option) any later version.
!
!  Py-ChemShell is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with Py-ChemShell.  If not, see
!  <http://www.gnu.org/licenses/>.

! YL 01/08/2018: this file should contain ONLY methods called by the (Python) interface
module ChemShellClusterModule

    use iso_c_binding
    use DL_PY2F

    private

    public PyFrag, PyCluster, PyOptions, PyCell, PyField, PyBQs, PyShells
    public get_ndims, cluster_origin
    public MAXCONN
    public debug

    integer(kind=8), parameter :: MAXCONN = 14
    type(dictType) , pointer   :: PyFrag, PyCluster, PyOptions, PyCell, PyField, PyBQs, PyShells
    integer                    :: debug
    integer        , external  :: cluster_cut
    real(kind=8)               :: cluster_origin(3)

! YL: since Intel Compiler 2016, "external" is no longer allowed to be bind(c)
!     "error #8809: An OPTIONAL or EXTERNAL dummy argument to a BIND(C) procedure is not interoperable"
!    integer(c_long), pointer, external :: PyCallback
!    abstract interface
!        integer(c_long) function callback() bind(c)
!            use iso_c_binding
!        endfunction callback
!    endinterface
!
!    procedure(callback), pointer :: PyCallback

    contains

    ! this is a wrapper around the original cluster_cut() of CONSTRUCT
    integer(c_int) function cluster_get_size(natoms_cluster,  &
                                             nshells_cluster, &
                                             chemsh_debug)    &
                   result(ierror)                             &
                   bind(c, name="cluster_get_size")

        implicit none

        integer, intent(out) :: natoms_cluster
        integer, intent(out) :: nshells_cluster
        integer, intent(in)  :: chemsh_debug

        debug = chemsh_debug

        ! set size of new cluster to zero to allow cluster_cut to return
        natoms_cluster  = 0
        nshells_cluster = 0

        ! TODO support fully coordinated mode
        if(cluster_cut(natoms_cluster, nshells_cluster).ne.0) then
            write(*,'(/A)') " >>> ChemShell CLUSTER ERROR: cluster_cut called in cluster_get_size"
        endif
        call flush(6)

        ! DEBUG
        write(*,'(/A)') " The created cluster contains"
        write(*,'(1X,I0,1X,A,I0,1X,A/)') natoms_cluster, "atoms and ", nshells_cluster, "shell centres"

        ierror = 0

    endfunction cluster_get_size
    integer(c_int) function cluster_get_coords(clusterPtr,   &
                                               chemsh_debug) &
                   result(ierror)                            &
                   bind(c, name='cluster_get_coords')

        implicit none
            
        type(PyType)             , intent(inout) :: clusterPtr
        integer                  , intent(in)    :: chemsh_debug

        real(kind=8)                             :: radius_cluster
        real(kind=8)    , pointer                :: coords(:,:), charges(:)
!        real(kind=8)                             :: origin_point(3)
        integer                                  :: natoms_frag, nshells_frag
        integer                                  :: natoms_cluster, nshells_cluster
        integer(kind=8) , pointer                :: znums(:)
        character(len=:), pointer                :: crystal_type

        debug = chemsh_debug

        if(associated(PyCluster)) deallocate(PyCluster)
        allocate(PyCluster, source=ptr2dict(clusterPtr))

        !Get the parameters for the routine from Python
        call PyFrag%get('npts'             , natoms_frag)
        call PyFrag%get('nshells'          , nshells_frag)

        call PyOptions%get('radius_cluster', radius_cluster)
        call PyOptions%get('crystal_type'  , crystal_type)
!        call PyOptions%get('origin'        , origin_point)

        call PyCluster%get('npts'   , natoms_cluster)
        call PyCluster%get('nshells', nshells_cluster)

        ! YL 01/08/2018: what is this?
        ! TODO support fully coordinated mode
        if(cluster_cut(natoms_cluster, nshells_cluster).ne.0) then
            write(*,'(/A)') "Something went wrong getting coordinates of cluster"
        endif
        call flush(6)

        ierror = 0

    endfunction cluster_get_coords
    integer(c_int) function cluster_adjust_charges(clusterPtr,   &
                                                   chemsh_debug) &
                   result(ierror)                                &
                   bind(c, name='cluster_adjust_charges')
      
        implicit none

        type(PyType)               , intent(inout) :: clusterPtr
        integer                    , intent(in)    :: chemsh_debug
        
        integer         , parameter                :: nbqs=0
        integer         , parameter                :: nbqs_cluster=0
        integer                                    :: natoms_frag, nshells_frag
        integer                                    :: natoms_cluster, nshells_cluster
        integer                                    :: dimensionality
        character(len=:), pointer                  :: crystal_type
        character(len=:), pointer                  :: adjust_mode
        
        debug = chemsh_debug

        if(associated(PyCluster)) deallocate(PyCluster)
        allocate(PyCluster, source=ptr2dict(clusterPtr))
        
        ! get the parameters for the routine from Python
        call PyFrag   %get('npts'         , natoms_frag)
        call PyFrag   %get('nshells'      , nshells_frag)
        call PyCell   %get('ndimensions'  , dimensionality)
        call PyCluster%get('npts'         , natoms_cluster)
        call PyCluster%get('nshells'      , nshells_cluster)
        call PyOptions%get('crystal_type' , crystal_type)
        call PyOptions%get('adjust_charge', adjust_mode)

        write(*,'(A)') ' Charges adjustment configurations'
        write(*,'(A,I12)') ' fragment natoms            : ', natoms_frag
        write(*,'(A,I12)') ' fragment nshells           : ', nshells_frag
        write(*,'(A,I12)') ' cluster natoms             : ', natoms_cluster
        write(*,'(A,I12)') ' cluster nshells            : ', nshells_cluster
        write(*,'(A,A)')   ' dimensionality             : ', dimensionality
        write(*,'(A,A)')   ' crystal_type               : ', trim(crystal_type)
        write(*,'(A,A)')   ' adjust mode                : ', trim(adjust_mode)

        ! nbqs_frag=0 and nbqs_cluster = 0
        call cluster_adjust_charge(natoms_cluster, 0, nshells_cluster, &
                                   natoms_frag   , 0, nshells_frag   , &
                                   ierror)

    endfunction cluster_adjust_charges
    integer(c_int) function cluster_calc_electrostatics(fieldPtr,     &
                                                        chemsh_debug) &
                   result(ierror)                                     &
                   bind(c, name='cluster_calc_electrostatics')

        implicit none

        type(PyType), intent(inout) :: fieldPtr
        integer     , intent(in)    :: chemsh_debug

        integer                     :: grid_mode
        integer                     :: natoms_frag, nshells_frag
        integer                     :: ngridpts

        debug = chemsh_debug

        allocate(pyField,source=ptr2dict(fieldPtr))

        call PyFrag%get('npts'   , natoms_frag)
        call PyFrag%get('nshells', nshells_frag)
        call PyOptions%get('grid_mode'  , grid_mode)
        call PyOptions%get('grid_points', ngridpts)

        ! nbqs=0
        call periodic_electrostatics(grid_mode, natoms_frag, 0, nshells_frag, ngridpts, ierror)

    endfunction cluster_calc_electrostatics
    integer(c_int) function cluster_fit_bqs(clusterPtr,   &
                                            fieldPtr  ,   &
                                            chemsh_debug) &
                   result(ierror)                         &
                   bind(c, name='cluster_fit_bqs')

        implicit none

        type(PyType)         , intent(in) :: clusterPtr
        type(PyType)         , intent(in) :: fieldPtr
        integer              , intent(in) :: chemsh_debug

        real(kind=8)                      :: radius_cluster, radius_active
        real(kind=8)                      :: bq_margin, bq_fit_weight, bq_layer
        integer                           :: bq_density
        integer                           :: natoms_frag, nshells_frag
        integer                           :: natoms_cluster, nshells_cluster

        integer                           :: field_npoints
        type(PyType), pointer             :: bqPtr

        debug = chemsh_debug

        ! YL: haven't implemented deallocation but do not forget it!
        if(associated(PyCluster)) deallocate(PyCluster)
        allocate(PyCluster, source=ptr2dict(clusterPtr))
        allocate(PyField  , source=ptr2dict(fieldPtr))
        call PyCluster%get('bqs', bqPtr)
        allocate(PyBQs    , source=ptr2dict(bqPtr))

        call PyField%get('npts', field_npoints)

        !Get the parameters for the routine from Python
        call PyFrag   %get('npts'          , natoms_frag)
        call PyFrag   %get('nshells'       , nshells_frag)
        call PyCluster%get('npts'          , natoms_cluster)
        call PyCluster%get('nshells'       , nshells_cluster)
        call PyOptions%get('radius_cluster', radius_cluster)
        call PyOptions%get('radius_active' , radius_active)
        call PyOptions%get('bq_margin'     , bq_margin)
        call PyOptions%get('bq_density'    , bq_density)
        call PyOptions%get('bq_layer'      , bq_layer)
        ! AJL, 12/06/18: Added so we can constrain the cluster charge
        call PyOptions%get('bq_fit_weight' , bq_fit_weight)

        write(*,'(A)') ' BQ fitting configurations'
        write(*,'(A,i12)')    ' fragment natoms            : ', natoms_frag
        write(*,'(A,i12)')    ' fragment nshells           : ', nshells_frag
        write(*,'(A,i12)')    ' cluster natoms             : ', natoms_cluster
        write(*,'(A,i12)')    ' cluster nshells            : ', nshells_cluster
        write(*,'(A,g20.12)') ' cluster radius             : ', radius_cluster
        write(*,'(A,g20.12)') ' active radius              : ', radius_active
        write(*,'(A,g20.12)') ' BQs margin                 : ', bq_margin
        write(*,'(A,g20.12)') ' BQs layer                  : ', bq_layer
        write(*,'(A,i12)')    ' BQs density                : ', bq_density
        write(*,'(A,g20.12)') ' fitting weight             : ', bq_fit_weight
        
        ! nbqs_frag=0 and nbqs_cluster=0
        call fit_bqs(natoms_cluster, 0, nshells_cluster, &
                     natoms_frag   , 0, nshells_frag   , &
                     radius_cluster, radius_active     , &
                     bq_margin, bq_density, bq_layer, bq_fit_weight, ierror)

    endfunction cluster_fit_bqs
    integer(c_int) function cluster_init(fragPtr   ,   &
                                         optionsPtr,   &
                                         chemsh_debug) &
                   result(ierror)                      &
                   bind(c, name='cluster_init')

        implicit none
        type(PyType)         , intent(in) :: fragPtr
        type(PyType)         , intent(in) :: optionsPtr
        integer              , intent(in) :: chemsh_debug

        type(PyType), pointer             :: cellPtr

        debug = chemsh_debug

        ! frag
        allocate(PyFrag, source=ptr2dict(fragPtr))

        ! options
        allocate(PyOptions, source=ptr2dict(optionsPtr))

        ! cell
        call PyFrag%get('cell', cellPtr)
        allocate(PyCell, source=ptr2dict(cellPtr))

        ierror = 0

    endfunction cluster_init
    integer(c_int) function cluster_finalise(chemsh_debug) &
                   result(ierror)                   &
                   bind(c, name='cluster_finalise')

        implicit none
 
        integer, intent(in) :: chemsh_debug

        debug = chemsh_debug

        deallocate(PyFrag, PyOptions, PyCell)

        ierror = 0

    endfunction cluster_finalise
    integer function get_ndims() result(ndims)

        implicit none

        call PyCell%get('ndimensions', ndims)

    endfunction get_ndims

endmodule ChemShellClusterModule

!  Copyright (C) 2017 The authors of Py-ChemShell
!
!  This file is part of Py-ChemShell.
!
!  Py-ChemShell is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as
!  published by the Free Software Foundation, either version 3 of the
!  License, or (at your option) any later version.
!
!  Py-ChemShell is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with Py-ChemShell.  If not, see
!  <http://www.gnu.org/licenses/>.


! cut out a cluster from a periodic crystal structure
integer function cluster_cut(clustersize, clustersize_shells) result(ierr)
  
  use ChemShellClusterModule

  implicit none

  integer, intent(inout)    :: clustersize, clustersize_shells

  integer :: ndim, ncores, nshells
  integer, parameter :: nbqs = 0
  character(len=:), pointer :: crystal_type, coordinated_mode, dimensionality
  double precision :: radius_cluster
  integer :: set_cluster_origin
  double precision :: frac_origin_point(3)

  integer :: i, j, k, l, m, p, ip, l1, sign, jj, ishel, pshel, isite

  ! Arrays for crystal information
  double precision :: a, b, c, alpha, beta, gamma, area, volume
  double precision, dimension(3, 3) :: vect, vecinv, cart_to_frac
  double precision, allocatable :: cart_coords(:,:)
  double precision, allocatable :: f_core(:,:), f_shel(:,:), r_core(:,:), r_shel(:,:)
  double precision, allocatable :: cart_charges(:)
  double precision, allocatable :: charge_core(:), charge_shel(:)
  integer, allocatable :: point_core(:)
  integer, allocatable :: point_shel(:)
  integer, parameter :: max_coord = 14
  integer, allocatable :: coordination(:)
  integer, allocatable :: point_neighbour(:,:)
  double precision, allocatable :: v_neighbour(:,:,:)
  integer, allocatable :: mol_point(:)
  integer, allocatable :: mol_size(:)
  integer, allocatable :: mol_core_point(:,:)
  double precision, allocatable :: mol_vec(:,:)

  double precision, dimension(3) :: f_centre, r_centre
  double precision, dimension(3) :: f, f1, f2, r, r2
  double precision :: romb_side, r_v, radius, radius1, buffer, charge1
  integer :: i_max, j_max, k_max
  integer :: nmol
  double precision, dimension(3) :: sum_f, av_f

  double precision, allocatable :: f_cluster_core(:,:)
  double precision, allocatable :: f_cluster_shel(:,:)
  double precision, allocatable :: r_cluster_core(:,:)
  double precision, allocatable :: r_cluster_shel(:,:)
  double precision, allocatable :: charge_cluster_core(:)
  double precision, allocatable :: charge_cluster_shel(:)
  integer, allocatable :: point_cluster_core(:)
  integer, allocatable :: point_uc_c(:)
  integer, allocatable :: point_uc_s(:)
  integer, allocatable :: point_added(:)
  double precision, allocatable :: r_cluster_mol(:,:)
  integer, allocatable :: point_cluster_mol(:)
  double precision :: charge_cluster
  integer :: tot_uc, max_core, max_shel, max_mol
  integer :: n_cluster_core, n_cluster_shel, n_cluster_mol
  integer :: n_added
  logical :: add_neighbour

  logical :: shell_model

  double precision :: two_pi
  integer, parameter :: periodic_frag = 1, cluster_frag = 2
  double precision, parameter :: d_min = 0.1d0

  double precision :: distance_2, distance_3
  double precision :: dum

  integer :: ncores_new_cluster, nshells_new_cluster

  ierr = 1

  ! get the parameters for the routine from Python
  call PyFrag%get('npts'   , ncores)
  call PyFrag%get('nshells', nshells)
  call PyOptions%get('radius_cluster', radius_cluster)
  call PyOptions%get('crystal_type'  , crystal_type)
  call PyOptions%get('coordinated'   , coordinated_mode)
  call PyOptions%get('origin'        , frac_origin_point)

  ndim = get_ndims()

  allocate(cart_coords(3,ncores+nshells))
  allocate(f_core(3,ncores))
  allocate(f_shel(3,nshells))
  allocate(r_core(3,ncores))
  allocate(r_shel(3,nshells))
  allocate(cart_charges(ncores+nshells))
  allocate(charge_core(ncores))
  allocate(charge_shel(nshells))
  allocate(point_core(nshells))
  allocate(point_shel(ncores))
  allocate(coordination(ncores))
  allocate(point_neighbour(max_coord,ncores))
  allocate(v_neighbour(3,max_coord,ncores))
  allocate(mol_point(ncores))
  allocate(mol_size(ncores))
  allocate(mol_core_point(ncores,ncores))
  allocate(mol_vec(3,ncores))

  if (debug > 0) then
     write(6,'(a)')    "-----------------------------"
     write(6,'(a,i4)') "cluster_cut debug level:", debug
     write(6,'(a)')    "-----------------------------"
  end if

  ! PGI does not like acos in parameter initialisation so initialise here
  two_pi = 2.d0*dacos(-1.d0)

  ! Check there are no point charges
  if (nbqs .ne. 0) then
     write(6,*) "cluster_cut: number of point charges must be zero"
     ierr = 1
     return
  end if

  ! coordinated_mode should only be specified for bulk systems
  if(ndim /= 3 .and. (trim(coordinated_mode).eq.'cations'.or.trim(coordinated_mode).eq.'anions')) then
     write(6,*) "cluster_cut: coordinated_mode only valid for bulk systems"
     ierr = 1
     return     
  end if
  ! molecular mode only for bulk systems
  if (ndim /= 3 .and. trim(crystal_type) .eq. 'molecular') then
     write(6,*) "cluster_cut: molecular crystal type only supported for bulk systems"
     ierr = 1
     return     
  end if
  ! coordinated_mode not compatible with molecular mode
  if((trim(coordinated_mode).eq.'cations'.or.trim(coordinated_mode).eq.'anions').and.trim(crystal_type).eq.'molecular') then
     write(6,*) "cluster_cut: coordinated_mode not valid for molecular crystals"
     ierr = 1
     return     
  end if

  if (nshells .eq. 0) then
     shell_model = .false.
  else
     shell_model = .true.
  end if

  ! Get unit cell vectors from fragment
  vect = 0.0d0
  call get_cell_vectors(periodic_frag, vect, ierr)
  if (ierr .ne. 0) return

  if (debug > 0) then
      write(6,*) "Cell vector:"
      write(6,'(3f12.7)') vect(1,:)
      write(6,'(3f12.7)') vect(2,:)
      write(6,'(3f12.7)') vect(3,:)
  end if 

  ! Call construct routines to generate unit cell parameters
  ! as they will not necessarily be present in the fragment object
  select case (ndim)
  case (2)
     call lattice_parameters_2(vect(1:2, 1:2), area, a, b, gamma)
  case (3)
     call lattice_parameters_3(vect, volume, a, b, c, alpha, beta, gamma)
  case default
     write(6,*) "cluster_cut: error, ndim=", ndim
     ierr = 1
     return
  end select

  ! Calculate inverse cell vector
  vecinv = 0.0d0
  select case (ndim)
  case (2)
     call inverse_2(vect(1:2, 1:2), vecinv(1:2, 1:2), dum)
  case (3)
     call inverse_3(vect, vecinv)
  case default
     write(6,*) "cluster_cut: error, ndim=", ndim
     ierr = 1
     return
  end select

  ! The construct routine takes fractional coordinates of the unit cell
  ! as an input. ChemShell fractional coordinates refer only to the asymmetric
  ! unit. They also are not 'the closest to the origin' (see frac_to_cart).
  ! Therefore we take the final cartesian coordinates and convert back
  ! to fractional coordinates.

  ! Get cartesian coordinates from fragment
  ! Split into core and shell arrays
  call get_cart_coords(periodic_frag, cart_coords, ncores, nshells, ierr)
  if (ierr .ne. 0) return

  ! Convert from cartesians to fractional coordinates
  select case (ndim)
  case (2)
     do i = 1, 2
        do j = 1, 2
           cart_to_frac(i,j) = vecinv(j,i)/two_pi
        end do
     end do
     do isite = 1, ncores
        f_core(1, isite) = cart_to_frac(1,1) * cart_coords(1, isite) &
             + cart_to_frac(2,1) * cart_coords(2, isite)
        f_core(2, isite) = cart_to_frac(1,2) * cart_coords(1, isite) &
             + cart_to_frac(2,2) * cart_coords(2, isite)
        ! Just store the z component
        f_core(3, isite) = cart_coords(3, isite)
     end do
     do isite = 1, nshells
        ishel = ncores + isite
        f_shel(1, isite) = cart_to_frac(1,1) * cart_coords(1, ishel) &
             + cart_to_frac(2,1) * cart_coords(2, ishel)
        f_shel(2, isite) = cart_to_frac(1,2) * cart_coords(1, ishel) &
             + cart_to_frac(2,2) * cart_coords(2, ishel)
        ! Just store the z component
        f_shel(3, isite) = cart_coords(3, ishel)
     end do
  case (3)
     do i = 1, 3
        do j = 1, 3
           cart_to_frac(i,j) = vecinv(j,i)/two_pi
        end do
     end do
     do isite = 1, ncores
        f_core(1, isite) = cart_to_frac(1,1) * cart_coords(1, isite) &
             + cart_to_frac(2,1) * cart_coords(2, isite) + cart_to_frac(3,1) * cart_coords(3, isite)
        f_core(2, isite) = cart_to_frac(1,2) * cart_coords(1, isite) &
             + cart_to_frac(2,2) * cart_coords(2, isite) + cart_to_frac(3,2) * cart_coords(3, isite)
        f_core(3, isite) = cart_to_frac(1,3) * cart_coords(1, isite) &
             + cart_to_frac(2,3) * cart_coords(2, isite) + cart_to_frac(3,3) * cart_coords(3, isite)
     end do
     do isite = 1, nshells
        ishel = ncores + isite
        f_shel(1, isite) = cart_to_frac(1,1) * cart_coords(1, ishel) &
             + cart_to_frac(2,1) * cart_coords(2, ishel) + cart_to_frac(3,1) * cart_coords(3, ishel)
        f_shel(2, isite) = cart_to_frac(1,2) * cart_coords(1, ishel) &
             + cart_to_frac(2,2) * cart_coords(2, ishel) + cart_to_frac(3,2) * cart_coords(3, ishel)
        f_shel(3, isite) = cart_to_frac(1,3) * cart_coords(1, ishel) &
             + cart_to_frac(2,3) * cart_coords(2, ishel) + cart_to_frac(3,3) * cart_coords(3, ishel)
     end do
  case default
     write(6,*) "cluster_cut: error, ndim=", ndim
     ierr = 1
     return
  end select
  if (debug > 3) then
     write(6,'(/a)') "Initial fractional coordinates"
     write(6,'(/a)') "CORES"
     do i = 1, ncores
        write(6,'(i6, 3f12.7)') i, f_core(1:3,i)
     end do
     write(6,'(/a)') "SHELLS"
     do i = 1, nshells
        write(6,'(i6, 3f12.7)') i, f_shel(1:3,i)
     end do
     write(6,*)
  end if

  ! Get charges of cartesian sites from fragment
  ! Split into core and shell arrays
  call get_cart_charges(periodic_frag, cart_charges, ncores+nshells, ierr)
  if (ierr .ne. 0) return
  charge_core = cart_charges(1:ncores)
  if (shell_model) charge_shel = cart_charges(ncores+1:ncores+nshells)

  ! Get pointers from shells to cores
  ! Then setup pointers in the other direction
  point_shel = 0
  if (shell_model) then
     call get_point_core(periodic_frag, point_core, nshells, ierr)
     if (ierr .ne. 0) return
     do i = 1, nshells
        point_shel(point_core(i)) = i
     end do
  end if

  ! YL 15/11/2019: user input of origin is only processed in Python
  ! f_centre is fractional and r_centre is cartesian
  ! YL 15/11/2019: frac_origin_point is always fractional on the Fortran side
  f_centre = frac_origin_point

  ! Translate cores towards the nominated centre and track shells
  select case (ndim)
  case (2)
     call transform_2(vect(1:2,1:2), f_centre(1:2), r_centre(1:2))
     r_centre(3) = f_centre(3)
     do i = 1, ncores
        f(1:2) = f_core(1:2,i)
        call translate_2(vect(1:2,1:2), f_centre(1:2), f(1:2), r(1:2))
        f_core(1:2,i) = f(1:2)
        r_core(1:2,i) = r(1:2)
        r_core(3,i) = f_core(3,i)
        if (shell_model) then
           j=point_shel(i)
           if(j.ne.0) then
              f1(1:2) = f_core(1:2,i)
              f2(1:2) = f_shel(1:2,j)
              call translate_2(vect(1:2,1:2), f1(1:2), f2(1:2), r(1:2))
              f_shel(1:2,j) = f2(1:2)
              r_shel(1:2,j) = r(1:2)
              r_shel(3,j) = f_shel(3,j)
           endif
        endif
     enddo
  case (3)
     call transform_3(vect, f_centre, r_centre)
     do i=1,ncores
        f(1:3) = f_core(1:3,i)
        call translate_3(vect,f_centre,f,r)
        f_core(1:3,i) = f(1:3)
        r_core(1:3,i) = r(1:3)
        if(shell_model) then
           j=point_shel(i)
           if(j.ne.0) then
              f1(1:3)=f_core(1:3,i)
              f2(1:3)=f_shel(1:3,j)
              call translate_3(vect,f1,f2,r)
              f_shel(1:3,j) = f2(1:3)
              r_shel(1:3,j) = r(1:3)
           endif
        endif
     enddo
  end select

  ! YL 17/11/2019: save to module
  cluster_origin = r_centre

  if (debug > 0) then
     write(6,'(/a)') "Cluster origin"
     write(6,'(/a)') "Fractional"
     write(6,'(4x, 3f12.7)') f_centre(1:3)
     write(6,'(/a)') "Cartesian"
     write(6,'(4x, 3f12.7)') r_centre(1:3)
     write(6,*)
  endif
  if (debug > 3) then
     write(6,'(/a)') "Fractional coords after translation to centre"
     write(6,'(/a)') "CORES"
     do i = 1, ncores
        write(6,'(i6, 3f12.7)') i, f_core(1:3,i)
     end do
     write(6,'(/a)') "SHELLS"
     do i = 1, nshells
        write(6,'(i6, 3f12.7)') i, f_shel(1:3,i)
     end do
     write(6,*)
  end if
  if (debug > 3) then
     write(6,'(/a)') "Cartesian coords after translation to centre"
     write(6,'(/a)') "CORES"
     do i = 1, ncores
        write(6,'(i6, 3f12.7)') i, r_core(1:3,i)
     end do
     write(6,'(/a)') "SHELLS"
     do i = 1, nshells
        write(6,'(i6, 3f12.7)') i, r_shel(1:3,i)
     end do
     write(6,*)
  end if

  ! Determine coordination number and neighbours for all atoms in the unit cell
  coordination(:) = 0
  call periodic_neighbour_list(ncores, coordination, point_neighbour, v_neighbour, ierr)
  if (ierr .ne. 0) return
  if (debug > 0) then
     write(6,'(/a)') "Crystal neighbour list"
     do i = 1, ncores
        write(6,'(i4,a,i4)') i, ":", coordination(i)
        do j = 1, coordination(i)
           write(6,'(2x,i4,2x,3f12.7)') point_neighbour(j,i), v_neighbour(1:3,j,i)
        end do
        write(6,*)
     end do
     write(6,*)
  end if

  ! Generate list of molecules
  nmol = 0
  mol_point = 0
  mol_size = 0
  mol_core_point = 0
  if(trim(crystal_type).eq.'molecular') then
     do i = 1, ncores
        ! Ignore atoms already assigned to a molecule
        if (mol_point(i) /= 0) cycle 
        ! New molecule
        nmol = nmol + 1
        mol_point(i) = nmol
        mol_vec(:,i) = 0.0d0
        ! Find all atoms in the molecule by a recursive search
        call traverse_molecule(i)
     end do
     do i = 1, ncores
        j = mol_point(i)
        mol_size(j) = mol_size(j) + 1
        mol_core_point(mol_size(j), j) = i
     end do
     if (debug > 0) then
        write(6,'(/a,i4)') "Number of molecules: ", nmol
        do i = 1, nmol
           write(6,'(i4,a,i4)') i, ':', mol_size(i)
           do j = 1, mol_size(i)
              write(6,'(i6,2x,3f12.7)') mol_core_point(j,i), mol_vec(1:3,mol_core_point(j,i))
           end do
        end do
     end if
  end if

  ! Determine extent of cluster, allocate memory
  select case (ndim)
  case (2)
     ! Calculate extensions of UC which includes the cluster hemisphere
     romb_side = radius_cluster / dabs(dsin(gamma))
     i_max = romb_side / a + 1
     j_max = romb_side / b + 1
     k_max = 0
     tot_uc = (2 * i_max + 1) * (2 * j_max + 1)
  case (3)
     ! Calculate extensions of UC which includes the cluster sphere 
     r_v = radius_cluster / volume
     i_max = r_v * b * c * dabs(dsin(alpha)) + 1
     j_max = r_v * a * c * dabs(dsin( beta)) + 1
     k_max = r_v * a * b * dabs(dsin(gamma)) + 1
     tot_uc = (2 * i_max + 1) * (2 * j_max + 1) * (2 * k_max + 1)
  case default
     write(6,*) "cluster_cut: error, ndim=", ndim
     ierr = 1
     return
  end select
  max_core = tot_uc * ncores
  max_shel = tot_uc * nshells
  max_mol = tot_uc * nmol
  allocate(f_cluster_core(3,max_core))
  allocate(f_cluster_shel(3,max_shel))
  allocate(r_cluster_core(3,max_core))
  allocate(r_cluster_shel(3,max_shel))
  allocate(charge_cluster_core(max_core))
  allocate(charge_cluster_shel(max_shel))
  allocate(point_cluster_core(max_shel))
  allocate(point_uc_c(max_core))
  allocate(point_uc_s(max_shel))
  allocate(point_added(max_core))
  allocate(r_cluster_mol(3,max_mol))
  allocate(point_cluster_mol(max_core))
  if (debug > 0) then
     write(6,'(/a)') "Unit cell extensions"
     write(6,'(/a,4i8)') "i_max, j_max, k_max, tot_uc: ", i_max, j_max, k_max, tot_uc
     write(6,'(a,3i8)') "max_core, max_shel, max_mol: ", max_core, max_shel, max_mol
     write(6,*)
  end if

  ! Build the cluster
  n_cluster_core = 0
  n_cluster_shel = 0
  ! n_added refers to atoms that are outside the cluster boundary
  ! but have been added to ensure full coordination of cations/anions
  n_added = 0
  point_added(:) = 0
  ! Molecular information for sorting molecular crystals
  n_cluster_mol = 0
  r_cluster_mol(1:3,:) = 0.0d0
  point_cluster_mol(:) = 0
  select case (ndim)
  case (2)
     if (trim(crystal_type).eq.'molecular') then
        write(6,*) "Surface cutting for molecular crystals not supported."
        ierr = 1
        return
     end if
     do i=-i_max,i_max
        do j=-j_max,j_max
           do p=1,ncores
              f(1)=f_core(1,p)+i
              f(2)=f_core(2,p)+j
              f(3)=f_core(3,p)
              radius=distance_2(vect(1:2,1:2),f(1:2),r_core(3,p), &
                   f_centre(1:2),f_centre(3))
              if(radius < radius_cluster) then
                 n_cluster_core = n_cluster_core + 1
                 f_cluster_core(1:3, n_cluster_core) = f(1:3)
                 point_uc_c(n_cluster_core) = p
              endif
           enddo !p
        enddo !j
     enddo !i
     charge_cluster=0.d0
     do i = 1, n_cluster_core
        ! Core coordinates and charges
        f(1:2) = f_cluster_core(1:2,i)        
        call transform_2(vect(1:2,1:2), f(1:2), r(1:2))
        r_cluster_core(1:2,i) = r(1:2)
        r_cluster_core(3,i) = f_cluster_core(3,i)
        j = point_uc_c(i)
        charge_cluster_core(i) = charge_core(j)
        charge_cluster = charge_cluster + charge_cluster_core(i)
     end do
  case(3)
     selectcase(trim(crystal_type))
     case('ionic', 'covalent')
        ! Extended crystals (ionic or covalent)
        do i=-i_max,i_max
           do j=-j_max,j_max
              do k=-k_max,k_max
                 do p=1,ncores
                    f(1)=f_core(1,p)+i
                    f(2)=f_core(2,p)+j
                    f(3)=f_core(3,p)+k
                    radius=distance_3(vect,f,f_centre)
                    if (radius < radius_cluster) then
                       ! All atoms within cutoff are added to cluster
                       n_cluster_core = n_cluster_core + 1
                       f_cluster_core(1:3, n_cluster_core) = f(1:3)
                       point_uc_c(n_cluster_core) = p
                       ! Atoms outside cutoff may also be added if
                       ! they neighbour a cluster atom and they are 
                       ! required to fully coordinate that atom
                       ! (depending on the coordinated_mode mode)
                       if(trim(coordinated_mode).eq.'cations'.or.trim(coordinated_mode).eq.'anions') then
                          charge1 = charge_core(p)
                          if (shell_model .and. point_shel(p) /= 0) then
                             charge1 = charge1 + charge_shel(point_shel(p))
                          endif
                          do l = 1, coordination(p)
                             l1 = point_neighbour(l,p)
                             ! Vector to the neighbour
                             call transform_3(cart_to_frac, v_neighbour(:,l,p), f2)
                             ! Absolute position of the neighbour
                             f2(1:3) = f2(1:3) + f(1:3)
                             radius1 = distance_3(vect, f2, f_centre)
                             ! Fully coordinate cations or anions depending on mode
                             sign = 1
                             if (trim(coordinated_mode).eq.'anions') sign = -1
                             if (radius1 > radius_cluster .and. &
                                  (sign * charge1) > 0) then
                                add_neighbour = .true.
                                do jj = 1, n_cluster_core
                                   if(point_added(jj).eq.1) then
                                      f1(1:3) = f_cluster_core(1:3, jj)
                                      radius = distance_3(vect, f1, f2)
                                      if(radius.lt.d_min) then
                                         add_neighbour = .false.
                                         exit
                                      end if
                                   end if
                                end do
                                if (add_neighbour) then
                                   n_cluster_core = n_cluster_core + 1
                                   f_cluster_core(1:3, n_cluster_core) = f2(1:3)
                                   point_added(n_cluster_core) = 1
                                   n_added = n_added + 1
                                   point_uc_c(n_cluster_core) = l1
                                endif !add_neighbour
                             endif !radius1>radius_cluster
                          enddo !coordination
                       endif !trim(coordinated_mode)
                    endif !radius<radius_cluster
                 enddo !p
              enddo !k
           enddo !j
        enddo !i
     case('molecular')
        ! Molecular crystals
        ! If the average distance of the molecule from the centre is below the 
        ! cluster radius the whole molecule is added to the cluster 
        if (ndim /= 3) then
           write(6,*) "cluster_cut: error, 3D molecular crystals only"
           ierr = 1
           return
        end if
        do i=-i_max,i_max
           do j=-j_max,j_max
              do k=-k_max,k_max
                 do m=1, nmol
                    ! Calculate distance of molecule centroid from cluster centre 
                    sum_f(1:3) = 0.0d0
                    ! Anchor atom
                    p = mol_core_point(1, m)
                    f(1)=f_core(1,p)+i
                    f(2)=f_core(2,p)+j
                    f(3)=f_core(3,p)+k                   
                    do ip = 1, mol_size(m)
                       p = mol_core_point(ip, m)
                       call transform_3(cart_to_frac, mol_vec(1:3,p), f2)
                       f2(1:3)=f2(1:3)+f(1:3)
                       sum_f(1:3) = sum_f(1:3) + f2(1:3)
                    end do
                    av_f(1:3) = sum_f(1:3) / mol_size(m)
                    radius = distance_3(vect,av_f,f_centre)
                    if (radius < radius_cluster) then
                       n_cluster_mol = n_cluster_mol + 1
                       ! Centroid stored for sorting cores later
                       call transform_3(vect, av_f(1:3), r_cluster_mol(1:3, n_cluster_mol))
                       ! All atoms in molecule are added to cluster
                       do ip = 1, mol_size(m)
                          p = mol_core_point(ip, m)
                          call transform_3(cart_to_frac, mol_vec(1:3,p), f2)
                          f2(1:3)=f2(1:3)+f(1:3)
                          n_cluster_core = n_cluster_core + 1
                          f_cluster_core(1:3, n_cluster_core) = f2(1:3)
                          point_uc_c(n_cluster_core) = p
                          point_cluster_mol(n_cluster_core) = n_cluster_mol
                       end do !ip
                    end if !radius < radius_cluster
                 end do !m
              end do !k
           end do !j
        end do !i
     case default
        write(6,*) "cluster_cut ERROR: crystal_type =", crystal_type
        ierr = 1
        return
     end select
     ! Cluster coordinates and charges
     charge_cluster = 0.0d0
     do i = 1, n_cluster_core
        ! Core coordinates and charges
        f(1:3) = f_cluster_core(1:3,i)
        call transform_3(vect,f,r)
        r_cluster_core(1:3,i) = r(1:3)
        j = point_uc_c(i)
        charge_cluster_core(i) = charge_core(j)
        charge_cluster = charge_cluster + charge_cluster_core(i)
     end do
  case default
     write(6,*) "cluster_cut ERROR: ndim=", ndim
     ierr = 1
     return
  end select
  ! This should never happen and would probably cause a crash but just in case
  if (n_cluster_core > max_core) then
     write(6,'(a,i6,a,i6)') "cluster_cut: error, n_cluster_core=", n_cluster_core, &
          " > max_core=", max_core
     ierr = 1
     return
  end if
  if (n_cluster_mol > max_mol) then
     write(6,'(a,i6,a,i6)') "cluster_cut: error, n_cluster_mol=", n_cluster_mol, &
          " > max_mol=", max_mol
     ierr = 1
     return
  end if
  if (debug > 4) then
     write(6,'(/a)') "Unsorted cluster cartesian coords and map back to UC (+point_added)"
     write(6,'(/a)') "CORES"
     do i = 1, n_cluster_core
        write(6,'(i6, 3f12.7,i6,i6)') i, r_cluster_core(1:3,i), point_uc_c(i), point_added(i)
     end do
  end if
  
  ! Sort cores into a more convenient order
  call sort_cores(crystal_type, 1, n_cluster_core)
 
  if (debug > 3) then
     write(6,'(/a)') "Sorted cluster cartesian coords and map back to UC (+point_added for cores)"
     write(6,'(/a)') "CORES"
     do i = 1, n_cluster_core
        write(6,'(i6, 3f12.7,i6,i6)') i, r_cluster_core(1:3,i), point_uc_c(i), point_added(i)
     end do
  end if

  ! Assign cluster shell coordinates and charges
  if (shell_model) then 
     do i = 1, n_cluster_core
        j = point_uc_c(i)
        k = point_shel(j)
        if (k /= 0) then
           n_cluster_shel = n_cluster_shel + 1
           point_uc_s(n_cluster_shel) = k
           point_cluster_core(n_cluster_shel) = i
           select case (ndim)
           case (2)
              f(1:2) = f_cluster_core(1:2,i)
              f2(1:2) = f_shel(1:2,k)
              call translate_2(vect(1:2,1:2),f(1:2),f2(1:2),r2(1:2))
              f_cluster_shel(1:2,n_cluster_shel) = f2(1:2)
              f_cluster_shel(3,n_cluster_shel) = f_shel(3,k)
              r_cluster_shel(1:2,n_cluster_shel) = r2(1:2)
              r_cluster_shel(3,n_cluster_shel) = f_shel(3,k)
           case (3)
              f(1:3) = f_cluster_core(1:3,i)
              f2(1:3) = f_shel(1:3,k)
              call translate_3(vect,f,f2,r2)
              f_cluster_shel(1:3,n_cluster_shel)=f2(1:3)
              r_cluster_shel(1:3,n_cluster_shel)=r2(1:3)
           end select
           charge_cluster_shel(n_cluster_shel) = charge_shel(k)  
           charge_cluster = charge_cluster + charge_cluster_shel(n_cluster_shel)
        end if
     end do
     if (n_cluster_shel > max_shel) then
        write(6,'(a,i6,a,i6)') "cluster_cut: error, n_cluster_shel=", n_cluster_shel, &
             " > max_shel=", max_shel
        ierr = 1
        return
     end if
     if (debug > 3) then
        write(6,'(/a)') "SHELLS"
        do i = 1, n_cluster_shel
           write(6,'(i6, 3f12.7,i6)') i, r_cluster_shel(1:3,i), point_uc_s(i)
        enddo
        write(6,*)
     end if
  end if

  if(clustersize.eq.0) then
      clustersize        = n_cluster_core
      clustersize_shells = n_cluster_shel
      return
  endif

  ! Write the cluster to the fragment object
  call setCluster(r_cluster_core, r_cluster_shel,           &
                  charge_cluster_core, charge_cluster_shel, &
                  point_uc_c, point_uc_s,                   &
                  point_cluster_core, ierr)

! Old call:
!  call set_cart_cluster(cluster_frag, periodic_frag, &
!       ncores, nshells, f_core, f_shel, &
!       ncores_cluster, nshels_cluster, r_cluster_core, r_cluster_shel, &
!       charge_cluster, charge_cluster_core, charge_cluster_shel, &
!       point_cluster_core, point_uc_c, point_uc_s, ierr)

  ! Write out origin in cartesians
  ierr = set_cluster_origin(r_centre)
  if (ierr .ne. 0) return

  ! Deallocate
  deallocate(f_cluster_core)
  deallocate(f_cluster_shel)
  deallocate(r_cluster_core)
  deallocate(r_cluster_shel)
  deallocate(charge_cluster_core)
  deallocate(charge_cluster_shel)
  deallocate(point_cluster_core)
  deallocate(point_uc_c)
  deallocate(point_uc_s)
  deallocate(point_added)
  deallocate(r_cluster_mol)
  deallocate(point_cluster_mol)

  deallocate(cart_coords)
  deallocate(f_core)
  deallocate(f_shel)
  deallocate(r_core)
  deallocate(r_shel)
  deallocate(cart_charges)
  deallocate(charge_core)
  deallocate(charge_shel)
  deallocate(point_core)
  deallocate(point_shel)
  deallocate(coordination)
  deallocate(point_neighbour)
  deallocate(v_neighbour)
  deallocate(mol_point)
  deallocate(mol_size)
  deallocate(mol_core_point)
  deallocate(mol_vec)

  ierr = 0

  call flush(6)

contains

  recursive subroutine traverse_molecule(icore)
    integer :: icore, icoord, pn
    do icoord = 1, coordination(icore)
       pn = point_neighbour(icoord, icore)
       if (mol_point(pn) == 0) then
          mol_point(pn) = nmol
          mol_vec(:,pn) = mol_vec(:,icore) + v_neighbour(:,icoord,icore) 
          call traverse_molecule(pn)
       end if
    end do
  end subroutine traverse_molecule
  
  recursive subroutine sort_cores(crystal_type, left, right)
    ! Quicksort
    integer :: left, right, pivot, newpivot
    character(*) :: crystal_type

    if (right > left) then
       pivot = left+((right-left)/2)
       if (trim(crystal_type).eq.'molecular') then
          newpivot = partition_mols(left, right, pivot)
       else
          newpivot = partition_cores(left, right, pivot)
       end if
       call sort_cores(crystal_type, left, newpivot - 1)
       call sort_cores(crystal_type, newpivot + 1, right)
    end if
  end subroutine sort_cores

  integer function partition_cores(left, right, pivot)
    integer :: left, right, pivot, store, spi
    double precision, dimension(3) :: rspi, rpivot
    rpivot = r_cluster_core(:, pivot)
    call swap_cores(pivot, right)
    store = left
    do spi = left, right-1
       rspi = r_cluster_core(:, spi)
       if (cmp_points(rspi, rpivot) == 1) then
          call swap_cores(spi, store)
          store = store + 1
       end if
    end do
    call swap_cores(store, right)
    partition_cores = store
  end function partition_cores

  integer function partition_mols(left, right, pivot)
    integer :: left, right, pivot, pivotmol, pivotuc, store, spi, spimol
    double precision, dimension(3) :: rspi, rpivot
    ! Cores in molecular crystals are sorted using molecule centroids
    pivotmol = point_cluster_mol(pivot)
    rpivot = r_cluster_mol(:, pivotmol)
    pivotuc = point_uc_c(pivot)
    call swap_cores(pivot, right)
    store = left
    do spi = left, right-1
       spimol = point_cluster_mol(spi)
       if (pivotmol == spimol) then
          ! Cores are in the same molecule
          ! Retain order from the input cell
          if (point_uc_c(spi) < pivotuc) then
             call swap_cores(spi, store)
             store = store + 1
          end if
       else
          ! Cores are in different molecules
          ! Sort by molecule centroid
          rspi = r_cluster_mol(:, spimol)
          if (cmp_points(rspi, rpivot) == 1) then
             call swap_cores(spi, store)
             store = store + 1
          end if
       end if
    end do
    call swap_cores(store, right)
    partition_mols = store
  end function partition_mols

  integer function cmp_points(ri, rj)
    ! Points (cores or molecules) are sorted according to:
    ! 1. Shortest distance to the origin
    ! 2. Highest Z
    ! 3. Angle on XY plane (atan2)
    !
    ! Returns:
    !  1 if ri before rj
    ! -1 if ri after rj
    !  0 if ri = rj
    !
    double precision, dimension(3) :: ri, rj, vi, vj
    double precision, parameter :: cmp_tol = 1.0d-4
    double precision :: disti, distj, ati, atj
    vi = ri - r_centre
    vj = rj - r_centre
    ! 1st test: shortest distance to origin
    disti = sqrt(dot_product(vi,vi))
    distj = sqrt(dot_product(vj,vj))
    if (disti < (distj - cmp_tol)) then
       cmp_points = 1
       return
    else if (distj < (disti - cmp_tol)) then
       cmp_points = -1
       return
    endif
    ! 2nd test: highest Z coordinate
    if (ri(3) > (rj(3) + cmp_tol)) then
       cmp_points = 1
       return
    else if (rj(3) > (ri(3) + cmp_tol)) then
       cmp_points = -1
       return
    endif
    ! 3rd test: angle on XY plane
    ati = atan2(ri(2), ri(1))
    atj = atan2(rj(2), rj(1))
    if (ati > atj) then
       cmp_points = 1
    else if (ati < atj) then
       cmp_points = -1
    else 
       cmp_points = 0
    end if
    end function cmp_points

    subroutine swap_cores(pi, pj)
      ! Swap two cores in cluster 
      ! Do not call after shells have been assigned
      integer :: pi, pj, si, sj
      integer :: idum
      double precision :: ddum
      double precision, dimension(3) :: rdum

      rdum = f_cluster_core(:,pi)
      f_cluster_core(:,pi) = f_cluster_core(:,pj)
      f_cluster_core(:,pj) = rdum

      rdum = r_cluster_core(:,pi)
      r_cluster_core(:,pi) = r_cluster_core(:,pj)
      r_cluster_core(:,pj) = rdum

      ddum = charge_cluster_core(pi)
      charge_cluster_core(pi) = charge_cluster_core(pj)
      charge_cluster_core(pj) = ddum

      idum = point_uc_c(pi)
      point_uc_c(pi) = point_uc_c(pj)
      point_uc_c(pj) = idum

      idum = point_added(pi)
      point_added(pi) = point_added(pj)
      point_added(pj) = idum

      idum = point_cluster_mol(pi)
      point_cluster_mol(pi) = point_cluster_mol(pj)
      point_cluster_mol(pj) = idum

    end subroutine swap_cores
 
end function cluster_cut

!!****h* main/dlf_global
!!
!! FUNCTION
!! Module to store global data and arrays
!!
!! Most input parameters and global options are documented here
!!
!! The following routines have to be changed if this module is changed:
!! * dlf_default_init
!! * dlf_default_set
!! * dlf_get_params (external !)
!! * dlf_checkpoint_write
!! * dlf_checkpoint_read
!! * and others, depending on the change
!!
!! DATA
!! $Date$
!! $Rev$
!! $Author$
!! $URL$
!! $Id$
!!
!! COPYRIGHT
!!
!!  Copyright 2007 Johannes Kaestner (kaestner@theochem.uni-stuttgart.de),
!!  Tom Keal (thomas.keal@stfc.ac.uk)
!!
!!  This file is part of DL-FIND.
!!
!!  DL-FIND is free software: you can redistribute it and/or modify
!!  it under the terms of the GNU Lesser General Public License as 
!!  published by the Free Software Foundation, either version 3 of the 
!!  License, or (at your option) any later version.
!!
!!  DL-FIND is distributed in the hope that it will be useful,
!!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!!  GNU Lesser General Public License for more details.
!!
!!  You should have received a copy of the GNU Lesser General Public 
!!  License along with DL-FIND.  If not, see 
!!  <http://www.gnu.org/licenses/>.
!!
!! SYNOPSIS
module dlf_global
  use dlf_parameter_module, only: rk
  implicit none

  ! Type declaration
  type glob_type
    integer  :: nvar        ! number of xyz variables (3*nat)
    integer  :: nat         ! number of xyz atoms
    real(rk) :: tolerance   ! main convergence criterion (Max grad comp.)
    real(rk) :: tolerance_e ! convergence criterion on energy change
    real(rk) :: energy
    real(rk) :: oldenergy
    logical  :: toldenergy  ! is oldenergy defined?
    logical  :: tinit=.false. ! true if this instance is initialised
    logical  :: tatoms      ! atoms or arbitrary DOF
    integer  :: maxcycle    ! maximum number of cycles
    integer  :: maxene      ! maximum number of E&G evaluations
    real(rk) :: distort     ! shift start structure along coords2 (+ or -)
    logical  :: massweight  ! use mass-weighted coordinates
    integer  :: maxdump     ! do only dump restart file after the at most
                            !   maxdump E&G evaluations
    logical  :: toldenergy_conv ! does the convergence module know of 
                            !     an old energy?
    real(rk) :: oldenergy_conv ! value of the old energy in convergence
    integer  :: task        ! number of taks for the task manager

    ! Types of calculations
    integer  :: iopt         ! type of optimisation algorithm
    integer  :: iline        ! type of line search or trust radius
    integer  :: imultistate  ! type of multistate calculation (0 = none)
    integer  :: needcoupling ! true if interstate coupling gradients 
                             !  should be calculated
    integer  :: imicroiter   ! flag for microiterative calculations 
                             ! =0 : standard, non-microiterative calculation
                             ! >0 : microiterative calculation
                             !  [=1 : inside macroiterative loop]
                             !  [=2 : inside microiterative loop]

    ! Line search properties
    real(rk) :: maxstep     ! maximum length of the step in internals
    real(rk) :: scalestep   ! constant factor with which to scale the step
    logical  :: taccepted   ! is this step accepted

    ! Optimiser parameters
    integer  :: lbfgs_mem   ! number of steps in LBFGS memory
    real(rk) :: temperature ! temperature for thermal analysis

    ! qTS parameters
    integer  :: nzero       ! number of zero vibrational modes in system 
    integer  :: qtsflag     ! additional info, like if tunnelig splittings are
                            ! to be calculated (see dlf_qts.f90)

    ! Damped dynamics
    real(rk) :: timestep 
    real(rk) :: fric0       ! start friction
    real(rk) :: fricfac     ! factor to reduce friction (<1) whenever
                            !   the energy is decreasing
    real(rk) :: fricp       ! friction to use whenever energy increasing

    ! Conical intersection search
    integer  :: state_i     ! lower state
    integer  :: state_j     ! upper state
    real(rk) :: pf_c1       ! penalty function parameter (aka alpha)
    real(rk) :: pf_c2       ! penalty function parameter (aka beta)
    real(rk) :: gp_c3       ! gradient projection parameter (aka alpha0)
    real(rk) :: gp_c4       ! gradient projection parameter (aka alpha1)
    real(rk) :: ln_t1       ! Lagrange-Newton orthogonalisation on 
                            !   threshold
    real(rk) :: ln_t2       ! Lagrange-Newton orthogonalisation off 
                            !   threshold

    ! hessian parameters
    integer  :: update      ! Hessian update scheme
    integer  :: maxupd      ! Maximum number of Hessian updates
    real(rk) :: delta       ! Delta-x in finite-difference Hessian
    real(rk) :: soft        ! Abs(eigval(hess)) < soft -> ignored in P-RFO
    integer  :: inithessian ! Option for method of calculating the initial 
                            !   Hessian
    integer  :: carthessian ! Hessian update in cartesians?
    logical  :: tsrelative  ! Transition vector I/O absolute or relative?
    real(rk) :: minstep     ! Hessian is not updated if step < minstep

    ! internal coordinates
    integer  :: icoord      ! type of internal coordinates
    integer  :: icoordinner ! type of internal coordinates for inner region
    integer  :: nivar       ! number of variables in internals
    logical  :: tcoords2    ! are coords2 used?
    integer  :: nimage      ! Number of images (e.g. in NEB)
    real(rk) :: nebk        ! force constant for NEB
    real(rk) :: neb_climb_test  ! threshold scale factor for spawning climbing image
    real(rk) :: neb_freeze_test ! threshold scale factor for freezing NEB images
    integer  :: maxrot      ! maximum number of rotations in each DIMER step
    real(rk) :: tolrot      ! angle tolerance for rotation (deg) in DIMER

    integer  :: ncons       ! number of constraints
    integer  :: nconn       ! number of user provided connections

    logical  :: havehessian ! do we have a valid hessian?

    ! restarting
    integer  :: dump        ! after how many E&G calculations to dump a 
                            !   checkpoint file?
    integer  :: restart     ! restart mode: 0 new, 1 read dump file ...

    ! cleanup
    integer :: cleanup      ! check that dlf_fail does not enter an infinite loop
                            ! when cleaning up allocatable arrays

    ! Parallel optimisation
    integer  :: po_pop_size      ! sample population size
    real(rk) :: po_radius_base   ! base value for the sample radii
    real(rk) :: po_contraction   ! factor by which the search radius decreases between 
                                 ! search cycles.  Cycle = 1 energy eval for 
                                 ! each member of the sample population.
    real(rk) :: po_tolerance_g   ! convergence criterion: max abs component of g
    real(rk) :: po_tol_r_base    ! base value for the radii tolerances
    integer  :: po_distribution  ! type of distribn of sample points in space
    integer  :: po_maxcycle      ! maximum number of cycles
    integer  :: po_init_pop_size ! size of initial population
    integer  :: po_reset         ! number of cycles before population resetting
    real(rk) :: po_mutation_rate ! Fraction of the total number of coordinates 
                                 ! in the population to be mutated (randomly 
                                 ! shifted) per cycle
    real(rk) :: po_death_rate    ! Fraction of the population to be replaced by
                                 ! offspring per cycle 
    real(rk) :: po_scalefac      ! Multiplying factor for the absolute gradient 
                                 ! vector in the force_bias stoch. search scheme
    integer  :: po_nsave         ! number of low-energy minima to store

    ! MPI-related variables that need to be known throughout the code, with 
    ! initialization for the case of a serial buils without a call to the dummy 
    ! routine dlf_mpi_initialize
    integer  :: nprocs=1         ! Total number of processors involved
    integer  :: ntasks=1         ! number of taskfarms (workgroups)
    integer  :: nprocs_per_task=1 ! number of processors per taskfarm
    integer  :: iam=0            ! rank (or index, starting from zero) of this 
                                 ! processor within global_comm
    integer  :: iam_in_task=0    ! rank (or index, starting from zero) of this
                                 ! processor within the most local communicator
    integer  :: mytask=0         ! index, starting from zero, of the task farm 
                                 ! to which this processor belongs
    !integer  :: master_in_task   ! rank of the spokesperson proc in each farm
    !                             ! within the communicator of a taskfarm

    integer  :: serial_cycle     ! Parallel NEB - calculate the first e/g array
                                 ! on all processors to ensure each image 
                                 ! calculation starts from a good guess on 
                                 ! the first cycle
    logical  :: dotask=.true.    ! Flag set if this processor should do the
                                 ! task in question

   ! ARRAYS
    real(rk),allocatable :: xcoords(:,:) ! xyz coordinates 
                                         !   (3,nat) / (1,nvar)
    real(rk),allocatable :: xcoords2(:,:,:)! xyz coordinates second set
                                         ! (3,nat,nframe) / (1,nvar,nframe)
                                         ! or different, depending 
                                         ! on the purpose!
    real(rk),allocatable :: xgradient(:,:)! xyz gradient (3,nat) / (1,nvar)
    integer ,allocatable :: znuc(:)      ! nuclear charges (nat)
    real(rk),allocatable :: weight(:)    ! weight for tsmodes etc (nat)
    real(rk),allocatable :: iweight(:)   ! weight of internal coordinates
                                         !   (nivar)
    real(rk),allocatable :: mass(:)      ! atomic mass (nat)

    ! arrays concerning internals
    real(rk),allocatable :: icoords(:)   ! internal coords (nivar)
    real(rk),allocatable :: igradient(:) ! gradient in internals (nivar)
    real(rk),allocatable :: ihessian(:,:)! Hessian in internals (nivar,nivar)
                                         !  allocation handled in formstep
    real(rk),allocatable :: step(:)      ! step in internals (nivar)
    integer ,allocatable :: spec(:)      ! (nat) fragment number, or
                                         ! -1: frozen,
                                         ! -2: x frozen, see dlf_coords.f90
    integer ,allocatable :: icons(:,:)   ! (5,ncons) constraints
    integer ,allocatable :: iconn(:,:)   ! (2,ncons) user provided 
                                         !  connections

    ! multiple state arrays for conical intersection searches
    real(rk),allocatable :: msenergy(:)       ! multistate energy
    real(rk),allocatable :: msgradient(:,:,:) ! xyz multistate gradients
    real(rk),allocatable :: mscoupling(:,:)   ! xyz interstate coupling 
                                              !   gradient

    ! arrays for parallel optimisation
    real(rk), allocatable :: po_radius(:) ! per-atom search radii (the prevailing units)
    real(rk), allocatable :: po_tolerance_r(:) ! tolerances on po_radius: stop if any component 
             ! of po_radius shrinks to less than the corresponding component of po_tolerance_r
    real(rk), allocatable :: po_radius_scaling(:) ! vector of scaling factors to convert 
             ! the base values (po_radius_base and po_tol_r_base) into the above 2 vectors.

    ! microiterative optimisation
    integer ,allocatable :: micspec(:)  ! (nat) inner region flag from spec array
    integer :: nicore ! number of internal coordinates in inner region 
                      ! (=0 for non-microiterative calculation)
    integer :: maxmicrocycle ! max number of microiterative cycles 
                             ! before switching back to macro
    logical :: micro_esp_fit ! fit ESP charges to inner region during microiterations
    ! ESP fit correction arrays
    ! final dimension in each is for multiple images
    real(rk),allocatable :: macrocoords(:,:,:) ! xyz coordinates for last macro step
    real(rk),allocatable :: g0corr(:,:,:)      ! xyz gradient correction for ESP fit
    real(rk),allocatable :: e0corr(:)                      ! E0 - E0(esp)

  end type glob_type

  ! Variables in the module
  type(glob_type) ,save :: glob
  integer           :: stdout=6
  integer           :: stderr=0
  real(rk)          :: pi     ! 3.1415...
  integer           :: printl ! how verbosely to write info to stdout
  integer           :: printf ! how verbosely files should be written
  logical           :: keep_alloutput=.true. ! Can be used to provide some 
  ! control over I/O in a parallel run, in conjunction with the interface 
  ! routine dlf_output.  For example: if true, write the output from 
  ! procs with rank > 0 to output.proc<proc number>, instead of standard 
  ! output.  Otherwise the output goes to /dev/null, instead of standard out. 

end module dlf_global
!!****

!  Copyright (C) 2017 The authors of Py-ChemShell
!
!  This file is part of Py-ChemShell.
!
!  Py-ChemShell is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as
!  published by the Free Software Foundation, either version 3 of the
!  License, or (at your option) any later version.
!
!  Py-ChemShell is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with Py-ChemShell.  If not, see
!  <http://www.gnu.org/licenses/>.

! WG = Workgroup
module ChemShellParallelModule

    use iso_c_binding
    use mpi
!    use IFPORT, only : MAX_HOSTNAM_LENGTH
    use DL_PY2F
    use ChemShellTaskfarmModule

    implicit none

!    include 'mpif.h'

    private

    ! public to libparallel.so procedures but invisible outside libparallel.so
    public initialise_parallel, finalise_parallel
    public create_python_object, synchronise_python_object, clean_python_object
    public getWG, getNode
    public synchronise_parallel
    public c_hostnames, c_world_hostnames, c_world_ranks
    public chemsh_parallel_intsize

    integer, parameter :: intType = sizeof(MPI_INTEGER)
    integer, parameter :: chemsh_parallel_intsize = sizeof(MPI_INTEGER)

    type parallelType

        private

        integer(kind=intType), public :: nprocs = 1
        integer(kind=intType), public :: nnodes_subset
        integer(kind=intType), public :: nnodes_wg
        integer(kind=intType), public :: rank
        integer(kind=intType), public :: nworkgroups = 1
        integer(kind=intType), public :: workgroup
        integer(kind=intType), public :: node_subset
        integer(kind=intType), public :: node
        integer(kind=intType), public :: comm_workgroup
        integer(kind=intType), public :: comm_node
        integer(kind=intType), public :: comm_subset
        integer(kind=intType), public :: ga_memory = 300
        integer(kind=intType), public :: debug  = 0
        integer(kind=intType), public :: null = MPI_COMM_NULL
        type(taskfarmType), pointer, private :: taskfarm => null()
        type(dictType)    , pointer, private :: PyObject => null()

        contains

        generic, public :: broadcast => private_broadcastScalar,    &
                                        private_broadcastOneDimInt, &
                                        private_broadcastOneDimLng, &
                                        private_broadcastOneDimDbl, &
                                        private_broadcastTwoDimInt, &
                                        private_broadcastTwoDimLng, &
                                        private_broadcastTwoDimDbl, &
                                        private_broadcastCPtr

        generic, public :: send      => private_sendScalar,    &
                                        private_sendOneDimInt, &
                                        private_sendOneDimLng, &
                                        private_sendOneDimDbl, &
                                        private_sendTwoDimInt, &
                                        private_sendTwoDimLng, &
                                        private_sendTwoDimDbl, &
                                        private_sendCPtr

        generic, public :: receive   => private_receiveScalar,    &
                                        private_receiveOneDimInt, &
                                        private_receiveOneDimLng, &
                                        private_receiveOneDimDbl, &
                                        private_receiveTwoDimInt, &
                                        private_receiveTwoDimLng, &
                                        private_receiveTwoDimDbl, &
                                        private_receiveCPtr

        generic, public :: gather    => private_gatherTwoDimDbl

        procedure,         public  :: init        => private_initialise
        procedure,         public  :: initialise  => private_initialise
        procedure,         public  :: finalise    => private_finalise
        procedure,         public  :: summarise   => private_summarise
        procedure,         public  :: sync        => private_synchronise
        procedure,         public  :: synchronise => private_synchronise
        procedure,         public  :: print       => private_print
        procedure,         public  :: is_root
        procedure,         public  :: is_subset
        procedure,         public  :: is_taskfarmed
        procedure, nopass, public  :: is_parallel
        procedure, nopass, public  :: exec_function
        procedure, nopass, public  :: get_function_handle
        procedure,         private :: private_broadcastScalar
        procedure,         private :: private_broadcastOneDimInt
        procedure,         private :: private_broadcastOneDimLng
        procedure,         private :: private_broadcastOneDimDbl
        procedure,         private :: private_broadcastTwoDimInt
        procedure,         private :: private_broadcastTwoDimLng
        procedure,         private :: private_broadcastTwoDimDbl
        procedure,         private :: private_broadcastCPtr
        procedure,         private :: private_sendScalar
        procedure,         private :: private_sendOneDimInt
        procedure,         private :: private_sendOneDimLng
        procedure,         private :: private_sendOneDimDbl
        procedure,         private :: private_sendTwoDimInt
        procedure,         private :: private_sendTwoDimLng
        procedure,         private :: private_sendTwoDimDbl
        procedure,         private :: private_sendCPtr
        procedure,         private :: private_receiveScalar
        procedure,         private :: private_receiveOneDimInt
        procedure,         private :: private_receiveOneDimLng
        procedure,         private :: private_receiveOneDimDbl
        procedure,         private :: private_receiveTwoDimInt
        procedure,         private :: private_receiveTwoDimLng
        procedure,         private :: private_receiveTwoDimDbl
        procedure,         private :: private_receiveCPtr
        procedure,         private :: private_gatherTwoDimDbl
        procedure,         private :: private_initialise
        procedure,         private :: private_finalise
        procedure,         private :: private_summarise
        procedure,         private :: private_synchronise
        procedure,         private :: private_print
        procedure,         private :: private_get_comm_from_level

    endtype parallelType

    ! the only thing Fortran application code can see from this API
    ! TODO: make this instance allocated in ChemShell rather than here to make
    !       the parallel module fully general-purpose
    type(parallelType), pointer    , public  :: chemsh_parallel

    real(kind=8)      , allocatable, private :: onedimdbl(:)    , twodimdbl(:,:)
    real(kind=8)      , allocatable, private :: onedimdblbuff(:), twodimdblbuff(:,:)

    character(len=:, kind=c_char), pointer :: c_hostnames, c_world_hostnames
    integer(kind=c_int)          , pointer :: c_world_ranks(:)

    contains

!!! API METHODS !!!
! public

    ! general-purpose API for Python
    integer(c_int) function create_python_object(objectPtr, onedimsize, twodimsizem, twodimsizen) result(ierror) bind(c)
!    integer(c_int) function create_python_object() result(ierror) bind(c)

        type(PyType)  , intent(in) :: objectPtr
        integer(c_int), intent(in) :: onedimsize
        integer(c_int), intent(in) :: twodimsizem
        integer(c_int), intent(in) :: twodimsizen

        ! result dictionary object
        if(.not.associated(chemsh_parallel%PyObject)) then
            allocate(chemsh_parallel%PyObject, source=ptr2dict(objectPtr))
        endif

        ! 1D array
        if(.not.allocated(onedimdbl).and.onedimsize.gt.0) then
            allocate(onedimdbl(onedimsize))
        endif
        if(.not.allocated(onedimdblbuff).and.onedimsize.gt.0) then
            allocate(onedimdblbuff(onedimsize*chemsh_parallel%nworkgroups))
        endif

        ! 2D array
        if(.not.allocated(twodimdbl).and.twodimsizem.gt.0.and.twodimsizen.gt.0) then
            allocate(twodimdbl(twodimsizem,twodimsizen))
        endif
        if(.not.allocated(twodimdblbuff).and.twodimsizem.gt.0.and.twodimsizen.gt.0) then
            allocate(twodimdblbuff(twodimsizem,twodimsizen*chemsh_parallel%nworkgroups))
        endif

        ierror = 0

    endfunction create_python_object
    ! FIXME: this is purpose-specific rather than API-like
    integer(c_int) function clean_python_object() result(ierror) bind(c)

        if(associated(chemsh_parallel%PyObject)) then
            deallocate(chemsh_parallel%PyObject)
        endif
        if(allocated(onedimdbl)) then
            deallocate(onedimdbl)
        endif
        if(allocated(onedimdblbuff)) then
            deallocate(onedimdblbuff)
        endif
        if(allocated(twodimdbl)) then
            deallocate(twodimdbl)
        endif
        if(allocated(twodimdblbuff)) then
            deallocate(twodimdblbuff)
        endif

        ierror = 0

    endfunction clean_python_object
    integer(c_int) function synchronise_python_object(objPtr, entry, attach) result(ierror) bind(c)

        ! A character dummy argument with length other than 1 is not interoperable
        type(PyType)                            , intent(in)           :: objPtr
        character(len=1, kind=c_char)           , intent(in)           :: entry(*)
        integer(c_int)                          , intent(in), optional :: attach

        integer(kind=intType)                                :: i, j, size, ierror_cast
        integer(kind=intType)        , parameter             :: root = 0
        type(dictType)               , pointer               :: PyObj
        character(len=16)                                    :: strbuff = ""
        integer                                              :: shp(2)
        integer                      , parameter             :: LENCHAR = 16
        integer(kind=8)              , allocatable           :: twodimint(:,:), twodimintbuff(:,:), toinserts(:,:)
        integer                      , allocatable           :: lpos(:), rpos(:)

        allocate(PyObj, source=ptr2dict(objPtr))

        ! convert c_char to Fortran character
        do i = 1, LENCHAR
            if(entry(i).ne.C_NULL_CHAR) then
                strbuff(i:i) = entry(i)
            else
                exit
            endif
        enddo
        shp = PyObj%enquireShape(strbuff)

        ! have to cast the type
        size = shp(1)*shp(2)

        allocate(twodimint(shp(1),shp(2)))
        allocate(toinserts(shp(1),shp(2)))
        allocate(twodimintbuff(shp(1),shp(2)*chemsh_parallel%nworkgroups))
        allocate(lpos(shp(2)))
        allocate(rpos(shp(2)))

        ! TODO: only integers so far
        call PyObj%get(trim(strbuff), twodimint)

        if(chemsh_parallel%is_taskfarmed()) then

            print '(3A)', " >>> merging ", trim(strbuff), " across workgroups..."

            ! workgroup 0: gather results from all other workgroups
            call MPI_GATHER(twodimint                , &
                            size                     , &
                            MPI_INTEGER8             , &
                            twodimintbuff            , &
                            size                     , &
                            MPI_INTEGER8             , &
                            root                     , &
                            chemsh_parallel%comm_node, &
                            ierror_cast)

            ! workgroup 0
            if(chemsh_parallel%rank.eq.0) then
                ! do maths
                if(present(attach)) then
                    ! attach to existing values, e.g.:
                    !     ( 1, 2,-1,-1,-1,...) merged with ( 0, 3,-1,-1,-1,...)
                    !     results in ( 1, 2, 0, 3,-1,...)
                    if(attach.eq.1) then
                        do i = 1, chemsh_parallel%nworkgroups-1
                            toinserts = twodimintbuff(1:shp(1),i*shp(2)+1:i*shp(2)+shp(2))
                            lpos = minloc(twodimint, 1)
                            rpos = minloc(toinserts, 1)
                            do j = 1, shp(2)
                                twodimint(lpos(j):lpos(j)+rpos(j)-1,j) = toinserts(:rpos(j)-1,j)
                            enddo
                        enddo
                    ! sum up
                    else
                        twodimint = twodimint + twodimintbuff(1:shp(1),i*shp(2)+1:i*shp(2)+shp(2))
                    endif
                ! sum up
                else
                    twodimint = twodimint + twodimintbuff(1:shp(1),i*shp(2)+1:i*shp(2)+shp(2))
                endif
            endif

            ! workgroup 0: broadcast to all workgroups
            call MPI_BCAST(twodimint                , &
                           size                     , &
                           MPI_INTEGER8             , &
                           root                     , &
                           chemsh_parallel%comm_node, &
                           ierror_cast)

            ! push to Python side
            if(chemsh_parallel%is_root()) then
                call PyObj%set(trim(strbuff), twodimint)
            endif

        endif

        deallocate(twodimint, toinserts, twodimintbuff)
        deallocate(lpos, rpos)

        ierror = ierror_cast

    endfunction synchronise_python_object
    integer(c_int) function initialise_parallel(nwgs, nnodes_subset, ga_memory, ChemShell_debug) &
                            result(ierror)                                                       &
                            bind(c, name="chemsh_parallel_f_initialise")

        integer(c_int), intent(in)           :: nwgs
        integer(c_int), intent(in)           :: nnodes_subset
        integer(c_int), intent(in)           :: ga_memory
        integer(c_int), intent(in), optional :: ChemShell_debug

        allocate(chemsh_parallel)

        if(present(ChemShell_debug)) then
            chemsh_parallel%debug = ChemShell_debug
        endif

        chemsh_parallel%nworkgroups = nwgs
        ! GA global memory (heap = stack = global/2): taskfarm%ga is private
        chemsh_parallel%ga_memory   = ga_memory

        ! number of processes in sub-group should not exceed total number of processes
        chemsh_parallel%nnodes_subset = nnodes_subset

        if(chemsh_parallel%initialise().ne.0) then
            print *, " >>> ERROR: failed initialising parallel module"
        endif

        ierror = chemsh_parallel%print()

        ! get a list of hostnames all over the world
        ierror = getWorldHostnames()

        ! get a list of hostnames within each workgroup
        ierror = getHostnames()

        ! get a list of world ranks within each workgroup
        ierror = getWorldRanks()

    endfunction initialise_parallel
    integer(c_int) function finalise_parallel() result(ierror) bind(c, name="chemsh_parallel_f_finalise")

        ierror = chemsh_parallel%finalise()

        deallocate(c_world_hostnames, c_hostnames, c_world_ranks)

        deallocate(chemsh_parallel)

    endfunction finalise_parallel
    integer(c_int) function broadcast(itype, buffer, lenbuf, root) result(ierror) bind(c, name="chemsh_parallel_f_broadcast")
    
        integer(c_int), intent(in) :: itype, lenbuf, root
        type(c_funptr), intent(in) :: buffer

        if(associated(chemsh_parallel)) then
            ierror = chemsh_parallel%broadcast(buffer, lenbuf, root, 0)
        else
            print *, " >>> ERROR: parallel moduled not initialised"
        endif

    endfunction broadcast
    integer(c_int) function synchronise_parallel() result(ierror) bind(c, name="chemsh_parallel_f_synchronise")

        ierror = chemsh_parallel%synchronise()
    
    endfunction synchronise_parallel
    ! myWorkgroup
    integer(c_int) function getWG() result(result) bind(c, name="chemsh_parallel_f_get_wg")
    
        result = chemsh_parallel%workgroup
    
    endfunction getWG
    ! myWorkgroupRank
    integer(c_int) function getNode() result(result) bind(c, name="chemsh_parallel_f_get_node")
    
        result = chemsh_parallel%node
    
    endfunction getNode
    ! number of world processes
    integer(c_int) function getNumProcesses() result(result) bind(c, name="chemsh_parallel_f_get_nprocs")
    
        result = chemsh_parallel%nprocs
    
    endfunction getNumProcesses
    ! number of workgroups
    integer(c_int) function getNumWorkgroups() result(result) bind(c, name="chemsh_parallel_f_get_nwgs")
    
        result = chemsh_parallel%nworkgroups
    
    endfunction getNumWorkgroups
    ! number of nodes in a workgroup
    integer(c_int) function getWGNumNodes() result(result) bind(c, name="chemsh_parallel_f_get_nnodes_wg")
    
        result = chemsh_parallel%nnodes_wg
    
    endfunction getWGNumNodes
    ! number of nodes in a workgroup's subset
    integer(c_int) function getSubsetNumNodes() result(result) bind(c, name="chemsh_parallel_f_get_nnodes_subset")
    
        result = chemsh_parallel%nnodes_subset
    
    endfunction getSubsetNumNodes

!!! PRIVATE METHODS !!!

    integer(kind=intType) function private_initialise(this) result(ierror)

        class(parallelType), intent(inout) :: this

        ! init
        call MPI_INIT(ierror)

        ! get nprocs
        call MPI_COMM_SIZE(MPI_COMM_WORLD, this%nprocs, ierror)

        ! get world rank
        call MPI_COMM_RANK(MPI_COMM_WORLD, this%rank  , ierror)

        allocate(this%taskfarm)

        ! GA global memory (heap = stack = global/2)
        this%taskfarm%ga_memory = this%ga_memory

        ierror = this%taskfarm%initialise(this%nworkgroups  , &
                                          this%nnodes_subset, &
                                          this%debug)

        this%workgroup      = this%taskfarm%colour
        this%node           = this%taskfarm%key
        this%node_subset    = this%taskfarm%key_subset
        ! YL 24/11/2018: corrected "this%nnodes_wg = this%taskfarm%ncolours" as "nkeys"
        this%nnodes_wg      = this%taskfarm%nkeys
        ! YL 24/11/2018: update nnodes_subset after initilisation
        this%nnodes_subset  = this%taskfarm%nsubsetkeys
        this%comm_workgroup = this%taskfarm%comm_colour
        this%comm_node      = this%taskfarm%comm_key
        this%comm_subset    = this%taskfarm%comm_subset
        this%null           = MPI_UNDEFINED

    endfunction private_initialise
    integer(kind=intType) function private_finalise(this) result(ierror)
    
        class(parallelType), intent(inout) :: this

!        call MPI_COMM_FREE(this%taskfarm%comm_subset, ierror)

        deallocate(this%taskfarm)

        call MPI_FINALIZE(ierror)
        
    endfunction private_finalise
    integer(kind=intType) function private_print(this) result(ierror)

        class(parallelType), intent(in) :: this

        ierror = this%taskfarm%print()

    endfunction private_print
    ! old way: bytewise broadcast of scalar value to workgroup
    integer(kind=intType) function private_broadcastCPtr(this, buffer, lenbuf, root, dummy, level) result(ierror)
 
        class(parallelType), intent(in)           :: this
        type(c_funptr)     , intent(in)           :: buffer
        class(*)           , intent(in)           :: lenbuf, root
        class(*)           , intent(in)           :: dummy
        character(len=*)   , intent(in), optional :: level
 
        integer(kind=intType)                     :: communicator

        if(present(level)) then
            communicator = this%private_get_comm_from_level(level)
        else
            communicator = this%comm_workgroup
        endif

        call MPI_BCAST(buffer, getCastInt(lenbuf), MPI_BYTE, getCastInt(root), communicator, ierror)

    endfunction private_broadcastCPtr
    integer(kind=intType) function private_broadcastScalar(this, buffer, lenbuf, root, level) result(ierror)
    
        class(parallelType), intent(in)           :: this
        class(*)           , intent(in)           :: buffer, lenbuf, root
        character(len=*)   , intent(in), optional :: level
    
        integer(kind=intType)                       :: communicator

        if(present(level)) then
            communicator = this%private_get_comm_from_level(level)
        else
            communicator = this%comm_workgroup
        endif

        ! Intel/GNU: there is no way to use iso_c_binding types (e.g., c_ptr) in selecttype procedure, otherwise "The type specification in TYPE IS or CLASS IS statement must not specify a sequence derived type or a type with the BIND attribute."
        selecttype(tmp=>buffer)
            class default
                call MPI_BCAST(buffer, getCastInt(lenbuf), MPI_BYTE, getCastInt(root), communicator, ierror)
        endselect
        call flush(6)

    endfunction private_broadcastScalar
    integer(kind=intType) function private_broadcastOneDimInt(this, buffer, lenbuf, root, level) result(ierror)
 
        class(parallelType), intent(in)           :: this
        integer(kind=4)    , intent(in)           :: buffer(:)
        class(*)           , intent(in)           :: lenbuf, root
        character(len=*)   , intent(in), optional :: level
 
        integer(kind=intType)                     :: communicator

        if(present(level)) then
            communicator = this%private_get_comm_from_level(level)
        else
            communicator = this%comm_workgroup
        endif

        call MPI_BCAST(buffer, getCastInt(lenbuf), MPI_BYTE, getCastInt(root), communicator, ierror)

    endfunction private_broadcastOneDimInt
    integer(kind=intType) function private_broadcastOneDimLng(this, buffer, lenbuf, root, level) result(ierror)
 
        class(parallelType), intent(in)           :: this
        integer(kind=8)    , intent(in)           :: buffer(:)
        class(*)           , intent(in)           :: lenbuf, root
        character(len=*)   , intent(in), optional :: level
 
        integer(kind=intType)                     :: communicator

        if(present(level)) then
            communicator = this%private_get_comm_from_level(level)
        else
            communicator = this%comm_workgroup
        endif

        call MPI_BCAST(buffer, getCastInt(lenbuf), MPI_BYTE, getCastInt(root), communicator, ierror)

    endfunction private_broadcastOneDimLng
    integer(kind=intType) function private_broadcastOneDimDbl(this, buffer, lenbuf, root, level) result(ierror)
 
        class(parallelType), intent(in)           :: this
        real(kind=8)       , intent(in)           :: buffer(:)
        class(*)           , intent(in)           :: lenbuf, root
        character(len=*)   , intent(in), optional :: level
 
        integer(kind=intType)                     :: communicator

        if(present(level)) then
            communicator = this%private_get_comm_from_level(level)
        else
            communicator = this%comm_workgroup
        endif

        call MPI_BCAST(buffer, getCastInt(lenbuf), MPI_BYTE, getCastInt(root), communicator, ierror)

    endfunction private_broadcastOneDimDbl
    integer(kind=intType) function private_broadcastTwoDimInt(this, buffer, lenbuf, root, level) result(ierror)
 
        class(parallelType), intent(in)           :: this
        integer(kind=4)    , intent(in)           :: buffer(:,:)
        class(*)           , intent(in)           :: lenbuf, root
        character(len=*)   , intent(in), optional :: level
 
        integer(kind=intType)                     :: communicator

        if(present(level)) then
            communicator = this%private_get_comm_from_level(level)
        else
            communicator = this%comm_workgroup
        endif

        call MPI_BCAST(buffer, getCastInt(lenbuf), MPI_BYTE, getCastInt(root), communicator, ierror)

    endfunction private_broadcastTwoDimInt
    integer(kind=intType) function private_broadcastTwoDimLng(this, buffer, lenbuf, root, level) result(ierror)
 
        class(parallelType), intent(in)           :: this
        integer(kind=8)    , intent(in)           :: buffer(:,:)
        class(*)           , intent(in)           :: lenbuf, root
        character(len=*)   , intent(in), optional :: level
 
        integer(kind=intType)                     :: communicator

        if(present(level)) then
            communicator = this%private_get_comm_from_level(level)
        else
            communicator = this%comm_workgroup
        endif

        call MPI_BCAST(buffer, getCastInt(lenbuf), MPI_BYTE, getCastInt(root), communicator, ierror)

    endfunction private_broadcastTwoDimLng
    integer(kind=intType) function private_broadcastTwoDimDbl(this, buffer, lenbuf, root, level) result(ierror)
 
        class(parallelType), intent(in)           :: this
        real(kind=8)       , intent(in)           :: buffer(:,:)
        class(*)           , intent(in)           :: lenbuf, root
        character(len=*)   , intent(in), optional :: level

        integer(kind=intType)                       :: communicator

        if(present(level)) then
            communicator = this%private_get_comm_from_level(level)
        else
            communicator = this%comm_workgroup
        endif

        call MPI_BCAST(buffer, getCastInt(lenbuf), MPI_BYTE, getCastInt(root), communicator, ierror)

    endfunction private_broadcastTwoDimDbl
    integer(kind=intType) function private_sendCPtr(this, buffer, lenbuf, dest, tag, dummy, level) result(ierror)
 
        class(parallelType), intent(in) :: this
        type(c_funptr)     , intent(in) :: buffer
        class(*)           , intent(in) :: lenbuf, dest, tag
        class(*)           , intent(in) :: dummy
        character(len=*)   , intent(in), optional :: level
 
        call MPI_SEND(buffer             , &
                      getCastInt(lenbuf) , &
                      MPI_BYTE           , &
                      getCastInt(dest)   , &
                      getCastInt(tag)    , &
                      this%comm_workgroup, &
                      ierror)

    endfunction private_sendCPtr
    integer(kind=intType) function private_sendScalar(this, buffer, lenbuf, dest, tag) result(ierror)
    
        class(parallelType), intent(in) :: this
        class(*)           , intent(in) :: buffer
        class(*)           , intent(in) :: lenbuf, dest, tag
    
        ! Intel/GNU: there is no way to use iso_c_binding types (e.g., c_ptr) in selecttype procedure, otherwise "The type specification in TYPE IS or CLASS IS statement must not specify a sequence derived type or a type with the BIND attribute."
        selecttype(buffer)
            class default
        endselect

        call MPI_SEND(buffer             , &
                      getCastInt(lenbuf) , &
                      MPI_BYTE           , &
                      getCastInt(dest)   , &
                      getCastInt(tag)    , &
                      this%comm_workgroup, &
                      ierror)

    endfunction private_sendScalar
    integer(kind=intType) function private_sendOneDimInt(this, buffer, lenbuf, dest, tag) result(ierror)
 
        class(parallelType), intent(in) :: this
        integer(kind=4)    , intent(in) :: buffer(:)
        class(*)           , intent(in) :: lenbuf, dest, tag
 
        call MPI_SEND(buffer             , &
                      getCastInt(lenbuf) , &
                      MPI_BYTE           , &
                      getCastInt(dest)   , &
                      getCastInt(tag)    , &
                      this%comm_workgroup, &
                      ierror)

    endfunction private_sendOneDimInt
    integer(kind=intType) function private_sendOneDimLng(this, buffer, lenbuf, dest, tag) result(ierror)
 
        class(parallelType), intent(in) :: this
        integer(kind=8)    , intent(in) :: buffer(:)
        class(*)           , intent(in) :: lenbuf, dest, tag
 
        call MPI_SEND(buffer             , &
                      getCastInt(lenbuf) , &
                      MPI_BYTE           , &
                      getCastInt(dest)   , &
                      getCastInt(tag)    , &
                      this%comm_workgroup, &
                      ierror)

    endfunction private_sendOneDimLng
    integer(kind=intType) function private_sendOneDimDbl(this, buffer, lenbuf, dest, tag) result(ierror)
 
        class(parallelType), intent(in) :: this
        real(kind=8)       , intent(in) :: buffer(:)
        class(*)           , intent(in) :: lenbuf, dest, tag
 
        call MPI_SEND(buffer             , &
                      getCastInt(lenbuf) , &
                      MPI_BYTE           , &
                      getCastInt(dest)   , &
                      getCastInt(tag)    , &
                      this%comm_workgroup, &
                      ierror)

    endfunction private_sendOneDimDbl
    integer(kind=intType) function private_sendTwoDimInt(this, buffer, lenbuf, dest, tag) result(ierror)
 
        class(parallelType), intent(in) :: this
        integer(kind=4)    , intent(in) :: buffer(:,:)
        class(*)           , intent(in) :: lenbuf, dest, tag
 
        call MPI_SEND(buffer             , &
                      getCastInt(lenbuf) , &
                      MPI_BYTE           , &
                      getCastInt(dest)   , &
                      getCastInt(tag)    , &
                      this%comm_workgroup, &
                      ierror)

    endfunction private_sendTwoDimInt
    integer(kind=intType) function private_sendTwoDimLng(this, buffer, lenbuf, dest, tag) result(ierror)
 
        class(parallelType), intent(in) :: this
        integer(kind=8)    , intent(in) :: buffer(:,:)
        class(*)           , intent(in) :: lenbuf, dest, tag
 
        call MPI_SEND(buffer             , &
                      getCastInt(lenbuf) , &
                      MPI_BYTE           , &
                      getCastInt(dest)   , &
                      getCastInt(tag)    , &
                      this%comm_workgroup, &
                      ierror)

    endfunction private_sendTwoDimLng
    integer(kind=intType) function private_sendTwoDimDbl(this, buffer, lenbuf, dest, tag, level) result(ierror)
 
        class(parallelType), intent(in)           :: this
        real(kind=8)       , intent(in)           :: buffer(:,:)
        class(*)           , intent(in)           :: lenbuf, dest, tag
        character(len=*)   , intent(in), optional :: level

        integer(kind=intType)                     :: communicator
 
        if(present(level)) then
            communicator = this%private_get_comm_from_level(level)
        else
            communicator = this%comm_workgroup
        endif

        call MPI_SEND(buffer            , &
                      getCastInt(lenbuf), &
                      MPI_BYTE          , &
                      getCastInt(dest)  , &
                      getCastInt(tag)   , &
                      communicator      , &
                      ierror)

    endfunction private_sendTwoDimDbl
    integer(kind=intType) function private_receiveCPtr(this, buffer, lenbuf, source, tag, dummy, level) result(ierror)
 
        class(parallelType), intent(in)           :: this
        type(c_funptr)     , intent(in)           :: buffer
        class(*)           , intent(in)           :: lenbuf, source, tag
        class(*)           , intent(in)           :: dummy
        character(len=*)   , intent(in), optional :: level
 
        integer(kind=intType)                     :: communicator

        if(present(level)) then
            communicator = this%private_get_comm_from_level(level)
        else
            communicator = this%comm_workgroup
        endif

        call MPI_RECV(buffer            , &
                      getCastInt(lenbuf), &
                      MPI_BYTE          , &
                      getCastInt(source), &
                      getCastInt(tag)   , &
                      communicator      , &
                      MPI_STATUS_IGNORE , &
                      ierror)

    endfunction private_receiveCPtr
    integer(kind=intType) function private_receiveScalar(this, buffer, lenbuf, source, tag) result(ierror)
    
        class(parallelType), intent(in) :: this
        class(*)           , intent(in) :: buffer
        class(*)           , intent(in) :: lenbuf, source, tag
    
        ! Intel/GNU: there is no way to use iso_c_binding types (e.g., c_ptr) in selecttype procedure, otherwise "The type specification in TYPE IS or CLASS IS statement must not specify a sequence derived type or a type with the BIND attribute."
        selecttype(buffer)
            class default
        endselect

        call MPI_RECV(buffer             , &
                      getCastInt(lenbuf) , &
                      MPI_BYTE           , &
                      getCastInt(source) , &
                      getCastInt(tag)    , &
                      this%comm_workgroup, &
                      MPI_STATUS_IGNORE  , &
                      ierror)

    endfunction private_receiveScalar
    integer(kind=intType) function private_receiveOneDimInt(this, buffer, lenbuf, source, tag) result(ierror)
 
        class(parallelType), intent(in) :: this
        integer(kind=4)    , intent(in) :: buffer(:)
        class(*)           , intent(in) :: lenbuf, source, tag
 
        call MPI_RECV(buffer             , &
                      getCastInt(lenbuf) , &
                      MPI_BYTE           , &
                      getCastInt(source) , &
                      getCastInt(tag)    , &
                      this%comm_workgroup, &
                      MPI_STATUS_IGNORE  , &
                      ierror)

    endfunction private_receiveOneDimInt
    integer(kind=intType) function private_receiveOneDimLng(this, buffer, lenbuf, source, tag) result(ierror)
 
        class(parallelType), intent(in) :: this
        integer(kind=8)    , intent(in) :: buffer(:)
        class(*)           , intent(in) :: lenbuf, source, tag
 
        call MPI_RECV(buffer             , &
                      getCastInt(lenbuf) , &
                      MPI_BYTE           , &
                      getCastInt(source) , &
                      getCastInt(tag)    , &
                      this%comm_workgroup, &
                      MPI_STATUS_IGNORE  , &
                      ierror)

    endfunction private_receiveOneDimLng
    integer(kind=intType) function private_receiveOneDimDbl(this, buffer, lenbuf, source, tag) result(ierror)
 
        class(parallelType), intent(in) :: this
        real(kind=8)       , intent(in) :: buffer(:)
        class(*)           , intent(in) :: lenbuf, source, tag
 
        call MPI_RECV(buffer             , &
                      getCastInt(lenbuf) , &
                      MPI_BYTE           , &
                      getCastInt(source) , &
                      getCastInt(tag)    , &
                      this%comm_workgroup, &
                      MPI_STATUS_IGNORE  , &
                      ierror)

    endfunction private_receiveOneDimDbl
    integer(kind=intType) function private_receiveTwoDimInt(this, buffer, lenbuf, source, tag) result(ierror)
 
        class(parallelType), intent(in) :: this
        integer(kind=4)    , intent(in) :: buffer(:,:)
        class(*)           , intent(in) :: lenbuf, source, tag
 
        call MPI_RECV(buffer             , &
                      getCastInt(lenbuf) , &
                      MPI_BYTE           , &
                      getCastInt(source) , &
                      getCastInt(tag)    , &
                      this%comm_workgroup, &
                      MPI_STATUS_IGNORE  , &
                      ierror)

    endfunction private_receiveTwoDimInt
    integer(kind=intType) function private_receiveTwoDimLng(this, buffer, lenbuf, source, tag) result(ierror)
 
        class(parallelType), intent(in) :: this
        integer(kind=8)    , intent(in) :: buffer(:,:)
        class(*)           , intent(in) :: lenbuf, source, tag
 
        call MPI_RECV(buffer             , &
                      getCastInt(lenbuf) , &
                      MPI_BYTE           , &
                      getCastInt(source) , &
                      getCastInt(tag)    , &
                      this%comm_workgroup, &
                      MPI_STATUS_IGNORE  , &
                      ierror)

    endfunction private_receiveTwoDimLng
    integer(kind=intType) function private_receiveTwoDimDbl(this, buffer, lenbuf, source, tag, level) result(ierror)
 
        class(parallelType), intent(in)           :: this
        real(kind=8)       , intent(in)           :: buffer(:,:)
        class(*)           , intent(in)           :: lenbuf, source, tag
        character(len=*)   , intent(in), optional :: level

        integer(kind=intType)                     :: communicator
 
        if(present(level)) then
            communicator = this%private_get_comm_from_level(level)
        else
            communicator = this%comm_workgroup
        endif
        
        call MPI_RECV(buffer            , &
                      getCastInt(lenbuf), &
                      MPI_BYTE          , &
                      getCastInt(source), &
                      getCastInt(tag)   , &
                      communicator      , &
                      MPI_STATUS_IGNORE , &
                      ierror)

    endfunction private_receiveTwoDimDbl
    ! stub: not in use
    integer(kind=intType) function private_gatherTwoDimDbl(this, buffer, lenbuf, root, level) result(ierror)
 
        class(parallelType), intent(in)           :: this
        real(kind=8)       , intent(in)           :: buffer(:,:)
        class(*)           , intent(in)           :: lenbuf, root
        character(len=*)   , intent(in), optional :: level

        integer(kind=intType)                     :: communicator
 
        if(present(level)) then
            communicator = this%private_get_comm_from_level(level)
        else
            communicator = this%comm_workgroup
        endif

        ierror = 0       
 
!        call MPI_GATHER(buffer                   , &
!                        size                     , &
!                        MPI_DOUBLE_PRECISION     , &
!                        twodimdblbuff            , &
!                        size                     , &
!                        MPI_DOUBLE_PRECISION     , &
!                        getCastInt(root)         , &
!                        communicator             , &
!                        ierror_cast)
    endfunction private_gatherTwoDimDbl
    integer(kind=intType) function private_summarise(this, level) result(ierror)

        class(parallelType), intent(in) :: this
        integer            , intent(in) :: level

        ierror = this%taskfarm%summarise(level)

    endfunction private_summarise
    integer(kind=intType) function private_synchronise(this) result(ierror)
    
        class(parallelType), intent(in) :: this

        ierror = this%taskfarm%synchronise()
        
    endfunction private_synchronise
    integer(kind=intType) function private_get_comm_from_level(this, level) result(communicator)

        class(parallelType), intent(in) :: this
        character(len=*)   , intent(in) :: level

        if(trim(level).eq."global".or.trim(level).eq."world") then
            communicator = MPI_COMM_WORLD
        elseif(trim(level).eq."subworkgroup".or.trim(level).eq."subset") then
            communicator = this%comm_subset
        elseif(trim(level).eq."workgroup") then
            communicator = this%comm_workgroup
        elseif(trim(level).eq."node".or.trim(level).eq."counterpart") then
            communicator = this%comm_node
        else
            communicator = this%comm_workgroup
        endif

    endfunction private_get_comm_from_level
    character(len=6) function getWGDirname() result(iret)

        character(len=3) :: WG_index

        ! get directory name and create it
        write(WG_index, '(I0.3)') getWG()
        write(iret, '(A6)') "wg_" // WG_index

    endfunction getWGDirname
    ! will typically be called from a Python interpreter that belongs to a single work group
    integer(c_int) function getWorldRanks() result(iret) bind(c, name="chemsh_parallel_f_get_c_world_ranks")

        integer(kind=intType), parameter :: root = 0
        integer :: i, ierror
        integer                          :: status(MPI_STATUS_SIZE)

        allocate(c_world_ranks(chemsh_parallel%nnodes_wg))
        
        call MPI_COMM_RANK(MPI_COMM_WORLD, c_world_ranks(chemsh_parallel%node+1), ierror)
        if(chemsh_parallel%is_root()) then
            do i = 1, chemsh_parallel%nnodes_wg-1
                call MPI_RECV(c_world_ranks(i+1), 1, MPI_INT, i, 254, chemsh_parallel%taskfarm%comm_colour, status, ierror)
            enddo
        else
            call MPI_SEND(c_world_ranks(chemsh_parallel%node+1), &
                          1,                                     &
                          MPI_INT,                               &
                          root,                                  &
                          254,                                   &
                          chemsh_parallel%taskfarm%comm_colour,  &
                          ierror)
        endif

        iret = ierror

    endfunction getWorldRanks 
    ! will be called when the MPI is initialised and the saved string can be accessed from a Python interpreter that belongs to a single work group
    integer(c_int) function getWorldHostnames() result(iret) bind(c, name="chemsh_parallel_f_get_c_world_hostnames")

        character(len=MPI_MAX_PROCESSOR_NAME)              :: procname
        character(len=:)                     , allocatable :: allprocnames(:)
        integer(kind=intType)                , parameter   :: root = 0
        integer                                            :: i, ierror, lhostname, c_len
        integer                                            :: status(MPI_STATUS_SIZE)

        call MPI_GET_PROCESSOR_NAME(procname, lhostname, ierror)

        c_len = lhostname + 1

        allocate(character(len=lhostname) :: allprocnames(chemsh_parallel%nprocs))
        allocate(character(len=c_len*chemsh_parallel%nprocs+1, kind=c_char) :: c_world_hostnames)

        ! world root
        if(chemsh_parallel%rank.eq.0) then
            allprocnames(1) = procname(1:lhostname)
            do i = 1, chemsh_parallel%nprocs-1
                call MPI_RECV(allprocnames(i+1), lhostname, MPI_CHARACTER, i, 256, MPI_COMM_WORLD, status, ierror)
            enddo
        else
            call MPI_SEND(procname, lhostname, MPI_CHARACTER, root, 256, MPI_COMM_WORLD, ierror)
        endif

        call MPI_BARRIER(MPI_COMM_WORLD, IERROR)

        ! broadcast
        call MPI_BCAST(allprocnames                    , &
                       lhostname*chemsh_parallel%nprocs, &
                       MPI_CHARACTER                   , &
                       root                            , &
                       MPI_COMM_WORLD                  , &
                       ierror)

        ! formulate c_world_hostnames in all workgroups
        if(chemsh_parallel%is_root()) then
            do i = 1, chemsh_parallel%nprocs
                write(c_world_hostnames((i-1)*c_len+1:i*c_len-1), '(A)') allprocnames(i)
                write(c_world_hostnames( i   *c_len  :i*c_len  ), '(A)') trim(";")
            enddo
            c_world_hostnames(c_len*chemsh_parallel%nprocs+1:c_len*chemsh_parallel%nprocs+1) = C_NULL_CHAR
        endif

        deallocate(allprocnames)

        iret = ierror

    endfunction getWorldHostnames
    ! will be called when the MPI is initialised and the saved string can be accessed from a Python interpreter that belongs to a single work group
    integer(c_int) function getHostnames() result(iret) bind(c, name="chemsh_parallel_f_get_c_hostnames")

        character(len=MPI_MAX_PROCESSOR_NAME)              :: procname
        character(len=:)                     , allocatable :: allprocnames(:)
        integer(kind=intType)                , parameter   :: root = 0
        integer                                            :: i, ierror, lhostname, c_len
        integer                                            :: status(MPI_STATUS_SIZE)

        call MPI_GET_PROCESSOR_NAME(procname, lhostname, ierror)

        c_len = lhostname + 1

        allocate(character(len=lhostname) :: allprocnames(chemsh_parallel%nnodes_wg))
        allocate(character(len=c_len*chemsh_parallel%nnodes_wg+1, kind=c_char) :: c_hostnames)

        if(chemsh_parallel%is_root()) then
            allprocnames(1) = procname(1:lhostname)
            do i = 1, chemsh_parallel%nnodes_wg-1
                call MPI_RECV(allprocnames(i+1),                    &
                              lhostname,                            &
                              MPI_CHARACTER,                        &
                              i,                                    &
                              255,                                  &
                              chemsh_parallel%taskfarm%comm_colour, &
                              status,                               &
                              ierror)
            enddo
            do i = 1, chemsh_parallel%nnodes_wg
                write(c_hostnames((i-1)*c_len+1:i*c_len-1), '(A)') allprocnames(i)
                write(c_hostnames( i   *c_len  :i*c_len  ), '(A)') trim(";")
            enddo
            c_hostnames(c_len*chemsh_parallel%nnodes_wg+1:c_len*chemsh_parallel%nnodes_wg+1) = C_NULL_CHAR
        else
            call MPI_SEND(procname, lhostname, MPI_CHARACTER, root, 255, chemsh_parallel%taskfarm%comm_colour, ierror)
        endif

        deallocate(allprocnames)

        iret = ierror

    endfunction getHostnames
    character(len=10) function getWGOutName() result(iret)

!        iret = getWGDirname() // ".out"
        write(iret, '(A10)') trim(getWGDirname()) // ".out"

    endfunction getWGOutName
    character(len=10) function getWGErrName() result(iret)

!        iret = getWGDirname() // ".err"
        write(iret, '(A10)') trim(getWGDirname()) // ".err"

    endfunction getWGErrName
    character(len=14) function getBackupName(oldname) result(iret)

        character(*), intent(in) :: oldname

!        iret = trim(oldname) // ".OLD"
        write(iret, '(A14)') trim(oldname) // ".OLD"

    endfunction getBackupName
    integer(c_int) function get_function_handle(func_pointer) result(handle)
    
        interface
            integer(c_int) function chemsh_parallel_c_register_function(func_pointer) bind(c, name='chemsh_parallel_c_register_function')
                use iso_c_binding
                type(c_funptr), value :: func_pointer
            endfunction chemsh_parallel_c_register_function
        endinterface
      
        type(c_funptr), value :: func_pointer
      
        handle = chemsh_parallel_c_register_function(func_pointer)
    
    endfunction get_function_handle
    integer(c_int) function exec_function(handle, debug) result(ierror)
    
        interface
            integer(c_int) function chemsh_parallel_c_exec_function(handle, debug) bind(c, name='chemsh_parallel_c_exec_function')
                use iso_c_binding
                integer(c_int), value :: handle
                integer(c_int), value :: debug
            endfunction chemsh_parallel_c_exec_function
        endinterface
      
        integer(c_int), intent(in)           :: handle
        integer(c_int), intent(in), optional :: debug

        integer(c_int) :: c_debug
    
        if(.not.present(debug)) then
            c_debug = 0
        else
            c_debug = debug
        endif

        ierror = chemsh_parallel_c_exec_function(handle, c_debug)
    
    endfunction exec_function
    logical function is_taskfarmed(this) result(result)

        class(parallelType), intent(in) :: this

        result = this%nworkgroups.gt.1

    endfunction is_taskfarmed
    ! query build
    logical function is_parallel() result(result)

        result = .true.
    
    endfunction is_parallel
    logical function is_root(this) result(result)

        class(parallelType), intent(in) :: this

        if(associated(this%taskfarm)) then
            result = this%taskfarm%is_root()
        else
            print *, ">>> ChemShell ERROR: parallelism not yet initialised!"
            stop
        endif

    endfunction is_root
    logical function is_subset(this) result(result)

        class(parallelType), intent(in) :: this

        if(associated(this%taskfarm)) then
            result = this%taskfarm%is_subset()
        else
            print *, ">>> CHEMSH_PARALLEL ERROR: MPI not yet initialised!"
            stop
        endif

    endfunction is_subset
    ! convert any kind=4 or kind=8 integer to intType
    integer(kind=intType) function getCastInt(input) result(result)

        class(*), intent(in) :: input

        selecttype(tmp=>input)
            type is(integer(kind=4))
                result = int(tmp, kind=4)
            type is(integer(kind=8))
                result = int(tmp, kind=8)
!            type is(integer(c_int))
!                result = tmp
        endselect
        
    endfunction getCastInt

endmodule ChemShellParallelModule

! Adapted from parallel_ga.F of Tcl-ChemShell
! you.lu@stfc.ac.uk
! Feb 2017

!  Copyright (C) 2017 The authors of Py-ChemShell
!
!  This file is part of Py-ChemShell.
!
!  Py-ChemShell is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as
!  published by the Free Software Foundation, either version 3 of the
!  License, or (at your option) any later version.
!
!  Py-ChemShell is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with Py-ChemShell.  If not, see
!  <http://www.gnu.org/licenses/>.

module ChemShellGAModule

    implicit none

!DEC$ NOFREEFORM
#include "mafdecls.fh"
#include "global.fh"
!DEC$ FREEFORM

    private
    public :: GAType

    integer, parameter :: intType = sizeof(0)

    type GAType
        private
        integer             , public :: debug
        integer             , public :: ncolours
        integer             , public :: nkeys
        integer             , public :: colour
        integer             , public :: key
        integer             , public :: comm_colour
        integer             , public :: comm_key
        integer, allocatable, public :: procgroup(:)
        integer             , private :: ga_memory
        contains
        procedure, public :: initialise  => private_initialise
        procedure, public :: finalise    => private_finalise
        procedure, public :: synchronise => private_synchronise
        procedure, public :: summarise   => private_summarise
        procedure, public :: print       => private_print
        procedure, public :: is_root      => private_is_root
        procedure, public :: setProcGroup => private_set_processors_group
        procedure, private :: private_initialise
        procedure, private :: private_finalise
        procedure, private :: private_synchronise
        procedure, private :: private_summarise
        procedure, private :: private_print
        procedure, private :: private_set_processors_group
        procedure, private :: private_is_root
    endtype GAType

    contains

    integer(kind=intType) function private_initialise(this, ncolours, ga_memory, debug) result(ierror)

        use iso_c_binding

        implicit none

!#include "mafdecls.fh"

        class(GAType)              , intent(inout) :: this
        class(*)                   , intent(in)    :: ncolours
        class(*)                   , intent(in)    :: debug
        class(*)                   , intent(in)    :: ga_memory

        integer                                    :: ga_nprocs
        integer                                    :: i, icolour
        integer                                    :: stack, heap, global
        integer                                    :: stack_auto, heap_auto, global_auto
        integer         , parameter                :: MB2Byte  = 1024*1024
        integer         , parameter                :: MB2ndbls = 1024*1024/8
        character(len=8)                           :: sbuffh = "", sbuffs = "", sbuffg = ""


        ! always compile libga.so 64-bit while libparallel.so could be 32-bit
        selecttype(ncolours)
            type is(integer(kind=4))
                this%ncolours = ncolours
            type is(integer(kind=8))
                this%ncolours = ncolours
        endselect
        selecttype(ga_memory)
            type is(integer(kind=4))
                this%ga_memory = ga_memory
            type is(integer(kind=8))
                this%ga_memory = ga_memory
        endselect
        selecttype(debug)
            type is(integer(kind=4))
                this%debug = debug
            type is(integer(kind=8))
                this%debug = debug
        endselect

        ! TD 22/04/2024: I didn't find documentation on this point, but by looking at GA
        ! examples I think calling both MPI_INIT and PBEGINF is an error
        ! This sometimes causes hangs on archer2
        !call PBEGINF

!        ! get the environment variables of HEAP/STACK/GLOBAL in MByte
!        ! TODO: review if this reduces the modularity of parallel lib
!        call get_environment_variable("HEAP  ", sbuffh)
!        read(sbuffh, '(i8)') heap
!        call get_environment_variable("STACK ", sbuffs)
!        read(sbuffs, '(i8)') stack
!        call get_environment_variable("GLOBAL", sbuffg)
!        read(sbuffg, '(i8)') global

        ! default size (MB)
!        if(any((/heap, stack, global/).le.0)) then
        global = this%ga_memory
        heap   = global/2
        stack  = global/2
!        endif

        ! convert MByte to number of doubles
!            heap   = MA_SIZEOF(MT_BYTE, MB2Byte*heap  , MT_DBL)
!            stack  = MA_SIZEOF(MT_BYTE, MB2Byte*stack , MT_DBL)
!            global = MA_SIZEOF(MT_BYTE, MB2Byte*global, MT_DBL)
        
        ! TODO this the TCS method
!        mt_dbl_i8  = int(MT_DBL , kind=i8)
!        mt_byte_i8 = int(MT_BYTE, kind=i8)

!        size_i8 = int(MA_SIZEOF(mt_dbl_i8, global, mt_byte_i8), kind=i8)

        ! amount of memory in bytes per process (this is a collective operation)
        call GA_INITIALIZE_LTD(global*MB2Byte)
!        call GA_INITIALIZE_LTD(size_i8)

        ! GA uses local memory
        if(GA_USES_MA()) then
            if(.not.MA_INIT(MT_DBL, -1, -1)) then
            !if(.not.MA_INIT(mt_dbl_i8, -1, -1)) then
                print *, ">>> GA module: MA_INIT() failed (local memory mode)"
                stop
            endif
        ! GA uses shared memory
        else
            if(.not.MA_INIT(MT_DBL, stack*MB2ndbls, heap*MB2ndbls)) then
            !if(.not.MA_INIT(mt_dbl_i8, stack, heap+global)) then
                print *, ">>> GA module: MA_INIT() failed (shared memory mode)"
                stop
            endif
        endif

        ! hardware memory limit
        global_auto = GA_MEMORY_AVAIL()
        heap_auto   = MA_INQUIRE_HEAP(MT_DBL)
        stack_auto  = MA_INQUIRE_STACK(MT_DBL)

        ! shouldn't exceed the hardware limit
        global = min(global, global_auto)
        heap   = min(heap  , heap_auto)
        stack  = min(stack , stack_auto)

        ! TCS: WG_size
        ga_nprocs = GA_NNODES()
        if(mod(ga_nprocs, this%ncolours).eq.0) then
            this%nkeys = ga_nprocs / this%ncolours
        else
            print *, ">>> FATAL ERROR: number of processors (-np) not divisible by number of workgroups (-nwg)"
            stop
        endif

        ! GA_NODEID() returns MPI_WORLD_RANK
        this%colour   = GA_NODEID() / this%nkeys
        this%key      = mod(GA_NODEID(), this%nkeys)

        allocate(this%procgroup(this%ncolours))

        do icolour = 1, this%ncolours
            ! for example we have 6 processes in 3 workgroups
            ! proclist used for GA_PGROUP_CREATE is (/0,1/), (/2,3/), and (/4,5/), respectively
            this%procgroup(icolour) = GA_PGROUP_CREATE((/(i, i=this%nkeys*(icolour-1), this%nkeys*icolour-1)/), this%nkeys)
        enddo

        call GA_PGROUP_SET_DEFAULT(this%procgroup(this%colour+1))

        call GA_SYNC()

        call GA_MPI_COMM_PGROUP_DEFAULT(this%comm_colour)

        if(this%colour.eq.0.and.this%key.eq.0) then
            write(6,'(//1x,a)') repeat("=", 48)
            write(6,'(/a/)') " Initialising Parallelism driven by Global Arrays (GA)"
            write(6,'(1x,a,1x,i5,1x,a,i7,a)') "Heap   size:", heap  , "MB (", heap_auto  /1024, " GB available)"
            write(6,'(1x,a,1x,i5,1x,a,i7,a)') "Stack  size:", stack , "MB (", stack_auto /1024, " GB available)"
            write(6,'(1x,a,1x,i5,1x,a,i7,a)') "Global size:", global, "MB (", global_auto/1024, " GB available)"
            write(6,'(/1x,a/)') repeat("=", 48)
            if(this%debug.eq.5) then
                call MA_SUMMARIZE_ALLOCATED_BLOCKS()
                call MA_PRINT_STATS(.true.)
            endif
        endif

        ierror = 0

    endfunction private_initialise
    integer(kind=intType) function private_finalise(this) result(ierror)

        class(GAType), intent(inout) :: this

        deallocate(this%procgroup)
        call GA_TERMINATE()
        call PEND

        ierror = 0

    endfunction private_finalise
    integer function private_summarise(this, level) result(ierror)

        class(GAType), intent(in) :: this
        class(*)     , intent(in) :: level

        selecttype(level)
            type is (integer(kind=4))
                call GA_SUMMARIZE(int8(level))
            type is (integer(kind=8))
                call GA_SUMMARIZE(level)
        endselect

        ierror = 0

    endfunction private_summarise
    subroutine private_synchronise(this)

        class(GAType), intent(inout) :: this

        call GA_SYNC()

    endsubroutine private_synchronise
    integer function private_print(this) result(ierror)

        class(GAType), intent(inout) :: this

        if(this%ncolours.gt.1.and.this%key.eq.0.and.this%debug.eq.5) then
            call GA_PRINT_STATS()
        endif

        ierror = 0

    endfunction private_print
    subroutine private_set_processors_group(this, proc_group)

        class(GAType), intent(inout) :: this
        integer      , intent(in)    :: proc_group(this%nkeys)

        call GA_PGROUP_SET_DEFAULT(proc_group(this%colour))

    endsubroutine private_set_processors_group
    logical function private_is_root(this) result(result)

        class(GAType), intent(in) :: this

!        result = this%key.eq.0
        result = GA_NODEID().eq.0

    endfunction private_is_root

endmodule ChemShellGAModule

!  Copyright (C) 2017 The authors of Py-ChemShell
!
!  This file is part of Py-ChemShell.
!
!  Py-ChemShell is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as
!  published by the Free Software Foundation, either version 3 of the
!  License, or (at your option) any later version.
!
!  Py-ChemShell is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with Py-ChemShell.  If not, see
!  <http://www.gnu.org/licenses/>.

module ChemShellDLPOLYModule

    use, intrinsic :: iso_c_binding
    use DL_PY2F 
    use ChemShellParallelModule
    use DLPOLYModule

    implicit none
    private

    public register_dl_poly, interface_dl_poly, dl_poly_wrap
    public PyFrag, PyShells, PyOptions, nshells

    type(dictType) , pointer :: PyFrag, PyShells, PyResult, PyOptions
    integer                  :: natoms, nshells

    integer        :: dl_poly_task
    integer(c_int) :: c_debug
    integer(c_int) :: dl_poly_handle

    contains

      
    subroutine register_dl_poly(debug) bind(c, name="f_register_dl_poly")

        use ChemShellParallelModule, only : chemsh_parallel

        integer(c_int), intent(in) :: debug

        type(c_funptr) :: dl_poly_pointer

        c_debug = debug

        dl_poly_pointer = c_funloc(dl_poly_wrap)
        dl_poly_handle = chemsh_parallel%get_function_handle(dl_poly_pointer)

    endsubroutine register_dl_poly
    ! called by master process only
    subroutine interface_dl_poly(fragPtr, resultPtr, optionsPtr) bind(c)
 
        use ChemShellParallelModule, only : chemsh_parallel

        implicit none
 
        type(PyType)  , intent(in) :: fragPtr
        type(PyType)  , intent(in) :: resultPtr
        type(PyType)  , intent(in) :: optionsPtr

        integer                    :: ierror
        type(PyType)  , pointer    :: shellsPtr

        ! set up dict of fragObj
        allocate(PyFrag, source=ptr2dict(fragPtr))
        call PyFrag%get('npts', natoms)
        call PyFrag%get('shells', shellsPtr)
        allocate(PyResult, source=ptr2dict(resultPtr))
        allocate(PyOptions, source=ptr2dict(optionsPtr))

        ! set up dict of shellsObj and save nshells
        allocate(PyShells, source=ptr2dict(shellsPtr))
        call PyShells%get('npts', nshells)
 
        if (chemsh_parallel%is_parallel()) then
           ierror = chemsh_parallel%exec_function(dl_poly_handle, c_debug)
        else
           ierror = dl_poly_wrap()
        endif
 
        if(associated(PyFrag)) then
            deallocate(PyFrag)
        endif
        if(associated(PyShells)) then
            deallocate(PyShells)
        endif
        if(associated(PyResult)) then
            deallocate(PyResult)
        endif
        if(associated(PyOptions)) then
            deallocate(PyOptions)
        endif
 
    endsubroutine interface_dl_poly
    ! also called by slave processes
    integer function dl_poly_wrap() result(ierror)

        use ChemShellParallelModule, only : chemsh_parallel
        use DLPOLYModule           , only : dl_poly_gradients, dl_poly_global_indices, control_filename, output_filename

        integer                   :: itype, lenbuf, ifrom, itag
        logical                   :: opened
        integer                   :: i, shapebuff(2), nnodes, node
        integer(kind=4) , pointer :: natoms_per_domain(:), global_indices_per_node(:)
        real(kind=8)    , pointer :: gradients(:,:), gbuff(:,:)
        character(len=:), pointer :: strbuff

        ! size of int for GULP
        lenbuf = 4
        ifrom  = 0
        itag   = 66

        if(chemsh_parallel%is_root()) then
            call PyOptions%get('output', strbuff)
            output_filename  = trim(strbuff)
! YL 17/08/2021: we can't yet get values out from a tuple so it's hardcoded for the time being
!            call PyOptions%get('input' , strbuff)
            control_filename = '_dl_poly.inp'
        endif

        ! number of nodes per subset (rather than workgroup!)
        nnodes = chemsh_parallel%nnodes_subset
        node   = chemsh_parallel%node_subset

        ierror = chemsh_parallel%broadcast(natoms, lenbuf, ifrom)

!        include "dl_poly_routines.f90"
        allocate(gradients(3,natoms))
        allocate(gbuff(3,natoms))
        allocate(global_indices_per_node(natoms))
        allocate(natoms_per_domain(nnodes))
        gradients = 0.0
        natoms_per_domain = 0
        
        ! share task control flag
        itype = 402

!        ierror = parallel%broadcast(itype, dl_poly_task, lenbuf, ifrom, 0)

        ! YL 30/11/2018: dl_poly_gradients is allocated by the DL_POLY main routine
!        allocate(dl_poly_gradients(3,natoms), stat=ierror)

        if(chemsh_parallel%is_subset()) then
            ! cast to system integer kind
            call dl_poly(int(chemsh_parallel%comm_subset))
        endif

        ! YL 24/11/2018: I don't know how it worked before, but in DL_POLY 4 the forces are held per
        !                domain (the fxx, fyy, & fzz arrays) and one domain has no idea about others'
        !                sizes, so we must creat a full list of natoms/domain to gather the gradients
        shapebuff = shape(dl_poly_gradients)
        if(chemsh_parallel%is_root()) then
            natoms_per_domain(1) = shapebuff(2)
            do i = 1, nnodes-1
                ierror = chemsh_parallel%receive(natoms_per_domain(i+1), lenbuf, i, itag)
            enddo
        else
            ! YL 21/11/2021: restrained to the MM subset otherwise Cray's MPICH (GNU>=10.2) segfaults
            !                on the remaining processes
            if(chemsh_parallel%is_subset()) then
                ierror = chemsh_parallel%send(shapebuff(2), lenbuf, 0, itag)
            endif
        endif

        ! get the whole array of indices per node
        if(chemsh_parallel%is_root()) then
            global_indices_per_node(1:natoms_per_domain(1)) = dl_poly_global_indices
            do i = 1, nnodes-1
                ierror = chemsh_parallel%receive(global_indices_per_node(sum(natoms_per_domain(1:i))+1:sum(natoms_per_domain(1:i+1))), 4*natoms_per_domain(i+1), i, itag)
            enddo
        else
            ! YL 21/11/2021: restrained to the MM subset otherwise Cray's MPICH (GNU>=10.2) segfaults
            !                on the remaining processes
            if(chemsh_parallel%is_subset()) then
                ierror = chemsh_parallel%send(dl_poly_global_indices, 4*shapebuff(2), 0, itag)
            endif
        endif

        ierror = chemsh_parallel%broadcast(natoms_per_domain, lenbuf*nnodes, 0)

        ! copy the domain's gradients to the buffer in the nodes order
        ! YL 21/11/2021: we restrain this operation to the MPI subset because otherwise GNU-compiled
        !                code throws out "Fortran runtime error: Array bound mismatch for dimension 1 of array 'gbuff' (1/3)"
        !                for the non-subset MPI processes; but do not use -fcheck=no-bounds in compile flags which
        !                causes more problems
        if(chemsh_parallel%is_subset()) then
            gbuff(1:3,sum(natoms_per_domain(1:node))+1:sum(natoms_per_domain(1:node+1))) = dl_poly_gradients
        endif

        ! the root gathers the gradients
        if(chemsh_parallel%is_root()) then
            do i = 1, nnodes-1
                ierror = chemsh_parallel%receive(gbuff(1:3,sum(natoms_per_domain(1:i))+1:sum(natoms_per_domain(1:i+1))), 8*3*natoms_per_domain(i+1), i, itag)
            enddo
        else
            ! YL 21/11/2021: restrained to the MM subset otherwise Cray's MPICH (GNU>=10.2) segfaults
            !                on the remaining processes
            if(chemsh_parallel%is_subset()) then
                ierror = chemsh_parallel%send(dl_poly_gradients, 8*3*shapebuff(2), 0, itag)
            endif
        endif

        ! sort the gradients according to the global indices
        if(chemsh_parallel%is_root()) then
            gradients(1:3,dl_poly_global_indices) = dl_poly_gradients
            do i = 1, nnodes-1
                gradients(1:3,global_indices_per_node(sum(natoms_per_domain(1:i))+1:sum(natoms_per_domain(1:i+1)))) = gbuff(1:3,sum(natoms_per_domain(1:i))+1:sum(natoms_per_domain(1:i+1)))
            enddo
        endif

        if(chemsh_parallel%is_root()) then
            call PyResult%set('energy'   , (/dl_poly_energy/))
            call PyResult%set('gradients', gradients)
        endif
        
        deallocate(gradients, gbuff, natoms_per_domain, global_indices_per_node)
        ! YL 14/02/2019: these public arrays should only be deallocated by
        !                ChemShell/DL_POLY4 interface
        if(associated(dl_poly_global_indices)) deallocate(dl_poly_global_indices)
        if(associated(dl_poly_gradients))      deallocate(dl_poly_gradients)

    endfunction dl_poly_wrap

endmodule ChemShellDLPOLYModule

!  Copyright (C) 2017 The authors of Py-ChemShell
!
!  This file is part of Py-ChemShell.
!
!  Py-ChemShell is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as
!  published by the Free Software Foundation, either version 3 of the
!  License, or (at your option) any later version.
!
!  Py-ChemShell is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with Py-ChemShell.  If not, see
!  <http://www.gnu.org/licenses/>.

module ChemShellDLFModule

    use, intrinsic :: iso_c_binding
    use DL_PY2F
    use dlf_parameter_module, only: rk
    use dlf_convergence     , only: valg, valrmsg, vals, valrmss

    private
    public interface_dlf, PyFrag, PyFrag2, PyResult
    public PyOptions, PyCallback, PySetParams
!, PyGetGrads
    public ierror

! YL: since Intel Compiler 2016, "external" is no longer allowed to be bind(c)
!     "error #8809: An OPTIONAL or EXTERNAL dummy argument to a BIND(C) procedure is not interoperable"
!    integer(c_long), pointer, external :: PyCallback
    abstract interface
        integer(c_long) function callback() bind(c)
            use iso_c_binding
        endfunction callback
        real(c_double) function objective() bind(c)
            use iso_c_binding
        endfunction objective
        integer(c_long) function setParams() bind(c)
            use iso_c_binding
        endfunction setParams
! YL 26/01/2021: unified the both callback functions for parameterisation and geometry otimisation to callback()
!        integer(c_long) function getGrads() bind(c)
!            use iso_c_binding
!        endfunction getGrads
    endinterface

    type(dictType)      , pointer :: PyFrag, PyFrag2, PyResult, PyOptions
    procedure(callback) , pointer :: PyCallback
    procedure(setParams), pointer :: PySetParams
!    procedure(getGrads) , pointer :: PyGetGrads
    integer                      :: ierror

    contains

!        function interface_dlf(nvarin, nvarin2, nspec, theoryPtr, fragPtr, resultPtr, optionsPtr, callbackPtr) bind(c) result(ireturn)
        function interface_dlf(nvarin, nvarin2, nspec, theoryPtr, fragPtr, resultPtr, optionsPtr) bind(c) result(ireturn)

            implicit none
    
            integer(c_long)           , intent(in) :: nvarin
            integer(c_long)           , intent(in) :: nvarin2
            integer(c_long)           , intent(in) :: nspec
            type(PyType)              , intent(in) :: theoryPtr
            type(PyType)              , intent(in) :: fragPtr
            type(PyType)              , intent(in) :: resultPtr
            type(PyType)              , intent(in) :: optionsPtr
!            type(c_funptr)            , intent(in) :: callbackPtr
    
            type(PyType)   , pointer               :: frag2Ptr
            integer(c_long), parameter             :: master = 1
            integer(c_int)                         :: ireturn

            ! if pyfuncPtr is a pointer GNU segfaults at runtime while Intel does not
            type(c_funptr)                         :: pyfuncPtr

            logical                                :: parameterise
            integer                                :: iparameterise
            real(rk)                               :: energy(1)

            allocate(PyFrag   , source=ptr2dict(fragPtr))
            allocate(PyResult , source=ptr2dict(resultPtr))
            allocate(PyOptions, source=ptr2dict(optionsPtr))
    
            ! callback function to calculate the gradients
            ! YL 26/01/2021: no longer needed as the pointer to the callback function is passed via PyOptions
!            call c_f_procpointer(callbackPtr, PyCallback)
            call PyOptions%get('callback', pyfuncPtr)
            call c_f_procpointer(pyfuncPtr, PyCallback)

            call PyOptions%get("parameterise", iparameterise)
            parameterise = iparameterise.eq.1

            ! atomistic mode
            if(.not.parameterise) then
                ! could be moved to dlf_get_parameters(), however will be difficult to deallocate
                call PyOptions%get('frag2', frag2Ptr)

                if(associated(frag2Ptr)) then
                    allocate(PyFrag2, source=ptr2dict(frag2Ptr))
                endif

            ! parameter mode
            else

                ! objective function
!                call PyOptions%get('objfunc', pyfuncPtr)
!                if(associated(pyfuncPtr)) then
!                call c_f_procpointer(pyfuncPtr, PyObjFunc)
!                endif
    
                ! function to set the parameter values
                call PyOptions%get('setParameters', pyfuncPtr)
!                if(associated(pyfuncPtr)) then
                call c_f_procpointer(pyfuncPtr, PySetParams)
!                endif
    
            endif

            call dlf_mpi_initialize

            call dl_find(nvarin, nvarin2, nspec, master)

            ! save the final energy, max grad, max step, RMS grad, RMS step
            ! this is the only place where we can get the information because no method of dlf_routines.f90 is called when DL_FIND converges
            call PyResult%get('energy', energy)
            call PyResult%set('convergences', (/energy(1),valg,vals,valrmsg,valrmss/))
    
            if(associated(PyFrag)) then
                call PyFrag%finalise()
                deallocate(PyFrag)
            endif
            if(associated(PyResult)) then
                call PyResult%finalise()
                deallocate(PyResult)
            endif
            if(associated(PyOptions)) then
                call PyOptions%finalise()
                deallocate(PyOptions)
            endif
            if(associated(PyFrag2)) then
                call PyFrag2%finalise()
                deallocate(PyFrag2)
            endif

            ireturn = ierror 
    
        endfunction interface_dlf

endmodule ChemShellDLFModule

!! COPYRIGHT
!!
!!  Copyright 2007 Johannes Kaestner (kaestner@theochem.uni-stuttgart.de),
!!  Tom Keal (thomas.keal@stfc.ac.uk), Alex Turner, Salomon Billeter,
!!  Stephan Thiel, Max-Planck Institut fuer Kohlenforshung, Muelheim, 
!!  Germany.
!!
!!  This file is part of DL-FIND.
!!
!!  DL-FIND is free software: you can redistribute it and/or modify
!!  it under the terms of the GNU Lesser General Public License as 
!!  published by the Free Software Foundation, either version 3 of the 
!!  License, or (at your option) any later version.
!!
!!  DL-FIND is distributed in the hope that it will be useful,
!!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!!  GNU Lesser General Public License for more details.
!!
!!  You should have received a copy of the GNU Lesser General Public 
!!  License along with DL-FIND.  If not, see 
!!  <http://www.gnu.org/licenses/>.
!!

MODULE dlfhdlc_hdlclib
!  USE global
  use dlf_parameter_module, only: rk
  use dlf_global, only: printl,stdout!,pi

  USE dlfhdlc_matrixlib
  USE dlfhdlc_primitive
  USE dlfhdlc_constraint
  IMPLICIT NONE

!------------------------------------------------------------------------------
! Type definitions for HDLC objects and initialisation
! Dimensions of integer matrices: (value, entry)
! Dimensions of Cartesians matrix: (component, atom), unlike old HDLCopt
!
! Fields of an HDLC object:
!
! name                    identification as in resn()
! natom                   number of atoms
! lgmatok                 .true. if G not linear dependent
! x       (natom)         X coordinates
! y       (natom)         Y coordinates
! z       (natom)         Z coordinates
! ut      matrix(ndlc,np) U transposed
! np                      number of primitives
! nconn                   number of connections
! nbend                   number of bends, linears, impropers
! nrots                   number of torsions
! ncons                   number of constraints
! iconn   (2,nconn)       connectivity
! ibend   (4,nbend)       bends, linears, impropers
! irots   (4,nrots)       torsions
! icons   (6,ncons)       constraints
! vcons   (ncons)         values of constraints
! oldxyz  matrix(3*natom,1) old xyz values (used for cartesian fitting)
! biasv                   bias vector
! err_cnt                 counter of HDLC breakdowns
! next    hdlc_obj        next HDLC object
! prev    hdlc_obj        previous HDLC object
!------------------------------------------------------------------------------

  TYPE residue_type
    ! scalars
    INTEGER :: name ! number of the this residue
    integer :: natom
    LOGICAL :: lgmatok
    INTEGER :: np, nconn, nbend, nrots, ncons
    logical :: tbias ! is bias set?
    ! replacing the linked list:
    integer :: next,prev
    integer :: ip ! start position of this residue in the icoords array
    INTEGER :: err_cnt
    ! arrays
    ! allocated in hdlc_create, deallocated in hdlc_destroy
    REAL (rk), POINTER :: x(:), y(:), z(:) ! (natom)
    INTEGER, POINTER   :: iconn(:,:) ! (2,max(1,residue%nconn))
    INTEGER, pointer   :: ibend(:,:) ! (4,max(1, > residue%nbend))
    INTEGER, POINTER   :: irots(:,:) ! (4,max(1, > residue%nrots))
    INTEGER, POINTER   :: icons(:,:) ! (6,max(1,residue%ncons))
    REAL (rk), POINTER :: vcons(:) ! (max(1,residue%ncons))
    REAL (rk), POINTER :: biasv(:) ! (residue%np) reference value for torsions and impropers
    ! at and xweight are allocated in dlf_hdlc_init, deallocated in dlf_hdlc_destroy
    ! at and xweight used to be allocatable arrays rather than pointers.
    ! JK changed it to pointers to make the code work with pgf90 7.1 and newer
    integer,  pointer  :: at(:) ! (natom) atom indices 
    real(rk), pointer  :: xweight(:) ! (natom)
    ! matrices
    TYPE (matrix) :: ut      ! (n6,nii,'Ut matrix')
    TYPE (matrix) :: oldxyz  ! (3*residue%natom,1,'old XYZ')
    TYPE (matrix) :: iweight ! (matrix_dimension(bhdlc,1)-residue%ncons ,1,'i weight')
  END TYPE residue_type

!------------------------------------------------------------------------------
! Module variables
! - checkpointing of hdlc and all residues: hdlc_wr_hdlc / hdlc_rd_hdlc
!
! lhdlc    .true. if there are internal (HDLC or DLC) coordinates
! internal .true. if 3N-6 DLC instead of 3N HDLC (internals only)
! ngroups  number of active (i.e. non-deleted) HDLC residues
! first    pointer to the first HDLC object
! last     pointer to the last HDLC object
!------------------------------------------------------------------------------

  TYPE hdlc_ctrl
    ! all allcatables are allocated in dlf_hdlc_init, and dallocated in dlf_hdlc_destroy
    LOGICAL              :: tinit ! is this instance initialised?
    LOGICAL              :: lhdlc, internal
    INTEGER              :: ngroups
    integer              :: contyp ! 0 internals, 1 total connection
    integer, allocatable :: resn(:) ! (nat)
    integer, allocatable :: err_cnt(:) ! (ngroups) error counter
    integer              :: nmin ! 0 for hdlc, 6 for DLC
    ! residues
    integer              :: first,last ! number of first and last active res
    TYPE (residue_type), allocatable :: res(:) ! (last-first+1)
    ! constraint data
    integer              :: nconstr ! global number of constraints
    integer, allocatable :: iconstr(:,:) ! (6,nconstr) constraint data
    ! connection data
    integer              :: nincon ! number of user provided connections
    integer, allocatable :: incon(:,:) ! (2,nincon) connections
    logical              :: interror ! internal permanent error ocurred
    integer              :: ngroupsdrop ! number of groups to drop when restarted
    integer              :: nfrozen ! number of frozen atoms
  END TYPE hdlc_ctrl

  TYPE (hdlc_ctrl),save :: hdlc

CONTAINS

!==============================================================================
! routines formerly known as method routines of HDLC objects
!==============================================================================

!------------------------------------------------------------------------------
! subroutine hdlc_create
!
! method: create
!
! Creates a new HDLC residue from cartesian coordinates and (optionally)
! connectivity and constraints.
!------------------------------------------------------------------------------

  SUBROUTINE hdlc_create(residue,xyz,con,cns,name)
    ! create residue hdlc%res(name) 

! args
    INTEGER name
    TYPE (residue_type), intent(inout) :: residue
    TYPE (matrix) :: xyz, cns
    TYPE (int_matrix) :: con

! local vars
    LOGICAL failed
    INTEGER idum, n6, ni,jdum
    TYPE (matrix) :: bprim, bhdlc, ighdlc
    ! for setting the bias
    real(rk),pointer    :: prim_tmp(:)
    TYPE (matrix) :: chdlc, primweight

! begin, do linked list stuff
    IF (printl>=2) THEN
      WRITE (stdout,'(3x,a,i4)') 'Generating HDLC for residue ', name
    END IF

    residue%name=name
    residue%next=-1
    IF (hdlc%ngroups==0) THEN
      ! this is the first residue
      residue%prev=-1
    ELSE
      residue%prev=name-1
      hdlc%res(name-1)%next=name
    END IF
    hdlc%ngroups = hdlc%ngroups + 1

! clear pointers of the new residue and other values
    NULLIFY (residue%x)
    NULLIFY (residue%y)
    NULLIFY (residue%z)
    NULLIFY (residue%iconn)
    NULLIFY (residue%ibend)
    NULLIFY (residue%irots)
    NULLIFY (residue%icons)
    NULLIFY (residue%vcons)
    NULLIFY (residue%biasv)
    idum=matrix_destroy(residue%ut)
    idum=matrix_destroy(residue%oldxyz)
    idum=matrix_destroy(residue%iweight)
    residue%ncons = 0
    residue%nconn = 0
    residue%nbend = 0
    residue%nrots = 0

! store residue information
    residue%name = name

! store the coordinates as components
    residue%natom = matrix_dimension(xyz,1)/3
    allocate (residue%x(residue%natom))
    allocate (residue%y(residue%natom))
    allocate (residue%z(residue%natom))
    CALL hdlc_linear_checkin(xyz,residue%natom,residue%x,residue%y,residue%z)

! if there are connections - fill in connections
    IF (allocated(con%data)) THEN
      residue%nconn = int_matrix_dimension(con,2)
      allocate (residue%iconn(2,max(1,residue%nconn)))
      CALL hdlc_con_checkin(con,residue%nconn,residue%iconn)

! fill in connections required for constraints
      IF (allocated(cns%data)) THEN
        residue%ncons = matrix_dimension(cns,2)
        allocate (residue%icons(6,max(1,residue%ncons)))
        allocate (residue%vcons(max(1,residue%ncons)))
        CALL ci_cons(cns,residue%ncons,residue%icons,residue%vcons, &
          residue%nconn,residue%iconn)
      else
        ! allocate constraint data nontheless
        allocate (residue%icons(6,max(1,residue%ncons)))
        allocate (residue%vcons(max(1,residue%ncons)))
      END IF


! generate angular primitives from connectivity
      CALL valcoor(residue%nconn,residue%iconn,residue%natom,residue%x, &
        residue%y,residue%z,residue%nbend,residue%ibend,residue%nrots, &
        residue%irots)

! if there are no connections yet - apply total connection scheme
    ELSE
      NULLIFY (residue%iconn)
      CALL connect_all(residue%natom,residue%nconn,residue%iconn)

      ! allocate constraint data nontheless
      allocate (residue%icons(6,max(1,residue%ncons)))
      allocate (residue%vcons(max(1,residue%ncons)))
    END IF ! (associated(con))

! done connections, now do angular constraints
    IF (residue%ncons>0) THEN
      CALL ck_angle_cons(residue%ncons,residue%icons,residue%nconn, &
        residue%ibend,residue%nbend,residue%irots,residue%nrots)
    END IF

! print out primitives - ugly patch for SGI machines
    IF ( .NOT. associated(residue%ibend)) allocate (residue%ibend(4,1))
    IF ( .NOT. associated(residue%irots)) allocate (residue%irots(4,1))
    CALL valcoor_print(residue%nconn,residue%iconn,residue%nbend, &
      residue%ibend,residue%nrots,residue%irots,residue%x,residue%y,residue%z, &
      residue%natom)

! generate the primitive B matrix
    CALL hdlc_make_bprim(residue%natom,residue%x,residue%y,residue%z, &
      residue%nconn,residue%iconn,residue%nbend,residue%ibend,residue%nrots, &
      residue%irots,residue%np,bprim,ni,residue%xweight,primweight)

! generate the Ut matrix
    CALL hdlc_make_ut(residue%ut,bprim)

! orthogonalise against constrained space
    IF (residue%ncons>0) THEN
      CALL ortho_cons(residue%ut,residue%ncons,residue%icons)
    END IF

! generate HDLC B matrix
    CALL hdlc_make_bhdlc(bprim,bhdlc,residue%ut)

    ! iweight_i = (%ut_ij)**2 * primweight_j
    residue%iweight = matrix_create( &
        matrix_dimension(bhdlc,1)-residue%ncons ,1,'i weight')
    !idum = matrix_multiply(1.0D0,residue%ut,primweight,0.0D0,residue%iweight)
    residue%iweight%data(:,:)=0.D0
    ! constrained hdlcs are at the end, and need not to be addressed here
    do idum=1,matrix_dimension(residue%ut,1)-residue%ncons ! number of hdlcs
      do jdum=1,matrix_dimension(residue%ut,2) ! number of primitives
        residue%iweight%data(idum,1)=residue%iweight%data(idum,1) + &
            residue%ut%data(idum,jdum)**2 * primweight%data(jdum,1)
      end do
    end do
    idum=matrix_destroy(primweight)

! generate HDLC inverse G matrix - only as check - set residue%lgmatok
    CALL hdlc_make_ighdlc(bhdlc,ighdlc,failed)
    CALL hdlc_report_failure(residue,failed,'create')

! here would be the initialisation of the internal biasing vector
    allocate (residue%biasv(residue%np))
    CALL vector_initialise(residue%biasv,residue%np,0.0D0)

! generate matrix holding the Cartesians of the previous step
    residue%oldxyz = matrix_create(3*residue%natom,1,'old XYZ')
    idum = matrix_copy(xyz,residue%oldxyz)

! initialise cyclic failure counter
    residue%err_cnt = 0

    residue%tbias=.false.
    ! transform coordinates to hdlc once to set bias
    chdlc = matrix_create(3*residue%natom-hdlc%nmin,1,'CHDLC tmp')
    call coord_cart_to_hdlc(residue,xyz,chdlc,prim_tmp,.false.)
    idum = matrix_destroy(chdlc)

! clean up
    idum = matrix_destroy(bprim)
    idum = matrix_destroy(bhdlc)
    idum = matrix_destroy(ighdlc)

! end
  END SUBROUTINE hdlc_create

!------------------------------------------------------------------------------
! subroutine hdlc_destroy
!
! method: destry
!
! Destroys a HDLC residue
!------------------------------------------------------------------------------

  SUBROUTINE hdlc_destroy(residue)

! args
    TYPE (residue_type),intent(inout) :: residue !, first, last

! local vars
    INTEGER idum

! begin
    IF (printl>=5) THEN
      WRITE (stdout,'(a,i4,/)') 'Destroying HDLC residue ', residue%name
    END IF

    ! care about linked list
    IF (residue%next/=-1) THEN
      IF (residue%prev/=-1) THEN ! not first, not last
        hdlc%res(residue%prev)%next=residue%next
        hdlc%res(residue%next)%prev=residue%prev
      ELSE ! first, not last
        hdlc%first=residue%next
        hdlc%res(residue%next)%prev=-1
      END IF
    ELSE ! not first, last
      IF (residue%prev/=-1) THEN
        hdlc%last = residue%prev
        hdlc%res(residue%prev)%next=-1
      ELSE ! first, last
        hdlc%first=-1
        hdlc%last=-1
      END IF
    END IF
    ! destroy storage
    IF (associated(residue%x)) deallocate (residue%x)
    IF (associated(residue%y)) deallocate (residue%y)
    IF (associated(residue%z)) deallocate (residue%z)
    IF (associated(residue%iconn)) deallocate (residue%iconn)
    IF (associated(residue%ibend)) deallocate (residue%ibend)
    IF (associated(residue%irots)) deallocate (residue%irots)
    IF (associated(residue%icons)) deallocate (residue%icons)
    IF (associated(residue%vcons)) deallocate (residue%vcons)
    IF (associated(residue%biasv)) deallocate (residue%biasv)

    ! To me this seems like a compiler bug: if i destroy residue%ut with g95,
    ! hdlc%res(residue%name)%ut is still allocated. Thus we destroy that directly
    ! this was the case, when hdlc_destroy was called with a residue that was not
    ! mapped back to hldc%res(i)
    idum = matrix_destroy(residue%ut)
    !idum = matrix_destroy(hdlc%res(residue%name)%ut)
    idum=matrix_destroy(residue%oldxyz)
    !idum=matrix_destroy(hdlc%res(residue%name)%oldxyz)
    idum=matrix_destroy(residue%iweight)
    !idum=matrix_destroy(hdlc%res(residue%name)%iweight)

    hdlc%ngroups = hdlc%ngroups - 1
    residue%name=-1

    ! residue%at and residue%xweight are deallocated in dlf_hdlc_destroy

  END SUBROUTINE hdlc_destroy

!------------------------------------------------------------------------------
! subroutine coord_cart_to_hdlc
!
! method: getint
!
! Convert Cartesian coordinates to HDLC
!
! Note: if this subroutine is called by coord_hdlc_to_cart,
! - set lback to .true.
! - prim is preallocated on call, prim is set with primitives on return
! - the Cartesians are not stored to res%oldxyz
!------------------------------------------------------------------------------

  SUBROUTINE coord_cart_to_hdlc(res,xyz,chdlc,prim,lback)

! args
    LOGICAL lback
    REAL (rk), DIMENSION (:), POINTER :: prim
    TYPE (residue_type) :: res
    TYPE (matrix) :: xyz, chdlc

! local params
    REAL (rk) one
    PARAMETER (one=1.0D0)

! local vars
    INTEGER i, idum, j, n6, nip
    REAL (rk) a1, a2, dx, dy, dz, fact, r
    REAL (rk), DIMENSION (:), ALLOCATABLE :: x, y, z, p, iut

! begin, the following exception should never occur
    IF (res%natom/=matrix_dimension(xyz,1)/3) THEN
      WRITE (stdout,'(A,I4,A,I4,A,I4)') 'Residue ', res%name, ', natom: ', &
        res%natom, '; coordinates, natom: ', matrix_dimension(xyz,1)/3
      CALL hdlc_errflag('Size mismatch','abort')
    END IF

! allocate temporary space and separate Cartesian components
    call allocate (x,res%natom)
    call allocate (y,res%natom)
    call allocate (z,res%natom)
    call allocate (p,3*res%natom)
    CALL hdlc_linear_checkin(xyz,res%natom,x,y,z)

! init memory for primitive internals and rows of UT
    IF ( .NOT. lback) allocate (prim(res%np))
    call allocate (iut,res%np)
    nip = 0
    IF (hdlc%internal) THEN
      n6 = 3*res%natom - 6
    ELSE
      n6 = 3*res%natom
    END IF

! set up scaling factor for Cartesians
!!$    IF (ctrl%cfact==0.0D0) THEN
      fact = 1.0D0/real(res%natom,rk)
      fact=1.d0 ! hardcoded at the moment
!!$    ELSE IF (ctrl%cfact<0.0D0) THEN
!!$      fact = -ctrl%cfact/real(res%natom,rk)
!!$    ELSE
!!$      fact = ctrl%cfact
!!$    END IF

! compute all stretches
    DO i = 1, res%nconn
      nip = nip + 1
      dx = x(res%iconn(1,i)) - x(res%iconn(2,i))
      dy = y(res%iconn(1,i)) - y(res%iconn(2,i))
      dz = z(res%iconn(1,i)) - z(res%iconn(2,i))
      r = sqrt(dx*dx+dy*dy+dz*dz)
      prim(nip) = r
    END DO

! compute all bends
    DO i = 1, res%nbend
      IF (res%ibend(1,i)>0) THEN
        nip = nip + 1

! bends: simple bend
        IF (res%ibend(4,i)==0) THEN
          prim(nip) = vangle(x(res%ibend(1,i)),x(res%ibend(2, &
            i)),x(res%ibend(3,i)),y(res%ibend(1,i)),y(res%ibend(2, &
            i)),y(res%ibend(3,i)),z(res%ibend(1,i)),z(res%ibend(2, &
            i)),z(res%ibend(3,i)))

! bends: dihedrals - impropers??
        ELSE IF (res%ibend(4,i)>0) THEN
          prim(nip) = vdihedral(x(res%ibend(1,i)),y(res%ibend(1, &
            i)),z(res%ibend(1,i)),x(res%ibend(2,i)),y(res%ibend(2, &
            i)),z(res%ibend(2,i)),x(res%ibend(3,i)),y(res%ibend(3, &
            i)),z(res%ibend(3,i)),x(res%ibend(4,i)),y(res%ibend(4, &
            i)),z(res%ibend(4,i)))
!          prim(nip) = prim(nip) + res%biasv(nip) ! JK was
          if(.not.res%tbias) then
            res%biasv(nip)=prim(nip)
            !hdlc%res(res%name)%biasv(nip)=prim(nip)
          else
            ! set as close as possible to bias ...
            if(prim(nip)-res%biasv(nip) > pi )  prim(nip)=prim(nip)- 2.D0 * pi
            if(prim(nip)-res%biasv(nip) < -pi ) prim(nip)=prim(nip)+ 2.D0 * pi
            ! now bprim should be within pi to bias, if not terminate
            if(prim(nip)-res%biasv(nip) > pi ) then
              print*,res%biasv(nip)
              print*,prim(nip)
              call dlf_fail("HDLC Bias problem")
            end if
            if(prim(nip)-res%biasv(nip) < -pi) then
              print*,res%biasv(nip)
              print*,prim(nip)
              call dlf_fail("HDLC Bias problem")
            end if
            if(printl >= 4 .and. abs(prim(nip)-res%biasv(nip)) > 3.D0) then
              write(stdout,"('Warning, Torsion or improper number ',i4,&
                  &' differs by more than 3.0 from bias. Troubles likely')") nip
              write(stdout,"('Improper=',es15.7,' Bias=',es15.7)") &
                  prim(nip),res%biasv(nip)
            end if
          end if

! bends: linear bends (two bends in each of two planes, see hdlc_make_bprim)
        ELSE IF (res%ibend(4,i)<=-1) THEN
          a1 = vangle(x(res%ibend(1,i)),x(res%ibend(2,i)),x(res%ibend(2, &
            i)),y(res%ibend(1,i)),y(res%ibend(2,i)),y(res%ibend(2, &
            i))+one,z(res%ibend(1,i)),z(res%ibend(2,i)),z(res%ibend(2,i)))
          a2 = vangle(x(res%ibend(2,i)),x(res%ibend(2,i)),x(res%ibend(3, &
            i)),y(res%ibend(2,i))+one,y(res%ibend(2,i)),y(res%ibend(3, &
            i)),z(res%ibend(2,i)),z(res%ibend(2,i)),z(res%ibend(3,i)))
!            prim(nip) = a1 + a2
          prim(nip) = y(res%ibend(2,i))
          nip = nip + 1
          IF (res%ibend(4,i)==-1) THEN
            a1 = vangle(x(res%ibend(1,i)),x(res%ibend(2,i)),x(res%ibend(2, &
              i)),y(res%ibend(1,i)),y(res%ibend(2,i)),y(res%ibend(2, &
              i)),z(res%ibend(1,i)),z(res%ibend(2,i)),z(res%ibend(2,i))+one)
            a2 = vangle(x(res%ibend(2,i)),x(res%ibend(2,i)),x(res%ibend(3, &
              i)),y(res%ibend(2,i)),y(res%ibend(2,i)),y(res%ibend(3, &
              i)),z(res%ibend(2,i))+one,z(res%ibend(2,i)),z(res%ibend(3,i)))
          ELSE
            a1 = vangle(x(res%ibend(1,i)),x(res%ibend(2,i)),x(res%ibend(2, &
              i))+one,y(res%ibend(1,i)),y(res%ibend(2,i)),y(res%ibend(2, &
              i)),z(res%ibend(1,i)),z(res%ibend(2,i)),z(res%ibend(2,i)))
            a2 = vangle(x(res%ibend(2,i))+one,x(res%ibend(2,i)),x(res%ibend(3, &
              i)),y(res%ibend(2,i)),y(res%ibend(2,i)),y(res%ibend(3, &
              i)),z(res%ibend(2,i)),z(res%ibend(2,i)),z(res%ibend(3,i)))
          END IF
!            prim(nip) = a1 + a2
          IF (res%ibend(4,i)==-1) THEN
            prim(nip) = z(res%ibend(2,i))
          ELSE
            prim(nip) = x(res%ibend(2,i))
          END IF
        END IF ! (res%ibend(4,i) .eq. 0) ... else if ...
      END IF ! (res%ibend(4,i) .eq. 0)
    END DO ! (i = 1,res%nbend)

! dihedrals
    DO i = 1, res%nrots
      nip = nip + 1
      prim(nip) = vdihedral(x(res%irots(1,i)),y(res%irots(1,i)),z(res%irots(1, &
        i)),x(res%irots(2,i)),y(res%irots(2,i)),z(res%irots(2, &
        i)),x(res%irots(3,i)),y(res%irots(3,i)),z(res%irots(3, &
        i)),x(res%irots(4,i)),y(res%irots(4,i)),z(res%irots(4,i)))
!      prim(nip) = prim(nip) + res%biasv(nip) ! JK was
      if(.not.res%tbias) then
        res%biasv(nip)=prim(nip)
        !hdlc%res(res%name)%biasv(nip)=prim(nip)
      else
        ! set as close as possible to bias ...
        if(prim(nip)-res%biasv(nip) > pi )  prim(nip)=prim(nip)- 2.D0 * pi
        if(prim(nip)-res%biasv(nip) < -pi ) prim(nip)=prim(nip)+ 2.D0 * pi
        ! now bprim should be within pi to bias, if not terminate
        if(prim(nip)-res%biasv(nip) > pi ) then
          print*,res%biasv(nip)
          print*,prim(nip)
          call dlf_fail("HDLC Bias problem")
        end if
        if(prim(nip)-res%biasv(nip) < -pi) then
          print*,res%biasv(nip)
          print*,prim(nip)
          call dlf_fail("HDLC Bias problem")
        end if
        if(printl >= 4 .and. abs(prim(nip)-res%biasv(nip)) > 3.D0) then
          write(stdout,"('Warning, Torsion or improper number ',i4,&
              &' differs by more than 3.0 from bias. Troubles likely')") nip
              write(stdout,"('Improper=',es15.7,' Bias=',es15.7)") &
                  prim(nip),res%biasv(nip)
        end if
      end if
    END DO

    res%tbias=.true. ! now, bias is set - this does not seem to work!
    ! to set a residue variable, we have to adress it via hdlc%res(res%name)
    hdlc%res(res%name)%tbias=.true. 

! Cartesians if required
    IF ( .NOT. hdlc%internal) THEN
      DO i = 1, res%natom
        nip = nip + 1
        prim(nip) = x(i)*fact
        nip = nip + 1
        prim(nip) = y(i)*fact
        nip = nip + 1
        prim(nip) = z(i)*fact
      END DO
    END IF

! if nip is not res%np, something went really wrong
    IF (nip/=res%np) THEN
      WRITE (stdout,'(/,A,I4,A,I4)') 'Error, nip: ', nip, ', np: ', res%np
      CALL hdlc_errflag('Error converting Cartesians to HDLC','stop')
    END IF

!//////////////////////////////////////////////////////////////////////////////
! the primitives are available in prim(1..nip) at this point
!//////////////////////////////////////////////////////////////////////////////
    ! print primitives
    IF ( .NOT. lback .and. printl >= 6) then
      DO i = 1,res%np
        write(stdout,'("Primitive ",i4," = ",es15.6," Bias = ",es15.6)') &
            i,prim(i),res%biasv(i)
      end DO
    end IF

! to find HDLC, multiply each row of UT by the primitive internals and sum up
    DO i = 1, n6
      p(i) = 0.0D0
      idum = matrix_get_row(res%ut,size(iut),iut,i)
      DO j = 1, res%np
        p(i) = p(i) + iut(j)*prim(j)
      END DO
!      write (stdout,'(a,i4,a,f20.14)') 'HDLC coordinate ', i, ': ', p(i)
    END DO

! if in internals, set last 6 to zero
    IF (hdlc%internal) THEN
      DO i = n6 + 1, n6 + 6
        p(i) = 0.0D0
      END DO
    END IF

! free memory for primitive internals and rows of UT
    call deallocate (iut)
    IF ( .NOT. lback) deallocate (prim)

! store HDLC to the returned matrix and hold Cartesians in the residue
    idum = matrix_set(chdlc,size(p),p)
    IF ( .NOT. lback) idum = matrix_copy(xyz,res%oldxyz)

! clean up
    call deallocate (p)
    call deallocate (z)
    call deallocate (y)
    call deallocate (x)

  END SUBROUTINE coord_cart_to_hdlc

!------------------------------------------------------------------------------
! subroutine grad_cart_to_hdlc
!
! method: intgrd
!
! Convert Cartesian gradient to HDLC
!------------------------------------------------------------------------------

  SUBROUTINE grad_cart_to_hdlc(res,xyz,gxyz,ghdlc)

! args
    TYPE (residue_type) :: res
    TYPE (matrix) :: xyz, gxyz, ghdlc

! local vars
    LOGICAL failed
    INTEGER i, idum, n, n6, ni
    REAL (rk), DIMENSION (:), ALLOCATABLE :: x, y, z
    REAL (rk), DIMENSION (:,:), POINTER :: ghdlc_dat
    TYPE (matrix) :: bprim, bhdlc, bthdlc, ighdlc, primweight

! begin, the following exception should never occur
    IF (res%natom/=matrix_dimension(gxyz,1)/3) THEN
      WRITE (stdout,'(A,I4,A,I4,A,I4)') 'Residue ', res%name, ', natom: ', &
        res%natom, '; coordinates, natom: ', matrix_dimension(gxyz,1)/3
      CALL hdlc_errflag('Size mismatch','abort')
    END IF

! allocate temporary space and separate Cartesian components
    call allocate (x,res%natom)
    call allocate (y,res%natom)
    call allocate (z,res%natom)
    CALL hdlc_linear_checkin(xyz,res%natom,x,y,z)

! number of HDLC internals: n6, number of Cartesians: n 
    n = res%natom*3
    IF (hdlc%internal) THEN
      n6 = n - 6
    ELSE
      n6 = n
    END IF

! generate a primitive B matrix (force generation of a new matrix)
    idum = matrix_destroy(bprim)
    CALL hdlc_make_bprim(res%natom,x,y,z,res%nconn,res%iconn,res%nbend, &
      res%ibend,res%nrots,res%irots,res%np,bprim,ni,res%xweight,primweight)

    ! we don't need the weights here, so destroy primweight
    idum=matrix_destroy(primweight)

! generate delocalised B matrix (force again)
    idum = matrix_destroy(bhdlc)
    CALL hdlc_make_bhdlc(bprim,bhdlc,res%ut)

! generate HDLC inverse G matrix
    idum = matrix_destroy(ighdlc)
    CALL hdlc_make_ighdlc(bhdlc,ighdlc,failed)
    CALL hdlc_report_failure(res,failed,'intgrd')

! make HDLC Bt**-1
    bthdlc = matrix_create(n6,n,'HDLC_BT')
    idum = matrix_multiply(1.0D0,ighdlc,bhdlc,0.0D0,bthdlc)

! set HDLC gradient = (Bt**-1) * Cartesian gradient
    idum = matrix_multiply(1.0D0,bthdlc,gxyz,0.0D0,ghdlc)

! clean up
    idum = matrix_destroy(bprim)
    idum = matrix_destroy(bhdlc)
    idum = matrix_destroy(bthdlc)
    idum = matrix_destroy(ighdlc)
    call deallocate (z)
    call deallocate (y)
    call deallocate (x)
!   call timePrint('END-INTGRAD')

  END SUBROUTINE grad_cart_to_hdlc

!------------------------------------------------------------------------------
! subroutine hess_cart_to_hdlc
!
! method: intgrd
!
! Convert Cartesian hessian to HDLC
!
! Johannes Kaestner, 2006
!------------------------------------------------------------------------------

  SUBROUTINE hess_cart_to_hdlc(res,xyz,hxyz,hhdlc)

    IMPLICIT NONE
! args
    TYPE (residue_type) :: res
    TYPE (matrix) :: xyz, hxyz, hhdlc

! local vars
    LOGICAL failed
    INTEGER i, idum, n, n6, ni
    REAL (rk), DIMENSION (:), ALLOCATABLE :: x, y, z
    REAL (rk), DIMENSION (:,:), POINTER :: ghdlc_dat
    TYPE (matrix) :: bprim, bhdlc, bthdlc, ighdlc, htmp,primweight
    real (rk) :: det

! begin, the following exception should never occur
    IF (res%natom/=matrix_dimension(hxyz,1)/3) THEN
      WRITE (stdout,'(A,I4,A,I4,A,I4)') 'Residue ', res%name, ', natom: ', &
        res%natom, '; coordinates, natom: ', matrix_dimension(hxyz,1)/3
      CALL hdlc_errflag('Size mismatch','abort')
    END IF

! allocate temporary space and separate Cartesian components
    call allocate (x,res%natom)
    call allocate (y,res%natom)
    call allocate (z,res%natom)
    CALL hdlc_linear_checkin(xyz,res%natom,x,y,z)

! number of HDLC internals: n6, number of Cartesians: n 
    n = res%natom*3
    IF (hdlc%internal) THEN
      n6 = n - 6
    ELSE
      n6 = n
    END IF

! generate a primitive B matrix (force generation of a new matrix)
    idum = matrix_destroy(bprim)
    CALL hdlc_make_bprim(res%natom,x,y,z,res%nconn,res%iconn,res%nbend, &
      res%ibend,res%nrots,res%irots,res%np,bprim,ni,res%xweight,primweight)

    ! we don't need the weights here, so destroy primweight
    idum=matrix_destroy(primweight)


! generate delocalised B matrix (force again)
    idum = matrix_destroy(bhdlc)
    CALL hdlc_make_bhdlc(bprim,bhdlc,res%ut)

! generate HDLC inverse G matrix
    idum = matrix_destroy(ighdlc)
    CALL hdlc_make_ighdlc(bhdlc,ighdlc,failed)
    CALL hdlc_report_failure(res,failed,'intgrd')

! make HDLC Bt**-1
    bthdlc = matrix_create(n6,n,'HDLC_BT')
    idum = matrix_multiply(1.0D0,ighdlc,bhdlc,0.0D0,bthdlc)

! set HDLC hessian  = (Bt**-1) * Cartesian hessian * (Bt**-1)T
    htmp = matrix_create(n6,n,'Bt**-1 x hxyz')
    idum = matrix_multiply(1.0D0,bthdlc,hxyz,0.0D0,htmp)
    idum = matrix_transpose(bthdlc)
    idum = matrix_multiply(1.0D0,htmp,bthdlc,0.0D0,hhdlc)

! clean up
    idum = matrix_destroy(htmp)
    idum = matrix_destroy(bprim)
    idum = matrix_destroy(bhdlc)
    idum = matrix_destroy(bthdlc)
    idum = matrix_destroy(ighdlc)

    call deallocate (z)
    call deallocate (y)
    call deallocate (x)

  END SUBROUTINE hess_cart_to_hdlc

!------------------------------------------------------------------------------
! subroutine coord_hdlc_to_cart
!
! method: getcrt
!
! Convert HDLC to Cartesian coordinates
!
! Arrays/matrices of Cartesians:
! xyz:                 Cartesians returned by this routine
! res%oldxyz:          Cartesians stored by coords_cart_to_hdlc
! res%x, res%y, res%z: Cartesians used to generate UT (by hdlc_create)
!------------------------------------------------------------------------------

  SUBROUTINE coord_hdlc_to_cart(res,xyz,chdlc)

! args
    TYPE (residue_type) :: res
    TYPE (matrix) :: xyz, chdlc

! local params
    REAL (rk) poor
    PARAMETER (poor=1.0D-6)

! local vars
    LOGICAL failed, flipped
    INTEGER failc, i, idum, iter, j, k, n, n6, ni
    REAL (rk) absm, cexit, dx, dy, mag, trust
    REAL (rk), DIMENSION (:), ALLOCATABLE :: tmp_dif, x, y, z
    REAL (rk), DIMENSION (:), POINTER :: prim, oldprim, tmp_prim
    TYPE (matrix) :: dif, xdif, bthdlc, xyzbak, xyzback, olhdlc, bhdlc, &
      ighdlc, bprim, scrdif
    ! for printing redudant internals
    TYPE (matrix) :: umat,qmat,primweight

! begin, the following exception should never occur
    IF (res%natom/=matrix_dimension(xyz,1)/3) THEN
      WRITE (stdout,'(A,I4,A,I4,A,I4)') 'Residue ', res%name, ', natom: ', &
        res%natom, '; coordinates, natom: ', matrix_dimension(xyz,1)/3
      CALL hdlc_errflag('Size mismatch','abort')
    END IF

! this parameter needs to be set upon every call
    cexit = 1.0D-12

! say what we are doing
    IF (printl>=6) WRITE (stdout,'(7X,A,/)') 'Entering fitting algorithm'
    IF (printl>=6) THEN
      WRITE (stdout,'(5X,A,E8.1)') 'Initial maximum exit error in HDLC is ', &
        cexit
      WRITE (stdout,'(5X,A,E8.1)') &
        'Convergence considered poor if error greater than ', poor
    END IF

! n6 is the number of HDLC in the residue
    n = 3*res%natom
    IF (hdlc%internal) THEN
      n6 = n - 6
    ELSE
      n6 = n
    END IF

! generate some work matrices
    dif = matrix_create(n6,1,'HDLC diff')
    xdif = matrix_create(n,1,'Cart diff')
    bthdlc = matrix_create(n6,n,'HDLC_BT')
    xyzbak = matrix_create(n,1,'Cart backup')
    ! xyzback is used in case of breakdown to copy back the original cartesians
    xyzback = matrix_create(n,1,'Cart store')
    olhdlc = matrix_create(n6,1,'old HDLC')

! allocate memory for primitives
    allocate (prim(res%np))
    allocate (oldprim(res%np))

! allocate arrays holding the Cartesian components
    call allocate (x,res%natom)
    call allocate (y,res%natom)
    call allocate (z,res%natom)

! intial guess of Cartesians are the input Cartesians - changed by JK,
    ! was the other way round
    idum = matrix_copy(xyz,res%oldxyz)

! backup old Carts in case the iterative B matrix method fails and least square
! SD fitting is used
    idum = matrix_copy(res%oldxyz,xyzbak)
    idum = matrix_copy(res%oldxyz,xyzback)

! set currect Carts to old Carts
    idum = matrix_copy(res%oldxyz,xyz)

! the following deallocations to force generation should never be necessary
    idum = matrix_destroy(bhdlc)
    idum = matrix_destroy(ighdlc)
    idum = matrix_destroy(bprim)

    ! This is to start from zero bias. I am not sure if this is good!
    !CALL vector_initialise(res%biasv,res%np,0.0D0)

    if(printl>=6.and..not.hdlc%internal) then
      write(stdout,"('Fitting to non-redundant internals:')")
      idum=matrix_print(chdlc)
      write(stdout,"('Starting fit from cartesians:')")
      idum=matrix_print(xyz)
      write(stdout,"('Possible redundant internals:')")
      idum=matrix_copy(res%ut,umat)
      idum=matrix_transpose(umat)
      qmat = matrix_create(res%np,1,'Redudant internals')
      idum=matrix_multiply(1.D0,umat,chdlc,0.D0,qmat)
      idum=matrix_print(qmat)
      idum=matrix_destroy(qmat)
      idum=matrix_destroy(umat)
    end if

!//////////////////////////////////////////////////////////////////////////////
! Initial trust multiplier
!
! The algorithm makes non-linear fitting steps based on the B matrix.
! Often the step direction is OK, but the magnitude two large.
! The trust multiplier is used to reduce the step size upon step failure.
!//////////////////////////////////////////////////////////////////////////////

    trust = 1.0D0

! set iteration counter
    iter = 0

! set up fail counter, give up if ten consecutive steps fail to improve the fit
    failc = 0

!//////////////////////////////////////////////////////////////////////////////
! Initialise absolute error memory
!
! The absolute error is the measure by which the algorithm tests convergence,
! but the maximum element of the error vector is the exit criterion
!
! dx:   maximum of the absolute of the elements of the error vector
! absm: dx of the previous iteration
!
! dy:   absolute of the error vector (root of scalar product by itself)
! mag:  dy of the previous iteration
!//////////////////////////////////////////////////////////////////////////////

    absm = 0.0D0
    mag = 0.0D0

!//////////////////////////////////////////////////////////////////////////////
! start of main loop
!//////////////////////////////////////////////////////////////////////////////

100 CONTINUE
    CALL hdlc_linear_checkin(xyz,res%natom,x,y,z)
    k = 0
    flipped = .FALSE.

!//////////////////////////////////////////////////////////////////////////////
! Test if torsion flipped through 180 degrees:
!
! Torsion flip of 360 degrees due to identification of -179 degrees and 181
! degrees can cause failure of the non-linear fit
! trust radius would be > 180 degrees
! 
! The bias vector corrects for this
!//////////////////////////////////////////////////////////////////////////////

    DO WHILE (flipped .OR. k==0)
      k = k + 1
      IF (k>2) CALL hdlc_errflag('Code error in hdlclib$hdlc_cart_to_hdlc', &
        'abort')
      flipped = .FALSE.

! get HDLC from current Cartesians xyz
      CALL coord_cart_to_hdlc(res,xyz,olhdlc,prim,.TRUE.)
      IF (iter>0) THEN
        IF ( .NOT. hdlc%internal) THEN
          j = res%np - res%natom*3
        ELSE
          j = res%np
        END IF
        ! commented out as bias is now the reference value of torsions
        ! and impropers at the first geometry. coord_cart_to_hdlc will
        ! set these primitives as close as possible to bias.
!!$        DO j = res%nconn + 1, j
!!$          IF (prim(j)>oldprim(j)+pi) THEN
!!$            res%biasv(j) = res%biasv(j) - pi*2.0D0
!!$            flipped = .TRUE.
!!$          ELSE IF (prim(j)<oldprim(j)-pi) THEN
!!$            res%biasv(j) = res%biasv(j) + pi*2.0D0
!!$            flipped = .TRUE.
!!$          END IF
!!$        END DO
      END IF ! (iter.gt.0)
    END DO ! (flipped .or. k.eq.0)
    tmp_prim => oldprim
    oldprim => prim
    prim => tmp_prim

! generate a primitive B matrix from current cartesians
    CALL hdlc_make_bprim(res%natom,x,y,z,res%nconn,res%iconn,res%nbend, &
      res%ibend,res%nrots,res%irots,res%np,bprim,ni,res%xweight,primweight)

    ! we don't need the weights here, so destroy primweight
    idum=matrix_destroy(primweight)

! generate HDLC B matrix
    CALL hdlc_make_bhdlc(bprim,bhdlc,res%ut)

! generate HDLC inverse G matrix
    CALL hdlc_make_ighdlc(bhdlc,ighdlc,failed)
    CALL hdlc_report_failure(res,failed,'getcrt')

! make HDLC Bt**-1
    idum = matrix_multiply(1.0D0,ighdlc,bhdlc,0.0D0,bthdlc)

! make [Bt**-1]t
    idum = matrix_transpose(bthdlc)

! get difference between input HDLC and HDLC of the current iteration (olhdlc)

    idum = matrix_copy(olhdlc,dif)
    idum = matrix_scale(dif,-1.0D0)
    idum = matrix_add(dif,dif,chdlc)
    dx = matrix_absmax(dif)
    dy = matrix_length(dif)

! relax limit after four and ten cycles
    IF (iter==4 .OR. iter==10) THEN
      cexit = cexit*1.0D2
      IF (printl>=6) WRITE (stdout,'(5x,a,e8.1)') &
        'Relaxing maximum exit error to ', cexit
    END IF

! report convergence info if requested
    IF (printl>=6) WRITE (stdout,'(5x,a,i3,a,g9.3,a,g9.3,a,f6.3)') &
      'Step ', iter, ', max error= ', dx, ', length of error= ', dy, &
      ', step scaling factor= ', trust
    CALL dlf_flushout

! set up on first iteration
    IF (iter==0) THEN
      absm = dx + 1.0D0
      mag = dy + 1.0D0
    END IF

! test maximum absolute element of difference vector for convergence
    IF (dx<cexit) THEN
      IF (mag<dy) THEN
        idum = matrix_copy(xyzbak,xyz)
        IF (printl>=6) WRITE (stdout,'(5x,a)') 'Recalling best step'
      END IF
      GO TO 200
    END IF

!//////////////////////////////////////////////////////////////////////////////
! *** NOT IMPLEMENTED BUT PLANNED ***
!
! if there are 10 unreasonably small steps 
! or a step that increases the error
! go over to a much more stable least squares fit method
!//////////////////////////////////////////////////////////////////////////////

! reject step if error increases
    IF (mag<dy) THEN
      IF (printl>=6) WRITE (stdout,'(/,5x,a,/)') 'Rejecting step'
      trust = trust*0.5D0
      idum = matrix_copy(xyzbak,xyz)
      IF (iter>2*n6) THEN
        IF (printl>=6) WRITE (stdout,'(/,5x,a,/)') &
          'Cannot make step - guessing'
        IF (dx>poor) res%lgmatok = .FALSE.
        GO TO 200
      END IF

! error is reduced - too slow convergence detects linear dependence
    ELSE
      IF (iter>2*n6) THEN
        IF (printl>=6) WRITE (stdout,'(/,5x,a,/)') &
          'Step converged too slowly'
        IF (dx>poor) res%lgmatok = .FALSE.
        GO TO 200
      END IF

! step accepted
      absm = dx
      mag = dy
      failc = 0
      trust = min(1.0D0,trust*1.25D0)

! record best position yet
      idum = matrix_copy(xyz,xyzbak)

! set xyz = oldxyz + [Bt**-1] * trust * [HDLC-HDLC(xyz(i))]
! if internal, create a scratch copy of dif with the last six elements missing
      IF (hdlc%internal) THEN
        scrdif = matrix_create(n6,1,'scrdif')
        call allocate (tmp_dif,n)
        idum = matrix_get(dif,n,tmp_dif)
        idum = matrix_set(scrdif,n,tmp_dif)
        idum = matrix_multiply(1.0D0,bthdlc,scrdif,0.0D0,xdif)
        idum = matrix_scale(xdif,trust)
        idum = matrix_add(xyz,xdif,res%oldxyz)
        idum = matrix_destroy(scrdif)
        call deallocate (tmp_dif)
      ELSE
        idum = matrix_multiply(1.0D0,bthdlc,dif,0.0D0,xdif)
        idum = matrix_scale(xdif,trust)
        idum = matrix_add(xyz,xdif,res%oldxyz)
      END IF

! now xyz contains a guess - recompute the HDLC
    END IF ! (mag.lt.dy)
    idum = matrix_copy(xyz,res%oldxyz)
    idum = matrix_transpose(bthdlc)
    iter = iter + 1
    GO TO 100

!//////////////////////////////////////////////////////////////////////////////
! end of main loop - prepare for return 
!//////////////////////////////////////////////////////////////////////////////

200 CONTINUE

    ! back up cartesians in case of conversion failure
    if(.not.res%lgmatok) idum = matrix_copy(xyzback,xyz)

! if print level>=5, convergence has already been reported
    IF (printl==5) WRITE (stdout,'(5x,a,i3,a,/,5x,g9.3,a,/)') &
      'Converged Cartesians in ', iter, ' steps to ', dx, &
      ' maximum component of error vector'

    ! set bias to zero again.
    !CALL vector_initialise(res%biasv,res%np,0.0D0)

! clean up
    call deallocate (x)
    call deallocate (y)
    call deallocate (z)
    NULLIFY (tmp_prim)
    IF (associated(prim)) deallocate (prim)
    IF (associated(oldprim)) deallocate (oldprim)
    idum = matrix_destroy(dif)
    idum = matrix_destroy(xdif)
    idum = matrix_destroy(ighdlc)
    idum = matrix_destroy(bthdlc)
    idum = matrix_destroy(bhdlc)
    idum = matrix_destroy(bprim)
    idum = matrix_destroy(xyzbak)
    idum = matrix_destroy(xyzback)
    idum = matrix_destroy(olhdlc)

  END SUBROUTINE coord_hdlc_to_cart

!------------------------------------------------------------------------------
! subroutine hdlc_split_cons
!
! Wrapper to split_cons in library constraint: unwraps variables from residue.
! Separates the values of the constrained degrees of freedom and stores them
! to residue%vcons if required
!
! Arguments:
! residue:  residue (in)
! hdlc_mat: matrix of full HDLC coordinates (in)
!           matrix of active HDLC coordinates (out)
! lstore: constrained HDLC coordinates are stored to vcons if (lstore) (in)
!------------------------------------------------------------------------------

  SUBROUTINE hdlc_split_cons(residue,hdlc_mat,lstore)
    LOGICAL lstore
    TYPE (residue_type) :: residue
    TYPE (matrix) :: hdlc_mat

    CALL split_cons(hdlc_mat,lstore,hdlc%internal,residue%natom, &
        residue%ncons,residue%vcons)
  END SUBROUTINE hdlc_split_cons

!------------------------------------------------------------------------------
! subroutine hdlc_rest_cons
!
! Wrapper to rest_cons in library constraint: unwraps variables from residue.
! Restores the values of the constrained degrees of freedom from residue%vcons
!
! Arguments:
! residue:  residue (in)
! hdlc_mat: matrix of active HDLC coordinates (in)
!           matrix of all HDLC coordinates (out)
!------------------------------------------------------------------------------

  SUBROUTINE hdlc_rest_cons(residue,hdlc_mat)
    TYPE (residue_type) :: residue
    TYPE (matrix) :: hdlc_mat

    CALL rest_cons(hdlc_mat,hdlc%internal,residue%natom,residue%ncons,residue%vcons)
  END SUBROUTINE hdlc_rest_cons

!==============================================================================
! routines doing the calculations for the delocalisations
!==============================================================================

!//////////////////////////////////////////////////////////////////////////////
! subroutine hdlc_make_bprim
!
! Makes the B matrix for primitive internal coordinates
!
! On input
! ========
! n  (int)           = number of atoms
! x,y,z (dble)       = cartesian co-ordiantes
! nbend (int)        = number of bends (this is linears and wags as well)
! nrots (int)        = number of rotations
! nconn (int)        = number of connections
! bprim              = pointer to a matrix
!
! if bprim is not associated, a new matrix is made
! if bprim is associated, it is expected to point to a previous matrix
!
! iconn(nconn) (int) = connections array
!                      a,b a-b connection
!
! ibend(nbend) (int) = array from valcoor
!                      a,b,c,0  bend a-b-c
!                      a,b,c,-1 line relative to yz plane
!                      a,b,c,-2 line relative to xy plane
!                      a,b,c,d  dihedral a-b-c-d
!                      (the dihedral is no longer supported by valcoor
!                      but is here for user defined coords)
!
! irots(nrots) (int) = array from valcoor
!                      a,b,c,d  dihedral about b-c
!
! On output
! =========
! ni (int)     = number of primitive internal coordinates
! bprim        = pointer to primitive redundant B matrix
!//////////////////////////////////////////////////////////////////////////////

  SUBROUTINE hdlc_make_bprim(natom,x,y,z,nconn,iconn,nbend,ibend,nrots,irots, &
      np,bprim,ni,xweight,primweight)

! args
    INTEGER,intent(in) ::  natom
    INTEGER            :: nconn, nbend, nrots, np, ni
    INTEGER            :: iconn(2,nconn), ibend(4,nbend), irots(4,nrots)
    REAL (rk)          :: x(natom), y(natom), z(natom)
    TYPE (matrix)      :: bprim,primweight
    real (rk)          :: xweight(natom)

! local params
    INTEGER ib(4), noint, k, idum
    REAL (rk) :: cutoff
    PARAMETER (cutoff=1.0D-30)

! local vars
    LOGICAL lbumout
    INTEGER i, j
    REAL (rk), DIMENSION (:,:), ALLOCATABLE :: brow
    REAL (rk) :: b(3,4), d_zero, d_one, fact, cz(12)

! begin
    DATA lbumout/ .FALSE./
    DATA d_zero, d_one/0.0D0, 1.0D0/

    IF (printl>=6) WRITE (stdout,'(5X,A)') 'Entering B matrix generator'

! count the number of primitives
    IF (hdlc%internal) THEN
      ni = nconn + nbend + nrots
    ELSE
      ni = 3*natom + nconn + nbend + nrots
    END IF

! count linear bends as two primitives
    DO i = 1, nbend
      IF (ibend(4,i)<0 .AND. ibend(1,i)/=0) THEN
        ni = ni + 1
        IF (printl>=6) WRITE (stdout,'(5X,A,I5,A)') 'Linear bend ', i, &
          ' counts as two primitives'
      END IF
    END DO

! report
    IF (printl>=6) THEN
      IF (hdlc%internal) THEN
        WRITE (stdout,'(5X,A,I5,/)') 'Number of internal coordinates = ', ni
      ELSE
        WRITE (stdout,'(5X,A,I5)') 'Number of primitives = ', ni
        WRITE (stdout,'(5X,A,I5,A,/)') 'Of which are ', 3*natom, ' Cartesians'
      END IF
    END IF

! allocate memory for one row and the B matrix if required
    call allocate (brow,3,natom)

    IF ( .NOT. allocated(bprim%data)) THEN
      IF (printl>=6) WRITE (stdout,'(7X,A)') 'Allocating new B matrix'
      bprim = matrix_create(ni,3*natom,'B matrix')
    END IF

! allocate primweight matrix
    IF ( .NOT. allocated(primweight%data)) THEN
      IF (printl>=6) WRITE (stdout,'(7X,A)') 'Allocating new Prim Weight matrix'
      primweight = matrix_create(ni,1,'Prim Weight')
    END IF

! adjust the scaling factors for the cartesians (old code: start of ...bprim1)
!!$    IF (ctrl%cfact==d_zero) THEN
      fact = d_one/real(natom,rk)
      fact=1.D0
!!$    ELSE IF (ctrl%cfact<d_zero) THEN
!!$      fact = -ctrl%cfact/real(natom,rk)
!!$    ELSE
!!$      fact = ctrl%cfact
!!$    END IF
    noint = 0

! B matrix is made one row at a time by making brow
    brow(1:3,1:natom) = 0.D0

! loop over all connections making b matrix elements
    DO i = 1, nconn
      noint = i
      cz(1) = x(iconn(1,i))
      cz(2) = y(iconn(1,i))
      cz(3) = z(iconn(1,i))
      cz(4) = x(iconn(2,i))
      cz(5) = y(iconn(2,i))
      cz(6) = z(iconn(2,i))
      CALL str_dlc(1,1,2,b,ib,cz)

      primweight%data(noint,1)=(xweight(iconn(1,i)) + xweight(iconn(2,i))) * 0.5D0

! construct row of bmatrix
      DO j = 1, 2
        DO k = 1, 3
          brow(k,iconn(j,i)) = b(k,j)
        END DO
      END DO
      idum = matrix_set_row(bprim,size(brow),brow,noint)

! re-zero brow
      DO j = 1, 2
        DO k = 1, 3
          brow(k,iconn(j,i)) = d_zero
        END DO
      END DO
! end of loop over connections
    END DO

! loop over all bends making bends, wags and linears
    DO i = 1, nbend
      IF (ibend(1,i)>0) THEN
        noint = noint + 1

! 'normal' bend
        IF (ibend(4,i)==0) THEN
          cz(1) = x(ibend(1,i))
          cz(2) = y(ibend(1,i))
          cz(3) = z(ibend(1,i))
          cz(4) = x(ibend(2,i))
          cz(5) = y(ibend(2,i))
          cz(6) = z(ibend(2,i))
          cz(7) = x(ibend(3,i))
          cz(8) = y(ibend(3,i))
          cz(9) = z(ibend(3,i))
          CALL bend_dlc(1,1,2,3,b,ib,cz)

          primweight%data(noint,1)=(xweight(ibend(1,i)) + xweight(ibend(2,i)) &
              + xweight(ibend(3,i))) / 3.D0

! construct row of bmatrix
          DO j = 1, 3
            DO k = 1, 3
              brow(k,ibend(j,i)) = b(k,j)
            END DO
          END DO
          idum = matrix_set_row(bprim,size(brow),brow,noint)

! re-zero brow
          DO j = 1, 3
            DO k = 1, 3
              brow(k,ibend(j,i)) = d_zero
            END DO
          END DO

! improper dihedral
!
! Impropers can be constructed thus:
!
!        1         1
!        |         |
!        2    =>   2
!       / \         \  <- axis of rotation
!      4   3     4---3
!
! This is not a true wag but it should not make much
! difference in delocalised internals and requires less
! code!
        ELSE IF (ibend(4,i)>0) THEN
          cz(1) = x(ibend(1,i))
          cz(2) = y(ibend(1,i))
          cz(3) = z(ibend(1,i))
          cz(4) = x(ibend(2,i))
          cz(5) = y(ibend(2,i))
          cz(6) = z(ibend(2,i))
          cz(7) = x(ibend(3,i))
          cz(8) = y(ibend(3,i))
          cz(9) = z(ibend(3,i))
          cz(10) = x(ibend(4,i))
          cz(11) = y(ibend(4,i))
          cz(12) = z(ibend(4,i))
          CALL tors_dlc(1,1,2,3,4,b,ib,cz)

          primweight%data(noint,1)=(xweight(ibend(1,i)) + xweight(ibend(2,i)) &
              + xweight(ibend(3,i)) + xweight(ibend(4,i))) *0.25D0

! construct row of bmatrix
          DO j = 1, 4
            DO k = 1, 3
              brow(k,ibend(j,i)) = b(k,j)
            END DO
          END DO
          idum = matrix_set_row(bprim,size(brow),brow,noint)

! re-zero brow
          DO j = 1, 4
            DO k = 1, 3
              brow(k,ibend(j,i)) = d_zero
            END DO
          END DO

! 'linear' bend w.r.t. yz plane
!
! make a point translated through 1A from atom atom 2 in y, find both angles
! formed and contruct B matrix from contributions from real atoms, then
! repeat with y translation - two coordinates will be formed this way
!
! A   C    A Y    Y C
!  \ /  =   \| +  |/  
!   B        B    B
!
! first set up ib
        ELSE IF (ibend(4,i)<=-1) THEN
          cz(1) = x(ibend(1,i))
          cz(2) = y(ibend(1,i))
          cz(3) = z(ibend(1,i))
          cz(4) = x(ibend(2,i))
          cz(5) = y(ibend(2,i))
          cz(6) = z(ibend(2,i))
          cz(7) = x(ibend(2,i))
          cz(8) = y(ibend(2,i)) + 1.0D0
          cz(9) = z(ibend(2,i))
          CALL bend_dlc(1,1,2,3,b,ib,cz)

          primweight%data(noint,1)=(xweight(ibend(1,i)) + xweight(ibend(2,i))) *0.5D0

! copy atom 1 into real bmat
          DO j = 1, 3
            brow(j,ibend(1,i)) = b(j,1)
          END DO

! perform oposite angle
          cz(1) = x(ibend(2,i))
          cz(2) = y(ibend(2,i)) + 1.0D0
          cz(3) = z(ibend(2,i))
          cz(7) = x(ibend(3,i))
          cz(8) = y(ibend(3,i))
          cz(9) = z(ibend(3,i))
          CALL bend_dlc(1,1,2,3,b,ib,cz)

          primweight%data(noint,1)=(xweight(ibend(2,i)) + xweight(ibend(3,i))) *0.5D0
          
! copy atom 3 into bmat and add atoms 3 & 1 to make 2 
!            do j = 1,3
!               brow(j,ibend(3,i)) = b(j,3) 
!               brow(j,ibend(2,i)) = -1.0D0*(brow(j,ibend(1,i))+b(j,3))
!            end do
          brow(2,ibend(2,i)) = 1.0D0

! construct row of bmatrix
          idum = matrix_set_row(bprim,size(brow),brow,noint)

! re-zero brow
          DO j = 1, 3
            DO k = 1, 3
              brow(k,ibend(j,i)) = d_zero
            END DO
          END DO

! increment ic counter
          noint = noint + 1

! do other plane
!            in z if -1 or x if -2
          cz(1) = x(ibend(1,i))
          cz(2) = y(ibend(1,i))
          cz(3) = z(ibend(1,i))
          cz(4) = x(ibend(2,i))
          cz(5) = y(ibend(2,i))
          cz(6) = z(ibend(2,i))
          cz(8) = y(ibend(2,i))
          IF (ibend(4,i)==-1) THEN
            cz(7) = x(ibend(2,i))
            cz(9) = z(ibend(2,i)) + 1.0D0
          ELSE
            cz(7) = x(ibend(2,i)) + 1.0D0
            cz(9) = z(ibend(2,i))
          END IF
          CALL bend_dlc(1,1,2,3,b,ib,cz)

          primweight%data(noint,1)=(xweight(ibend(1,i)) + xweight(ibend(2,i))) *0.5D0

! copy atom 1 into real bmatrix
          DO j = 1, 3
            brow(j,ibend(1,i)) = b(j,1)
          END DO

! do opposite angle
          cz(2) = y(ibend(2,i))
          IF (ibend(4,i)==-1) THEN
            cz(1) = x(ibend(2,i))
            cz(3) = z(ibend(2,i)) + 1.0D0
          ELSE
            cz(1) = x(ibend(2,i)) + 1.0D0
            cz(3) = z(ibend(2,i))
          END IF
          cz(7) = x(ibend(3,i))
          cz(8) = y(ibend(3,i))
          cz(9) = z(ibend(3,i))
          CALL bend_dlc(1,1,2,3,b,ib,cz)

! copy atom 3 into bmatrix and add atoms 3 & 1 to make 2
!            do j = 1,3
!               brow(j,ibend(3,i))=b(j,3)
!               brow(j,ibend(2,i))=brow(j,ibend(1,i))+b(j,3)
!            end do
          IF (ibend(4,i)==-1) THEN
            brow(3,ibend(2,i)) = 1.0D0
          ELSE
            brow(1,ibend(2,i)) = 1.0D0
          END IF

! construct row of bmatrix
          idum = matrix_set_row(bprim,size(brow),brow,noint)

! re-zero brow
          DO j = 1, 3
            DO k = 1, 3
              brow(k,ibend(j,i)) = d_zero
            END DO
          END DO
        END IF ! if (ibend(4,i).eq.0) then ... elseif ...
      END IF ! if (ibend(1,i).gt.0) then

! end of loop over all bends etc.
    END DO ! do i = 1,nbend

! put in dihedrals
    DO i = 1, nrots
      noint = noint + 1
      cz(1) = x(irots(1,i))
      cz(2) = y(irots(1,i))
      cz(3) = z(irots(1,i))
      cz(4) = x(irots(2,i))
      cz(5) = y(irots(2,i))
      cz(6) = z(irots(2,i))
      cz(7) = x(irots(3,i))
      cz(8) = y(irots(3,i))
      cz(9) = z(irots(3,i))
      cz(10) = x(irots(4,i))
      cz(11) = y(irots(4,i))
      cz(12) = z(irots(4,i))
      CALL tors_dlc(1,1,2,3,4,b,ib,cz)

      primweight%data(noint,1)=(xweight(irots(1,i)) + xweight(irots(2,i)) &
          + xweight(irots(3,i)) + xweight(irots(4,i))) *0.25D0

! construct row of bmatrix
      DO j = 1, 4
        DO k = 1, 3
          brow(k,irots(j,i)) = b(k,j)
        END DO
      END DO
      idum = matrix_set_row(bprim,size(brow),brow,noint)

! re-zero brow
      DO j = 1, 4
        DO k = 1, 3
          brow(k,irots(j,i)) = d_zero
        END DO
      END DO

! end of loop over dihedrals
    END DO

! put in cartesians
    IF ( .NOT. hdlc%internal) THEN
      DO i = 1, natom
        DO j = 1, 3
          noint = noint + 1
! weight all cartesians the same way
          brow(j,i) = fact
          primweight%data(noint,1)=xweight(i)
          
! weight them slightly different (to avoid degeneration in
! the spectrum of the primitive G matrix) JK
! if  the added value is too large, the Gram-Schmidt orthogonalization 
! in constraints.f90:ortho_mat produces too many non-zero eigenvalues
!brow(j,i) = fact + dble(i-1)* 3.D-5 + dble(j-1)* 1.D-5 
          idum = matrix_set_row(bprim,size(brow),brow,noint)
          brow(j,i) = 0.0D0
        END DO
      END DO
    END IF

! set the number of primitives and print the matrix if requested
    np = noint
    IF (printl>=6) i = matrix_print(bprim)

    call deallocate(brow)

!//////////////////////////////////////////////////////////////////////////////
! Helper routines for hdlc_make_bprim
!
! The following three subroutines are adapted from the normal coordinate
! analysis program of Schachtschneider, Shell development
!//////////////////////////////////////////////////////////////////////////////

  CONTAINS
    SUBROUTINE str_dlc(noint,i,j,b,ib,c)
      INTEGER i, j, ib(4,*), noint
      REAL (rk) c(*), b(3,4,1)
!
      INTEGER iaind, jaind, m
      REAL (rk) dzero, rij(3), dijsq
!
      DATA dzero/0.0D0/
!
      iaind = 0
      jaind = 3
      ib(1,noint) = i
      ib(2,noint) = j
      dijsq = dzero
      DO m = 1, 3
        rij(m) = c(m+jaind) - c(m+iaind)
        dijsq = dijsq + rij(m)**2
      END DO
      DO m = 1, 3
        b(m,1,noint) = -rij(m)/sqrt(dijsq)
        b(m,2,noint) = -b(m,1,noint)
      END DO
      RETURN
!
    END SUBROUTINE str_dlc
!
    SUBROUTINE bend_dlc(noint,i,j,k,b,ib,c)
      INTEGER i, j, k, ib(4,1), noint
      REAL (rk) b(3,4,1), c(*)
!
      INTEGER iaind, jaind, kaind, m
      REAL (rk) rji(3), rjk(3), eji(3), ejk(3), djisq, djksq, dzero, done, &
        sinj, dotj, dji, djk
!
      DATA dzero/0.0D0/, done/1.0D0/
!
      iaind = 0
      jaind = 3
      kaind = 6
      ib(1,noint) = i
      ib(2,noint) = j
      ib(3,noint) = k
      djisq = dzero
      djksq = dzero
      DO m = 1, 3
        rji(m) = c(m+iaind) - c(m+jaind)
        rjk(m) = c(m+kaind) - c(m+jaind)
        djisq = djisq + rji(m)**2
        djksq = djksq + rjk(m)**2
      END DO
      dji = sqrt(djisq)
      djk = sqrt(djksq)
      dotj = dzero
      DO m = 1, 3
        eji(m) = rji(m)/dji
        ejk(m) = rjk(m)/djk
        dotj = dotj + eji(m)*ejk(m)
      END DO
      sinj = sqrt(done-dotj**2)
      IF (sinj<1.0D-20) GO TO 145
      DO m = 1, 3
        b(m,3,noint) = ((dotj*ejk(m)-eji(m)))/(djk*sinj)
        b(m,1,noint) = ((dotj*eji(m)-ejk(m)))/(dji*sinj)
        b(m,2,noint) = -b(m,1,noint) - b(m,3,noint)
      END DO
!
      RETURN
145   CONTINUE
      DO m = 1, 3
        b(m,3,noint) = 0.0D0
        b(m,1,noint) = 0.0D0
        b(m,2,noint) = 0.0D0
      END DO
      RETURN
!
    END SUBROUTINE bend_dlc
!
    SUBROUTINE tors_dlc(noint,i,j,k,l,b,ib,c)
      INTEGER i, j, k, l, ib(4,*), noint
      REAL (rk) b(3,4,1), c(*)
!
      INTEGER iaind, jaind, kaind, laind, m
      REAL (rk) dzero, done, dij, dijsq, djk, djksq, dkl, dklsq, dotpj, dotpk, &
        sinpj, sinpk, smi, smj, sml, f1, f2
      REAL (rk) rij(3), rjk(3), rkl(3), eij(3), ejk(3), ekl(3), cr1(3), cr2(3)
!
      DATA dzero/0.0D0/, done/1.0D0/
!
      iaind = 0
      jaind = 3
      kaind = 6
      laind = 9
      ib(1,noint) = i
      ib(2,noint) = j
      ib(3,noint) = k
      ib(4,noint) = l
      dijsq = dzero
      djksq = dzero
      dklsq = dzero
      DO m = 1, 3
        rij(m) = c(m+jaind) - c(m+iaind)
        dijsq = dijsq + rij(m)**2
        rjk(m) = c(m+kaind) - c(m+jaind)
        djksq = djksq + rjk(m)**2
        rkl(m) = c(m+laind) - c(m+kaind)
        dklsq = dklsq + rkl(m)**2
      END DO
      dij = sqrt(dijsq)
      djk = sqrt(djksq)
      dkl = sqrt(dklsq)
      DO m = 1, 3
        eij(m) = rij(m)/dij
        ejk(m) = rjk(m)/djk
        ekl(m) = rkl(m)/dkl
      END DO
      cr1(1) = eij(2)*ejk(3) - eij(3)*ejk(2)
      cr1(2) = eij(3)*ejk(1) - eij(1)*ejk(3)
      cr1(3) = eij(1)*ejk(2) - eij(2)*ejk(1)
      cr2(1) = ejk(2)*ekl(3) - ejk(3)*ekl(2)
      cr2(2) = ejk(3)*ekl(1) - ejk(1)*ekl(3)
      cr2(3) = ejk(1)*ekl(2) - ejk(2)*ekl(1)
      dotpj = -(eij(1)*ejk(1)+eij(2)*ejk(2)+eij(3)*ejk(3))
      dotpk = -(ejk(1)*ekl(1)+ejk(2)*ekl(2)+ejk(3)*ekl(3))
      sinpj = sqrt(done-dotpj**2)
      sinpk = sqrt(done-dotpk**2)
      DO m = 1, 3
        smi = -cr1(m)/(dij*sinpj*sinpj)
        b(m,1,noint) = smi
        f1 = 0.0D0
        f2 = 0.0D0
        IF (sinpj>1.0D-20) f1 = (cr1(m)*(djk-dij*dotpj))/(djk*dij*sinpj*sinpj)
        IF (sinpk>1.0D-20) f2 = (dotpk*cr2(m))/(djk*sinpk*sinpk)
        smj = f1 - f2
        b(m,2,noint) = smj
        sml = 0.0D0
        IF (sinpk>1.0D-20) sml = cr2(m)/(dkl*sinpk*sinpk)
        b(m,4,noint) = sml
        b(m,3,noint) = (-smi-smj-sml)
      END DO
      RETURN
    END SUBROUTINE tors_dlc

!//////////////////////////////////////////////////////////////////////////////
! end of helper routines for hdlc_make_bprim
!//////////////////////////////////////////////////////////////////////////////

  END SUBROUTINE hdlc_make_bprim

!//////////////////////////////////////////////////////////////////////////////
! subroutine hdlc_make_ut
!
! Constructs Ut, the transpose of the non-redundant eigenvectors of the
! redundant G matrix
!
! Alexander J Turner Dec 1997
!
!     See:
! J_Baker, A_Kessi and B_Delley
! J.Chem.Phys 105,(1),1 July 1996
!
! Input
! =====
!
! bprim:  primitive B matrix
!
! Output
! ======
!
! ut: transposed U matrix
!
! Paramters
! =========
!
! Cutoff decides if an eigenvalue of G is zero
!
!//////////////////////////////////////////////////////////////////////////////

  SUBROUTINE hdlc_make_ut(ut,bprim)
    IMPLICIT NONE
! args
    TYPE (matrix) :: bprim, ut

! local params
    REAL (rk), PARAMETER :: cutoff = 1.0D-8

! local vars
    INTEGER :: i, idum, j, n, n6, nii
    REAL (rk), DIMENSION (:), ALLOCATABLE :: temp
    TYPE (matrix) :: g_mat, btprim, r_mat, v_mat

! begin, nii: number of primitives
    IF (printl>=6) WRITE (stdout,'(5X,A)') 'Entering UT matrix generator'
    nii = matrix_dimension(bprim,1)
! n: number of cartesians
    n = matrix_dimension(bprim,2)

! n6: number of delocalised internal coordinates
    IF (hdlc%internal) THEN
      n6 = n - 6
    ELSE
      n6 = n
    END IF

! test for insufficient primitives
    IF (nii<n6) THEN
      WRITE (stdout,'(A,I5,A,I5,A)') 'There are ', nii, ' primitives and ', &
        n6, ' required!'
      CALL hdlc_errflag('Insufficient primitive coordinates','abort')
    END IF

! allocate space
    g_mat = matrix_create(nii,nii,'G matrix')
    btprim = matrix_create(nii,n,'Bt matrix')

! form G
    idum = matrix_copy(bprim,btprim)
    idum = matrix_transpose(btprim)
    idum = matrix_multiply(1.0D0,bprim,btprim,0.0D0,g_mat)

! allocate work matrices for the diagonalisation; Bt is not used any longer
    idum = matrix_destroy(btprim)

! Next two lines change due to problems with LAPACK routine dsyevx
!   r_mat = matrix_create (nii, n6, 'R vectors')
!   v_mat = matrix_create (n6, 1,   'R roots ')
    r_mat = matrix_create(nii,nii,'R vectors')
    v_mat = matrix_create(nii,1,'R roots ')

! diagonalise and form U 
    idum = matrix_diagonalise(g_mat,r_mat,v_mat,.FALSE.)
    IF (idum/=0) THEN
      CALL hdlc_errflag('G matrix could not be diagonalised','stop')
    END IF

! allocate Ut matrix; the G matrix not used any longer
    idum = matrix_destroy(g_mat)
    ut = matrix_create(n6,nii,'Ut matrix')

! check for faulty eigenvalue structure, use temp as scratch
    call allocate (temp,nii)
    idum = matrix_get(v_mat,nii,temp)
    IF (printl>=6) WRITE (stdout,'(5x,a,/)') &
      'Eigenvalue structure of primitive G matrix'
    j = 0
    DO i = 1, nii
      IF (printl>=6) WRITE (stdout,'(5x,a,i5,a,f13.8)') 'Eigenvalue ', i, &
        ' = ', temp(i)
      IF (abs(temp(i))>cutoff) j = j + 1
    END DO
    IF (printl>=5) WRITE (stdout,'(/,5x,a,i5,a,i5,a,/)') &
      'The system has ', n6, ' degrees of freedom, and ', j, &
      ' non-zero eigenvalues'
    IF (j<n6) THEN
      WRITE (stdout,'(/,5x,a,i5,a,i5,a,/)') &
          'The system has ', n6, ' degrees of freedom, and ', j, &
          ' non-zero eigenvalues'
      IF (hdlc%ngroups==1 .AND. hdlc%internal .AND. hdlc%contyp==1) THEN
        CALL hdlc_errflag( &
          'DLC based on total connection cannot be used for a planar system', &
          'stop')
      ELSE
        CALL hdlc_errflag( &
          'Too few delocalised coordinates with non-zero values','stop')
      END IF
    END IF

    IF (printl>=6) idum = matrix_print(r_mat)

! generate Ut (the eigenvectors come out of matrix_diagonalise in columns!)
    DO i = 1, n6
      j = matrix_get_column(r_mat,size(temp),temp,i)
      j = matrix_set_row(ut,size(temp),temp,i)
    END DO

! clean up some memory
    idum = matrix_destroy(v_mat)
    idum = matrix_destroy(r_mat)
    call deallocate (temp)

    IF (printl>=6) idum = matrix_print(ut)

! end
    RETURN
  END SUBROUTINE hdlc_make_ut

!//////////////////////////////////////////////////////////////////////////////
! subroutine hdlc_make_bhdlc
!
! Construct delocalised B matrix
!
! Input
! =====
! ut    : Ut matrix
! bprim : primitive B matrix
! bhdlc : unassociated => generate B matrix
!         associated   => pre-existing B matrix
!
! Output
! ======
! bhdlc : HDLC B matrix
!
!//////////////////////////////////////////////////////////////////////////////

  SUBROUTINE hdlc_make_bhdlc(bprim,bhdlc,ut)

! args
    TYPE (matrix) :: bhdlc, bprim, ut

! local vars
    INTEGER :: idum, n, np, n6

! begin, get dimensions of B matrix
    np = matrix_dimension(bprim,1)
    n = matrix_dimension(bprim,2)
    IF (hdlc%internal) THEN
      n6 = n - 6
    ELSE
      n6 = n
    END IF

! create B matrix if needed
    IF ( .NOT. allocated(bhdlc%data)) THEN
      bhdlc = matrix_create(n6,n,'B HDLC')
      IF (printl>=6) WRITE (stdout,'(7X,A,/)') 'New HDLC B matrix'
    END IF

! do maths
    idum = matrix_multiply(1.0D0,ut,bprim,0.0D0,bhdlc)
    IF (printl>=6) idum = matrix_print(bhdlc)

  END SUBROUTINE hdlc_make_bhdlc

!//////////////////////////////////////////////////////////////////////////////
! subroutine hdlc_make_ighdlc
!
! Construct inverse G matrix from delocalised B matrix
!
! Input
! =====
! bhdlc  : HDLC B matrix
! ighdlc : unassociated => generate iG matrix
!          associated   => pre-existing iG matrix
!
! Output
! ======
! ighdlc : inverse HDLC G matrix
! failed : true if det|iG| < cutoff
!
!//////////////////////////////////////////////////////////////////////////////

  SUBROUTINE hdlc_make_ighdlc(bhdlc,ighdlc,failed)

! args
    LOGICAL failed
    TYPE (matrix) :: bhdlc, ighdlc

! local params
    REAL (rk) :: cutoff
    PARAMETER (cutoff=1.0D-8)

! local vars
    INTEGER i, idum, n, n6
    REAL (rk) :: det
    TYPE (matrix) :: bthdlc

! begin, get number of HDLC (n6) and number of cartesians (n)
    n6 = matrix_dimension(bhdlc,1)
    n = matrix_dimension(bhdlc,2)
! generate iG matrix if needed
    IF ( .NOT. allocated(ighdlc%data)) THEN
      ighdlc = matrix_create(n6,n6,'HDLC iG')
      IF (printl>=6) WRITE (stdout,'(7X,A,/)') 'New HDLC iG matrix'
    END IF

! make B transposed
    bthdlc = matrix_create(n6,n,'HDLC BT')
    idum = matrix_copy(bhdlc,bthdlc)
    idum = matrix_transpose(bthdlc)

! do maths
    idum = matrix_multiply(1.0D0,bhdlc,bthdlc,0.0D0,ighdlc)
    IF (printl>=6) THEN
      WRITE (stdout,'(7X,A,/)') &
        'Matrix printed is G HDLC (= B HDLC * BT HDLC) before inversion'
      idum = matrix_print(ighdlc)
    END IF
    idum = matrix_invert(ighdlc,det,.TRUE.)

! clean up
    idum = matrix_destroy(bthdlc)

! check for linear dependency in iG, scale det to be size-independent
    i = matrix_dimension(ighdlc,1)
    IF (printl>=6) THEN
      WRITE (stdout,'(7X,A,E13.5,/)') 'The HDLC G matrix determinant is ', det
    END IF
    det = det**(1.0D0/real(i,rk))
    failed = (det<cutoff)
  END SUBROUTINE hdlc_make_ighdlc

!==============================================================================
! checkpointing
!==============================================================================

!//////////////////////////////////////////////////////////////////////////////
! subroutine hdlc_wr_hdlc
!
! Write all HDLC objects to iunit
!//////////////////////////////////////////////////////////////////////////////

  SUBROUTINE hdlc_wr_hdlc(iunit,s_hdlc,lform,lerr)
    use dlf_checkpoint, only: write_separator
    implicit none
! args
    LOGICAL lform, lerr
    INTEGER iunit
    CHARACTER*25 secthead
    TYPE (hdlc_ctrl) :: s_hdlc

! local vars
    INTEGER i, j, igroup
    TYPE (residue_type) :: res

! begin
    lerr = .FALSE.

    call write_separator(iunit,"HDLC sizes")

! write header, return if no HDLC residues
    IF (lform) THEN
      WRITE (iunit,*,err=98) s_hdlc%lhdlc, s_hdlc%internal &
          , s_hdlc%ngroups, s_hdlc%contyp
    ELSE
      WRITE (iunit,err=98) s_hdlc%lhdlc, s_hdlc%internal &
          , s_hdlc%ngroups, s_hdlc%contyp
    END IF
    IF ( .NOT. s_hdlc%lhdlc) RETURN

    ! new block for dl-find:
    IF (lform) THEN
      WRITE (iunit,*,err=98) s_hdlc%first, s_hdlc%last, &
          s_hdlc%nmin, s_hdlc%ngroupsdrop, s_hdlc%nfrozen, s_hdlc%err_cnt(:)
    ELSE
      write (iunit,err=98) s_hdlc%first, s_hdlc%last, &
          s_hdlc%nmin, s_hdlc%ngroupsdrop, s_hdlc%nfrozen, s_hdlc%err_cnt(:)
    END IF

! loop over all HDLC objects
    DO igroup = 1, s_hdlc%ngroups

      call write_separator(iunit,"HDLC residue")

      res = s_hdlc%res(igroup)

! write scalars
      IF (lform) THEN
        WRITE (iunit,'(8I8)',err=98) res%name, res%natom, res%np, &
          res%nconn, res%nbend, res%nrots, res%ncons, res%ip
        WRITE (iunit,*,err=98) res%err_cnt, res%lgmatok, res%next, &
            res%prev, res%tbias
      ELSE
        WRITE (iunit,err=98) res%name, res%natom, res%np, &
          res%nconn, res%nbend, res%nrots, res%ncons, res%ip
        WRITE (iunit,err=98) res%err_cnt, res%lgmatok, res%next, &
            res%prev, res%tbias
      END IF

    call write_separator(iunit,"HDLC res arrays")
! write arrays
      IF (lform) THEN
        WRITE (iunit,'(5F16.10)',err=98) (res%x(i),i=1,res%natom)
        WRITE (iunit,'(5F16.10)',err=98) (res%y(i),i=1,res%natom)
        WRITE (iunit,'(5F16.10)',err=98) (res%z(i),i=1,res%natom)
        WRITE (iunit,'(2I8)',err=98) ((res%iconn(i,j),i=1,2),j=1,res%nconn)
        WRITE (iunit,'(4I8)',err=98) ((res%ibend(i,j),i=1,4),j=1,res%nbend)
        WRITE (iunit,'(4I8)',err=98) ((res%irots(i,j),i=1,4),j=1,res%nrots)
        WRITE (iunit,'(6I8)',err=98) ((res%icons(i,j),i=1,6),j=1,res%ncons)
        WRITE (iunit,'(5F16.10)',err=98) (res%vcons(i),i=1,res%ncons)
        WRITE (iunit,'(6I8)',err=98) (res%at(i),i=1,res%natom)
        WRITE (iunit,'(5F16.10)',err=98) (res%biasv(i),i=1,res%np )
      ELSE
        WRITE (iunit,err=98) (res%x(i),i=1,res%natom)
        WRITE (iunit,err=98) (res%y(i),i=1,res%natom)
        WRITE (iunit,err=98) (res%z(i),i=1,res%natom)
        WRITE (iunit,err=98) ((res%iconn(i,j),i=1,2),j=1,res%nconn)
        WRITE (iunit,err=98) ((res%ibend(i,j),i=1,4),j=1,res%nbend)
        WRITE (iunit,err=98) ((res%irots(i,j),i=1,4),j=1,res%nrots)
        WRITE (iunit,err=98) ((res%icons(i,j),i=1,6),j=1,res%ncons)
        WRITE (iunit,err=98) (res%vcons(i),i=1,res%ncons)
        WRITE (iunit,err=98) (res%at(i),i=1,res%natom)
        WRITE (iunit,err=98) (res%biasv(i),i=1,res%np)
      END IF

! write matrices - see matrixlib
      CALL hdlc_wr_matrix(iunit,res%ut,lform,lerr)
      CALL hdlc_wr_matrix(iunit,res%iweight,lform,lerr)
      CALL hdlc_wr_matrix(iunit,res%oldxyz,lform,lerr)

! end loop over all HDLC residues
    END DO

    call write_separator(iunit,"END")

! I/O failure jump point
    RETURN
98  lerr = .TRUE.
    IF (printl>=-1) WRITE (stdout,'(/,a,i5,a,/)') &
      '*** Problem writing residue ', igroup, ' to checkpoint file ***'
  END SUBROUTINE hdlc_wr_hdlc

!//////////////////////////////////////////////////////////////////////////////
! subroutine hdlc_rd_hdlc
!
! Read all HDLC objects from iunit
!//////////////////////////////////////////////////////////////////////////////

  SUBROUTINE hdlc_rd_hdlc(iunit,s_hdlc,lform,tok)
    use dlf_checkpoint, only: read_separator
    implicit none
! args
    LOGICAL lform, tok
    INTEGER iunit
    CHARACTER*25 secthead
    TYPE (hdlc_ctrl) :: s_hdlc

! local vars
    INTEGER i, j, igroup, contyp
    INTEGER, DIMENSION (1) :: idum
    TYPE (residue_type) :: res
    logical :: tchk,lerr,recoverable
    integer :: natom, nconn, nbend, nrots, ncons
    integer :: ar2(2),ar1(1)
! **********************************************************************

    tok = .false.
    igroup = 0

    call read_separator(iunit,"HDLC sizes",tchk)
    if(.not.tchk) return

! read header, return if no HDLC residues
    IF (lform) THEN
      READ (iunit,*,err=98) s_hdlc%lhdlc, s_hdlc%internal, igroup, contyp
    ELSE
      READ (iunit,err=98) s_hdlc%lhdlc, s_hdlc%internal, igroup, contyp
    END IF
    IF ( .NOT. s_hdlc%lhdlc) then
      tok=.true.
      RETURN
    end IF

    if(igroup/=s_hdlc%ngroups) then
      if(printl>=4) &
          write(stdout,"('Number of residues in checkpoint file inconsistent')")
      return
    end if

    if(contyp/=s_hdlc%contyp) then
      if(printl>=4) &
          write(stdout,"('Connection type in checkpoint file inconsistent')")
      return
    end if

    ! new block for dl-find (no constraints and input connections yet ...):
    IF (lform) THEN
      READ (iunit,*,err=98) s_hdlc%first, s_hdlc%last, &
          s_hdlc%nmin, s_hdlc%ngroupsdrop, s_hdlc%nfrozen, s_hdlc%err_cnt(:)
    ELSE
      READ (iunit,err=98) s_hdlc%first, s_hdlc%last, &
          s_hdlc%nmin, s_hdlc%ngroupsdrop, s_hdlc%nfrozen, s_hdlc%err_cnt(:)
    END IF

! loop over all HDLC objects
    DO igroup = 1, s_hdlc%ngroups

      call read_separator(iunit,"HDLC residue",tchk)
      if(.not.tchk) return

      res=s_hdlc%res(igroup)
! allocate new residue and read scalars
!      allocate (res)
      IF (lform) THEN
        READ (iunit,'(8I8)',err=98) res%name, natom, res%np, &
          nconn, nbend, nrots, ncons, res%ip
        READ (iunit,*,err=98) res%err_cnt, res%lgmatok, res%next, &
            res%prev, res%tbias
      ELSE
        READ (iunit,err=98) res%name, natom, res%np, &
          nconn, nbend, nrots, ncons, res%ip
        READ (iunit,err=98) res%err_cnt, res%lgmatok, res%next, &
            res%prev, res%tbias
      END IF

      !Check for correct array sizes
      tchk=.false.
      recoverable=.false.
      ! Somtimes, a bond moves to a rotation or vice versa. This may be recoverable
      if(nbend/=res%nbend) then
        if(printl>=4) then
          write(stdout,"('Number of bends in residue',i4,' inconsistent&
              & in checkpoint file')") igroup
          write(stdout,"('Number of bends created',i4)") res%nbend
          write(stdout,"('Number of bends read   ',i4)") nbend
          write(stdout,"('This will allow recovery')")
        endif
        tchk=.true.
        recoverable=.true.
      end if
      if(nrots/=res%nrots) then
        if(printl>=4) then
          write(stdout,"('Number of rotations in residue',i4,' inconsistent&
              & in checkpoint file')") igroup
          write(stdout,"('Number of rotations created',i4)") res%nrots
          write(stdout,"('Number of rotations read   ',i4)") nrots
          write(stdout,"('This will allow recovery')")
        end if
        tchk=.true.
        recoverable=.true.
      end if
      if(natom/=res%natom) then
        if(printl>=4) then
          write(stdout,"('Number of atoms in residue',i4,' inconsistent&
              & in checkpoint file')") igroup
          write(stdout,"('This will NOT allow recovery')")
        end if
        tchk=.true.
        recoverable=.false.
      end if
      if(nconn/=res%nconn) then
        if(printl>=4) then
          write(stdout,"('Number of connections in residue',i4,' inconsistent&
              & in checkpoint file')") igroup
          write(stdout,"('Number of connections created',i4)") res%nconn
          write(stdout,"('Number of connections read   ',i4)") nconn
          write(stdout,"('This will allow recovery')")
        end if
        tchk=.true.
        recoverable=.true.
      end if
      if(ncons/=res%ncons) then
        if(printl>=4) then
          write(stdout,"('Number of constraints in residue',i4,' inconsistent&
              & in checkpoint file')") igroup
          write(stdout,"('This will NOT allow recovery')")
        end if
        tchk=.true.
        recoverable=.false.
      end if

      ! error check
      if(tchk) then
        if(printl>=4) write(stdout,"('Problem in reading checkpoint')")
        if(recoverable) then
          if(printl>=4) write(stdout,"('Trying to recover')")
          ! only recover if original arrays are large enough, do 
          ! not reallocate
          ar2=shape(res%ibend)
          if(ar2(2)>= nbend) then
            ar2=shape(res%irots)
            if(ar2(2)>= nrots) then
              ar2=shape(res%iconn)
              if(ar2(2)>= nconn) then
                res%nbend= nbend
                res%nrots= nrots
                res%nconn= nconn
                if(printl>=4) write(stdout,"('Aiming at recovery')")
              else
                if(printl>=4) write(stdout,"('Failed to recover due to number of connections')")
                return
              end if
            else
              if(printl>=4) write(stdout,"('Failed to recover due to number of rotations')")
              return
            end if
          else
            if(printl>=4) write(stdout,"('Failed to recover due to number of bends')")
            return
          end if
        else
          if(printl>=4) write(stdout,"('Not trying to recover')")
          return
        end if
      end if

! allocate contained arrays
!!$      allocate (res%x(res%natom))
!!$      allocate (res%y(res%natom))
!!$      allocate (res%z(res%natom))
!!$      allocate (res%iconn(2,max(1,res%nconn)))
!!$      allocate (res%ibend(4,max(1,res%nbend)))
!!$      allocate (res%irots(4,max(1,res%nrots)))
!!$      allocate (res%icons(6,max(1,res%ncons)))
!!$      allocate (res%vcons(max(1,res%ncons)))

! here would be the initialisation of the internal biasing vector
!!$       allocate (res%biasv(res%np))
       call vector_initialise (res%biasv, res%np, 0.0D0)
!       nullify(res%oldxyz)
!       idum=matrix_destroy(res%oldxyz)

       call read_separator(iunit,"HDLC res arrays",tchk)
       if(.not.tchk) return

! read contained arrays
      IF (lform) THEN
        READ (iunit,'(5F16.10)',err=98) (res%x(i),i=1,res%natom)
        READ (iunit,'(5F16.10)',err=98) (res%y(i),i=1,res%natom)
        READ (iunit,'(5F16.10)',err=98) (res%z(i),i=1,res%natom)
        READ (iunit,'(2I8)',err=98) ((res%iconn(i,j),i=1,2),j=1,res%nconn)
        READ (iunit,'(4I8)',err=98) ((res%ibend(i,j),i=1,4),j=1,res%nbend)
        READ (iunit,'(4I8)',err=98) ((res%irots(i,j),i=1,4),j=1,res%nrots)
        READ (iunit,'(6I8)',err=98) ((res%icons(i,j),i=1,6),j=1,res%ncons)
        READ (iunit,'(5F16.10)',err=98) (res%vcons(i),i=1,res%ncons)
        READ (iunit,'(6I8)',err=98) (res%at(i),i=1,res%natom)
        READ (iunit,'(5F16.10)',err=98) (res%biasv(i),i=1,res%np )
      ELSE
        READ (iunit,err=98) (res%x(i),i=1,res%natom)
        READ (iunit,err=98) (res%y(i),i=1,res%natom)
        READ (iunit,err=98) (res%z(i),i=1,res%natom)
        READ (iunit,err=98) ((res%iconn(i,j),i=1,2),j=1,res%nconn)
        READ (iunit,err=98) ((res%ibend(i,j),i=1,4),j=1,res%nbend)
        READ (iunit,err=98) ((res%irots(i,j),i=1,4),j=1,res%nrots)
        READ (iunit,err=98) ((res%icons(i,j),i=1,6),j=1,res%ncons)
        READ (iunit,err=98) (res%vcons(i),i=1,res%ncons)
        READ (iunit,err=98) (res%at(i),i=1,res%natom)
        READ (iunit,err=98) (res%biasv(i),i=1,res%np )
      END IF

! read UT matrix - see matrixlib
      CALL hdlc_rd_matrix(iunit,res%ut,lform,lerr)
      if(lerr) then
        tok=.false.
        print*,"Error reading UT matrix from checkpoint"
        return
      end if
      CALL hdlc_rd_matrix(iunit,res%iweight,lform,lerr)
      if(lerr) then
        tok=.false.
        print*,"Error reading iweight matrix from checkpoint"
        return
      end if
      CALL hdlc_rd_matrix(iunit,res%oldxyz,lform,lerr)
      if(lerr) then
        tok=.false.
        print*,"Error reading OldXYZ matrix from checkpoint"
        return
      end if

      s_hdlc%res(igroup) = res
!!$! linked list stuff
!!$      IF (igroup==1) THEN
!!$!        s_hdlc%first => res
!!$      ELSE
!!$        res%next=-1
!!$        res%prev = s_hdlc%last
!!$      END IF
    END DO

    call read_separator(iunit,"END",tchk)
    if(.not.tchk) return

    tok=.true.
    RETURN

! I/O failure jump point - destroy already read objects if necessary
98  tok = .false.
!    s_hdlc%lhdlc = .FALSE.
!    IF (igroup>0) CALL hdlc_destroy_all(.FALSE.,idum)
    IF (printl>=4) WRITE (stdout,'(/,a,i5,a,/)') &
      '*** Problem reading residue ', igroup, ' ***'
  END SUBROUTINE hdlc_rd_hdlc

!==============================================================================
! general helper routines follow
!==============================================================================

!//////////////////////////////////////////////////////////////////////////////
! subroutine hdlc_destroy_all
!
! Destroys all HDLC residues and saves the fields residue%err_cnt to the array
! err_cnt if lsave is set
!//////////////////////////////////////////////////////////////////////////////

  SUBROUTINE hdlc_destroy_all(lsave,ngroups,err_cnt)

! args
    LOGICAL lsave
    integer, intent(in)  :: ngroups
    INTEGER, intent(out) :: err_cnt(ngroups)

! local vars
    INTEGER i,this

    IF (printl>=2) THEN
      WRITE (stdout,'(a,/)') 'Destroying all HDLC residues'
    END IF
    i = 1
    DO WHILE (hdlc%ngroups/=0)
      this=hdlc%first
      IF (lsave .AND. (hdlc%res(this)%err_cnt<2000 .OR. hdlc%res(this)%ncons>0)) THEN
        err_cnt(i) = hdlc%res(this)%err_cnt
        i = i + 1
      END IF
      CALL hdlc_destroy(hdlc%res(this))
      
    END DO
  END SUBROUTINE hdlc_destroy_all

!//////////////////////////////////////////////////////////////////////////////
! subroutine hdlc_linear_checkin
!
! Fill in cartesian components into separate arrays
! On input: mat is a (3,natom) matrix: ((x1,y1,z1),(x2,..),...)
!           or an (3*natom,1) matrix: (x1,y1,z1,x2,...)
!//////////////////////////////////////////////////////////////////////////////

  SUBROUTINE hdlc_linear_checkin(mat,natom,x,y,z)

! args
    TYPE (matrix)          :: mat
    integer, intent(in)    :: natom
    REAL (rk), intent(out) :: x(natom), y(natom), z(natom)

! local vars
    INTEGER i, j, size
    REAL (rk), allocatable :: xyz_data(:,:)

! begin
    !xyz_data => matrix_data_array(mat)
    call allocate(xyz_data,matrix_dimension(mat,1),matrix_dimension(mat,2))
    xyz_data(:,:)=mat%data(:,:)

    IF (matrix_dimension(mat,2)==1) THEN
      size = matrix_dimension(mat,1)/3
      if(size>natom) CALL hdlc_errflag('Error in hdlc_linear_checkin A','stop')
      j = 0
      DO i = 1, size
        x(i) = xyz_data(j+1,1)
        y(i) = xyz_data(j+2,1)
        z(i) = xyz_data(j+3,1)
        j = j + 3
      END DO
    ELSE
      size = matrix_dimension(mat,2)
      if(size>natom) CALL hdlc_errflag('Error in hdlc_linear_checkin B','stop')
      DO i = 1, size
        x(i) = xyz_data(1,i)
        y(i) = xyz_data(2,i)
        z(i) = xyz_data(3,i)
      END DO
    END IF
    call deallocate(xyz_data)
  END SUBROUTINE hdlc_linear_checkin

!//////////////////////////////////////////////////////////////////////////////
! subroutine hdlc_con_checkin
!//////////////////////////////////////////////////////////////////////////////

  SUBROUTINE hdlc_con_checkin(imat,nconn_in,iconn)

! args
    TYPE (int_matrix) :: imat
    integer, intent(in) :: nconn_in
    INTEGER, intent(out) :: iconn(2,nconn_in)

! local vars
    INTEGER i, nconn

! begin
    nconn = int_matrix_dimension(imat,2)
    if(nconn/=nconn_in) then
      CALL hdlc_errflag('Error in hdlc_con_checkin','stop')
    end if
    DO i = 1, nconn
      iconn(1,i) = imat%data(1,i)
      iconn(2,i) = imat%data(2,i)
    END DO
  END SUBROUTINE hdlc_con_checkin

!//////////////////////////////////////////////////////////////////////////////
! subroutine hdlc_report_failure
!//////////////////////////////////////////////////////////////////////////////

  SUBROUTINE hdlc_report_failure(residue,failed,location)

! args
    LOGICAL failed
    CHARACTER(*) location
    TYPE (residue_type) :: residue

! begin
    residue%lgmatok = ( .NOT. failed)
    IF (failed) THEN
      IF (printl>=2) WRITE (stdout,'(/,A,I3,A,A,/)') &
        'G matrix linear dependent in residue ', residue%name, ', routine: ', &
        location
    END IF
  END SUBROUTINE hdlc_report_failure

!//////////////////////////////////////////////////////////////////////////////
! subroutine vector_initialise
!//////////////////////////////////////////////////////////////////////////////

  SUBROUTINE vector_initialise(vector,number,value)

! args
    INTEGER number
    REAL (rk) value
    REAL (rk), DIMENSION (number) :: vector

! local vars
    INTEGER i

! begin
    DO i = 1, number
      vector(i) = value
    END DO
  END SUBROUTINE vector_initialise

END MODULE dlfhdlc_hdlclib

subroutine hdlc_errflag(msg,action)
  implicit none
  character(*),intent(in) :: msg,action
  write(*,'("HDLC-errflag, action: ",a)') action
  call dlf_fail(msg)
end subroutine hdlc_errflag

#ifndef GAMESS
!------------------------------------------------------------------------------
! subroutine dlf_flushout
!
! Flush the I/O buffers of standard output
!------------------------------------------------------------------------------
SUBROUTINE dlf_flushout()
  use dlf_global, only: stdout
  CALL flush(stdout)
END SUBROUTINE dlf_flushout
#else
SUBROUTINE dlf_flushout()
  CALL flushout
END SUBROUTINE dlf_flushout
#endif

!!****h* utilities/linalg
!!
!! FUNCTION
!! Linear algebra utilities
!!
!! These subroutines provide wrappers for lapack and blas routines
!! so that the latter are only called once in the code. This 
!! should facilitate porting.
!!
!! COPYRIGHT
!!
!!  Copyright 2007 Johannes Kaestner (kaestner@theochem.uni-stuttgart.de),
!!  Tom Keal (thomas.keal@stfc.ac.uk)
!!
!!  This file is part of DL-FIND.
!!
!!  DL-FIND is free software: you can redistribute it and/or modify
!!  it under the terms of the GNU Lesser General Public License as 
!!  published by the Free Software Foundation, either version 3 of the 
!!  License, or (at your option) any later version.
!!
!!  DL-FIND is distributed in the hope that it will be useful,
!!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!!  GNU Lesser General Public License for more details.
!!
!!  You should have received a copy of the GNU Lesser General Public 
!!  License along with DL-FIND.  If not, see 
!!  <http://www.gnu.org/licenses/>.
!!
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* linalg/dlf_matrix_multiply
!!
!! FUNCTION
!!
!! C= alpha * AxB + beta * C
!!
!! SYNOPSIS
subroutine dlf_matrix_multiply(M,N,K,alpha,A,B,beta,C)
  use dlf_parameter_module, only: rk
  implicit none
  integer  ,intent(in)    :: M,N,K
  real(rk) ,intent(in)    :: alpha,beta
  real(rk) ,intent(in)    :: A(M,K) ! K is the common index
  real(rk) ,intent(in)    :: B(K,N)
  real(rk) ,intent(inout) :: C(M,N)
!! SOURCE
! **********************************************************************
  CALL dgemm('N','N',M,N,K,alpha, A , M, B, K, beta, C, M)
end subroutine dlf_matrix_multiply
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* linalg/dlf_matrix_invert
!!
!! FUNCTION
!!
!! A <- A^-1
!!
!! SYNOPSIS
subroutine dlf_matrix_invert(N,tdet,a,det)
  use dlf_parameter_module, only: rk
  use dlfhdlc_matrixlib, only: array_invert 
  implicit none
  integer  ,intent(in)    :: N
  logical  ,intent(in)    :: tdet
  real(rk) ,intent(inout) :: A(N,N)
  real(rk) ,intent(out)   :: det
!! SOURCE
  integer :: idum
! **********************************************************************
  idum = array_invert(A,det,tdet,N)
end subroutine dlf_matrix_invert
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* linalg/dlf_matrix_diagonalise
!!
!! FUNCTION
!!
!! Calculate eigenvalues and eigenvectors of a real, symmetric matrix A
!!
!! The eigenvector to the eigenvalue evals(ivar) is evecs(:,ivar)
!!
!! SYNOPSIS
subroutine dlf_matrix_diagonalise(N,a,evals,evecs)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlfhdlc_matrixlib, only: array_diagonalise
  implicit none
  integer  ,intent(in)    :: N
  real(rk) ,intent(in)    :: A(N,N)
  real(rk) ,intent(out)   :: evals(N)
  real(rk) ,intent(out)   :: evecs(N,N)
  integer :: idum
! **********************************************************************
  idum = array_diagonalise(a,evecs,evals,n,n,n,.true.)
end subroutine dlf_matrix_diagonalise
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* linalg/dlf_matrix_print
!!
!! FUNCTION
!!
!! Print out a matrix 
!!
!! M = number of rows
!! N = number of columns
!! a = M x N array
!!
!! SYNOPSIS
subroutine dlf_matrix_print(M,N,a)
  use dlf_parameter_module, only: rk
  use dlf_global, only: stdout
  implicit none
  integer  ,intent(in)    :: M,N 
  real(rk) ,intent(in)    :: a(M,N)
!! SOURCE
! **********************************************************************
  integer :: imin, imax, max, i, j
  logical :: highprec

  highprec = .false.

  if (highprec) then
     max = 7
  else
     max = 12
  end if
  imax = 0

  do while(imax < N)
     imin = imax + 1
     imax = imax + max
     if (imax > N) imax = N
     write(stdout, *)
     if (highprec) then
        write(stdout, '(6X,7(6X,I3,6X))') (i,i=imin,imax)
     else
        write(stdout, '(6X,12(3X,I3,3X))') (i,i=imin,imax)
     end if
     write(stdout, *)
     do j = 1, M
        if (highprec) then
           write(stdout, '(I5,1X,7F15.10)') j, (a(j,i),i=imin,imax)
        else
           write(stdout, '(I5,1X,12F9.5)') j, (a(j,i),i=imin,imax)
        end if
     end do
  end do
end subroutine dlf_matrix_print
!!****

! **********************************************************************
! **                                                                  **
! **              Hybrid Delocalised Internal Coordinates             **
! **                                                                  **
! **                         HDLC Driver routines                     **
! **                                                                  **
! **                                                                  **
! **********************************************************************
!!****h* coords/hdlc
!!
!! NAME
!! hdlc
!!
!! FUNCTION
!! 
!! Hybrid Delocalised Internal Coordinates
!! 
!! HDLC Driver routines
!!
!! Usage:
!! *  call dlf_hdlc_init
!! *  call dlf_hdlc_create
!! *  use the hdlc with dlf_hdlc_xtoi and dlf_hdlc_itox. In case a 
!!    breakdown occurs (tok==.false.) use:
!! *  call dlf_hdlc_reset 
!! *  call dlf_hdlc_create
!! *  finally: call dlf_hdlc_destroy
!!
!!
!! DATA
!! $Date$
!! $Rev$
!! $Author$
!! $URL$
!! $Id$
!!
!! COPYRIGHT
!!
!!  Copyright 2007 Johannes Kaestner (kaestner@theochem.uni-stuttgart.de),
!!  Tom Keal (thomas.keal@stfc.ac.uk), Alex Turner, Salomon Billeter,
!!  Stephan Thiel, Max-Planck Institut fuer Kohlenforshung, Muelheim, 
!!  Germany.
!!
!!  This file is part of DL-FIND.
!!
!!  DL-FIND is free software: you can redistribute it and/or modify
!!  it under the terms of the GNU Lesser General Public License as 
!!  published by the Free Software Foundation, either version 3 of the 
!!  License, or (at your option) any later version.
!!
!!  DL-FIND is distributed in the hope that it will be useful,
!!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!!  GNU Lesser General Public License for more details.
!!
!!  You should have received a copy of the GNU Lesser General Public 
!!  License along with DL-FIND.  If not, see 
!!  <http://www.gnu.org/licenses/>.
!!
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* hdlc/dlf_hdlc_init
!!
!! FUNCTION
!!
!! Initialise HDLC object for one hdlc set:
!! * allocate all arrays that are independent of the coordinates and thus
!! of the actual hdlc state
!!
!! SYNOPSIS
subroutine dlf_hdlc_init(nat,spec,icoord,nconstr,iconstr,nincon,incon)
!! SOURCE
  use dlf_parameter_module, only: ik
  use dlf_global, only: stdout,printl
  use dlfhdlc_hdlclib, only: hdlc
  use dlf_allocate, only: allocate,deallocate
  implicit none
  integer ,intent(in) :: nat
  integer ,intent(in) :: spec(nat)
  integer ,intent(in) :: icoord
  integer ,intent(in) :: nconstr
  integer ,intent(in) :: iconstr(5,max(nconstr,1)) 
  integer ,intent(in) :: nincon
  integer ,intent(in) :: incon(2,max(nincon,1)) 
  ! local vars
  integer             :: ngroups,i,j,first,length,ires,iat,ndel,ii,count
  logical, parameter :: dbg=.false.
  integer, allocatable :: rlength(:)
! **********************************************************************
  hdlc%tinit=.true.
  hdlc%lhdlc=.false. ! no hdlcs created yet

  if(nat<1) then
    call dlf_fail("Number of atoms in HDLC must be >0!")
  end if

  if(printl>=4) then
    write(stdout,"('Residue member list:')")
    do iat=1,nat,10
      write(stdout,"(i5,' : ',10i5)") iat-1,(spec(iat+i),i=0,min(9,nat-iat))
    end do
  end if

  ! allocate and set residue numbers
  call allocate(hdlc%resn,nat)

  !  hdlc%resn(:)=spec(:)
  if(dbg) print*,"spec",spec
  hdlc%resn=0
  ! attention: ngoups is calculated here as well as in dlf_hdlc_create.
  ! it may be smaller there, as residues may have been deleted
  ! ires makes sure that residues are sorted and consecutively numbered
  ngroups = 0
  j = 0
  first=1
  hdlc%nfrozen=0
  ires=0
  !determine maximum number of residues
  DO i = 1, nat
    IF (spec(i)<=0) THEN
      IF (spec(i)<0) then
        hdlc%nfrozen=hdlc%nfrozen+1
        hdlc%resn(i)=spec(i)
      end IF
    ELSE 
      ! see if this spec has been handled before
      j=0
      do ii=i-1,1,-1
        if(spec(ii)==spec(i)) then
          j=hdlc%resn(ii)
          exit
        end if
      end do
      if(j/=0) then
        hdlc%resn(i)=j
      else
        ! new residue starts here
        ires=ires+1
        hdlc%resn(i)=ires
      end if
    end IF
  end DO
  ! now hdlc%resn(i) contains residue numbers in ascending order, not necessarily 
  !continous
  ! Determine length of the residues
  ngroups=ires
  call allocate(rlength,ngroups)
  rlength(:)=0
  DO i = 1, nat
    ! this should never happen
    if(hdlc%resn(i)>ngroups) call dlf_fail("Inconsistent residue list")
    if(hdlc%resn(i)>0) rlength(hdlc%resn(i))=rlength(hdlc%resn(i))+1
  end DO
  !delete residues with only one atom
  ndel=0
  do ires=1,ngroups
    ! this should never happen
    if(rlength(ires)==0) call dlf_fail("Inconsistent residue size")
    if(rlength(ires)==1) ndel=ndel+1
  end do
  if(ndel>0 .and. printl>=4 ) then
    print*,ndel," groups will be deleted as they only contain one atom"
  end if
  ngroups=ngroups-ndel

  if(dbg) print*,"hdlc%resn",hdlc%resn
  if(dbg) PRINT*,"ngroups",ngroups

  IF(ngroups==0) then
    call dlf_fail("No residues present in dfl_hdlc_init")
  end IF

  call allocate(hdlc%err_cnt,ngroups)
  hdlc%err_cnt(:)=0

  !=====================================================================
  ! allocate residues
  !=====================================================================
  hdlc%first=1
  hdlc%last=ngroups
  allocate(hdlc%res(1:ngroups))
  ! storage is a bit difficut to monitor here ...
  ! initialise the name (number of residue)
  do i=hdlc%first,hdlc%last
    hdlc%res(i)%name=i
  end do
  ! get the list of atoms participating in the corresponding residue (res%at)
  ires=0
  do i=1,ngroups+ndel
    if(rlength(i)==1) then
      ! delete this residue
      DO iat = 1, nat
        if(hdlc%resn(iat)==i) hdlc%resn(iat)=0
      end DO
    else
      ires=ires+1
      hdlc%res(ires)%natom=rlength(i)
      allocate(hdlc%res(ires)%at(rlength(i))) ! pointer
      allocate(hdlc%res(ires)%xweight(rlength(i))) ! pointer
      count=1
      do iat = 1, nat
        if(hdlc%resn(iat)==i) then
          ! this works at resn is in ascending order
          hdlc%resn(iat)=ires ! may be different as to removed residues
          hdlc%res(ires)%at(count)=iat
          count=count+1
        end if
      end do
    end if
  end do
  call deallocate(rlength)
!!$  ! debug:
!!$  do ires=1,ngroups
!!$    print*,"JK Group",ires,":",hdlc%res(ires)%at(:)
!!$  end do

  !=====================================================================
  ! handle constraints
  !=====================================================================
  hdlc%nconstr=nconstr
  call allocate(hdlc%iconstr,5,max(nconstr,1))
  if(nconstr>0) hdlc%iconstr(:,:)=iconstr(:,:)

  !=====================================================================
  ! handle user input connections
  !=====================================================================
  hdlc%nincon=nincon
  call allocate(hdlc%incon,2,max(nincon,1))
  if(nincon>0) hdlc%incon(:,:)=incon(:,:)

  !=====================================================================
  ! handle contyp (0 internals, 1 Total connection)
  !=====================================================================
  if(icoord==1) then
    hdlc%contyp=0
  else if(icoord==2) then
    hdlc%contyp=1
  else if(icoord==3) then
    hdlc%contyp=0
  else if(icoord==4) then
    hdlc%contyp=1
  else
    Write(stdout,"('icoord=',i4,'is not supported in HDLC')")
    call dlf_fail("Wrong icoord setting in HDLC")
  end if
  hdlc%internal=(icoord>=3)
  if(hdlc%internal) then
    if(maxval(spec)/=minval(spec)) then
      call dlf_fail("All atoms have to belong to the same residue if icoord > 2")
    end if
    hdlc%nmin=6
  else
    hdlc%nmin=0
  end if

end subroutine dlf_hdlc_init
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* hdlc/dlf_hdlc_get_nivar
!!
!! FUNCTION
!!
!! return number of internal coordinates
!!
!! note that global data is used in these calculations
!!
!! SYNOPSIS
subroutine dlf_hdlc_get_nivar(region, nivar)
!! SOURCE
  use dlf_global, only: glob, stdout
  use dlfhdlc_hdlclib, only: hdlc, get_cons_regions
  implicit none
  integer, intent(in) :: region
  integer  ,intent(out) :: nivar
  integer :: i, iat, ninner, nouter, nfull
  integer :: nincons, noutcons
! **********************************************************************
  if(.not.hdlc%tinit) &
      call dlf_fail("HDLC not initialised in dlf_hdlc_get_nivar")
  ! nat should prbably be replaced ...
  nfull = glob%nat * 3 - hdlc%nconstr - hdlc%nmin - hdlc%nfrozen * 3

  ninner = 0
  nouter = 0
  ! Total inner and outer coordinates
  do i = 1, glob%nat
     if (glob%spec(i) < 0) cycle ! frozen
     if (glob%micspec(i) == 1) then
        ninner = ninner + 3
     else
        nouter = nouter + 3
     end if
  end do
  ! Subtract no. of constraints from the correct region 
  call get_cons_regions(hdlc%nconstr, hdlc%iconstr, glob%nat, glob%spec, &
       glob%micspec, nincons, noutcons)
  ninner = ninner - nincons
  nouter = nouter - noutcons

  ! nmin only applies to a single (inner) residue setup, i.e. DLC or TC
  ninner = ninner - hdlc%nmin

  if (nfull /= ninner + nouter) then
     write(stdout,*) "nfull, ninner, nouter = ", nfull, ninner, nouter
     call dlf_fail("Inconsistent nivar values in dlf_hdlc_get_nivar")
  end if

  select case (region)
  case (0)
     nivar = nfull
  case (1)
     nivar = ninner
  case (2)
     nivar = nouter
  case default
     call dlf_fail("Unknown region number in dlf_hdlc_get_nivar")
  end select
  
end subroutine dlf_hdlc_get_nivar
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* hdlc/dlf_hdlc_create
!!
!! FUNCTION
!!
!! create all hdlcs (i.e. the Ut matrix) 
!!
!! more than one image may be provided. In this case, the union of the
!! connections of all image are used. The Ut matrix is calculated for 
!! the first image provided.
!!
!! SYNOPSIS
subroutine dlf_hdlc_create(nat,nicore,spec,micspec,attypes,nimage,xcoords,xweight,mass)
!! SOURCE
  use dlf_global, only: printl,stdout
  use dlf_allocate, only: allocate, deallocate
  use dlfhdlc_hdlclib, only: hdlc,matrix,int_matrix,matrix_create,matrix_set, &
      int_matrix_destroy,matrix_destroy, &
      ! subroutines
      connect_prim, ci_conn, assign_cons, hdlc_create, assign_cons, &
      hdlc_create
  use dlf_parameter_module, only: rk
  implicit none
  integer ,intent(in) :: nat
  integer, intent(in) :: nicore
  integer ,intent(in) :: spec(nat)
  integer, intent(in) :: micspec(nat)
  integer ,intent(in) :: attypes(nat)
  integer ,intent(in) :: nimage
  real(rk),intent(in) :: xcoords(3,nimage*nat)
  real(rk),intent(in) :: xweight(nat)
  real(rk),intent(in) :: mass(nat)
  !
  integer             :: ngroups
  real(rk),allocatable:: vconstr(:) !max(1,nconstr) ! value of the constraint??
  TYPE (matrix)       :: cns, xyz
  INTEGER, pointer    :: iconn(:,:)
  TYPE (int_matrix)   :: con
  integer             :: iatom, group, ifin,idum,length, istart,nconn
  integer             :: i,j,fail,ncart,maxcon,iimage,iphdlc,ipinner,ipouter
  integer             :: ires, iat,irun
  real(rk),allocatable:: atmp(:)
  integer, allocatable:: atmpi(:)
  integer             :: nconst_here,nconst_sum
  integer             :: iregion
! **********************************************************************

  if(.not.hdlc%tinit) &
      call dlf_fail("HDLC not initialised in dlf_hdlc_create")

  hdlc%lhdlc=.true. ! this does not seem to have any effect ...

! ngroups: number of HDLC residues in hdlc%resn
! the variable hdlc%ngroups has to denote the number of actually allocated
!   residues
  j = 0
  ncart = 0
  ngroups = 0
  DO i = 1, nat
    IF (hdlc%resn(i)==0) THEN
      ncart = ncart + 1
    else if (hdlc%resn(i)<0) then
      cycle
    ELSE IF (hdlc%resn(i)>j) THEN
      ngroups = ngroups + 1
      j = hdlc%resn(i)
    END IF
  END DO

  call allocate(vconstr,max(1,hdlc%nconstr))
  vconstr(:)=0.D0
  
  IF (printl>=2) WRITE (stdout,'(/,a,i4,a)') &
      'Generating new HDLC for ', ngroups, ' residues'

! loop over all groups
! icoords is ordered with inner region coords followed by
! outer region coords. ip (icoords position) must be set 
! accordingly.
  ipinner = 1
  ipouter = nicore + 1
  hdlc%first=1
  nconst_sum=0
  do ires=1,ngroups
    ! Determine which region the residue is in by the 
    ! micspec value of the first atom in it
    ! NB: for standard (non-microiterative) optimisations, 
    ! all residues are considered to be 'inner'
    iregion = micspec(hdlc%res(ires)%at(1))
    if (iregion == 1) then
       iphdlc = ipinner
    else
       iphdlc = ipouter
    end if
    ! Residues must not contain a mix of inner and outer atoms
    do i = 1, hdlc%res(ires)%natom
       if (micspec(hdlc%res(ires)%at(i)) /= iregion) then
          write (stdout,'(3x,a,i4,a)') 'Residue number ', ires, &
               ' crosses inner/outer boundary.'
          write (stdout,'("   Atoms: ",10i6)') hdlc%res(ires)%at(:)
          call dlf_fail("HDLC residue crosses inner/outer boundary")
       end if
    end do
    hdlc%res(ires)%ip=iphdlc
    iphdlc=iphdlc+hdlc%res(ires)%natom * 3

    length=hdlc%res(ires)%natom
! now we have group, istart, ifin
    istart=1
    ifin=1 !dummies to be removed - IMPROVE!
    IF (printl>=2) THEN
      WRITE (stdout,'(/,a)') 'Located a new residue for HDLC'
      WRITE (stdout,'(3x,a,i4)') 'Residue number is ', ires
      WRITE (stdout,'(3x,a,i5)') 'Number of atoms it contains ',length
      WRITE (stdout,'("   Atoms: ",10i6)') hdlc%res(ires)%at(:)
    END IF
    IF (length<2) THEN
      CALL hdlc_errflag('No residue can contain less than two atoms', &
          'stop')
    END IF
    xyz = matrix_create(3*length,1,'XYZ')

    ! define res%xweight
    do iat=1,length
      hdlc%res(ires)%xweight(iat)=xweight(hdlc%res(ires)%at(iat))
    end do

    ! get connections for primitive internals
    IF (hdlc%contyp==0) THEN

      nconn=0
      maxcon=length
      allocate (iconn(2,maxcon)) ! pointer

      ! get connections from the images, using image 1 as last one,
      !  because these xyz coordinates should remain
      do iimage=nimage,1,-1
        !check in atom coordinates
        call allocate(atmp,3*length)
        do iat=1,length
          atmp((iat-1)*3+1:(iat-1)*3+3)= &
              xcoords(:, (iimage-1)*nat + hdlc%res(ires)%at(iat))
        end do
        !CALL dummyarg_checkin(reshape(xcoords(:,(iimage-1)*nat+1:iimage*nat),&
        !    (/3*nat/)),3*(istart-1)+1,3*length)
        idum = matrix_set(xyz,size(atmp),atmp)
        !CALL dummyarg_clear
        call deallocate(atmp)

        !CALL dummyarg_checkin(attypes,istart,length)
        call allocate(atmpi,length)
        do iat=1,length
          atmpi(iat)=attypes(hdlc%res(ires)%at(iat))
        end do
        CALL connect_prim(length,maxcon,atmpi,nconn,iconn,xyz)
        call deallocate(atmpi)
        !CALL dummyarg_clear
      end do

      ! check in user connections and create connections matrix
      CALL ci_conn(con,nconn,iconn,hdlc%nincon,hdlc%incon,length,&
          hdlc%res(ires)%at)
      DEALLOCATE (iconn) ! pointer

      ! check in constraints
      CALL assign_cons(cns,hdlc%iconstr,hdlc%nconstr,vconstr, &
          1,length,hdlc%res(ires)%at,hdlc%internal,nconst_here)
      iphdlc=iphdlc-nconst_here

      ! create the HDLC - primitives
      CALL hdlc_create(hdlc%res(ires),xyz,con,cns,ires)
      idum = int_matrix_destroy(con)
      idum = matrix_destroy(cns)

      ! create the HDLC - total connection scheme - no check if only stretch constr.
    ELSE ! (ctrl%contyp.eq.0 ...)

      !check in atom coordinates
      call allocate(atmp,3*length)
      do iat=1,length
        atmp((iat-1)*3+1:(iat-1)*3+3)=xcoords(:,hdlc%res(ires)%at(iat))
      end do
      idum = matrix_set(xyz,size(atmp),atmp)
      call deallocate(atmp)

      !CALL dummyarg_checkin(reshape(xcoords,(/3*nat/)),3*(istart-1)+1,3*length)
      !idum = matrix_set(xyz,dummyarg)
      !CALL dummyarg_clear

      CALL assign_cons(cns,hdlc%iconstr,hdlc%nconstr,vconstr, &
          1,length,hdlc%res(ires)%at,hdlc%internal,nconst_here)
      iphdlc=iphdlc-nconst_here

      CALL hdlc_create(hdlc%res(ires),xyz,con,cns,ires)
      idum = matrix_destroy(cns)
    END IF ! (ctrl%contyp.eq.0 ...)

! restore the error counter
    hdlc%res(ires)%err_cnt = hdlc%err_cnt(ires)
    idum = matrix_destroy(xyz)
    nconst_sum=nconst_sum+nconst_here

    ! Write out mapping of HDLCs to internal coordinates
    ! Useful for identifying which HDLC the max grad component 
    ! corresponds to during an optimisation
    if (printl >= 2) then
       write(stdout, '("   Residue ", i6, " has internal coords ", i6, &
            " to ", i6)') ires, hdlc%res(ires)%ip, iphdlc-1
    end if

    ! update inner or outer coords position marker
    if (iregion == 1) then
       ipinner = iphdlc
    else
       ipouter = iphdlc
    end if

  END DO ! ires=1,ngroups
  call deallocate(vconstr)

  hdlc%nconstr=nconst_sum
  
end subroutine dlf_hdlc_create
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* hdlc/dlf_hdlc_getweight
!!
!! FUNCTION
!!
!! return weights on internal coordinates
!!
!! SYNOPSIS
subroutine dlf_hdlc_getweight(nat,nivar,nicore,micspec,xweight,iweight)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: printl,stdout  
  use dlfhdlc_hdlclib
  implicit none
  integer ,intent(in) :: nat
  integer ,intent(in) :: nivar
  integer ,intent(in) :: nicore
  integer ,intent(in) :: micspec(nat)
  real(rk),intent(in) :: xweight(nat)   ! only used for cartesians
  real(rk),intent(out):: iweight(nivar)
  integer             :: iphdlc,group,iat,length,ndfhdlc,inta2(2)
  integer             :: ipinner, ipouter
  TYPE (residue_type) :: residue
! **********************************************************************
  if(.not.hdlc%tinit) &
      call dlf_fail("HDLC not initialised in dlf_hdlc_getweight")

  iweight(:)=0.D0
  ipinner = 1
  ipouter = nicore + 1
  DO group = 1, hdlc%ngroups
 
    ! ignore deleted residues
    if(hdlc%res(group)%name==-1) cycle
    residue=hdlc%res(group)
    iphdlc = residue%ip 
    length = residue%natom

    if(.not.allocated(hdlc%res(group)%iweight%data)) then
      call dlf_fail("No weights present in dlf_hdlc_getweight")
    end if

    !ndfhdlc = 3*length - residue%ncons ! orig
    inta2=shape(hdlc%res(group)%iweight%data)
    ndfhdlc=inta2(1)

    iweight(iphdlc:iphdlc+ndfhdlc-1)=reshape(  &
        hdlc%res(group)%iweight%data(:,:),(/ndfhdlc/))
    ! for correct start of cartesians
    if (iphdlc <= nicore) then
       ipinner = ipinner + ndfhdlc-hdlc%nmin
    else 
       ipouter = ipouter + ndfhdlc-hdlc%nmin
    end if

  end DO

  DO iat = 1, nat
    IF (hdlc%resn(iat)==0) THEN
       if (micspec(iat) == 1) then
          iweight(ipinner:ipinner+2) = xweight(iat)
          ipinner = ipinner + 3
       else
          iweight(ipouter:ipouter+2) = xweight(iat)
          ipouter = ipouter + 3
       end if
    end IF
  end DO

end subroutine dlf_hdlc_getweight
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* hdlc/dlf_hdlc_xtoi
!!
!! FUNCTION
!!
!! convert Cartesian -> HDLC
!!
!! SYNOPSIS
subroutine dlf_hdlc_xtoi(nat,nivar,nicore,micspec,xcoords,xgradient,&
     icoords,igradient)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: printl,stdout  
  use dlf_allocate, only: allocate,deallocate
  use dlfhdlc_hdlclib, only: hdlc,matrix,residue_type,matrix_create, &
      matrix_set,matrix_get,matrix_destroy, matrix_print, &
      ! subroutines
      coord_cart_to_hdlc, grad_cart_to_hdlc, hdlc_split_cons, hdlc_split_cons
  implicit none
  integer ,intent(in) :: nat
  integer ,intent(in) :: nivar
  integer, intent(in) :: nicore
  integer ,intent(in) :: micspec(nat)  
  real(rk),intent(in) :: xcoords(3,nat)
  real(rk),intent(in) :: xgradient(3,nat)
  real(rk),intent(out):: icoords(nivar)
  real(rk),intent(out):: igradient(nivar)

  TYPE (residue_type) :: residue
  TYPE (matrix)       :: cns, xyz, cxyz, chdlc, gxyz, ghdlc
  integer             :: ndfcons,group,iphdlc,length,ndfhdlc
  integer             :: idum,j,iat,m,ndfopt
  integer             :: ipinner, ipouter
  real(rk),pointer    :: prim_tmp(:) 
  real(rk),allocatable:: atmp(:)
! **********************************************************************
  if(.not.hdlc%tinit) &
      call dlf_fail("HDLC not initialised in dlf_hdlc_xtoi")

  IF(hdlc%NGROUPS<1) call dlf_fail("Number of fragements in HDLC must be >0")

  IF (printl>=4) WRITE (stdout,'(/,A)') &
      'Converting Cartesians to HDLC'
  ndfcons = 0

  ipinner = 1
  ipouter = nicore + 1

  DO group = 1, hdlc%ngroups
 
    ! ignore deleted residues
    if(hdlc%res(group)%name==-1) cycle
    residue=hdlc%res(group)

    iphdlc = residue%ip 
    ndfcons = ndfcons + residue%ncons
    length = residue%natom
    ndfhdlc = 3*length - residue%ncons

! now we have group, istart, ifin, iphdlc, ndfhdlc; convert coords to HDLC
    cxyz = matrix_create(3*length,1,'CXYZ')
    chdlc = matrix_create(3*length-hdlc%nmin,1,'CHDLC')
    call allocate(atmp,3*length)
    do iat=1,length
      atmp((iat-1)*3+1:(iat-1)*3+3)= xcoords(:,residue%at(iat))
    end do
    idum = matrix_set(cxyz,size(atmp),atmp)

    CALL coord_cart_to_hdlc(residue,cxyz,chdlc,prim_tmp,.FALSE.)

! convert gradient to HDLC
    gxyz = matrix_create(3*length,1,'GXYZ')
    ghdlc = matrix_create(3*length-hdlc%nmin,1,'GHDLC')
    do iat=1,length
      atmp((iat-1)*3+1:(iat-1)*3+3)= xgradient(:,residue%at(iat))
    end do
    !CALL dummyarg_checkin(reshape(xgradient,(/3*nat/)),3*(istart-1)+1,3*length)
    idum = matrix_set(gxyz,size(atmp),atmp)
    call deallocate(atmp)
    !CALL dummyarg_clear
    CALL grad_cart_to_hdlc(residue,cxyz,gxyz,ghdlc)

! separate between active space and constraints - resize CHDLC and GHDLC
    IF (residue%ncons/=0) THEN
      CALL hdlc_split_cons(residue,chdlc,.true.)
      CALL hdlc_split_cons(residue,ghdlc,.FALSE.)
    END IF

! set icoords and igradient, size of chdlc/ghdlc now: ndfhdlc
    idum = matrix_get(chdlc,ndfhdlc-hdlc%nmin,&
        icoords(iphdlc:iphdlc+ndfhdlc-hdlc%nmin-1))
    idum = matrix_get(ghdlc,ndfhdlc-hdlc%nmin,&
        igradient(iphdlc:iphdlc+ndfhdlc-hdlc%nmin-1))

! prepare for the next group
    idum = matrix_destroy(cxyz)
    idum = matrix_destroy(gxyz)
    idum = matrix_destroy(chdlc)
    idum = matrix_destroy(ghdlc)

    ! for correct start of cartesians
    if (iphdlc <= nicore) then
       ipinner = ipinner + ndfhdlc-hdlc%nmin
    else
       ipouter = ipouter + ndfhdlc-hdlc%nmin
    end if

  END DO ! group = 1,hdlc%ngroups

! check in Cartesians - no cartesian constraints implemented!
  j = 0
  DO iat = 1, nat
    IF (hdlc%resn(iat)==0) THEN
       if (micspec(iat) == 1) then
          iphdlc = ipinner
       else
          iphdlc = ipouter
       end if
       DO m = 0, 2
          icoords(iphdlc+m) =   xcoords(m+1,iat)
          igradient(iphdlc+m) = xgradient(m+1,iat)
       END DO
       iphdlc = iphdlc + 3
       if (micspec(iat) == 1) then
          ipinner = iphdlc
       else
          ipouter = iphdlc
       end if
    END IF
  END DO ! iat = 1,nat

  if (ipinner /= nicore + 1) then
     write(stdout,*) "ipinner, nicore=", ipinner, nicore
     call dlf_fail("Error in the transformation hdlc_xtoi (inner)")
  end if
  if (ipouter /= nivar + 1) then
     write(stdout,*) "ipouter, nivar=", ipouter, nivar
     call dlf_fail("Error in the transformation hdlc_xtoi (outer)")
  end if

end subroutine dlf_hdlc_xtoi
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* hdlc/dlf_hdlc_hessian_xtoi
!!
!! FUNCTION
!!
!!  convert Hessian: Cartesian -> HDLC
!! 
!!  This routine misses a term within each residue: the drivative of the internals with 
!!  respect to both cartesians!
!!
!!  Additionally, all inter-residue terms are missing. This may be less 
!!  of a problem, as the whole core should be one residue anyway.
!!
!!  Also does not yet support microiterative calcs. In principle this 
!!  could be implemented with HDLCs, providing the inner region contains
!!  only one residue.
!!
!! SYNOPSIS
subroutine dlf_hdlc_hessian_xtoi(nat,nivar,xcoords,xhessian,ihessian)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: stdout,printl
  use dlfhdlc_hdlclib, only: hdlc,matrix,residue_type,matrix_create, &
      matrix_set,matrix_get,matrix_destroy, &
      ! subroutines
      hess_cart_to_hdlc
  implicit none
  integer ,intent(in) :: nat
  integer ,intent(in) :: nivar
  real(rk),intent(in) :: xcoords(3,nat)
  real(rk),intent(in) :: xhessian(3*nat,3*nat)
  real(rk),intent(out):: ihessian(nivar,nivar)
  integer             :: group,istart,length,idum,pos
  TYPE (matrix)       :: cxyz,hxyz,hhdlc
  TYPE (residue_type) :: residue
! **********************************************************************
  if(.not.hdlc%tinit) &
      call dlf_fail("HDLC not initialised in dlf_hdlc_xtoi")
  
  IF(hdlc%NGROUPS<1) call dlf_fail("Number of fragemnts in HDLC must be >0")

  if(hdlc%ngroups>1) then
    call dlf_fail("Conversion of a Cartesian Hessian to HDLC only works &
        & for only one fragment (residue)")
  end if

  IF (printl>=4) WRITE (stdout,'(/,A)') &
      'Converting Cartesian Hessian to HDLC'

  pos=1
  istart=1
  DO group = 1, hdlc%ngroups

    ! ignore deleted residues
    if(hdlc%res(group)%name==-1) cycle
    residue=hdlc%res(group)

    length = residue%natom

    ! set coordinates
    cxyz = matrix_create(3*length,1,'CXYZ')
    !CALL dummyarg_checkin(reshape(xcoords,(/3*nat/)),3*(istart-1)+1,3*length)
    !idum = matrix_set(cxyz,dummyarg)
    idum = matrix_set(cxyz,3*length,xcoords(:,istart:istart+length-1))
    !CALL dummyarg_clear

    ! set cartesian hessian matrix
    hxyz = matrix_create(3*length,3*length,'HXYZ')
    !CALL dummyarg_checkin(hess,3*(istart-1)+1,3*length)
    ! This will be a block-diagonal Hessian with a block for each residue only.
    !    that's not what it is supposed to be in the end...
    ! position of the residue in icoords (residue%ip) should be considered!
    idum=(3*length-hdlc%nmin)**2
    idum = matrix_set(hxyz,idum,xhessian(3*(istart-1)+1:3*(istart-1)+3*length,&
        3*(istart-1)+1:3*(istart-1)+3*length))
    !CALL dummyarg_clear

    hhdlc = matrix_create(3*length-hdlc%nmin,3*length-hdlc%nmin,'HHDLC')
    ! convert cartesian to HDLC
    call hess_cart_to_hdlc(residue,cxyz,hxyz,hhdlc)

    ! here, constraints should be handeled

    ! read out the hessian to hess
    idum=(3*length-hdlc%nmin)**2
    idum = matrix_get(hhdlc,idum,ihessian(pos:pos+3*length-hdlc%nmin-1, &
        pos:pos+3*length-hdlc%nmin-1))

    idum = matrix_destroy(cxyz)
    idum = matrix_destroy(hxyz)
    idum = matrix_destroy(hhdlc)

    pos=pos+3*length-hdlc%nmin
    
  end DO

end subroutine dlf_hdlc_hessian_xtoi
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* hdlc/dlf_hdlc_itox
!!
!! FUNCTION
!!
!!  convert HDLC -> Cartesian
!!
!! SYNOPSIS
subroutine dlf_hdlc_itox(nat,nivar,nicore,micspec,icoords,xcoords,tok)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: printl,stdout  
  use dlfhdlc_hdlclib, only: hdlc,matrix,residue_type,matrix_create,matrix_set, &
      matrix_destroy,matrix_get, matrix_print,&
      ! subroutines
      hdlc_rest_cons,coord_hdlc_to_cart,hdlc_destroy_all
  use dlf_allocate, only: allocate, deallocate
  implicit none
  integer ,intent(in)   :: nat
  integer ,intent(in)   :: nivar
  integer, intent(in)   :: nicore
  integer ,intent(in)   :: micspec(nat) 
  real(rk),intent(in)   :: icoords(nivar)
  real(rk),intent(inout):: xcoords(3,nat)
  logical ,intent(out)  :: tok
  !
  TYPE (residue_type)   :: residue
  TYPE (matrix)         :: cns, xyz, cxyz, chdlc, gxyz, ghdlc
  integer               :: ndfcons,group,iphdlc,length,ndfhdlc
  integer               :: idum,j,iatom,m,ndfopt,i,iat
  integer               :: ipinner, ipouter
  real(rk),allocatable  :: atmp(:)
! **********************************************************************

  if(.not.hdlc%tinit) &
      call dlf_fail("HDLC not initialised in dlf_hdlc_itox")

  IF(hdlc%NGROUPS<1) call dlf_fail("Number of fragemnts in HDLC must be >0")

  tok=.true.
  hdlc%interror=.false.
  IF (printl>=4) WRITE (stdout,'(/,A)') &
      'Converting HDLC to Cartesians'

  ipinner = 1
  ipouter = nicore + 1

! loop over all residues
  hdlc%ngroupsdrop = 0
  ndfcons = 0
  DO group = 1, hdlc%ngroups
    residue = hdlc%res(group)
    ! ignore deleted residues
    if(hdlc%res(group)%name==-1) cycle

    iphdlc = residue%ip 
    ndfcons = ndfcons + residue%ncons
    length = residue%natom
    ndfhdlc = 3*length - residue%ncons

! now we have group, istart, ifin, iphdlc, ndfhdlc; check out HDLC coordinates
    chdlc = matrix_create(ndfhdlc-hdlc%nmin,1,'CHDLC')
    cxyz = matrix_create(3*length,1,'CXYZ')
    !CALL dummyarg_checkin(icoords,iphdlc,ndfhdlc-hdlc%nmin)
    idum = matrix_set(chdlc,ndfhdlc-hdlc%nmin,icoords(iphdlc:iphdlc+ndfhdlc-hdlc%nmin-1))
    call allocate(atmp,3*residue%natom)
    do iat=1,length
      atmp((iat-1)*3+1:(iat-1)*3+3)= xcoords(:,residue%at(iat))
    end do
    idum = matrix_set(cxyz,size(atmp),atmp) !xcoords(:,istart:istart+residue%natom-1))

! restore values of constrained variables if required
    IF (residue%ncons/=0) THEN
      CALL hdlc_rest_cons(residue,chdlc)
    END IF

! fit Cartesian coordinates to HDLC coordinates; size of chdlc now: 3*length
    CALL coord_hdlc_to_cart(residue,cxyz,chdlc)

! conversion HDLC -> Cartesian failed due to singular G matrix
    IF ( .NOT. residue%lgmatok) THEN
      tok=.false.
      residue%err_cnt = residue%err_cnt + 1000

      IF (printl>=2) WRITE (stdout,'(3X,A,I4,A,I4,/)') &
          'Conversion of residue ', residue%name, &
          ' failed , HDLC failure gauge: ', residue%err_cnt

! persistent HDLC failure - remove residue if there are no constraints
      IF (residue%err_cnt>=1990) THEN
        ! the removal of a residue is broken since the introduction of residue%at and
        ! residue %xweight. Thus stop.
        WRITE (stdout,'(A,I4,A)') &
              'Cyclic failure at residue ', residue%name, &
              ', stopping'
        call dlf_fail("Residue conversion error")

        IF (residue%ncons>0) THEN
          hdlc%interror = .TRUE.
          IF (printl>=1) WRITE (stdout,'(A,I4,A,I4)') &
              'Warning: could not remove residue', residue%name, &
              ', number of constraints: ', residue%ncons
        ELSE
          hdlc%ngroupsdrop = hdlc%ngroupsdrop + 1
          IF (printl>=2) WRITE (stdout,'(A,I4,A)') &
              'Cyclic failure - removing residue ', residue%name, &
              ' from list'
          DO i = 1,length
            hdlc%resn(residue%at(i)) = -10 ! changed from -2 to -10
          END DO
        END IF
      END IF

      ! leave xcoords for this residue unchanged if failes

! conversion HDLC -> Cartesian was successful
    ELSE
      residue%err_cnt = residue%err_cnt/2
      IF (printl>=6) WRITE (stdout,'(5X,A,I5,A,I3,/)') 'Residue ', &
          residue%name, ', HDLC failure gauge: ', residue%err_cnt

      ! check in coordinates
      idum=matrix_get(cxyz,3*residue%natom,atmp)
      do iat=1,length
        xcoords(:,residue%at(iat))=atmp((iat-1)*3+1:(iat-1)*3+3)
      end do
      !idum=matrix_get(cxyz,xcoords(:,istart:istart+length-1))

    END IF

! prepare for the next group
    ! for correct start of cartesians
    if (iphdlc <= nicore) then
       ipinner = ipinner + ndfhdlc-hdlc%nmin
    else
       ipouter = ipouter + ndfhdlc-hdlc%nmin
    end if
    idum = matrix_destroy(cxyz)
    idum = matrix_destroy(chdlc)
    call deallocate(atmp)
    hdlc%res(group) = residue 
  END DO ! (group = 1,ngroups)

! check in Cartesians
  DO iatom = 1, nat
    IF (hdlc%resn(iatom)==0) THEN
       if (micspec(iatom) == 1) then
          iphdlc = ipinner
       else
          iphdlc = ipouter
       end if
       DO m = 0, 2
          xcoords(m+1,iatom) = icoords(iphdlc+m)
       END DO
       iphdlc = iphdlc + 3
       if (micspec(iatom) == 1) then
          ipinner = iphdlc
       else
          ipouter = iphdlc
       end if
    END IF
  END DO 

  if (ipinner /= nicore + 1) then
     write(stdout,*) "ipinner, nicore=", ipinner, nicore
     call dlf_fail("Error in the transformation hdlc_itox (inner)")
  end if
  if (ipouter /= nivar + 1) then
     write(stdout,*) "ipouter, nivar=", ipouter, nivar
     call dlf_fail("Error in the transformation hdlc_itox (outer)")
  end if

! if geometry died, save err_cnt and destroy all HDLC residues and restart
! tok is returned. It is the responsibility of the calling routine to call
! dlf_hdlc_reset if the HDLCs should really be destroyed.
!!$  IF ( .NOT. tok) THEN
!!$    CALL hdlc_destroy_all(.TRUE.,hdlc%err_cnt)
!!$    hdlc%ngroups = hdlc%ngroups - ngroupsdrop
!!$
!!$! if a residue has been removed, its number is set to -10 to prevent checkin
!!$    DO iatom = 1, nat
!!$      IF (hdlc%resn(iatom)==-10) hdlc%resn(iatom) = -1 ! this has to be checked ...
!!$    END DO
!!$    IF (interror) THEN
!!$      call dlf_fail("Giving up on HDLC due to a residue that does not &
!!$          &converge and contains constraints")
!!$    END IF
!!$  END IF
end subroutine dlf_hdlc_itox
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* hdlc/dlf_hdlc_reset
!!
!! FUNCTION
!!
!! Reset the internal coordinate definition. Possibly remove one or more
!! residues. Should be called after a hdlc coordinate breakdown.
!!
!! SYNOPSIS
subroutine dlf_hdlc_reset
!! SOURCE
  use dlf_global, only:glob
  use dlfhdlc_hdlclib, only: hdlc, hdlc_destroy_all
  implicit none
  integer       :: iatom
! **********************************************************************
  if(.not.hdlc%tinit) &
      call dlf_fail("HDLC not initialised in dlf_hdlc_reset")
  CALL hdlc_destroy_all(.TRUE.,size(hdlc%err_cnt),hdlc%err_cnt)
! if a residue has been removed, its number is set to -10 to prevent checkin
  DO iatom = 1, glob%nat ! <--- this is dangerous - improve!
    IF (hdlc%resn(iatom)==-10) hdlc%resn(iatom) = 0 ! this has to be checked ...
  END DO
  hdlc%ngroups = hdlc%ngroups - hdlc%ngroupsdrop
  hdlc%ngroupsdrop=0

  ! commented out as it leads to termination after the first breakdown
  !if (hdlc%ngroups==0.and.hdlc%internal) then
  !  call dlf_fail("Internal coordinates can not be restored. Use cartesians instead")
  !end if

  IF (hdlc%interror) THEN
    call dlf_fail("Giving up on HDLC due to a residue that does not &
        &converge and contains constraints")
  END IF
end subroutine dlf_hdlc_reset
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* hdlc/dlf_hdlc_destroy
!!
!! FUNCTION
!!
!! Destroy the HDLC object and deallocate all arrays
!!
!! SYNOPSIS
subroutine dlf_hdlc_destroy
!! SOURCE
  use dlf_parameter_module, only: ik
  use dlf_global, only: stdout
  use dlf_allocate, only: deallocate
  use dlfhdlc_hdlclib, only: hdlc, hdlc_destroy_all
  implicit none
  integer             :: fail,igroup
! **********************************************************************
  if(.not.hdlc%tinit) return ! nothing to do 

  hdlc%tinit=.false.

  if(hdlc%lhdlc) then
    CALL hdlc_destroy_all(.TRUE.,size(hdlc%err_cnt),hdlc%err_cnt)
  end if

  ! deallocate arrays of individual residues
  do igroup=1,size(hdlc%err_cnt)
    deallocate(hdlc%res(igroup)%xweight) ! pointer
    deallocate(hdlc%res(igroup)%at)      ! pointer
  end do

  ! deallocate hdlc arrays
  call deallocate(hdlc%resn)
  call deallocate(hdlc%err_cnt)
  call deallocate(hdlc%iconstr)
  call deallocate(hdlc%incon)

  ! deallocate residues - no storage check available
  ! this was previously commented out because of a bug in pgf90
  ! however not deallocating it causes problems with ifort, giving an
  ! error of array already allocated if an (h)dlc job is run twice in the
  ! same chemshell script. This code doesn't seem to cause pgf90 any 
  ! problems any more anyway (as of v9.0)
  deallocate(hdlc%res,stat=fail)
  if(fail>0) then
    call dlf_fail("Deallocation error at residues")
  end if
  
end subroutine dlf_hdlc_destroy
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_checkpoint_hdlc_write
  ! Write HDLC data to checkpoint file
  use dlfhdlc_hdlclib, only: hdlc,hdlc_wr_hdlc
  use dlf_checkpoint, only: tchkform
  implicit none
  logical :: lerr
  integer, parameter :: ifunit = 104
! **********************************************************************
  if(tchkform) then
    open(unit=ifunit,file="dlf_hdlc.chk",form="formatted")
  else
    open(unit=ifunit,file="dlf_hdlc.chk",form="unformatted")
  end if

  call hdlc_wr_hdlc(ifunit,hdlc,tchkform,lerr)

  close(ifunit)

end subroutine dlf_checkpoint_hdlc_write

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_checkpoint_hdlc_read(lerr)
  ! Read HDLC data from checkpoint file
  use dlfhdlc_hdlclib, only: hdlc,hdlc_rd_hdlc
  use dlf_checkpoint, only: tchkform
  implicit none
  logical ,intent(out) :: lerr
  integer, parameter :: ifunit = 104
! **********************************************************************
  if(tchkform) then
    open(unit=ifunit,file="dlf_hdlc.chk",form="formatted")
  else
    open(unit=ifunit,file="dlf_hdlc.chk",form="unformatted")
  end if

  call hdlc_rd_hdlc(ifunit,hdlc,tchkform,lerr)

  close(ifunit)

end subroutine dlf_checkpoint_hdlc_read

! **********************************************************************
! **                                                                  **
! **               Microiterative optimisation routines               **
! **                                                                  **
! **                          Tom Keal, 2012                          **
! **                                                                  **
! **********************************************************************
!!****h* DL-FIND/microiter
!!
!! NAME
!! microiter
!!
!! FUNCTION
!! Support routines for microiterative optimisation
!!
!! COMMENTS
!! Implemented under the HECToR dCSE project
!! "Microiterative QM/MM Optimisation for Materials Chemistry"
!! T.W. Keal, P. Sherwood, A. Walsh, A.A. Sokol and C.R.A. Catlow
!!
!! www.hector.ac.uk/cse/distributedcse/reports/chemshell02
!!
!! The microiterative minimisation algorithm is based on the original 
!! implementation for HDLCOpt:
!!
!! Johannes Kaestner, Stephan Thiel, Hans Martin Senn, Paul Sherwood
!! and Walter Thiel, J. Chem. Theory Comput. v3 p1064 (2007)
!!
!! In the DL-FIND implementation microiterative minimisation, 
!! P-RFO, dimer and NEB are supported.
!!
!! DATA
!!  $Date$
!!  $Rev$
!!  $Author$
!!  $URL$
!!  $Id$
!!
!! COPYRIGHT
!!
!!  Copyright 2012 Tom Keal (thomas.keal@stfc.ac.uk) 
!!
!!  This file is part of DL-FIND.
!!
!!  DL-FIND is free software: you can redistribute it and/or modify
!!  it under the terms of the GNU Lesser General Public License as 
!!  published by the Free Software Foundation, either version 3 of the 
!!  License, or (at your option) any later version.
!!
!!  DL-FIND is distributed in the hope that it will be useful,
!!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!!  GNU Lesser General Public License for more details.
!!
!!  You should have received a copy of the GNU Lesser General Public 
!!  License along with DL-FIND.  If not, see 
!!  <http://www.gnu.org/licenses/>.
!!
!! SOURCE
module dlf_microiter
  use dlf_parameter_module, only: rk
  type microiter_type
     integer :: varperimage ! total no. of internal coordinates per image
     integer :: coreperimage ! no. of inner region coordinates per image
     integer :: outerperimage ! no. of outer region coordinates per image
     integer :: nmicvar ! number of internal coordinates in microiterative region
     integer :: nmicimage ! number of images involved in microiterative opt
     real(rk), allocatable :: micicoords(:)
     real(rk), allocatable :: micigradient(:)
     real(rk), allocatable :: micstep(:)
     logical :: tmicoldenergy ! do we have an old energy from the current cycle
     real(rk) :: micoldenergy
     real(rk), allocatable :: micoldgradient(:)
     real(rk) :: macroenergy_conv ! save macro energy convergence test info
  end type microiter_type
  type(microiter_type), save :: microiter
end module dlf_microiter
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* microiter/dlf_microiter_init
!!
!! FUNCTION
!!
!! Initialise microiterative optimisation. Identify inner atoms, 
!! allocate arrays, etc.
!!
!! INPUTS
!!
!! none
!!
!! OUTPUTS
!! 
!! none
!!
!! SYNOPSIS
subroutine dlf_microiter_init
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob, stdout
  use dlf_microiter
  use dlf_allocate, only: allocate,deallocate
  use dlf_stat, only: stat
  implicit none
  integer :: ivar

  ! TODO should we be using glob lbfgs_mem to init?? what does hdlcopt do?

  ! Get number of internal coords in each region (per image)
  call dlf_direct_get_nivar(0, microiter%varperimage)
  call dlf_direct_get_nivar(1, microiter%coreperimage)
  call dlf_direct_get_nivar(2, microiter%outerperimage)

  if (microiter%varperimage /= microiter%coreperimage + microiter%outerperimage) then
     call dlf_fail("dlf_microiter_init: inconsistent varperimage, coreperimage, outperimage")
  end if

  ! Size of microiterative region depends on optimisation method
  select case (glob%icoord)
  case (100:199)
     ! NEB
     microiter%nmicvar = microiter%outerperimage * glob%nimage
     microiter%nmicimage = glob%nimage
     if (glob%nivar /= microiter%nmicvar + glob%nicore) then
        call dlf_fail("dlf_microiter_init: inconsistent nivar, nmicvar, nicore for NEB")
     end if
  case (200:299)
     ! Dimer 
     ! Only one set of environment coords, which correspond to the 
     ! dimer midpoint (translation step).
     microiter%nmicvar = microiter%outerperimage
     microiter%nmicimage = 1
     if (glob%nivar /= 2 * microiter%nmicvar + glob%nicore) then
        call dlf_fail("dlf_microiter_init: inconsistent nivar, nmicvar, nicore for dimer")
     end if     
  case default
     ! Microiterative minimisation, P-RFO ...
     microiter%nmicvar = microiter%outerperimage
     microiter%nmicimage = 1
     if (glob%nivar /= microiter%nmicvar + glob%nicore) then
        call dlf_fail("dlf_microiter_init: inconsistent nivar, nmicvar, nicore")
     end if
  end select
  
  ! Initialise microiterative LBFGS
  call dlf_lbfgs_select("microiter",.true.)
  call dlf_lbfgs_init(microiter%nmicvar, glob%lbfgs_mem) 
  call dlf_lbfgs_deselect

  ! Allocate microiterative arrays
  call allocate(microiter%micicoords, microiter%nmicvar)
  call allocate(microiter%micigradient, microiter%nmicvar)
  call allocate(microiter%micstep, microiter%nmicvar)
  call allocate(microiter%micoldgradient, microiter%nmicvar)
  
  ! Init statistics
  stat%miccycle = 0
  stat%tmiccycle = 0
  stat%tmicaccepted = 0

end subroutine dlf_microiter_init
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* microiter/dlf_microiter_destroy
!!
!! FUNCTION
!!
!! Initialise microiterative optimisation. Identify inner atoms, 
!! allocate arrays, etc.
!!
!! INPUTS
!!
!! none
!!
!! OUTPUTS
!! 
!! none
!!
!! SYNOPSIS
subroutine dlf_microiter_destroy
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob, stdout
  use dlf_microiter
  use dlf_allocate, only: allocate,deallocate
  implicit none
  logical :: exists

  call dlf_lbfgs_exists("microiter", exists)
  if (exists) then
     call dlf_lbfgs_select("microiter",.false.)
     call dlf_lbfgs_destroy
     call dlf_lbfgs_deselect
  end if

  ! Deallocate microiterative arrays
  if (allocated(microiter%micicoords)) call deallocate(microiter%micicoords)
  if (allocated(microiter%micigradient)) call deallocate(microiter%micigradient)
  if (allocated(microiter%micstep)) call deallocate(microiter%micstep)
  if (allocated(microiter%micoldgradient)) call deallocate(microiter%micoldgradient)

end subroutine dlf_microiter_destroy
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* microiter/dlf_microiter_check_macrostep
!!
!! FUNCTION
!!
!! For macroiterative steps, only move the inner region
!!
!! INPUTS
!!
!! none
!!
!! OUTPUTS
!! 
!! none
!!
!! SYNOPSIS
subroutine dlf_microiter_check_macrostep
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob, stdout
  use dlf_microiter
  implicit none
  integer :: ivar, iglobstart, iglobend
  
  do ivar = 1, microiter%nmicimage
     iglobstart =  ((ivar - 1) * microiter%varperimage) + microiter%coreperimage + 1
     iglobend = ivar * microiter%varperimage
     glob%step(iglobstart:iglobend) = 0.0d0
  end do

end subroutine dlf_microiter_check_macrostep
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* microiter/dlf_microiter_reset_macrostep
!!
!! FUNCTION
!!
!! If macroiterative step is rejected, inner region step should be halved,
!! while outer region should be set back to the original coordinates
!!
!! INPUTS
!!
!! none
!!
!! OUTPUTS
!! 
!! none
!!
!! SYNOPSIS
subroutine dlf_microiter_reset_macrostep
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob, stdout
  use dlf_microiter
  implicit none
  integer :: ivar, iglobstart, iglobend
  
  do ivar = 1, microiter%nmicimage
     ! Inner region: halve step
     iglobstart = ((ivar - 1) * microiter%varperimage) + 1
     iglobend = ((ivar - 1) * microiter%varperimage) + microiter%coreperimage
     glob%step(iglobstart:iglobend) = glob%step(iglobstart:iglobend) * 0.5d0
     glob%icoords(iglobstart:iglobend) = glob%icoords(iglobstart:iglobend) - &
          glob%step(iglobstart:iglobend)     
     ! Outer region: reset step completely
     iglobstart = iglobend + 1
     iglobend = ivar * microiter%varperimage
     glob%icoords(iglobstart:iglobend) = glob%icoords(iglobstart:iglobend) - &
          glob%step(iglobstart:iglobend) 
     glob%step(iglobstart:iglobend) = 0.0d0
  end do

end subroutine dlf_microiter_reset_macrostep
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* microiter/dlf_microiter_enter
!!
!! FUNCTION
!!
!! Enter the microiterative optimisation loop
!!
!! INPUTS
!!
!! none
!!
!! OUTPUTS
!! 
!! none
!!
!! SYNOPSIS
subroutine dlf_microiter_enter
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob, stdout
  use dlf_microiter
  use dlf_stat, only: stat
  implicit none

  call dlf_lbfgs_select("microiter",.false.)
  ! Reset microiter memory
  call dlf_lbfgs_restart

  microiter%micstep(:) = 0.0d0

  ! Microiteration mode
  glob%imicroiter = 2

  ! Reset microiterative cycle counter
  stat%miccycle = 0

  ! We do not yet have an old energy from this cycle
  microiter%tmicoldenergy = .false.
  microiter%micoldenergy = 0.0d0
  ! Save macro energy convergence test information
  microiter%macroenergy_conv = glob%oldenergy_conv

end subroutine dlf_microiter_enter
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* microiter/dlf_microiter_itomic
!!
!! FUNCTION
!!
!! Set up microiterative arrays
!!
!! INPUTS
!!
!! glob%icoords
!! glob%igradient
!!
!! OUTPUTS
!! 
!! microiter%micicoords
!! microiter%micigradient
!!
!! SYNOPSIS
subroutine dlf_microiter_itomic
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob, stdout
  use dlf_microiter
  implicit none
  integer :: ivar, imicstart, imicend, iglobstart, iglobend

  ! Copy outer region data to microiterative arrays
  do ivar = 1, microiter%nmicimage
     imicstart = ((ivar - 1) * microiter%outerperimage) + 1
     imicend = ivar * microiter%outerperimage
     iglobstart = ((ivar - 1) * microiter%varperimage) + microiter%coreperimage + 1
     iglobend = ivar * microiter%varperimage
     microiter%micicoords(imicstart:imicend) = glob%icoords(iglobstart:iglobend)
     microiter%micigradient(imicstart:imicend) = glob%igradient(iglobstart:iglobend)
  end do
  
  !write(*,*) "MICICOORDS"
  !write(*,*) microiter%micicoords
  !write(*,*) "***"
  !write(*,*) "MICIGRADIENT"
  !write(*,*) microiter%micigradient
  !write(*,*) "***"

end subroutine dlf_microiter_itomic
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* microiter/dlf_microiter_formstep
!!
!! FUNCTION
!!
!! Microiterative formstep
!!
!! INPUTS
!!
!! none
!!
!! OUTPUTS
!! 
!! none
!!
!! SYNOPSIS
subroutine dlf_microiter_formstep
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob, stdout
  use dlf_microiter
  implicit none

  call dlf_lbfgs_step(microiter%micicoords, microiter%micigradient, &
       microiter%micstep)

end subroutine dlf_microiter_formstep
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* microiter/dlf_microiter_scalestep
!!
!! FUNCTION
!!
!! Scale microiterative step
!!
!! INPUTS
!!
!! none
!!
!! OUTPUTS
!! 
!! none
!!
!! SYNOPSIS
subroutine dlf_microiter_scalestep
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob, stdout
  use dlf_microiter
  implicit none
  integer :: ivar, icount

  call dlf_scalestep_microiter(microiter%nmicvar, microiter%micstep)

  ! Following dlf_scalestep
  microiter%micoldgradient = microiter%micigradient
  
end subroutine dlf_microiter_scalestep
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* microiter/dlf_microiter_step
!!
!! FUNCTION
!!
!! Carry out microiterative step
!!
!! INPUTS
!!
!! none
!!
!! OUTPUTS
!! 
!! none
!!
!! SYNOPSIS
subroutine dlf_microiter_step
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob, stdout
  use dlf_microiter
  use dlf_stat, only: stat
  implicit none
  integer :: ivar, imicstart, imicend, iglobstart, iglobend

  ! Update global coordinates with microiterative step
  do ivar = 1, microiter%nmicimage
     imicstart = ((ivar - 1) * microiter%outerperimage) + 1
     imicend = ivar * microiter%outerperimage
     iglobstart =  ((ivar - 1) * microiter%varperimage) + microiter%coreperimage + 1
     iglobend = ivar * microiter%varperimage
     glob%icoords(iglobstart:iglobend) = glob%icoords(iglobstart:iglobend) + &
          microiter%micstep(imicstart:imicend)
     ! This is for eventual reset of macrostep if not accepted
     glob%step(iglobstart:iglobend) = glob%step(iglobstart:iglobend) + &
          microiter%micstep(imicstart:imicend)
  end do

  ! Store old energy
  microiter%micoldenergy = glob%energy
  microiter%tmicoldenergy = .true.
  
end subroutine dlf_microiter_step
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* microiter/dlf_microiter_test_acceptance
!!
!! FUNCTION
!!
!! Test acceptance of microiterative step
!!
!! INPUTS
!!
!! microiter%micstep
!!
!! OUTPUTS
!! 
!! microiter%micstep
!!
!! SYNOPSIS
subroutine dlf_microiter_test_acceptance(tswitch)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob, stdout
  use dlf_microiter
  implicit none
  logical, intent(out) :: tswitch
  integer :: ivar, imicstart, imicend, iglobstart, iglobend

  call test_acceptance_microiter(microiter%nmicvar, glob%energy, &
       microiter%micigradient, microiter%micoldgradient, &
       microiter%tmicoldenergy, &
       microiter%micoldenergy, microiter%micstep, microiter%micicoords, &
       glob%taccepted, tswitch)

  ! Update glob%icoords if rejected
  if (.not. glob%taccepted) then
     do ivar = 1, microiter%nmicimage
        imicstart = ((ivar - 1) * microiter%outerperimage) + 1
        imicend = ivar * microiter%outerperimage
        iglobstart =  ((ivar - 1) * microiter%varperimage) + microiter%coreperimage + 1
        iglobend = ivar * microiter%varperimage
        glob%icoords(iglobstart:iglobend) = glob%icoords(iglobstart:iglobend) - &
             microiter%micstep(imicstart:imicend)
        ! This is for eventual reset of macrostep if not accepted
        glob%step(iglobstart:iglobend) = glob%step(iglobstart:iglobend) - &
             microiter%micstep(imicstart:imicend)        
     end do
  end if

  ! Restore macro energy if switching
  if (tswitch) then
     glob%toldenergy_conv = .true.
     glob%oldenergy_conv = microiter%macroenergy_conv     
  end if

end subroutine dlf_microiter_test_acceptance
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* microiter/dlf_microiter_convergence
!!
!! FUNCTION
!!
!! Check if microiterations have converged
!!
!! INPUTS
!!
!! none
!!
!! OUTPUTS
!! 
!! tconv
!!
!! SYNOPSIS
subroutine dlf_microiter_convergence(tconv)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob, stdout
  use dlf_microiter
  use dlf_stat, only: stat
  implicit none
  logical, intent(out) :: tconv

  call convergence_set_info("of microiterations", microiter%nmicvar, &
       glob%energy, microiter%micigradient, microiter%micstep)
  
  ! No energy/step on first microiter cycle
  if (stat%miccycle == 1) glob%toldenergy_conv = .false.
  
  call convergence_test(stat%miccycle, .true., tconv)

  ! Reset to macro old energy for macro step
  if (tconv) then
     glob%toldenergy_conv = .true.
     glob%oldenergy_conv = microiter%macroenergy_conv
  end if
  
end subroutine dlf_microiter_convergence
!!****

! Pass command-line arguments from Fortran to C

!  Copyright (C) 2017 The authors of Py-ChemShell
!
!  This file is part of Py-ChemShell.
!
!  Py-ChemShell is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as
!  published by the Free Software Foundation, either version 3 of the
!  License, or (at your option) any later version.
!
!  Py-ChemShell is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with Py-ChemShell.  If not, see
!  <http://www.gnu.org/licenses/>.

subroutine f_iargc(num) bind(c, name="f_iargc")

    use iso_c_binding

    implicit none

    integer(c_int), intent(out) :: num
    num = command_argument_count()
    ! Argument 0 is counted in argc
    num = num + 1

endsubroutine f_iargc
integer(c_int) function getNumArgs() result(argc) bind(c, name="chemsh_f_get_argc")

    use iso_c_binding

    implicit none

    argc = command_argument_count() + 1

endfunction getNumArgs
subroutine getArgs(iarg, maxlen, arglen, c_arg) bind(c, name="chemsh_f_get_argv")

    use iso_c_binding

    implicit none

    integer(c_int)   , intent(in)  :: iarg
    integer(c_int)   , intent(in)  :: maxlen
    integer(c_int)   , intent(out) :: arglen
    character(c_char), intent(out) :: c_arg(maxlen)

    integer                        :: i, f_iarg, f_arglen
    character(len=maxlen)          :: f_arg
  
    f_iarg = iarg
    call get_command_argument(f_iarg, f_arg, f_arglen)
    arglen = f_arglen

    do i = 1, arglen
        c_arg(i) = f_arg(i:i)
    enddo
    ! c_arg(i + 1) = c_null_char

endsubroutine getArgs

! this is a wrapper function to call C. Yong's DL_FIELD and avoid the generic C function name "main()"
! you.lu@stfc.ac.uk
! May 2018

integer(c_int) function dl_field_main() bind(c) result(ierror)

    use iso_c_binding

    write(*,*)
    write(*,*) ">>> DL_FIELD is not available in this ChemShell build"
    write(*,*)

    ierror = 0

endfunction

!  Copyright (C) 2017 The authors of Py-ChemShell
!
!  This file is part of Py-ChemShell.
!
!  Py-ChemShell is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as
!  published by the Free Software Foundation, either version 3 of the
!  License, or (at your option) any later version.
!
!  Py-ChemShell is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with Py-ChemShell.  If not, see
!  <http://www.gnu.org/licenses/>.

! Replace CP2K's main program (in CP2K/src/start/cp2k.F)
! with a ChemShell-specific startup routine
! YL 21/02/2021: upgraded to support v8.1
! TWK 10/10/2022: modified file handling to support v2022.1

subroutine cp2k(input, output, initialise, is_root, communicator)

!    use ChemShellParallelModule, only : chemsh_parallel
!    use omp_lib            , only : omp_set_num_threads
!    use cp2k_info          , only : cp2k_flags
    use cp2k_runs          , only : run_input
    use f77_interface      , only : finalize_cp2k, init_cp2k
    use input_cp2k         , only : create_cp2k_root_section
    use input_cp2k_read    , only : empty_initial_variables
    use input_section_types, only : section_release, section_type
    use kinds              , only : default_path_length
    use cp_files           , only : open_file, close_file, get_unit_number
!    use machine            , only : default_output_unit
!    use message_passing    , only : mp_comm_world
!    use timings            , only : add_timer_env
! YL 09/01/2020: a local copy of the original source file
#include "cp2k_base_uses.f90"

    implicit none
 
    character(len=*), intent(in)         :: input
    character(len=*), intent(in)         :: output
    logical         , intent(in)         :: initialise
    logical         , intent(in)         :: is_root
    integer(kind=4) , intent(in)         :: communicator
 
    character(len=default_path_length)   :: input_file_name, output_file_name
    integer                              :: output_unit
    integer                              :: ierror, linput, loutput, ifunit
    type(section_type), pointer          :: input_declaration

    ! set default behaviour for the command line switches
    input_file_name             = repeat(' ', default_path_length)
    output_file_name            = repeat(' ', default_path_length)
    linput                      = len(trim(input))
    loutput                     = len(trim(output))
    input_file_name (1:linput)  = input (1:linput)
    output_file_name(1:loutput) = output(1:loutput)
    call flush(6)
 
    if(initialise) then
        if(is_root) then
            write(*, '(/A/)') " ChemShell/CP2K: initialising..."
            call flush(6)
        endif
        call init_cp2k(.false., ierror)
    endif
 
    ! create a section instance
    nullify(input_declaration)
    call create_cp2k_root_section(input_declaration)
    call flush(6)

    ! run via input file
    if(is_root) then
        ifunit = get_unit_number(output_file_name)
        ! TWK 10/10/2022 CP2K no longer opens the output file in run_input,
        ! so we do it here
        call open_file(file_name=output_file_name, file_status="UNKNOWN", &
            file_action="WRITE", file_position="APPEND", skip_get_unit_number=.TRUE., &
            unit_number=ifunit)
    end if
    if(is_root) then
        write(*, '(/A,A,A/)') " ChemShell/CP2K: running input file ", trim(input_file_name), "..."
        call flush(6)
    endif
    call run_input(input_declaration, input_file_name, output_file_name, empty_initial_variables, communicator)
    call flush(6)

    ! YL 03/03/2021: because we archive the output file at every cycle of geometry
    !                geometry optimisation or MD simulation to keep each single-
    !                point calculation separate, each time we have to close the file unit
    !                which is not closed by the run_input() function (CP2K isn't designed
    !                to work this way); it looks safe to use the root process to close it
    !                (and get the unit number) but we can't get the local MPI environment
    !                instance para_env and its I/O node para_env%ionode; in fact it works
    !                OK without closing the output file if compiled with gfortran, but
    !                with ifort it won't work
    if(is_root) then
        call close_file(ifunit)
        call flush(6)
    endif

    ! clear the section instance
    call section_release(input_declaration)
    call flush(6)
 
    ! YL 01/03/2021: we don't finailse the CP2K instance for now because knowing
    !                when to do it needs an extra argument to be passed in
!    call finalize_cp2k(finalize_mpi=.false., ierror=ierror)
!    cpassert(ierror == 0)

endsubroutine

!!****h* formstep/lbfgs
!!
!! NAME
!! L-BFGS
!!
!! FUNCTION
!! Optimisation algorithms: determine a search direction. 
!!
!!
!!       LIMITED MEMORY BFGS METHOD FOR LARGE SCALE OPTIMIZATION
!!                         JORGE NOCEDAL
!!                       *** July 1990 ***
!!
!!
!!    This subroutine solves the unconstrained minimization problem
!!
!!                     min F(x),    x= (x1,x2,...,xN),
!!
!!     using the limited memory BFGS method. The routine is especially
!!     effective on problems involving a large number of variables. In
!!     a typical iteration of this method an approximation Hk to the
!!     inverse of the Hessian is obtained by applying M BFGS updates to
!!     a diagonal matrix Hk0, using information from the previous M steps.
!!     The user specifies the number M, which determines the amount of
!!     storage required by the routine. 
!!     The algorithm is described in "On the limited memory BFGS method
!!     for large scale optimization", by D. Liu and J. Nocedal,
!!     Mathematical Programming B 45 (1989) 503-528.
!!
!!    M (Nmem) is an INTEGER variable that must be set by the user to
!!            the number of corrections used in the BFGS update. It
!!            is not altered by the routine. Values of M less than 3 are
!!            not recommended; large values of M will result in excessive
!!            computing time. 3<= M <=7 is recommended. Restriction: M>0.
!!
!! An f77 version of this file was originally obtained from
!! http://www.ece.northwestern.edu/~nocedal/lbfgs.html
!! Condition for Use: This software is freely available for educational
!! or commercial purposes. We expect that all publications describing 
!! work using this software quote at least one of the references:
!!
!! J. Nocedal. Updating Quasi-Newton Matrices with Limited Storage (1980),
!! Mathematics of Computation 35, pp. 773-782.
!!
!! D.C. Liu and J. Nocedal. On the Limited Memory Method for Large Scale
!! Optimization (1989), Mathematical Programming B, 45, 3, pp. 503-528.
!!
!! For normal use in one instance, use dlf_lbfgs_init, _step, and _destroy. 
!! To restart the optimiser, use dlf_lbfgs_restart.
!!
!! If two overlapping optimisations should use L-BFGS, the module can be started
!! in more instances: use dlf_lbfgs_select to select an instance. Always the current
!! instance will be affected by dlf_lbfgs_step, dlf_lbfgs_restart and dlf_lbfgs_destroy. Use 
!! dlf_lbfgs_deselect to select the main instance (first instance). To invoke a new instance, 
!! use dlf_lbfgs_deselect("newname",.true.) and then dlf_lbfgs_init.
!!
!!**********************************************************************

!! DATA
!! $Date$
!! $Rev$
!! $Author$
!! $URL$
!! $Id$
!!
!! COPYRIGHT
!!
!!  Copyright 2007 Johannes Kaestner (kaestner@theochem.uni-stuttgart.de),
!!  Tom Keal (thomas.keal@stfc.ac.uk)
!!
!!  This file is part of DL-FIND.
!!
!!  DL-FIND is free software: you can redistribute it and/or modify
!!  it under the terms of the GNU Lesser General Public License as 
!!  published by the Free Software Foundation, either version 3 of the 
!!  License, or (at your option) any later version.
!!
!!  DL-FIND is distributed in the hope that it will be useful,
!!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!!  GNU Lesser General Public License for more details.
!!
!!  You should have received a copy of the GNU Lesser General Public 
!!  License along with DL-FIND.  If not, see 
!!  <http://www.gnu.org/licenses/>.
!!
!!****

MODULE LBFGS_MODULE
  USE dlf_parameter_module, only: rk 
  type lbfgs_type
    integer                 :: N ! number of variables
    integer                 :: M ! number steps to remember
    REAL(RK), ALLOCATABLE   :: store(:)  ! N WORK 1 - N
    REAL(RK), ALLOCATABLE   :: store2(:) ! N old coords
    REAL(RK), ALLOCATABLE   :: rho(:)    ! M WORK N+1 - N+M
    REAL(RK), ALLOCATABLE   :: alpha(:)  ! M WORK N+M+1 - N+2M
    ! YL 22/01/2021: swapped the two dimensions because Fortran is a column-major language and
    !                the previous discontiguous way of use of the arrays incur temporary arrays
    REAL(RK), ALLOCATABLE   :: step(:,:) ! N,M WORK N+2M+1 - N+2M+NM
    REAL(RK), ALLOCATABLE   :: dgrad(:,:)! N,M WORK N+2M+NM+1 - N+2M+2NM
    logical                 :: tprecon ! is precon set (and allocated)?
    real(rk), allocatable   :: precon(:,:) ! (N,N) guess for the initial inverse hessian
                                ! full matrix, not just the diagonal. If this is used,
                                ! the algorithm gets order N^2 !
    
    integer                 :: point ! CURRENT POSITION IN THE WORK ARRAY
    INTEGER                 :: iter ! number of iteration
    logical                 :: tinit
    character(40)           :: tag
    type(lbfgs_type),pointer  :: next
  end type lbfgs_type
  type(lbfgs_type),pointer,save :: lbfgs
  type(lbfgs_type),pointer,save :: lbfgs_first
  logical, save               :: tinit=.false.
  LOGICAL,PARAMETER :: dbg=.false. ! write debug info 
  character(40),save     :: newtag="none"
END MODULE LBFGS_MODULE

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* lbfgs/dlf_lbfgs_step
!!
!! FUNCTION
!!
!! Form an L-BFGS step from the input geometry, gradient, and the history
!!
!! SYNOPSIS
SUBROUTINE dlf_lbfgs_step(x,g,step_)
!! SOURCE
  USE dlf_parameter_module, only: rk
  use dlf_global, only: stdout,printl
  USE lbfgs_module
  IMPLICIT NONE
  !
  ! Dummy arguments
  !
  REAL(RK), intent(in)    :: x(lbfgs%n) ! position (coords)
  REAL(RK), intent(in)    :: g(lbfgs%n) ! gradient
  REAL(RK), intent(out)   :: step_(lbfgs%n) ! Step
  !
  ! Local variables
  !
  REAL(RK) :: diag(lbfgs%n)
  REAL(RK) :: beta , gnorm , sq , stp , yr , ys , yy 
  INTEGER  :: bound , cp , i 
  INTEGER  :: oldpoint,ivar
  real(RK) ,external :: ddot
! **********************************************************************
  if(.not.tinit) call dlf_fail("LBFGS not initialised!")
  if(.not.lbfgs%tinit) then
    print*,"Instance of L-BFGS:",trim(lbfgs%tag)
    call dlf_fail("This instance of LBFGS not initialised!")
  end if

  if(lbfgs%iter==0) then ! first iteration, steepest descent!
    lbfgs%point = 1
    oldpoint = 1

    lbfgs%iter=1
    ! if the fist step should be smaller, include a factor here 
    step_(:) = -g(:)*0.02D0/dsqrt(sum(g**2))
    
    ! Store old gradient and coordinates
    lbfgs%store(:) = g(:)
    lbfgs%store2(:)= x(:)

    return

  end if

  ! ====================================================================
  ! All steps but first: calculate L-BFGS Step
  ! ====================================================================

  ! COMPUTE THE NEW STEP AND GRADIENT CHANGE
  lbfgs%step(:,lbfgs%point) = x(:) - lbfgs%store2(:) 
  lbfgs%dgrad(:,lbfgs%point) = g(:) - lbfgs%store(:)

  oldpoint=lbfgs%point

  ! take next point
  lbfgs%point = lbfgs%point + 1
  IF ( lbfgs%point>lbfgs%m ) lbfgs%point = 1

  lbfgs%iter = lbfgs%iter + 1

  if(dbg) print*,"@100 lbfgs%point=",lbfgs%point
  if(dbg) print*,"lbfgs%dgrad",lbfgs%dgrad
  if(dbg) print*,"lbfgs%step",lbfgs%step

  bound = lbfgs%iter - 1
  IF ( lbfgs%iter>lbfgs%m ) bound = lbfgs%m
  ys = DDOT(lbfgs%n,lbfgs%dgrad(:,oldpoint),1,lbfgs%step(:,oldpoint),1)
  yy = DDOT(lbfgs%n,lbfgs%dgrad(:,oldpoint),1,lbfgs%dgrad(:,oldpoint),1)
  diag(:) = ys/yy ! default guess for diag
  !print*,"JK precon scale factor:",ys/yy

  if(dbg) print*,"Before 200: ys,yy",ys,yy

  ! ====================================================================
  ! COMPUTE -H*G USING THE FORMULA GIVEN IN: Nocedal, J. 1980,
  ! "Updating quasi-Newton matrices with limited storage",
  ! Mathematics of Computation, Vol.24, No.151, pp. 773-782.
  ! ====================================================================
  !
  cp = lbfgs%point
  lbfgs%rho(oldpoint) = 1.D0/ys
  if(dbg) print*,"lbfgs%rho",lbfgs%rho
  if(dbg) print*,"bound",bound

  lbfgs%store(:) = -g(:)
  cp = lbfgs%point
  DO i = 1 , bound
    cp = cp - 1
    IF ( cp==0 ) cp = lbfgs%m 
    sq = DDOT(lbfgs%n,lbfgs%step(:,cp),1,lbfgs%store(:),1)
    lbfgs%alpha(cp) = lbfgs%rho(cp)*sq
    !CALL DAXPY(lbfgs%n,-lbfgs%alpha(cp),lbfgs%dgrad(:,cp),1,lbfgs%store(:),1) 
    lbfgs%store(:)=lbfgs%store(:)-lbfgs%alpha(cp)*lbfgs%dgrad(:,cp)
  END DO
  if(dbg) print*,"removed DAXPY"
  if(dbg) print*,"AFTER CALL TO DAXPY"
  !
  if(lbfgs%tprecon) then
    ! diag= lbfgs%precon * lbfgs%store manually :-(
    do ivar=1,lbfgs%n
      diag(ivar)=sum(lbfgs%precon(:,ivar)*lbfgs%store(:))
    end do
    !diag = matmul(lbfgs%precon,lbfgs%store)
    lbfgs%store(:) = diag !* ys/yy
    !lbfgs%store(:) = lbfgs%store(:)*ys/yy
  else
    lbfgs%store(:) = diag(:)*lbfgs%store(:) 
  end if
  !
  DO i = 1 , bound
    if(dbg) print*,"cp",cp
    yr = DDOT(lbfgs%n,lbfgs%dgrad(:,cp),1,lbfgs%store(:),1)
    beta = lbfgs%rho(cp)*yr
    beta = lbfgs%alpha(cp) - beta
    !CALL DAXPY(lbfgs%n,beta,lbfgs%step(:,cp),1,lbfgs%store(:),1)
    lbfgs%store(:)=lbfgs%store(:)+beta*lbfgs%step(:,cp)
    cp = cp + 1
    IF ( cp>lbfgs%m ) cp = 1
  END DO
  !
  ! STORE THE NEW SEARCH DIRECTION
  lbfgs%step(:,lbfgs%point) = lbfgs%store(:)

  DO i = 1 , lbfgs%n
    lbfgs%store(i) = g(i)
  END DO

  stp = 1.D0

  ! ====================================================================
  ! check that function is descending
  ! ====================================================================
  yr= ddot (lbfgs%n,lbfgs%step(:,lbfgs%point),1,g(:),1)
  if(yr>0.D0) then
    if(printl>=4) write(stdout,*) "Inverting BFGS direction"
    stp=-stp
  end if

  if(dbg) then
    print*,"stp",stp
    print*,"lbfgs%step(:,:)",lbfgs%step(:,:)
    print*,"lbfgs%point",lbfgs%point
    print*,"lbfgs%step(:,lbfgs%point)",lbfgs%step(:,lbfgs%point)
  end if

  ! set step (return value)
  step_(:)=stp*lbfgs%step(:,lbfgs%point)
  
  ! Store old gradient and coordinates
  lbfgs%store(:) = g(:)
  lbfgs%store2(:)= x(:)

END SUBROUTINE DLF_LBFGS_STEP
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* lbfgs/dlf_lbfgs_restart
!!
!! FUNCTION
!!
!! Restart the L-BFGS algorithm, reset the memory
!!
!! SYNOPSIS
subroutine dlf_lbfgs_restart
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: stdout, printl
  USE lbfgs_module
  implicit none
  ! **********************************************************************
  if(.not.tinit) call dlf_fail("LBFGS not initialised!")
  if(.not.lbfgs%tinit) then
    print*,"Instance of L-BFGS:",trim(lbfgs%tag)
    call dlf_fail("This instance of LBFGS not initialised!")
  end if

  if(printl>=4) then
    if(trim(lbfgs%tag)=="main") then
      write(stdout,'("Restarting L-BFGS optimiser")')
    else
      write(stdout,'("Restarting L-BFGS optimiser, instance: ",a)') &
          trim(lbfgs%tag)
    end if
  end if
  lbfgs%iter=0
end subroutine dlf_lbfgs_restart
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* lbfgs/dlf_lbfgs_select
!!
!! FUNCTION
!!
!! Select an instance of L-BFGS 
!!
!! To be called before initialisation of new instances, but not before
!! the first instance, which is automaticall called "main".
!!
!! SYNOPSIS
subroutine dlf_lbfgs_select(tag,newinstance)
!! SOURCE
  USE lbfgs_module
  implicit none
  character(*), intent(in)  :: tag
  logical     , intent(in)  :: newinstance
  ! **********************************************************************
  if(.not.tinit) then
    !call dlf_fail("LBFGS not initialised in lbfgs_select!")
    call dlf_lbfgs_init(1,1) ! initialise a dummy first instance
    lbfgs%tinit=.false.
  end if
    

  ! try to selcet instance with %tag=tag
  lbfgs=>lbfgs_first
  do while (associated(lbfgs%next))
    if(trim(lbfgs%tag)==trim(tag)) exit
    lbfgs=>lbfgs%next
  end do

  if(newinstance) then
    if(trim(lbfgs%tag)==trim(tag)) then 
      print*,"Error, instance ",trim(tag)," already exists and selected &
          &with flag 'new'"
      call dlf_fail("Error selecting new hdlcopt instance")
    end if
    newtag=tag
    ! last instance selected, newtag contains name of new instance
  else
    if(lbfgs%tag/=tag) then
      print*,"Error, instance ",trim(tag)," does not exist"
      print*,"Existing inctances:"
      lbfgs=>lbfgs_first
      do while (associated(lbfgs))
        print*,"--",trim(lbfgs%tag),"--"
        lbfgs=>lbfgs%next
      end do
      call dlf_fail("Error selecting new hdlcopt instance")

    end if
    ! instance with %tag = tag selected
  end if
  if(dbg) PRINT*,"SELECTED -",trim(tag),"-"
end subroutine dlf_lbfgs_select
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* lbfgs/dlf_lbfgs_deselect
!!
!! FUNCTION
!!
!! Select first instance of L-BFGS 
!!
!! SYNOPSIS
subroutine dlf_lbfgs_deselect
!! SOURCE
  USE lbfgs_module
  implicit none
  ! **********************************************************************
  ! do nothing in case lbfgs does not exist
  if(.not.tinit) return !call dlf_fail("LBFGS not initialised!")
  call dlf_lbfgs_select("main",.false.)
  newtag="main"
end subroutine dlf_lbfgs_deselect
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* lbfgs/dlf_lbfgs_exists
!!
!! FUNCTION
!!
!! Find out if an instance with a specified tag is initialised
!!
!! SYNOPSIS
subroutine dlf_lbfgs_exists(tag,exists)
!! SOURCE
  USE lbfgs_module
  implicit none
  character(*),   intent(in)  :: tag
  logical     ,   intent(out) :: exists
  type(lbfgs_type),pointer    :: lbfgs_search
  ! **********************************************************************
  if(.not.tinit) then
    exists=.false.
    return
  end if

  lbfgs_search=>lbfgs_first
  exists=.false.
  do while (associated(lbfgs_search))
    if(trim(lbfgs_search%tag)==trim(tag)) then
      if(lbfgs_search%tinit) then
        exists=.true.
        return
      end if
    end if
    lbfgs_search => lbfgs_search%next
  end do
end subroutine dlf_lbfgs_exists
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* lbfgs/dlf_lbfgs_init
!!
!! FUNCTION
!!
!! Initialise the L-BFGS routines, allocate memory
!!
!! SYNOPSIS
subroutine dlf_lbfgs_init(nvar,nmem)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: stderr
  USE lbfgs_module
  use dlf_allocate, only: allocate, deallocate
  implicit none
  integer,  intent(in)    :: Nvar ! number of variables
  integer,  intent(in)    :: Nmem ! number steps to remember
  ! **********************************************************************
  if(tinit) then
    ! this is initialisation of a new (not first) instance

    ! trap initialisation of "main" if another instance is allready there
    if(trim(newtag)=="main") then
      if(trim(lbfgs%tag)/="main".or.lbfgs%n/=1) then
        call dlf_fail("L-BFGS main instance is allready initialised")
      end if
      ! deallocate 
      call deallocate(lbfgs%store)
      call deallocate(lbfgs%store2)
      call deallocate(lbfgs%rho)
      call deallocate(lbfgs%alpha)
      call deallocate(lbfgs%step)
      call deallocate(lbfgs%dgrad)
      
    else

      ! lbfgs should now point to the last existing instance
      if(dbg) print*,"Current lbfgs instance: ",trim(lbfgs%tag)
      
      ! check that no instance with tag=newtag exists
      lbfgs=>lbfgs_first
      do while (associated(lbfgs%next))
        lbfgs=>lbfgs%next
        if(trim(lbfgs%tag)==trim(newtag)) then
          print*,"Instance with name ",trim(newtag)," already initialised"
          call dlf_fail("Instance with name already initialised")
        end if
      end do
      
      allocate(lbfgs%next)
      lbfgs=>lbfgs%next
      nullify(lbfgs%next)
      
    end if ! (trim(newtag)=="main")

  else
    ! this is the initialisation of the first instance
    tinit=.true.
    newtag="main"
    if(associated(lbfgs)) call dlf_fail("This instance of LBFGS has already been initialised")
    ! allocate the lbfgs pointer
    allocate(lbfgs)

    nullify(lbfgs%next)
    lbfgs_first => lbfgs

  end if


  lbfgs%tag=newtag
  lbfgs%tinit=.true.

  if(dbg) print*,"Allocating ",trim(lbfgs%tag)
  lbfgs%n=nvar
  lbfgs%m=nmem
  lbfgs%tprecon=.false.
  if(lbfgs%n<=0) call dlf_fail("nvar in L-BFGS has to be > 0")
  if(lbfgs%m<=0) call dlf_fail("Nmem in L-BFGS has to be > 0")

  ! allocate memory
  call allocate(lbfgs%store,LBFGS%N)
  call allocate(lbfgs%store2,LBFGS%N)
  call allocate(lbfgs%rho,LBFGS%M)
  call allocate(lbfgs%alpha,LBFGS%M)
  call allocate(lbfgs%step,LBFGS%N,LBFGS%M)
  call allocate(lbfgs%dgrad,LBFGS%N,LBFGS%M)

  ! variables to set at the beginning
  lbfgs%iter = 0

  ! initialise (mainly to avoid NaNs in checkpointing)
  lbfgs%store(:)=0.D0
  lbfgs%store2(:)=0.D0
  lbfgs%rho(:)=0.D0
  lbfgs%alpha(:)=0.D0
  lbfgs%step(:,:)=0.D0
  lbfgs%dgrad(:,:)=0.D0

end subroutine dlf_lbfgs_init
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* lbfgs/dlf_lbfgs_destroy
!!
!! FUNCTION
!!
!! Deallocate memory
!!
!! SYNOPSIS
subroutine dlf_lbfgs_destroy
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: stderr
  USE lbfgs_module
  use dlf_allocate, only: deallocate
  implicit none
  logical         :: allgone
  ! **********************************************************************
  ! Only need to deallocate if LBFGS has been initialised
  if(.not.tinit) return

  !deallocate memory of the present instance
  call deallocate(lbfgs%store)
  call deallocate(lbfgs%store2)
  call deallocate(lbfgs%rho)
  call deallocate(lbfgs%alpha)
  call deallocate(lbfgs%step)
  call deallocate(lbfgs%dgrad)
  if(lbfgs%tprecon) then
    deallocate(lbfgs%precon)
  end if
  lbfgs%tinit=.false.
!print*,"Destroying ",trim(lbfgs%tag)

  ! check if all instances are deleted
  allgone=.true.
  lbfgs=>lbfgs_first
  do while (associated(lbfgs))
    if(lbfgs%tinit) then
      allgone=.false.
      exit
    end if
    lbfgs => lbfgs%next
  end do
  ! this may leave lbfgs pointing nowhere. This is fine as one cannot expect
  ! it to point somewhere usefull after dlf_lbfgs_destroy


  if(allgone) then

    ! if only a dummy has been initialised for the instance MAIN, it may still be
    ! allocated, even though %tinit would be false. Deallocate in this case
    lbfgs=>lbfgs_first
    if(allocated(lbfgs%store)) call deallocate(lbfgs%store)
    if(allocated(lbfgs%store2)) call deallocate(lbfgs%store2)
    if(allocated(lbfgs%rho)) call deallocate(lbfgs%rho)
    if(allocated(lbfgs%alpha)) call deallocate(lbfgs%alpha)
    if(allocated(lbfgs%step)) call deallocate(lbfgs%step)
    if(allocated(lbfgs%dgrad)) call deallocate(lbfgs%dgrad)

    ! deallocate everything
    tinit=.false.
    lbfgs=>lbfgs_first
    do while (associated(lbfgs%next))
      lbfgs_first => lbfgs
      lbfgs => lbfgs%next
!print*,"Finally deallocating ",trim(lbfgs_first%tag)
      deallocate(lbfgs_first)
    end do
!print*,"Finally deallocating ",trim(lbfgs%tag)
    deallocate(lbfgs)
    nullify(lbfgs)
    nullify(lbfgs_first)
  end if

end subroutine dlf_lbfgs_destroy
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* lbfgs/dlf_lbfgs_precon
!!
!! FUNCTION
!!
!! Supply a precondition matrix, an estimate of the inverse Hessian
!! to the module
!! The space for the matrix is only allocated here.
!!
!! SYNOPSIS
subroutine dlf_lbfgs_precon(precon)
!! SOURCE
  use dlf_parameter_module, only: rk
  !use dlf_global, only: glob,stderr
  USE lbfgs_module
  use dlf_allocate, only: allocate
  implicit none
  real(rk)  ,intent(in):: precon(lbfgs%N,lbfgs%N)
  ! **********************************************************************
  if(.not.tinit) call dlf_fail("LBFGS not initialised in lbfgs_precon!")
  if(.not.lbfgs%tinit) then
    print*,"Instance of L-BFGS:",trim(lbfgs%tag)
    call dlf_fail("This instance of LBFGS not initialised!")
  end if
  if(.not.lbfgs%tprecon) then
    lbfgs%tprecon=.true.
    call allocate(lbfgs%precon, LBFGS%N, LBFGS%N)
  end if
  lbfgs%precon=precon
end subroutine dlf_lbfgs_precon
!!****

!   ----------------------------------------------------------
!   local routine, only to be used if no external ddot is
!   available (which is not recommended!)
FUNCTION DDOT_internal(n,dx,incx,dy,incy)
  USE dlf_parameter_module, only: rk                        
  IMPLICIT NONE
  !
  ! Dummy arguments
  !
  INTEGER :: incx , incy , n
  REAL(RK) :: DDOT_internal
  REAL(RK) , DIMENSION(n) :: dx , dy
  INTENT (IN) dx , dy , incx , incy , n
  !
  ! Local variables
  !
  REAL(RK) :: dtemp
  INTEGER :: i , ix , iy , m , mp1
  !
  !     forms the dot product of two vectors.
  !     uses unrolled loops for increments equal to one.
  !     jack dongarra, linpack, 3/11/78.
  !
  !
  DDOT_internal = 0.0D0
  dtemp = 0.0D0
  IF ( n<=0 ) RETURN
  IF ( incx==1 .AND. incy==1 ) THEN
    !
    !        code for both increments equal to 1
    !
    !
    !        clean-up loop
    !
    m = MOD(n,5)
    IF ( m/=0 ) THEN
      DO i = 1 , m
        dtemp = dtemp + dx(i)*dy(i)
      END DO
      IF ( n<5 ) THEN
        DDOT_internal = dtemp
        return
      END IF
    END IF
    mp1 = m + 1
    DO i = mp1 , n , 5
      dtemp = dtemp + dx(i)*dy(i) + dx(i+1)*dy(i+1) + dx(i+2)     &
          & *dy(i+2) + dx(i+3)*dy(i+3) + dx(i+4)*dy(i+4)
    END DO
    DDOT_internal = dtemp
  ELSE
    !
    !        code for unequal increments or equal increments
    !          not equal to 1
    !
    ix = 1
    iy = 1
    IF ( incx<0 ) ix = (-n+1)*incx + 1
    IF ( incy<0 ) iy = (-n+1)*incy + 1
    DO i = 1 , n
      dtemp = dtemp + dx(ix)*dy(iy)
      ix = ix + incx
      iy = iy + incy
    END DO
    DDOT_internal = dtemp
    RETURN
  END IF
END FUNCTION DDOT_INTERNAL

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_checkpoint_lbfgs_write
  use dlf_parameter_module, only: rk
  use dlf_global, only: stderr
  USE lbfgs_module
  use dlf_checkpoint, only: tchkform,write_separator
  implicit none
  type(lbfgs_type),pointer :: lbfgs_current
  ! YL 15/12/2020: we need avoid using file units ifunit, 101, or 102 to make Cray compiler happy
  !                see pp 141: http://103.251.184.12/wp-content/uploads/2018/01/Cray_Fortran_Reference_Manual_S-3901_86.pdf
  !                The values of INPUT_UNIT, OUTPUT_UNIT, and ERROR_UNIT defined in the ISO_Fortran_env module are
  !                ifunit, 101, and 102, respectively. These three unit numbers are reserved and may not be used for other purposes.
  !                The files connected to these units are the same files used by the companion C processor for standard input
  !                (stdin), output (stdout), and error (stderr). An asterisk (*) specified as the unit for a READ statement specifies unit
  !                ifunit. An asterisk specified as the unit for a WRITE statement, and the unit for PRINT statements is unit 101. All
  !                positive default integer values are available for use as unit numbers.
  integer, parameter :: ifunit = 104
  ! **********************************************************************
  if(.not.tinit) call dlf_fail("LBFGS not initialised! (in checkpoint write)")

  lbfgs_current => lbfgs
  lbfgs => lbfgs_first

  if(tchkform) then
    open(unit=ifunit,file="dlf_lbfgs.chk",form="formatted")
    call write_separator(ifunit,"current")
    write(ifunit,*) lbfgs_current%tag
    do while (associated(lbfgs))
      call write_separator(ifunit,"NM")
      write(ifunit,*) lbfgs%n,lbfgs%m
      call write_separator(ifunit,"Arrays")
      write(ifunit,*) lbfgs%store,lbfgs%store2,lbfgs%rho,lbfgs%alpha,lbfgs%step,lbfgs%dgrad
      call write_separator(ifunit,"Position")
      write(ifunit,*) lbfgs%point,lbfgs%iter
      lbfgs=>lbfgs%next
    end do
    call write_separator(ifunit,"END")
  else
    open(unit=ifunit,file="dlf_lbfgs.chk",form="unformatted")
    call write_separator(ifunit,"current")
    write(ifunit) lbfgs_current%tag
    do while (associated(lbfgs))
      call write_separator(ifunit,"NM")
      write(ifunit) lbfgs%n,lbfgs%m
      call write_separator(ifunit,"Arrays")
      write(ifunit) lbfgs%store,lbfgs%store2,lbfgs%rho,lbfgs%alpha,lbfgs%step,lbfgs%dgrad
      call write_separator(ifunit,"Position")
      write(ifunit) lbfgs%point,lbfgs%iter
      lbfgs=>lbfgs%next
    end do
    call write_separator(ifunit,"END")
  end if
  close(ifunit)
  lbfgs => lbfgs_current

end subroutine dlf_checkpoint_lbfgs_write

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_checkpoint_lbfgs_read(tok)
  use dlf_global, only: stdout,printl
  USE lbfgs_module
  use dlf_checkpoint, only: tchkform, read_separator
  implicit none
  logical,intent(out) :: tok
  logical             :: tchk
  integer             :: n_f,m_f
  character(40)       :: tag_read
  integer, parameter  :: ifunit = 104
  ! **********************************************************************
  tok=.false.
  if(.not.tinit) call dlf_fail("LBFGS not initialised! (in checkpoint read)")

  ! check if checkpoint file exists
  INQUIRE(FILE="dlf_lbfgs.chk",EXIST=tchk)
  if(.not.tchk) then
    write(stdout,10) "File dlf_lbfgs.chk not found"
    return
  end if

  if(tchkform) then
    open(unit=ifunit,file="dlf_lbfgs.chk",form="formatted")
  else
    open(unit=ifunit,file="dlf_lbfgs.chk",form="unformatted")
  end if

  lbfgs => lbfgs_first

  call read_separator(ifunit,"current",tchk)
  if(.not.tchk) return    

  if(tchkform) then
    read(ifunit,*,end=201,err=200) tag_read
  else
    read(ifunit,end=201,err=200) tag_read
  end if

  do while (associated(lbfgs))


    call read_separator(ifunit,"NM",tchk)
    if(.not.tchk) return    

    if(tchkform) then
      read(ifunit,*,end=201,err=200) n_f,m_f
    else
      read(ifunit,end=201,err=200) n_f,m_f
    end if
    
    if(n_f/=lbfgs%n) then
      write(stdout,10) "Different L-BFGS system size"
      close(ifunit)
      return
    end if
    if(m_f/=lbfgs%m) then
      write(stdout,10) "Different L-BFGS memory size"
      close(ifunit)
      return
    end if
    
    call read_separator(ifunit,"Arrays",tchk)
    if(.not.tchk) return 
    
    if(tchkform) then
      read(ifunit,*,end=201,err=200) lbfgs%store,lbfgs%store2,lbfgs%rho,lbfgs%alpha,lbfgs%step,lbfgs%dgrad
    else
      read(ifunit,end=201,err=200) lbfgs%store,lbfgs%store2,lbfgs%rho,lbfgs%alpha,lbfgs%step,lbfgs%dgrad
    end if
    
    call read_separator(ifunit,"Position",tchk)
    if(.not.tchk) return 

    if(tchkform) then
      read(ifunit,*,end=201,err=200) lbfgs%point,lbfgs%iter
    else
      read(ifunit,end=201,err=200) lbfgs%point,lbfgs%iter
    end if

    lbfgs=>lbfgs%next

  end do ! while (associated(lbfgs))

  call read_separator(ifunit,"END",tchk)
  if(.not.tchk) return 
    
  ! now make sure that the instance of the checkpoint is selected
  call dlf_lbfgs_select(trim(tag_read),.false.)

  if(printl >= 6) write(stdout,"('LBFGS checkpoint file sucessfully read')")
  close(ifunit)
  tok=.true.

  return

  ! return on error
  close(ifunit)
200 continue
  write(stdout,10) "Error reading LBFGS checkpoint file"
  return
201 continue
  write(stdout,10) "Error (EOF) reading file"
  return

10 format("Checkpoint reading WARNING: ",a)

end subroutine dlf_checkpoint_lbfgs_read

! stubs for serial build

!  Copyright (C) 2017 The authors of Py-ChemShell
!
!  This file is part of Py-ChemShell.
!
!  Py-ChemShell is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as
!  published by the Free Software Foundation, either version 3 of the
!  License, or (at your option) any later version.
!
!  Py-ChemShell is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with Py-ChemShell.  If not, see
!  <http://www.gnu.org/licenses/>.

module ChemShellParallelModule

    use iso_c_binding

    implicit none

    private

    integer :: mpi_comm_workgroup, mpi_comm_counterparts
    integer :: nWorkgroups, nProcs, workgroupSize
    integer :: myWorldRank, myWorkgroup, myWorkgroupRank
  
    type parallelType
        integer, public  :: nprocs         =  1
        integer, public  :: nnodes_subset  =  1
        integer, public  :: rank           =  0
        integer, public  :: nworkgroups    =  1
        integer, public  :: workgroup      =  0
        integer, public  :: node_subset    =  0
        integer, public  :: node           =  0
        integer, public  :: comm_workgroup =  0
        integer, public  :: comm_node      = -1
        integer, public  :: comm_subset    =  0
        integer, public  :: null           = -1
        integer, public  :: debug          = -1
        contains
        generic, public :: broadcast   => private_broadcastScalar, &
                                          private_broadcastOneDim, &
                                          private_broadcastTwoDim
        generic, public :: send        => private_sendScalar, &
                                          private_sendOneDim, &
                                          private_sendTwoDim
        generic, public :: receive     => private_receiveScalar, &
                                          private_receiveOneDim, &
                                          private_receiveTwoDim
        procedure, public         :: init        => private_function
        procedure, public         :: initialise  => private_function
        procedure, public         :: finalise    => private_function
        procedure, public         :: print       => private_function
        procedure, public         :: summarise   => private_function
        procedure, public         :: sync        => private_function
        procedure, public         :: synchronise => private_function
        procedure, nopass, public :: is_root
        procedure, nopass, public :: is_subset
        procedure, nopass, public :: is_taskfarmed
        procedure, nopass, public :: is_parallel
        procedure, nopass, public :: exec_function
        procedure, nopass, public :: get_function_handle
        procedure, private        :: private_broadcastScalar
        procedure, private        :: private_broadcastOneDim
        procedure, private        :: private_broadcastTwoDim
        procedure, private        :: private_sendScalar
        procedure, private        :: private_sendOneDim
        procedure, private        :: private_sendTwoDim
        procedure, private        :: private_receiveScalar
        procedure, private        :: private_receiveOneDim
        procedure, private        :: private_receiveTwoDim
        procedure, private        :: private_function
    endtype parallelType

    type(parallelType), public :: chemsh_parallel

    contains

    logical function is_root() result(result)

        result = .true.

    endfunction is_root
    logical function is_subset() result(result)

        result = .true.

    endfunction is_subset
    logical function is_taskfarmed() result(result)

        result = .false.

    endfunction is_taskfarmed
    integer function private_function(this, arg) result(result)

        class(parallelType), intent(in)           :: this
        class(*)           , intent(in), optional :: arg

        result = 0

    endfunction private_function
    integer function private_broadcastScalar(this, buf, lenbuf, root, dummy) result(ierror)

        implicit none

        class(parallelType), intent(in)           :: this
        class(*)           , intent(in)           :: buf, lenbuf, root
        class(*)           , intent(in), optional :: dummy
        
        ierror = 0
        
    endfunction private_broadcastScalar
    integer function private_broadcastOneDim(this, buf, lenbuf, root, dummy) result(ierror)

        implicit none

        class(parallelType), intent(in)           :: this
        class(*)           , intent(in)           :: buf(:), lenbuf, root
        class(*)           , intent(in), optional :: dummy
        
        ierror = 0
        
    endfunction private_broadcastOneDim
    integer function private_broadcastTwoDim(this, buf, lenbuf, root, dummy) result(ierror)

        implicit none

        class(parallelType), intent(in)           :: this
        class(*)           , intent(in)           :: buf(:,:), lenbuf, root
        class(*)           , intent(in), optional :: dummy
        
        ierror = 0
        
    endfunction private_broadcastTwoDim
    integer function private_sendScalar(this, buf, lenbuf, root, dummy) result(ierror)

        implicit none

        class(parallelType), intent(in)           :: this
        class(*)           , intent(in)           :: buf, lenbuf, root
        class(*)           , intent(in), optional :: dummy
        
        ierror = 0
        
    endfunction private_sendScalar
    integer function private_sendOneDim(this, buf, lenbuf, root, dummy) result(ierror)

        implicit none

        class(parallelType), intent(in)           :: this
        class(*)           , intent(in)           :: buf(:), lenbuf, root
        class(*)           , intent(in), optional :: dummy
        
        ierror = 0
        
    endfunction private_sendOneDim
    integer function private_sendTwoDim(this, buf, lenbuf, root, dummy) result(ierror)

        implicit none

        class(parallelType), intent(in)           :: this
        class(*)           , intent(in)           :: buf(:,:), lenbuf, root
        class(*)           , intent(in), optional :: dummy
        
        ierror = 0
        
    endfunction private_sendTwoDim
    integer function private_receiveScalar(this, buf, lenbuf, root, dummy) result(ierror)

        implicit none

        class(parallelType), intent(in)           :: this
        class(*)           , intent(in)           :: buf, lenbuf, root
        class(*)           , intent(in), optional :: dummy
        
        ierror = 0
        
    endfunction private_receiveScalar
    integer function private_receiveOneDim(this, buf, lenbuf, root, dummy) result(ierror)

        implicit none

        class(parallelType), intent(in)           :: this
        class(*)           , intent(in)           :: buf(:), lenbuf, root
        class(*)           , intent(in), optional :: dummy
        
        ierror = 0
        
    endfunction private_receiveOneDim
    integer function private_receiveTwoDim(this, buf, lenbuf, root, dummy) result(ierror)

        implicit none

        class(parallelType), intent(in)           :: this
        class(*)           , intent(in)           :: buf(:,:), lenbuf, root
        class(*)           , intent(in), optional :: dummy
        
        ierror = 0
        
    endfunction private_receiveTwoDim
    integer(c_int) function create_python_result(dummy) result(ierror) bind(c)

        implicit none

        integer(c_int), intent(in) :: dummy
    
        ierror = 0
    
    endfunction create_python_result
    integer(c_int) function synchronise_python_object(dummyObj, dummyEntry) result(ierror) bind(c)

        implicit none

        integer(c_int), intent(in) :: dummyObj, dummyEntry
    
        ierror = 0
    
    endfunction synchronise_python_object
    integer(c_int) function synchronise_python_result(dummy) result(ierror) bind(c)

        implicit none

        integer(c_int), intent(in) :: dummy
    
        ierror = 0
    
    endfunction synchronise_python_result
    integer(c_int) function clean_python_result() result(ierror) bind(c)

        implicit none

        ierror = 0
    
    endfunction clean_python_result
    integer(c_int) function initialise_parallel(ChemShell_debug) result(ierror) bind(c, name="chemsh_parallel_f_initialise")
    
        implicit none
    
        integer, intent(in), value :: ChemShell_debug
    
        ierror = 0
    
    endfunction initialise_parallel
    integer(c_int) function finalise_parallel() result(ierror) bind(c, name="chemsh_parallel_f_finalise")

        implicit none

        ierror = 0

    endfunction finalise_parallel
    integer(c_int) function get_function_handle(func_pointer) result(handle)

        type(c_funptr), value :: func_pointer

        handle = 0

    endfunction get_function_handle
    integer(c_int) function exec_function(handle, debug) result(ierror)

        integer(c_int), intent(in)           :: handle
        integer(c_int), intent(in), optional :: debug

        ierror = 0

    endfunction exec_function
    ! myWorkgroup
    integer(c_int) function getWG() result(wg) bind(c, name="chemsh_parallel_f_get_wg")

        wg = 0

    endfunction getWG
    ! myWorkgroupRank
    integer(c_int) function getNode() result(node) bind(c, name="chemsh_parallel_f_get_node")

        node = 0

    endfunction getNode
    integer(c_int) function getWGNumNodes() result(result) bind(c, name="chemsh_parallel_f_get_nnodes_wg")

        result = 1

    endfunction getWGNumNodes
    ! number of workgroups
    integer(c_int) function getNumWorkgroups() result(nwgs) bind(c, name="chemsh_parallel_f_get_nwgs")

        nwgs = 1

    endfunction getNumWorkgroups
    ! number of nodes in a workgroup's subset
    integer(c_int) function getSubsetNumNodes() result(result) bind(c, name="chemsh_parallel_f_get_nnodes_subset")

        result = 1

    endfunction getSubsetNumNodes
    ! query ChemShell build
    logical function is_parallel() result(result)
    
        result = .false.
    
    endfunction is_parallel

endmodule ChemShellParallelModule

!  Copyright (C) 2017 The authors of Py-ChemShell
!
!  This file is part of Py-ChemShell.
!
!  Py-ChemShell is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as
!  published by the Free Software Foundation, either version 3 of the
!  License, or (at your option) any later version.
!
!  Py-ChemShell is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with Py-ChemShell.  If not, see
!  <http://www.gnu.org/licenses/>.

subroutine frac_to_cart(ndim, nsites, ierr)
  !
  ! Converts from fractional coordinates to cartesian coordinates
  !
  ! Limitation: assumes no symmetry (i.e. the fractional coordinates describe 
  ! the full primitive unit cell, not the asymmetric unit)
  !
  implicit none

  integer, intent(in) :: ndim, nsites
  integer, intent(out) :: ierr
  integer :: isite

  double precision :: a, b, c, alpha, beta, gamma, dum
  double precision, dimension(3, 3) :: vect
  double precision, dimension(3, nsites) :: frac_coords, cart_coords

  integer, parameter :: periodic_frag = 1, cluster_frag = 2

  ierr = 0

  ! Get unit cell parameters from fragment
  ! a, b, c in atomic units
  ! alpha, beta, gamma in radians
  call get_unit_cell(periodic_frag, a, b, c, alpha, beta, gamma, ierr)
  if (ierr .ne. 0) return

  ! Call construct routines to generate the cell vectors
  vect = 0.0d0
  select case (ndim)
  case (1)
     vect(1, 1) = a
  case (2)
     call lattice_cryst_2(a, b, gamma, vect(1:2, 1:2), dum)
  case (3)
     call lattice_cryst_3(a, b, c, alpha, beta, gamma, vect, dum)
  case default
     write(6,*) "frac_to_cart: error, ndim=", ndim
     ierr = 1
     return
  end select

  ! Get fractional coordinates from fragment
  ! This is received as a single block of coordinates containing
  ! all atoms, point charges (bqs) and shells. There is no need to 
  ! differentiate between these as the same transformation is applied to all 
  ! sites.


  ! YL FIXME: get_frac_coords() is yet to implement
  call get_frac_coords(periodic_frag, frac_coords, ierr)  
  if (ierr .ne. 0) return

  ! Convert fractional coordinates to cartesian
  do isite = 1, nsites
     ! Only the periodic dimensions are fractional
     select case (ndim)
     case (1)
        cart_coords(1, isite) = frac_coords(1, isite) * a
        cart_coords(2, isite) = frac_coords(2, isite)
        cart_coords(3, isite) = frac_coords(3, isite)
     case (2)
        cart_coords(1, isite) = vect(1,1) * frac_coords(1, isite) + vect(2,1) * frac_coords(2, isite) 
        cart_coords(2, isite) = vect(1,2) * frac_coords(1, isite) + vect(2,2) * frac_coords(2, isite) 
        cart_coords(3, isite) = frac_coords(3, isite)
     case (3)
        cart_coords(1, isite) = vect(1,1) * frac_coords(1, isite) &
             + vect(2,1) * frac_coords(2, isite) + vect(3,1) * frac_coords(3, isite)
        cart_coords(2, isite) = vect(1,2) * frac_coords(1, isite) &
             + vect(2,2) * frac_coords(2, isite) + vect(3,2) * frac_coords(3, isite)
        cart_coords(3, isite) = vect(1,3) * frac_coords(1, isite) &
             + vect(2,3) * frac_coords(2, isite) + vect(3,3) * frac_coords(3, isite)
     case default
        write(6,*) "frac_to_cart: error, ndim=", ndim
        ierr = 1
        return
     end select
  enddo

  ! Look for equivalent sites closer to the origin
  call find_equiv_coords(ndim, nsites, vect, cart_coords, ierr)
  if (ierr .ne. 0) return

  ! Give cartesian coordinates to fragment
  call set_cart_unit_cell(periodic_frag, vect, cart_coords, ierr)
  if (ierr .ne. 0) return

end subroutine frac_to_cart


subroutine centre_cart_coords(ndim, nsites, ierr)
  !
  ! Wrapper around routine to find equivalent cartesian sites closer
  ! to the origin
  !
  implicit none

  integer, intent(in) :: ndim, nsites
  integer, intent(out) :: ierr
  integer :: isite

  double precision, dimension(3, 3) :: vect
  double precision, dimension(3, nsites) :: cart_coords

  integer, parameter :: periodic_frag = 1, cluster_frag = 2

  ierr = 0

  ! Get unit cell vectors from fragment
  vect = 0.0d0
  call get_cell_vectors(periodic_frag, vect, ierr)
  if (ierr .ne. 0) return  

  ! Get cartesian coordinates from fragment
  ! This is received as a single block of coordinates containing
  ! all atoms, point charges (bqs) and shells. There is no need to 
  ! differentiate between these as the same transformation is applied to all 
  ! sites.
  ! Note we read and write cart coords directly as the shells have 
  ! not yet been assigned to relative positions
  call get_cart_coords(periodic_frag, 0, cart_coords, ierr)  
  if (ierr .ne. 0) return

  ! Look for equivalent sites closer to the origin
  call find_equiv_coords(ndim, nsites, vect, cart_coords, ierr)
  if (ierr .ne. 0) return

  ! Give cartesian coordinates to fragment
  call set_cart_coords(periodic_frag, 0, cart_coords, ierr)
  if (ierr .ne. 0) return

end subroutine centre_cart_coords


subroutine find_equiv_coords(ndim, nsites, vect, cart_coords, ierr)
  !
  ! Following xtal, look for equivalent sites closer to the origin
  ! Note that we do not worry here about keeping shells associated with cores
  ! In c_create, this is handled afterwards by a call to FRAG_assign_shells_to_atoms
  !
  implicit none

  integer, intent(in) :: ndim, nsites
  double precision, dimension(3, 3), intent(in) :: vect
  double precision, dimension(3, nsites), intent(inout) :: cart_coords 
  integer, intent(out) :: ierr

  integer :: isite
  integer :: ap, bp, cp, loopa, loopb, loopc

  double precision, parameter :: search_tol = 1.0d-4
  double precision :: transx, transy, transz, bestx, besty, bestz, best_r2, r2

  ierr = 0

  ap = 0
  bp = 0
  cp = 0
  ! Only search over periodic dimensions
  select case (ndim)
  case (1)
     ap = 1
  case (2)
     ap = 1
     bp = 1
  case (3)
     ap = 1
     bp = 1
     cp = 1
  case default
     write(6,*) "find_equiv_coords: error, ndim=", ndim
     ierr = 1
     return
  end select
  do isite = 1, nsites
     ! Refinement - calculate the untranslated position first so that there is 
     ! no unecessary switching to equivalent coordinates.
     ! Note the results may now not exactly reproduce the old xtal code
     ! (though they will always be equivalent).
     bestx = cart_coords(1, isite)
     besty = cart_coords(2, isite)
     bestz = cart_coords(3, isite)
     r2 = bestx*bestx + besty*besty + bestz*bestz
     best_r2 = r2 - search_tol
     ! Now check possible translated positions
     do loopa = -ap, ap
        do loopb = -bp, bp
           do loopc = -cp, cp
              transx = cart_coords(1, isite) + loopa*vect(1, 1) + loopb*vect(2, 1) + loopc*vect(3, 1)
              transy = cart_coords(2, isite) + loopa*vect(1, 2) + loopb*vect(2, 2) + loopc*vect(3, 2)
              transz = cart_coords(3, isite) + loopa*vect(1, 3) + loopb*vect(2, 3) + loopc*vect(3, 3)
              r2 = transx*transx + transy*transy + transz*transz
              if (r2 .lt. best_r2) then
                 bestx = transx
                 besty = transy
                 bestz = transz
                 ! Tolerance term here is again following xtal. 
                 best_r2 = r2 - search_tol
              end if
           end do ! loopc
        end do ! loopb
     end do ! loopa
     cart_coords(1, isite) = bestx
     cart_coords(2, isite) = besty
     cart_coords(3, isite) = bestz
  end do ! isite

end subroutine find_equiv_coords

!!!
!!! Dummy subroutines corresponding to MPI functionality.
!!!
!! COPYRIGHT
!!
!!  Copyright 2007 Johannes Kaestner (kaestner@theochem.uni-stuttgart.de),
!!  Tom Keal (thomas.keal@stfc.ac.uk)
!!  Joanne Carr (j.m.carr@dl.ac.uk)
!!
!!  This file is part of DL-FIND.
!!
!!  DL-FIND is free software: you can redistribute it and/or modify
!!  it under the terms of the GNU Lesser General Public License as
!!  published by the Free Software Foundation, either version 3 of the
!!  License, or (at your option) any later version.
!!
!!  DL-FIND is distributed in the hope that it will be useful,
!!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!!  GNU Lesser General Public License for more details.
!!
!!  You should have received a copy of the GNU Lesser General Public
!!  License along with DL-FIND.  If not, see
!!  <http://www.gnu.org/licenses/>.
!!
subroutine dlf_mpi_initialize

  use dlf_parameter_module, only: rk
  use dlf_global, only: glob
  implicit none

! **********************************************************************

! Initialize the mpi-related variables that are used throughout the 
! code (not just within the wrapper MPI wourtines...)

  glob%nprocs = 1
  glob%ntasks = 1
  glob%nprocs_per_task = 1

  glob%iam = 0
  glob%mytask = 0
  glob%iam_in_task = 0
  !glob%master_in_task = 0

  return

end subroutine dlf_mpi_initialize


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_mpi_finalize

  implicit none

! **********************************************************************

  return

end subroutine dlf_mpi_finalize


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_mpi_abort

  implicit none

! **********************************************************************

  return

end subroutine dlf_mpi_abort


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_make_taskfarm(tdlf_farm)

  implicit none
  integer :: tdlf_farm

! **********************************************************************

  return

end subroutine dlf_make_taskfarm


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_mpi_counters

  implicit none

! **********************************************************************

  return

end subroutine dlf_mpi_counters


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_mpi_memory(sto,maxsto)

  implicit none
  integer :: sto,maxsto

! **********************************************************************

  return

end subroutine dlf_mpi_memory


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_mpi_time(descr, cput, wallt)
  use dlf_parameter_module, only: rk

  implicit none
  real(rk) :: cput,wallt
  character(len=*) :: descr

! **********************************************************************

  return

end subroutine dlf_mpi_time


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_global_real_bcast(a,n,iproc)

  use dlf_parameter_module, only: rk
  implicit none

  integer :: iproc, n
  real(rk), dimension(n) :: a
! **********************************************************************

  return

end subroutine dlf_global_real_bcast


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_global_int_bcast(a,n,iproc)

  use dlf_parameter_module, only: rk
  implicit none

  integer :: iproc, n
  integer, dimension(n) :: a
! **********************************************************************

  return

end subroutine dlf_global_int_bcast


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_global_log_bcast(a,n,iproc)

  use dlf_parameter_module, only: rk
  implicit none

  integer :: iproc, n
  logical, dimension(n) :: a
! **********************************************************************

  return

end subroutine dlf_global_log_bcast


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_global_real_sum(a,n)

  use dlf_parameter_module, only: rk
  implicit none

  integer :: n
  real(rk), dimension(n) :: a
! **********************************************************************

  return

end subroutine dlf_global_real_sum


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_tasks_real_sum(a,n)

  use dlf_parameter_module, only: rk
  implicit none

  integer :: n
  real(rk), dimension(n) :: a
! **********************************************************************

  return
  
end subroutine dlf_tasks_real_sum


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_tasks_int_sum(a,n)

  implicit none

  integer :: n
  integer, dimension(n) :: a
! **********************************************************************

  return

end subroutine dlf_tasks_int_sum


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_tasks_int_gather(a,n,b,m,iproc)

  use dlf_parameter_module, only: rk
  implicit none

  integer :: n, m, iproc
  integer, dimension(n) :: a
  integer, dimension(m) :: b
! **********************************************************************

  return

end subroutine dlf_tasks_int_gather


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_tasks_real_gather(a,n,b,m,iproc)

  use dlf_parameter_module, only: rk
  implicit none

  integer :: n, m, iproc
  real(rk), dimension(n) :: a
  real(rk), dimension(m) :: b
! **********************************************************************

  return

end subroutine dlf_tasks_real_gather

! **********************************************************************
! **               Utility unit: run-time bookkeeping                 **
! **********************************************************************

! $Date$
! $Rev$
! $Author$
! $URL$
! $Id$

!! COPYRIGHT
!!
!!  Copyright 2007 Johannes Kaestner (kaestner@theochem.uni-stuttgart.de),
!!  Tom Keal (thomas.keal@stfc.ac.uk)
!!
!!  This file is part of DL-FIND.
!!
!!  DL-FIND is free software: you can redistribute it and/or modify
!!  it under the terms of the GNU Lesser General Public License as 
!!  published by the Free Software Foundation, either version 3 of the 
!!  License, or (at your option) any later version.
!!
!!  DL-FIND is distributed in the hope that it will be useful,
!!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!!  GNU Lesser General Public License for more details.
!!
!!  You should have received a copy of the GNU Lesser General Public 
!!  License along with DL-FIND.  If not, see 
!!  <http://www.gnu.org/licenses/>.
!!
module dlf_time
  use dlf_parameter_module, only: rk
  type time_type
    logical  :: running
    real(rk) :: accum_cpu_time
    real(rk) :: accum_wall_time
    real(rk) :: start_cpu_time
    real(rk) :: start_wall_time
  end type time_type
  integer,parameter    :: maxclock=6
  type(time_type),save :: clock(maxclock)
  logical,save         :: warning=.false.
end module dlf_time

subroutine get_cpu_time(time)
  ! return the cpu-time in seconds 
  use dlf_parameter_module, only: rk
  implicit none
  real(rk) ,intent(out) :: time
! **********************************************************************
  call cpu_time(time)
end subroutine get_cpu_time

subroutine get_wall_time(time)
  ! return the wall-clock time in seconds
  use dlf_parameter_module, only: rk
  implicit none
  real(rk) ,intent(out) :: time
  integer  :: count,count_rate,count_max
  integer,save :: lastcount=0
! **********************************************************************
  call system_clock(count,count_rate,count_max)
  if(count<lastcount) count=count+count_max
  time=dble(count)/dble(count_rate)
end subroutine get_wall_time

subroutine map_clock(name,number)
  use dlf_time
  implicit none
  character(*),intent(IN) :: name
  integer     ,intent(out):: number
  IF(NAME=="TOTAL") THEN
    NUMBER=1
  ELSE IF(NAME=="EANDG") THEN
    NUMBER=2
  ELSE IF(NAME=="FORMSTEP") THEN
    NUMBER=3
  ELSE IF(NAME=="COORDS") THEN
    NUMBER=4
  ELSE IF(NAME=="CHECKPOINT") THEN
    NUMBER=5
  ELSE IF(NAME=="XYZ") THEN
    NUMBER=6
  else 
    warning=.true.
    print*,"Warning: clock not recognised",name
    number=-1
  end if
end subroutine map_clock

subroutine clock_start(name)
  use dlf_time
  implicit none
  character(*),intent(IN) :: name
  integer                 :: number
  real(rk)                :: svar
! **********************************************************************
  call map_clock(name,number)
  if(number<=0) return
  if(clock(number)%running) then
    warning=.true.
    print*,"Warning: clock",name," already running"
    return
  end if
  clock(number)%running=.true.
  call get_cpu_time(svar)
  clock(number)%start_cpu_time=svar
  call get_wall_time(svar)
  clock(number)%start_wall_time=svar
end subroutine clock_start

subroutine clock_stop(name)
  use dlf_time
  implicit none
  character(*),intent(IN) :: name
  integer                 :: number
  real(rk)                :: svar,svar2
! **********************************************************************
  call get_cpu_time(svar)
  call get_wall_time(svar2)
  call map_clock(name,number)
  if(number<=0) return
  if(.not.clock(number)%running) then
    warning=.true.
    print*,"Warning: clock",name," not running"
    return
  end if
  clock(number)%running=.false.
  clock(number)%accum_cpu_time=clock(number)%accum_cpu_time+ &
      svar-clock(number)%start_cpu_time
  clock(number)%accum_wall_time=clock(number)%accum_wall_time+ &
      svar2-clock(number)%start_wall_time
end subroutine clock_stop

subroutine time_init
  use dlf_time
  implicit none
! **********************************************************************
  clock(:)%running=.false.
  clock(:)%accum_cpu_time=0.D0
  clock(:)%accum_wall_time=0.D0
end subroutine time_init

subroutine time_report
  use dlf_time
  use dlf_global, only: stdout,printl,glob
  implicit none
  character(50)   :: descr(maxclock)
  integer         :: iclock
  real(rk)        :: maxcpu,maxwall,fraction_cpu,fraction_wall
! **********************************************************************
  descr(1)="Total"
  descr(2)="Energy and Gradient"
  descr(3)="Step direction"
  descr(4)="Coordinate transformation"
  descr(5)="Checkpoint file I/O"
  descr(6)="XYZ-file I/O"

! can't return as dlf_mpi_time requires participation
!  if(printl<=0) return
  if (printl > 0) then
     write(stdout,'(/,"Timing report")')
     write(stdout,'("=============")')
     write(stdout,'("Module                       &
         &               CPU time            Wall clock time")')
     call flush(stdout)
     maxcpu=maxval(clock(:)%accum_cpu_time)
     maxwall=maxval(clock(:)%accum_wall_time)
     do iclock=1,maxclock
       if(.not.clock(iclock)%running) then
         fraction_cpu=0.D0
         if(maxcpu > 0.D0) &
             fraction_cpu=clock(iclock)%accum_cpu_time*100.D0/maxcpu
         fraction_wall=0.D0
         if(maxwall > 0.D0) &
             fraction_wall=clock(iclock)%accum_wall_time*100.D0/maxwall
         write(stdout,1000) TRIM(descr(iclock)), &
             clock(iclock)%accum_cpu_time, fraction_cpu,&
             clock(iclock)%accum_wall_time,fraction_wall
       else
         write(stdout,'(a," is still running")') TRIM(descr(iclock))
       end if
     end do
  end if

  if (glob%nprocs > 1 .and. glob%ntasks > 1) then
     if (glob%iam == 0 .and. printl > 0) then
        write(stdout,*)
        write(stdout,'(a)')"Task-farming statistics:"
        write(stdout,'("Module                                      &
              &Total     Mean      St.dev.   Max       Min")')
     end if
     do iclock=1,maxclock
       if(.not.clock(iclock)%running) call dlf_mpi_time(descr(iclock), &
         clock(iclock)%accum_cpu_time, clock(iclock)%accum_wall_time)
     end do
     if (glob%iam == 0 .and. printl > 0) then
        write(stdout,*)
        write(stdout,'(a)')"Task-farming statistics: end"
     end if
  end if

1000 format (t1,"................................................", &
         t1,a," ",t40,2(f10.3," (",f6.2,"%)")," seconds")
end subroutine time_report

!  Copyright (C) 2017 The authors of Py-ChemShell
!
!  This file is part of Py-ChemShell.
!
!  Py-ChemShell is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as
!  published by the Free Software Foundation, either version 3 of the
!  License, or (at your option) any later version.
!
!  Py-ChemShell is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with Py-ChemShell.  If not, see
!  <http://www.gnu.org/licenses/>.

! YL: better call this module ClusterOptionsModule to store fragment and other information
module ClusterCreateModule

    use iso_c_binding
    use DL_PY2F

    private
    public init, finalise
    public get_cluster_size
    public PyFrag, PyCluster, PyOptions, PyCell, PyField, PyBQs, PyShells
!    public nneighbours, neighbours, neighb_vectors

    integer(kind=8)            :: ncores
!    integer(kind=8), pointer   :: nneighbours(:)
!    integer(kind=8), pointer   :: neighbours(:,:)
    integer(kind=8), parameter :: MAXCONN = 14
!    real(kind=8)   , pointer   :: neighb_vectors(:,:)
    type(dictType) , pointer   :: PyFrag, PyCluster, PyOptions, PyCell, PyField, PyBQs, PyShells


!    type, bind(c) :: frag_pass
        ! This type must match the frag_pass C struct on the python side
!        integer(c_int) :: nat
!        type(c_ptr)    :: ncores, nshells 
!    end type frag_pass
!    type :: fragment
     ! This is our Fortran fragment data structure
!        integer(c_int), dimension(:)  ,pointer  :: ncores
!        integer(c_int), dimension(:)  ,pointer  :: nshells
     !   real(c_double), dimension(:,:),pointer  :: pos
     !   real(c_double), dimension(:)  ,pointer  :: charge
!    end type fragment


    contains

    subroutine init(fragPtr, optionsPtr) bind(c)

        implicit none
        type(PyType)         , intent(in) :: fragPtr
        type(PyType)         , intent(in) :: optionsPtr
        type(PyType), pointer             :: cellPtr

        real(kind=8) :: floatbuff

        ! frag
        allocate(PyFrag, source=ptr2dict(fragPtr))

        ! options
        allocate(PyOptions, source=ptr2dict(optionsPtr))

        ! cell
        call PyFrag%get('cell', cellPtr)
        allocate(PyCell, source=ptr2dict(cellPtr))

        ! YL: didn't we forget to set ncores which is needed by set_neighbours()?
        call PyFrag%get('npts', ncores)

    endsubroutine init
    subroutine finalise() bind(c)

        implicit none

        deallocate(PyFrag, PyOptions, PyCell)

!        if(associated(nneighbours)) then
!            deallocate(nneighbours)
!        endif        
!        if(associated(neighbours)) then
!            deallocate(neighbours)
!        endif
!        if(associated(neighb_vectors)) then
!            deallocate(neighb_vectors)
!        endif
    
    endsubroutine finalise
    subroutine cluster_transfer_data()

        implicit none
        integer :: ierr
        print *, "### FORTRAN: cluster_transfer_data"
    endsubroutine cluster_transfer_data


endmodule clusterCreateModule

!  Copyright (C) 2023 The authors of Py-ChemShell
!
!  This file is part of Py-ChemShell.
!
!  Py-ChemShell is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as
!  published by the Free Software Foundation, either version 3 of the
!  License, or (at your option) any later version.
!
!  Py-ChemShell is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with Py-ChemShell.  If not, see
!  <http://www.gnu.org/licenses/>.

module ChemShellCastepModule
    
    use, intrinsic :: iso_c_binding
    
    !Rajany: ptrtodict-function convert PyType ptr to dictionary
    !Rajany: PyType is a bind-c structure in fortran
    
    use DL_PY2F, only : PyType, dictType, ptr2dict
    use ChemShellParallelModule, only : chemsh_parallel

    private
   
    public register_castep, interface_castep, castep_wrap
    public natoms
    
    !! These pointers are saved across all function calls in module
    type(dictType)  , pointer   :: PyOptions
    type(dictType)  , pointer   :: PyFrag
    type(dictType)  , pointer   :: PyResult
    type(dictType)  , pointer   :: PyCell
    integer(c_int)              :: c_debug
    integer(c_int)              :: castep_handle

    logical           , save    :: initialise = .true.

    contains

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    !Rajany: executed by the startup main function 

    subroutine register_castep(debug) bind(c, name="f_register_castep")

        integer(c_int), intent(in) :: debug
        type(c_funptr)             :: castep_pointer
        c_debug        = debug
        castep_pointer = c_funloc(castep_wrap) 
        castep_handle  = chemsh_parallel%get_function_handle(castep_pointer)
    
    endsubroutine register_castep
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
    ! called by master process only
    integer(c_int) function interface_castep(fragPtr, optionsPtr, resultPtr,&
                                            cellPtr) result(ierror) bind(c)
 
        implicit none
        type(PyType)  , intent(in) :: fragPtr
        type(PyType)  , intent(in) :: optionsPtr
        type(PyType)  , intent(in) :: ResultPtr
        type(PyType)  , intent(in) :: cellPtr

        !!!!!!!!!!!!!!!! declarations end !!!!!!!!!!!!!!!!!!
        ierror = 1
        ! set up dict of fragObj
        allocate(PyFrag, source=ptr2dict(fragPtr))
        allocate(PyOptions, source=ptr2dict(optionsPtr))
        allocate(PyResult, source=ptr2dict(resultPtr))
        allocate(PyCell, source=ptr2dict(cellPtr))

        !get's arguments:metaobj,key,value(out)
        !call PyOptions%get("input", ptr_input) !!error,keyword "input"
        !.. not found in dictionary
        !calls the wrapper
        if(chemsh_parallel%is_parallel()) then
            ierror = chemsh_parallel%exec_function(castep_handle, c_debug)
        else
            ierror = castep_wrap()
        endif

        if(associated(PyFrag)) then
            call PyFrag%finalise()
            deallocate(PyFrag)
        endif

       if(associated(PyResult)) then
            call PyResult%finalise()
            deallocate(PyResult)
       endif
       if(associated(PyOptions)) then
            call PyOptions%finalise()
            deallocate(PyOptions)
        endif
 
       if(associated(PyCell)) then
            call PyCell%finalise()
            deallocate(PyCell)
        endif
    endfunction interface_castep
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    ! also called by slave processes
    integer function castep_wrap() result(ierror)

        use ChemShellParallelModule, only : chemsh_parallel
        
        implicit none
        
        character(len=255) :: castep_input
        integer         :: linput
        integer(kind=4) :: communicator
        !for mpi error message
        integer         :: error
        logical         :: isroot
        integer, parameter :: dp=selected_real_kind(15,300)
        !Rajany: Not initialising natoms here caused overflow
        integer         :: natoms=0
        real(kind=dp)   :: energy
        real(kind=dp)   :: new_lattice(3,3)
        real(kind=dp), allocatable, dimension(:,:)  :: new_positions
        real(kind=dp), allocatable, dimension(:,:)  :: forces

        !!!! Rajany: new_positions are passed as dummy array, so interface included.

        interface
             subroutine castepfunc(input_seed, initial, is_root, communicator, &
                        energy, forces, new_lattice, new_positions, natoms)

              integer, parameter :: dp=selected_real_kind(15,300)
              logical, save :: initialised 

              character(len=*), intent(in)         :: input_seed
              logical         , intent(in)         :: initial
              logical         , intent(in)         :: is_root
              integer(kind=4) , intent(in)         :: communicator 
              real(kind=dp)   , intent(inout)      :: energy
              real(kind=dp)   , dimension(:,:),   allocatable,  intent(inout):: forces
              real(kind=dp)   , dimension(3,3),   intent(inout)              :: new_lattice
              real(kind=dp)   , dimension(:,:),   intent(in)                 :: new_positions
              integer(kind=4) , intent(in)         :: natoms
              integer                              :: linput
              character(len=:), allocatable        :: input_seedname
             end subroutine
         end interface

        !!!!!!!!!!!!!!!!!!!!!!!!   declarations end !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        ierror = 1
        castep_input = repeat(' ',255)
        castep_input = "_castep"
        linput  = len(trim(castep_input))
        !ierror = chemsh_parallel%broadcast(linput , 1, 0)
        !ierror = chemsh_parallel%broadcast(castep_input(1:linput), linput , 0)
        !call flush(6)
        
        communicator = chemsh_parallel%comm_workgroup
        isroot=chemsh_parallel%is_root() 

        if(isroot) then
        call PyFrag%get('npts'   , natoms)
        call PyCell%get('vectors'   , new_lattice)
        endif

        ierror = chemsh_parallel%broadcast(natoms,1,0)
        ierror = chemsh_parallel%broadcast(new_lattice,sizeof(new_lattice),0)
        !print *,'natoms',natoms
        !print *,'new_lattice',new_lattice
        !call flush(6)
        !Rajany: fortran column major
        allocate(new_positions(3,natoms), source=0.0_dp)

        if(isroot) then
        call PyFrag%get('xyz',new_positions)
        endif
        ierror = chemsh_parallel%broadcast(new_positions,sizeof(new_positions),0)
        !print *,'new_positions', new_positions
        !call flush(6)

        !Rajany:lattice vector components is across row in castep and column in chemsh
        !tanspose is not necessary here because of the conversion to fortran matrix
        !in column order, but should transpose in input file

        call castepfunc(castep_input(1:linput), &
                        initialise, isroot, communicator, energy, forces, &
                        new_lattice, new_positions, natoms )
        initialise = .false.
        ierror = 0

        !Rajany:update the results with the returned values      
        ! update, self._results with the energy and forces
        if(isroot) then
        call PyResult%set('energy', [energy])
        endif

        if(isroot) then
        call PyResult%set('gradients', forces(1:3, 1:natoms))
        endif

        deallocate(new_positions)

    endfunction castep_wrap
endmodule ChemShellCastepModule
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! **********************************************************************
! **                Optimisation Algorithms: main unit                **
! **********************************************************************
!!****h* DL-FIND/formstep
!!
!! NAME
!! formstep
!!
!! FUNCTION
!! Optimisation algorithms: determine a search direction. 
!!
!! The variable
!!              IOPT
!! determines which algorithm is to be used. The routines called by this file are
!! supposed to do unconstrained optimisation in the corresponding internal
!! coordinates.
!! The file also contains routines for calculating and updating a Hessian.
!!
!! Inputs
!!    glob%icoords
!!    glob%igradient
!!    glob%toldenergy
!!     Initialisation routines may require additional parameters.
!! 
!! Outputs
!!    glob%step
!!
!! DATA
!! $Date$
!! $Rev$
!! $Author$
!! $URL$
!! $Id$
!!
!! COPYRIGHT
!!
!!  Copyright 2007 Johannes Kaestner (kaestner@theochem.uni-stuttgart.de),
!!  Tom Keal (thomas.keal@stfc.ac.uk)
!!
!!  This file is part of DL-FIND.
!!
!!  DL-FIND is free software: you can redistribute it and/or modify
!!  it under the terms of the GNU Lesser General Public License as 
!!  published by the Free Software Foundation, either version 3 of the 
!!  License, or (at your option) any later version.
!!
!!  DL-FIND is distributed in the hope that it will be useful,
!!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!!  GNU Lesser General Public License for more details.
!!
!!  You should have received a copy of the GNU Lesser General Public 
!!  License along with DL-FIND.  If not, see 
!!  <http://www.gnu.org/licenses/>.
!!
!!****
module dlf_formstep_module
  use dlf_parameter_module, only: rk
  ! conjugate gradient data
  real(rk), allocatable, save :: oldg1(:)     ! glob%nivar
  real(rk), allocatable, save :: g1(:)        ! glob%nivar
  real(rk), allocatable, save :: oldcoords(:) ! glob%nivar
  integer, save               :: cgstep       ! number of CG steps taken
  integer, parameter          :: maxcgstep=10
  ! damped dynamics data
  real(rk)                    :: fricm        ! decreasing friction in damped dynamics
  ! data for dlf_formstep_set_tsmode
  real(rk), allocatable, save :: tscoords(:) ! x-coords
  real(rk), allocatable, save :: tsmode_r(:) ! x-coords, relative
  real(rk), save              :: energy      ! ts energy
  logical , save              :: tenergy     ! is energy set?
  logical , save              :: tsc_ok      ! are TS coords ok to use?
  logical , save              :: tsm_ok      ! is TS-mode ok to use?
  ! communication to outside
  logical , save              :: needhessian 
end module dlf_formstep_module

! module for Optimisers using the Hessian
module dlf_hessian
  use dlf_parameter_module, only: rk
  logical ,save        :: fd_hess_running ! true if FD Hessian is currently running
                                   ! initially set F in dlf_formstep_init
  integer ,save        :: nihvar   ! size of Hessian (nihvar, nihvar)
  integer, save        :: numfd    ! number of FD Hessian eigenmodes to calculate
  integer ,save        :: iivar,direction
  real(rk),save        :: soft ! Hessian eigenvalues absolutely smaller 
                               ! than "soft" are ignored in P-RFO
  integer ,save        :: follow ! Type of mode following:
                          ! 0: no mode following: TS mode has the lowest eigenvalue
                          ! 1: specify direction by input - not yet implemented
                          ! 2: determine direction at first P-RFO step
                          ! 3: update direction at each P-RFO step
  logical ,save        :: tsvectorset ! is tsverctor defined?
  integer ,save        :: tsmode ! number of mode to maximise
  logical ,save        :: twopoint ! type of finite difference Hessian
  real(rk),save        :: storeenergy
  logical ,save        :: carthessian ! should the Hessian be updated in 
                                      ! Cartesian coordinates (T) or internals (F)
  real(rk),allocatable,save :: eigvec(:,:)  ! (nihvar,nihvar) Hessian eigenmodes
  real(rk),allocatable,save :: eigval(:)    ! (nihvar) Hessian eigenvalues
  real(rk),allocatable,save :: storegrad(:) ! (nihvar) old gradient in fdhessian
  integer             ,save :: iupd ! actual number of Hessian updates
  real(rk),allocatable,save :: tsvector(:) ! (nihvar) Vector to follow in P-RFO
  ! The old arrays are set in formstep. Used there and in hessian_update
  real(rk),allocatable,save :: oldc(:)      ! (nihvar) old i-coords
  real(rk),allocatable,save :: oldgrad(:)   ! (nihvar) old i-coords
  real(rk)            ,save :: minstep      ! minimum step length for Hessian update to be performed
                                       ! set in formstep_init
  logical,save              :: fracrec ! recalculate a fraction of the hessian?
end module dlf_hessian

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* formstep/dlf_formstep
!!
!! FUNCTION
!!
!! The optimisation algorithm: calculate a step vector from the gradient
!! and possibly some gradient history information or hessian.
!!
!! Some optimisers are implemented here, some in their own files (L-BFGS,
!! P-RFO).
!!
!! INPUTS
!!
!! glob%igradient
!!
!!
!! OUTPUTS
!! 
!! glob%step
!!
!! SYNOPSIS
subroutine dlf_formstep
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr,stdout,printl,pi
  use dlf_formstep_module
  use dlf_hessian
  use dlf_allocate
  use dlf_constants, only : dlf_constants_get
  implicit none
  !
  real(rk)       :: oldstep(glob%nivar)
  real(rk)       :: svar,gamma
  logical        :: trestart
  integer        :: ivar,jvar
  real(rk),allocatable :: hess(:,:) ! for Newton-Raphson
  real(rk),allocatable :: ev2(:) ! for Newton-Raphson
  !real(rk),allocatable :: eigval(:) ! for Newton-Raphson
  real(rk),external :: ddot
  real(rk)       :: friction
  real(rk)       :: eigvalThreshold = 1.0d-10
  real(rk)       :: projGradient
  ! for NR-QTS
  real(rk)       :: beta_hbar,dtau,CM_INV_FOR_AMU,amu
! **********************************************************************
  select case (glob%iopt)

! ======================================================================
! Steepest descent
! ======================================================================
  case (0)

    glob%step(:)= -1.D0 * glob%igradient(:)
    if(glob%iline/=0)  glob%step(:)= glob%step(:)* glob%scalestep

! ======================================================================
! Conjugate gradient following Polak and Ribiere
! ======================================================================
  case (1)
    
    if(glob%toldenergy) then

      !Powell-Beale Restarts
      trestart= (&
          dot_product( oldg1(:) , glob%igradient(:)) .gt. &
          0.2D0 * dot_product( glob%igradient(:), glob%igradient(:)) )

      ! get old step from coordinate differences
      oldstep(:)=glob%icoords(:)-oldcoords(:)
      ! normalise?

      if(trestart) then
        gamma = 0.D0
        if(printl >= 2) print*,"Restarting CG algorithm"
      else

        ! should old gradient and old step be stored in the global module
        ! or internally here?
        gamma=dot_product( &
            glob%igradient(:)-oldg1(:) , glob%igradient(:) ) / &
            dot_product( oldg1(:) , oldg1(:) )
        if(printl>=6) print*,"Continuing CG algorithm"
      end if

      glob%step(:)= -1.D0 * glob%igradient(:) + gamma * oldstep(:)

    else
      ! first step: do an SD step
      glob%step(:)= -1.D0 * glob%igradient(:)
    end if
    oldg1(:)=glob%igradient(:)
    oldcoords(:)=glob%icoords(:)

! ======================================================================
! Conjugate gradient following Polak and Ribiere - better implementation
! ======================================================================
  case (2)
    ! oldcoords is the old search direction here!
    if(glob%toldenergy) then

      if(cgstep < maxcgstep) then

        gamma=ddot(glob%nivar,glob%igradient(:)-oldg1(:),1,&
            glob%igradient(:),1) / &
            ddot(glob%nivar,oldg1(:),1,oldg1(:),1)
        cgstep=cgstep+1
        if(gamma < 0.D0) gamma=0.D0
      else
        gamma = 0.D0
        oldcoords(:)=0.D0
        cgstep=0
        if(printl >= 4) write(stdout,'("Restarting CG algorithm")')

      end if

      glob%step(:)= -1.D0 * glob%igradient(:) + gamma * oldcoords(:)

    else
      ! first step: do an SD step
      glob%step(:)= -1.D0 * glob%igradient(:)
      cgstep=0
    end if
    
    oldg1(:)=glob%igradient(:)
    oldcoords(:)=glob%step(:)

    glob%step(:)=glob%step(:)*glob%scalestep

! ======================================================================
! L-BFGS
! ======================================================================
  CASE (3)

    CALL DLF_LBFGS_STEP(GLOB%ICOORDS,GLOB%IGRADIENT,GLOB%STEP)

! ======================================================================
! P-RFO
! ======================================================================
  CASE (10)

    ! Note in the microiterative case (where nihvar /= glob%nivar), we
    ! rely on icoords etc. being ordered with inner region first.

    ! store old coords and grad
    if(sum((oldc(:)-glob%icoords(1:nihvar))**2) > minstep ) then
      oldc(:)=glob%icoords(1:nihvar)
      oldgrad(:)=glob%igradient(1:nihvar)
    end if
    ! send information to set_tsmode
    call dlf_formstep_set_tsmode(1,-1,(/glob%energy/)) ! send energy
    call dlf_formstep_set_tsmode(glob%nvar,0,glob%xcoords) ! TS-geometry
    call dlf_prfo_step(nihvar, glob%icoords(1:nihvar), &
        glob%igradient(1:nihvar), glob%ihessian, glob%step(1:nihvar))

! ======================================================================
! Hessian and thermal analysis only
! ======================================================================
  CASE (9, 11, 12)
    ! do nothing

! ======================================================================
! Newton-Raphson
! ======================================================================
  CASE (20)
    if(.not.glob%havehessian) call dlf_fail("No Hessian present in Newton-Raphson")

    ! store Hessian
    call allocate(hess,glob%nivar,glob%nivar)
    call allocate(ev2,glob%nivar)
    hess(:,:)=glob%ihessian(:,:)

!    ivar = array_invert(hess,svar,.true.,glob%nivar)
!!$    ! full inverstion - only works without soft modes
!!$    call dlf_matrix_invert(glob%nivar,.false.,hess,svar)
!!$!    if(printl>=4) write(stdout,"('Determinant of H in NR step: ',es10.2)") svar

    ! Alternative: skip eigenvectors which belong to the 6 softest modes
    if(printl>=4) write(stdout,"('Diagonalizing the Hessian...')")
    call dlf_matrix_diagonalise(glob%nivar,glob%ihessian,eigval,hess)
    ev2=abs(eigval)
    soft=-0.1D0
    do ivar=1,glob%nzero
      soft=minval(ev2)
      ev2(minloc(ev2))=huge(1.D0)
    end do
    if(printl>=4) write(stdout,"('Criterion for soft modes in NR: ',es10.3)") soft

    if(glob%icoord==190) then
      call dlf_constants_get("AMU",amu)
      call dlf_constants_get("CM_INV_FOR_AMU",CM_INV_FOR_AMu)
    END if

    glob%step(:)=0.D0
    do ivar=1,glob%nivar
      if(abs(eigval(ivar))>soft) then
        if(ivar<=12.and.printl>=4.and.glob%icoord==190) then
          ! I am not sure how realistic these are with varying dtau
          svar=sqrt(abs(eigval(ivar)*dble(glob%nimage)*amu))*CM_INV_FOR_AMU
          if(eigval(ivar)<0.D0) svar=-svar
          write(stdout,'(" Eigval ",i2,1x,es10.3,2x,f10.3," cm^-1, used")') &
              ivar,eigval(ivar),svar
        end if
        eigval(ivar)=1.D0/eigval(ivar)
        ! for finding first-order saddle points:
        if(glob%icoord==190 .and. ivar>1 .and. eigval(ivar)<0.D0 ) then
          eigval(ivar)=-eigval(ivar)
          if(printl>=4) write(stdout,'("Inverted mode",i3)') ivar
        end if

        ! contribution to NR step
        svar=ddot(glob%nivar,hess(:,ivar),1,glob%igradient,1)
        glob%step=glob%step - hess(:,ivar) * eigval(ivar) * svar 

      else
        if(ivar<=12.and.printl>=4.and.glob%icoord==190) then
          svar=sqrt(abs(eigval(ivar)*dble(glob%nimage)*amu))*CM_INV_FOR_AMU
          if(eigval(ivar)<0.D0) svar=-svar
          write(stdout,'(" Eigval ",i2,1x,es10.3,2x,f10.3," cm^-1, ignored")') &
              ivar,eigval(ivar),svar
        end if
        eigval(ivar)=0.D0
      end if
    end do

    call deallocate(hess)
    call deallocate(ev2)
    
    ! store old coords and grad
    if(sum((oldc(:)-glob%icoords(:))**2) > minstep ) then
      oldc(:)=glob%icoords(:)
      oldgrad(:)=glob%igradient(:)
    end if

! ======================================================================
! Damped dynamics
! ======================================================================
  CASE (30)
    if(glob%toldenergy) then
      if(glob%energy<glob%oldenergy) then
        friction=fricm*glob%fricfac
        fricm=friction
      else
        if(printl>=4) write(stdout,"('Energy increasing, using high &
            &friction')")
        friction=glob%fricp
      end if
    else
      friction=glob%fric0
      fricm=friction
      oldcoords(:)=glob%icoords(:)
    end if
    glob%step(:)=1.D0/(1.D0+friction)*( &
        (1.D0-friction)*glob%icoords(:) - &
        (1.D0-friction)*oldcoords(:) - &
        glob%igradient(:)*glob%timestep**2 )

    !svar=sum(glob%step**2)*0.5D0/timestep**2+glob%energy
    !print*,"Total energy:",svar,"friction",friction

    oldcoords(:)=glob%icoords(:)

! ======================================================================
! Lagrange-Newton
! ======================================================================
  CASE (40)
    if(.not.glob%havehessian) call dlf_fail("No Hessian present in Newton-Raphson")

    ! Solving the equation for the step,
    !
    !    H s = -g
    ! =>   s = - H(-1) g
    !
    ! But matrix inversion is prone to numerical instabilities when the
    ! interstate coupling gradient is very small.
    !
    ! Therefore instead we diagonalise the Hessian matrix (following MNDO).
    !
    !      D = X(-1) H X
    !
    ! The step is then,
    !
    !      s = - X D(-1) X(-1) g
    !
    ! X, the matrix of eigenvectors, is simple to invert as X(-1) = X(t)
    ! D, the matrix of eigenvalues, is also straightforward as it is diagonal
    !
    call dlf_matrix_diagonalise(glob%nivar, glob%ihessian, eigval, eigvec)
    glob%step = 0.0d0
    do ivar = 1, glob%nivar
       if (abs(eigval(ivar)) > eigvalThreshold) then 
          projGradient = ddot(glob%nivar, eigvec(1, ivar), 1, glob%igradient, 1)
          do jvar = 1, glob%nivar
             glob%step(jvar) = glob%step(jvar) - &
                  (projGradient / eigval(ivar)) * eigvec(jvar, ivar)
          enddo
       endif
    enddo

    if (printl >= 6) then
       write(stdout, '(a)') "Hessian eigenvalues:"
       write(stdout, '(12f10.5)') eigval(:)
       write(stdout, '(a)') "Hessian eigenvectors:"
       do ivar = 1, glob%nivar
          write(stdout, '(12f10.5)') eigvec(ivar, :)
       end do
    end if

    ! store old coords and grad
    if(sum((oldc(:)-glob%icoords(:))**2) > minstep ) then
      oldc(:)=glob%icoords(:)
      call dlf_ln_savegrads
      ! Note oldgrad(:) is not used for LN, as the 'old' gradient
      ! for updating the Hessian has to be rebuilt with knowledge
      ! of the current Lagrange multipliers     
    end if

! ======================================================================
! Wrong optimisation type setting
! ======================================================================
  case default
    write(stderr,*) "Optimisation algorithm",glob%iopt,"not implemented"
    call dlf_fail("Optimisation algorithm error")

  end select
end subroutine dlf_formstep
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* formstep/dlf_formstep_restart
!!
!! FUNCTION
!!
!! Restart the optimisation algorithm.
!!
!! SYNOPSIS
subroutine dlf_formstep_restart
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr
  use dlf_formstep_module, only: cgstep,maxcgstep,fricm,oldcoords
  implicit none
! **********************************************************************
  select case (glob%iopt)
  case(2)
    cgstep = maxcgstep + 1 ! make sure CG is restarted
! L-BFGS
  case (3)
    call dlf_lbfgs_restart
  case (30)
    fricm=glob%fric0
    oldcoords(:)=glob%icoords(:)
  end select
  glob%toldenergy=.false.

  ! call an external routine (currently only used by ChemShell)
  call dlf_update()

end subroutine dlf_formstep_restart
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* formstep/dlf_formstep_init
!!
!! FUNCTION
!!
!! Allocate arrays for the optimisation algorithm.
!!
!!
!! SYNOPSIS
subroutine dlf_formstep_init(needhessian_)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr
  use dlf_formstep_module
  use dlf_hessian
  use dlf_allocate, only: allocate
  implicit none
  logical,intent(out)     :: needhessian_
! **********************************************************************
  fd_hess_running=.false.
  needhessian=.false.

  ! get Hessian values from global module
  soft=glob%soft
  ! To reproduce the old default "twopoint" behaviour, we default to 
  ! a two point FD Hessian if an external Hessian is selected but not
  ! available
  twopoint = (glob%inithessian == 2 .or. glob%inithessian == 0)
  carthessian=(glob%carthessian==1)
  follow=0 ! get from global eventually - IMPROVE
  tsmode=1
  minstep=glob%minstep

  ! energy not set in dlf_formstep_set_tsmode
  tenergy=.false.

  select case (glob%iopt)
! steepest descent
  case (1,2,30)
    call allocate(oldg1,glob%nivar)
    call allocate(g1,glob%nivar)
    call allocate(oldcoords,glob%nivar)
! L-BFGS
  case (3)
    call dlf_lbfgs_init(glob%nivar,glob%lbfgs_mem)
  case (9)
! fd-test
    needhessian=.true.
  case (10)
! P-RFO
    needhessian=.true.
    if (glob%imicroiter > 0) then
       call allocate(tsvector,glob%nicore)
    else
       call allocate(tsvector,glob%nivar)
    end if
    tsvector(:)=0.D0
    tsvectorset=.false.
  case (11,12)
! Hessian and thermal analysis only
    needhessian=.true.
! Newton-Raphson
  case (20, 40)
    needhessian=.true.
  end select

  ! allocate the global Hessian if required
  if(needhessian) then
    ! part of module dlf_hessian
    if (glob%imicroiter > 0) then
       ! In microiterative P-RFO only the inner region has a Hessian
       nihvar = glob%nicore
    else
       nihvar = glob%nivar
    end if
    call allocate(glob%ihessian,nihvar,nihvar)
    glob%ihessian=0.D0
    glob%havehessian=.false.
    ! set numfd just to init it, reset in fdhessian 
    numfd = nihvar

    ! update and PRFO
    call allocate(oldc,nihvar)
    oldc(:)=0.D0 ! initialise, as the question of update may depend on them
    call allocate(oldgrad,nihvar)
    iupd=0
    ! FD HESSIAN calculation
    call allocate(storegrad,nihvar)

    call allocate(eigval,nihvar)
    call allocate(eigvec,nihvar,nihvar)

  end if

  needhessian_=needhessian

  ! Initialise microiterative optimisation if required
  if (glob%imicroiter > 0) call dlf_microiter_init

end subroutine dlf_formstep_init
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* formstep/dlf_formstep_destroy
!!
!! FUNCTION
!!
!! Deallocate arrays for the optimisation algorithm.
!!
!!
!! SYNOPSIS
subroutine dlf_formstep_destroy
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr
  use dlf_formstep_module
  use dlf_hessian
  use dlf_allocate, only: deallocate
  implicit none
! **********************************************************************

  select case (glob%iopt)
! steepest descent
  case (1,2,30)
    if (allocated(oldg1)) call deallocate(oldg1)
    if (allocated(g1)) call deallocate(g1)
    if (allocated(oldcoords)) call deallocate(oldcoords)

! L-BFGS
  case (3)
    call dlf_lbfgs_destroy
! P-RFO
  case (10)
    if (allocated(tsvector)) call deallocate(tsvector)
  end select

  if(allocated(glob%ihessian)) then
    call deallocate(glob%ihessian)
    glob%havehessian=.false.

    if (allocated(oldc)) call deallocate(oldc)
    if (allocated(oldgrad)) call deallocate(oldgrad)

    ! FD HESSIAN calculation
    if (allocated(storegrad)) call deallocate(storegrad)

    if (allocated(eigval)) call deallocate(eigval)
    if (allocated(eigvec)) call deallocate(eigvec)

  end if

  if (glob%imicroiter > 0) call dlf_microiter_destroy

end subroutine dlf_formstep_destroy
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_checkpoint_formstep_write
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr
  use dlf_formstep_module
  use dlf_hessian
  use dlf_checkpoint, only: tchkform,write_separator
  implicit none
  ! YL 15/12/2020: we need avoid using file units ifunit, 101, or 102 to make Cray compiler happy
  !                see pp 141: http://103.251.184.12/wp-content/uploads/2018/01/Cray_Fortran_Reference_Manual_S-3901_86.pdf
  !                The values of INPUT_UNIT, OUTPUT_UNIT, and ERROR_UNIT defined in the ISO_Fortran_env module are
  !                ifunit, 101, and 102, respectively. These three unit numbers are reserved and may not be used for other purposes.
  !                The files connected to these units are the same files used by the companion C processor for standard input
  !                (stdin), output (stdout), and error (stderr). An asterisk (*) specified as the unit for a READ statement specifies unit
  !                ifunit. An asterisk specified as the unit for a WRITE statement, and the unit for PRINT statements is unit 101. All
  !                positive default integer values are available for use as unit numbers.
  integer, parameter :: ifunit = 104
! **********************************************************************

! Open the checkpoint file (it may result in an empty file)
  if(tchkform) then
    open(unit=ifunit,file="dlf_formstep.chk",form="formatted")
  else
    open(unit=ifunit,file="dlf_formstep.chk",form="unformatted")
  end if

! Data for dlf_formstep_set_tsmode
  if(allocated(tscoords).or.allocated(tsmode_r).or.tenergy) then
    call write_separator(ifunit,"TSMODE")

    ! write allocation status
    if(tchkform) then
      write(ifunit,*) allocated(tscoords), allocated(tsmode_r),tenergy
    else
      write(ifunit) allocated(tscoords), allocated(tsmode_r),tenergy
    end if

    if(allocated(tscoords)) then
      if(tchkform) then
        write(ifunit,*) tscoords(:)
      else
        write(ifunit) tscoords(:)
      end if
    end if

    if(allocated(tsmode_r)) then
      if(tchkform) then
        write(ifunit,*) tsmode_r(:)
      else
        write(ifunit) tsmode_r(:)
      end if
    end if

    if(tenergy) then
      if(tchkform) then
        write(ifunit,*) energy
      else
        write(ifunit) energy
      end if
    end if

    call write_separator(ifunit,"END TSM")
  end if

  select case (glob%iopt)

! Algorithms with no checkpoint:
  case (0, 11, 12, 20, 40, 51, 52)

! Conjugate gradient, damped dyn
  case (1:2,30)

    if(tchkform) then
      call write_separator(ifunit,"CG-Arrays")
      write(ifunit,*) cgstep,fricm
      write(ifunit,*) oldg1,g1,oldcoords
      call write_separator(ifunit,"END")
    else
      call write_separator(ifunit,"CG-Arrays")
      write(ifunit) cgstep,fricm
      write(ifunit) oldg1,g1,oldcoords
      call write_separator(ifunit,"END")
    end if

! L-BFGS
  CASE (3)

    CALL DLF_checkpoint_LBFGS_write

! P-RFO
  case (10)
    call write_separator(ifunit,"TS-vectorset")
    if(tchkform) then
      write(ifunit,*) tsvectorset
    else
      write(ifunit) tsvectorset
    end if
    if(tsvectorset) then
      call write_separator(ifunit,"TS-vector")
      if(tchkform) then
        write(ifunit,*) tsmode,tsvector
      else
        write(ifunit) tsmode,tsvector
      end if
    end if
    call write_separator(ifunit,"END")

! ======================================================================
! Wrong optimisation type setting
! ======================================================================
  case default
    write(stderr,'(a,i4,a)') "Optimisation algorithm",glob%iopt,"not implemented"
    call dlf_fail("Optimisation algorithm error")

  end select
  
  ! close dlf_formstep.chk
  close(ifunit)

! ======================================================================
! Write Hessian Data
! ======================================================================
  if(allocated(glob%ihessian)) then
    if(tchkform) then
      open(unit=ifunit,file="dlf_hessian.chk",form="formatted")
      call write_separator(ifunit,"Hessian size")
      write(ifunit,*) nihvar
      call write_separator(ifunit,"Hessian data")
      write(ifunit,*) glob%havehessian,fd_hess_running,iivar,direction,storeenergy,iupd,fracrec,numfd
      call write_separator(ifunit,"Hessian arrays")
      write(ifunit,*) glob%ihessian,oldc,oldgrad
      if(allocated(storegrad)) write(ifunit,*) storegrad
      call write_separator(ifunit,"END")
      close(ifunit)
    else
      open(unit=ifunit,file="dlf_hessian.chk",form="unformatted")
      call write_separator(ifunit,"Hessian size")
      write(ifunit) nihvar
      call write_separator(ifunit,"Hessian data")
      write(ifunit) glob%havehessian,fd_hess_running,iivar,direction,storeenergy,iupd,fracrec,numfd
      call write_separator(ifunit,"Hessian arrays")
      write(ifunit) glob%ihessian,oldc,oldgrad
      if(allocated(storegrad)) write(ifunit) storegrad
      call write_separator(ifunit,"END")
      close(ifunit)
    end if
  end if

end subroutine dlf_checkpoint_formstep_write

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subroutine dlf_checkpoint_formstep_read(tok)
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stdout,stderr
  use dlf_formstep_module
  use dlf_hessian
  use dlf_allocate, only: allocate, deallocate
  use dlf_checkpoint, only: tchkform, read_separator
  implicit none
  logical,intent(out) :: tok
  logical             :: tchk
  integer             :: var
  logical             :: alloc_tscoords,alloc_tsmode_r
  integer, parameter  :: ifunit = 104
! **********************************************************************
  tok=.false.

  ! check if checkpoint file exists
  INQUIRE(FILE="dlf_formstep.chk",EXIST=tchk)
  if(.not.tchk) then
    write(stdout,10) "File dlf_formstep.chk not found"
    return
  end if
  
  ! open the checkpoint file
  if(tchkform) then
    open(unit=ifunit,file="dlf_formstep.chk",form="formatted")
  else
    open(unit=ifunit,file="dlf_formstep.chk",form="unformatted")
  end if

! Data for dlf_formstep_set_tsmode
  call read_separator(ifunit,"TSMODE",tchk)
  if(tchk) then

    ! read allocation status and data
    if(tchkform) then
      read(ifunit,*,end=201,err=200) alloc_tscoords,alloc_tsmode_r,tenergy
    else
      read(ifunit,end=201,err=200) alloc_tscoords,alloc_tsmode_r,tenergy
    end if

    if(alloc_tscoords) then
      if(.not.allocated(tscoords)) call allocate(tscoords,glob%nvar)
      if(tchkform) then
        read(ifunit,*,end=201,err=200) tscoords(:)
      else
        read(ifunit,end=201,err=200) tscoords(:)
      end if
    else
      if(allocated(tscoords)) call deallocate(tscoords)
    end if

    if(alloc_tsmode_r) then
      if(.not.allocated(tsmode_r)) call allocate(tsmode_r,glob%nvar)
      if(tchkform) then
        read(ifunit,*,end=201,err=200) tsmode_r(:)
      else
        read(ifunit,end=201,err=200) tsmode_r(:)
      end if
    else
      if (allocated(tsmode_r)) call deallocate(tsmode_r)
    end if

    if(tenergy) then
      if(tchkform) then
        read(ifunit,*,end=201,err=200) energy
      else
        read(ifunit,end=201,err=200) energy
      end if
    end if

    call read_separator(ifunit,"END TSM",tchk)
    if(.not.tchk) return

  else
    ! the checkpoint file has to be reopened
    if(tchkform) then
      open(unit=ifunit,file="dlf_formstep.chk",form="formatted")
    else
      open(unit=ifunit,file="dlf_formstep.chk",form="unformatted")
    end if
  end if

  select case (glob%iopt)

! ======================================================================
! Algorithms with no checkpoint
! ======================================================================
  case (0,11,12,20, 40, 51, 52)

    tok=.true.

! ======================================================================
! Algorithms with checkpoint handled here: Conjugate gradient, damped
! dynamics
! ======================================================================
  case (1:2,30)

    call read_separator(ifunit,"CG-Arrays",tchk)
    if(.not.tchk) return 
    
    if(tchkform) then
      read(ifunit,*,end=201,err=200) cgstep,fricm
      read(ifunit,*,end=201,err=200) oldg1,g1,oldcoords
    else
      read(ifunit,end=201,err=200) cgstep,fricm
      read(ifunit,end=201,err=200) oldg1,g1,oldcoords
    end if

    call read_separator(ifunit,"END",tchk)
    if(.not.tchk) return

! ======================================================================
! L-BFGS
! ======================================================================
  CASE (3)

    CALL DLF_checkpoint_LBFGS_read(tok)
    return

! P-RFO
  case (10)

    call read_separator(ifunit,"TS-vectorset",tchk)
    if(.not.tchk) return 

    if(tchkform) then
      read(ifunit,*,end=201,err=200) tsvectorset
    else
      read(ifunit,end=201,err=200) tsvectorset
    end if

    if(tsvectorset) then
      call read_separator(ifunit,"TS-vector",tchk)
      if(.not.tchk) return 

      if(tchkform) then
        read(ifunit,*,end=201,err=200) tsmode,tsvector
      else
        read(ifunit,end=201,err=200) tsmode,tsvector
      end if
    end if
    call read_separator(ifunit,"END",tchk)
    if(.not.tchk) return

! ======================================================================
! Wrong optimisation type setting
! ======================================================================
  case default
    write(stderr,'(a,i4,a)') "Optimisation algorithm",glob%iopt,"not implemented"
    call dlf_fail("Optimisation algorithm error")

  end select

  ! close dlf_formstep.chk
  close(ifunit)

! ======================================================================
! Read Hessian Data
! ======================================================================
  if(allocated(glob%ihessian)) then
    tok=.false.
    ! check if checkpoint file exists
    INQUIRE(FILE="dlf_hessian.chk",EXIST=tchk)
    if(.not.tchk) then
      write(stdout,10) "File dlf_hessian.chk not found"
      return
    end if
    if(tchkform) then
      open(unit=ifunit,file="dlf_hessian.chk",form="formatted")
    else
      open(unit=ifunit,file="dlf_hessian.chk",form="unformatted")
    end if

    call read_separator(ifunit,"Hessian size",tchk)
    if(.not.tchk) return

    if(tchkform) then
      read(ifunit,*,end=201,err=200) var
    else
      read(ifunit,end=201,err=200) var
    end if
    if(var/=nihvar) then
      print*,var,nihvar
      write(stdout,10) "Inconsistent Hessian size"
      close(ifunit)
      return
    end if

    call read_separator(ifunit,"Hessian data",tchk)
    if(.not.tchk) return 

    if(tchkform) then
      read(ifunit,*,end=201,err=200) glob%havehessian,fd_hess_running,iivar, &
          direction,storeenergy,iupd,fracrec,numfd
    else
      read(ifunit,end=201,err=200) glob%havehessian,fd_hess_running,iivar, &
          direction,storeenergy,iupd,fracrec,numfd
    end if

    call read_separator(ifunit,"Hessian arrays",tchk)
    if(.not.tchk) return 

    if(tchkform) then
      read(ifunit,*,end=201,err=200) glob%ihessian,oldc,oldgrad
    else
      read(ifunit,end=201,err=200) glob%ihessian,oldc,oldgrad
    end if
    if(allocated(storegrad)) then
      if(tchkform) then
        read(ifunit,*,end=201,err=200) storegrad
      else
        read(ifunit,end=201,err=200) storegrad
      end if
    end if
    call read_separator(ifunit,"END",tchk)
    if(.not.tchk) return 

    close(ifunit)
  end if

  tok=.true.
  return

  ! return on error
200 continue
  write(stdout,10) "Error reading CG/Hessian checkpoint file"
  return
201 continue
  write(stdout,10) "Error (EOF) reading CG/Hessian checkpoint file"
  return

10 format("Checkpoint reading WARNING: ",a)


end subroutine dlf_checkpoint_formstep_read

! **********************************************************************
! **                                                                  **
! **        DL-FIND Hessian Routines (including P-RFO)                **
! **                                                                  **
! **                                                                  **
! **                                                                  **
! **                                                                  **
! **                                                                  **
! **********************************************************************

!!****h* formstep/hessian
!!
!! NAME
!! hessian
!!
!! FUNCTION
!! Calculate (and use) the hessian. Includes P-RFO
!!
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* hessian/dlf_makehessian
!!
!! FUNCTION
!!
!! called from the main cycle in dl-find
!! Build up a Hessian by either:
!! * Reading it in from external sources (dlf_get_hessian)
!! * Updating an existing Hessian
!! * Building it from scratch by finite-difference
!! * Setting it to the identity matrix
!! * Improving an existing Hessian by finite-difference in its eigenmodes
!!
!! SYNOPSIS
subroutine dlf_makehessian(trerun_energy,tconv)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stdout,printl
  use dlf_stat, only: stat
  use dlf_constants, only: dlf_constants_get
  use dlf_allocate
  use dlf_hessian
  implicit none
  logical, intent(inout) :: trerun_energy
  logical, intent(inout) :: tconv
  integer                :: status
  integer                :: iimage ! not used here
  logical                :: was_updated,tok
  ! this should be improved ...
  ! real(rk) :: hess_loc(glob%nvar,glob%nvar)
  real(rk),allocatable :: hess_loc(:,:) !glob%nvar,glob%nvar)
  real(rk),allocatable :: mass(:) 
  real(rk) :: svar,arr2(2)
  integer :: i,ivar
! **********************************************************************
  ! Don't update the Hessian on a microiterative step
  ! as the Hessian only applies to the inner (P-RFO) region
  if (glob%imicroiter == 2) return

  if (glob%icoord >= 10 .and. glob%icoord <= 19) then
     if (glob%imicroiter > 0) call dlf_fail("microiterative LN not implemented")
     call dlf_conint_make_ln_hess(trerun_energy,tconv)
     return
  endif

  if(glob%icoord==190) then
    if (glob%imicroiter > 0) call dlf_fail("microiterative qts not implemented") 
    call dlf_qts_get_hessian(trerun_energy)
    call qts_hessian_etos_halfpath 
    !
    return
    !
  end if

  ! read hessian if inithessian=5
  if (glob%inithessian == 5) then
    if (glob%imicroiter > 0) call dlf_fail("microiterative qts not implemented")
    ivar=1
    call allocate(mass,glob%nat)
    call read_qts_hessian(glob%nat,ivar,glob%nivar,glob%temperature,&
        svar,glob%xcoords,glob%ihessian,svar,arr2,mass,"",tok)
    if(.not.tok) call dlf_fail("Reading Hessian from file failed")
    if(ivar/=1) call dlf_fail("Hessian must contain one image")
    call deallocate(mass)
    call dlf_constants_get("AMU",svar)
    glob%ihessian=glob%ihessian*svar !*(1.66054D-27/9.10939D-31)
    call dlf_matrix_diagonalise(glob%nivar,glob%ihessian,eigval,eigvec)
    if (printl>=4 .or. (glob%iopt==11 .and. printl>=2)) then      
      write(stdout,"(/,'Hessian eigenvalues:')")
      write(stdout,"(12f9.5)") eigval
    end if
    glob%havehessian=.true.
    return
  end if

  call dlf_hessian_update(nihvar, glob%icoords(1:nihvar), oldc, &
       glob%igradient(1:nihvar), oldgrad, glob%ihessian, &
       glob%havehessian, fracrec, was_updated)
  ! issue: since was_updated is not used any more, oldgrad will be wrong for too large minstep
  
  if(.not.glob%havehessian) then

    if(.not. fd_hess_running) then
      ! test for convergence before calculating the Hessian
      ! skip that if Hessian calculation is the main task
      if(glob%iopt/=11.and.glob%iopt/=12) then
        call convergence_test(stat%ccycle,.true.,tconv)
        if(tconv) return
      end if

      if (glob%inithessian == 4) then
         ! Initial Hessian is the identity matrix
         glob%ihessian = 0.0d0
         do i = 1, nihvar
            glob%ihessian(i, i) = 1.0d0
         end do
         glob%havehessian = .true.
      end if

      if (glob%inithessian == 0) then
         if (glob%imicroiter > 0) call dlf_fail(&
              "inithessian = 0 with microiterative opt not yet implemented")
         ! try to get an analytic Hessian - care about allocation business
         ! call to an external routine ...
         call allocate(hess_loc,glob%nvar,glob%nvar)
         call dlf_get_hessian(glob%nvar,glob%xcoords,hess_loc,status)
         if(status==0.and.printl>=4) write(stdout,"('Analytic hessian calculated')")
         !switch:
         !status=1
         
         if(status==0) then
            !        write(*,"('HESS',2F10.2)") HESS_LOC
            ! convert it into internals
            call clock_start("COORDS")
            !     write(*,"('xHESS',12F10.4)") HESS_LOC
            call dlf_coords_hessian_xtoi(glob%nvar,hess_loc)
            !     write(*,"('iHESS',8F10.4)") glob%ihessian
            call clock_stop("COORDS")
            glob%havehessian=.true.
         else
            if(printl>=2) write(stdout,'(a)') &
                 "External Hessian not available, using two point FD."
         end if
         call deallocate(hess_loc)
      end if
    end if

    if(.not.glob%havehessian) then

      if (glob%inithessian == 3) then
         ! Simple diagonal Hessian a la MNDO
         call dlf_diaghessian(nihvar, glob%energy, glob%icoords(1:nihvar), &
              glob%igradient(1:nihvar), glob%ihessian, glob%havehessian)
      else
         ! Finite Difference Hessian calculation in internal coordinates
         ! dlf_fdhessian writes fd_hess_running
         call dlf_fdhessian(nihvar, fracrec, glob%energy, glob%icoords(1:nihvar), &
              glob%igradient(1:nihvar), glob%ihessian, glob%havehessian)
      end if

      ! check if FD-Hessian calculation currently running
      trerun_energy=(fd_hess_running) 
      if(trerun_energy) then
        call clock_start("COORDS")
        call dlf_coords_itox(iimage)
        call clock_stop("COORDS")
      end if

    end if

    if(glob%havehessian) then
      ! Print out Hessian if running Hessian evaluation only or if debugging
      if (printl>=6 .or. (glob%iopt==11 .and. printl>=2)) then
        write(stdout,"(/,'Symmetrised Hessian matrix (DL-FIND coordinates):')")
        call dlf_matrix_print(nihvar, nihvar, glob%ihessian)
      end if
      ! Determine eigenvalues and eigenvectors
      call dlf_matrix_diagonalise(nihvar,glob%ihessian,eigval,eigvec)
      if (printl>=4 .or. (glob%iopt==11 .and. printl>=2)) then      
         write(stdout,"(/,'Hessian eigenvalues:')")
         write(stdout,"(12f9.5)") eigval
      end if
   end if

 end if

end subroutine dlf_makehessian
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* hessian/dlf_diaghessian
!!
!! FUNCTION
!!
!! Calculate a simple diagonal Hessian by one-point finite difference,
!! much like the default behaviour of the standard MNDO optimiser.
!!
!! Fracrecalc is not applicable here as it makes no sense to partially update
!! an already available Hessian with a diagonal Hessian
!!
!! SYNOPSIS
subroutine dlf_diaghessian(nvar_,energy,coords,gradient,hess,havehessian)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stdout,printl
  use dlf_hessian
  implicit none
  !
  integer,intent(in)     :: nvar_ ! Number of variables 
  real(rk),intent(inout) :: energy          ! at the 2nd step out
  real(rk),intent(inout) :: coords(nvar_)   ! always changed
  real(rk),intent(inout) :: gradient(nvar_) ! at the 2nd step out
  real(rk),intent(inout) :: hess(nvar_,nvar_)
  logical,intent(out)    :: havehessian
  integer                :: i
  real(rk)               :: dx
  real(rk)               :: svar
! **********************************************************************

  if(.not.fd_hess_running) then
    ! First step - initialise
     if(printl >= 4) then
        write(stdout,'(A)') &
             "Finite-difference calculation for a diagonal Hessian"
     end if

     ! backup energy and gradient so it can be restored after Hessian calc
     storeenergy = energy
     storegrad(1:nvar_) = gradient(:)

     hess = 0.0d0
     ! move to the 2nd point, backwards along the gradient
     do i = 1, nvar_
        coords(i) = coords(i) - sign(glob%delta, gradient(i))
     end do

     fd_hess_running = .true.
     havehessian = .false.
   
     if(printl >= 4) then
        write(stdout,'("Delta : ",es10.2)') glob%delta
     end if

     return
  end if ! End of initialisation step


  ! Second step - calculate diagonal Hessian
  if(printl>=4) then
    write(stdout,"('Finite-difference diagonal Hessian: 2nd point')")
    write(stdout,"('Energy difference to 1st point:        ',es10.2,' H')") energy-storeenergy
    svar=sqrt(sum((gradient(:)-storegrad(1:nvar_))**2))
    write(stdout,"('Abs. Gradient difference to 1st point: ',es10.2)") svar
  end if

  ! calculate Hessian and restore coordinates
  do i = 1, nvar_
     dx = sign(glob%delta, storegrad(i))
     hess(i, i) = (storegrad(i) - gradient(i)) / dx
     ! Hessian should be positive
     if (hess(i, i) < 0.0d0) hess(i, i) = abs(storegrad(i)) / glob%delta
     ! Minimum threshold set to identity matrix element
     hess(i, i) = max(hess(i, i), 1.0d0)
     coords(i) = coords(i) + dx   
  end do

  ! restore energy and gradient
  energy = storeenergy
  gradient(:) = storegrad(1:nvar_)
  
  fd_hess_running=.false.
  havehessian=.true.

end subroutine dlf_diaghessian
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* hessian/dlf_fdhessian
!!
!! FUNCTION
!!
!! Calculate the Hessian by finite differencing.
!!
!! One-point and Two-point formulas are available.
!!
!! If Fracrecalc is true, only part of the Hessian is recalculated:
!! The Hessian is expressed in its eigenmodes. Finite-difference elongations
!! along the lowest eigenmodes are calculated. The gradient is transformed
!! back into the eigenmode-space. Finally, the Hessian is transformed back
!! into coordinate space. Frac_recalc is only used if a Hessian is
!! already available, and if do_partial_fd (in _update) is true.
!!
!! SYNOPSIS
subroutine dlf_fdhessian(nvar_,fracrecalc,energy,coords,gradient,hess,havehessian)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stdout,printl
  use dlf_allocate, only: allocate, deallocate
  use dlf_hessian
  implicit none
  !
  integer,intent(in)     :: nvar_ ! Number of variables 
  logical,intent(inout)  :: fracrecalc ! Recalculate only fraction
  real(rk),intent(inout) :: energy          ! at the last step out
  real(rk),intent(inout) :: coords(nvar_)   ! always changed
  real(rk),intent(inout) :: gradient(nvar_) ! at the last step out
  real(rk),intent(inout) :: hess(nvar_,nvar_)
  logical,intent(out)    :: havehessian
  integer                :: status ! parallel FD check
  integer                :: fail,ivar,jvar,taskfarm_mode
  real(rk)               :: svar
  real(rk),allocatable   :: tmpmat(:,:)
! **********************************************************************
  if(.not.fd_hess_running) then
    ! First step - initialise
    if(fracrecalc) then

      ! all negative, "zero", and the first positive (i.e. > soft) modes
      ! will be recalculated.

      ! Diagonalise the present Hessian
      call dlf_matrix_diagonalise(nvar_,hess,eigval(1:nvar_),eigvec(1:nvar_,1:nvar_))
      !write(stdout,"('eigval-pa',12f10.4)") eigval

      do ivar=1,nvar_
        if(eigval(ivar)>max(soft,0.D0)) exit
      end do

      if(printl >= 4) then
        write(stdout,'(A,i3,a)') "Finite-difference calculation of the", &
            ivar," lowest Hessian eigenmodes"
      end if
      numfd = ivar
    else
      if(printl >= 4) then
        write(stdout,'(A)') &
            "Finite-difference calculation of the whole Hessian"
      end if
      numfd = nvar_
    end if
    iivar=1
    direction=1 ! do first 1, then -1

    ! Task-farming allocation based on iivar
    ! For full Hessian calculations only 
    ! (standalone Hessian calcs in mind rather than optimisations)
    ! To extend to fracrecalc case, would need to consider how to deal
    ! with non-zero initial Hessian when sharing data
    call dlf_qts_get_int("TASKFARM_MODE",taskfarm_mode)
    if (.not. fracrecalc .and. glob%ntasks > 1.and.taskfarm_mode==1) then
       glob%dotask = (mod(iivar,glob%ntasks) == glob%mytask)
    end if

    storeenergy=energy
    ! keep gradient and restore it when Hessian has finished
    storegrad(1:nvar_)=gradient(:)

    fd_hess_running=.true.

    if(fracrecalc) then
      hess=0.D0
      do ivar=1,nvar_
        hess(ivar,ivar)=eigval(ivar)
      end do

      ! do the step
      coords(:)=coords(:) + glob%delta * eigvec(1:nvar_,1)

    else
      hess=0.D0

      ! do the step
      coords(1)=coords(1)+glob%delta

    end if

    

    havehessian=.false.

    if(printl >= 4) then
      write(stdout,'("Delta : ",es10.2)') glob%delta
    end if

    return
    
  end if !(.not.fd_hess_running)

  if(printl>=4 .and. glob%dotask) then
    write(stdout,"('Finite-difference Hessian: variable ',i4,'/',i4,&
        &' direction=',i2)") iivar,numfd,direction
  end if
  if(printl>=3 .and. glob%dotask) then
    write(stdout,"('Energy difference to midpoint:        ',es10.2,' H')") energy-storeenergy
    svar=sqrt(sum((gradient(:)-storegrad(1:nvar_))**2))
    write(stdout,"('Abs. Gradient difference to midpoint: ',es10.2)") svar
  end if

  ! The values of iivar and direction are those for which the gradient is currently available

  if(iivar<numfd.or. (twopoint.and.direction==1) ) then
    ! general step in the course of Hessian calculation

    if(direction==1.and.twopoint) then
      if (glob%dotask) then
        hess(iivar,:)=gradient(:)
      end if
      direction=-1
      if(fracrecalc) then
        coords(:)=coords(:) - 2.D0 * glob%delta * eigvec(1:nvar_,iivar)
      else
        coords(iivar)=coords(iivar)-2.D0*glob%delta
      end if
    else
      if(twopoint) then
        !set back coordinates
        if(fracrecalc) then
          gradient(:)=(hess(iivar,:)-gradient(:))/(2.D0*glob%delta)
          call dlf_matrix_multiply(1,nvar_,nvar_,1.D0,gradient,eigvec(1:nvar_,1:nvar_), &
               0.D0,hess(iivar,:))
          coords(:)=coords(:) + glob%delta * eigvec(1:nvar_,iivar)
        else
          if (glob%dotask) then
            hess(iivar,:)=(hess(iivar,:)-gradient(:))/(2.D0*glob%delta)
          end if
          coords(iivar)=coords(iivar)+glob%delta
        end if
        direction=1
      else
        if(fracrecalc) then
          gradient(:)=(gradient(:)-storegrad(1:nvar_)) / glob%delta
          call dlf_matrix_multiply(1,nvar_,nvar_,1.D0,gradient,eigvec(1:nvar_,1:nvar_), &
               0.D0,hess(iivar,:))
          coords(:)=coords(:) - glob%delta * eigvec(1:nvar_,iivar)
        else
          if (glob%dotask) then 
            hess(iivar,:)=(gradient(:)-storegrad(1:nvar_)) / glob%delta
          end if
          coords(iivar)=coords(iivar)-glob%delta
        end if
      end if
      iivar=iivar+1
      ! Task-farming: next allocation
      call dlf_qts_get_int("TASKFARM_MODE",taskfarm_mode)
      if (.not. fracrecalc .and. glob%ntasks > 1.and.taskfarm_mode==1) then
        glob%dotask = (mod(iivar,glob%ntasks) == glob%mytask)
      end if
      if(fracrecalc) then
        coords(:)=coords(:) + glob%delta * eigvec(1:nvar_,iivar)
      else
        coords(iivar)=coords(iivar)+glob%delta
      end if
    end if
      
    havehessian=.false.
      
  else !(iivar<numfd.or. (twopoint.and.direction==1) )
    ! final step: calculate Hessian and deallocate
    !set back coordinates
    if(twopoint) then
      if(fracrecalc) then
        gradient(:)=(hess(iivar,:)-gradient(:))/(2.D0*glob%delta)
        call dlf_matrix_multiply(1,nvar_,nvar_,1.D0,gradient,eigvec(1:nvar_,1:nvar_), &
             0.D0,hess(iivar,:))
        coords(:)=coords(:) + glob%delta * eigvec(1:nvar_,iivar)
      else
        if (glob%dotask) then 
           hess(iivar,:)=(hess(iivar,:)-gradient(:))/(2.D0*glob%delta)
        end if
        coords(iivar)=coords(iivar)+glob%delta
      end if
    else
      if(fracrecalc) then
        gradient(:)=(gradient(:)-storegrad(1:nvar_)) / glob%delta
        call dlf_matrix_multiply(1,nvar_,nvar_,1.D0,gradient,eigvec(1:nvar_,1:nvar_), &
             0.D0,hess(iivar,:))
        coords(:)=coords(:) - glob%delta * eigvec(1:nvar_,iivar)
      else
        if (glob%dotask) then 
          hess(iivar,:)=(gradient(:)-storegrad(1:nvar_)) / glob%delta
        end if
        coords(iivar)=coords(iivar)-glob%delta
      end if
    end if

    ! Task-farming: check no gradient evaluations in other workgroups failed
    ! then share Hessian data
    call dlf_qts_get_int("TASKFARM_MODE",taskfarm_mode)
    if (.not. fracrecalc .and. glob%ntasks > 1.and.taskfarm_mode==1) then
       ! If it has got here all calcs on this workgroup have succeeded
       status = 0
       call dlf_tasks_int_sum(status, 1)
       if (status > 0) then
          call dlf_fail("Task-farmed gradient evaluations failed")
       end if
       call dlf_tasks_real_sum(hess, nvar_*nvar_)
    end if

    ! Symmetrise the Hessian
    if(fracrecalc) then

      ! build up the Hessian

      ! symmetrise
      do ivar=1,numfd
        do jvar=ivar+1,nvar_
          if(jvar<=numfd) then
            hess(ivar,jvar)=0.5D0*(hess(ivar,jvar)+hess(jvar,ivar))
            hess(jvar,ivar)=hess(ivar,jvar)
          else
            hess(jvar,ivar)=hess(ivar,jvar)
          end if
        end do
      end do

      ! Multiply with the eigenvectors to restore the real Hessian
      call allocate(tmpmat,nvar_,nvar_)
      eigvec(1:nvar_,1:nvar_) = transpose(eigvec(1:nvar_,1:nvar_))
      call dlf_matrix_multiply(nvar_,nvar_,nvar_,1.D0,hess,eigvec(1:nvar_,1:nvar_),0.D0,tmpmat)
      eigvec(1:nvar_,1:nvar_) = transpose(eigvec(1:nvar_,1:nvar_))
      call dlf_matrix_multiply(nvar_,nvar_,nvar_,1.D0,eigvec(1:nvar_,1:nvar_),tmpmat,0.D0,hess)
      call deallocate(tmpmat)
      
    else
      do ivar=1,numfd
        do jvar=ivar+1,numfd
          hess(ivar,jvar)=0.5D0*(hess(ivar,jvar)+hess(jvar,ivar))
          hess(jvar,ivar)=hess(ivar,jvar)
        end do
      end do
    end if

    ! restore energy and gradient
    energy=storeenergy
    gradient(:)=storegrad(1:nvar_)

    fd_hess_running=.false.
    havehessian=.true.
    call dlf_qts_get_int("TASKFARM_MODE",taskfarm_mode)
    if(taskfarm_mode==1) glob%dotask = .true.

  end if ! (iivar<numfd.or. (twopoint.and.direction==1) )

end subroutine dlf_fdhessian
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* hessian/dlf_test_delta
!!
!! FUNCTION
!!
!! Test various different values of delta for calculating a Hessian by
!! a two-point finite-difference of the gradients.
!!
!! For numdelta=9 (hardcoded), 19 Energy and gradient calculations are
!! performed. The elongations are always calculated for the first
!! element in the coordinates array. The different values for the
!! first diagonal element of the resulting Hessian are plotted at the
!! end.
!!
!! This routine is called if iopt=9
!!
!! SYNOPSIS
subroutine dlf_test_delta(trerun_energy)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stdout,printl
  use dlf_hessian
  implicit none
  logical,intent(out):: trerun_energy
  integer,parameter :: numdelta=9 ! hardcoded for the time being
  real(rk),save     :: dder(numdelta)
  real(rk)          :: delta(numdelta)
  integer           :: ivar
  real(rk)          :: svar
  logical           :: tok
! **********************************************************************

  if(.not.allocated(storegrad)) then
    call dlf_fail("Hessian module must be initiated when dlf_test_delta is called")
  end if

  if (glob%imicroiter > 0) then
     call dlf_fail('dlf_test_delta not yet compatible with microiterative PRFO')
  end if

  trerun_energy=.true.
  ! set the values of delta to try out
  delta(1)=0.0001D0
  delta(2)=0.0002D0
  delta(3)=0.0005D0
  do ivar=4,numdelta
    delta(ivar)=delta(ivar-3)*10.D0
  end do

  if(.not.fd_hess_running) then
    ! First step - initialise

    iivar=1
    direction=1 ! do first 1, then -1
    storeenergy=glob%energy
    ! keep gradient and restore it when Hessian has finished
    storegrad(:)=glob%igradient(:)

    fd_hess_running=.true.

    dder=0.D0
    ! do first step
    glob%icoords(1)=glob%icoords(1)+delta(1)

  else !(.not.fd_hess_running)

    ! intermediate steps

    if(printl>=4) then
      write(stdout,"('Finite-difference Hessian test calculation ',i4,'/',i4,&
          &' direction=',i2)") iivar,numdelta,direction
    end if
    if(printl>=3) then
      write(stdout,'("Delta :                               ",es10.2)') delta(iivar)
      write(stdout,"('Energy difference to midpoint:        ',es10.2,' H')") glob%energy-storeenergy
      svar=sqrt(sum((glob%igradient(:)-storegrad(:))**2))
      write(stdout,"('Abs. Gradient difference to midpoint: ',es10.2)") svar
    end if

    ! The values of iivar and direction are those for which the gradient is currently available

    if(iivar<numdelta.or. direction==1 ) then
      ! general step in the course of Hessian calculation

      if(direction==1) then
        dder(iivar)=glob%igradient(1)
        direction=-1
        glob%icoords(1)=glob%icoords(1)-2.D0*delta(iivar)
      else
        !set back coordinates
        dder(iivar)=(dder(iivar)-glob%igradient(1))/(2.D0*delta(iivar))
        if(printl>=4) then
          write(stdout,'("Delta: ",es10.3," First diagonal element of the &
              &Hessian: ",es20.13)') delta(iivar),dder(iivar)
        end if
        glob%icoords(1)=glob%icoords(1)+delta(iivar)

        direction=1
        iivar=iivar+1

        glob%icoords(1)=glob%icoords(1)+delta(iivar)
      end if
    else ! (iivar<numdelta.or. direction==1 )
      ! final step: calculate Hessian and deallocate
      !set back coordinates
      dder(iivar)=(dder(iivar)-glob%igradient(1))/(2.D0*delta(iivar))
      glob%icoords(1)=glob%icoords(1)+delta(iivar)

      ! restore energy and gradient
      glob%energy=storeenergy
      glob%igradient(:)=storegrad(:)

      fd_hess_running=.false.

      !havehessian=.true.
      trerun_energy=.false.

      ! print report!
      if(printl>=2) then
        write(stdout,*) "Delta    First diagonal element of the Hessian"
        do ivar=1,numdelta
          write(stdout,'(es10.3,es20.13)') delta(ivar),dder(ivar)
        end do
      end if
      
    end if ! (iivar<numdelta.or. direction==1 )
      
  end if ! (.not.fd_hess_running)

  ! transform coordinates back to xcoords
  call dlf_direct_itox(glob%nvar,glob%nivar,glob%nicore,glob%icoords,glob%xcoords,tok)
  if(.not.tok.and. mod(glob%icoord,10)>0 .and. mod(glob%icoord,10)<=4 ) then
    call dlf_fail('HDLC coordinate breakdown')
  end if

end subroutine dlf_test_delta
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* hessian/dlf_hessian_update
!!
!! FUNCTION
!!
!! Update the global Hessian
!!
!! If we do not have a Hessian, there is nothing to update. Return.
!!
!! If we have one, and are allowed to update it, update it. If too many
!!  updates have been made, destroy and recalculate it.
!!
!! COMMENTS
!!
!! The gradient, coordinates and hessian are passed to and from the
!! routine through the arguments and are therefore independent of the
!! data stored in glob. This is useful for the Lagrange-Newton method
!! where the optimiser gradient is not necessarily the same as the 
!! gradient used for the update of the Hessian.
!!
!! INPUTS
!!
!! nvar - dimensions of gradient, coordinates, Hessian
!! coords(nvar) - current coordinates
!! oldcoords(nvar) - coordinates of previous step
!! gradient(nvar) - current gradient
!! oldgradient(nvar) - gradient of previous step
!! havehessian - if false return as no update is possible
!! fracrecalc
!! glob%update - specifies which update algorithm to use
!! glob%maxupd - check that max no. of updates is not exceeded
!! glob%nivar - check that nvar is consistent
!! glob%icoord - for check of consistency of nvar
!! (dlf_hessian) fd_hess_running
!! (dlf_hessian) iupd - no. of updates since last reset
!!
!! OUTPUTS
!! 
!! hess(nvar, nvar) - the updated Hessian in internal coordinates
!! havehessian - false if no update requested or max updates reached
!! fracrecalc
!! (dlf_hessian) iupd - no. of updates since last reset
!!
!! SYNOPSIS
subroutine dlf_hessian_update(nvar, coords, oldcoords, gradient, &
     oldgradient, hess, havehessian, fracrecalc, was_updated)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stdout, stderr, printl
  use dlf_hessian
  implicit none
  integer,intent(in)    :: nvar ! used for temporary storage arrays
  real(rk),intent(in) :: coords(nvar)   
  real(rk),intent(in) :: oldcoords(nvar)
  real(rk),intent(in) :: gradient(nvar)
  real(rk),intent(in) :: oldgradient(nvar)
  real(rk),intent(inout) :: hess(nvar,nvar)
  logical,intent(inout) :: havehessian
  logical,intent(inout) :: fracrecalc ! recalculate fraction of Hessian
  logical,intent(out)   :: was_updated ! at return: was the Hessian updated here?
  ! temporary arrays
  real(rk) :: fvec(nvar),step(nvar), tvec(nvar)
  real(rk) :: fx_xx,xx,svar,bof, dds, ddtd
  real(RK) ,external :: ddot
  integer  :: ivar,jvar
  logical,parameter :: do_partial_fd=.false. ! Current main switch!
! **********************************************************************

  was_updated=.false.

  if(.not.fd_hess_running) fracrecalc=.false.
  if(.not.havehessian.or.glob%update==0) then
    havehessian=.false.
    return
  end if

  ! Check for maximum number of updates reached
  ! In case of partial finite-difference, do an update first, then return and 
  ! Recalculate the lower modes
  if(iupd>=glob%maxupd .and. .not. do_partial_fd) then
    havehessian=.false.
    iupd=0
    hess = -1.D0
    fracrecalc=.false.
    return
  end if

  if (glob%icoord >= 10 .and. glob%icoord <= 19) then
    if (nvar /= glob%nivar - 2) &
        call dlf_fail("Inconsistent Lagrange-Newton nvar in dlf_hessian_update")
  elseif(glob%icoord == 190 ) then
    continue
  elseif(glob%imicroiter > 0) then
     if (nvar /= glob%nicore) &
        call dlf_fail("Inconsistent microiterative nvar in dlf_hessian_update")
  elseif(nvar/=glob%nivar) then
      call dlf_fail("Inconsistent nvar in dlf_hessian_update")
  endif

  ! Useful variables for updating
  fvec(:) = gradient(:) - oldgradient(:)
  step(:) = coords(:) - oldcoords(:)

  xx=ddot(nvar,step,1,step,1)
  if(xx <= minstep ) then
    if(printl>=2) write(stdout,"('Step too small. Skipping hessian update')")
    return
  end if

  iupd=iupd+1

  if(printl>=3) then
     select case (glob%update)
     case(1)
        write(stdout,"('Updating Hessian with the Powell update, No ',i5)") iupd
     case(2)
        write(stdout,"('Updating Hessian with the Bofill update, No ',i5)") iupd
     case(3)
        write(stdout,"('Updating Hessian with the BFGS update, No ',i5)") iupd
     end select
  end if
    
  select case (glob%update)
  case(1,2)
     ! Powell/Bofill updates

     ! fvec = fvec - hessian x step
     call dlf_matrix_multiply(nvar,1,nvar,-1.D0, hess,step,1.D0,fvec)

     fx_xx=ddot(nvar,fvec,1,step,1) / xx

     if(glob%update==2) then
        svar=ddot(nvar,fvec,1,fvec,1)
        bof=fx_xx**2 * xx / svar
        if(printl>=6) write(stdout,'("Bof=",es10.3)') bof
     end if

     do ivar=1,nvar
        do jvar=ivar,nvar

           ! Powell
           svar=fvec(ivar)*step(jvar) + step(ivar)*fvec(jvar) - fx_xx* step(ivar)*step(jvar)

           if(glob%update==2) then
              ! Bofill
              svar=svar*(1.D0-bof) + bof/fx_xx * fvec(ivar)*fvec(jvar)
           end if

           hess(ivar,jvar) = hess(ivar,jvar) + svar/xx
           hess(jvar,ivar) = hess(ivar,jvar)
        end do
     end do
     
  case(3)
     ! BFGS update

     ! tvec is hessian x step
     tvec = 0.0d0
     call dlf_matrix_multiply(nvar, 1, nvar, 1.0d0, hess, step, 0.0d0, tvec)

     dds = ddot(nvar, fvec, 1, step, 1)
     ddtd = ddot(nvar, step, 1, tvec, 1)

     do ivar = 1, nvar
        do jvar = ivar, nvar
           svar = (fvec(ivar) * fvec(jvar)) / dds - &
                  (tvec(ivar) * tvec(jvar)) / ddtd
           hess(ivar, jvar) = hess(ivar, jvar) + svar
           hess(jvar, ivar) = hess(ivar, jvar)
        end do
     end do

  case default
     ! Update mechanism not recognised
     write(stderr,*) "Hessian update", glob%update, "not implemented"
     call dlf_fail("Hessian update error")

  end select

  was_updated=.true.

  ! Check for maximum number of updates reached
  ! In case of partial finite-difference, do an update first, then return and 
  ! Recalculate the lower modes
  if(iupd>=glob%maxupd .and. do_partial_fd) then
    havehessian=.false.
    iupd=0
    fracrecalc=.true.

  end if

end subroutine dlf_hessian_update
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* hessian/dlf_prfo_step
!!
!! FUNCTION
!!
!! Calculate a P-RFO step
!! This routine does only require the current Hessian and gradient,
!! not an old one.
!!
!! Notes to the Hessian update:
!! Paul updates some modes of the Hessian, whenever the number of positive 
!! eigenvalues (non-positive is below "soft") changes. He recalculates all
!! negative and soft modes plus one.
!!
!! SYNOPSIS
subroutine dlf_prfo_step(nvar,coords,gradient,hessian,step)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: stdout,printl,stderr,glob,pi
  use dlf_hessian
  implicit none
  integer ,intent(in)   :: nvar 
  real(rk),intent(in)   :: coords(nvar)
  real(rk),intent(in)   :: gradient(nvar)
  real(rk),intent(in)   :: hessian(nvar,nvar)
  real(rk),intent(out)  :: step(nvar)
  !
  ! these may be made variable in the future:
  integer   :: maxit=100 ! maximum number of iterations to find lambda
!  real(rk)  :: tol=1.D-5 ! tolerance in iterations
  real(rk)  :: tol=1.D-6 ! tolerance in iterations
  real(rk)  :: bracket=1.D-4  ! threshold for using bracket scheme - why not 0.D0?
  real(rk)  :: delta=0.05D0, big=1000.D0 ! for bracketing 
  !
  real(rk)              :: lamts,lamu,laml,lam
  real(rk)              :: ug(nvar) ! eigvec * gradient
  real(rk)              :: tmpvec(nvar)
  integer               :: ivar,iter,nmode,maxsoft
  real(rk)              :: svar,lowev,maxov
  real(rk)              :: soft_tmp,ev2(nvar)
  real(rk)              :: CM_INV_FOR_AMU
  real(RK) ,external    :: ddot
  logical               :: conv=.false.,err=.false.
  logical               :: skipmode(nvar)
  logical :: dbg=.true.
  real(8)               :: lam_thresh
! **********************************************************************
  
  maxsoft=glob%nzero
  ! try:
  if(glob%icoord==190) then
    tol=1.D-13
    bracket=1.D-6
    delta=1.D-3
    maxit=1000
  end if


  if(.not.glob%havehessian) call dlf_fail("No Hessian present in P-RFO") !??

  call dlf_matrix_diagonalise(nvar,hessian,eigval,eigvec)

  if(printl >= 2) then
    write(stdout,"('Eigenvalues of the Hessian:')") 
    write(stdout,"(9f10.4)") eigval
  end if

  ! Determine mode to follow
  if(follow==0) then
    tsmode=1
  else if(follow==1) then
    call dlf_fail("Hessian mode following 1 not implemented")
  else if(follow==2.or.follow==3) then
    if(tsvectorset) then
      maxov= dabs(ddot(nvar,eigvec(:,tsmode),1,tsvector,1))
      nmode=tsmode
      if(printl>=4) write(stdout,"('Overlap of current TS mode with &
          &previous one ',f6.3)") maxov
      do ivar=1,nvar
        if(ivar==tsmode) cycle
        svar= dabs(ddot(nvar,eigvec(:,ivar),1,tsvector,1))
        if(svar > maxov) then
          if(printl>=6) write(stdout,"('Overlap of mode',i4,' with &
              & TS-vector is ',f6.3,', larger than TS-mode',f6.3)") &
              ivar,svar,maxov
          maxov=svar
          nmode=ivar
        end if
      end do
      if(nmode /= tsmode) then
        !mode switching!
        if(printl>=2) write(stdout,"('Switching TS mode from mode',i4,&
            &' to mode',i4)") tsmode,nmode
        tsmode=nmode
        if(printl>=4) write(stdout,"('Overlap of current TS mode with &
            &previous one ',f6.3)") maxov
      end if
      if(follow==3) tsvector=eigvec(:,tsmode)
    else
      ! first step: use vector 1
      tsvector(:)=eigvec(:,1)
      tsvectorset=.true.
    end if
  else
    write(stderr,"('Wrong setting of follow:',i5)") follow
    call dlf_fail("Hessian mode following wrong")
  end if

  ! print frequency in case of mass-weighted coordinates
  if(glob%massweight  .and.(.not.glob%icoord==190) .and.printl>=2) then
    ! sqrt(H/u)/a_B/2/pi/c / 100
    !svar=sqrt( 4.35974417D-18/ 1.66053886D-27 ) / ( 2.D0 * pi * &
    !    0.5291772108D-10 * 299792458.D0) / 100.D0
    !call dlf_constants_get("CM_INV_FOR_AMU",CM_INV_FOR_AMU)
    !svar=sqrt(abs(eigval(tsmode))) * CM_INV_FOR_AMU
    !if(eigval(tsmode)<0.D0) svar=-svar
    !write(stdout,"('Frequency of transition mode',f10.3,' cm^-1 &
    !    &(negative value denotes imaginary frequency)')") &
    !    svar
    call dlf_print_wavenumber(eigval(tsmode),.true.)
  end if

  call dlf_formstep_set_tsmode(nvar,11,eigvec(:,tsmode))

  ! calculate eigvec*gradient
  do ivar=1,nvar
    ug(ivar) = ddot(nvar,eigvec(:,ivar),1,gradient(:),1)
  end do

  ! calculate Lambda that minimises along the TS-mode:
  lamts=0.5D0 * ( eigval(tsmode) + dsqrt( eigval(tsmode)**2 + 4.D0 * ug(tsmode)**2) )

  if(printl >= 2 .or. dbg) then
    write(stdout,'("Lambda for maximising TS mode:     ",es12.4," Eigenvalue:",es12.4)') lamts,eigval(tsmode)
  end if

  ! Calculate the number of modes considered "soft"
  if (glob%imicroiter > 0 .and. maxsoft > 0 .and. printl >= 2) then
     write(stdout,'("Warning: nzero > 0 is not appropriate for microiterative optimisation")')
     write(stdout,'("nzero=0 recommended to allow core region to rotate/translate in environment.")')
  end if
  nmode=0
  soft_tmp=soft
  ev2=0.D0
  do ivar=1,nvar
    if(ivar==tsmode) cycle
    if(abs(eigval(ivar)) < soft ) then
      nmode=nmode+1
      ev2(ivar)=dabs(eigval(ivar))
    end if
  end do

  ! Check that at most 6 modes are considered "soft"
  if(nmode>maxsoft) then
    do ivar=nmode-1,maxsoft,-1
      soft_tmp=maxval(ev2)
      ev2(maxloc(ev2))=0.D0
    end do
    if(printl>=4) write(stdout,'("Criterion for soft modes tightened to &
        &",es12.4)') soft_tmp
    ! recalculate nmode
    nmode=0
    do ivar=1,nvar
      if(ivar==tsmode) cycle
      if(abs(eigval(ivar)) < soft_tmp ) then
        nmode=nmode+1
        if(printl>=4) write(stdout,'("Mode ",i4," considered soft")') ivar
      end if
    end do
  end if

  if(nmode>0.and.printl>=2) &
      write(stdout,'("Ignoring ",i3," soft modes")') nmode

  ! find lowest eigenvalue that is not TS-mode and not soft
  !   i.e. the lowest eigenmode that is minimised
  do ivar=1,nvar
    if(ivar==tsmode) cycle
    if(abs(eigval(ivar)) < soft_tmp ) cycle
    lowev=eigval(ivar)
    exit
  end do

  ! define skipmode
  skipmode(:)=.true.
  do ivar=1,nvar
    if(ivar==tsmode) cycle
    if(abs(eigval(ivar)) < soft_tmp ) cycle
    ! instead of the above line: modes 2-7 soft
    !  if(ivar>=2.and.ivar<=7) cycle
    !  print*,"Modes 2 to 7 soft"
    !<<<<
    skipmode(ivar)=.false.
  end do

  lamu=0.D0
  laml=0.D0
  lam=0.D0

  if(lowev < bracket) then
    lam=lowev-delta
    lamu=lowev
    laml=-big
  end if

  do iter=1,maxit

    svar=0.D0

    do ivar=1,nvar
      if(ivar==tsmode) cycle
      !if(abs(eigval(ivar)) < soft_tmp ) cycle
      if(skipmode(ivar)) cycle
      if(abs(lam - eigval(ivar)) > 1.D-14) then
        svar=svar+ ug(ivar)**2 / (lam - eigval(ivar) )
      end if
    end do

    if(abs(svar-lam) < tol) then
      ! we are converged

      if(lam>lowev) then
        print*,"Lambda > lowest non-TS eigenvalue, bad Hessian?"
        err=.true.
      end if

      if(lam>0.D0 .and. lowev>0.D0) then
        print*,"Lambda and lowest non-TS eigenvalue >0. Bad Hessian?"
        print*,"Lambda:",lam
        !err=.true.
      end if

      if(dbg.and..not.err) then
        print*,"Lambda converged in",iter,"iterations"
      end if
      
      conv=.true.

      exit

    end if

    ! we are not converged. Next iteration:

    !write(*,'("A",4f15.8)') svar,lam,lamu,laml
    if(lowev < bracket ) then
      if(svar < lam) lamu=lam
      if(svar > lam) laml=lam
      if(laml > -big) then
        lam=0.5D0 * (lamu + laml)
      else
        lam = lam-delta
      end if
    else
      lam=svar
    end if
    !write(*,'("B",4f15.8)') svar,lam,lamu,laml

  end do

  !if(.not.conv) call dlf_fail("P-RFO loop not converged")
  if(err) call dlf_fail("P-RFO error")

  if(printl >= 2 .or. dbg) &
      write(stdout,'("Lambda for minimising other modes: ",es12.4)') lam

  ! calculate step:
  step=0.D0
  do ivar=1,nvar
    if(ivar==tsmode) then
      if( abs(lamts-eigval(ivar)) < 1.D-5 ) then
        ug(ivar)=1.D0
      else
        ug(ivar)=ug(ivar) / (eigval(ivar) - lamts)
      end if
    else
      !if(abs(eigval(ivar)) < soft_tmp ) then
      if(skipmode(ivar) ) then
        if(printl>=4) write(stdout,'("Mode ",i4," ignored, as &
            &|eigenvalue| ",es10.3," < soft =",es10.3)') &
            ivar,eigval(ivar),soft_tmp
        cycle
      end if
      if(glob%icoord==190) then
        lam_thresh=1.D-10
      else
        lam_thresh=1.D-5
      end if
      if( abs(lam-eigval(ivar)) < lam_thresh ) then 
        print*,"WARNING: lam-eigval(ivar) small for non-TS mode",ivar,"!"
        ug(ivar)= -1.D0 / eigval(ivar) ! take a newton-raphson step for this one
      else
        ug(ivar)=ug(ivar) / (eigval(ivar) - lam)
      end if
    end if
    if(printl>=6) write(stdout,'("Mode ",i4," Length ",es10.3)') ivar,ug(ivar)
    step(:) = step(:) - ug(ivar) * eigvec(:,ivar)
  end do

  if(printl >= 2 .or. dbg) &
      write(stdout,'("P-RFO step length:                 ",es12.4)') sqrt(sum(step(:)**2))

end subroutine dlf_prfo_step
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* formstep/dlf_formstep_set_tsmode
!!
!! FUNCTION
!!
!! Write the transition mode to a file
!!
!! mode:
!!   -2   deallocate all arrays
!!   -1   coords contains only energy (nvar=1)
!!   00   TS structure in x-coordinates
!!   01   TS structure in i-coordinates (similar x-coords have to be provided priorly)
!!   10   TS mode relative to TS structure in x-coordinates
!!   11   TS mode relative to TS structure in i-coordinates
!!   20   TS mode absolute in x-coordinates (not yet implemented)
!!   21   TS mode absolute in i-coordinates (not yet implemented)
!!
!! This routine does not produce errors in case of wrong input,
!! it just does nothing in this case.
!!
!! SYNOPSIS
subroutine dlf_formstep_set_tsmode(nvar,mode,coords)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr,stdout,printl,printf
  use dlf_formstep_module, only: tscoords, tsmode_r, energy, tenergy, &
      tsc_ok, tsm_ok
  use dlf_allocate, only: allocate, deallocate
  implicit none
  integer ,intent(in) :: nvar
  integer ,intent(in) :: mode
  real(rk),intent(in) :: coords(nvar)
  real(rk),allocatable :: store1(:),store2(:),store3(:)
  logical              :: tok
  real(rk)             :: svar
  real(rk),external    :: ddot
  integer              :: nivarf, nicoref
! **********************************************************************
  if(glob%icoord==190) return
  if(mode==-1) then
    if(nvar/=1) return
    tenergy=.true.
    energy=coords(1)
  else if(mode==0) then
    if(allocated(tscoords)) call deallocate(tscoords)
    if(nvar/=glob%nvar) return
    call allocate(tscoords,nvar)
    tscoords=coords
    tsc_ok=.true.
  else if(mode==1) then
    if(.not.(allocated(tscoords).and.tsc_ok)) return
    ! This mode does not appear to ever be called, so I do not know
    ! how it should be modified for the microiterative case
    call dlf_direct_itox(glob%nvar,nvar,glob%nicore,coords,tscoords,tok)
    if(.not.tok) then
      call deallocate(tscoords)
      write(stdout,'(a)') "HDLC breakdown in set_tsmode ignored in mode 1"
      tsc_ok=.false.
      return
    end if
  else if(mode==10) then
    if(allocated(tsmode_r)) call deallocate(tsmode_r)
    if(nvar/=glob%nvar) return
    call allocate(tsmode_r,nvar)
    tsmode_r=coords
    tsm_ok=.true.
  else if(mode==11) then
    ! transform tscoords to icoords
    if(.not.(allocated(tscoords).and.tsc_ok)) return
    if(allocated(tsmode_r)) call deallocate(tsmode_r)
    ! nvar= number of internal coordinates
    call allocate(tsmode_r,glob%nvar)
    tsmode_r=tscoords
    call allocate(store1,glob%nvar) ! xgradient
    store1=0.D0
    ! get full region nivar (in a microiterative calc, nvar is only inner region)
    call dlf_direct_get_nivar(0, nivarf)
    call dlf_direct_get_nivar(1, nicoref)
    call allocate(store2,nivarf) ! igradient
    store2=0.D0
    call allocate(store3,nivarf) ! icoords
    store3=0.D0
    call dlf_direct_xtoi(glob%nvar,nivarf,nicoref,tscoords,store1,store3,store2)
    ! add coords
    ! make sure the relative coords are short:
    svar=ddot(nvar,coords,1,coords,1)
    store3(1:nvar)=store3(1:nvar)+coords/sqrt(svar)*0.05D0
    ! transform to x-coords
    call dlf_direct_itox(glob%nvar,nivarf,nicoref,store3,tsmode_r,tok)
    call deallocate(store1)
    call deallocate(store2)
    call deallocate(store3)
    if(.not.tok) then
      write(stdout,'(a)') "HDLC breakdown in set_tsmode ignored in mode 11"
      call deallocate(tsmode_r)
      tsm_ok=.false.
      return
    end if
    ! subtract tscoords
    tsmode_r=tsmode_r-tscoords
    tsm_ok=.true.
  else if(mode==-2) then
    if(allocated(tsmode_r)) call deallocate(tsmode_r)
    if(allocated(tscoords)) call deallocate(tscoords)
    tsc_ok=.false.
    tsm_ok=.false.
  end if
  if(tsc_ok.and.tsm_ok.and. tenergy) then
    if(printf>=2) then
      if(printl>=4) write(stdout,"('Writing TS-mode')")
      ! JMC call dlf_put_coords(glob%nvar,1,energy,tscoords,glob%iam) JMC
      ! changed the mode in this call from 1 to 3 for convenience with the
      ! castep interface; this means that for CRYSTAL and CASTEP the ts coords
      ! will not go to the general coords file (at least one of which in each
      ! case is written in append mode) but instead will go to a specific file
      ! for TS coords only, currently overwritten each time (see the routines
      ! in the interface files for more details)
      call dlf_put_coords(glob%nvar,3,energy,tscoords,glob%iam)
      if(glob%tsrelative) then
        call dlf_put_coords(glob%nvar,2,energy,tsmode_r,glob%iam) 
      else
        call dlf_put_coords(glob%nvar,2,energy,tscoords+tsmode_r,glob%iam) 
      end if
      if(printf>=3.and.glob%iam == 0) call write_xyz(32,glob%nat,glob%znuc,tsmode_r)
    end if
    !call deallocate(tscoords)
    !call deallocate(tsmode_r)
    tsc_ok=.false.
    tsm_ok=.false.
    tenergy=.false.
  end if

end subroutine dlf_formstep_set_tsmode
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* formstep/dlf_formstep_get_ra
!!
!! FUNCTION
!!
!! Get a real-number array from the formstep module
!!
!! SYNOPSIS
subroutine dlf_formstep_get_ra(label,array_size,array,tok)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_formstep_module, only: tscoords, tsmode_r
  implicit none
  character(*), intent(in) :: label
  integer     , intent(in) :: array_size
  real(rk)    , intent(out):: array(array_size)
  logical     , intent(out):: tok
! **********************************************************************
  tok=.false.
  if (label=="TSCOORDS") then
    if(.not.allocated(tscoords)) return
    if(size(tscoords) /= array_size) return
    array(:)=tscoords(:)
    tok=.true.
  else if (label=="TSMODE_R") then
    if(.not.allocated(tsmode_r)) return
    if(size(tsmode_r) /= array_size) return
    array(:)=tsmode_r(:)
    tok=.true.
  else
    call dlf_fail("Wrong label in dlf_formstep_get_ra")
  end if
end subroutine dlf_formstep_get_ra
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* formstep/dlf_formstep_get_logical
!!
!! FUNCTION
!!
!! Get a logical value the formstep module
!!
!! SYNOPSIS
subroutine dlf_formstep_get_logical(label,tval)
!! SOURCE
  use dlf_formstep_module, only: needhessian
  use dlf_hessian, only: fd_hess_running
  implicit none
  character(*), intent(in) :: label
  logical     , intent(out):: tval
! **********************************************************************
  if (label=="NEEDHESSIAN") then
    tval=needhessian
  else if (label=="FD_HESS_RUNNING") then
    tval=fd_hess_running
  else
    call dlf_fail("Wrong label in dlf_formstep_get_logical")
  end if
end subroutine dlf_formstep_get_logical
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* hessian/dlf_thermal
!!
!! FUNCTION
!!
!! * diagonalise the (mass-weighted) hessian
!! * calculate vibration frequencies
!! * calculate thermal and entropic contributions
!!
!! SYNOPSIS
subroutine dlf_thermal()
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stdout,printl,pi,printf
  use dlf_stat, only: stat
  use dlf_constants, only : dlf_constants_get
  use dlf_hessian
  implicit none
  real(rk)        :: frequency_factor,svar
  real(rk)        :: temperature,planck,boltz,wavenumber
  real(rk)        :: speed_of_light, angstrom,hartree,avog
  real(rk)        :: evib, frequ, svib, vibtemp, zpe 
  real(rk)        :: zpetot,evibtot,svibtot,kboltz_au,svar2
  integer         :: ival, npmodes
  real(rk)        :: peigval(glob%nivar)
  real(rk)        :: ev2(glob%nivar),soft_local
  real(rk)        :: arr2(2)
  logical         :: tok
! **********************************************************************
  if (.not.glob%massweight .or. glob%icoord /= 0) then
     call dlf_fail("Thermal analysis only possible in mass-weighted &
         &cartesian coordinates")
  endif
  if (.not.glob%havehessian) then
    call dlf_fail("No hessian present for thermal analysis")
  end if
  if (glob%imicroiter > 0) then
     call dlf_fail("dlf_thermal not compatible with microiter")
  end if
  ! only act on first node, but print analysis even for printl=0
  if(printl<0) return

  ! Project out translation and rotational modes
  ! (if no atoms are frozen)
  call dlf_thermal_project(npmodes,peigval,tok)

  ! Vibrational analysis

  ! constants from NIST (2008)
  !speed_of_light=299792458.D0
  !planck=6.62606896D-34
  !boltz=1.3806504D-23
  !avog=6.02214179D23

  ! derived values
  !angstrom=0.5291772108D-10
  !hartree=4.35974417D-18

  ! sqrt(H/u)/a_B/2/pi/c / 100
  !frequency_factor=dsqrt( 4.35974417D-18/ 1.66053886D-27 ) / ( 2.D0 * pi * &
  !    angstrom * speed_of_light) / 100.D0
  !print*,"Frequ-fac",frequency_factor

  call dlf_constants_get("SOL",speed_of_light)
  call dlf_constants_get("HARTREE",hartree)
  call dlf_constants_get("PLANCK",planck)
  call dlf_constants_get("CM_INV_FOR_AMU",svar)
  call dlf_constants_get("KBOLTZ",boltz)
  call dlf_constants_get("AVOGADRO",avog)
  frequency_factor=svar
  !print*,"Frequ-fac",frequency_factor

  temperature=glob%temperature

  write(stdout,*)
  write(stdout,"('Thermochemical analysis')")
  write(stdout,"('Temperature: ',f10.2,' Kelvin')") temperature
  if (.not. tok) then
     write(stdout,"('Modes assumed to have zero vibrational frequency:',i3)") glob%nzero
  end if
  write(stdout,"(' Mode     Eigenvalue Frequency Vib.T.(K)      &
      &  ZPE (H)   Vib. Ene.(H)      - T*S (H)')")
  zpetot=0.D0
  evibtot=0.D0
  svibtot=0.D0

  soft_local = -0.1d0
  if (.not. tok) then
     ! If frozen atoms were found, trans/rot modes were not projected out
     ! Instead fall back to a user-specified number of modes to ignore (nzero)
     ev2=abs(eigval)
     do ival=1,glob%nzero
        soft_local=minval(ev2)
        ev2(minloc(ev2))=huge(1.D0)
     end do
  end if

  ! print out frequencies:
  do ival=1, npmodes
    wavenumber = sqrt(abs(peigval(ival))) * frequency_factor

    if (peigval(ival)<0.D0) then
       ! Imaginary modes
       write(stdout,"(i5,f15.10,f10.3,'i')") ival,peigval(ival),wavenumber
    else if (.not. tok .and. abs(peigval(ival))<=soft_local) then
       ! User-specified soft modes
       write(stdout,"(i5,f15.10,f10.3)") ival,peigval(ival),wavenumber
    else

      ! convert eig from cm-1 to Hz 
      frequ = wavenumber * 1.D2 * speed_of_light
      ! vibrational temperature in K
      vibtemp = frequ*planck/boltz
      ! zero point vib. (J)
      zpe = planck*frequ*0.5D0
      ! vibrational energy
      svar = dexp(vibtemp/temperature)-1.D0
      evib = planck*frequ / svar
      ! vibrational entropy
      svar = dexp(-vibtemp/temperature)
      svib = vibtemp/temperature / (1.D0/svar -1.D0)
      svib = svib - dlog(1.D0 - svar)
      svib = svib * boltz
      
      write(stdout,"(i5,f15.10,2f10.3,3f15.10)") ival,peigval(ival),wavenumber, &
          vibtemp,zpe/hartree,evib/hartree, -svib/hartree*temperature
      
      zpetot=zpetot+zpe
      evibtot=evibtot+evib
      svibtot=svibtot+svib
    end if
  end do
  write(*,"('total',35x,3f15.10)") &
      zpetot/hartree,evibtot/hartree,-svibtot/hartree*temperature
  write(*,"('total vibrational energy correction to E_electronic',&
      &f15.10,' H')") (zpetot+evibtot-svibtot*temperature)/hartree
  write(*,"('total ZPE  ',f15.5,' J/mol')") zpetot*avog
  write(*,"('total E vib',f15.5,' J/mol')") evibtot*avog
  write(*,"('total S vib',f15.5,' J/mol/K')") svibtot*avog
  
  ! write out the hessian and the energy of the "Midpoint" in qts format
  call dlf_constants_get("AMU",svar2)
  if(abs(peigval(1))>soft_local.and.peigval(1)<0.D0) then
    !
    ! we have a transition state
    !
    ! write crossover temperature for tunnelling
    call dlf_print_wavenumber(eigval(1),.false.)
    ! format as reactant (only hessian eigenvalues)
    call write_qts_reactant(glob%nat,glob%nivar,glob%energy,&
        glob%xcoords,eigval/svar2,"ts")
    arr2=-1.D0
    call write_qts_hessian(glob%nat,1,glob%nivar,-1.D0,&
        glob%energy,glob%xcoords,glob%ihessian/svar2,0.D0,arr2,"ts")
    if(printf>=4) then

      ! write an xyz file of the transition mode
      open(unit=55,file="tsmode_mov.xyz")
      call write_xyz(55,glob%nat,glob%znuc,glob%xcoords)
      svar=glob%distort
      call dlf_cartesian_xtoi(glob%nat,glob%nivar,glob%nicore,glob%massweight,glob%xcoords, &
          glob%xgradient,glob%icoords,glob%igradient)
      ! this is an abuse of glob%xcoords and glob%icoords. They now contain the moved coords...
      if(abs(svar)<1.D-7) svar=0.5D0/maxval(abs(eigvec(:,1)))
      glob%icoords=glob%icoords+svar*eigvec(:,1)
      call dlf_cartesian_itox(glob%nat,glob%nivar,glob%nicore, &
           glob%massweight,glob%icoords,glob%xcoords)

      call write_xyz(55,glob%nat,glob%znuc,glob%xcoords)
      close(55)

      ! also write to result2
      if(glob%tsrelative) then
        glob%icoords=svar*eigvec(:,1)
        call dlf_cartesian_itox(glob%nat,glob%nivar,glob%nicore,glob%massweight,glob%icoords,glob%xcoords)
        call dlf_put_coords(glob%nvar,2,glob%energy,glob%xcoords,glob%iam)         
      else
        call dlf_put_coords(glob%nvar,2,glob%energy,glob%xcoords,glob%iam) 
      end if
    end if
  else
    ! we probably have a reactant
    ! format as reactant (only hessian eigenvalues)
    call write_qts_reactant(glob%nat,glob%nivar,glob%energy,&
        glob%xcoords,eigval/svar2,"")
    arr2=-1.D0
    call write_qts_hessian(glob%nat,1,glob%nivar,-1.D0,&
        glob%energy,glob%xcoords,glob%ihessian/svar2,0.D0,arr2,"rs")
  end if

end subroutine dlf_thermal
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* hessian/dlf_thermal_project
!!
!! FUNCTION
!!
!! * project out non-zero translational and rotational modes from Hessian
!!
!! References: 
!!   1 "Vibrational Analysis in Gaussian", Joseph W. Ochterski
!!      http://www.gaussian.com/g_whitepap/vib/vib.pdf
!!   2 The code in OPTvibfrq in opt/vibfrq.f
!!
!! Notes
!!   - Both of the above start from non-mass-weighted Cartesians whereas
!!     in DL-FIND the Hessian is already mass-weighted 
!!   - There appears to be an error in Ref 1 eqn 5 as the expression 
!!     should be multiplied by sqrt(mass), not divided by it (cf ref 2)
!!     If the uncorrected eqn5 is used then the rotational modes are not 
!!     fully orthogonal to the translational ones.
!!
!! SYNOPSIS
subroutine dlf_thermal_project(npmodes,peigval,tok)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stdout,printl
  use dlf_hessian
  implicit none
  real(rk), external :: ddot
  integer, intent(out)  :: npmodes ! number of vibrational modes
  real(rk), intent(out) :: peigval(glob%nivar) ! eigenvalues after projection
  logical               :: tok
  real(rk)              :: comcoords(3,glob%nat) ! centre of mass coordinates
  real(rk)              :: com(3) ! centre of mass
  real(rk)              :: totmass ! total mass
  real(rk)              :: moi(3,3) ! moment of inertia tensor
  real(rk)              :: moivec(3,3) ! MOI eigenvectors
  real(rk)              :: moival(3) ! MOI eigenvalues
  real(rk)              :: transmat(glob%nivar,glob%nivar) ! transformation matrix
  real(rk)              :: px(3), py(3), pz(3)
  real(rk)              :: smass
  real(rk), parameter   :: mcutoff = 1.0d-12
  integer               :: ntrro ! number of trans/rot modes
  real(rk)              :: test, norm
  real(rk)              :: trialv(glob%nivar)
  real(rk)              :: phess(glob%nivar,glob%nivar) ! projected Hessian
  real(rk)              :: peigvec(glob%nivar, glob%nivar) ! eigenvectors after proj.
  real(rk)              :: pmodes(glob%nivar, glob%nivar) ! vib modes after proj.
  integer               :: pstart
  integer               :: ival, jval, kval, lval, icount
! **********************************************************************
  tok=.false.
  ! Do not continue if any coordinates are frozen
  if (glob%nivar /= glob%nat * 3 .or. glob%nat==1) then
     write(stdout,*)
     write(stdout,"('Frozen atoms found: no modes will be projected out')")
     npmodes = glob%nivar
     peigval = eigval
     return
  end if

  write(stdout,*)
  write(stdout,"('Projecting out translational and rotational modes')")

  ! Calculate centre of mass and moment of inertia tensor

  ! xcoords is not fully up to date so convert icoords instead
  call dlf_cartesian_itox(glob%nat, glob%nivar, glob%nicore, &
       glob%massweight, glob%icoords, comcoords)

  com(:) = 0.0d0
  totmass = 0.0d0
  do ival = 1, glob%nat
     com(1:3) = com(1:3) + glob%mass(ival) * comcoords(1:3, ival)
     totmass = totmass + glob%mass(ival)
  end do
  com(1:3) = com(1:3) / totmass

  do ival = 1, glob%nat
     comcoords(1:3, ival) = comcoords(1:3, ival) - com(1:3)
  end do

  moi(:,:) = 0.0d0
  do ival = 1, glob%nat
     moi(1,1) = moi(1,1) + glob%mass(ival) * &
          (comcoords(2,ival) * comcoords(2,ival) + comcoords(3,ival) * comcoords(3,ival))
     moi(2,2) = moi(2,2) + glob%mass(ival) * &
          (comcoords(1,ival) * comcoords(1,ival) + comcoords(3,ival) * comcoords(3,ival))
     moi(3,3) = moi(3,3) + glob%mass(ival) * &
          (comcoords(1,ival) * comcoords(1,ival) + comcoords(2,ival) * comcoords(2,ival))
     moi(1,2) = moi(1,2) - glob%mass(ival) * comcoords(1, ival) * comcoords(2, ival)
     moi(1,3) = moi(1,3) - glob%mass(ival) * comcoords(1, ival) * comcoords(3, ival)
     moi(2,3) = moi(2,3) - glob%mass(ival) * comcoords(2, ival) * comcoords(3, ival)
  end do
  moi(2,1) = moi(1,2)
  moi(3,1) = moi(1,3)
  moi(3,2) = moi(2,3)

  call dlf_matrix_diagonalise(3, moi, moival, moivec)

  if (printl >= 6) then
     write(stdout,"(/,'Centre of mass'/3f15.5)") com(1:3)
     write(stdout,"('Moment of inertia tensor')")
     write(stdout,"(3f15.5)") moi(1:3, 1:3)
     write(stdout,"('Principal moments of inertia')")
     write(stdout,"(3f15.5)") moival(1:3)
     write(stdout,"('Principal axes')")
     write(stdout,"(3f15.5)") moivec(1:3, 1:3)
  end if

  ! Construct transformation matrix to internal coordinates
  ntrro = 6
  transmat(:, :) = 0.0d0
  do ival = 1, glob%nat
     smass = sqrt(glob%mass(ival))
     kval = 3 * (ival - 1)
     ! Translational vectors
     transmat(kval+1, 1) = smass
     transmat(kval+2, 2) = smass
     transmat(kval+3, 3) = smass
     ! Rotational vectors
     px = sum(comcoords(1:3,ival) * moivec(1:3,1))
     py = sum(comcoords(1:3,ival) * moivec(1:3,2))
     pz = sum(comcoords(1:3,ival) * moivec(1:3,3))
     transmat(kval+1:kval+3, 4) = (py*moivec(1:3,3) - pz*moivec(1:3,2))*smass
     transmat(kval+1:kval+3, 5) = (pz*moivec(1:3,1) - px*moivec(1:3,3))*smass
     transmat(kval+1:kval+3, 6) = (px*moivec(1:3,2) - py*moivec(1:3,1))*smass
  end do
  ! Normalise vectors and check for linear molecules (one less mode)
  do ival = 1, 6
     test = ddot(glob%nivar, transmat(1,ival), 1, transmat(1,ival), 1)
     if (test < mcutoff) then
        kval = ival
        ntrro = ntrro - 1
        if (ntrro < 5) then
           write(stdout,"('Error: too few rotational/translation modes')")
           npmodes = glob%nivar
           peigval = eigval
           return
        end if
     else
        norm = 1.0d0/sqrt(test)
        call dscal(glob%nivar, norm, transmat(1,ival), 1)
     end if
  end do
  if (ntrro == 5 .and. kval /= 6) then
     transmat(:, kval) = transmat(:, 6)
     transmat(:, 6) = 0.0d0
  end if
  write(stdout,"(/,'Number of translational/rotational modes:',i4)") ntrro

  ! Generate 3N-ntrro other orthogonal vectors 
  ! Following the method in OPTvibfrq
  icount = ntrro
  do ival = 1, glob%nivar
     trialv(:) = 0.0d0
     trialv(ival) = 1.0d0
     do jval = 1, icount
        ! Test if trial vector is linearly independent of previous set
        test = -ddot(glob%nivar, transmat(1,jval), 1, trialv, 1)
        call daxpy(glob%nivar, test, transmat(1,jval), 1, trialv, 1)
     end do
     test = ddot(glob%nivar, trialv, 1, trialv, 1)
     if (test > mcutoff) then
        icount = icount + 1
        norm = 1.0d0/sqrt(test)
        transmat(1:glob%nivar, icount) = norm * trialv(1:glob%nivar)
     end if
     if (icount == glob%nivar) exit
  end do
  if (icount /= glob%nivar) then
     write(stdout,"('Error: unable to generate transformation matrix')")
     npmodes = glob%nivar
     peigval = eigval
     return
  end if
  if (printl >= 6) then
     write(stdout,"(/,'Transformation matrix')")
     call dlf_matrix_print(glob%nivar, glob%nivar, transmat)
  end if

  ! Apply transformation matrix: D(T) H D
  ! Use peigvec as scratch to store intermediate
  phess(:,:) = 0.0d0
  peigvec(:,:) = 0.0d0
  call dlf_matrix_multiply(glob%nivar, glob%nivar, glob%nivar, &
       1.0d0, glob%ihessian, transmat, 0.0d0, peigvec)
  ! Should alter dlf_matrix_multiply to allow transpose option to be set...
  transmat = transpose(transmat)
  call dlf_matrix_multiply(glob%nivar, glob%nivar, glob%nivar, &
       1.0d0, transmat, peigvec, 0.0d0, phess)
  transmat = transpose(transmat)

  if (printl >= 6) then
     write(stdout,"(/,'Hessian matrix after projection:')")
     call dlf_matrix_print(glob%nivar, glob%nivar, phess)
  end if

  ! Find eigenvalues of Nvib x Nvib submatrix
  peigval(:) = 0.0d0
  peigvec(:,:) = 0.0d0
  npmodes = glob%nivar - ntrro
  pstart = ntrro + 1
  call dlf_matrix_diagonalise(npmodes, phess(pstart:glob%nivar, pstart:glob%nivar), &
       peigval(1:npmodes), peigvec(1:npmodes,1:npmodes))

  if (printl >= 6) then
     write(stdout,"('Vibrational submatrix eigenvalues:')")
     write(stdout,"(12f9.5)") peigval(1:npmodes)
     write(stdout,"('Vibrational submatrix eigenvectors:')")
     call dlf_matrix_print(npmodes, npmodes, peigvec(1:npmodes, 1:npmodes))
  end if

  ! Print out normalised normal modes
  ! These are in non-mass-weighted Cartesians (division by smass)
  pmodes(:,:) = 0.0d0
  do kval = 1, glob%nivar
     do ival = 1, npmodes
        do jval = 1, npmodes
           pmodes(kval, ival) = pmodes(kval, ival) + &
                transmat(kval, ntrro + jval) * peigvec(jval, ival)
        end do
        lval = (kval - 1) / 3 + 1
        smass = sqrt(glob%mass(lval))
        pmodes(kval, ival) = pmodes(kval, ival) / smass
     end do
  end do
  do ival = 1, npmodes
     test = ddot(glob%nivar, pmodes(1,ival), 1, pmodes(1,ival), 1)
     norm = 1.0d0 / sqrt(test)
     call dscal(glob%nivar, norm, pmodes(1,ival), 1)
  end do

  if (printl >= 4) then
     write(stdout,"(/,'Normalised normal modes (Cartesian coordinates):')")
     call dlf_matrix_print(glob%nivar, npmodes, pmodes(1:glob%nivar, 1:npmodes))
  end if
  
  tok=.true.

end subroutine dlf_thermal_project
!!****

! **********************************************************************
! **                Coordinate transformation: main unit              **
! **                                                                  **
! **   Subunits:                                                      **
! **     dlf_neb.f90                                                  **
! **     dlf_dimer.f90                                                **
! **     dlf_hdlc_interface.f90                                       **
! **                                                                  **
! **                                                                  **
! **                                                                  **
! **********************************************************************
!!****h* DL-FIND/coords
!!
!! NAME
!! coords
!!
!! FUNCTION
!! Coordinate transformation: main unit
!!
!! Weight transformation is calculated at coordinate initialisation
!!
!! DATA
!! $Date$                   
!! $Rev$                                                              
!! $Author$                                                         
!! $URL$   
!! $Id$                      
!!
!! COPYRIGHT
!!
!!  Copyright 2007 Johannes Kaestner (kaestner@theochem.uni-stuttgart.de),
!!  Tom Keal (thomas.keal@stfc.ac.uk)
!!
!!  This file is part of DL-FIND.
!!
!!  DL-FIND is free software: you can redistribute it and/or modify
!!  it under the terms of the GNU Lesser General Public License as 
!!  published by the Free Software Foundation, either version 3 of the 
!!  License, or (at your option) any later version.
!!
!!  DL-FIND is distributed in the hope that it will be useful,
!!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!!  GNU Lesser General Public License for more details.
!!
!!  You should have received a copy of the GNU Lesser General Public 
!!  License along with DL-FIND.  If not, see 
!!  <http://www.gnu.org/licenses/>.
!!
!! SOURCE
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* coords/dlf_coords_init
!!
!! FUNCTION
!! Initialise coordinate transformation
!!
!! In case of a direct coordinate transformation (glob%icoord<10):
!! * Find the number of degrees of freedom
!! * (Initialise HDLCs)
!! * Allocate global arrays (glob%icoords, glob%igradient, glob%step)
!!
!! In multiple image methods (NEB, dimer) call their respective init routines
!!
!! SYNOPSIS
subroutine dlf_coords_init
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr,stdout,printl
  use dlf_allocate, only: allocate, deallocate
  implicit none
  integer               :: iat,ivar
  real(rk)              :: svar
  real(rk), allocatable :: tmp_icoords(:)
  real(RK), external    :: ddot
  logical               :: tok
! **********************************************************************

  ! ====================================================================
  ! CHECK FOR A CONSISTENT RESIDUE SPECIFICATION
  ! ====================================================================
  if(mod(glob%icoord,10)==3.or.mod(glob%icoord,10)==4) then
    ! The only allowed residue specification is: all atoms are 
    ! optimised, and all are part of one residue
    if(minval(glob%spec(:)) < 0) call dlf_fail("Frozen atoms are not &
        &permitted when using pure internals, use HDLC instead")
    if(minval(glob%spec(:)) /= maxval(glob%spec(:))) &
        call dlf_fail("All atoms must belong to the same residue for &
        &pure internals")
    if(maxval(glob%spec(:))==0) glob%spec(:)=1
  end if

  select case (glob%icoord)

! ======================================================================
! Cartesians
! ======================================================================
  case (0, 10)
    call dlf_cartesian_get_nivar(0, glob%nivar)
    if(printl >=4) then
      do iat=1,glob%nat
        select case (glob%spec(iat))
        case (0)
          write(stdout,1000) iat,"free"
        case (-1)
          write(stdout,1000) iat,"frozen"
        case (-2)
          write(stdout,1000) iat,"x frozen"
        case (-3)
          write(stdout,1000) iat,"y frozen"
        case (-4)
          write(stdout,1000) iat,"z frozen"
        case (-23)
          write(stdout,1000) iat,"x and y frozen"
        case (-24)
          write(stdout,1000) iat,"x and z frozen"
        case (-34)
          write(stdout,1000) iat,"y and z frozen"
        case default
          write(stdout,1001) iat,"free. Spec. residue:",glob%spec(iat)
        end select
      end do
    end if

    ! Extra coordinates for Lagrange-Newton
    if (glob%icoord == 10) glob%nivar = glob%nivar + 2

    ! allocate arrays
    call allocate( glob%icoords,glob%nivar)
    call allocate( glob%igradient,glob%nivar)
    call allocate( glob%step,glob%nivar)
    call allocate( glob%iweight,glob%nivar)
    glob%icoords(:)=0.D0
    glob%igradient(:)=0.D0
    glob%step(:)=0.D0
    glob%iweight(:)=0.D0

    ! Allocate conint arrays
    ! and initialise extra Lagrange-Newton coordinates
    if (glob%icoord == 10) call dlf_ln_allocate

    ! set weight
    ivar=1
    do iat=1,glob%nat
      if(glob%spec(iat)>=0) then
        glob%iweight(ivar:ivar+2)=glob%weight(iat)
        ivar=ivar+3
      else if(glob%spec(iat)==-1) then
      else if(glob%spec(iat)>=-4) then
        glob%iweight(ivar:ivar+1)=glob%weight(iat)
        ivar=ivar+2
      else
        glob%iweight(ivar)=glob%weight(iat)
        ivar=ivar+1
      end if
    end do
    ! Set some sensible weights for the extra coordinates
    if (glob%icoord == 10) then
       glob%iweight(glob%nivar - 1:glob%nivar) = 1.0d0
       ivar = ivar + 2
    endif
    ! YL 06/02/2021: only check this for atom mode now (we haven't used weights for parameterisation)
    if(ivar-1/=glob%nivar.and.glob%tatoms) then
      call dlf_fail("Error in cartesian iweight calculation")
    end if

    ! Number of variables in inner region for microiterative calculations
    call dlf_cartesian_get_nivar(1, glob%nicore)

! ======================================================================
! HDLC/DLC
! ======================================================================
  case (1:4, 11:14)

    call dlf_hdlc_init(glob%nat,glob%spec,mod(glob%icoord,10),glob%ncons, &
        glob%icons,glob%nconn,glob%iconn)

    call dlf_hdlc_get_nivar(0, glob%nivar)
    call dlf_hdlc_get_nivar(1, glob%nicore)

    ! calculate weights here
    call dlf_hdlc_create(glob%nat,glob%nicore,glob%spec,glob%micspec, &
        glob%znuc,1,glob%xcoords,glob%weight,glob%mass)

    ! Extra coordinates for Lagrange-Newton
    if ((glob%icoord / 10) == 1) glob%nivar = glob%nivar + 2

    !allocate arrays
    call allocate( glob%icoords,glob%nivar)
    call allocate( glob%igradient,glob%nivar)
    call allocate( glob%step,glob%nivar)
    glob%icoords(:)=0.D0
    glob%igradient(:)=0.D0
    glob%step(:)=0.D0

    ! Allocate conint arrays
    ! and initialise extra Lagrange-Newton coordinates
    if ((glob%icoord / 10) == 1) call dlf_ln_allocate

    ! get weights
    call allocate( glob%iweight,glob%nivar)

    if ((glob%icoord / 10) == 1) then
       call dlf_hdlc_getweight(glob%nat, glob%nivar - 2, glob%nicore, &
            glob%micspec, glob%weight, glob%iweight(1:glob%nivar - 2))
       ! Set some sensible weights for the extra coordinates
       glob%iweight(glob%nivar - 1:glob%nivar) = 1.0d0
    else
       call dlf_hdlc_getweight(glob%nat,glob%nivar,glob%nicore,&
            glob%micspec,glob%weight,glob%iweight)
    endif

! ======================================================================
! NEB 
! ======================================================================
  case (100:199)
    call dlf_neb_init(glob%nimage,glob%icoord)

! ======================================================================
! Dimer Method
! ======================================================================
  case (200:299)
    call dlf_dimer_init(glob%icoord)

! ======================================================================
! Wrong coordinate setting
! ======================================================================
  case default
    write(stderr,*) "Coordinate type",glob%icoord,"not implemented"
    call dlf_fail("Coordinate type error")

  end select

  ! distort if requested and a single-image method is used
  if(glob%icoord<100 .and. glob%tcoords2 .and. abs(glob%distort)>0.D0) then
    ! make xcoords2 relative
    if(.not.glob%tsrelative) glob%xcoords2(:,:,1)=glob%xcoords2(:,:,1)-glob%xcoords
    ! guess at distance distort in xyz space
    svar=dsqrt(ddot(glob%nvar,glob%xcoords2(:,:,1),1,glob%xcoords2(:,:,1),1))
    glob%xcoords2(:,:,1)=glob%xcoords2(:,:,1) / svar * glob%distort ! SIGN ENTERS HERE
    ! make xcoords2 absolute
    glob%xcoords2(:,:,1)=glob%xcoords2(:,:,1)+glob%xcoords

    ! calculate internals for coords
    glob%xgradient(:,:)=0.D0
    call dlf_direct_xtoi(glob%nvar,glob%nivar,glob%nicore,glob%xcoords,glob%xgradient, &
        glob%icoords,glob%igradient)
    ! calculate internals for coords2 (stored in tmp_icoords)
    call allocate(tmp_icoords, glob%nivar)
    call dlf_direct_xtoi(glob%nvar,glob%nivar,glob%nicore,glob%xcoords2(:,:,1), &
        glob%xgradient,tmp_icoords,glob%igradient)
    ! make tmp_icoords relative
    tmp_icoords=tmp_icoords-glob%icoords
    svar=dsqrt(ddot(glob%nivar,tmp_icoords,1,tmp_icoords,1))
    ! now distort icoords
    glob%icoords=glob%icoords+tmp_icoords/svar*abs(glob%distort)
    call deallocate(tmp_icoords)
    ! transform icoords back to xcoords 
    call dlf_direct_itox(glob%nvar,glob%nivar,glob%nicore, &
        glob%icoords,glob%xcoords,tok)
    if(.not.tok) then
      call dlf_fail("Back transformation after distort failed. Use a&
          & smaller value for distort.")
    end if
  end if

! formats
1000 format ("Atom ",i6,2x,a)
1001 format ("Atom ",i6,2x,a,2x,i6)

end subroutine dlf_coords_init
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* coords/dlf_coords_destroy
!!
!! FUNCTION
!! Deallocate global arrays belonging to internal coordinates
!!
!! SYNOPSIS
subroutine dlf_coords_destroy
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr
  use dlf_allocate, only: deallocate
  implicit none
! **********************************************************************
  select case (glob%icoord)

! ======================================================================
! Cartesians
! ======================================================================
  case (0, 10)

    ! deallocate arrays
    if (allocated(glob%icoords)) call deallocate( glob%icoords)
    if (allocated(glob%igradient)) call deallocate( glob%igradient)
    if (allocated(glob%step)) call deallocate( glob%step)
    if (allocated(glob%iweight)) call deallocate( glob%iweight)

! ======================================================================
! HDLC/DLC
! ======================================================================
  case (1:4, 11:14)

    ! deallocate arrays
    if (allocated(glob%icoords)) call deallocate( glob%icoords)
    if (allocated(glob%igradient)) call deallocate( glob%igradient)
    if (allocated(glob%step)) call deallocate( glob%step)
    if (allocated(glob%iweight)) call deallocate( glob%iweight)

    call dlf_hdlc_destroy

! ======================================================================
! NEB 
! ======================================================================
  case (100:199)
    call dlf_neb_destroy

! ======================================================================
! Dimer Method
! ======================================================================
  case (200:299)
    call dlf_dimer_destroy

! ======================================================================
! Wrong coordinate setting
! ======================================================================
  case default
    write(stderr,*) "Coordinate type",glob%icoord,"not implemented"
    call dlf_fail("Coordinate type error")

  end select

end subroutine dlf_coords_destroy
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* coords/dlf_coords_xtoi
!!
!! FUNCTION
!! Transform Cartesian coordinates and gradient to internals
!!
!! In case of a direct coordinate transformation, call dlf_direct_xtoi
!!
!! In multiple image methods (NEB, dimer) call their respective xtoi routines
!!
!! INPUTS
!!
!! glob%nvar, glob%nivar, glob%xcoords, glob%xgradient
!!
!! OUTPUTS
!! 
!! glob%icoords, glob%igradient, trerun_energy, testconv
!!
!! SYNOPSIS
subroutine dlf_coords_xtoi(trerun_energy,testconv,iimage)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob, stdout, stderr, printl
  implicit none
  logical, intent(out) :: trerun_energy
  logical, intent(out) :: testconv ! is convergence tested here?
  integer, intent(out) :: iimage ! which image to be calculated next?
! **********************************************************************

  testconv=.false.
  iimage=1
  
  if(printl>=6) print*,"Transforming X to I"
  trerun_energy=.false.

  select case (glob%icoord/10)

! ======================================================================
! Direct coordinate transform
! ======================================================================
  case (0)

    call dlf_direct_xtoi(glob%nvar,glob%nivar,glob%nicore,glob%xcoords, &
          glob%xgradient,glob%icoords,glob%igradient)

! ======================================================================
! Lagrange-Newton coordinates
! ======================================================================
  case (1)

    call dlf_ln_xtoi

! ======================================================================
! NEB 
! ======================================================================
  case (10:19) ! 100-199

    if(glob%iopt==12) then
      call dlf_qts_get_hessian(trerun_energy)
    else
      call dlf_neb_xtoi(trerun_energy,iimage)
    end if

! ======================================================================
! Dimer 
! ======================================================================
  case (20:29) ! 200-299

    call dlf_dimer_xtoi(trerun_energy,testconv)

! ======================================================================
! Wrong coordinate setting
! ======================================================================
  case default
    write(stderr,*) "Coordinate type",glob%icoord,"not implemented"
    call dlf_fail("Coordinate type error")

  end select

  ! call the test for different deltas here
  if(glob%iopt==9) &
      call dlf_test_delta(trerun_energy)

end subroutine dlf_coords_xtoi
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* coords/dlf_coords_itox
!!
!! FUNCTION
!! Transform internal coordinates to xyz coordinates, handle breakdowns.
!! Gradient is not back-transformed.
!!
!! In case of a direct coordinate transformation, call dlf_direct_itox.
!!
!! In multiple image methods (NEB, dimer) call their respective itox routines.
!!
!! INPUTS
!!
!! glob%nvar, glob%nivar, glob%icoords
!!
!! OUTPUTS
!! 
!! glob%xcoords
!!
!! SYNOPSIS
subroutine dlf_coords_itox(iimage)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr,stdout,printl
  implicit none
  integer, intent(out) :: iimage ! which image to be calculated next?  
  logical :: tok
! **********************************************************************
  iimage=1

  if(printl>=6) print*,"Transforming I to X"

  select case (glob%icoord/10)

! ======================================================================
! Direct coordinate transform
! ======================================================================
  case (0)

    call dlf_direct_itox(glob%nvar,glob%nivar,glob%nicore,glob%icoords,glob%xcoords,tok)
    if(.not.tok.and. mod(glob%icoord,10)>0 .and. mod(glob%icoord,10)<=4 ) then
      if(printl>=4) write(stdout, &
          "('HDLC coordinate breakdown. Recalculating HDLCs and &
          &restarting optimiser.')")
      call dlf_hdlc_reset
      ! the arrays glob%spec,glob%znuc have to be changed when using 
      !  more instances of hdlc
      call dlf_hdlc_create(glob%nvar/3,glob%nicore,glob%spec,glob%micspec, &
          glob%znuc,1,glob%xcoords,glob%weight,glob%mass)
      ! recalculate iweight
      call dlf_hdlc_getweight(glob%nat,glob%nivar,glob%nicore,glob%micspec, &
           glob%weight,glob%iweight)
      call dlf_formstep_restart
      glob%havehessian=.false.
    end if

! ======================================================================
! Lagrange-Newton coordinates
! ======================================================================
  case (1)

    call dlf_direct_itox(glob%nvar,glob%nivar - 2,glob%nicore, &
         glob%icoords(1:glob%nivar - 2),glob%xcoords,tok)
    if(.not.tok.and. mod(glob%icoord,10)>0 .and. mod(glob%icoord,10)<=4 ) then
      if(printl>=4) write(stdout, &
          "('HDLC coordinate breakdown. Recalculating HDLCs and &
          &restarting optimiser.')")
      call dlf_hdlc_reset
      ! the arrays glob%spec,glob%znuc have to be changed when using 
      !  more instances of hdlc
      call dlf_hdlc_create(glob%nvar/3,glob%nicore,glob%spec,glob%micspec, &
          glob%znuc,1,glob%xcoords,glob%weight,glob%mass)
      ! recalculate iweight
      call dlf_hdlc_getweight(glob%nat,glob%nivar - 2, glob%nicore, &
           glob%micspec, glob%weight, glob%iweight(1:glob%nivar - 2))
      call dlf_formstep_restart
      glob%havehessian=.false.
    end if

! ======================================================================
! NEB 
! ======================================================================
  case (10:19) ! 100-199

    call dlf_neb_itox(iimage)

! ======================================================================
! Dimer 
! ======================================================================
  case (20:29) ! 200-299

    call dlf_dimer_itox

! ======================================================================
! Wrong coordinate setting
! ======================================================================
  case default
    write(stderr,*) "Coordinate type",glob%icoord,"not implemented"
    call dlf_fail("Coordinate type error")

  end select

end subroutine dlf_coords_itox
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* coords/dlf_direct_xtoi
!!
!! FUNCTION
!! Transform xyz coordinates to internal coordinates
!! Only one set of coordinates is transformed, not a path 
!! (as possible by dlf_coords_xtoi)
!!
!! x-weights are transformed to i-weights
!!
!! INPUTS
!!
!! only local variables
!!
!! OUTPUTS
!! 
!! only local variables except for glob%massweight
!!
!! SYNOPSIS
subroutine dlf_direct_xtoi(nvar,nivar,nicore,xcoords,xgradient,icoords,&
    igradient)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr
  implicit none
  integer ,intent(in)  :: nvar,nivar,nicore
  real(rk),intent(in)  :: xcoords(nvar)
  real(rk),intent(in)  :: xgradient(nvar)
  real(rk),intent(out) :: icoords(nivar)
  real(rk),intent(out) :: igradient(nivar)
! **********************************************************************
  select case (mod(glob%icoord,10))
! ======================================================================
! Cartesian coordinates
! ======================================================================
  case (0)
    if(glob%tatoms) then
      call dlf_cartesian_xtoi(nvar/3,nivar,nicore,glob%massweight, &
          xcoords,xgradient,icoords,igradient)
    else
      icoords(:)=xcoords(:)
      igradient(:)=xgradient(:)
    end if
! ======================================================================
! HDLC/DLC
! ======================================================================
  case (1:4)
    call dlf_hdlc_xtoi(nvar/3,nivar,nicore,glob%micspec, &
         xcoords,xgradient,icoords,igradient)

! ======================================================================
! Wrong coordinate setting
! ======================================================================
  case default
    write(stderr,*) "Coordinate type",glob%icoord,"not implemented"
    call dlf_fail("Coordinate type error (direct)")

  end select
end subroutine dlf_direct_xtoi
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* coords/dlf_direct_itox
!!
!! FUNCTION
!! Transform internal coordinates to xyz coordinates, do not handle breakdowns
!! Only one set of coordinates is transformed, not a path 
!! (as possible by dlf_coords_itox)
!!
!! INPUTS
!!
!! only local variables
!!
!! OUTPUTS
!! 
!! only local variables
!!
!! SYNOPSIS
subroutine dlf_direct_itox(nvar,nivar,nicore,icoords,xcoords,tok)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr,stdout
  implicit none
  integer ,intent(in)   :: nvar,nivar,nicore
  real(rk),intent(in)   :: icoords(nivar)
  real(rk),intent(inout):: xcoords(nvar)
  logical ,intent(out)  :: tok
! **********************************************************************
  select case (mod(glob%icoord,10))
! ======================================================================
! Cartesian coordinates
! ======================================================================
  case (0)
    if(glob%tatoms) then
      call dlf_cartesian_itox(nvar/3,nivar,nicore,glob%massweight,icoords,xcoords)
    else
      xcoords(:)=icoords(:)
    end if
    tok=.true.

! ======================================================================
! HDLC/DLC
! ======================================================================
  case (1:4)
    call dlf_hdlc_itox(nvar/3,nivar,nicore,glob%micspec,icoords,xcoords,tok)

! ======================================================================
! Wrong coordinate setting
! ======================================================================
  case default
    write(stderr,*) "Coordinate type",glob%icoord,"not implemented"
    call dlf_fail("Coordinate type error (direct)")

  end select
end subroutine dlf_direct_itox
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* coords/dlf_direct_get_nivar
!!
!! FUNCTION
!! return the number of internal degrees of freedom to optimise for 
!! one image
!!
!! region = 0 - full region
!! region = 1 - inner (macroiterative) region
!! region = 2 - outer (microiterative) region
!!
!! INPUTS
!!
!! glob%spec
!!
!! OUTPUTS
!! 
!! local
!!
!! SYNOPSIS
subroutine dlf_direct_get_nivar(region, nivar)
!! SOURCE
  use dlf_global, only: glob,stderr
  implicit none
  integer, intent(in) :: region ! microiterative region
  integer, intent(out) :: nivar ! number of internal variables
! **********************************************************************
  select case (mod(glob%icoord,10))
  ! Cartesian coordinates
  case (0)
    call dlf_cartesian_get_nivar(region, nivar)
  ! HDLC/DLC
  case (1:4)
    call dlf_hdlc_get_nivar(region, nivar)
! ======================================================================
! Wrong coordinate setting
! ======================================================================
  case default
    write(stderr,*) "Coordinate type",glob%icoord,"not implemented"
    call dlf_fail("Coordinate type error (direct_get_nivar)")

  end select
end subroutine dlf_direct_get_nivar
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* coords/dlf_cartesian_get_nivar
!!
!! FUNCTION
!! return the number of degrees of freedom to optimise in Cartesian 
!! coordinates
!!
!! region = 0 - full region
!! region = 1 - inner (macroiterative) region
!! region = 2 - outer (microiterative) region
!!
!! INPUTS
!!
!! glob%spec, glob%micspec
!!
!! OUTPUTS
!! 
!! local
!!
!! SYNOPSIS
subroutine dlf_cartesian_get_nivar(region, nivar)
!! SOURCE
  use dlf_global, only: glob,stderr
  implicit none
  integer, intent(in) :: region ! microiterative region
  integer, intent(out) :: nivar ! number of internal variables
  integer :: iat
  logical :: warned
  ! negative spec values:
  ! -1  x,y,z frozen
  ! -2  x frozen
  ! -3  y frozen
  ! -4  z frozen
  ! -23 x and y frozen
  ! -24 x and z frozen
  ! -34 y and z frozen
! **********************************************************************
  warned=.false.
  if(.not.glob%tatoms) then
    ! no Cartesian constraints if no atoms as input
    nivar=glob%nvar
    return
  end if
  nivar=0
  do iat=1,glob%nat
    ! Ignore inner/outer regions as appropriate
    if (region == 1 .and. glob%micspec(iat) == 0) cycle
    if (region == 2 .and. glob%micspec(iat) == 1) cycle
    if(glob%spec(iat)>0) then
      if(.not.warned) then
        !print*,"Warning: fragments not used when Cartesian coordinates are requested!"
        warned=.true.
      end if
      nivar=nivar+3
    else if(glob%spec(iat)==0) then
      ! not frozen
      nivar=nivar+3
    else if(glob%spec(iat)==-1) then
    else if(glob%spec(iat)>=-4) then
      nivar=nivar+2
    else
      nivar=nivar+1
    end if
    ! invalid setting will be recognised in the conversion
  end do
end subroutine dlf_cartesian_get_nivar
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* coords/dlf_cartesian_xtoi
!!
!! FUNCTION
!! Transform xyz coordinates to "internal" Cartesian coordinates.
!! Do mass weighting eventually
!!
!! Meaning of negative glob%spec values:
!!   -1  x,y,z frozen
!!   -2  x frozen
!!   -3  y frozen
!!   -4  z frozen
!!   -23 x and y frozen
!!   -24 x and z frozen
!!   -34 y and z frozen
!!
!! INPUTS
!!
!! glob%spec, (glob%mass)
!!
!! OUTPUTS
!! 
!! only local variables
!!
!! SYNOPSIS
subroutine dlf_cartesian_xtoi(nat,nivar,nicore,massweight,xcoords,xgradient,&
    icoords,igradient)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr
  implicit none
  integer ,intent(in)  :: nat,nivar,nicore
  logical ,intent(in)  :: massweight
  real(rk),intent(in)  :: xcoords(3,nat)
  real(rk),intent(in)  :: xgradient(3,nat)
  real(rk),intent(out) :: icoords(nivar)
  real(rk),intent(out) :: igradient(nivar)
  integer              :: iat,iivar,iinner,iouter
  logical              :: warned
  real(rk)             :: massf
! **********************************************************************
  if(.not.glob%tatoms) then
    call dlf_fail("dlf_cartesian_xtoi can only be used for atom input")
  end if
  warned=.false.
  ! Separate counts to order icoords into inner and outer groups
  iinner = 1
  iouter = nicore + 1
  do iat=1,glob%nat
    if(massweight) then
      massf=dsqrt(glob%mass(iat))
    else
      massf=1.D0
    end if
    if (glob%micspec(iat) == 1) then
       iivar = iinner
    else
       iivar = iouter
    end if
    if(glob%spec(iat)>0) then
      if(.not.warned) then
        !print*,"Warning: fragments not used when Cartesian coordinates are requested!"
        warned=.true.
      end if
      icoords(iivar:iivar+2)=massf*xcoords(:,iat)
      igradient(iivar:iivar+2)=xgradient(:,iat)/massf
      iivar=iivar+3
    else if(glob%spec(iat)==0) then
      ! not frozen
      icoords(iivar:iivar+2)=massf*xcoords(:,iat)
      igradient(iivar:iivar+2)=xgradient(:,iat)/massf
      iivar=iivar+3
    else if(glob%spec(iat)==-1) then
    else if(glob%spec(iat)==-2) then
      icoords(iivar:iivar+1)=massf*xcoords(2:3,iat)
      igradient(iivar:iivar+1)=xgradient(2:3,iat)/massf
      iivar=iivar+2
    else if(glob%spec(iat)==-3) then
      icoords(iivar:iivar+1)=massf*xcoords(1:3:2,iat)
      igradient(iivar:iivar+1)=xgradient(1:3:2,iat)/massf
      iivar=iivar+2
    else if(glob%spec(iat)==-4) then
      icoords(iivar:iivar+1)=massf*xcoords(1:2,iat)
      igradient(iivar:iivar+1)=xgradient(1:2,iat)/massf
      iivar=iivar+2
    else if(glob%spec(iat)==-23) then
      icoords(iivar)=massf*xcoords(3,iat)
      igradient(iivar)=xgradient(3,iat)/massf
      iivar=iivar+1
    else if(glob%spec(iat)==-24) then
      icoords(iivar)=massf*xcoords(2,iat)
      igradient(iivar)=xgradient(2,iat)/massf
      iivar=iivar+1
    else if(glob%spec(iat)==-34) then
      icoords(iivar)=massf*xcoords(1,iat)
      igradient(iivar)=xgradient(1,iat)/massf
      iivar=iivar+1
    else
      write(stderr,"('Spec setting of atom',i5,' is wrong:',i5)") &
          iat,glob%spec(iat)
      call dlf_fail("Wrong spec setting")
    end if
    if (glob%micspec(iat) == 1) then
       iinner = iivar
    else
       iouter = iivar
    end if    
  end do
  if(iinner /= nicore + 1) then
    print*,iinner-1,nicore
    call dlf_fail("Error in the transformation cartesian_xtoi (inner)")
  end if
  if(iouter /= nivar + 1) then
    print*,iouter-1,nivar
    call dlf_fail("Error in the transformation cartesian_xtoi (outer)")
  end if
end subroutine dlf_cartesian_xtoi
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* coords/dlf_cartesian_itox
!!
!! FUNCTION
!! Convert internal cartesian coordinats (frozen components missing)
!! to the full set of cartesians. Do mass re-weighting eventually.
!!
!! IMPORTANT: this routine relies on the fact that the frozen components 
!! of glob%xcoords are not modified by any other routine than this one.
!!
!! INPUTS
!!
!! glob%spec, (glob%mass)
!!
!! OUTPUTS
!! 
!! only local variables
!!
!! SYNOPSIS
subroutine dlf_cartesian_itox(nat,nivar,nicore,massweight,icoords,xcoords)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr
  implicit none
  integer ,intent(in)   :: nat,nivar,nicore
  logical ,intent(in)   :: massweight
  real(rk),intent(in)   :: icoords(nivar)
  real(rk),intent(inout):: xcoords(3,nat)
  integer               :: iat,iivar,iinner,iouter
  logical               :: warned
  real(rk)              :: massf
! **********************************************************************
  if(.not.glob%tatoms) then
    call dlf_fail("dlf_cartesian_itox can only be used for atom input")
  end if
  warned=.false.
  ! Separate counts as icoords is ordered into inner and outer groups
  iinner = 1
  iouter = nicore + 1
  do iat=1,glob%nat
    if(massweight) then
      massf=dsqrt(glob%mass(iat))
    else
      massf=1.D0
    end if
    if (glob%micspec(iat) == 1) then
       iivar = iinner
    else
       iivar = iouter
    end if
    if(glob%spec(iat)>0) then
      if(.not.warned) then
        !print*,"Warning: fragments not used when cartesian coordinates are requested!"
        warned=.true.
      end if
      xcoords(:,iat)=icoords(iivar:iivar+2)/massf
      iivar=iivar+3
    else if(glob%spec(iat)==0) then
      ! not frozen
      xcoords(:,iat)=icoords(iivar:iivar+2)/massf
      iivar=iivar+3
    else if(glob%spec(iat)==-1) then
    else if(glob%spec(iat)==-2) then
      xcoords(2:3,iat)=icoords(iivar:iivar+1)/massf
      iivar=iivar+2
    else if(glob%spec(iat)==-3) then
      xcoords(1:3:2,iat)=icoords(iivar:iivar+1)/massf
      iivar=iivar+2
    else if(glob%spec(iat)==-4) then
      xcoords(1:2,iat)=icoords(iivar:iivar+1)/massf
      iivar=iivar+2
    else if(glob%spec(iat)==-23) then
      xcoords(3,iat)=icoords(iivar)/massf
      iivar=iivar+1
    else if(glob%spec(iat)==-24) then
      xcoords(2,iat)=icoords(iivar)/massf
      iivar=iivar+1
    else if(glob%spec(iat)==-34) then
      xcoords(1,iat)=icoords(iivar)/massf
      iivar=iivar+1
    else
      write(stderr,"('Spec setting of atom',i5,' is wrong:',i5)") &
          iat,glob%spec(iat)
      call dlf_fail("Wrong spec setting")
    end if
    if (glob%micspec(iat) == 1) then
       iinner = iivar
    else
       iouter = iivar
    end if
  end do
  if(iinner /= nicore + 1) then
    print*,iinner-1,nicore
    call dlf_fail("Error in the transformation cartesian_itox (inner)")
  end if
  if(iouter /= nivar + 1) then
    print*,iouter-1,nivar
    call dlf_fail("Error in the transformation cartesian_itox (outer)")
  end if
end subroutine dlf_cartesian_itox
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* coords/dlf_cartesian_gradient_itox
!!
!! FUNCTION
!! Convert an internal cartesian gradient (frozen components missing)
!! to the full set of cartesian gradient. Do mass re-weighting eventually.
!!
!! IMPORTANT: the gradient on frozen atoms is zeroed in this routine
!!
!! INPUTS
!!
!! glob%spec, (glob%mass)
!!
!! OUTPUTS
!! 
!! only local variables
!!
!! SYNOPSIS
subroutine dlf_cartesian_gradient_itox(nat,nivar,nicore,massweight,igradient,xgradient)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr
  implicit none
  integer ,intent(in)   :: nat,nivar,nicore
  logical ,intent(in)   :: massweight
  real(rk),intent(in)   :: igradient(nivar)
  real(rk),intent(out)  :: xgradient(3,nat)
  integer               :: iat,iivar,iinner,iouter
  logical               :: warned
  real(rk)              :: massf
! **********************************************************************
  if(.not.glob%tatoms) then
    call dlf_fail("dlf_cartesian_itox can only be used for atom input")
  end if
  if(mod(glob%icoord,10) /= 0 ) call dlf_fail("dlf_cartesian_gradient_itox&
      & can only be used for cartesian coordinates")
  xgradient(:,:)=0.D0
  warned=.false.
  ! Separate counts as icoords is ordered into inner and outer groups
  iinner = 1
  iouter = nicore + 1
  do iat=1,glob%nat
    if(massweight) then
      massf=1.D0/dsqrt(glob%mass(iat))
    else
      massf=1.D0
    end if
    if (glob%micspec(iat) == 1) then
       iivar = iinner
    else
       iivar = iouter
    end if
    if(glob%spec(iat)>0) then
      if(.not.warned) then
        !print*,"Warning: fragments not used when cartesian coordinates are requested!"
        warned=.true.
      end if
      xgradient(:,iat)=igradient(iivar:iivar+2)/massf
      iivar=iivar+3
    else if(glob%spec(iat)==0) then
      ! not frozen
      xgradient(:,iat)=igradient(iivar:iivar+2)/massf
      iivar=iivar+3
    else if(glob%spec(iat)==-1) then
    else if(glob%spec(iat)==-2) then
      xgradient(2:3,iat)=igradient(iivar:iivar+1)/massf
      iivar=iivar+2
    else if(glob%spec(iat)==-3) then
      xgradient(1:3:2,iat)=igradient(iivar:iivar+1)/massf
      iivar=iivar+2
    else if(glob%spec(iat)==-4) then
      xgradient(1:2,iat)=igradient(iivar:iivar+1)/massf
      iivar=iivar+2
    else if(glob%spec(iat)==-23) then
      xgradient(3,iat)=igradient(iivar)/massf
      iivar=iivar+1
    else if(glob%spec(iat)==-24) then
      xgradient(2,iat)=igradient(iivar)/massf
      iivar=iivar+1
    else if(glob%spec(iat)==-34) then
      xgradient(1,iat)=igradient(iivar)/massf
      iivar=iivar+1
    else
      write(stderr,"('Spec setting of atom',i5,' is wrong:',i5)") &
          iat,glob%spec(iat)
      call dlf_fail("Wrong spec setting")
    end if
    if (glob%micspec(iat) == 1) then
       iinner = iivar
    else
       iouter = iivar
    end if
  end do
  if(iinner /= nicore + 1) then
    print*,iinner-1,nicore
    call dlf_fail("Error in the transformation cartesian_gradient_itox (inner)")
  end if
  if(iouter /= nivar + 1) then
    print*,iouter-1,nivar
    call dlf_fail("Error in the transformation cartesian_gradient_itox (outer)")
  end if
end subroutine dlf_cartesian_gradient_itox
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* coords/dlf_coords_hessian_xtoi
!!
!! FUNCTION
!! Transform Cartesian Hessian into internal Hessian
!!
!! INPUTS
!!
!! local vars (+ glob%spec, glob%mass)
!!
!! OUTPUTS
!! 
!! glob%ihessian
!!
!! SYNOPSIS
subroutine dlf_coords_hessian_xtoi(nvar,xhessian)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr
  implicit none
  integer, intent(in) :: nvar
  real(rk),intent(in) :: xhessian(nvar,nvar)
! **********************************************************************
  select case (glob%icoord)
  ! Cartesians
  case (0)
    call dlf_cartesian_hessian_xtoi(glob%nat,nvar,glob%nivar,glob%massweight,xhessian,&
        glob%spec,glob%mass,glob%ihessian)

  ! HDLC/DLC
  case (1:4)
    call dlf_hdlc_hessian_xtoi(nvar/3,glob%nivar,glob%xcoords,xhessian,glob%ihessian)
  ! qTS in mass-weighted internal coordinates
  case (190)
    call qts_hessian_etos_halfpath 
    !call dlf_qts_get_hessian_external ! previous name of qts_hessian_etos_halfpath
  case default
    write(stderr,*) "Hessian transformation for coordinate type", &
        glob%icoord,"not implemented"
    call dlf_fail("Hessian transformation error")
  end select
end subroutine dlf_coords_hessian_xtoi
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* coords/dlf_cartesian_hessian_xtoi
!!
!! FUNCTION
!! transform a Cartesian Hessian to an internal Cartesian (taking
!! frozen atoms into account. This routine may be improved for speed
!! and memory usage.
!!
!! INPUTS
!!
!! local vars (+ glob%spec, glob%mass)
!!
!! OUTPUTS
!! 
!! local vars
!!
!! SYNOPSIS
subroutine dlf_cartesian_hessian_xtoi(nat,nvar,nivar,massweight,xhessian,&
    spec,mass,ihessian)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr
  implicit none
  integer ,intent(in)  :: nat,nvar,nivar
  logical ,intent(in)  :: massweight
  real(rk),intent(in)  :: xhessian(nvar,nvar)
  integer ,intent(in)  :: spec(nat)
  real(rk),intent(in)  :: mass(nat)
  real(rk),intent(out) :: ihessian(nivar,nivar)
  integer              :: iat,iivar,ivar
  real(rk)             :: umat(nvar,nivar)
  real(rk)             :: umatt(nivar,nvar)
  real(rk)             :: tmpmat(nvar,nivar)
  real(rk)             :: massf
! **********************************************************************
  if(.not.glob%tatoms) then
    if(nvar/=nivar) call dlf_fail("Wrong number of DOF in dlf_cartesian_hessian_xtoi")
    ihessian=xhessian
    return
  end if
  ! set up umat
  umat=0.D0
  iivar=1
  do iat=1,nat
    if(massweight) then
      massf=1.D0/dsqrt(mass(iat))
    else
      massf=1.D0
    end if
    ivar=(iat-1)*3+1
    if(spec(iat)>=0) then
      ! not frozen
      umat(ivar  ,iivar  )=massf
      umat(ivar+1,iivar+1)=massf
      umat(ivar+2,iivar+2)=massf
      iivar=iivar+3
    else if(spec(iat)==-1) then
    else if(spec(iat)==-2) then
      umat(ivar+1,iivar  )=massf
      umat(ivar+2,iivar+1)=massf
      iivar=iivar+2
    else if(spec(iat)==-3) then
      umat(ivar  ,iivar  )=massf
      umat(ivar+2,iivar+1)=massf
      iivar=iivar+2
    else if(spec(iat)==-4) then
      umat(ivar  ,iivar  )=massf
      umat(ivar+1,iivar+1)=massf
      iivar=iivar+2
    else if(spec(iat)==-23) then
      umat(ivar+2,iivar  )=massf
      iivar=iivar+1
    else if(spec(iat)==-24) then
      umat(ivar+1,iivar  )=massf
      iivar=iivar+1
    else if(spec(iat)==-34) then
      umat(ivar  ,iivar  )=massf
      iivar=iivar+1
    else
      write(stderr,"('Spec setting of atom',i5,' is wrong:',i5)") &
          iat,spec(iat)
      call dlf_fail("Wrong spec setting")
    end if
  end do
  if(iivar/=nivar+1) then
    print*,iivar-1,nivar
    call dlf_fail("Error in the transformation cartesian_xtoi")
  end if
  ! now transform the hessian
  call dlf_matrix_multiply(nvar,nivar,nvar,1.D0,xhessian,umat,0.D0,tmpmat)
  umatt=transpose(umat)
  call dlf_matrix_multiply(nivar,nivar,nvar,1.D0,umatt,tmpmat,0.D0,ihessian)

end subroutine dlf_cartesian_hessian_xtoi
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* coords/dlf_cartesian_hessian_itox
!!
!! FUNCTION
!! transform an internal Hessian to a Cartesian Hessian (taking
!! frozen atoms into account. This routine can be improved for speed
!! and memory usage.
!!
!! INPUTS
!!
!! local vars
!!
!! OUTPUTS
!! 
!! local vars
!!
!! SYNOPSIS
subroutine dlf_cartesian_hessian_itox(nat,nvar,nivar,massweight,ihessian,&
    spec,mass,xhessian)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: stderr
  implicit none
  integer ,intent(in)  :: nat,nvar,nivar
  logical ,intent(in)  :: massweight
  real(rk),intent(in)  :: ihessian(nivar,nivar)
  integer ,intent(in)  :: spec(nat)
  real(rk),intent(in)  :: mass(nat)
  real(rk),intent(out) :: xhessian(nvar,nvar)
  integer              :: iat,iivar,ivar
  real(rk)             :: umat(nvar,nivar)
  real(rk)             :: umatt(nivar,nvar)
  real(rk)             :: tmpmat(nivar,nvar)
  real(rk)             :: massf
! **********************************************************************

  ! set up umat
  umat=0.D0
  iivar=1
  do iat=1,nat
    if(massweight) then
      massf=dsqrt(mass(iat))
    else
      massf=1.D0
    end if
    ivar=(iat-1)*3+1
    if(spec(iat)>=0) then
      ! not frozen
      umat(ivar  ,iivar  )=massf
      umat(ivar+1,iivar+1)=massf
      umat(ivar+2,iivar+2)=massf
      iivar=iivar+3
    else if(spec(iat)==-1) then
    else if(spec(iat)==-2) then
      umat(ivar+1,iivar  )=massf
      umat(ivar+2,iivar+1)=massf
      iivar=iivar+2
    else if(spec(iat)==-3) then
      umat(ivar  ,iivar  )=massf
      umat(ivar+2,iivar+1)=massf
      iivar=iivar+2
    else if(spec(iat)==-4) then
      umat(ivar  ,iivar  )=massf
      umat(ivar+1,iivar+1)=massf
      iivar=iivar+2
    else if(spec(iat)==-23) then
      umat(ivar+2,iivar  )=massf
      iivar=iivar+1
    else if(spec(iat)==-24) then
      umat(ivar+1,iivar  )=massf
      iivar=iivar+1
    else if(spec(iat)==-34) then
      umat(ivar  ,iivar  )=massf
      iivar=iivar+1
    else
      write(stderr,"('Spec setting of atom',i5,' is wrong:',i5)") &
          iat,spec(iat)
      call dlf_fail("Wrong spec setting")
    end if
  end do
  if(iivar/=nivar+1) then
    print*,iivar-1,nivar
    call dlf_fail("Error in the transformation cartesian_itox")
  end if
  ! now transform the hessian
  umatt=transpose(umat)
  call dlf_matrix_multiply(nivar,nvar,nivar,1.D0,ihessian,umatt,0.D0,tmpmat)
  call dlf_matrix_multiply(nvar,nvar,nivar,1.D0,umat,tmpmat,0.D0,xhessian)

!  call dlf_matrix_multiply(3*nat,nivar,3*nat,1.D0,xhessian,umat,0.D0,tmpmat)
!  call dlf_matrix_multiply(nivar,nivar,3*nat,1.D0,umatt,tmpmat,0.D0,ihessian)

end subroutine dlf_cartesian_hessian_itox
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* coords/dlf_coords_tranrot
!!
!! FUNCTION
!! Project out the translation and rotation component of a vector in the 
!! current internal coordinate system
!! at the moment, this is only done in Cartesian coordinates if no atom 
!! is frozen
!! vector may be a gradient (which should not contain rotation or 
!! translation anyway) or the dimer axis in the dimer method
!!
!! Rotation not yet implemented!
!!
!! INPUTS
!!
!! only local variables
!!
!! OUTPUTS
!! 
!! only local variables
!!
!! SYNOPSIS
subroutine dlf_coords_tranrot(nvar,vector)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr,printl,stdout
  implicit none
  integer , intent(in)       :: nvar
  real(rk), intent(inout)    :: vector(nvar)
  real(rk)                   :: svar
  integer                    :: nat
! **********************************************************************
  if(mod(glob%icoord,10)/=0) return
  if(glob%massweight) return
  if(.not.glob%tatoms) return
  if(minval(glob%spec(:)) < 0) then
    print*,"Warning: removal of rotation and translation not possible&
        & for frozen atoms"
    return
  end if
  nat=nvar/3
  svar=sum(vector(1:nvar:3))/dble(nat)
  if(printl>=6) write(stdout,'("Removing x-translation:",es12.4)') svar
  vector(1:nvar:3)=vector(1:nvar:3)-svar

  svar=sum(vector(2:nvar:3))/dble(nat)
  if(printl>=6) write(stdout,'("Removing y-translation:",es12.4)') svar
  vector(2:nvar:3)=vector(2:nvar:3)-svar

  svar=sum(vector(3:nvar:3))/dble(nat)
  if(printl>=6) write(stdout,'("Removing z-translation:",es12.4)') svar
  vector(3:nvar:3)=vector(3:nvar:3)-svar

  ! rotation not yet implemented - IMPROVE!
end subroutine dlf_coords_tranrot
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* coords/dlf_cartesian_align
!!
!! FUNCTION
!! Translate and rotate coords2 to minimum square distance from coords1.
!! Both sets have to contain Cartesian coordinates.
!!
!! If one atom is frozen, rotation is done around this atom (no translation
!! is done).
!! If more than one atom is frozen, or other Cartesian constraints are
!! present, nothing is done.
!!
!! See W. Kabsch, Acta Cryst. A 32, p 922 (1976).
!! This follows an RMS best fit procedure.
!!
!! Attention: the input coordinates have to be Cartesians, not 
!! mass-weighted Cartesians!
!!
!! INPUTS
!!
!! only local variables
!!
!! OUTPUTS
!! 
!! only local variables
!!
!! SYNOPSIS
subroutine dlf_cartesian_align(nat,coords1,coords2)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr,printl,stdout
  implicit none
  integer , intent(in)       :: nat
  real(rk), intent(inout)       :: coords1(3,nat)
  real(rk), intent(inout)    :: coords2(3,nat)
  !
  real(rk)                   :: weight(nat) ! now local, can be set on input
  real(rk)                   :: svar,detrot
  integer                    :: ivar,rotat,iat,i,j,itry
  real(rk)                   :: center(3),rmat(3,3),rsmat(3,3)
  real(rk)                   :: eigvec(3,3),eigval(3)
  real(rk)                   :: trans(3),rotmat(3,3)
! **********************************************************************
  if(.not.glob%tatoms) return
  if(minval(glob%spec(:)) < -1) return
  rotat=0
  if(minval(glob%spec(:)) < 0) then
    ivar=0
    do iat=1,nat
      if(glob%spec(iat)==-1) then
        ivar=ivar+1
        if(ivar>1) exit
        rotat=iat
      end if
    end do
    if(ivar>1) return
  end if
  weight(:)=1.D0
  ! remove translation
  ! get centre of coords1 and translational difference
  center(:)=0.D0
  trans(:)=0.D0
  if(rotat==0) then
    do iat=1,nat
      center(:)=center(:)+weight(iat)*coords1(:,iat)
      trans(:)=trans(:)+weight(iat)*(coords1(:,iat)-coords2(:,iat))
    end do
    center(:)=center(:)/sum(weight)
    trans(:)=trans(:)/sum(weight)
  else
    center(:)=coords1(:,rotat)
    trans(:)=coords1(:,rotat)-coords2(:,rotat)
  end if
  ! translate them to common centre
  do iat=1,nat
    coords2(:,iat)=coords2(:,iat)+trans(:)
  end do
  if(printl>=6) write(stdout,"('Translating by ',3f10.5)") trans

  ! now get rotation
  ! following W. Kabsch, Acta Cryst. A 32, p 922 (1976)
  rmat=0.D0
  do iat=1,nat
    do i=1,3
      do j=1,3
        rmat(i,j)=rmat(i,j)+weight(iat)*(coords1(i,iat)-center(i))* &
            (coords2(j,iat)-center(j))
      end do
    end do
  end do
  rmat=rmat/sum(weight)
  !write(*,"('R   ',3f10.3)") rmat
  rsmat=transpose(rmat)
  eigvec=matmul(rsmat,rmat)
  rsmat=eigvec

  !write(stdout,"('RtR ',3f10.3)") rsmat
  call dlf_matrix_diagonalise(3,rsmat,eigval,eigvec)
  !do i=1,3
  !  write(*,"('Eigval, vec a_k ',f10.3,5x,3f10.3)") eigval(i),eigvec(:,i)
  !end do

  ! It turns out that the rotation matrix may have a determinat of -1
  ! in the procedure used here, i.e. the system is mirrored - which is
  ! wrong chemically. This can be avoided by inserting a minus in the
  ! equation
  ! 1.d0/dsqrt(eigval(i)) * matmul(rmat,eigvec(:,i))

  ! So, here we first calculate the rotation matrix, and if it is
  ! zero, the first eigenvalue is reversed

  do itry=1,2
    ! rsmat are the vectors b:
    j=-1
    do i=1,3
      if(eigval(i)<1.D-8) then
        if(i>1) then
          ! the system is linear - no rotation necessay.
          return
          !print*,"Eigenval. zero",i,eigval(i)
          !call dlf_fail("Error in dlf_cartesian_align")
        end if
        j=1
      else
        if(i==1.and.itry==2) then
          rsmat(:,i)=-1.d0/dsqrt(eigval(i)) * matmul(rmat,eigvec(:,i))
        else
          rsmat(:,i)=1.d0/dsqrt(eigval(i)) * matmul(rmat,eigvec(:,i))
        end if
      end if
    end do
    if(j==1) then
      ! one eigenvalue was zero, the system is planar
      rsmat(1,1)=rsmat(2,2)*rsmat(3,3)-rsmat(3,2)*rsmat(2,3)
      rsmat(2,1)=rsmat(3,2)*rsmat(1,3)-rsmat(1,2)*rsmat(3,3)
      rsmat(3,1)=rsmat(1,2)*rsmat(2,3)-rsmat(2,2)*rsmat(1,3)
      ! deal with negative determinant
      if (itry==2) then
         rsmat(:,1) = -rsmat(:,1)
      end if
    end if

    do i=1,3
      do j=1,3
        rotmat(i,j)=sum(rsmat(i,:)*eigvec(j,:))
      end do
    end do
    !write(*,"('rotmat ',3f10.3)") rotmat
    detrot=   &
        rotmat(1,1)*(rotmat(2,2)*rotmat(3,3)-rotmat(2,3)*rotmat(3,2)) &
        -rotmat(2,1)*(rotmat(1,2)*rotmat(3,3)-rotmat(1,3)*rotmat(3,2)) &
        +rotmat(3,1)*(rotmat(1,2)*rotmat(2,3)-rotmat(1,3)*rotmat(2,2))
    !write(*,*) "Determinat of rotmat", detrot
    if(detrot > 0.D0) exit
    if(detrot < 0.D0 .and. itry==2) then
      call dlf_fail("Error in dlf_cartesian_align, obtained a mirroring instead of rotation.")
    end if

  end do

  do iat=1,nat
    coords2(:,iat)= coords2(:,iat)-center
    coords2(:,iat)=matmul(rotmat,coords2(:,iat))
    coords2(:,iat)= coords2(:,iat)+center
  end do
end subroutine dlf_cartesian_align
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* coords/dlf_re_mass_weight_hessian
!!
!! FUNCTION 
!!
!! Get a hessian in mass-weighted coordinates and return one in
!! mass-weighted coordinates with different masses
!!
!! The hessian is in icoords. It will be converted back to xcoords
!! (partially: the frozen atoms will be ignored). Thus, the spec array
!! is needed.
!!
!! SYNOPSIS
subroutine dlf_re_mass_weight_hessian(nat,nivar,mass_in,mass_out,ihessian)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr,printl,stdout
  use dlf_allocate, only: allocate, deallocate
  implicit none
  integer , intent(in)       :: nat ! global number of atoms
  integer , intent(in)       :: nivar ! number of DOF in ihessian
  real(rk), intent(in)       :: mass_in(nat)
  real(rk), intent(in)       :: mass_out(nat)
  real(rk), intent(inout)    :: ihessian(nivar,nivar)
  !
  integer, allocatable :: mapfrozen(:) ! nat
  integer :: iat
  integer :: natr ! number of non-frozen atoms
  integer, allocatable :: spec(:) ! natr
  real(rk),allocatable :: mass(:) ! natr
  real(rk),allocatable :: xhessian(:,:) ! (3*natr,3*natr)
  real(rk) :: svar

  if(nat/=glob%nat) call dlf_fail("Number of atoms inconsistent in dlf_re_mass_weight_hessian")

  call allocate(mapfrozen,nat)

  ! map to a smaller array of xcoords (only non-frozen atoms)
  natr=0
  mapfrozen(:)=0
  do iat=1,nat
    if(glob%spec(iat)/=-1) then
      natr=natr+1
      mapfrozen(iat)=natr ! mapfrozen runs from 1 to natr, its index from 1 to nat
    end if
  end do
  if(printl>=6) write(stdout,*) "Number of non-frozen atoms",natr
  
  call allocate(spec,natr)
  call allocate(mass,natr)
  spec=0
  mass=-1.D0

  do iat=1,nat
    if(mapfrozen(iat)>0) then
      mass(mapfrozen(iat))=mass_in(iat)
      spec(mapfrozen(iat))=glob%spec(iat)
    end if
  end do
  ! sanity check
  if(minval(mass)<0.D0) call dlf_fail("error in mass-array conversion")
  call allocate(xhessian,3*natr,3*natr)

  call dlf_cartesian_hessian_itox(natr,3*natr,nivar,.true.,ihessian,&
    spec,mass,xhessian)

  ! now modify masses
  do iat=1,nat
    if(mapfrozen(iat)>0) then
      ! only modify the masses if they differ by less than a factor of
      ! 4. This is to avoid problems with the wrong (surplus)
      ! conversion between atomic mass units and atomic units
      if(abs(mass_in(iat)-mass_out(iat))>1.D-5) then
        svar=abs(mass(mapfrozen(iat))/mass_out(iat))
        if(svar<10.D0.and.svar>0.1D0) then
          mass(mapfrozen(iat))=mass_out(iat)
          if(printl>=4) then
            write(stdout,'(a,i5,a,f10.6,a,f10.6)') "Mass change atom",iat,": old mass ",mass_in(iat), &
                " new mass ",mass_out(iat)
          end if
        end if
      end if
    end if
  end do
  
  ! adjust args
  call dlf_cartesian_hessian_xtoi(natr,3*natr,nivar,.true.,xhessian,&
      spec,mass,ihessian)

  call deallocate(xhessian)
  call deallocate(mass)
  call deallocate(spec)
  call deallocate(mapfrozen)

end subroutine dlf_re_mass_weight_hessian
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* coords/dlf_checkpoint_coords_write
!!
!! FUNCTION
!! Write checkpoint information
!!
!! SYNOPSIS
subroutine dlf_checkpoint_coords_write
!! SOURCE
  use dlf_global, only: glob,stderr
  implicit none
! **********************************************************************

  ! hdlc
  if(mod(glob%icoord,10)>=1 .and. mod(glob%icoord,10)<=4) then
    call dlf_checkpoint_hdlc_write
  end if

  ! NEB
  if(glob%icoord>=100 .and. glob%icoord<200) then
    call dlf_checkpoint_neb_write
  end if

  ! DIMER
  if(glob%icoord>=200 .and. glob%icoord<300) then
    call dlf_checkpoint_dimer_write
    ! make sure L-BFGS checkpoint is written if dimer is used but no
    ! global l-bfgs
    if(glob%iopt/=3) call DLF_checkpoint_LBFGS_write
  end if

end subroutine dlf_checkpoint_coords_write
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* coords/dlf_checkpoint_coords_read
!!
!! FUNCTION
!! Read checkpoint information
!!
!! SYNOPSIS
subroutine dlf_checkpoint_coords_read(tok)
!! SOURCE
  use dlf_global, only: glob,stderr
  implicit none
  logical,intent(out) :: tok
! **********************************************************************
  tok=.true.

  ! hdlc
  if(mod(glob%icoord,10)>=1 .and. mod(glob%icoord,10)<=4) then
    call dlf_checkpoint_hdlc_read(tok)
    if(.not.tok) return
  end if

  ! NEB
  if(glob%icoord>=100 .and. glob%icoord<200) then
    call dlf_checkpoint_neb_read(tok)
    if(.not.tok) return
  end if

  ! DIMER
  if(glob%icoord>=200 .and. glob%icoord<300) then
    call dlf_checkpoint_dimer_read(tok)
    if(.not.tok) return

    ! make sure L-BFGS checkpoint is written if dimer is used but no
    ! global l-bfgs
    if(glob%iopt/=3) then
      call DLF_checkpoint_LBFGS_read(tok)
    end if

  end if

end subroutine dlf_checkpoint_coords_read
!!****

!!****h* utilities/dlf_mpi
!!
!! NAME
!! mpi
!!
!! FUNCTION
!! Wrappers and more for MPI functionality and taskfarming
!!
!! COPYRIGHT
!!
!!  Copyright 2007 Johannes Kaestner (kaestner@theochem.uni-stuttgart.de),
!!  Tom Keal (thomas.keal@stfc.ac.uk)
!!  Joanne Carr (j.m.carr@dl.ac.uk)
!!
!!  This file is part of DL-FIND.
!!
!!  DL-FIND is free software: you can redistribute it and/or modify
!!  it under the terms of the GNU Lesser General Public License as
!!  published by the Free Software Foundation, either version 3 of the
!!  License, or (at your option) any later version.
!!
!!  DL-FIND is distributed in the hope that it will be useful,
!!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!!  GNU Lesser General Public License for more details.
!!
!!  You should have received a copy of the GNU Lesser General Public
!!  License along with DL-FIND.  If not, see
!!  <http://www.gnu.org/licenses/>.
!!
!! SOURCE
!!****
module dlf_mpi_module
  include 'mpif.h'
  save

  integer  :: global_comm      ! set to, and use instead of, mpi_comm_world
  integer  :: task_comm        ! communicator for a taskfarm
  integer  :: ax_tasks_comm    ! communicator comprising one member
                               ! (``spokesperson'') from each taskfarm
  integer  :: mpi_rk ! set to mpi_double_precision in dlf_mpi_initialize
  integer  :: mpi_ik ! set to mpi_integer in dlf_mpi_initialize

  integer, parameter :: buff_size = 65536
! Since buffers are used in the reduction operations, don't send/receive 
! the whole array in a single chunk but use 1/2 megabyte segments instead
! (after subroutine global_gsum in CRYSTAL, which is the equivalent wrapper
! routine to this one).
! 1MB = 1048576 bytes; 8 bytes per element of a double precision array,
! so buff_size is 65536 or 256**2 (from 1048576/2/8).

end module dlf_mpi_module


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* dlf_mpi/dlf_mpi_initialize
!!
!! FUNCTION
!!
!! Deal with MPI initialization if the calling program has not already 
!! done this, and get processor info (rank, total number) in 
!! MPI_COMM_WORLD.  Exchange this information with the calling program.
!!
!! SYNOPSIS
subroutine dlf_mpi_initialize
!! SOURCE

  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr,stdout
  use dlf_mpi_module
  implicit none

  integer :: ierr, colour, key
  logical :: tinitialized
  character(len=10) :: suffix

! **********************************************************************

  ! The line below is OK unless a compiler option is used to change the 
  ! default for double precision
  mpi_rk = mpi_double_precision
  mpi_ik = mpi_integer

! See if the program that calls dl-find has already called mpi_init
  call mpi_initialized(tinitialized,ierr)
  if (ierr /= 0) write(stdout,'(1x,a)') 'WARNING: MPI error in mpi_initialized'
  ! don't want to call dlf_fail here as that subroutine indirectly calls 
  ! mpi_abort currently!

  if (.not. tinitialized) then ! dl-find sorts out the initial MPI stuff

     call mpi_init(ierr)
     if (ierr /= 0) call dlf_fail("Failure in mpi_init")

     global_comm = mpi_comm_world

     call mpi_comm_rank(global_comm, glob%iam, ierr)
     if (ierr /= 0) call dlf_fail("Failure in mpi_comm_rank")

     call mpi_comm_size(global_comm, glob%nprocs, ierr)
     if (ierr /= 0) call dlf_fail("Failure in mpi_comm_size")

     ! Make this information accessible to the calling (energy and gradient)
     ! program, so that it can translate the variable names.
     call dlf_put_procinfo(glob%nprocs, glob%iam, global_comm)

     !! write some info on the parallelization to standard out
     !write(stdout,'(1x,a)')"In dlf_mpi_initialize: MPI initialization/setup &
     !                      &completed successfully"
     !write(stdout,'(1x,a,i10,a)')"I have rank ",glob%iam," in mpi_comm_world"
     !write(stdout,'(1x,a,i10)')"Total number of processors = ",glob%nprocs
     !if (keep_alloutput) then
     !   write(stdout,'(1x,a)')"Keeping output from all processors"
     !else
     !   write(stdout,'(1x,a)')"Not keeping output from processors /= 0"
     !end if

  else ! the calling program has already done a mpi_init
 
     call dlf_get_procinfo(glob%nprocs, glob%iam, global_comm)

  end if

end subroutine dlf_mpi_initialize
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* dlf_mpi/dlf_mpi_abort
!!
!! FUNCTION
!!
!! mpi_abort wrapper
!!
!! SYNOPSIS
subroutine dlf_mpi_abort
!! SOURCE

  use dlf_parameter_module, only: rk
  use dlf_global, only: stderr,stdout
  use dlf_mpi_module
  implicit none

  integer :: ierr

! **********************************************************************

  call mpi_abort(global_comm,1,ierr)
  ! the 1 is the errorcode, like call exit(1)
  if (ierr /= 0) write(stdout,'(1x,a)') "Failure in mpi_abort"

end subroutine dlf_mpi_abort
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* dlf_mpi/dlf_mpi_finalize
!!
!! FUNCTION
!!
!! mpi_finalize wrapper.  Only makes the call if mpi_initialized returns 
!! .true.
!!
!! SYNOPSIS
subroutine dlf_mpi_finalize
!! SOURCE

  use dlf_global, only: stdout
  use dlf_mpi_module
  implicit none

  integer :: ierr
  logical :: tinitialized

! **********************************************************************

! First check whether mpi is still running...
  call mpi_initialized(tinitialized,ierr)
  if (ierr /= 0) call dlf_fail("Failure in mpi_initialized in dlf_mpi_finalize")

  if (tinitialized) then
     call mpi_finalize(ierr)
     if (ierr /= 0) call dlf_fail("Failure in mpi_finalize")
  else
     write(stdout,'(a)') " Not calling MPI_Finalize in dlf_mpi_finalize"
     write(stdout,'(a)') " as MPI is no longer running"
  end if

end subroutine dlf_mpi_finalize
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* dlf_mpi/dlf_make_taskfarm
!!
!! FUNCTION
!!
!! Either set up taskfarms and send the relevant information back to the 
!! calling program via the dlf_put_taskfarm routine, or get existing 
!! taskfarm info via dlf_get_taskfarm. Do the latter if tdlf_farm == 0 
!! Taskfarming is based on split communicators.
!!
!! SYNOPSIS
subroutine dlf_make_taskfarm(tdlf_farm)
!! SOURCE

! Note that this subroutine must be passed through even if glob%ntasks = 1,
! to set up the appropriate communicators
! Also note that dlf_get_taskfarm is called from here, if the calling 
! program has set up the farms already.

  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr,stdout
  use dlf_mpi_module
  implicit none

  integer :: ierr, colour, key
  integer :: tdlf_farm

! **********************************************************************

  !glob%ntasks = glob%nprocs !!! for testing!!!

  if (tdlf_farm == 0) then
     call dlf_get_taskfarm(glob%ntasks, glob%nprocs_per_task, &
          glob%iam_in_task, glob%mytask, task_comm, ax_tasks_comm)
  else
     if (mod(glob%nprocs, glob%ntasks) /= 0) call dlf_fail("Number of &
                        &processors not divisible by number of workgroups requested")

     glob%nprocs_per_task = glob%nprocs / glob%ntasks

! uses integer division to assign the first glob%nprocs_per_task procs to
! task farm 0, the second set to task farm 1, and so on up to glob%ntasks-1.

     colour = glob%iam / glob%nprocs_per_task

! uses mod function to calculate the rank of each processor with respect
! to its task farm, starting from 0.

     key = mod(glob%iam, glob%nprocs_per_task)

! create a new communicator for each task farm (so only processors in the same
! farm can talk to each other on this communicator)

     call mpi_comm_split(global_comm, colour, key, task_comm, ierr)

     glob%iam_in_task = key
     glob%mytask = colour
     !glob%master_in_task = 0

! create another set of communicators, each of which comprises the ith-ranked 
! processor from each task farm; a simple way of doing this is by swapping the roles of
! colour and key used above.

     call mpi_comm_split(global_comm, key, colour, ax_tasks_comm, ierr)

! Make the taskfarm information accessible to the calling (energy and gradient) 
! program, so that it can translate the variable names.

     call dlf_put_taskfarm(glob%ntasks, glob%nprocs_per_task, glob%iam_in_task,&
                           glob%mytask, task_comm, ax_tasks_comm)
  end if

! Write some debug info about the taskfarm to standard out

!  write(stdout,'(1x,a,i10,a)')"In dlf_make_taskfarm: there are ",glob%ntasks,&
!                              " workgroups"
!  write(stdout,'(1x,a,i10)')"My workgroup is indexed ",glob%mytask
!  write(stdout,'(1x,a,i10,a)')"I have rank ",glob%iam_in_task," in my workgroup"
!  write(stdout,'(1x,a,i10,a)')"There are ",glob%nprocs_per_task," processors &
!                              &in my workgroup"

end subroutine dlf_make_taskfarm
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* dlf_mpi/dlf_mpi_counters
!!
!! FUNCTION
!!
!! Calculate some information on the parallel load balancing for dlf_report. 
!! Total, mean, minimum and maximum and standard deviation of the number of 
!! energy evaluations per processor.
!! Only one contribution to the statistics per taskfarm.
!!
!! INPUTS
!!
!! stat%pene
!! glob%ntasks
!! glob%nprocs
!! glob%iam
!! glob%iam_in_task
!!
!! SYNOPSIS
subroutine dlf_mpi_counters
!! SOURCE

  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stdout,printl
  use dlf_stat, only: stat
  use dlf_mpi_module
  implicit none

  integer :: iproc, n, ierr
  integer :: total_count,lowest_count,highest_count
  integer, dimension(glob%ntasks) :: ene_count
  real(rk) :: mean_count,mean_count2,sigma_count
! **********************************************************************

  if (glob%ntasks == 1 .or. glob%nprocs == 1) return

! First do an mpi_gather to get the pene's from all procs
! Note this is not necessarily equal to stat%sene as some energy
! evaluations may be duplicated across workgroups

  iproc = -1
  if (glob%iam == 0) iproc = glob%iam_in_task
  call dlf_global_int_bcast(iproc, 1, 0)

  ene_count(:) = 0
  call dlf_tasks_int_gather(stat%pene, 1, ene_count, glob%ntasks, iproc)

! Now calculate the stats and do some writing
  if (glob%iam == 0 .and. printl > 0) then

     total_count = sum(ene_count(:))
     mean_count = dble(total_count) / dble(glob%ntasks)
     mean_count2 = dble(sum(ene_count(:)**2)) / dble(glob%ntasks)
     sigma_count = sqrt(mean_count2 - mean_count**2)
     lowest_count = minval(ene_count)
     highest_count = maxval(ene_count)

     write(stdout,'(a)')"Task-farming statistics:"
     write(stdout,2000) "Number of workgroups", glob%ntasks

     if (stat%ccycle > 0) then
        write(stdout,'(a)')"Evaluations of the total energy"
        write(stdout,2000) "Total number (incl. duplicates)",total_count
        write(stdout,2000) "Mean number",nint(mean_count)
        write(stdout,2000) "Standard deviation",nint(sigma_count)
        write(stdout,2000) "Lowest number per workgroup",lowest_count
        write(stdout,2000) "Highest number per workgroup",highest_count
        write(stdout,2000) "Total number (excl. duplicates)",stat%sene
     end if

     write(stdout,'(a)')"Task-farming statistics: end"

  end if  

  ! real number
  1000 format (t1,'................................................', &
           t1,a,' ',t50,es10.3,1x,a)
  ! integer
  2000 format (t1,'................................................', &
           t1,a,' ',t50,i10,1x,a)

end subroutine dlf_mpi_counters
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* dlf_mpi/dlf_mpi_memory
!!
!! FUNCTION
!!
!! Summarise memory use across taskfarms: calculate total, mean, 
!! standard deviation, maximum and minimum.
!!
!! INPUTS
!!
!! local vars
!! glob%ntasks
!! glob%nprocs
!! glob%iam
!! glob%iam_in_task
!!
!! SYNOPSIS
subroutine dlf_mpi_memory(sto,maxsto)
!! SOURCE

  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stdout
  use dlf_mpi_module
  implicit none

  integer :: sto, maxsto
  integer :: iproc, ierr
  integer :: total_stored,lowest_stored,highest_stored
  integer, dimension(glob%ntasks) :: stored
  real(rk) :: mean_stored,mean_stored2,sigma_stored
! **********************************************************************

  if (glob%ntasks == 1 .or. glob%nprocs == 1) return

! First do an mpi_gather to get the sto's from all procs

  iproc = -1
  if (glob%iam == 0) iproc = glob%iam_in_task
  call dlf_global_int_bcast(iproc, 1, 0)

  stored(:) = 0
  call dlf_tasks_int_gather(sto, 1, stored, glob%ntasks, iproc)

  if (minval(stored) > 0 .and. glob%iam == 0) then
     total_stored = sum(stored(:))
     mean_stored = dble(total_stored) / dble(glob%ntasks)
     mean_stored2 = dble(sum(stored(:)**2)) / dble(glob%ntasks)
     sigma_stored = sqrt(mean_stored2 - mean_stored**2)
     lowest_stored = minval(stored)
     highest_stored = maxval(stored)

     write(stdout,'(a)')"Task-farming statistics:"
     write(stdout,'(a)')"Current memory usage (/kB)"
     write(stdout,1000) "Total",dble(total_stored)/1024.D0
     write(stdout,1000) "Mean",mean_stored/1024.D0
     write(stdout,1000) "Standard deviation",sigma_stored/1024.D0
     write(stdout,1000) "Lowest",dble(lowest_stored)/1024.D0
     write(stdout,1000) "Highest",dble(highest_stored)/1024.D0
     write(stdout,'(a)')"Task-farming statistics: end"

  end if

  stored(:) = 0
  call dlf_tasks_int_gather(maxsto, 1, stored, glob%ntasks, iproc)

  if (glob%iam == 0) then
     total_stored = sum(stored(:))
     mean_stored = dble(total_stored) / dble(glob%ntasks)
     mean_stored2 = dble(sum(stored(:)**2)) / dble(glob%ntasks)
     sigma_stored = sqrt(mean_stored2 - mean_stored**2)
     lowest_stored = minval(stored)
     highest_stored = maxval(stored)

     write(stdout,'(a)')"Task-farming statistics:"
     write(stdout,'(a)')"Maximum memory usage (/kB):"
     write(stdout,1000) "Total",dble(total_stored)/1024.D0
     write(stdout,1000) "Mean",mean_stored/1024.D0
     write(stdout,1000) "Standard deviation",sigma_stored/1024.D0
     write(stdout,1000) "Lowest",dble(lowest_stored)/1024.D0
     write(stdout,1000) "Highest",dble(highest_stored)/1024.D0
     write(stdout,'(a)')"Task-farming statistics: end"
     call flush(stdout)

  end if

    ! real number
1000 format (t1,'................................................', &
         t1,a,' ',t50,es10.4,1x,a)

end subroutine dlf_mpi_memory
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* dlf_mpi/dlf_mpi_time
!!
!! FUNCTION
!!
!! Summarise CPU and wallclock timings across taskfarms: calculate total, 
!! mean, standard deviation, maximum and minimum, as part of time_report.
!!
!! INPUTS
!!
!! local vars
!! glob%ntasks
!! glob%nprocs
!! glob%iam
!! glob%iam_in_task
!!
!! SYNOPSIS
subroutine dlf_mpi_time(descr, cput, wallt)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stdout,printl
  use dlf_mpi_module

  implicit none
  integer  :: iproc, n, ierr
  real(rk) :: cput,wallt
  real(rk) :: total_cput,lowest_cput,highest_cput
  real(rk) :: mean_cput,mean_cput2,sigma_cput
  real(rk) :: total_wallt,lowest_wallt,highest_wallt
  real(rk) :: mean_wallt,mean_wallt2,sigma_wallt
  real(rk), dimension(glob%ntasks) :: cputime, walltime
  character(len=*) :: descr
! **********************************************************************

  if (glob%nprocs == 1 .or. glob%ntasks == 1) return

! First do two mpi_gathers to get the cput's and wallt's from all procs

  iproc = -1
  if (glob%iam == 0) iproc = glob%iam_in_task
  call dlf_global_int_bcast(iproc, 1, 0)

  cputime(:) = 0.0D0
  walltime(:) = 0.0D0
  call dlf_tasks_real_gather(cput, 1, cputime, glob%ntasks, iproc)
  call dlf_tasks_real_gather(wallt, 1, walltime, glob%ntasks, iproc)

  if (glob%iam == 0 .and. printl > 0) then
     total_cput = sum(cputime(:))
     mean_cput = total_cput / dble(glob%ntasks)
     mean_cput2 = sum(cputime(:)**2) / dble(glob%ntasks)
     sigma_cput = sqrt(mean_cput2 - mean_cput**2)
     lowest_cput = minval(cputime)
     highest_cput = maxval(cputime)

     total_wallt = sum(walltime(:))
     mean_wallt = total_wallt / dble(glob%ntasks)
     mean_wallt2 = sum(walltime(:)**2) / dble(glob%ntasks)
     sigma_wallt = sqrt(mean_wallt2 - mean_wallt**2)
     lowest_wallt = minval(walltime)
     highest_wallt = maxval(walltime)

     write(stdout,*)
     write(stdout,1000) trim(adjustl(descr))//" CPU /s", total_cput, mean_cput,&
                        sigma_cput, lowest_cput, highest_cput
     write(stdout,1000) trim(adjustl(descr))//" Wall /s", total_wallt, &
                        mean_wallt, sigma_wallt, lowest_wallt, highest_wallt
  end if

  ! real number
  1000 format (t1,"................................................", &
         t1,a," ",t40,5f10.3)


end subroutine dlf_mpi_time
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* dlf_mpi/dlf_global_real_bcast
!!
!! FUNCTION
!!
!! broadcasts the real data in the dummy argument array on the selected root 
!! processor to all other processors via mpi_bcast.  This routine is blocking.
!!
!! INPUTS
!!
!! local variables 
!! glob%nprocs
!! global_comm
!! mpi_rk
!!
!! SYNOPSIS
subroutine dlf_global_real_bcast(a,n,iproc)
!! SOURCE

! broadcasts the real(rk) data in array a on processor iproc
! to all other processors via mpi_bcast.  This routine is blocking.

  use dlf_parameter_module, only: rk
  use dlf_global, only: glob
  use dlf_mpi_module
  implicit none

  integer :: iproc, n, ierr
  real(rk), dimension(n) :: a
! **********************************************************************

  if (glob%nprocs == 1) return
  if (n <= 0) call dlf_fail("dlf_global_real_bcast called with n <= 0")

  call mpi_bcast(a,n,mpi_rk,iproc,global_comm,ierr)

  if (ierr /= 0) call dlf_fail("Failure in dlf_global_real_bcast")

end subroutine dlf_global_real_bcast
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* dlf_mpi/dlf_global_int_bcast
!!
!! FUNCTION
!!
!! broadcasts the integer data in the dummy argument array on the selected root
!! processor to all other processors via mpi_bcast.  This routine is blocking.
!!
!! INPUTS
!!
!! local variables
!! glob%nprocs
!! global_comm
!! mpi_ik
!!
!! SYNOPSIS
subroutine dlf_global_int_bcast(a,n,iproc)
!! SOURCE

! broadcasts the integer data in array a on processor iproc
! to all other processors via mpi_bcast.  This routine is blocking.

  use dlf_parameter_module, only: rk
  use dlf_global, only: glob
  use dlf_mpi_module
  implicit none

  integer :: iproc, n, ierr
  integer, dimension(n) :: a
! **********************************************************************

  if (glob%nprocs == 1) return
  if (n <= 0) call dlf_fail("dlf_global_int_bcast called with n <= 0")

  call mpi_bcast(a,n,mpi_ik,iproc,global_comm,ierr)

  if (ierr /= 0) call dlf_fail("Failure in dlf_global_int_bcast")

end subroutine dlf_global_int_bcast
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* dlf_mpi/dlf_global_log_bcast
!!
!! FUNCTION
!!
!! broadcasts the logical data in the dummy argument array on the selected root
!! processor to all other processors via mpi_bcast.  This routine is blocking.
!!
!! INPUTS
!!
!! local variables
!! glob%nprocs
!! global_comm
!!
!! SYNOPSIS
subroutine dlf_global_log_bcast(a,n,iproc)
!! SOURCE

! broadcasts the logical data in array a on processor iproc
! to all other processors via mpi_bcast.  This routine is blocking.

  use dlf_parameter_module, only: rk
  use dlf_global, only: glob
  use dlf_mpi_module
  implicit none

  integer :: iproc, n, ierr
  logical, dimension(n) :: a
! **********************************************************************

  if (glob%nprocs == 1) return
  if (n <= 0) call dlf_fail("dlf_global_log_bcast called with n <= 0")

  call mpi_bcast(a,n,mpi_logical,iproc,global_comm,ierr)

  if (ierr /= 0) call dlf_fail("Failure in dlf_global_log_bcast")

end subroutine dlf_global_log_bcast
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* dlf_mpi/dlf_global_real_sum
!!
!! FUNCTION
!!
!! Does an mpi_allreduce with the mpi_sum operation on the real data stored 
!! partially in the dummy argument array on each processor.  The result (the 
!! completed array) is known on all processors.  This routine is blocking.
!!
!! INPUTS
!!
!! local vars
!! glob%nprocs
!! mpi_rk
!! global_comm
!!
!! SYNOPSIS
subroutine dlf_global_real_sum(a,n)
!! SOURCE

! Does an mpi_allreduce with the mpi_sum operation on the real(rk) 
! data stored partially in array a on each processor.  The result (the 
! completed array a) is known on all processors.  This routine is blocking.

  use dlf_parameter_module, only: rk
  use dlf_global, only: glob
  use dlf_mpi_module
  implicit none

  integer :: n, ierr, length, start, finish
  real(rk), dimension(n) :: a
  real(rk), dimension(buff_size) :: buff
! **********************************************************************

  if (glob%nprocs == 1) return
  if (n <= 0) call dlf_fail("dlf_global_real_sum called with n <= 0")

  start = 0
  do
     if (start >= n) exit 
     length = min(buff_size, n - start)
     call mpi_allreduce(a(start+1), buff(1:length), length, mpi_rk, mpi_sum, &
                      & global_comm, ierr)
     if (ierr /= 0) call dlf_fail("Failure in dlf_global_real_sum")
     finish = start + length
     a(start+1 : finish) = buff(:length)
     start = finish
  end do

end subroutine dlf_global_real_sum
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* dlf_mpi/dlf_tasks_real_sum
!!
!! FUNCTION
!!
!! Does an mpi_allreduce with the mpi_sum operation on the real data stored
!! partially in the dummy argument array on one processor from each taskfarm,
!! for each group consisting of the processors with the same task-farm rank.
!! Assumes that the arrays on each processor in a particular taskfarm are 
!! identical.
!! The result (the completed array) is known on all the processors involved.
!! This routine is blocking.
!!
!! INPUTS
!!
!! local vars
!! glob%ntasks
!! glob%nprocs
!! mpi_rk
!! ax_tasks_comm
!! buff_size
!!
!! SYNOPSIS
subroutine dlf_tasks_real_sum(a,n)
!! SOURCE

! Does an mpi_allreduce with the mpi_sum operation on the real(rk)
! data stored partially in array a on one processor from each taskfarm, 
! for each group consisting of the processors with the same task-farm rank.
! Assumes that each processor in a particular taskfarm has identical 
! a arrays.! -- nothing is special about the one chosen here.
! The result (the completed array a) is known on all the procs involved.!, 
!! so an mpi_bcast is called with the communicator for a task-farm to make 
!! a known on all processors.  Both routines are blocking.

  use dlf_parameter_module, only: rk
  use dlf_global, only: glob
  use dlf_mpi_module
  implicit none

  integer :: n, ierr, length, start, finish
  real(rk), dimension(n) :: a
  real(rk), dimension(buff_size) :: buff
! **********************************************************************

  if (glob%ntasks == 1 .or. glob%nprocs == 1) return
  if (n <= 0) call dlf_fail("dlf_tasks_real_sum called with n <= 0")

  start = 0
  do
     if (start >= n) exit
     length = min(buff_size, n - start)
     call mpi_allreduce(a(start+1), buff(1:length), length, mpi_rk, mpi_sum, &
                      & ax_tasks_comm, ierr)
     if (ierr /= 0) call dlf_fail("Failure in mpi_allreduce in&
                                & dlf_tasks_real_sum")
     finish = start + length
     a(start+1 : finish) = buff(:length)
     start = finish
  end do

!  call mpi_bcast(a,n,mpi_rk,glob%master_in_task,task_comm,ierr)
!  if (ierr /= 0) call dlf_fail("Failure in mpi_bcast in dlf_tasks_real_sum")
  
end subroutine dlf_tasks_real_sum
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* dlf_mpi/dlf_tasks_int_sum
!!
!! FUNCTION
!!
!! Does an mpi_allreduce with the mpi_sum operation on the integer data stored
!! partially in the dummy argument array on one processor from each taskfarm,  
!! for each group consisting of the processors with the same task-farm rank.
!! Assumes that the arrays on each processor in a particular taskfarm are 
!! identical.
!! The result (the completed array) is known on all the processors involved.
!! This routine is blocking.
!!
!! INPUTS
!!
!! local vars
!! glob%ntasks
!! glob%nprocs
!! mpi_ik
!! ax_tasks_comm
!! buff_size
!!
!! SYNOPSIS
subroutine dlf_tasks_int_sum(a,n)
!! SOURCE

! Does an mpi_allreduce with the mpi_sum operation on the integer 
! data stored partially in array a on one processor from each taskfarm,
! for each group consisting of the processors with the same task-farm rank.
! Assumes that each processor in a particular taskfarm has identical
! a arrays.! -- nothing is special about the one chosen here.
! The result (the completed array a) is known on all the procs involved.!,
!! so an mpi_bcast is called with the communicator for a task-farm to make
!! a known on all processors.  Both routines are blocking.

  use dlf_parameter_module, only: rk
  use dlf_global, only: glob
  use dlf_mpi_module
  implicit none

  integer :: n, ierr, length, start, finish
  integer, dimension(n) :: a
  integer, dimension(buff_size) :: buff
! **********************************************************************

  if (glob%ntasks == 1 .or. glob%nprocs == 1) return
  if (n <= 0) call dlf_fail("dlf_tasks_int_sum called with n <= 0")

  start = 0
  do
     if (start >= n) exit
     length = min(buff_size, n - start)
     call mpi_allreduce(a(start+1), buff(1:length), length, mpi_ik, mpi_sum, &
                      & ax_tasks_comm, ierr)
     if (ierr /= 0) call dlf_fail("Failure in mpi_allreduce in&
                                & dlf_tasks_int_sum")
     finish = start + length
     a(start+1 : finish) = buff(:length)
     start = finish
  end do

!  call mpi_bcast(a,n,mpi_rk,glob%master_in_task,task_comm,ierr)
!  if (ierr /= 0) call dlf_fail("Failure in mpi_bcast in dlf_tasks_real_sum")

end subroutine dlf_tasks_int_sum
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* dlf_mpi/dlf_tasks_int_gather
!!
!! FUNCTION
!!
!! Does an mpi_gather on the items of integer data in the dummy argument 
!! array on one procesor from 
!! each taskfarm, for each group consisting of the processors with the 
!! the same taskfarm rank.  Assumes that each processor in a particular 
!! taskfarm has identical dummy argument arrays.
!! The resulting dummy argument array is only known on the root processor.
!!
!! INPUTS
!!
!! local vars
!! glob%ntasks
!! glob%nprocs
!! mpi_ik
!! ax_tasks_comm
!!
!! SYNOPSIS
subroutine dlf_tasks_int_gather(a,n,b,m,iproc)
!! SOURCE

! Does an mpi_gather on the n items of integer data in array a on one 
! procesor from
! each taskfarm, for each group consisting of the processors with the 
! the same task-farm rank.  Assumes that each processor in a particular 
! taskfarm has identical a arrays.
! The result (array b, of dimension m = n*glob%ntasks) is only known on 
! the root processor, iproc

  use dlf_parameter_module, only: rk
  use dlf_global, only: glob
  use dlf_mpi_module
  implicit none

  integer :: n, m, ierr, iproc
  integer, dimension(n) :: a
  integer, dimension(m) :: b
! **********************************************************************

  if (glob%ntasks == 1 .or. glob%nprocs == 1) then
      if (n /= m) call dlf_fail("dlf_tasks_int_gather called with n /= m")
      b(:) = a(:)
      return
  end if

  if (n <= 0) call dlf_fail("dlf_tasks_int_gather called with n <= 0")
  if (m <= 0) call dlf_fail("dlf_tasks_int_gather called with m <= 0")

  call mpi_gather(a, n, mpi_ik, b, n, mpi_ik, iproc, ax_tasks_comm, ierr)
  if (ierr /= 0) call dlf_fail("Failure in mpi_gather in dlf_tasks_int_gather")

end subroutine dlf_tasks_int_gather
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* dlf_mpi/dlf_tasks_real_gather
!!
!! FUNCTION
!!
!! Does an mpi_gather on the items of real data in the dummy argument
!! array on one procesor from
!! each taskfarm, for each group consisting of the processors with the
!! the same taskfarm rank.  Assumes that each processor in a particular
!! taskfarm has identical dummy argument arrays.
!! The resulting dummy argument array is only known on the root processor.
!!
!! INPUTS
!!
!! local vars
!! glob%ntasks
!! glob%nprocs
!! mpi_rk
!! ax_tasks_comm
!!
!! SYNOPSIS
subroutine dlf_tasks_real_gather(a,n,b,m,iproc)
!! SOURCE

! Does an mpi_gather on the n items of real data in array a on one 
! procesor from
! each taskfarm, for each group consisting of the processors with the
! the same task-farm rank.  Assumes that each processor in a particular
! taskfarm has identical a arrays.
! The result (array b, of dimension m = n*glob%ntasks) is only known on 
! the root processor, iproc

  use dlf_parameter_module, only: rk
  use dlf_global, only: glob
  use dlf_mpi_module
  implicit none

  integer :: n, m, ierr, iproc
  real(rk), dimension(n) :: a
  real(rk), dimension(m) :: b
! **********************************************************************

  if (glob%ntasks == 1 .or. glob%nprocs == 1) then
      if (n /= m) call dlf_fail("dlf_tasks_real_gather called with n /= m")
      b(:) = a(:)
      return
  end if

  if (n <= 0) call dlf_fail("dlf_tasks_real_gather called with n <= 0")
  if (m <= 0) call dlf_fail("dlf_tasks_real_gather called with m <= 0")

  call mpi_gather(a, n, mpi_rk, b, n, mpi_rk, iproc, ax_tasks_comm, ierr)
  if (ierr /= 0) call dlf_fail("Failure in mpi_gather in dlf_tasks_real_gather")

end subroutine dlf_tasks_real_gather
!!****

! **********************************************************************
! **                                                                  **
! **                      Parallel optimisation                       **
! **                                                                  **
! **********************************************************************
!!****h* DL-FIND/parallel_opt
!!
!! NAME
!! parallel_opt
!!
!! FUNCTION
!! Performs a parallel optimisation; currently either stochastic search 
!! or genetic algorithm.
!!
!! COPYRIGHT
!!
!!  Copyright 2007 Johannes Kaestner (kaestner@theochem.uni-stuttgart.de),
!!  Tom Keal (thomas.keal@stfc.ac.uk),
!!  Joanne Carr (j.m.carr@dl.ac.uk)
!!
!!  This file is part of DL-FIND.
!!
!!  DL-FIND is free software: you can redistribute it and/or modify
!!  it under the terms of the GNU Lesser General Public License as
!!  published by the Free Software Foundation, either version 3 of the
!!  License, or (at your option) any later version.
!!
!!  DL-FIND is distributed in the hope that it will be useful,
!!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!!  GNU Lesser General Public License for more details.
!!
!!  You should have received a copy of the GNU Lesser General Public
!!  License along with DL-FIND.  If not, see
!!  <http://www.gnu.org/licenses/>.
!!
!! SOURCE
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* parallel_opt/dlf_parallel_opt
!!
!! FUNCTION
!! Set up, perform and close down after, the parallel optimisation
!! Note that two numbers are hardwired in the code at present -- 
!! small, mainly used as the tolerance on fractional energy differences to 
!! distinguish between structures; and the reduction of the radius by a 
!! factor of 4 after the initial population is set up in the genetic algorithm
!! (search for the comment: Scale the radius from its initial value).
!!
!! INPUTS
!!
!! glob%xcoords
!!
!! for SS -- 
!! glob%po_pop_size
!! glob%po_radius(:)
!! glob%po_contraction
!! glob%po_tolerance_r(:)
!! glob%po_tolerance_g
!! glob%po_distribution
!! glob%po_maxcycle
!! glob%po_scalefac
!!
!! for GA -- 
!! glob%po_pop_size
!! glob%po_radius(:)
!! glob%po_tolerance_g
!! glob%po_maxcycle
!! glob%po_init_pop_size
!! glob%po_reset
!! glob%po_mutation_rate
!! glob%po_death_rate
!! glob%po_nsave
!!
!! OUTPUTS
!!
!! tconv
!!
!! Local variables:
!!  * xcoords_best(:,:)
!!  * energy_best
!!  * for GA, if nsave/=0 -- energies_save(:)
!!                           nevals_save(:)
!!                           xcoords_save(:,:,:)
!!
!! Files, if converged -- best.xyz
!! best_active.xyz
!!
!! SYNOPSIS
subroutine dlf_parallel_opt(trestarted_report, tconv &
#ifdef GAMESS
    ,core&
#endif
    )
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr,stdout,printl,printf
  use dlf_stat, only: stat
  use dlf_allocate, only: allocate,deallocate
  use dlf_checkpoint
  use dlf_sort_module
  implicit none
#ifdef GAMESS
  real(rk) :: core(*) ! GAMESS memory, not used in DL-FIND
#endif
  integer              :: status, iimage, i, j, k, seed_size, nmutations 
  integer              :: nresets, noffspring, lower_index, arr_size
  integer,dimension(1) :: position
  integer,dimension(8) :: time_data
  integer,allocatable  :: seed(:), nevals_save(:)
  logical              :: stochastic, genetic, trestarted_report, tconv, texit
  logical              :: dummy_logical, trestarted, tno_diversity
  real(rk)             :: random, energy_best
  real(rk)             :: mean_init_e, mean_init_e2, sigma_init_e
  real(rk),allocatable :: pop_energies(:), init_pop_energies(:)
  real(rk),allocatable :: icoords_best(:), igradient_best(:), xcoords_best(:,:)
  real(rk),allocatable :: energies_save(:), xcoords_save(:,:,:)
  real(rk),allocatable :: pop_icoords(:,:), init_pop_icoords(:,:)
  real(rk),allocatable :: pop_xgradient(:,:,:)

! may want to change this for different systems...
  real(rk), parameter  :: small=1.0D-12

! **********************************************************************

! Initialise variables
    stochastic = (glob%iopt == 51)
    genetic = (glob%iopt == 52)
    tconv = .false.
    texit = .false.
    seed_size = 1
    energy_best = huge(1.0D0)
    iimage = 1
!    stat%sene = 0
!    stat%ccycle = 0
    ! GA variables
    if (genetic) then
       nresets = 0
       tno_diversity = .false.

       if (glob%po_pop_size < 4) then
          write(stdout,'(1x,a)')"ERROR: working population size is too small"
          write(stdout,'(1x,a)')"Size must be >= 4 for genetic algorithm"
          call dlf_fail("Input population size too small")
       end if

       if (glob%po_init_pop_size < glob%po_pop_size) then
          write(stdout,'(1x,a)')"ERROR: initial population size is too small"
          write(stdout,'(1x,a)')"Size must be >= working population size"
          call dlf_fail("Input initial population size too small")
       end if

       nmutations = nint(glob%po_pop_size * glob%nivar * glob%po_mutation_rate)
       ! use nint above to allow nmutations = 0
       if (nmutations > glob%po_pop_size * glob%nivar) &
                                     &nmutations = glob%po_pop_size * glob%nivar
       noffspring = int(glob%po_pop_size * glob%po_death_rate) + 1
       ! int truncates,  so noffspring will never be zero
       ! check noffspring against the upper limit of glob%po_pop_size - 2
       ! (want to leave at least two individuals as possible parents)
       if (noffspring > glob%po_pop_size - 2) noffspring = glob%po_pop_size - 2
       if (mod(noffspring,2) == 1) then
          ! want to replace the two parents with their two offspring, so ensure 
          ! noffspring is even by increasing the value by 1 if it is odd
          noffspring = noffspring + 1
          if (noffspring > glob%po_pop_size - 2) noffspring = noffspring - 2
       end if

       write(stdout,'(1x,a,i10)')"In dlf_parallel_opt, noffspring = ",noffspring
       write(stdout,'(1x,a,i10)')"In dlf_parallel_opt, nmutations = ",nmutations
    end if
    
! Initialise random number generator on the zeroth processor only
! (no other processor should generate any random numbers...)
! (pgf95 is rather picky about the random number seed, hence the 
! complicated procedure below...)

    if (glob%iam == 0) then
       call random_seed(size = seed_size)
       call allocate(seed, seed_size)
       seed = 1
       call date_and_time(values = time_data)
       seed(1) = time_data(8)
       do i = 1, seed_size - 1
          seed(i + 1) = time_data(8 - mod(i,8)) * seed(1) * i
          ! use smallest units of time_data first, and make the repeats different
          if (seed(i + 1) == 0) seed(i + 1) = i
       end do
       seed = 11*seed ! so seed does not just contain small values
                      ! Also helps to ensure that not all the elements are even 
                      ! (which hinders performance for pgf95)
       call random_seed(put = seed)
       !!! for testing    call random_seed(get = seed)
       write(stdout,'(1x,a)')"Random number seed = "
       do i = 1, seed_size
          write(stdout,*) seed(i)
       end do
       write(stdout,'(1x,a)')"End of random number seed"
       call random_number(random)
       write(stdout,*)"random 1 ",random
       call random_number(random)
       write(stdout,*)"random 2 ",random
    
       call deallocate(seed)
    end if

! allocate storage
    call allocate(pop_icoords, glob%po_pop_size, glob%nivar)
    call allocate(pop_xgradient, glob%po_pop_size, 3, glob%nat)
    call allocate(pop_energies, glob%po_pop_size)
    call allocate(icoords_best, glob%nivar)
    call allocate(igradient_best, glob%nivar)
    call allocate(xcoords_best, 3, glob%nat)
    call allocate(glob%po_radius, glob%nivar)
    call allocate(glob%po_tolerance_r, glob%nivar)

! Set the sample and tolerance radii arrays 
! Note that on restart, the base values glob%po_radius_base and glob%po_tol_r_base
! are obtained from the restart file, but the contents of glob%po_radius_scaling(:) 
! must still be determined from the passed tmpcoords2 array in dlf_get_params. 
! glob%po_radius_scaling(:) can therefore be different from the original if desired.
    arr_size = SIZE(glob%po_radius_scaling, 1)
    if (arr_size == 1 .and. glob%nivar > 1) then
       glob%po_radius(:) = glob%po_radius_base
       glob%po_tolerance_r(:) = glob%po_tol_r_base
    elseif (arr_size == glob%nivar) then
       glob%po_radius(:) = glob%po_radius_base * glob%po_radius_scaling(:)
       glob%po_tolerance_r(:) = glob%po_tol_r_base * glob%po_radius_scaling(:)
    else
       call dlf_fail("Radii scaling factors incompatible with working coordinates")
    end if

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Setup of initial population or individual
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    if (stochastic) then

       lower_index = 1

       ! read checkpoint file OR sort out initial individual
       if (glob%restart == 1) then

          call clock_start("CHECKPOINT")
          call dlf_checkpoint_po_read
          call clock_stop("CHECKPOINT")
          if (.not.trestarted) call dlf_fail("Restart attempt failed")

       else

          ! evaluate initial point
          call clock_start("EANDG")
          call dlf_get_gradient(glob%nvar,glob%xcoords,energy_best, &
               glob%xgradient,iimage,&
#ifdef GAMESS
               core,&
#endif
               status)
          stat%sene = stat%sene + 1
          stat%pene = stat%pene + 1
          call clock_stop("EANDG")

          ! check of NaN in the energy (comparison of NaN with any number
          ! returns .false. , pgf90 does not understand isnan() )
          if ( abs(energy_best) > huge(1.D0) ) then
            status = 1
          else
            if (.not. abs(energy_best) < huge(1.D0) ) status = 1
          end if

          if (status/=0) then
             call dlf_report(trestarted_report)
             call dlf_fail("Energy evaluation failed")
          end if

          xcoords_best(:,:) = glob%xcoords(:,:)
   
          ! convert glob%xcoords and glob%xgradient from Cartesians to the 
          ! working (i-labelled) coordinates glob%icoords and glob%igradient
          call clock_start("COORDS")
          call dlf_coords_xtoi(dummy_logical,dummy_logical,iimage,0)
          call clock_stop("COORDS")

          icoords_best(:) = glob%icoords(:)
          igradient_best(:) = glob%igradient(:)

       end if 

    else if (genetic) then

       lower_index = 2
       call allocate(init_pop_icoords,glob%po_init_pop_size,glob%nivar)
       call allocate(init_pop_energies,glob%po_init_pop_size)

       if (glob%po_nsave > 0) then
          call allocate(xcoords_save,glob%po_nsave,3,glob%nat)
          call allocate(energies_save,glob%po_nsave)
          call allocate(nevals_save,glob%po_nsave)
          energies_save(:) = huge(1.0D0)
          nevals_save(:) = 0
          xcoords_save(:,:,:) = 0.0D0
       end if

       ! read checkpoint file OR sort out initial population
       if (glob%restart == 1) then

          call clock_start("CHECKPOINT")
          call dlf_checkpoint_po_read
          call clock_stop("CHECKPOINT")
          if (.not.trestarted) call dlf_fail("Restart attempt failed")

       else

          ! convert glob%xcoords from Cartesians to the
          ! working (i-labelled) coordinates glob%icoords
          ! The glob%[x,i]gradient arrays contain junk at this point
          glob%xgradient = 0.0D0 ! Safest to initialize though
          call clock_start("COORDS")
          call dlf_coords_xtoi(dummy_logical,dummy_logical,iimage,0)
          call clock_stop("COORDS")

          ! Make initial population...
          if (glob%iam == 0) then
             call clock_start("FORMSTEP")
             call dlf_genetic_initialpop(init_pop_icoords(:,:),&
                                & glob%po_init_pop_size, glob%icoords(:))
             call clock_stop("FORMSTEP")
          end if

          call dlf_global_real_bcast(init_pop_icoords(:,:), &
                                   & glob%po_init_pop_size*glob%nivar, 0)

          ! ...then work out the energy of each individual...
          init_pop_energies(:) = 0.0D0
          do j = 1, glob%po_init_pop_size
             k = mod(j,glob%ntasks)
             stat%sene = stat%sene + 1
             if (k == glob%mytask) then

                glob%icoords(:) = init_pop_icoords(j,:)
   
                ! convert glob%icoords (used as a temporary storage array) back
                ! to Cartesians in glob%xcoords, before call to dlf_get_gradient
   
                call clock_start("COORDS")
                call dlf_coords_itox(iimage)
                call clock_stop("COORDS")

                call clock_start("EANDG")
!!! using pop_xgradient array as a dummy in the call, because IN THE CURRENT 
!!! CODE it will not be used before it is filled with the proper values, and
!!! to save memory I don't want an unnecessary init_pop_xgradient array.
                call dlf_get_gradient(glob%nvar,glob%xcoords, &
                     init_pop_energies(j), pop_xgradient(1,:,:),iimage,&
#ifdef GAMESS
                     core,&
#endif
                     status)
                stat%pene = stat%pene + 1
                call clock_stop("EANDG")

                ! check of NaN in the energy (comparison of NaN with any number
                ! returns .false. , pgf90 does not understand isnan() )
                if ( abs(init_pop_energies(j)) > huge(1.D0) ) then
                  status = 1
                else
                  if (.not. abs(init_pop_energies(j)) < huge(1.D0) ) status = 1
                end if

                if (status/=0) then
                   init_pop_energies(j) = huge(1.0D0)
                   !pop_xgradient(j,:,:) = huge(1.0D0)
                end if

             endif
          enddo

          !!!call dlf_global_real_sum(init_pop_energies(:), glob%po_init_pop_size)
          !!!init_pop_energies(:) = init_pop_energies(:)/glob%nprocs_per_task
          call dlf_tasks_real_sum(init_pop_energies(:), glob%po_init_pop_size)

          ! ...then sort the population on energy...
          call dlf_sort(init_pop_icoords(:,:), init_pop_energies(:), &
                      & glob%po_init_pop_size, glob%nivar)

          ! Write information for the starting population
          mean_init_e = sum(init_pop_energies(:)) / dble(glob%po_init_pop_size)
          mean_init_e2 =sum(init_pop_energies(:)**2)/dble(glob%po_init_pop_size)
          sigma_init_e = sqrt(mean_init_e2 - mean_init_e**2)

          write(stdout,'(1x,a)')"Initial population:"
          write(stdout,'(1x,a,es16.9)')"Lowest energy = ",init_pop_energies(1)
          write(stdout,'(1x,a,es16.9)')"Mean energy = ",mean_init_e
          write(stdout,'(1x,a,es16.9)')"Standard deviation of the energy = ",&
                                       &sigma_init_e

          ! ...and put the glob%po_pop_size fittest (=lowest-energy) individuals
          ! into the working population, pop_icoords(:,:) and pop_energies(:)
          pop_icoords(:,:) = init_pop_icoords(:glob%po_pop_size,:)
          pop_energies(:) = init_pop_energies(:glob%po_pop_size)

       end if

       ! Scale the radius from its initial value, for use in setting up the 
       ! population, to something more appropriate for the mutations.

       glob%po_radius(:) = 0.25D0*glob%po_radius(:)

    else
    
       call dlf_fail("Parallel optimisation option requested that does not &
                     &yet exist")

    end if
   
    call flush(stdout)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! End setup of initial population or individual
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Main cycles loop
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    do i = 1, glob%po_maxcycle

       stat%ccycle = stat%ccycle + 1

! Generate the individuals in the population for this cycle and store them in 
! pop_icoords(:,:)
       if (glob%iam == 0) then
          call clock_start("FORMSTEP")
          if (stochastic) then
             call dlf_stoch_makepop
          else if (genetic) then
             call dlf_genetic_makepop
          end if
          call clock_stop("FORMSTEP")
       end if

       if (genetic) then
          call dlf_global_log_bcast(tno_diversity, 1, 0)
          if (tno_diversity) then
             write(stdout,'(1x,a)')"dlf_parallel_opt WARNING"
             write(stdout,'(1x,a)')"Insufficient genetic diversity in population"
             !exit ! don't necesarily need to exit here
             write(stdout,'(1x,a)')"Resetting population from known individual &
                                   &of lowest energy"
             write(stdout,'(1x,a)')"(Could also try a higher mutation rate)"
             if (glob%iam == 0) then
                call clock_start("FORMSTEP")
                call dlf_genetic_initialpop(pop_icoords(:,:), &
                                   & glob%po_pop_size, pop_icoords(1,:))
                ! Note, dlf_genetic_initialpop doesn't calculate energies
                call clock_stop("FORMSTEP")
             end if
             tno_diversity = .false.
          else
             if (nmutations > 0) then
                if (glob%iam == 0) call dlf_genetic_mutate
             end if
          end if
       end if

       ! This call can go here rather than before the if (genetic) block above 
       ! because the subroutine calls that require pop_icoords(:,:) to be known
       ! should only be made from the master processor (glob%iam ==0), which knows 
       ! the full pop_icoords after the call to dlf_genetic_makepop

      call dlf_global_real_bcast(pop_icoords(:,:),glob%po_pop_size*glob%nivar,0)

       ! This (re)initialization is necessary for the parallel implementation, 
       ! when MPI_Allreduce calls are made for the pop_energies(:) and 
       ! pop_xgradient(:,:,:) arrays.
       call dlf_init_engarrays

       ! calculate energy and gradient for each individual in the population
       ! (apart from the first individual in a GA run...)
       call dlf_get_engarrays

! Make the full pop_energies (and pop_xgradient) arrays known on all processors
       !!!call dlf_global_real_sum(pop_energies(:), glob%po_pop_size)
       !!!pop_energies(:) = pop_energies(:)/glob%nprocs_per_task
       !!!call dlf_global_real_sum(pop_xgradient(:,:,:), glob%po_pop_size*glob%nvar)
       !!!pop_xgradient(:,:,:) = pop_xgradient(:,:,:)/glob%nprocs_per_task
       call dlf_tasks_real_sum(pop_energies(:), glob%po_pop_size)
       call dlf_tasks_real_sum(pop_xgradient(:,:,:), glob%po_pop_size*glob%nvar)

! Prepare for next cycle; test for convergence or failure
       if (stochastic) then
          call dlf_stoch_endcycle
          if (texit) exit
       else if (genetic) then
          call dlf_sort(pop_icoords(:,:), pop_xgradient(:,:,:), &
                  & pop_energies(:), glob%po_pop_size, glob%nivar, 3, glob%nat)
          call dlf_genetic_endcycle
       end if

       if ( (mod(i,glob%po_reset) == 0) .and. genetic) then
          nresets = nresets + 1
          write(stdout,'(1x,a)')"Resetting population from known individual of &
                                &lowest energy"

          if (glob%iam == 0) then
             call clock_start("FORMSTEP")
             call dlf_genetic_initialpop(pop_icoords(:,:), &
                                & glob%po_pop_size, pop_icoords(1,:))
             call clock_stop("FORMSTEP")
          end if

          call dlf_global_real_bcast(pop_icoords(:,:),&
                                    &glob%po_pop_size*glob%nivar,0)
          call dlf_init_engarrays
          call dlf_get_engarrays
          call dlf_tasks_real_sum(pop_energies(:), glob%po_pop_size)
          call dlf_tasks_real_sum(pop_xgradient(:,:,:), &
                                 &glob%po_pop_size*glob%nvar)
          call dlf_sort(pop_icoords(:,:), pop_xgradient(:,:,:), &
                  & pop_energies(:), glob%po_pop_size, glob%nivar, 3, glob%nat)

       end if

       call flush(stdout)

    end do ! the cycles loop

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! End of main cycles loop
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    if (genetic .and. tconv .and. glob%po_nsave > 0) then
       write(stdout,'(1x,a)')"End of genetic algorithm"
       write(stdout,'(1x,a,i10,a)')"List of ",glob%po_nsave," lowest-energy minima"
       do i = 1, glob%po_nsave
          if (energies_save(i) == huge(1.0D0)) then
             write(stdout,'(1x,a)')"Warning: no more unique minima found"
             exit
          end if
          write(stdout,'(1x,i10)') i
          write(stdout,'(1x,a,es16.9)')"Energy = ",energies_save(i)
          write(stdout,'(1x,a,i10,a)')"Found after ",nevals_save(i),&
                                     &" energy evaluations"
          write(stdout,'(1x,a)')"Cartesian coordinates:"
          write(stdout,'(3(1x,es16.9))') xcoords_save(i,:,:)
          call dlf_put_coords(glob%nvar,-i,energies_save(i),xcoords_save(i,:,:)&
                             &,glob%iam)
       end do
    end if

    call flush(stdout)
    call dlf_po_destroy ! deallocate memory
    return

contains
!!****

! Internal procedures as they should not be called from any subroutine apart 
! from dlf_parallel_opt


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* parallel_opt/dlf_init_engarrays
!!
!! FUNCTION
!! 
!! Initialize population energy and gradient arrays to zero before any
!! possible MPI_Allreduce calls are made
!!
!! SYNOPSIS
subroutine dlf_init_engarrays
!! SOURCE

    ! This (re)initialization is necessary for the parallel implementation, when
    ! MPI_Allreduce calls are made.
    if (stochastic) then
       pop_xgradient(:,:,:) = 0.0D0
       pop_energies(:) = 0.0D0
    else if (genetic) then
       ! the first member of the population is excluded from mutation and is
       ! thus unchanged in this generation - no need to recalculate
       if (glob%mytask == 0) then
          pop_xgradient(2:glob%po_pop_size,:,:) = 0.0D0
          pop_energies(2:glob%po_pop_size) = 0.0D0
       else
          pop_xgradient(:,:,:) = 0.0D0
          pop_energies(:) = 0.0D0
       end if
    end if

end subroutine dlf_init_engarrays
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* parallel_opt/dlf_get_engarrays
!!
!! FUNCTION
!!
!! Calculate energy and gradient for each individual in the population
!! (apart from the first individual in a GA run...)
!! Parallelised, with each taskfarm essentially calculating e and g for 
!! the i-th, (i+ntasks)-th, (i+2*ntasks)-th, etc. individuals.
!!
!! INPUTS
!!
!! pop_icoords(:,:)
!! lower_index
!! glob%po_pop_size
!! glob%ntasks
!! glob%mytask
!! iimage
!! glob%nvar
!!
!! OUTPUTS
!!
!! pop_energies(:)
!! pop_xgradient(:,:,:)
!!
!! SYNOPSIS
subroutine dlf_get_engarrays
!! SOURCE

integer :: l, m, status

    do m = lower_index, glob%po_pop_size
       l = mod(m,glob%ntasks)
       stat%sene = stat%sene + 1
       if (l == glob%mytask) then

          glob%icoords(:) = pop_icoords(m,:)

          ! convert glob%icoords (used as a temporary storage array) back
          ! to Cartesians in glob%xcoords, before call to dlf_get_gradient

          call clock_start("COORDS")
          call dlf_coords_itox(iimage)
          call clock_stop("COORDS")

          call clock_start("EANDG")
          call dlf_get_gradient(glob%nvar,glob%xcoords,pop_energies(m), &
               pop_xgradient(m,:,:),iimage,&
#ifdef GAMESS
               core,&
#endif
               status)
          stat%pene = stat%pene + 1
          call clock_stop("EANDG")

          ! check of NaN in the energy (comparison of NaN with any number
          ! returns .false. , pgf90 does not understand isnan() )
          if ( abs(pop_energies(m)) > huge(1.D0) ) then
            status = 1
          else
            if (.not. abs(pop_energies(m)) < huge(1.D0) ) status = 1
          end if

          if (status/=0) then
             pop_energies(m) = huge(1.0D0)
             pop_xgradient(m,:,:) = huge(1.0D0)
          end if

       endif
    enddo

end subroutine dlf_get_engarrays
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* parallel_opt/dlf_stoch_makepop
!!
!! FUNCTION
!!
!! Create the population for a stochastic search.
!! Only executed on the rank-zero processor, as it depends on random 
!! numbers.
!! Works wholly in "i" coordinates.
!!
!! INPUTS
!!
!! glob%po_pop_size
!! glob%nivar
!! glob%iam
!! glob%po_distribution
!! glob%po_radius(:)
!! glob%po_scalefac
!! igradient_best(:)
!!
!! OUTPUTS
!!
!! pop_icoords(:,:)
!!
!! SYNOPSIS
subroutine dlf_stoch_makepop
!! SOURCE

integer :: l,m

    if (glob%iam /= 0) return ! as only iam == 0 has seeded the random number 
                              ! generator.

! we are working wholly in "i" coordinates in this subroutine

    pop_icoords(:,:) = 0.0D0
    do l = 1, glob%po_pop_size
       do m = 1, glob%nivar
          call random_number(random)
          select case (glob%po_distribution)
          case (3) ! force bias
            random = random * glob%po_radius(m)
            random = random * glob%po_scalefac * abs(igradient_best(m))
            if (igradient_best(m) > 0.0D0) random = -1.0D0*random
          case (2) ! force_direction_bias
            random = random * glob%po_radius(m)
            if (igradient_best(m) > 0.0D0) random = -1.0D0*random
          case (1)
            ! uniform distribution over the full hypersphere in config.space
            random = (random * 2.0D0 * glob%po_radius(m)) - glob%po_radius(m)
          case default
             write(stderr,'(1x,a,i2,a)') "Parallel optimisation &
             &distribution type ",glob%po_distribution," not implemented"
             call dlf_fail("Bad option for parallel optimisation distribution &
                           &type")
          end select
          pop_icoords(l,m) = icoords_best(m) + random
       end do
    enddo
   
end subroutine dlf_stoch_makepop
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* parallel_opt/dlf_genetic_makepop
!!
!! FUNCTION
!!
!! Create the population during the cycles of the genetic algorithm.
!! Only executed on the rank-zero processor, as it depends on random 
!! numbers.
!! Works wholly in "i" coordinates.
!!
!! INPUTS
!!
!! glob%iam
!! glob%nivar
!! glob%po_pop_size
!! noffspring
!! pop_energies(:)
!! pop_icoords(:,:)
!!
!! OUTPUTS
!!
!! tno_diversity
!! pop_icoords(:,:) 
!!
!! SYNOPSIS
subroutine dlf_genetic_makepop
!! SOURCE

integer               :: l, m, kk, cross_over
integer,dimension(2)  :: ip
real(rk)              :: sum_w, dummy, dummy2, delta, harvest, blending
real(rk), allocatable :: w_cost(:)

    if (glob%iam /= 0) return ! as only iam == 0 has seeded the random number 
                              ! generator.

! set cost(i.e. energy)-weighted probabilities of parenthood for the breeding 
! population, i.e. the glob%po_pop_size - noffspring lowest-energy individuals 

    call allocate(w_cost,glob%po_pop_size - noffspring)
    sum_w = 0.0D0

    do l = 1, glob%po_pop_size - noffspring
       w_cost(l) = pop_energies(l) - pop_energies(glob%po_pop_size - noffspring + 1)
    end do

    sum_w = sum(w_cost)

    ! test whether the (sorted) energies of the breeding section of the 
    ! population are all identical to at least a chosen precision.

    dummy = abs( (pop_energies(1) - pop_energies(glob%po_pop_size-noffspring)) &
               & / pop_energies(1) )

    ! Also test for the case where, of the breeding population plus the 
    ! next-highest-energy configuration, the lowest is unique and the rest are 
    ! identical.  This situation would mean that the lowest-energy individual 
    ! is the first parent, and no second parent can be selected in the scheme 
    ! in the offspring generation loop below.

    dummy2 = abs( (pop_energies(2) - pop_energies(glob%po_pop_size-noffspring+1)) &
               & / pop_energies(2) )

    ! if the population is lacking in genetic diversity then return

    if (sum_w == 0.0D0 .or. dummy < small .or. dummy2 < small) then
       tno_diversity = .true.
       call deallocate(w_cost)
       return
    end if

    tno_diversity = .false.

    ! Accumulate the w_cost's

    w_cost(:) = w_cost(:)/sum_w

    do l = 2, glob%po_pop_size - noffspring
       w_cost(l) = w_cost(l) + w_cost(l-1)
    end do

    ! in case there are rounding errors, set the final w_cost to 1.0

    w_cost(glob%po_pop_size - noffspring) = 1.0D0

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! offspring generation loop
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    do l = 1, noffspring - 1, 2

       ! select parents: ip(1:2).  Makes sure that ip(1) /= ip(2)

       kk = 1
       do
          call random_number(harvest)
          if (harvest < w_cost(1)) then
              ip(kk) = 1
              kk = kk + 1
          else
              do m = 2, glob%po_pop_size - noffspring
                 if (harvest <= w_cost(m)) then
                    ip(kk) = m
                    kk = kk + 1
                    exit
                 end if
              end do
          end if
          if (kk == 3) then
              if (ip(1) == ip(2)) then
                 kk = 2 ! choose a different "father"
              else
                 exit ! we have two different parents
              end if
          end if
       end do

       ! choose one of the glob%nivar variables as the cross-over point

       call random_number(harvest)
       cross_over = int( harvest * glob%nivar ) + 1
       delta = pop_icoords(ip(1),cross_over) - pop_icoords(ip(2),cross_over)

       ! Check we have a viable cross over point given the parents

       if ( (abs( delta/pop_icoords(ip(1),cross_over) ) < 1.0D3*small) .and. &
           &(cross_over == 1 .or. cross_over == glob%nivar) ) then
          ! no point crossing as the offspring will be identical to the parents
 
          ! Shift the cross-over point one element to the right until we find a 
          ! point at which the parents differ.
          ! At present, if no such point exists then we just continue with the 
          ! value of cross_over from after the do loop, regardless. IMPROVE !!!
          do m = 1, glob%nivar - 1
             cross_over = cross_over + 1
             if (cross_over > glob%nivar) cross_over = 1
             delta = pop_icoords(ip(1),cross_over)-pop_icoords(ip(2),cross_over)
             if (abs( delta/pop_icoords(ip(1),cross_over) ) > 1.0D3*small) exit
          end do
       end if

       ! Choose blending factor

       call random_number(blending)

       ! Make offspring
 
       m = glob%po_pop_size - noffspring ! to save characters

       pop_icoords(m + l     , cross_over) = pop_icoords(ip(1), cross_over) &
                                                           & - blending * delta
       pop_icoords(m + l + 1 , cross_over) = pop_icoords(ip(2), cross_over) &
                                                           & + blending * delta
       if (cross_over == glob%nivar) then
          pop_icoords(m + l     , 1 : glob%nivar - 1) = &
                                       & pop_icoords(ip(1), 1 : glob%nivar - 1)
          pop_icoords(m + l + 1 , 1 : glob%nivar - 1) = &
                                       & pop_icoords(ip(2), 1 : glob%nivar - 1)
       else
           if (cross_over == 1) then
              pop_icoords(m + l     , 2 : glob%nivar) = &
                                           & pop_icoords(ip(2), 2 : glob%nivar)
              pop_icoords(m + l + 1 , 2 : glob%nivar) = &
                                           & pop_icoords(ip(1), 2 : glob%nivar)
           else
              pop_icoords(m + l     , 1 : cross_over - 1) = &
                                       & pop_icoords(ip(1), 1 : cross_over - 1)
              pop_icoords(m + l + 1 , 1 : cross_over - 1) = &
                                       & pop_icoords(ip(2), 1 : cross_over - 1)
 
              pop_icoords(m + l     , cross_over + 1 : glob%nivar) = &
                              & pop_icoords(ip(2), cross_over + 1 : glob%nivar)
              pop_icoords(m + l + 1 , cross_over + 1 : glob%nivar) = &
                              & pop_icoords(ip(1), cross_over + 1 : glob%nivar)
           end if
       end if
    end do

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! end of offspring generation loop
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    call deallocate(w_cost)

end subroutine dlf_genetic_makepop
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* parallel_opt/dlf_genetic_initialpop
!!
!! FUNCTION
!!
!! Create the "initial" population for the genetic algorithm, including 
!! the population after a reset has been requested, from a starting 
!! structure in icoords form.
!! Only executed on the rank-zero processor, as it depends on random 
!! numbers.
!! 
!! INPUTS
!!
!! princeps(:)
!! n
!! glob%nivar
!! glob%po_radius(:)
!! glob%iam
!!
!! OUTPUTS
!!
!! dum_pop(:,:)
!!
!! SYNOPSIS
subroutine dlf_genetic_initialpop(dum_pop,n,princeps)
!! SOURCE

! princeps is the "first citizen" in icoords form, from which the rest of the 
! population will be seeded.
! n is the population size (can be either the initial or working population)
! On return, dum_pop contains the newly created population in icoords form

  integer  :: n, l, m
  real(rk) :: r
  real(rk) :: princeps(:), dum_pop(:,:)

  if (glob%iam /= 0) return ! as only iam == 0 has seeded the random number 
                            ! generator.

  dum_pop(1,:) = princeps(:)
  
  do l = 2, n ! n is the population size
     do m = 1, glob%nivar
        call random_number(r)
        r = (r * 2.0D0 * glob%po_radius(m)) - glob%po_radius(m)
        dum_pop(l,m) = dum_pop(1,m) + r
     end do
  end do

end subroutine dlf_genetic_initialpop
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* parallel_opt/dlf_genetic_mutate
!!
!! FUNCTION
!!
!! Mutate the population in the genetic algorithm by perturbing i-coordinates.
!! Only executed on the rank-zero processor, as it depends on random 
!! numbers.
!!
!! INPUTS
!!
!! glob%iam
!! nmutations
!! glob%po_pop_size
!! glob%nivar
!! glob%po_radius(:)
!! pop_icoords(:,:)
!!
!! OUTPUTS
!!
!! pop_icoords(:,:)
!!
!! SYNOPSIS
subroutine dlf_genetic_mutate
!! SOURCE

integer  :: l, indiv, element
real(rk) :: harvest, shift, factor

  if (glob%iam /= 0) return ! as only iam == 0 has seeded the random number 
                            ! generator.

  do l = 1, nmutations
     call random_number(harvest)
     indiv = int( harvest*(glob%po_pop_size - 1) ) + 2
     ! the "+ 2" means indiv is never one (i.e. the lowest-energy individual)
     if (indiv > glob%po_pop_size) indiv = glob%po_pop_size

     call random_number(harvest)
     element = int( harvest*glob%nivar ) + 1
     if (element > glob%nivar) element = glob%nivar

     call random_number(harvest)
     factor = (glob%po_radius(element)*glob%po_radius(element))/2.0D0
     shift = -factor * log( sqrt( 3.1415D0*factor )*harvest )
     !!! why this form?
     if (abs(shift) > glob%po_radius(element)) shift = glob%po_radius(element)

     call random_number(harvest)
     if (harvest < 0.5D0) shift = -shift
     pop_icoords(indiv, element) = pop_icoords(indiv, element) + shift
  end do

end subroutine dlf_genetic_mutate
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* parallel_opt/dlf_stoch_endcycle
!!
!! FUNCTION
!!
!! Book-keeping at the end of a stochastic search cycle, including 
!! tests for failure and convergence and checkpointing.
!!
!! INPUTS
!!
!! pop_energies(:)
!! pop_icoords(:,:)
!! pop_xgradient(:,:,:)
!! glob%po_tolerance_g
!! glob%po_tolerance_r(:)
!! glob%iam
!! glob%po_radius(:)
!! glob%po_contraction
!! glob%dump
!! printl
!! printf
!!
!! OUTPUTS
!!
!! energy_best
!! icoords_best(:)
!! xcoords_best(:,:)
!! igradient_best(:)
!! tconv
!! texit
!!
!! files, if converged -- best.xyz
!! best_active.xyz
!!
!! SYNOPSIS
subroutine dlf_stoch_endcycle
!! SOURCE
 
integer :: l, k

    if ( minval(pop_energies(:)) < energy_best ) then ! store new "best" arrays
       energy_best = minval(pop_energies(:))
       position(1:1) = minloc(pop_energies(:))
       icoords_best(:) = pop_icoords(position(1),:)

       ! convert icoords_best(:) to Cartesians and store in xcoords_best(3,:)
       glob%icoords(:) = icoords_best(:)
       call clock_start("COORDS")
       call dlf_coords_itox(iimage)
       call clock_stop("COORDS")
       xcoords_best(:,:) = glob%xcoords(:,:)

       ! convert pop_xgradient(position(1), :, :) from Cartesians and store in
       ! igradient_best(:)
       glob%xgradient(:,:) = pop_xgradient(position(1), :, :)
       call clock_start("COORDS")
       call dlf_coords_xtoi(dummy_logical,dummy_logical,iimage,0)
       call clock_stop("COORDS")
       igradient_best(:) = glob%igradient(:)
    endif

    write(stdout,'(1x,a,i10)')"CYCLE ",i 
    ! i is the counter in the cycles do loop of the calling subroutine

! Make sure the value of glob%po_tolerance_g is appropriate for the coord system
    if ( maxval(abs(igradient_best(:))) < glob%po_tolerance_g ) then
       if (printl > 0) then
          write(stdout,'(1x,a)')"****Stochastic search converged****"
          write(stdout,'(1x,a,es16.9)')"Lowest energy = ",energy_best
          if (printl >= 4) then
             write(stdout,'(1x,a)')"for Cartesian coordinates "
             write(stdout,'(3(1x,es16.9))') xcoords_best(:,:)
          end if
          write(stdout,'(1x,a,es16.9)')"Max component of absolute force = ",&
                                       &maxval(abs(igradient_best(:)))
          write(stdout,'(1x,a,i10)')"Number of energy evaluations required = ",&
                                    &1 + glob%po_pop_size*i
       end if

       if (printf>=2 .and. glob%iam == 0) then
          call clock_start("XYZ")
          open(unit=400,file="best.xyz")
          open(unit=401,file="best_active.xyz")
          call write_xyz(400,glob%nat,glob%znuc,xcoords_best)
          call write_xyz_active(401,glob%nat,glob%znuc,glob%spec,xcoords_best)
          close(400)
          close(401)
          call dlf_put_coords(glob%nvar,1,energy_best,xcoords_best,glob%iam)
          call clock_stop("XYZ")
       end if
       tconv = .true.
       texit = .true.
       return
    end if

    glob%po_radius(:) = glob%po_contraction * glob%po_radius(:)

! Stop if any component of the vector of radii falls below its tolerance.
    do l = 1, glob%nivar
       if (glob%po_radius(l) < glob%po_tolerance_r(l)) then
          if (printl > 0) then
             write(stdout,'(1x,a)')"Search restricted to less than minimum radius"
             write(stdout,'(1x,a)')"Sample radius, tolerance:"
             do k = 1, glob%nivar
                write(stdout,'(2(1x,es16.9))') glob%po_radius(k),glob%po_tolerance_r(k) 
             end do
             write(stdout,'(1x,a,es16.9)')"Lowest energy = ",energy_best
             if (printl >= 4) then
                write(stdout,'(1x,a)')"for Cartesian coordinates "
                write(stdout,'(3(1x,es16.9))') xcoords_best(:,:)
             end if
             write(stdout,'(1x,a,es16.9)')"Max component of absolute force = ", &
                                          &maxval(abs(igradient_best(:)))
             write(stdout,'(1x,a,i10)')"Number of energy evaluations required = ",&
                                       &1 + glob%po_pop_size*i
             write(stdout,'(1x,a)')"Stopping"
          end if
          texit = .true.
          return
       end if
    end do

    if (glob%dump > 0 .and. mod(i,glob%dump)==0) then
       call clock_start("CHECKPOINT")
       if (printl>=6) write(stdout,"('Writing restart information')")
       status = 1
       call dlf_checkpoint_write(status)
       call dlf_checkpoint_po_write
       call clock_stop("CHECKPOINT")
    end if

    write(stdout,'(1x,a,es16.9)')"Lowest energy = ",energy_best
    if (printl >= 4) then
       write(stdout,'(1x,a)')"for Cartesian coordinates "
       write(stdout,'(3(1x,es16.9))') xcoords_best(:,:)
    end if
    write(stdout,'(1x,a,es16.9)')"Max component of absolute force = ", &
                                &maxval(abs(igradient_best(:)))
    write(stdout,'(1x,a,i10)')"Energy calls = ",1 + glob%po_pop_size*i

    call flush(stdout)

end subroutine dlf_stoch_endcycle
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* parallel_opt/dlf_genetic_endcycle
!!
!! FUNCTION
!!
!! Book-keeping at the end of a genetic algorithm cycle, including
!! checkpointing and a test for convergence.
!!
!! INPUTS
!!
!! pop_energies(:)
!! pop_icoords(:,:)
!! pop_xgradient(:,:,:)
!! glob%po_tolerance_g
!! glob%iam
!! glob%po_nsave
!! glob%dump
!! printl
!! printf
!!
!! OUTPUTS
!!
!! energy_best
!! icoords_best(:)
!! xcoords_best(:,:)
!! igradient_best(:)
!! tconv
!!
!! if nsave/=0 -- energies_save(:)
!! nevals_save(:)
!! xcoords_save(:,:,:)
!!
!! local variables -- mean_e
!! sigma_e
!!
!! files, if converged -- best.xyz
!! best_active.xyz
!!
!! SYNOPSIS
subroutine dlf_genetic_endcycle
!! SOURCE

integer  :: m, l
real(rk) :: mean_e, mean_e2, sigma_e

    energy_best = pop_energies(1)
    icoords_best(:) = pop_icoords(1,:)

    ! convert icoords_best(:) to Cartesians and store in xcoords_best(3,:)
    glob%icoords(:) = icoords_best(:)
    call clock_start("COORDS")
    call dlf_coords_itox(iimage)
    call clock_stop("COORDS")
    xcoords_best(:,:) = glob%xcoords(:,:)

    ! convert pop_xgradient(1, :, :) from Cartesians and store in
    ! igradient_best(:) !!! assuming we know the gradient already....
    glob%xgradient(:,:) = pop_xgradient(1, :, :)
    call clock_start("COORDS")
    call dlf_coords_xtoi(dummy_logical,dummy_logical,iimage,0)
    call clock_stop("COORDS")
    igradient_best(:) = glob%igradient(:)

    mean_e = sum(pop_energies(:)) / dble(glob%po_pop_size)
    mean_e2 = sum(pop_energies(:)**2) / dble(glob%po_pop_size)
    sigma_e = sqrt(mean_e2 - mean_e**2)

! Write details for this generation
    ! i is the counter in the cycles do loop of the calling subroutine
    write(stdout,'(1x,a,i10)')"CYCLE ",i
    write(stdout,'(1x,a,es16.9)')"Lowest energy = ",pop_energies(1)
    if (printl >= 4) then
       write(stdout,'(1x,a)')"for Cartesian coordinates "
       write(stdout,'(3(1x,es16.9))') xcoords_best(:,:)
    end if
    write(stdout,'(1x,a,es16.9)')"Max component of absolute force = ",&
                                 &maxval(abs(igradient_best(:)))
    write(stdout,'(1x,a,es16.9)')"Mean energy for population = ",mean_e
    write(stdout,'(1x,a,es16.9)')"Standard deviation of the energy = ",sigma_e
    write(stdout,'(1x,a,i10)')"Energy calls = ", &
                   &glob%po_init_pop_size + (glob%po_pop_size - 1)*(i + nresets)

! Make sure the value of glob%po_tolerance_g is appropriate for the coord system
    if ( (maxval(abs(igradient_best(:))) < glob%po_tolerance_g) .AND. &
         (energy_best < HUGE(1.0D0)) ) then
    ! Added a catch for energy_best == huge above to avoid false convergence in the (unlikely!) case the coord transformation
    ! for the gradient vastly changes the values from when the Cartesian gradient vector was set to huge in dlf_get_engarrays
       if (printl > 0) then
          write(stdout,'(1x,a)')"****Genetic algorithm converged to a minimum****"
          write(stdout,'(1x,a,es16.9)')"Lowest energy = ",energy_best
          if (printl >= 4) then
             write(stdout,'(1x,a)')"for Cartesian coordinates "
             write(stdout,'(3(1x,es16.9))') xcoords_best(:,:)
          end if
          write(stdout,'(1x,a,es16.9)')"Max component of absolute force = ", &
                                       &maxval(abs(igradient_best(:)))
          write(stdout,'(1x,a,i10)')"Number of energy evaluations required = ",&
                  &glob%po_init_pop_size + (glob%po_pop_size - 1)*(i + nresets)
          write(stdout,'(1x,a)')"GA continuing... (minimum may be only local)"
       end if

       if (printf>=2 .and. glob%iam == 0) then
          call clock_start("XYZ")
          open(unit=400,file="best.xyz",position="APPEND")
          open(unit=401,file="best_active.xyz",position="APPEND")
          call write_xyz(400,glob%nat,glob%znuc,xcoords_best)
          call write_xyz_active(401,glob%nat,glob%znuc,glob%spec,xcoords_best)
          close(400)
          close(401)
          call clock_stop("XYZ")
       end if

       if (glob%po_nsave > 0) then
          if (energy_best < energies_save(glob%po_nsave)) then
             do m = 1, glob%po_nsave
                !!!crudely check for multiple incidences of a particular minimum
                if ( abs( ( energy_best - energies_save(m) )/energy_best ) &
                   & < small ) exit
                if (energy_best < energies_save(m)) then
                   do l = glob%po_nsave-1, m, -1
                      energies_save(l+1) = energies_save(l)
                      xcoords_save(l+1,:,:) = xcoords_save(l,:,:)
                      nevals_save(l+1) = nevals_save(l)
                   end do
                   energies_save(m) = energy_best
                   xcoords_save(m,:,:) = xcoords_best(:,:)
                   nevals_save(m) = glob%po_init_pop_size + &
                                    &(glob%po_pop_size - 1)*(i + nresets)
                   exit
                end if
             end do
          end if
       end if 

       tconv = .true.
    end if

    if (glob%dump > 0 .and. mod(i,glob%dump)==0) then
       call clock_start("CHECKPOINT")
       if (printl>=6) write(stdout,"('Writing restart information')")
       status = 1
       call dlf_checkpoint_write(status)
       call dlf_checkpoint_po_write
       call clock_stop("CHECKPOINT")
    end if

    call flush(stdout)

end subroutine dlf_genetic_endcycle
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* parallel_opt/dlf_po_destroy
!!
!! FUNCTION
!!
!! Deallocate population arrays
!!
!! SYNOPSIS
subroutine dlf_po_destroy
!! SOURCE

    call deallocate(pop_icoords)
    call deallocate(pop_xgradient)
    call deallocate(pop_energies)

    call deallocate(icoords_best)
    call deallocate(igradient_best)
    call deallocate(xcoords_best)

    if (genetic) then

       call deallocate(init_pop_icoords)
       call deallocate(init_pop_energies)

    end if

    call deallocate(glob%po_radius)
    call deallocate(glob%po_tolerance_r)

end subroutine dlf_po_destroy
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* parallel_opt/dlf_checkpoint_po_read
!!
!! FUNCTION
!!
!! Reading of the parallel optimisation checkpoint file
!!
!! OUTPUTS
!!
!! trestarted
!!
!! SS -- energy_best
!! icoords_best(:)
!! xcoords_best(:,:)
!! igradient_best(:)
!!
!! GA -- pop_icoords(:,:)
!! pop_energies(:)
!! pop_xgradient(:,:,:)
!!
!! SYNOPSIS
subroutine dlf_checkpoint_po_read
!! SOURCE

logical               :: tchk, tallocated
real(rk), allocatable :: dummy(:,:,:)
  ! YL 15/12/2020: we need avoid using file units ifunit, 101, or 102 to make Cray compiler happy
  !                see pp 141: http://103.251.184.12/wp-content/uploads/2018/01/Cray_Fortran_Reference_Manual_S-3901_86.pdf
  !                The values of INPUT_UNIT, OUTPUT_UNIT, and ERROR_UNIT defined in the ISO_Fortran_env module are
  !                ifunit, 101, and 102, respectively. These three unit numbers are reserved and may not be used for other purposes.
  !                The files connected to these units are the same files used by the companion C processor for standard input
  !                (stdin), output (stdout), and error (stderr). An asterisk (*) specified as the unit for a READ statement specifies unit
  !                ifunit. An asterisk specified as the unit for a WRITE statement, and the unit for PRINT statements is unit 101. All
  !                positive default integer values are available for use as unit numbers.
  integer, parameter :: ifunit = 104

  trestarted=.false.
    
  ! check if checkpoint file exists
  INQUIRE(FILE="dlf_parallel_opt.chk",EXIST=tchk)
  if (.not.tchk) then
    write(stdout,10) "File dlf_parallel_opt.chk not found"
    return
  end if

  ! open the checkpoint file
  if (tchkform) then
    open(unit=ifunit,file="dlf_parallel_opt.chk",form="formatted")
  else
    open(unit=ifunit,file="dlf_parallel_opt.chk",form="unformatted")
  end if

  if (stochastic) then

    call read_separator(ifunit,"Best arrays",tchk)
    if (.not. tchk) return
    if (tchkform) then
       read(ifunit,*,end=201,err=200) energy_best, icoords_best(:), &
                                  &xcoords_best(:,:), igradient_best(:)
    else
      read(ifunit,end=201,err=200) energy_best, icoords_best(:), &
                               &xcoords_best(:,:), igradient_best(:)
    end if

  else if (genetic) then

    call read_separator(ifunit,"Population",tchk)
    if (.not. tchk) return
    if (tchkform) then
       read(ifunit,*,end=201,err=200) pop_icoords(:,:), pop_energies(:)
       read(ifunit,*,end=201,err=200) tallocated
       if (tallocated .and. allocated(pop_xgradient)) then
          read(ifunit,*,end=201,err=200) pop_xgradient(:,:,:)
       else if (tallocated) then
          call allocate(dummy, glob%po_pop_size, 3, glob%nat)
          read(ifunit,*,end=201,err=200) dummy(:,:,:)
          call deallocate(dummy)
       end if
    else
       read(ifunit,end=201,err=200) pop_icoords(:,:), pop_energies(:)
       read(ifunit,end=201,err=200) tallocated
       if (tallocated .and. allocated(pop_xgradient)) then
          read(ifunit,end=201,err=200) pop_xgradient(:,:,:)
       else if (tallocated) then
          call allocate(dummy, glob%po_pop_size, 3, glob%nat)
          read(ifunit,end=201,err=200) dummy(:,:,:)
          call deallocate(dummy)
       end if
    end if

  end if

  call read_separator(ifunit,"END",tchk)
  if (.not.tchk) return

! successful reading
  close(ifunit)
  trestarted=.true.
  return

  ! return on error
200 continue
  write(stdout,10) "Error reading parallel optimisation checkpoint file"
  return
201 continue
  write(stdout,10) "Error (EOF) reading parallel optimisation checkpoint file"
  return

10 format("Checkpoint reading WARNING: ",a)

end subroutine dlf_checkpoint_po_read
!!****


! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* parallel_opt/dlf_checkpoint_po_write
!!
!! FUNCTION
!!
!! Writing of the parallel optimisation checkpoint file
!!
!! INPUTS
!!
!! trestarted
!!
!! SS -- energy_best
!! icoords_best(:)
!! xcoords_best(:,:)
!! igradient_best(:)
!!
!! GA -- pop_icoords(:,:)
!! pop_energies(:)
!! pop_xgradient(:,:,:)
!!
!! SYNOPSIS
subroutine dlf_checkpoint_po_write
!! SOURCE

  integer, parameter :: ifunit = 104
! Only want one processor to do the writing; that processor must know         
! all the necessary information.
  if (glob%iam /= 0) return 

! Open the checkpoint file
  if (tchkform) then
    open(unit=ifunit,file="dlf_parallel_opt.chk",form="formatted")
  else
    open(unit=ifunit,file="dlf_parallel_opt.chk",form="unformatted")
  end if

  if (stochastic) then

    call write_separator(ifunit,"Best arrays")
    if (tchkform) then
       write(ifunit,*) energy_best, icoords_best(:), &
                   &xcoords_best(:,:), igradient_best(:)
    else
      write(ifunit) energy_best, icoords_best(:), &
                &xcoords_best(:,:), igradient_best(:)
    end if

  else if (genetic) then

    call write_separator(ifunit,"Population")
    if (tchkform) then
       write(ifunit,*) pop_icoords(:,:), pop_energies(:)
       write(ifunit,*) allocated(pop_xgradient)
       if (allocated(pop_xgradient)) write(ifunit,*) pop_xgradient(:,:,:)
    else
       write(ifunit) pop_icoords(:,:), pop_energies(:)
       write(ifunit) allocated(pop_xgradient)
       if (allocated(pop_xgradient)) write(ifunit) pop_xgradient(:,:,:)
    end if

  end if

  call write_separator(ifunit,"END")
  close(ifunit)

end subroutine dlf_checkpoint_po_write
!!****


end subroutine dlf_parallel_opt
!!****

!  Copyright (C) 2017 The authors of Py-ChemShell
!
!  This file is part of Py-ChemShell.
!
!  Py-ChemShell is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as
!  published by the Free Software Foundation, either version 3 of the
!  License, or (at your option) any later version.
!
!  Py-ChemShell is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with Py-ChemShell.  If not, see
!  <http://www.gnu.org/licenses/>.

!  Stubs - to reduce executable size

!      subroutine mp2_input
!      write(6,*)'mp2_input'
!      stop
!      end
!     subroutine stepper_input
!     write(6,*)'stepper_input'
!     stop
!     end
!      subroutine driver_input
!      write(6,*)'driver_input'
!      stop
!      end
subroutine arg_input
write(6,*)'arg_input'
stop
end
subroutine md_input
write(6,*)'md_input'
stop
end
!      subroutine ccsd_input
!      write(6,*)'ccsd_input'
!      stop
!      end
!      subroutine mcscf_input
!      write(6,*)'mcscf_input'
!      stop
!      end
subroutine plnwv_input
write(6,*)'plnwv_input'
stop
end
!      subroutine dplot_input
!      write(6,*)'dplot_input'
!      stop
!      end
!      subroutine prop_input
!      write(6,*)'prop_input'
!      stop
!      end
subroutine gap_parse
write(6,*)'gap_parse'
stop
end
!     subroutine qmmm_input
!     write(6,*)'qmmm_input'
!     stop
!     end
! required now
!      subroutine task_input
!      write(6,*)'task_input'
!      stop
!      end
subroutine python_input
write(6,*)'python_input'
stop
end
!      subroutine cosmo_initialize
!      write(6,*)'cosmo_initialize'
!      stop
!      end
subroutine cosmo_input
write(6,*)'cosmo_input'
stop
end
!      subroutine cosmo_charges
!      write(6,*)'cosmo_charges'
!      stop
!      end
!      subroutine cosmo_tidy
!      write(6,*)'cosmo_tidy'
!      stop
!      end
subroutine drdy_input
write(6,*)'drdy_input'
stop
end
subroutine pre_input
write(6,*)'pre_input'
stop
end
!      subroutine esp_input
!      write(6,*)'esp_input'
!      stop
!      end
subroutine ana_input
write(6,*)'ana_input'
stop
end
subroutine ideaz_input
write(6,*)'ideaz_input'
stop
end
subroutine nbo_input
write(6,*)'nbo_input'
stop
end
subroutine pspw_input
write(6,*)'pspw_input'
stop
end
!      subroutine cphf_poliz
!      write(6,*)'cphf_poliz'
!      stop
!      end
!      subroutine mcscf
!      write(6,*)'mcscf'
!      stop
!      end
! extra stubs needed because input has been put into libnwctask
!      subroutine int_giao_1ega
!      write(6,*)'int_giao_1ega'
!      stop
!      end
subroutine argos_input
write(6,*)'argos_input'
stop
end
subroutine transp_input
write(6,*)'transp_input'
stop
end
subroutine dia_input
write(6,*)'dia_input'
stop
end
subroutine nwpw_input
write(6,*)'nwpw_input'
stop
end
subroutine smd_input
write(6,*)'smd_input'
stop
end
subroutine rism_input
write(6,*)'rism_input'
stop
end
subroutine ccca_input
write(6,*)'ccca_input'
stop
end
subroutine dntmc_input
write(6,*)'dntmc_input'
stop
end
subroutine mymd_input
write(6,*)'mymd_input'
stop
end
subroutine mymc_input
write(6,*)'mymc_input'
stop
end
subroutine task_ccca_energy
write(6,*)'task_ccca_energy'
stop
end
subroutine task_rism
write(6,*)'task_rism'
stop
end
!     subroutine task_qmmm_energy
!     write(6,*)'task_qmmm_energy'
!     stop
!     end
subroutine dc_energy
write(6,*)'dc_energy'
stop
end
subroutine leps_energy
write(6,*)'leps_energy'
stop
end
subroutine nwmd
write(6,*)'nwmd'
stop
end
subroutine ofpw_energy
write(6,*)'ofpw_energy'
stop
end
subroutine paw_energy
write(6,*)'paw_energy'
stop
end
subroutine band_energy
write(6,*)'band_energy'
stop
end
subroutine pspw_energy
write(6,*)'pspw_energy'
stop
end
subroutine oimp2
write(6,*)'oimp2'
stop
end
subroutine rimp2g
write(6,*)'rimp2g'
stop
end
subroutine task_smd_energy
write(6,*)'task_smd_energy'
stop
end
!     subroutine task_qmmm_gradient
!     write(6,*)'task_qmmm_gradient'
!     stop
!     end
subroutine leps_gradient
write(6,*)'leps_gradient'
stop
end
subroutine paw_gradient
write(6,*)'paw_gradient'
stop
end
subroutine band_gradient
write(6,*)'band_gradient'
stop
end
subroutine pspw_gradient
write(6,*)'pspw_gradient'
stop
end
! Stubs for 6.3 (libqmmm.a)
subroutine qmd_input
write(6,*)'qmd_input'
stop
end
subroutine sp_travel
write(6,*)'sp_travel'
stop
end
subroutine sp_wrttrj
write(6,*)'sp_wrttrj'
stop
end
subroutine md_rdinp
write(6,*)'md_rdinp'
stop
end
subroutine md_start
write(6,*)'md_start'
stop
end
subroutine md_sp
write(6,*)'md_sp'
stop
end
subroutine md_finish
write(6,*)'md_finish'
stop
end
subroutine md_wrtrst
write(6,*)'md_wrtrst'
stop
end
subroutine sp_skip
write(6,*)'sp_skip'
stop
end
subroutine sp_rdtrj
write(6,*)'sp_rdtrj'
stop
end
subroutine prp_print
write(6,*)'prp_print'
stop
end
subroutine cf_print_energy
write(6,*)'cf_print_energy'
stop
end
subroutine sp_printf
write(6,*)'sp_printf'
stop
end
subroutine md_sp_qmmm
write(6,*)'md_sp_qmmm'
stop
end
subroutine cf_wcharge
write(6,*)'cf_wcharge'
stop
end
subroutine cf_trjhdr
write(6,*)'cf_trjhdr'
stop
end
subroutine cf_num2tag
write(6,*)'cf_num2tag'
stop
end
subroutine cf_get_msb
write(6,*)'cf_get_msb'
stop
end
subroutine cf_get_psb
write(6,*)'cf_get_psb'
stop
end
subroutine cf_element 
write(6,*)'cf_element'
stop
end
subroutine cf_charge 
write(6,*)'cf_charge'
stop
end
subroutine pspw_bq_gradient 
write(6,*)'pspw_bq_gradient'
stop
end
subroutine md_em
write(6,*)'md_em'
stop
end
! stubs for 6.6
subroutine mm_input
write(6,*)'mm_input'
stop
end
subroutine mm_add_energy
write(6,*)'mm_add_energy'
stop
end
subroutine mm_add_egrad
write(6,*)'mm_add_egrad'
stop
end
subroutine nwxc_getvals
write(6,*)'nwxc_getvals'
stop
end
subroutine nwxc_getwght
write(6,*)'nwxc_getwght'
stop
end
subroutine nwxc_print
write(6,*)'nwxc_print'
stop
end
subroutine nwxc_get_cam
write(6,*)'nwxc_get_cam'
stop
end
subroutine nwxc_rtdb_load
write(6,*)'nwxc_rtdb_load'
stop
end
subroutine nwxc_input
write(6,*)'nwxc_input'
stop
end
subroutine nwxc_rtdb_store
write(6,*)'nwxc_rtdb_store'
stop
end
subroutine nwxc_init
write(6,*)'nwxc_init'
stop
end
subroutine nwxc_get_disp
write(6,*)'nwxc_get_disp'
stop
end
subroutine nwxc_reset_rho_tolerance
write(6,*)'nwxc_reset_rho_tolerance'
stop
end
subroutine nwxc_eval_df
write(6,*)'nwxc_eval_df'
stop
end
subroutine nwxc_eval_df2
write(6,*)'nwxc_eval_df2'
stop
end
subroutine nwxc_eval_df3
write(6,*)'nwxc_eval_df3'
stop
end
!ENDCHEMSH

!
! The following vector routines are adapted from Construct v84
! by Sam French, Dan Wilson and Alexey Sokol DFRL RI 2008
!

!  Copyright (C) 2017 The authors of Py-ChemShell
!
!  This file is part of Py-ChemShell.
!
!  Py-ChemShell is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as
!  published by the Free Software Foundation, either version 3 of the
!  License, or (at your option) any later version.
!
!  Py-ChemShell is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with Py-ChemShell.  If not, see
!  <http://www.gnu.org/licenses/>.


      subroutine lattice_parameters_2(vect,area,a,b,gamma)
!
! 2-dim case
!
! Calculates lattice parameters and UC area from lattice vectors.
!
      implicit          none
      real*8            vect(2,2),a,b,gamma,area
      area=dabs(vect(1,1)*vect(2,2)-vect(1,2)*vect(2,1))
      a=dsqrt(vect(1,1)**2+vect(1,2)**2)
      b=dsqrt(vect(2,1)**2+vect(2,2)**2)
      gamma=dacos( &
           (vect(1,1)*vect(2,1)+vect(1,2)*vect(2,2))/(a*b))
      return
      end


      subroutine transform_2(device,f,r)
      implicit          none
      real*8            device(2,2),f(2),r(2)
      r(1)=device(1,1)*f(1)+device(2,1)*f(2)
      r(2)=device(1,2)*f(1)+device(2,2)*f(2)
      return
      end


      real*8 function dist_mod_2(device,f1,z1,f2,z2)
!
! 2-dim case
!
! Calculates closest distance between two points f1 and f2 defined by their
! fractional coordinates.
! device, transformation matrix of first rank, calculated beforehand as
! Cartesian coordinates of lattice vectors.
!
      implicit          none
      real*8            device(2,2),                &
                        f1(2),f2(2),d(2),r(2),p(2), &
                        dist2o,dist2n,z1,z2,z3
      integer*4         i,j,k
      do k=1,2
         d(k)=dmod(f1(k)-f2(k),1.d0)
         if(d(k).lt.0.d0) d(k)=d(k)+1.d0
      enddo
      dist2o=1.d32
      do i=-2,2
         p(1)=d(1)+real(i)
         do j=-2,2
            p(2)=d(2)+real(j)
            call transform_2(device,p,r)
            dist2n=r(1)**2+r(2)**2
            if(dist2n.lt.dist2o) then
               dist2o=dist2n
            endif
         enddo
      enddo
      z3=z1-z2
      dist_mod_2=dsqrt( dist2o+z3*z3 )
      return
      end

      real*8 function distance_2(device,f1,z1,f2,z2)
!
! 2-dim case
!
! Calculates absolute distance between two points f1 and f2 defined by their
! fractional and cartesian z1 and z2 coordinates.
! device, transformation matrix of first rank, calculated beforehand as
! Cartesian coordinates of lattice vectors.
!
      implicit          none
      real*8            device(2,2),f1(2),z1,f2(2),z2,d(2),z3,r(2)
      integer*4         i
      d(1)=f2(1)-f1(1)
      d(2)=f2(2)-f1(2)
      z3=z2-z1
      call transform_2(device,d,r)
      distance_2=dsqrt( r(1)*r(1)+r(2)*r(2)+z3*z3 )
      return
      end


      subroutine translate_2(device,f1,f2,r2)
!
! 2-dim case
!
! Translates point f2 to the closest positon to f1 for f1 and f2 defined
! by their fractional coordinates. r2 are revised Cartesian coordinates of f2.
! device, transformation matrix of first rank, calculated beforehand as
! Cartesian coordinates of lattice vectors.
!
      implicit          none
      real*8            device(2,2),f1(2),f2(2),r2(2), &
                        d(2),p(2),r(2),dist2n,dist2o,search_tol
      integer*4         i,j,k
! Threshold prevents arbitrary switching between equivalent coordinates
      search_tol = 1.0d-4
      do k=1,2
         d(k)=dmod(f2(k)-f1(k),1.d0)
      enddo
! Calculate the unchanged position first, again to avoid switching for 
! no reason
      p(1) = d(1)
      p(2) = d(2)
      call transform_2(device,p,r)
      dist2n = r(1)**2 + r(2)**2
      dist2o = dist2n - search_tol
      do k=1,2
         f2(k)=f1(k)+p(k)
      enddo      
! Now search over other positions
      do i=-2,2
         p(1)=d(1)+real(i)
         do j=-2,2
            p(2)=d(2)+real(j)
            call transform_2(device,p,r)
            dist2n=r(1)**2+r(2)**2
            if(dist2n.lt.dist2o) then
               dist2o = dist2n - search_tol
               do k=1,2
                  f2(k)=f1(k)+p(k)
               enddo
            endif
         enddo
      enddo
      call transform_2(device,f2,r2)
      return
      end

! Note on construction of cell vectors
!
! Due to limits of floating precision, gamma=90deg (for example) 
! results in a very small non-zero value for one of the resulting 
! cell vectors and therefore some of the resulting coordinates
!
! The old construct got clean coordinates by printing them out
! in f format instead of the standard e format. As we pass
! data directly to ChemShell this option is not available so
! instead we introduce a threshold (zthresh) for cell vectors below which
! they are reset to 0.
!
! (nb: the 'tiny' threshold in the 3d case is unrelated to this change)
!

      subroutine  lattice_cryst_2(a,b,gamma,vect,area)
!
! 2-dim case
!
! Builds matrix of Cartesian coordinates of surface lattice vectors
! from linear and angular lattice parameters according to CRYSTALL's
! convention:
!      First index counts vectors 1=a, 2=b
!      Second index counts coordinates 1=x, 2=y.
!      Vector b looks along axis Y.
!      Vector a is in XY plane under angle gamma to vector b.
!
      implicit          none
      real*8            vect(2,2),a,b,gamma,area,sin_gamma
      integer           i, j
      real*8            zthresh
      data              zthresh/1.0d-14/
      sin_gamma = dsin(gamma)
      vect(1,1) = a*sin_gamma
      vect(1,2) = a*dcos(gamma)
      vect(2,1) = 0.0d0
      vect(2,2) = b
      do i = 1, 2
         do j = 1, 2
            if (dabs(vect(i,j)) < zthresh) vect(i,j) = 0.0d0
         end do
      end do
      area = a*b*dabs(sin_gamma)
      return
      end


      subroutine  lattice_conv_2(a,b,gamma,vect,area)
!
! 2-dim case
!
! Builds matrix of Cartesian coordinates of surface lattice vectors
! from linear and angular lattice parameters according to CRYSTALL's
! convention:
!      First index counts vectors 1=a, 2=b
!      Second index counts coordinates 1=x, 2=y.
!      Vector a looks along axis X.
!      Vector b is in XY plane under angle gamma to vector a.
!
      implicit          none
      real*8            vect(2,2),a,b,gamma,area,sin_gamma
      integer           i, j
      real*8            zthresh
      data              zthresh/1.0d-14/
      sin_gamma = dsin(gamma)
      vect(1,1) = a
      vect(1,2) = 0.0d0
      vect(2,1) = b*dcos(gamma)
      vect(2,2) = b*sin_gamma
      do i = 1, 2
         do j = 1, 2
            if (dabs(vect(i,j)) < zthresh) vect(i,j) = 0.0d0
         end do
      end do
      area = a*b*dabs(sin_gamma)
      return
      end


      subroutine  lattice_cryst_3(a,b,c,alpha,beta,gamma,vect,volume)
!
! 3-dim case
!
! Builds matrix of Cartesian coordinates of lattice vectors
! from linear and angular lattice parameters according to CRYSTALL's
! convention:
!      First index counts vectors 1=a, 2=b, 3=c.
!      Second index counts coordinates 1=x, 2=y, 3=z.
!      Vector b looks along axis Y.
!      Vector a is in XY plane under angle gamma to vector b.
!      Vector c is over XY plane under angles alpha and beta
!      to vectors a and b, respectively.
! Input lenghths in atomic units.
! Input angles in radians.
!
      implicit          none
      real*8            vect(3,3),a,b,c,alpha,beta,gamma,volume, &
                        tiny,cos_gamma,sin_gamma,x3,y3,square
      integer           i, j
      real*8            zthresh
      data              zthresh/1.0d-14/
      data              tiny/0.1e-20/
      cos_gamma = dcos(gamma)
      sin_gamma = dsin(gamma)
      y3 = dcos(alpha)
      x3 = (dcos(beta)-y3*cos_gamma)/sin_gamma
      square = 1.0d0-x3*x3-y3*y3
      vect(1,1) = a*sin_gamma
      vect(1,2) = a*cos_gamma
      vect(1,3) = 0.0d0
      vect(2,1) = 0.0d0
      vect(2,2) = b
      vect(2,3) = 0.0d0
      vect(3,1) = c*x3
      vect(3,2) = c*y3
      if(square.lt.tiny) then
         vect(3,3) = 0.0d0
      else
         vect(3,3) = c*dsqrt(square)
      endif
      do i = 1, 3
         do j = 1, 3
            if (dabs(vect(i,j)) < zthresh) vect(i,j) = 0.0d0
         end do
      end do
      volume=dabs(vect(1,1)*(vect(2,2)*vect(3,3)-vect(2,3)*vect(3,2))- &
                  vect(2,1)*(vect(1,2)*vect(3,3)-vect(1,3)*vect(3,2))+ &
                  vect(3,1)*(vect(1,2)*vect(2,3)-vect(1,3)*vect(2,2)) )
      return
      end


      subroutine  lattice_conv_3(a,b,c,alpha,beta,gamma,vect,volume)
!
! 3-dim case
!
! Builds matrix of Cartesian coordinates of lattice vectors
! from linear and angular lattice parameters.
!      First index counts vectors 1=a, 2=b, 3=c.
!      Second index counts coordinates 1=x, 2=y, 3=z.
!      Vector a looks along axis X.
!      Vector b is in XY plane under angle gamma to vector a.
!      Vector c is over XY plane under angles alpha and beta
!      to vectors b and a, respectively.
!      The orientation of vectors corresponds to the right trio.
! Input lenghths in atomic units.
! Input angles in radians.
!
      implicit          none
      real*8            vect(3,3),a,b,c,alpha,beta,gamma,volume, &
                        tiny,cos_gamma,sin_gamma,x3,y3,square
      integer           i, j
      real*8            zthresh
      data              zthresh/1.0d-14/
      data              tiny/0.1e-20/
      cos_gamma = dcos(gamma)
      sin_gamma = dsin(gamma)
      x3 = dcos(beta)
      y3 = (dcos(alpha)-x3*cos_gamma)/sin_gamma
      square = 1.0d0-x3*x3-y3*y3
      vect(1,1) = a
      vect(1,2) = 0.0d0
      vect(1,3) = 0.0d0
      vect(2,1) = b*cos_gamma
      vect(2,2) = b*sin_gamma
      vect(2,3) = 0.0d0
      vect(3,1) = c*x3
      vect(3,2) = c*y3
      if(square.lt.tiny) then
         vect(3,3) = 0.0d0
      else
         vect(3,3) = c*dsqrt(square)
      endif
      do i = 1, 3
         do j = 1, 3
            if (dabs(vect(i,j)) < zthresh) vect(i,j) = 0.0d0
         end do
      end do
      volume=dabs(vect(1,1)*(vect(2,2)*vect(3,3)-vect(2,3)*vect(3,2))- &
                  vect(2,1)*(vect(1,2)*vect(3,3)-vect(1,3)*vect(3,2))+ &
                  vect(3,1)*(vect(1,2)*vect(2,3)-vect(1,3)*vect(2,2)) )
      return
      end


      subroutine inverse_3(ai,bi)
!
! 3-dim case
!
! Builds reciprocal vectors, bi, from direct, ai.
! Physical convention is used for reciprocal lattice vectors:
!      exp(i*ai*bi)=1
!
      implicit           none
      real*8                      &
                         two_pi,  &
                         det,     &
                         ai(3,3), &
                         bi(3,3)
       two_pi=2.d0*dacos(-1.d0)
      det= ai(1,1)*(ai(2,2)*ai(3,3)-ai(2,3)*ai(3,2)) &
          -ai(2,1)*(ai(1,2)*ai(3,3)-ai(1,3)*ai(3,2)) &
          +ai(3,1)*(ai(1,2)*ai(2,3)-ai(1,3)*ai(2,2))
      det=two_pi/det
      bi(1,1)= (ai(2,2)*ai(3,3)-ai(2,3)*ai(3,2))*det
      bi(1,2)=-(ai(2,1)*ai(3,3)-ai(2,3)*ai(3,1))*det
      bi(1,3)= (ai(2,1)*ai(3,2)-ai(2,2)*ai(3,1))*det
      bi(2,1)=-(ai(1,2)*ai(3,3)-ai(1,3)*ai(3,2))*det
      bi(2,2)= (ai(1,1)*ai(3,3)-ai(1,3)*ai(3,1))*det
      bi(2,3)=-(ai(1,1)*ai(3,2)-ai(1,2)*ai(3,1))*det
      bi(3,1)= (ai(1,2)*ai(2,3)-ai(2,2)*ai(1,3))*det
      bi(3,2)=-(ai(1,1)*ai(2,3)-ai(1,3)*ai(2,1))*det
      bi(3,3)= (ai(1,1)*ai(2,2)-ai(1,2)*ai(2,1))*det
      return
      end


      subroutine lattice_parameters_3(         &
           vect,volume,a,b,c,alpha,beta,gamma)

!
! 3-dim case
!
! Calculates lattice parameters and UC volume from lattice vectors.
!
      implicit          none
      real*8            vect(3,3),a,b,c,alpha,beta,gamma,volume
      volume=dabs(                                              &
           vect(1,1)*(vect(2,2)*vect(3,3)-vect(2,3)*vect(3,2))- &
           vect(2,1)*(vect(1,2)*vect(3,3)-vect(1,3)*vect(3,2))+ &
           vect(3,1)*(vect(1,2)*vect(2,3)-vect(1,3)*vect(2,2)) )
      a=dsqrt(vect(1,1)**2+vect(1,2)**2+vect(1,3)**2)
      b=dsqrt(vect(2,1)**2+vect(2,2)**2+vect(2,3)**2)
      c=dsqrt(vect(3,1)**2+vect(3,2)**2+vect(3,3)**2)
      alpha=dacos(                                                       &
           (vect(2,1)*vect(3,1)+vect(2,2)*vect(3,2)+vect(2,3)*vect(3,3)) &
          /(b*c) )
      beta=dacos(                                                        &
           (vect(1,1)*vect(3,1)+vect(1,2)*vect(3,2)+vect(1,3)*vect(3,3)) &
          /(a*c) )
      gamma=dacos(                                                       &
           (vect(1,1)*vect(2,1)+vect(1,2)*vect(2,2)+vect(1,3)*vect(2,3)) &
          /(a*b) )
      return
      end


      subroutine transform_3(device,ri,rf)
!
! 3-dim case
!
! Transforms coordinates of a vector from fractional into Cartesian
! and from Cartesian into fractional.
! device, transformation matrix of first rank, calculated beforehand
! as Cartesian coordinates of lattice vectors and reciprocal lattice
! vectors respectively.
!
      implicit          none
      real*8            device(3,3),ri(3),rf(3)
      integer*4         i
      do i=1,3
         rf(i)=ri(1)*device(1,i)+ri(2)*device(2,i)+ri(3)*device(3,i)
      enddo
      return
      end


      real*8 function dist_mod_3(device,f1,f2)
!
! 3-dim case
!
! Calculates closest distance between two points f1 and f2 defined by their
! fractional coordinates.
! device, transformation matrix of first rank, calculated beforehand as
! Cartesian coordinates of lattice vectors.
!
      implicit          none
      real*8            device(3,3)
      real*8            f1(3),f2(3),d(3),r(3),p(3),dist2o,dist2n
      integer*4         i,j,k
      do k=1,3
         d(k)=dmod(f1(k)-f2(k),1.d0)
         if(d(k).lt.0.d0) d(k)=d(k)+1.d0
      enddo
      dist2o=1.d32
      do i=-2,2
         p(1)=d(1)+real(i)
         do j=-2,2
            p(2)=d(2)+real(j)
            do k=-2,2
               p(3)=d(3)+real(k)
               call transform_3(device,p,r)
               dist2n=r(1)**2+r(2)**2+r(3)**2
               if(dist2n.lt.dist2o) then
                  dist2o=dist2n
               endif
            enddo
         enddo
      enddo
      dist_mod_3=dsqrt( dist2o )
      return
      end


      real*8 function distance_3(device,f1,f2)
!
! 3-dim case
!
! Calculates absolute distance between two points f1 and f2 defined by their
! fractional coordinates.
! device, transformation matrix of first rank, calculated beforehand as
! Cartesian coordinates of lattice vectors.
!
      implicit          none
      real*8            device(3,3),f1(3),f2(3),d(3),r(3)
      integer*4         i
      do i=1,3
         d(i)=f2(i)-f1(i)
      enddo
      call transform_3(device,d,r)
      distance_3=dsqrt( r(1)*r(1)+r(2)*r(2)+r(3)*r(3) )
      return
      end


      subroutine translate_3(device,f1,f2,r2)
!
! 3-dim case
!
! Translates point f2 to the closest positon to f1 for f1 and f2 defined
! by their fractional coordinates. r2 are revised Cartesian coordinates of f2.
! device, transformation matrix of first rank, calculated beforehand as
! Cartesian coordinates of lattice vectors.
!
      implicit          none
      real*8            device(3,3),f1(3),f2(3),r2(3),          &
                        d(3),p(3),r(3),dist2n,dist2o,search_tol
      integer*4         i,j,k,l
! Threshold prevents arbitrary switching between equivalent coordinates
      search_tol = 1.0d-4
      do k=1,3
         d(k)=dmod(f2(k)-f1(k),1.0d0)
!         if(d(k).lt.0.d0) d(k)=d(k)+1.d0
      enddo
! Calculate the unchanged position first, again to avoid switching for 
! no reason
      p(1) = d(1)
      p(2) = d(2)
      p(3) = d(3)
      call transform_3(device,p,r)
      dist2n = r(1)**2 + r(2)**2 + r(3)**2
      dist2o = dist2n - search_tol
      do l=1,3
         f2(l)=f1(l)+p(l)
      enddo      
! Now search over other positions
      do i=-2,2
         p(1)=d(1)+real(i)
         do j=-2,2
            p(2)=d(2)+real(j)
            do k=-2,2
               p(3)=d(3)+real(k)
               call transform_3(device,p,r)
               dist2n=r(1)**2+r(2)**2+r(3)**2
               if(dist2n.lt.dist2o) then
                  dist2o = dist2n - search_tol
                  do l=1,3
                     f2(l)=f1(l)+p(l)
                  enddo
               endif
            enddo
         enddo
      enddo
      call transform_3(device,f2,r2)
      return
      end


      subroutine inverse_2(ai,bi,area)
!
! 2-dim case
!
! Builds reciprocal vectors bi from direct vectors ai.
! Factor 2*pi is dropped.
! Calculates volume of UC in direct space.
! ai and bi are transformation matrices of first rank.
!
      implicit           none
      real*8             ai(2,2),bi(2,2)
      real*8             area,det
      real*8                    &
                         two_pi
      two_pi=2.d0*dacos(-1.d0)
      det= ai(1,1)*ai(2,2)-ai(1,2)*ai(2,1)
      area = abs(det)
      det=two_pi/det
      bi(1,1)= ai(2,2)*det
      bi(1,2)=-ai(2,1)*det
      bi(2,1)=-ai(1,2)*det
      bi(2,2)= ai(1,1)*det
      return
      end

! DL_PY2F is a library for direct coupling of Python/NumPy and Fortran developed by
! You Lu and Thomas W. Keal
! STFC Daresbury Laboratory
! under licence LGPLv3
! E-mail: you.lu@stfc.ac.uk

!  Copyright (C) 2017 The authors of DL_PY2F
!
!  This file is part of DL_PY2F.
!
!  DL_PY2F is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as
!  published by the Free Software Foundation, either version 3 of the
!  License, or (at your option) any later version.
!
!  DL_PY2F is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with DL_PY2F.  If not, see
!  <http://www.gnu.org/licenses/>.

module DL_PY2F

    use iso_c_binding

    implicit none

    private
    public  :: ptr2dict, dictType, PyType

    integer , parameter :: LENSTR = 32

    class(*), pointer :: scalarPtr => null()

    type, bind(c) :: CStructType
        ! YL 09/10/2018: components %type, %name, or %dtype of length > 1 no longer allowed by gfortran 8 or later
        character(len=1, kind=c_char) :: type(LENSTR)
        character(len=1, kind=c_char) :: name(LENSTR)
        character(len=1, kind=c_char) :: dtype(LENSTR)
        integer(c_long)               :: size
        integer(c_long)               :: sizem
        logical(c_bool)               :: isfield
        type(c_ptr)                   :: attr
    endtype CStructType
    ! Python object type: the components must be in the same order as defined in __init__.py
    ! YL: bind(c) is necessary here since PyType objects are used
    !     as arguments of c-binding procedures called by Python code;
    !     however, bind(c) and 'contains' section can NOT coexist!
    !     as a result, there is no way to apply an OO manner (e.g.,
    !     call theoryObj%py2f() nor 'extends')
    ! YL 10/02/2018: moved from py2f_datatypes.f90 and py2f_dictionary.f90, which have been deleted,
    !                to allow importing just the module DL_PY2F by the user to use the API. The reason
    !                is that PyType has to be bind(c) and so cannot be extensible at the same time.
    !                If it was not so, we could simply place it in py2f_datatypes.f90 as private_PyType and use
    !                    type, extend(private_PyType) :: PyType
    !                    endtype PyType
    !                in py2f.f90
    type, bind(c) :: PyType
        integer(c_long)   :: nattrs = 0
        type(c_ptr)       :: class_
        integer(c_long)   :: address_
        integer(c_long)   :: width
        ! YL NB 15/08/2021: on the Python side pointers are used because an error is encountered otherwise
        !                   so that debug has to be decoded by c_f_pointer()
        type(c_ptr)       :: debug
        type(CStructType) :: cdata
    endtype PyType
    ! a general-purpose dictionary-like class
    type dictType
        character(len=LENSTR)     :: type  = ""
! for now impossible to implement unlimited polymorphic arrays (see below) 
        integer                   :: sizem =  0
        integer                   :: sizen =  0
        character(len=:), pointer :: key             => null()
        class(*)        , pointer :: scalar          => null()
        class(*)        , pointer :: array(:)        => null()
        type(PyType)    , pointer :: PyPtr           => null()
        character(len=8), pointer :: onedimchar(:)   => null()
        integer(kind=8) , pointer :: onedimint(:)    => null()
        integer(kind=8) , pointer :: twodimint(:,:)  => null()
        real(kind=8)    , pointer :: onedimdbl(:)    => null()
        real(kind=8)    , pointer :: twodimdbl(:,:)  => null()
        real(kind=8)    , pointer :: onedimcdbl(:)   => null()
        real(kind=8)    , pointer :: twodimcdbl(:,:) => null()
        type(dictType)  , pointer :: next            => null()
        contains
        generic, public :: assign => assignScalar,     &
!                                     assignNull,       &
                                     assignOneDimChar, &
                                     assignOneDimDbl,  &
                                     assignTwoDimDbl,  &
                                     assignOneDimInt,  &
                                     assignTwoDimInt
        generic, public :: get    => getInt,        &
                                     getIntCLong,   &
                                     getReal,       &
                                     getDouble,     &
                                     getOneDimInt,  &
                                     getOneDimLong, &
                                     getOneDimDbl,  &
                                     getTwoDimInt,  &
                                     getTwoDimLong, &
                                     getTwoDimDbl,  &
                                     getChar,       &
                                     getCCharArray, &
                                     getLogical,    &
                                     getCLogical,   &
                                     getPyPtr,      &
!                                     getCPtr,       &
                                     getCFuncPtr
        generic, public :: set    => setOneDimDbl,  &
                                     setTwoDimDbl,  &
                                     setOneDimInt,  &
                                     setTwoDimInt,  &
                                     setOneDimLong, &
                                     setTwoDimLong, &
                                     setCCharArray, &
                                     setScalar
        ! initialiser
        procedure, public :: initialise => private_initialise
        procedure, public :: init       => private_initialise
        procedure, public :: finalise   => private_finalise
        ! assigners
        procedure, private :: assignScalar
!        procedure, private :: assignNull
        procedure, private :: assignOneDimChar
        procedure, private :: assignOneDimInt
        procedure, private :: assignTwoDimInt
        procedure, private :: assignOneDimDbl
        procedure, private :: assignTwoDimDbl
        procedure, private :: assignPyPtr
        ! getters
        ! Intel compiler requires to define the procedures line by line, rather than "procedure, private :: getInt, getReal, getChar" in a single line
        procedure, private :: getIntCLong
        procedure, private :: getInt
        procedure, private :: getReal
        procedure, private :: getDouble
        procedure, private :: getOneDimInt
        procedure, private :: getOneDimLong
        procedure, private :: getOneDimDbl
        procedure, private :: getTwoDimInt
        procedure, private :: getTwoDimLong
        procedure, private :: getTwoDimDbl
        procedure, private :: getChar
        procedure, private :: getCCharArray
        procedure, private :: getLogical
        procedure, private :: getCLogical
        procedure, private :: getPyPtr
!        procedure, private :: getCPtr
        procedure, private :: getCFuncPtr
        ! setters
        procedure, private :: setOneDimDbl
        procedure, private :: setTwoDimDbl
        procedure, private :: setOneDimInt
        procedure, private :: setTwoDimInt
        procedure, private :: setOneDimLong
        procedure, private :: setTwoDimLong
        procedure, private :: setCCharArray
        procedure, private :: setScalar
        ! pointers
!        procedure, public  :: ptr
        ! private tools
        procedure, private :: returnScalar
        procedure, private :: returnPyPtr
        procedure, private :: returnCFuncPtr
        procedure, private :: returnOneDimChar
        procedure, private :: returnOneDimInt
        procedure, private :: returnTwoDimInt
        procedure, private :: returnOneDimDbl
        procedure, private :: returnTwoDimDbl
        procedure, private :: returnSize
        ! enquiries
        procedure, public  :: keys
        procedure, public  :: enquireKey
        procedure, public  :: enquireShape
    endtype dictType

    integer    , parameter :: debug = 0
    type(c_ptr), parameter :: dummyPtr = c_null_ptr

    ! YL 20/09/2020: place the array buffers at the module level to deallocate later
!    integer(kind=8), pointer :: onedimint(:)

    contains

    function ptr2dict(metaPtr) result(dict)

        implicit none

        type(PyType)  , target , intent(in) :: metaPtr
        type(dictType)                      :: dict

        type(PyType)  , pointer             :: PyPtr

        ! ifort: must cast, otherwise error #6691: A pointer dummy argument may only be argument associated with a pointer.
        PyPtr => metaPtr

        call dict%init(PyPtr)

    endfunction ptr2dict

! INITIALISER

    subroutine private_initialise(metaObj, PyPtr, keepRef)

        class(dictType)            , intent(out)           :: metaObj
        type(PyType)      , pointer, intent(in)            :: PyPtr
        logical                    , intent(in) , optional :: keepRef

        type(CStructType) , pointer                        :: cdata(:)

        integer                                            :: i, j, ncols, sizem, sizen
        logical                                            :: keepReference

        character(len=8)  , parameter :: nonetype = "NoneType"
        type(PyType)      , pointer   :: pyptrbuff => null()
        integer(c_long)   , pointer   :: cintbuff  => null()
        type(c_funptr)    , pointer   :: cfuncbuff => null()
        integer(c_long)   , pointer   :: intarraybuff(:,:) => null(), onedimintbuff(:) => null(), twodimintbuff(:,:) => null()
        logical(c_bool)   , pointer   :: bbuff     => null()
        real(c_double)    , pointer   :: cdblbuff  => null()
        real(c_double)    , pointer   :: dblarraybuff(:,:) => null() , onedimdblbuff(:) => null() , twodimdblbuff(:,:) => null()
        character(len=LENSTR)         :: namebuff, typebuff, dtypebuff
        character(len=8)  , pointer   :: chararraybuff(:,:) => null()
        character(len=8)  , pointer   :: onedimcharbuff(:) => null(), twodimcharbuff(:,:) => null()
        ! should NOT have deferred length!
        character(len=255), pointer   :: cbuff => null()
        integer(c_long)   , pointer   :: debug_ptr

        if(.not.present(keepRef)) then
            keepReference = .true.
        endif

        ! map: cdata => PyPtr%cdata
        call c_f_pointer(c_loc(PyPtr%cdata), cdata, [PyPtr%nattrs])

        ! loop over components of Python object and set values to dictionary
        do i = 1, int(PyPtr%nattrs)

            ! YL 09/10/2018: as per gfortran 8, components %type, %name, or %dtype cannot be of length > 1
            ! (Error: Component ‘dtype’ of BIND(C) type at (1) must have length one)
            ! see: https://gcc.gnu.org/bugzilla/show_bug.cgi?id=84885
            ! so let's use array of characters
            do j = 1, LENSTR
                typebuff(j:j)  = cdata(i)%type(j)
                namebuff(j:j)  = cdata(i)%name(j)
                dtypebuff(j:j) = cdata(i)%dtype(j)
            enddo

            selectcase(trim(typebuff))

                ! YL 05/07/2023: previously "dict" type was not properly handled
                case('NoneType', 'dict')
                    ! YL 19/01/2021: assign to meet two cases
                    ! - meta%get('entry', pyptr) ... associated(ptr).eq..false. when a Python None is assigned
                    ! - meta%get('entry', intVar|realVar) doesn't crash when a Python None is assigned
                    call metaobj%assign(trim(namebuff), nonetype)
!                    call metaobj%assign(trim(namebuff), dummyPtr)

                case('function')
                    call c_f_pointer(cdata(i)%attr, cfuncbuff)
                    call metaobj%assign(trim(namebuff), cfuncbuff)

                case('object')
                    call c_f_pointer(cdata(i)%attr, pyptrbuff)
                    call metaObj%assign(trim(namebuff), pyptrbuff)

                case('int')
                    call c_f_pointer(cdata(i)%attr, cintbuff)
                    call metaObj%assign(trim(namebuff), cintbuff)

                case('float')
                    call c_f_pointer(cdata(i)%attr, cdblbuff)
                    call metaObj%assign(trim(namebuff), cdblbuff)

                case('bool')
                    call c_f_pointer(cdata(i)%attr, bbuff)
                    call metaObj%assign(trim(namebuff), bbuff)

                case('str')
                    call c_f_pointer(cdata(i)%attr, cbuff)
                    call metaObj%assign(trim(namebuff), cbuff)

                case('list')

                    ! ncols: number of array's columns (NB: ONLY _master!)
                    ! sizem: size m of the (/m, n/) array
                    ! sizen: size n of the (/m, n/) array
                    ncols = int(PyPtr%width)
                    sizem = int(cdata(i)%sizem)
                    if(cdata(i)%size.gt.0) then
                        sizen = int(cdata(i)%size/cdata(i)%sizem)
                    elseif(cdata(i)%size.eq.0) then
                        sizen = 0
                    endif

                    selectcase(trim(dtypebuff))

                        case('bytes64')

                            ! array is part of the _master array
                            if(cdata(i)%isfield) then

                                if(ncols.gt.0) then
                                    call c_f_pointer(cdata(i)%attr, chararraybuff, (/ncols, sizem/))
                                else
                                    call c_f_pointer(cdata(i)%attr, chararraybuff, (/sizen, sizem/))
                                endif
            
                                if(sizen.eq.1) then
                                    onedimcharbuff => chararraybuff(1,1:sizem)
                                    call metaObj%assign(trim(namebuff), onedimcharbuff, keepReference)
                                elseif(sizen.gt.1) then
                                    print *, ">>> DL_PY2F ERROR: 2-D char array not yet supported..."
    !                                twodimcharbuff => chararraybuff(1:sizen,:)
    !                                call metaObj%assign(trim(namebuff), twodimcharbuff, keepReference)
                                endif

                            ! array is not part of the _master array
                            else

                                ! receive the array using a (1, sizem*sizen) array
                                call c_f_pointer(cdata(i)%attr, chararraybuff, (/1, sizem*sizen/))

                                if(sizen.eq.1) then

                                    onedimcharbuff => chararraybuff(1,:)
                                    call metaObj%assign(trim(namebuff), onedimcharbuff, keepReference)

                                elseif(sizen.gt.1) then

                                    ! cast to a 2D array
                                    call c_f_pointer(c_loc(chararraybuff), twodimcharbuff, [sizen,sizem])
                                    print *, ">>> DL_PY2F ERROR: 2-D char array not yet supported..."
                                    !call metaObj%assign(trim(namebuff), twodimcharbuff, keepReference)

                                endif

                            endif
                                

                        case('float64')

                            ! array is part of the _master array
                            if(cdata(i)%isfield) then

                                if(ncols.gt.0) then
                                    call c_f_pointer(cdata(i)%attr, dblarraybuff, (/ncols, sizem/))
                                else
                                    call c_f_pointer(cdata(i)%attr, dblarraybuff, (/sizen, sizem/))
                                endif
            
                                if(sizen.eq.1) then
                                    onedimdblbuff => dblarraybuff(1,1:sizem)
                                    call metaObj%assign(trim(namebuff), onedimdblbuff, keepReference)
                                elseif(sizen.gt.1) then
                                    twodimdblbuff => dblarraybuff(1:sizen,:)
                                    call metaObj%assign(trim(namebuff), twodimdblbuff, keepReference)
                                endif

                            ! array is not part of the _master array
                            else

                                ! receive the array using a (1, sizem*sizen) array
                                call c_f_pointer(cdata(i)%attr, dblarraybuff, (/1, sizem*sizen/))

                                if(sizen.eq.1) then

                                    onedimdblbuff => dblarraybuff(1,:)
                                    call metaObj%assign(trim(namebuff), onedimdblbuff, keepReference)

                                elseif(sizen.gt.1) then

                                    ! cast to a 2D array
                                    call c_f_pointer(c_loc(dblarraybuff), twodimdblbuff, [sizen,sizem])
                                    call metaObj%assign(trim(namebuff), twodimdblbuff, keepReference)

                                endif

                            endif

                        case('int64')

                            ! array is part of the _master array
                            if(cdata(i)%isfield) then

                                if(ncols.gt.0) then
                                    call c_f_pointer(cdata(i)%attr, intarraybuff, (/ncols, sizem/))
                                else
                                    call c_f_pointer(cdata(i)%attr, intarraybuff, (/sizen, sizem/))
                                endif
            
                                if(sizen.eq.1) then
                                    onedimintbuff => intarraybuff(1,1:sizem)
                                    call metaObj%assign(trim(namebuff), onedimintbuff, keepReference)
                                elseif(sizen.gt.1) then
                                    twodimintbuff => intarraybuff(1:sizen,:)
                                    call metaObj%assign(trim(namebuff), twodimintbuff, keepReference)
                                endif

                            ! array is not part of the _master array
                            else

                                ! receive the array using a (1, sizem*sizen) array
                                call c_f_pointer(cdata(i)%attr, intarraybuff, (/1, sizem*sizen/))

                                if(sizen.eq.1) then

                                    onedimintbuff => intarraybuff(1,:)
                                    call metaObj%assign(trim(namebuff), onedimintbuff, keepReference)

                                elseif(sizen.gt.1) then

                                    ! cast to a 2D array
                                    call c_f_pointer(c_loc(intarraybuff), twodimintbuff, [sizen,sizem])
                                    call metaObj%assign(trim(namebuff), twodimintbuff, keepReference)

                                endif

                            endif

                        case default

                    endselect
                    ! YL 16/12/2023: support for structured array and record array (TODO: the latter not yet tested)
                    if(dtypebuff(1:4)=='void'.or.dtypebuff(1:6)=='record') then
                        ! array is part of the _master array
                        if(cdata(i)%isfield) then
                            if(ncols.gt.0) then
                                call c_f_pointer(cdata(i)%attr, dblarraybuff, (/ncols, sizem/))
                            else
                                call c_f_pointer(cdata(i)%attr, dblarraybuff, (/sizen, sizem/))
                            endif
                            if(sizen.eq.1) then
                                onedimdblbuff => dblarraybuff(1,1:sizem)
                                call metaObj%assign(trim(namebuff), onedimdblbuff, keepReference)
                            elseif(sizen.gt.1) then
                                twodimdblbuff => dblarraybuff(1:sizen,:)
                                call metaObj%assign(trim(namebuff), twodimdblbuff, keepReference)
                            endif
                        ! array is not part of the _master array
                        else
                            ! receive the array using a (1, sizem*sizen) array
                            call c_f_pointer(cdata(i)%attr, dblarraybuff, (/1, sizem*sizen/))
                            if(sizen.eq.1) then
                                onedimdblbuff => dblarraybuff(1,:)
                                call metaObj%assign(trim(namebuff), onedimdblbuff, keepReference)
                            elseif(sizen.gt.1) then
                                ! cast to a 2D array
                                call c_f_pointer(c_loc(dblarraybuff), twodimdblbuff, [sizen,sizem])
                                call metaObj%assign(trim(namebuff), twodimdblbuff, keepReference)
                            endif
                        endif
                    endif

                case default
                    ! YL 15/08/2021: PyPtr%debug is type(c_ptr), see above
                    call c_f_pointer(PyPtr%debug, debug_ptr)
                    if(debug_ptr.gt.2) then
                        write(*, '(/1X,A,1X,3A,1X,A/)') ">>> DL_PY2F WARNING: type",        &
                                                        '"', trim(typebuff), '"',           &
                                                        "could not be assigned for entity", &
                                                        '"', trim(namebuff), '"'
                    endif

            endselect

        enddo

! YL 19/01/2021: deallocate() segfaults
!        if(associated(pyptrbuff)     ) deallocate(pyptrbuff)
!        if(associated(cintbuff)      ) deallocate(cintbuff)
!        if(associated(cfuncbuff)     ) deallocate(cfuncbuff)
!        if(associated(intarraybuff)  ) deallocate(intarraybuff)
!        if(associated(onedimintbuff) ) deallocate(onedimintbuff)
!        if(associated(twodimintbuff) ) deallocate(twodimintbuff)
!        if(associated(bbuff)         ) deallocate(bbuff)
!        if(associated(cdblbuff)      ) deallocate(cdblbuff)
!        if(associated(dblarraybuff)  ) deallocate(dblarraybuff)
!        if(associated(onedimdblbuff) ) deallocate(onedimdblbuff)
!        if(associated(twodimdblbuff) ) deallocate(twodimdblbuff)
!        if(associated(chararraybuff) ) deallocate(chararraybuff)
!        if(associated(onedimcharbuff)) deallocate(onedimcharbuff)
!        if(associated(twodimcharbuff)) deallocate(twodimcharbuff)
!        if(associated(cbuff)         ) deallocate(cbuff)

    endsubroutine private_initialise
    recursive subroutine private_finalise(metaObj)

        class(dictType), intent(inout) :: metaObj

        ! recurse until we reach the end of the linked table
        if(associated(metaObj%key).and.associated(metaObj%next)) then

            call private_finalise(metaObj%next)

            deallocate(metaObj%next)

!            if(debug.gt.4) then
!                write(*,'(//A,1X,A)', advance="no"), ' >>> DL_PY2F: deallocating for entry', '"'//metaObj%key//'"... '
!            endif
            if(associated(metaObj%key)) then
!                if(debug.gt.4) write(*, "(1x,A)", advance="no") " key"
                deallocate(metaObj%key)
            endif
            if(associated(metaObj%scalar)) then
                selecttype(tmp=>metaObj%scalar)
                    class default
!                        if(debug.gt.4) write(*, "(1x,A)", advance="no") " scalar"
                        metaObj%scalar => null()
                endselect
            endif
            ! YL 19/01/2021: the following memory space is allocated by Python,
            !                so that can only be nullified
            if(associated(metaObj%array)) then
!                if(debug.gt.4) write(*, "(1x,A)", advance="no") " array"
                metaObj%array => null()
            endif
            if(associated(metaObj%PyPtr)) then
!                if(debug.gt.4) write(*, "(1x,A)", advance="no") " PyPtr"
                metaObj%PyPtr => null()
            endif
            if(associated(metaObj%onedimchar)) then
!                if(debug.gt.4) write(*, "(1x,A)", advance="no") " onedimchar"
                metaObj%onedimchar => null()
            endif
            if(associated(metaObj%onedimint)) then
!                if(debug.gt.4) write(*, "(1x,A)", advance="no") " onedimint"
                metaObj%onedimint  => null()
            endif
            if(associated(metaObj%twodimint)) then
!                if(debug.gt.4) write(*, "(1x,A)", advance="no") " twodimint"
                metaObj%twodimint  => null()
            endif
            if(associated(metaObj%onedimdbl)) then
!                if(debug.gt.4) write(*, "(1x,A)", advance="no") " onedimdbl"
                metaObj%onedimdbl  => null()
            endif
            if(associated(metaObj%twodimdbl)) then
!                if(debug.gt.4) write(*, "(1x,A)", advance="no") " twodimdbl"
                metaObj%twodimdbl  => null()
            endif
            if(associated(metaObj%onedimcdbl)) then
!                if(debug.gt.4) write(*, "(1x,A)", advance="no") " onedimcdbl"
                metaObj%onedimcdbl => null()
            endif
            if(associated(metaObj%twodimcdbl)) then
!                if(debug.gt.4) write(*, "(1x,A)", advance="no") " twodimcdbl"
                metaObj%twodimcdbl => null()
            endif

        ! end of linked table
        elseif(associated(metaObj%key).and..not.associated(metaObj%next)) then

!            if(debug.gt.4) then
!                write(*,'(//A,1X,A)', advance="no"), ' >>> DL_PY2F: deallocating for entry', '"'//metaObj%key//'"... '
!            endif
            if(associated(metaObj%key)) then
!                if(debug.gt.4) write(*, "(1x,A)", advance="no") " key"
                deallocate(metaObj%key)
            endif
            if(associated(metaObj%scalar)) then
                selecttype(tmp=>metaObj%scalar)
                    class default
!                        if(debug.gt.4) write(*, "(1x,A)", advance="no") " scalar"
                        metaObj%scalar => null()
                endselect
            endif
            ! YL 19/01/2021: the following memory space is allocated by Python,
            !                so that can only be nullified
            if(associated(metaObj%array)) then
!                if(debug.gt.4) write(*, "(1x,A)", advance="no") " array"
                metaObj%array => null()
            endif
            if(associated(metaObj%PyPtr)) then
!                if(debug.gt.4) write(*, "(1x,A)", advance="no") " PyPtr"
                metaObj%PyPtr => null()
            endif
            if(associated(metaObj%onedimchar)) then
!                if(debug.gt.4) write(*, "(1x,A)", advance="no") " onedimchar"
                metaObj%onedimchar => null()
            endif
            if(associated(metaObj%onedimint)) then
!                if(debug.gt.4) write(*, "(1x,A)", advance="no") " onedimint"
                metaObj%onedimint  => null()
            endif
            if(associated(metaObj%twodimint)) then
!                if(debug.gt.4) write(*, "(1x,A)", advance="no") " twodimint"
                metaObj%twodimint  => null()
            endif
            if(associated(metaObj%onedimdbl)) then
!                if(debug.gt.4) write(*, "(1x,A)", advance="no") " onedimdbl"
                metaObj%onedimdbl  => null()
            endif
            if(associated(metaObj%twodimdbl)) then
!                if(debug.gt.4) write(*, "(1x,A)", advance="no") " twodimdbl"
                metaObj%twodimdbl  => null()
            endif
            if(associated(metaObj%onedimcdbl)) then
!                if(debug.gt.4) write(*, "(1x,A)", advance="no") " onedimcdbl"
                metaObj%onedimcdbl => null()
            endif
            if(associated(metaObj%twodimcdbl)) then
!                if(debug.gt.4) write(*, "(1x,A)", advance="no") " twodimcdbl"
                metaObj%twodimcdbl => null()
            endif

        endif

        call flush(6)

    endsubroutine private_finalise

! END OF INITIALISER
! ASSIGNERS

    recursive subroutine assignScalar(metaObj, key, source)

        class(dictType) ,         intent(inout) :: metaObj
        character(len=*),         intent(in)    :: key
        class(*)        , target, intent(in)    :: source

        if(associated(metaObj%key)) then
            if(metaObj%key.eq.key) then
                deallocate(metaObj%scalar)
                metaObj%scalar => source
            else
                if(.not.associated(metaObj%next)) then
                    allocate(metaObj%next)
                endif
                call assignScalar(metaObj%next, key, source)
            endif
        else
            allocate(metaObj%key, source=key)
            metaObj%scalar => source
            if(debug.gt.5) then
                write(*,*) " DL_PY2F DEBUG: assignScalar"
                selecttype(tmp=>metaObj%scalar)
                    type is(character(kind=c_char, len=*))
                        write(*,*) " key = ", key, ", loc(metaObj%scalar) =", loc(tmp)
                    class default
                        write(*,*) ">>> DL_PY2F assignScalar: assigning character(kind=c_char, len=*)..."
                        write(*,*) "                          key = ", key
                        write(*,*) "                          loc(metaObj%scalar) =", loc(tmp)
                endselect
                write(*,*) ""
            endif
        endif

    endsubroutine assignScalar
! YL 19/01/2021: this is not distinguishable from assignScalar
!    recursive subroutine assignNull(metaObj, key, source)
!
!        class(dictType) ,          intent(inout) :: metaObj
!        character(len=*),          intent(in)    :: key
!        integer         , pointer, intent(in)    :: source
!
!        if(associated(metaObj%key)) then
!            if(metaObj%key.eq.key) then
!                deallocate(metaObj%scalar)
!                metaObj%scalar => source
!            else
!                if(.not.associated(metaObj%next)) then
!                    allocate(metaObj%next)
!                endif
!                call assignNull(metaObj%next, key, source)
!            endif
!        else
!            allocate(metaObj%key, source=key)
!            metaObj%scalar => source
!        endif
!
!    endsubroutine assignNull
! not in use
    recursive subroutine assignPyPtr(metaObj, key, source)

        class(dictType)         , intent(inout) :: metaObj
        character(len=*)        , intent(in)    :: key
        type(PyType)    , target, intent(in)    :: source

        if(associated(metaObj%key)) then
            if(metaObj%key.eq.key) then
                deallocate(metaObj%PyPtr)
                metaObj%PyPtr => source
            else
                if(.not.associated(metaObj%next)) then
                    allocate(metaObj%next)
                endif
                call assignPyPtr(metaObj%next, key, source)
            endif
        else
            allocate(metaObj%key, source=key)
            metaObj%PyPtr => source
        endif

    endsubroutine assignPyPtr
    recursive subroutine assignOneDimChar(metaObj, key, source, keepRef)

        class(dictType)          , intent(inout)           :: metaObj
        character(len=*)         , intent(in)              :: key
        character(len=8), pointer, intent(in)              :: source(:)
        logical                  , intent(in)   , optional :: keepRef

        logical                                            :: keepReference = .true.

        if(present(keepRef)) then
            keepReference = keepRef
        endif

        ! if the current obj already associated
        if(associated(metaObj%key)) then
            ! rewrite the current obj if key exists here
            if(metaObj%key.eq.key) then
                metaObj%sizem = size(source)
                deallocate(metaObj%onedimchar)
                ! will keep the reference pointing to the original Python object
                if(keepReference) then
                    metaObj%onedimchar => source
                ! will copy data and lose the reference to Python object
                else
                    allocate(metaObj%onedimchar(metaObj%sizem), source=source)
                endif
            ! move to next if this is not the key
            else
                if(.not.associated(metaObj%next)) then
                    allocate(metaObj%next)
                endif
                call assignOneDimChar(metaObj%next, key, source)
            endif
        ! create new if not associated
        else
            allocate(metaObj%key, source=key)
            metaObj%sizem = size(source)
            if(keepReference) then
                metaObj%onedimchar => source
            else
                allocate(metaObj%onedimchar(metaObj%sizem), source=source)
            endif
        endif

    endsubroutine assignOneDimChar
    recursive subroutine assignOneDimInt(metaObj, key, source, keepRef)

        class(dictType)          , intent(inout)           :: metaObj
        character(len=*)         , intent(in)              :: key
        integer(kind=8) , pointer, intent(in)              :: source(:)
        logical                  , intent(in)   , optional :: keepRef

        logical                                            :: keepReference = .true.

        if(present(keepRef)) then
            keepReference = keepRef
        endif

        ! if the current obj already associated
        if(associated(metaObj%key)) then
            ! rewrite the current obj if key exists here
            if(metaObj%key.eq.key) then
                metaObj%sizem = size(source)
                deallocate(metaObj%onedimint)
                ! will keep the reference pointing to the original Python object
                if(keepReference) then
                    metaObj%onedimint => source
                ! will copy data and lose the reference to Python object
                else
                    allocate(metaObj%onedimint(metaObj%sizem), source=source)
                endif
            ! move to next if this is not the key
            else
                if(.not.associated(metaObj%next)) then
                    allocate(metaObj%next)
                endif
                call assignOneDimInt(metaObj%next, key, source)
            endif
        ! create new if not associated
        else
            allocate(metaObj%key, source=key)
            metaObj%sizem = size(source)
            if(keepReference) then
                metaObj%onedimint => source
            else
                allocate(metaObj%onedimint(metaObj%sizem), source=source)
            endif
        endif

    endsubroutine assignOneDimInt
    recursive subroutine assignTwoDimInt(metaObj, key, source, keepRef)

        class(dictType)          , intent(inout)           :: metaObj
        character(len=*)         , intent(in)              :: key
        integer(kind=8) , pointer, intent(in)              :: source(:,:)
        logical                  , intent(in)   , optional :: keepRef

        integer                                            :: shp(2)
        logical                                            :: keepReference = .true.

        if(present(keepRef)) then
            keepReference = keepRef
        endif

        shp = (/shape(source)/)

        ! if the current obj already associated
        if(associated(metaObj%key)) then
            ! rewrite the current obj if key exists here
            if(metaObj%key.eq.key) then
                metaObj%sizem = shp(1)
                metaObj%sizen = shp(2)
                deallocate(metaObj%twodimint)
                if(keepReference) then
                    metaObj%twodimint => source
                else
                    allocate(metaObj%twodimint(metaObj%sizem,metaObj%sizen), source=source)
                endif
            ! move to next if this is not the key
            else
                if(.not.associated(metaObj%next)) then
                    allocate(metaObj%next)
                endif
                call assignTwoDimInt(metaObj%next, key, source)
            endif
        ! create new if not associated
        else
            allocate(metaObj%key, source=key)
            metaObj%sizem = shp(1)
            metaObj%sizen = shp(2)
            if(keepReference) then
                metaObj%twodimint => source
            else
                allocate(metaObj%twodimint(metaObj%sizem,metaObj%sizen), source=source)
            endif
        endif

    endsubroutine assignTwoDimInt
    recursive subroutine assignOneDimDbl(metaObj, key, source, keepRef)

        class(dictType)          , intent(inout)           :: metaObj
        character(len=*)         , intent(in)              :: key
        real(kind=8)    , pointer, intent(in)              :: source(:)
        logical                  , intent(in)   , optional :: keepRef

        logical                                            :: keepReference = .true.

        if(present(keepRef)) then
            keepReference = keepRef
        endif

        ! if the current obj already associated
        if(associated(metaObj%key)) then
            ! rewrite the current obj if key exists here
            if(metaObj%key.eq.key) then
                metaObj%sizem = size(source)
                deallocate(metaObj%onedimdbl)
                ! will keep the reference pointing to the original Python object
                if(keepReference) then
                    metaObj%onedimdbl => source
                ! will copy data and lose the reference to Python object
                ! not in use now but maybe useful in the future if we want local temporary copies
                else
                    allocate(metaObj%onedimdbl(metaObj%sizem), source=source)
                endif
            ! move to next if this is not the key
            else
                if(.not.associated(metaObj%next)) then
                    allocate(metaObj%next)
                endif
                call assignOneDimDbl(metaObj%next, key, source)
            endif
        ! create new if not associated
        else
            allocate(metaObj%key, source=key)
            metaObj%sizem = size(source)
            if(keepReference) then
                metaObj%onedimdbl => source
            else
                allocate(metaObj%onedimdbl(metaObj%sizem), source=source)
            endif
        endif

    endsubroutine assignOneDimDbl
    recursive subroutine assignTwoDimDbl(metaObj, key, source, keepRef)

        class(dictType)          , intent(inout)           :: metaObj
        character(len=*)         , intent(in)              :: key
        real(kind=8)    , pointer, intent(in)              :: source(:,:)
        logical                  , intent(in)   , optional :: keepRef

        integer                                            :: shp(2)
        logical                                            :: keepReference = .true.

        if(present(keepRef)) then
            keepReference = keepRef
        endif

        shp = (/shape(source)/)

        ! if the current obj already associated
        if(associated(metaObj%key)) then
            ! rewrite the current obj if key exists here
            if(metaObj%key.eq.key) then
                metaObj%sizem = shp(1)
                metaObj%sizen = shp(2)
                deallocate(metaObj%twodimdbl)
                if(keepReference) then
                    metaObj%twodimdbl => source
                else
                    allocate(metaObj%twodimdbl(metaObj%sizem,metaObj%sizen), source=source)
                endif
            ! move to next if this is not the key
            else
                if(.not.associated(metaObj%next)) then
                    allocate(metaObj%next)
                endif
                call assignTwoDimDbl(metaObj%next, key, source)
            endif
        ! create new if not associated
        else
            metaObj%sizem = shp(1)
            metaObj%sizen = shp(2)
            allocate(metaObj%key, source=key)
            if(keepReference) then
                metaObj%twodimdbl => source
            else
                allocate(metaObj%twodimdbl(metaObj%sizem,metaObj%sizen), source=source)
            endif
        endif

    endsubroutine assignTwoDimDbl

! END OF SETTERS
! ENQUIRIES

    recursive subroutine keys(metaObj, initialised)

        class(dictType), intent(in)           :: metaObj
        logical        , intent(in), optional :: initialised

        if(.not.present(initialised)) then
            write(*, "(/A)") " >>> DL_PY2F: The current dictionary object contains entries:"
            write(*, "(3X)", advance="no")
        endif

        if(associated(metaObj%key).and.associated(metaObj%next)) then
            write(*, "(2X,A)", advance="no") metaObj%key
            call keys(metaObj%next, .true.)
        ! end of linked table
        elseif(associated(metaObj%key).and..not.associated(metaObj%next)) then
            write(*, "(2X,A/)", advance="yes") metaObj%key
        endif

    endsubroutine keys
    ! YL 06/07/2023: we need such a function that returns .false. but doesn't throw out an error or stop the program
    recursive function enquireKey(metaObj, key) result(val)

        class(dictType) , intent(in) :: metaObj
        character(len=*), intent(in) :: key
        logical                      :: val

        if(associated(metaObj%key)) then
            if(metaObj%key.eq.trim(key)) then
                val = .true.
                return
            else
                ! end of search
                if(.not.associated(metaObj%next)) then
                    val = .false.
                    return
                else
                    ! go on trying
                    val = enquireKey(metaObj%next, key)
                endif
            endif
        ! end of search
        else
            val = .false.
            return
        endif

    endfunction enquireKey

! END OF ENQUIRIES
! TOOLS

    ! gfortran forces to declare result variable
    recursive function returnScalar(metaObj, key) result(val)

        class(dictType) , intent(in) :: metaObj
        character(len=*), intent(in) :: key
        class(*)        , pointer    :: val

        if(associated(metaObj%key)) then
            if(metaObj%key.eq.key) then
                ! YL: since gfortran/gcc 7 `val => metaObj%scalar` does not work!
!                val => metaObj%scalar
                allocate(val, source=metaObj%scalar)
                if(debug.gt.5) then
                    write(*,*) " DL_PY2F DEBUG: returnScalar"
                    selecttype(tmp=>metaObj%scalar)
                        class default
                            write(*,*) " key = ", key, ", loc(metaObj%scalar) =", loc(tmp)
                    endselect
                    write(*,*) ""
                endif
            else
                ! YL: since gfortran/gcc 7 `val => returnScalar(metaObj%next, key)` does not work!
!                val => returnScalar(metaObj%next, key)
                ! YL 06/02/2020: added printing of specific information
                if(.not.associated(metaObj%next)) then
                    print *, '>>> DL_PY2F ERROR: keyword "', key, '" not found in dictionary.'
                    print *
                    call exit(999)
                else
                    allocate(val, source=returnScalar(metaObj%next, key))
                endif
!                selecttype(tmp=>val)
!                    type is(character(*))
!                        if(trim(key)=='crystal_type') then
!                            print *, "### returnScalar: tmp =", tmp
!                        endif
!                endselect
            endif
        else
            print *, '>>> DL_PY2F ERROR: keyword \"', key, '\"not found in dictionary.'
        endif

    endfunction returnScalar
    recursive function returnCFuncPtr(metaObj, key) result(val)

        class(dictType)          , intent(in) :: metaObj
        character(len=*)         , intent(in) :: key
        type(c_funptr)  , pointer             :: val

        if(associated(metaObj%key)) then
            if(metaObj%key.eq.key) then
                call flush(6)
!                allocate(val, source=metaObj%scalar)
                val => metaObj%scalar
            else
                if(.not.associated(metaObj%next)) then
                    print *, '>>> DL_PY2F ERROR: keyword "', key, '" not found in dictionary.'
                    print *
                    call exit(999)
                else
                    val => returnCFuncPtr(metaObj%next, key)
                endif
!                val = c_loc(returnCFuncPtr(metaObj%next, key))
            endif
        else
            print *, '>>> DL_PY2F ERROR: keyword \"', key, '\"not found in dictionary.'
            call flush(6)
        endif

    endfunction returnCFuncPtr
    recursive function returnPyPtr(metaObj, key) result(val)

        class(dictType) , intent(in) :: metaObj
        character(len=*), intent(in) :: key
        type(PyType)    , pointer    :: val

        ! YL: it would be even safer if dict%type could be checked
        type(c_ptr)     , pointer    :: ptr

        if(associated(metaObj%key)) then
            if(metaObj%key.eq.key) then
                ptr => metaObj%scalar
                ! YL 18/09/18: the method of c_null_ptr does not work (randomly returning F or T when querying with c_associated) since some point (GNU 5 or 7 in Ubuntu 18?)
!                if(c_associated(ptr)) then
!                    val => metaObj%scalar
!                else
!                    val => null()
!                endif
                selecttype(tmp=>metaObj%scalar)
                    ! YL 20/01/2021: it's proven only this works well with Intel, GNU, and Cray after many attempts
                    type is(character(len=*))
                        if(tmp.eq."NoneType") then
                            val => null()
                        else
                            val => metaObj%scalar
                        endif
                    ! YL 20/01/2021: this works OK with GNU but not allowed by Intel
!                    type is(c_ptr)
!                        val => null()
                    ! YL 20/01/2021: obsolete
                    class default
                        ! Python reference
                        if(associated(metaObj%scalar)) then
                            val => metaObj%scalar
                        ! Python None
                        else
                            val => null()
                        endif
                endselect
            else
                val => returnPyPtr(metaObj%next, key)
            endif
        else
            print *, '\n>>> DL_PY2F ERROR: keyword \"', key, '\"not found in dictionary.\n'
            call flush(6)
        endif

    endfunction returnPyPtr
    recursive function returnSize(metaObj, key) result(size)

        class(dictType) , intent(in) :: metaObj
        character(len=*), intent(in) :: key
        integer                      :: size

        if(associated(metaObj%key)) then
            if(metaObj%key.eq.key) then
                size = metaObj%sizem
            else
                size = returnSize(metaObj%next, key)
            endif
        else
            print *, '>>> DL_PY2F ERROR: keyword \"', key, '\"not found in dictionary.'
        endif

    endfunction returnSize
    recursive function enquireShape(metaObj, key) result(shp)

        class(dictType) , intent(in) :: metaObj
        character(len=*), intent(in) :: key
        integer                      :: shp(2)

        if(associated(metaObj%key)) then
            call flush(6)
            if(metaObj%key.eq.trim(key)) then
                shp(1) = metaObj%sizem
                shp(2) = metaObj%sizen
            else
                shp = enquireShape(metaObj%next, key)
            endif
        else
            print *, '>>> DL_PY2F ERROR: keyword \"', key, '\"not found in dictionary.'
        endif

    endfunction enquireShape
    recursive function returnOneDimChar(metaObj, key) result(onedimchar)

        class(dictType) , intent(in) :: metaObj
        character(len=*), intent(in) :: key
        ! YL 20/09/2020: changed from pointer to allocatable so that the array gets automatically deallocated when going out of scope
        character(len=8), allocatable :: onedimchar(:)

        if(associated(metaObj%key)) then
            if(metaObj%key.eq.key) then
                allocate(onedimchar(metaObj%sizem), source=metaObj%onedimchar)
            else
                allocate(onedimchar(returnSize(metaObj%next, key)), source=returnOneDimChar(metaObj%next, key))
            endif
        else
            print *, '>>> DL_PY2F ERROR: keyword "', key, '" not found in dictionary.'
        endif

    endfunction returnOneDimChar
    recursive function returnOneDimInt(metaObj, key) result(onedimint)

        class(dictType) , intent(in)  :: metaObj
        character(len=*), intent(in)  :: key
        ! YL 20/09/2020: changed from pointer to allocatable so that the array gets automatically deallocated when going out of scope
        integer(kind=8) , allocatable :: onedimint(:)


        if(associated(metaObj%key)) then
            if(metaObj%key.eq.key) then
                allocate(onedimint(metaObj%sizem), source=metaObj%onedimint)
            else
                allocate(onedimint(returnSize(metaObj%next, key)), source=returnOneDimInt(metaObj%next, key))
            endif
        else
            print *, '>>> DL_PY2F ERROR: keyword "', key, '" not found in dictionary.'
        endif

    endfunction returnOneDimInt
    recursive function returnTwoDimInt(metaObj, key) result(twodimint)

        class(dictType) , intent(in)  :: metaObj
        character(len=*), intent(in)  :: key
        ! YL 20/09/2020: changed from pointer to allocatable so that the array gets automatically deallocated when going out of scope
        integer(kind=8) , allocatable :: twodimint(:,:)
        integer                       :: shp(2)

        if(associated(metaObj%key)) then
            if(metaObj%key.eq.key) then
                allocate(twodimint(metaObj%sizem, metaObj%sizen), source=metaObj%twodimint)
            else
                shp = enquireShape(metaObj%next, key)
                allocate(twodimint(shp(1), shp(2)), source=returnTwoDimInt(metaObj%next, key))
            endif
        else
            print *, '>>> DL_PY2F ERROR: keyword "', key, '" not found in dictionary.'
        endif

    endfunction returnTwoDimInt
    recursive function returnTwoDimDbl(metaObj, key) result(twodimdbl)

        class(dictType) , intent(in)  :: metaObj
        character(len=*), intent(in)  :: key
        ! YL 20/09/2020: changed from pointer to allocatable so that the array gets automatically deallocated when going out of scope
        real(kind=8)    , allocatable :: twodimdbl(:,:)
        integer                       :: shp(2)

        if(associated(metaObj%key)) then
            if(metaObj%key.eq.key) then
                allocate(twodimdbl(metaObj%sizem, metaObj%sizen), source=metaObj%twodimdbl)
            else
                shp = enquireShape(metaObj%next, key)
                allocate(twodimdbl(shp(1), shp(2)), source=returnTwoDimDbl(metaObj%next, key))
            endif
        else
            print *, '>>> DL_PY2F ERROR: keyword "', key, '" not found in dictionary.'
        endif

    endfunction returnTwoDimDbl
! for now impossible to implement unlimited polymorphic arrays (see below) 
    recursive function returnOneDimDbl(metaObj, key) result(onedimdbl)

        class(dictType) , intent(in)  :: metaObj
        character(len=*), intent(in)  :: key
        ! YL 20/09/2020: changed from pointer to allocatable so that the array gets automatically deallocated when going out of scope
        real(kind=8)    , allocatable :: onedimdbl(:)

        if(associated(metaObj%key)) then
            if(metaObj%key.eq.key) then
                allocate(onedimdbl(metaObj%sizem), source=metaObj%onedimdbl)
            else
                allocate(onedimdbl(returnSize(metaObj%next, key)), source=returnOneDimDbl(metaObj%next, key))
            endif
        else
            print *, '>>> DL_PY2F ERROR: keyword "', key, '" not found in dictionary.'
        endif

    endfunction returnOneDimDbl

! END OF TOOLS
! SETTERS

    ! YL 08/07/2019: in Python this can only change the value of the c_types-wrapped entity rather than the original attribute because only address of the former is passed in
    recursive subroutine setScalar(metaObj, key, val)

        class(dictType) , intent(inout) :: metaObj
        character(len=*), intent(in)    :: key
        class(*)        , intent(in)    :: val

        if(associated(metaObj%key)) then
            if(metaObj%key.eq.key) then
                selecttype(val)
                    type is(integer(kind=4))
                        selecttype(tmp=>metaObj%scalar)
                            type is(integer(kind=4))
                                tmp = int(val, kind=4)
                            type is(integer(kind=8))
                                tmp = int(val, kind=8)
                            class default
                                write(*,*) ">>> DL_PY2F ERROR: given value's type does not match the saved entry ", key
                        endselect
                    type is(integer(kind=8))
                        selecttype(tmp=>metaObj%scalar)
                            type is(integer(kind=4))
                                tmp = int(val, kind=4)
                            type is(integer(kind=8))
                                tmp = int(val, kind=8)
                            class default
                                write(*,*) ">>> DL_PY2F ERROR: given value's type does not match the saved entry ", key
                        endselect
                    type is(real(kind=8))
                        selecttype(tmp=>metaObj%scalar)
                            type is(real(kind=8))
                                tmp = int(val, kind=8)
                        endselect
                endselect
            else
                call setScalar(metaObj%next, key, val)
            endif
        else
            print *, '>>> DL_PY2F ERROR: keyword "', key, '" not found in dictionary.'
        endif

    endsubroutine setScalar
    recursive subroutine setCCharArray(metaObj, key, array)

        class(dictType)       , intent(inout) :: metaObj
        character(len=*)      , intent(in)    :: key
        character(kind=c_char), intent(in)    :: array(:)

        integer                               :: i

        if(associated(metaObj%key)) then
            if(metaObj%key.eq.key) then
                selecttype(tmp=>metaObj%scalar)
                    type is(character(kind=c_char, len=*))
                        do i = 1, size(array)
                            tmp(i:i) = array(i)
                        enddo
                endselect
            else
                call setCCharArray(metaObj%next, key, array)
            endif
        else
            print *, '>>> DL_PY2F ERROR: keyword "', key, '" not found in dictionary.'
        endif

    endsubroutine setCCharArray
    recursive subroutine setOneDimDbl(metaObj, key, array)

        class(dictType) , intent(inout) :: metaObj
        character(len=*), intent(in)    :: key
        real(kind=8)    , intent(in)    :: array(:)

        if(associated(metaObj%key)) then
            if(metaObj%key.eq.key) then
                metaObj%onedimdbl = array
            else
                call setOneDimDbl(metaObj%next, key, array)
            endif
        else
            print *, '>>> DL_PY2F ERROR: keyword "', key, '" not found in dictionary.'
        endif

    endsubroutine setOneDimDbl
    recursive subroutine setTwoDimDbl(metaObj, key, array)

        class(dictType) , intent(inout) :: metaObj
        character(len=*), intent(in)    :: key
        real(kind=8)    , intent(in)    :: array(:,:)

        if(associated(metaObj%key)) then
            if(metaObj%key.eq.key) then
                metaObj%twodimdbl = array
            else
                call setTwoDimDbl(metaObj%next, key, array)
            endif
        else
            print *, '>>> DL_PY2F ERROR: keyword "', key, '" not found in dictionary.'
        endif

    endsubroutine setTwoDimDbl
    recursive subroutine setOneDimInt(metaObj, key, array)

        class(dictType) , intent(inout) :: metaObj
        character(len=*), intent(in)    :: key
        integer(kind=4) , intent(in)    :: array(:)

        if(associated(metaObj%key)) then
            if(metaObj%key.eq.key) then
                metaObj%onedimint = array
            else
                call setOneDimInt(metaObj%next, key, array)
            endif
        else
            print *, '>>> DL_PY2F ERROR: keyword "', key, '" not found in dictionary.'
        endif

    endsubroutine setOneDimInt
    recursive subroutine setTwoDimInt(metaObj, key, array)

        class(dictType) , intent(inout) :: metaObj
        character(len=*), intent(in)    :: key
        integer(kind=4) , intent(in)    :: array(:,:)

        if(associated(metaObj%key)) then
            if(metaObj%key.eq.key) then
                metaObj%twodimint = array
            else
                call setTwoDimInt(metaObj%next, key, array)
            endif
        else
            print *, '>>> DL_PY2F ERROR: keyword "', key, '" not found in dictionary.'
        endif

    endsubroutine setTwoDimInt
    recursive subroutine setOneDimLong(metaObj, key, array)

        class(dictType) , intent(inout) :: metaObj
        character(len=*), intent(in)    :: key
        integer(kind=8) , intent(in)    :: array(:)

        if(associated(metaObj%key)) then
            if(metaObj%key.eq.key) then
                metaObj%onedimint = array
            else
                call setOneDimLong(metaObj%next, key, array)
            endif
        else
            print *, '>>> DL_PY2F ERROR: keyword "', key, '" not found in dictionary.'
        endif

    endsubroutine setOneDimLong
    recursive subroutine setTwoDimLong(metaObj, key, array)

        class(dictType) , intent(inout) :: metaObj
        character(len=*), intent(in)    :: key
        integer(kind=8) , intent(in)    :: array(:,:)

        if(associated(metaObj%key)) then
            if(metaObj%key.eq.key) then
                metaObj%twodimint = array
            else
                call setTwoDimLong(metaObj%next, key, array)
            endif
        else
            print *, '>>> DL_PY2F ERROR: keyword "', key, '" not found in dictionary.'
        endif

    endsubroutine setTwoDimLong

! END OF SETTERS
! GETTERS

    ! have to do interfaced overloading, because GNU compiler strictly requires actual argument to be polymorphic if we use class(*) as dummy argument (only intent=out)
    ! (!!!) Neither GNU nor Intel compilers distinguishes between "integer, pointer" and "integer" for overloading! But when actual argument is "integer", it cannot find the right interfaced subroutine with 'integer, pointer'!!!
    subroutine getInt(metaObj, key, val)

        class(dictType) , intent(in)  :: metaObj
        character(len=*), intent(in)  :: key
        integer(kind=4) , intent(out) :: val
  
        type(dictType)  , pointer     :: metaObjPtr

        ! Cray compiler thinks metaObj uninitialised and segfaults! so we have to allocate a temporary pointer
        allocate(metaObjPtr, source=metaObj)

        ! DANGEROUS! do NOT use local (temporary) pointer to pass value
        selecttype(tmp=>metaObjPtr%returnScalar(key))
            ! (integer and integer(c_int) are equivalent in 'selecttype')
            type is(integer(kind=4))
                ! for future development with pointers:
                !     Intel compiler requires tmp to possess target/pointer attribute,
                !     then we will have to declare tmp and cannot use "selecttype
                !     (tmp=>metaObj%returnScalar(key))" without decaration allocate(tmp, source=metaObj%returnScalar(key))
                !     so we may try val => metaObj%returnScalar(key) instead which should be fast enough
                val = tmp
            ! int type conversion (integer(kind=8) and integer(c_long) are equivalent in 'selecttype')
            type is(integer(kind=8))
                val = int(tmp)
            ! logical -> int conversion
            type is(logical)
                val = merge(1, 0, tmp)
            type is(logical(c_bool))
                val = merge(1, 0, tmp)
        endselect

        deallocate(metaObjPtr)

    endsubroutine getInt
    subroutine getIntCLong(metaObj, key, val)

        class(dictType) , intent(in)  :: metaObj
        character(len=*), intent(in)  :: key
        integer(kind=8) , intent(out) :: val
        type(dictType)  , pointer     :: metaObjPtr

        ! Cray compiler thinks metaObj uninitialised and segfaults! so we have to allocate a temporary pointer
        allocate(metaObjPtr, source=metaObj)
        
        selecttype(tmp=>metaObjPtr%returnScalar(key))
            type is(integer(kind=4))
                val = tmp
            type is(integer(kind=8))
                val = tmp
        endselect

        deallocate(metaObjPtr)

    endsubroutine getIntCLong
    subroutine getReal(metaObj, key, val)

        class(dictType) , intent(in)  :: metaObj
        character(len=*), intent(in)  :: key
        real(kind=4)    , intent(out) :: val
        type(dictType)  , pointer     :: metaObjPtr

        ! Cray compiler thinks metaObj uninitialised and segfaults! so we have to allocate a temporary pointer
        allocate(metaObjPtr, source=metaObj)

        selecttype(tmp=>metaObjPtr%returnScalar(key))
            type is(real(kind=4))
                val = tmp
            ! real type conversion (c_long and c_int are equivalent in 'selecttype')
            type is(real(kind=8))
                val = real(tmp, kind=4)
        endselect

        deallocate(metaObjPtr)

    endsubroutine getReal
    subroutine getDouble(metaObj, key, val)

        class(dictType) , intent(in)  :: metaObj
        character(len=*), intent(in)  :: key
        real(kind=8)    , intent(out) :: val

        type(dictType)  , pointer     :: metaObjPtr

        ! Cray compiler thinks metaObj uninitialised and segfaults! so we have to allocate a temporary pointer
        allocate(metaObjPtr, source=metaObj)

        selecttype(tmp=>metaObjPtr%returnScalar(key))
            type is(real(kind=4))
                val = real(tmp, kind=8)
            type is(real(kind=8))
                val = tmp
        endselect

        deallocate(metaObjPtr)

    endsubroutine getDouble
    subroutine getOneDimInt(metaObj, key, array)

        class(dictType) , intent(in)  :: metaObj
        character(len=*), intent(in)  :: key
        integer(kind=4) , intent(out) :: array(:)

        type(dictType)  , pointer     :: metaObjPtr

        ! Cray compiler thinks metaObj uninitialised and segfaults! so we have to allocate a temporary pointer
        allocate(metaObjPtr, source=metaObj)

        array = metaObjPtr%returnOneDimInt(key)

        deallocate(metaObjPtr)

    endsubroutine getOneDimInt
    subroutine getTwoDimInt(metaObj, key, array)

        class(dictType) , intent(in)  :: metaObj
        character(len=*), intent(in)  :: key
        integer(kind=4) , intent(out) :: array(:,:)

        type(dictType)  , pointer     :: metaObjPtr

        ! Cray compiler thinks metaObj uninitialised and segfaults! so we have to allocate a temporary pointer
        allocate(metaObjPtr, source=metaObj)

        array = metaObjPtr%returnTwoDimInt(key)

        deallocate(metaObjPtr)

    endsubroutine getTwoDimInt
    subroutine getOneDimLong(metaObj, key, array)

        class(dictType) , intent(in)  :: metaObj
        character(len=*), intent(in)  :: key
        integer(kind=8) , intent(out) :: array(:)

        type(dictType)  , pointer     :: metaObjPtr

        ! Cray compiler thinks metaObj uninitialised and segfaults! so we have to allocate a temporary pointer
        allocate(metaObjPtr, source=metaObj)

        array = metaObjPtr%returnOneDimInt(key)

        deallocate(metaObjPtr)

    endsubroutine getOneDimLong
    subroutine getTwoDimLong(metaObj, key, array)

        class(dictType) , intent(in)  :: metaObj
        character(len=*), intent(in)  :: key
        integer(kind=8) , intent(out) :: array(:,:)

        type(dictType)  , pointer     :: metaObjPtr

        ! Cray compiler thinks metaObj uninitialised and segfaults! so we have to allocate a temporary pointer
        allocate(metaObjPtr, source=metaObj)

        array = metaObjPtr%returnTwoDimInt(key)

        deallocate(metaObjPtr)

    endsubroutine getTwoDimLong
! doens't work for ifort, either
!    function getElement(array) result(element)
!        class(*)        , intent(in) :: array(:)
!        class(*)        , pointer    :: element
!        allocate(element, source=array(1))
!    endfunction getElement
    subroutine getOneDimDbl(metaObj, key, array)

        class(dictType) , intent(in)  :: metaObj
        character(len=*), intent(in)  :: key
        real(kind=8)    , intent(out) :: array(:)

        type(dictType)  , pointer     :: metaObjPtr

        ! Cray compiler thinks metaObj uninitialised and segfaults! so we have to allocate a temporary pointer
        allocate(metaObjPtr, source=metaObj)

        array = metaObjPtr%returnOneDimDbl(key)

        deallocate(metaObjPtr)

    endsubroutine getOneDimDbl
    subroutine getTwoDimDbl(metaObj, key, array)

        class(dictType) , intent(in)  :: metaObj
        character(len=*), intent(in)  :: key
        real(kind=8)    , intent(out) :: array(:,:)

        type(dictType)  , pointer     :: metaObjPtr

        ! Cray compiler thinks metaObj uninitialised and segfaults! so we have to allocate a temporary pointer
        allocate(metaObjPtr, source=metaObj)

        array = metaObjPtr%returnTwoDimDbl(key)

        deallocate(metaObjPtr)

    endsubroutine getTwoDimDbl
    subroutine getCCharArray(metaObj, key, array)

        class(dictType)                , intent(in)  :: metaObj
        character(len=*)               , intent(in)  :: key
        character(kind=c_char)         , intent(out) :: array(:)

        ! YL 14/08/2019: strange gfortran bug that it doesn't compile if cbuff is initialised as cbuff => null()
        character(len=:)      , pointer              :: cbuff
        integer                                      :: i
        type(dictType)  , pointer     :: metaObjPtr

        ! Cray compiler thinks metaObj uninitialised and segfaults! so we have to allocate a temporary pointer
        allocate(metaObjPtr, source=metaObj)

        call metaObjPtr%getChar(key, cbuff)

        do i = 1, len(trim(cbuff))
            array(i) = cbuff(i:i)
        enddo
        
        deallocate(metaObjPtr)

    endsubroutine getCCharArray
    subroutine getChar(metaObj, key, val)

        class(dictType)          , intent(in)  :: metaObj
        character(len=*)         , intent(in)  :: key
        character(len=:), pointer, intent(out) :: val

!        class(*)        , pointer              :: gnu, intel
        character       , target               :: blanc = ""

!        character(len=*), pointer, bind(c)              :: tmp

        ! this is a workaround before gfortran 9 is widedly used (see below)
        ! must be sequence to point to unlimited polymorphic returned by metaObj%returnScalar()
        type charType
            sequence
            ! hopefully 255 is long enough in most cases
            character(len=255) :: char
        endtype charType
        type(charType)  , pointer              :: charbuff
        type(dictType)  , pointer     :: metaObjPtr

        ! Cray compiler thinks metaObj uninitialised and segfaults! so we have to allocate a temporary pointer
        allocate(metaObjPtr, source=metaObj)

!        gnu   => blanc
!        intel => blanc

        ! we are sure metaObj%returnScalar(key) is correct, however
        ! have to use this step to temporarily hold the result in pointer tmp (see below)
        ! YL 01/03/2018: allocate(tmp, metaObj%returnScalar(key)) won't work
        ! YL 01/03/2018: gfortran 7 does not work with tmp => metaObj%returnScalar(key) and selecttype(tmp) however
        !                ifort does not work with selecttype(tmp=>metaObj%returnScalar(key))
        ! YL 08/01/2019: no longer works as per Intel 18: intel => metaObj%returnScalar(key)
        !intel => metaObj%returnScalar(key)
        ! YL 15/01/2019: however gfortran 7/8 does not compile this at all! see: https://github.com/oseledets/ttpy/issues/60
        !                it's said to be fixed in gfortran 9
!        allocate(intel, source=metaObj%returnScalar(key))
!        selecttype(tmp=>intel)
!            type is(character(*))
!                if(trim(tmp).ne."") then
!                    val => tmp
!                endif
!        endselect

        ! this is a workaround for Intel since gfortran 7/8 doesn't compile the above method
        charbuff => metaObjPtr%returnScalar(key)
        val => charbuff%char

        ! this is the GNU way
        selecttype(gnu=>metaObjPtr%returnScalar(key))
            type is(character(*))
                ! YL 19/10/2021: this will cause a runtime error when compiled with -check all or -check pointer (Intel bug?)
                if(trim(gnu).ne."") then
                    val => gnu
                endif
        endselect

        deallocate(metaObjPtr)

    endsubroutine getChar
!    subroutine getCPtr(metaObj, key, val)
!
!        class(dictType)          , intent(in)  :: metaObj
!        character(len=*)         , intent(in)  :: key
!        type(c_ptr)     , pointer, intent(out) :: val
!
!!        selecttype(tmp=>metaObj%returnScalar(key))
!!!            type is(type(c_ptr))
!!            class default
!!                val => tmp
!!        endselect
!
!    endsubroutine getCPtr
    subroutine getCFuncPtr(metaObj, key, val)

        class(dictType)          , intent(in)  :: metaObj
        character(len=*)         , intent(in)  :: key
        ! GNU segfaults at runtime if val is a pointer; while with Intel compiler val can be a pointer (val => metaObj%...)
        type(c_funptr)           , intent(out) :: val
        type(dictType)  , pointer     :: metaObjPtr

        ! Cray compiler thinks metaObj uninitialised and segfaults! so we have to allocate a temporary pointer
        allocate(metaObjPtr, source=metaObj)

!        allocate(val, source=metaObj%returnCFuncPtr(key))
        val = metaObjPtr%returnCFuncPtr(key)
!        selecttype(tmp=>metaObj%returnCFuncPtr(key))
!            class is(type(c_funptr))
!            class default
!                val => tmp
!        endselect

        deallocate(metaObjPtr)

    endsubroutine getCFuncPtr
    subroutine getLogical(metaObj, key, val)

        class(dictType) , intent(in)  :: metaObj
        character(len=*), intent(in)  :: key
        logical         , intent(out) :: val
        type(dictType)  , pointer     :: metaObjPtr

        ! Cray compiler thinks metaObj uninitialised and segfaults! so we have to allocate a temporary pointer
        allocate(metaObjPtr, source=metaObj)

        selecttype(tmp=>metaObjPtr%returnScalar(key))
            type is(logical(c_bool))
                val = merge(.true., .false., tmp)
        endselect

        deallocate(metaObjPtr)

    endsubroutine getLogical
    subroutine getCLogical(metaObj, key, val)

        class(dictType) , intent(in)  :: metaObj
        character(len=*), intent(in)  :: key
        logical(c_bool) , intent(out) :: val
        type(dictType)  , pointer     :: metaObjPtr

        ! Cray compiler thinks metaObj uninitialised and segfaults! so we have to allocate a temporary pointer
        allocate(metaObjPtr, source=metaObj)

        selecttype(tmp=>metaObjPtr%returnScalar(key))
            type is(logical(c_bool))
                val = merge(.true., .false., tmp)
        endselect

        deallocate(metaObjPtr)

    endsubroutine getCLogical
    subroutine getPyPtr(metaObj, key, val)

        class(dictType)          , intent(in)  :: metaObj
        character(len=*)         , intent(in)  :: key
        type(PyType)    , pointer, intent(out) :: val

        type(dictType)  , pointer              :: metaObjPtr
        integer ncols

        ! Cray compiler thinks metaObj uninitialised and segfaults! so we have to allocate a temporary pointer
        allocate(metaObjPtr, source=metaObj)
!        selecttype(tmp=>metaObj)
!            type is(dictType)
!                print *, "### getPyPtr: type is dictType, loc tmp =", loc(tmp)
!            class is(dictType)
!                print *, "### getPyPtr: class is dictType, loc tmp =", loc(tmp)
!            class default
!                print *, "### getPyPtr: class is default, loc tmp =", loc(tmp)
!        endselect
        val => metaObjPtr%returnPyPtr(key)

        ! some versions of GNU compiler segfaults if the Python object is None (c_ptr_null)
        if(associated(val)) then
            ncols = int(val%width)
        endif

        deallocate(metaObjPtr)

    endsubroutine getPyPtr

! END OF GETTERS
! POINTERS

!    function ptr(metaObj, key) result(val)
!
!        class(dictType)          , intent(in)  :: metaObj
!        character(len=*)         , intent(in)  :: key
!        class(*)        , pointer              :: val
!
!!        val => metaObj%returnOneDimDbl(key)
!
!    endfunction ptr

! END OF POINTERS

endmodule DL_PY2F

!!****h* utilities/dlf_sort
!!
!! NAME
!! sort
!!
!! FUNCTION
!! Simple bubble sort
!!
!! COPYRIGHT
!!
!!  Copyright 2007 Johannes Kaestner (kaestner@theochem.uni-stuttgart.de),
!!  Tom Keal (thomas.keal@stfc.ac.uk)
!!  Joanne Carr (j.m.carr@dl.ac.uk)
!!
!!  This file is part of DL-FIND.
!!
!!  DL-FIND is free software: you can redistribute it and/or modify
!!  it under the terms of the GNU Lesser General Public License as 
!!  published by the Free Software Foundation, either version 3 of the 
!!  License, or (at your option) any later version.
!!
!!  DL-FIND is distributed in the hope that it will be useful,
!!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!!  GNU Lesser General Public License for more details.
!!
!!  You should have received a copy of the GNU Lesser General Public 
!!  License along with DL-FIND.  If not, see 
!!  <http://www.gnu.org/licenses/>.
!!
!! SOURCE
!!****
module dlf_sort_module
  use dlf_parameter_module, only: rk
  implicit none
  private

  public :: dlf_sort

  interface dlf_sort
    module procedure dlf_sort_1
    module procedure dlf_sort_2
  end interface

  integer  :: nswap, ii
  real(rk) :: tmp
contains

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* dlf_sort/dlf_sort_1
!! 
!! FUNCTION 
!! Simple bubble sort, on the 2-dimensional array (1st argument), 
!! according to the corresponding values in the 1-D array (2nd argument). 
!! The lower the value the smaller the index in the resulting
!! sorted array.
!! The next 2 arguments are the upper bounds of the 1st and 2nd 
!! dimensions of the array in the first argument.  The upper bounds of the
!! first dimensions of all the passed arrays must coincide.
!! 
!! Designed for use with dlf_parallel_opt.
!! 
!! INPUTS
!!
!! a(index_1,index_2)
!! values(index_1)
!! index_1
!! index_2
!!
!! OUTPUTS
!!
!! the sorted array a(index_1,index_2)
!!
!! SYNOPSIS
subroutine dlf_sort_1(a,values,index_1,index_2)
!! SOURCE

  integer, intent(in)  :: index_1 ! upper bound of the 1st dimension of a
  integer, intent(in)  :: index_2 ! upper bound of the 2nd dimension of a
  real(rk), dimension(index_2)                         :: swap
  real(rk), dimension(index_1)         , intent(inout) :: values
  real(rk), dimension(index_1, index_2), intent(inout) :: a

  do
     nswap = 0
     do ii = 1, index_1 - 1
        if (values(ii) > values(ii+1)) then
            swap(:) = a(ii,:)
            a(ii,:) = a(ii+1,:)
            a(ii+1,:) = swap(:)
            tmp = values(ii)
            values(ii) = values(ii+1)
            values(ii+1) = tmp
            nswap = nswap + 1
        end if
     end do
     if (nswap == 0) exit
  end do

end subroutine dlf_sort_1
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* dlf_sort/dlf_sort_2
!!
!! FUNCTION
!! Simple bubble sort, on the 2-dimensional array (1st argument) and 
!! 3-dimensional array (2nd argument),
!! according to the corresponding values in the 1-D array (3rd argument).
!! The lower the value the smaller the index in the resulting
!! sorted arrays.
!! The next 2 arguments are the upper bounds of the 1st and 2nd
!! dimensions of the array in the first argument.  The next 2 arguments 
!! are the upper bounds of the 2nd and 3rd dimensions of the second 
!! array.  The upper bounds of the 
!! first dimensions of all the passed arrays must coincide.
!!
!! Designed for use with dlf_parallel_opt.
!!
!! INPUTS
!!
!! a(index_1,index_2)
!! b(index_1,index_3,index_4)
!! values(index_1)
!! index_1
!! index_2
!! index_3
!! index_4
!!
!! OUTPUTS
!!
!! sorted arrays a(index_1,index_2)
!! b(index_1,index_3,index_4)
!!
!! SYNOPSIS
subroutine dlf_sort_2(a,b,values,index_1,index_2,index_3,index_4)
!! SOURCE

  integer, intent(in)  :: index_1 ! upper bound of the 1st dimension of a
  integer, intent(in)  :: index_2 ! upper bound of the 2nd dimension of a
  integer, intent(in)  :: index_3 ! upper bound of the 2nd dimension of b
  integer, intent(in)  :: index_4 ! upper bound of the 3rd dimension of b
  real(rk), dimension(index_2)                                  :: swap_a
  real(rk), dimension(index_3, index_4)                         :: swap_b
  real(rk), dimension(index_1)                  , intent(inout) :: values
  real(rk), dimension(index_1, index_2)         , intent(inout) :: a
  real(rk), dimension(index_1, index_3, index_4), intent(inout) :: b
  
  do
     nswap = 0
     do ii = 1, index_1 - 1
        if (values(ii) > values(ii+1)) then
            swap_a(:) = a(ii,:)
            a(ii,:) = a(ii+1,:)
            a(ii+1,:) = swap_a(:)

            swap_b(:,:) = b(ii,:,:)
            b(ii,:,:) = b(ii+1,:,:)
            b(ii+1,:,:) = swap_b(:,:)

            tmp = values(ii)
            values(ii) = values(ii+1)
            values(ii+1) = tmp
            nswap = nswap + 1
        end if
     end do 
     if (nswap == 0) exit 
  end do

end subroutine dlf_sort_2
!!****

end module dlf_sort_module

!  Copyright (C) 2019 The authors of Py-ChemShell
!
!  This file is part of Py-ChemShell.
!
!  Py-ChemShell is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as
!  published by the Free Software Foundation, either version 3 of the
!  License, or (at your option) any later version.
!
!  Py-ChemShell is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with Py-ChemShell.  If not, see
!  <http://www.gnu.org/licenses/>.

module ChemShellFHIAimsModule

    use, intrinsic :: iso_c_binding
    use DL_PY2F
    use ChemShellParallelModule, only : chemsh_parallel

    private

    public register_fhiaims, interface_fhiaims, fhiaims_wrap
    public PyFrag, PyShells, nshells, PyOptions

    type(dictType) , pointer :: PyFrag, PyShells, PyOptions
    integer                  :: nshells
    integer(c_int)           :: c_debug
    integer(c_int)           :: fhiaims_handle

    contains

      
    subroutine register_fhiaims(debug) bind(c, name="f_register_fhiaims")

        integer(c_int), intent(in) :: debug

        type(c_funptr) :: fhiaims_pointer

        c_debug = debug

        fhiaims_pointer = c_funloc(fhiaims_wrap)
        fhiaims_handle = chemsh_parallel%get_function_handle(fhiaims_pointer)

    endsubroutine register_fhiaims
    ! called by master process only
    subroutine interface_fhiaims(fragPtr, optionsPtr) bind(c)
 
        implicit none
 
        type(PyType)  , intent(in) :: fragPtr
 
        integer                    :: ierror
        type(PyType)  , pointer    :: shellsPtr

        type(PyType) , intent(in) :: optionsPtr

        ! set up dict of optionsObj
        allocate(PyOptions, source=ptr2dict(optionsPtr))

        ! set up dict of fragObj
        allocate(PyFrag, source=ptr2dict(fragPtr))
        call PyFrag%get('shells', shellsPtr)
 
        ! set up dict of shellsObj and save nshells
        allocate(PyShells, source=ptr2dict(shellsPtr))
        call PyShells%get('npts', nshells)
 
        if(chemsh_parallel%is_parallel()) then
            ierror = chemsh_parallel%exec_function(fhiaims_handle, c_debug)
        else
            ierror = fhiaims_wrap()
        endif
 
        deallocate(PyFrag, PyShells, PyOptions)
 
    endsubroutine interface_fhiaims
    ! also called by slave processes
    integer function fhiaims_wrap() result(ierror)

        use ChemShellParallelModule, only : chemsh_parallel

        integer :: mpi_comm
        integer :: ou
        logical :: mpi_switch


        character(len=:)  , pointer :: output_filename
        character(len=255) :: fhiaims_output
        integer :: loutput

        fhiaims_output = repeat(' ', 255)

        nullify(output_filename)

        ! extract the output filename from the options object 
        call PyOptions%get("output", output_filename)

        loutput = len(trim(output_filename))
        fhiaims_output(1:loutput) = output_filename(1:loutput)


        mpi_comm = chemsh_parallel%comm_workgroup
        mpi_switch = .false.
        if(mpi_comm /= -1) then
            mpi_switch = .true.
        endif

        ou = 123
        if(chemsh_parallel%is_root()) then
            open(unit=ou, status='unknown',form='formatted',file=fhiaims_output)
        endif

        ierror = chemsh_parallel%sync()

        !write(6,*) mpi_comm, ou, mpi_switch

        !if(chemsh_parallel%is_subset()) then
        call aims(mpi_comm, ou, mpi_switch)
        !endif

        close(ou)

    endfunction fhiaims_wrap

endmodule ChemShellFHIAimsModule

! **********************************************************************
! **                      Improved Dimer method                       **
! **                 with L-BFGS rotation optimisation                **
! **                and L-BFGS translation optimisation               **
! **********************************************************************
!!****h* coords/dimer
!!
!! NAME
!! dimer
!!
!! FUNCTION
!! Apply the dimer method for transition state search
!!
!! COMMENTS
!! Cartesians of midpoint and tangent are stored
!!
!! icoords holds two images:
!! R_midpoint, Axis (= R_end-R_midpoint, length is dimer%delta)
!! igradient the corresponding gradient. 
!!
!! The dimer Distance is kept in i-space, the distance between 
!! R_midpoint and R_end is dimer%delta
!!
!! DATA
!!  $Date: 2006-12-13 15:55:10 +0000 (Wed, 13 Dec 2006) $
!!  $Rev: 29 $
!!  $Author: jk37 $
!!  $URL: http://ccpforge.cse.rl.ac.uk/svn/dl-find/trunk/dlf_dimer.f90 $
!!  $Id: dlf_dimer.f90 29 2006-12-13 15:55:10Z jk37 $
!!
!! COPYRIGHT
!!
!!  Copyright 2007 Johannes Kaestner (kaestner@theochem.uni-stuttgart.de),
!!  Tom Keal (thomas.keal@stfc.ac.uk)
!!
!!  This file is part of DL-FIND.
!!
!!  DL-FIND is free software: you can redistribute it and/or modify
!!  it under the terms of the GNU Lesser General Public License as 
!!  published by the Free Software Foundation, either version 3 of the 
!!  License, or (at your option) any later version.
!!
!!  DL-FIND is distributed in the hope that it will be useful,
!!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!!  GNU Lesser General Public License for more details.
!!
!!  You should have received a copy of the GNU Lesser General Public 
!!  License along with DL-FIND.  If not, see 
!!  <http://www.gnu.org/licenses/>.
!!
!! SOURCE
module dlf_dimer
  use dlf_parameter_module, only: rk
  type dimer_type
    integer               :: varperimage  ! no. of icoords per image
    integer               :: coreperimage ! no. of inner region icoords per image
    integer               :: status
    integer               :: mode !:
      ! 0: all rotations covered by the optimiser
      ! 1: rotations by linesearch here. No extrapolation of gradient
      ! 2: rotations by linesearch here. Extrapolation of gradient
    real(rk)              :: delta
    real(rk)              :: emid   ! energy of the dimer midpoint
    real(rk)              :: curve  ! curvature
    real(rk)              :: tolrot ! tolerance in rotation angle in order
                                    ! not to perform a new dimer rotation
    real(rk), allocatable :: xtangent(:,:) ! (3,nat) half dimer axis vector
    real(rk), allocatable :: xmidpoint(:,:) ! (3,nat)
    real(rk), allocatable :: rotgrad(:) ! (varperimage)
    real(rk), allocatable :: rotdir(:) ! (varperimage)
    real(rk), allocatable :: oldrotgrad(:) ! (varperimage)
    real(rk), allocatable :: oldrotdir(:) ! (varperimage)
    real(rk), allocatable :: vector(:) ! (varperimage)
    real(rk), allocatable :: theta(:) ! (varperimage)
    real(rk), allocatable :: grad1(:) ! (varperimage) gradient at 
                                      ! dimer end before rotation
    logical               :: toldrot
    logical               :: toptdir ! rotation optimised here rather than in formstep
    integer               :: cgstep
    logical               :: extrapolate_grad ! use extrapolated gradient
                             ! after rotation directly for next rotation?
    integer               :: nrot ! current number of rotations at fixed midpoint
    integer               :: maxrot ! max number of rotations at fixed midpoint
    real(rk)              :: phi,dcurvedphi
    ! test               
    logical               :: cdelta
  end type dimer_type
  type(dimer_type),save   :: dimer
  ! hard-coded at the moment:
  logical,parameter :: rot_lbfgs=.true.
end module dlf_dimer
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* dimer/dlf_dimer_init
!!
!! FUNCTION
!!
!! Initialise dimer calculations:
!! * Find the number of degrees of freedom
!! * (Initialise HDLCs)
!! * Allocate global and internal arrays
!! * Define the first dimer geometry
!! * Set default values for the calculation
!!
!! INPUTS
!!
!! glob%delta glob%tolrot glob%maxrot glob%tcoords2 glob%xcoords2
!! glob%nat / glob%nvar glob%spec glob%icoord glob%ncons glob%icons
!! glob%nconn glob%iconn glob%znuc glob%xcoords
!!
!! OUTPUTS
!! 
!! glob%nivar, glob%xcoords2 (if not set)
!! 
!! allocates: glob%icoords, glob%igradient, glob%step
!!
!! SYNOPSIS
subroutine dlf_dimer_init(icoord)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr,stdout,printl,pi
  use dlf_dimer
  use dlf_allocate, only: allocate,deallocate
  implicit none
  integer, intent(in)   :: icoord ! choice of dimer details 
  integer               :: ivar,iat
  real(rk)              :: svar
  real(RK) ,external    :: ddot
  logical               :: trandom,tplanar
  real(rk)              :: vnormal(3),v1(3),v2(3)
  real(rk) ,parameter   :: tolplanar=1.D-4
! **********************************************************************
  dimer%cdelta=.false. !<- this does not seem to make a difference

  ! set mode
  if( icoord<200 .or. icoord>299) call dlf_fail("Wrong icoord in Dimer")

  ! set parameters
  dimer%delta=glob%delta
  dimer%status=1
  dimer%nrot=0
  dimer%mode=mod(icoord/10,10)
  dimer%extrapolate_grad=(dimer%mode==2)
  dimer%tolrot=glob%tolrot/180.D0*pi
  dimer%maxrot=glob%maxrot

  ! check coords2
  trandom=.false.
  if(.not.glob%tcoords2) then
    ! if not provided by input, use random direction
    if(printl>=2) write(stdout,"('Dimer direction randomised')")
    glob%tcoords2=.true.
    if(glob%tatoms) then
      call allocate(glob%xcoords2,3,glob%nat,1)
    else
      call allocate(glob%xcoords2,1,glob%nvar,1)
    end if

    call random_number(glob%xcoords2)
    ! center coordinates
    glob%xcoords2=glob%xcoords2-0.5D0

    !check if system is planar
    if(glob%tatoms.and.glob%nat>=4) then
      v1=glob%xcoords(:,1)-glob%xcoords(:,2)
      v2=glob%xcoords(:,1)-glob%xcoords(:,3)
      vnormal(1)=v1(2)*v2(3)-v1(3)*v2(2)
      vnormal(2)=v1(3)*v2(1)-v1(1)*v2(3)
      vnormal(3)=v1(1)*v2(2)-v1(2)*v2(1)
      tplanar=.true.
      do iat=4,glob%nat
        if(abs(sum(vnormal*(glob%xcoords(:,1)-glob%xcoords(:,iat)))) &
            >= tolplanar) then
          tplanar=.false.
          exit
        end if
      end do
      if(tplanar)then
        svar=sqrt(sum(vnormal**2))
        vnormal=vnormal/svar
        if(printl>=2) write(stdout,*) "System planar, taking care of &
            &that when randomising dimer direction"
        do iat=1,glob%nat
          svar=sum(vnormal*glob%xcoords2(:,iat,1))
          glob%xcoords2(:,iat,1)=glob%xcoords2(:,iat,1)-svar*vnormal
        end do
        print*,"Random direction after planarising:"
        write(*,'(3f10.5)') glob%xcoords2
      end if
    end if

    if(dimer%mode==0) dimer%mode=1
    trandom=.true.
  end if

  if(dimer%mode >= 1) dimer%toptdir=.true.    

  ivar=mod(icoord,10)
  select case (ivar)
  ! Cartesian coordinates
  case (0,5)
    ! define the number of internal variables (covering all images)
    call dlf_direct_get_nivar(0, dimer%varperimage)
    call dlf_direct_get_nivar(1, dimer%coreperimage)

    ! calculate iweights
    call allocate( glob%iweight,dimer%varperimage*2)
    ! first image
    ivar=1
    do iat=1,glob%nat
      if(glob%spec(iat)>=0) then
        glob%iweight(ivar:ivar+2)=glob%weight(iat)
        ivar=ivar+3
      else if(glob%spec(iat)==-1) then
      else if(glob%spec(iat)>=-4) then
        glob%iweight(ivar:ivar+1)=glob%weight(iat)
        ivar=ivar+2
      else
        glob%iweight(ivar)=glob%weight(iat)
        ivar=ivar+1
      end if
    end do
    if(ivar-1/=dimer%varperimage) then
      call dlf_fail("Error in cartesian iweight calculation in dimer")
    end if
    ! copy weights to other image
    glob%iweight(dimer%varperimage+1:2*dimer%varperimage)=glob%iweight(1:dimer%varperimage)

  ! HDLC
  case(1:4)
    call dlf_hdlc_init(glob%nat,glob%spec,mod(glob%icoord,10),glob%ncons, &
        glob%icons,glob%nconn,glob%iconn)

    call dlf_hdlc_get_nivar(0, dimer%varperimage)
    call dlf_hdlc_get_nivar(1, dimer%coreperimage)

    ! create hdlc with midpoint as coordinates
    call dlf_hdlc_create(glob%nat,dimer%coreperimage,glob%spec,glob%micspec,glob%znuc,1, &
        glob%xcoords(:,:),glob%weight,glob%mass)

    ! calculate iweights
    call allocate( glob%iweight,dimer%varperimage*2)
    call dlf_hdlc_getweight(glob%nat,dimer%varperimage,dimer%coreperimage,glob%micspec,&
        glob%weight,glob%iweight(1:dimer%varperimage))
    ! copy weights to other image
    glob%iweight(dimer%varperimage+1:2*dimer%varperimage)=glob%iweight(1:dimer%varperimage)

  case default
    write(stderr,'("Coordinate type ",i3," not supported in Dimer")') icoord
    call dlf_fail("Wrong coordinate type in dimer")
  end select

  ! simple dimer method:
  glob%nivar = 2 * dimer%varperimage
  glob%nicore = 2 * dimer%coreperimage

  if(glob%tatoms) then
    call allocate( dimer%xtangent, 3, glob%nat)
    call allocate( dimer%xmidpoint, 3, glob%nat)
  else
    call allocate( dimer%xtangent, 1, glob%nvar)
    call allocate( dimer%xmidpoint, 1, glob%nvar)
  end if

  call allocate( glob%icoords,glob%nivar)
  call allocate( glob%igradient,glob%nivar)
  call allocate( glob%step,glob%nivar) 

  call allocate( dimer%rotgrad,dimer%varperimage)
  call allocate( dimer%rotdir,dimer%varperimage)
  call allocate( dimer%oldrotgrad,dimer%varperimage)
  call allocate( dimer%oldrotdir,dimer%varperimage)
  call allocate( dimer%vector,dimer%varperimage)
  call allocate( dimer%theta,dimer%varperimage)
  call allocate( dimer%grad1,dimer%varperimage)
  dimer%toldrot=.false.

  ! xcoords contains midpoint, xcoords2 contains endpoint 1, distance 
  !  not necessarily correct

  !Set icoords(1)
  glob%xgradient=0.D0

  call dlf_direct_xtoi(glob%nvar,dimer%varperimage,dimer%coreperimage, &
      glob%xcoords,glob%xgradient,glob%icoords(1:dimer%varperimage), & 
      glob%igradient(1:dimer%varperimage))
  dimer%xmidpoint(:,:)=glob%xcoords(:,:)

  ! Guess xcoords2 at distance delta from xcoords
  if(glob%tsrelative.or.trandom) then
    dimer%xtangent(:,:)=glob%xcoords2(:,:,1)
  else
    dimer%xtangent(:,:)=glob%xcoords2(:,:,1)-glob%xcoords(:,:)
  end if
  svar=dsqrt(ddot(glob%nvar,dimer%xtangent,1,dimer%xtangent,1))
  dimer%xtangent(:,:)=dimer%xtangent(:,:) / svar * dimer%delta
  glob%xcoords(:,:)=glob%xcoords(:,:) + dimer%xtangent(:,:)

  ! set icoords2 to the guessed endpoint
  call dlf_direct_xtoi(glob%nvar,dimer%varperimage,dimer%coreperimage, &
      glob%xcoords,glob%xgradient,glob%icoords(dimer%varperimage+1:), &
      glob%igradient(1:dimer%varperimage))

  ! set xcoords back for first step
  glob%xcoords(:,:)=glob%xcoords(:,:) - dimer%xtangent(:,:)

  ! set icoords2 to R_end-R_midpoint with the proper length
  glob%icoords(dimer%varperimage+1:)=glob%icoords(dimer%varperimage+1:)- &
      glob%icoords(1:dimer%varperimage)

  ! weight icoords2
  glob%icoords(dimer%varperimage+1:)=glob%icoords(dimer%varperimage+1:) * &
      glob%iweight(1:dimer%varperimage)

  ! remove translation and rotation from dimer axis
  call dlf_coords_tranrot(dimer%varperimage,glob%icoords(dimer%varperimage+1:))
  svar=ddot(dimer%varperimage,glob%icoords(dimer%varperimage+1:),1, &
      glob%icoords(dimer%varperimage+1:),1)
  if(svar>1.D-15) then
    glob%icoords(dimer%varperimage+1:)=glob%icoords(dimer%varperimage+1:) &
        / dsqrt(svar) * dimer%delta
  else
    call dlf_fail("Input dimer distance too small!")
  end if

  ! rubbish for printing
  if(.not.glob%tatoms) then
    if (glob%iam == 0) then
       open(unit=40,file="axis.inc")
       open(unit=41,file="dimer.xy",position="append")
    end if
  end if

  if(rot_lbfgs) then
    call dlf_lbfgs_select("dimer rotation",.true.)
    call dlf_lbfgs_init(dimer%varperimage,min(dimer%maxrot,dimer%varperimage)) 
    call dlf_lbfgs_deselect
  end if

end subroutine dlf_dimer_init
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* dimer/dlf_dimer_destroy
!!
!! FUNCTION
!! Destroy dimer arrays and close files
!!
!! SYNOPSIS
subroutine dlf_dimer_destroy
!! SOURCE
  ! deallocate arrays concerning internal coordinates
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr
  use dlf_dimer
  use dlf_allocate, only: deallocate
  implicit none
  logical :: exists
! **********************************************************************
  ! deallocate arrays
  if (allocated(glob%icoords)) call deallocate( glob%icoords)
  if (allocated(glob%igradient)) call deallocate( glob%igradient)
  if (allocated(glob%step)) call deallocate( glob%step)
  if (allocated(glob%iweight)) call deallocate( glob%iweight)

  if (allocated(dimer%rotgrad)) call deallocate( dimer%rotgrad)
  if (allocated(dimer%rotdir)) call deallocate( dimer%rotdir)
  if (allocated(dimer%oldrotgrad)) call deallocate( dimer%oldrotgrad)
  if (allocated(dimer%oldrotdir)) call deallocate( dimer%oldrotdir)
  if (allocated(dimer%vector)) call deallocate( dimer%vector)
  if (allocated(dimer%theta)) call deallocate( dimer%theta)
  if (allocated(dimer%grad1)) call deallocate( dimer%grad1)

  if(rot_lbfgs) then
    ! dimer%oldrotdir, dimer%oldrotgrad are not needed!
    call dlf_lbfgs_exists("dimer rotation", exists)
    if (exists) then
       call dlf_lbfgs_select("dimer rotation",.false.)
       call dlf_lbfgs_destroy
       call dlf_lbfgs_deselect
    end if
  end if

  select case (mod(glob%icoord,10))
  ! HDLC
  case(1:4)
    call dlf_hdlc_destroy
  end select

  if (allocated(dimer%xtangent)) call deallocate( dimer%xtangent)
  if (allocated(dimer%xmidpoint)) call deallocate( dimer%xmidpoint)

  ! rubbish for printing
  if(.not.glob%tatoms) then
    if (glob%iam == 0) then
       close(40)
       close(41)
    end if
  end if

end subroutine dlf_dimer_destroy
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* dimer/dlf_dimer_xtoi
!!
!! FUNCTION
!! * Convert individual energy/gradients into the dimer force expression
!! * Estimate a dimer rotation angle
!! * Optimise the dimer rotation eventually
!!
!! SYNOPSIS
subroutine dlf_dimer_xtoi(trerun_energy,testconv)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr,stdout,printl,pi
  use dlf_stat, only: stat
  use dlf_dimer
  use dlf_allocate, only: allocate,deallocate
  implicit none
  logical, intent(out)  :: trerun_energy
  logical, intent(out)  :: testconv ! is convergence tested here?
  real(rk)              :: svar
  logical               :: stoprot
  real(rk),external     :: ddot
  real(rk)              :: phi1
  logical               :: exists
! **********************************************************************

  ! If in a microiterative loop, just xtoi the midpoint
  if (glob%imicroiter == 2) then
     call dlf_direct_xtoi(glob%nvar,dimer%varperimage,dimer%coreperimage, &
          glob%xcoords,glob%xgradient,glob%icoords(1:dimer%varperimage), &
          glob%igradient(1:dimer%varperimage))
     return
  end if

  ! ====================================================================
  ! Optimise the rotation
  ! ====================================================================

  ! this routine has to be called several times from the main cycle 
  !  (after each E&G evaluation). Thus we have to use dimer%status to 
  !  keep track.
  
  stoprot=.false.
  trerun_energy=.true.

  if(dimer%status == 1) then
    ! check overall convergence, set xcoords to x1
    call dlf_dimer_was_midpoint(trerun_energy,testconv)
    if(.not.trerun_energy) return ! converged
    ! now calculate endpoint: g1
    ! dimer%status = 2 is set in dlf_dimer_was_midpoint
  else if (dimer%status == 2) then
    ! calculate theta,
    ! estimate rotation angle: phi1
    ! check convergence of rotation (based on phi1),
    ! rotate the dimer to x1'
    call dlf_dimer_was_g1(.false.,stoprot)
    ! now calculate g1'
    dimer%status = 3
  else if (dimer%status == 3) then
    ! calculate optimal rotation angle phi_opt,
    ! check convergence, 
    ! set dimer direction according to phi_opt
    call dlf_dimer_was_g1prime(stoprot,phi1)
    if(dimer%extrapolate_grad.and..not.stoprot) then
      ! extrapolate the gradient at g1
      !call dlf_dimer_extrapolate_gradient(phi1)
      call dlf_dimer_extrapolate_gradient(dimer%varperimage,phi1, &
          dimer%phi,glob%igradient(1:dimer%varperimage),dimer%grad1,&
          glob%igradient(dimer%varperimage+1:))

      call dlf_dimer_was_g1(.true.,stoprot)
      ! now calculate g1'
      dimer%status = 3
    else
      ! now calculate endpoint: g1
      dimer%status = 2
    end if
  else
    call dlf_fail("Wrong dimer%status")
  end if

  ! ====================================================================
  ! If the rotations are converged, transform the gradient
  ! ====================================================================
  if(stoprot) then
    ! rotation has converged, transform gradient and return
    if(printl>=2) then
      if(abs(dimer%phi) <= dimer%tolrot) then
        write(stdout,"('Dimer rotation converged after ',i4,' steps')") &
            dimer%nrot
      else
        write(stdout,"('Dimer rotation not converged after ',i4,' steps')") &
            dimer%nrot
        write(stdout,"('Dimer rotation terminated, maximum number of&
            & rotations reached')")
      end if
    end if
    ! dimer is not rotated any more, send tsmode to set_tsmode
    ! TS mode in internals
    call dlf_formstep_set_tsmode(dimer%varperimage,11,dimer%vector) 
    
    if(printl>=2) write(stdout,'("Curvature after dimer rotation:     &
        &      ",f12.5)') &
        dimer%curve
    
    ! print frequency in case of mass-weighted coordinates
    if(glob%massweight .and. printl>=2) then

      call dlf_print_wavenumber(dimer%curve,.true.)

!!$      ! sqrt(H/u)/a_B/2/pi/c / 100
!!$      svar=sqrt( 4.35974417D-18/ 1.66053886D-27 ) / ( 2.D0 * pi * &
!!$          0.5291772108D-10 * 299792458.D0) / 100.D0
!!$      svar=sqrt(abs(dimer%curve)) * svar
!!$      if(dimer%curve<0.D0) svar=-svar
!!$      write(stdout,"('Frequency of transition mode',f10.3,' cm^-1 &
!!$          &(negative value denotes imaginary frequency)')") &
!!$          svar
    end if
    
    
    ! transform gradient:
    if(dimer%toptdir) then
      ! set rotational force to zero if rotation is optimised here 
      ! rather than by formstep
      glob%igradient(dimer%varperimage+1:)=0.d0
    else
      glob%igradient(dimer%varperimage+1:)=dimer%rotgrad*1.0D0 
    end if
    
    ! translational gradient:
    svar=sum(dimer%vector(:) * glob%igradient(1:dimer%varperimage))
    if(dimer%curve > 0.D0) then
      glob%igradient(1:dimer%varperimage)=-svar*dimer%vector(:)
    else
      glob%igradient(1:dimer%varperimage)=glob%igradient(1:dimer%varperimage) - &
          2.D0 * svar * dimer%vector(:)
    end if

    dimer%nrot=0
    dimer%toldrot=.false. ! no CG for next rotation
    if(rot_lbfgs) then
      call dlf_lbfgs_select("dimer rotation",.false.)
      call dlf_lbfgs_restart
      dimer%rotdir(:)=0.D0
      call dlf_lbfgs_deselect
    end if
    dimer%status=1
    trerun_energy=.false.
    testconv=.true.

  end if !(stoprot)

end subroutine dlf_dimer_xtoi
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* dimer/dlf_dimer_was_midpoint
!!
!! FUNCTION
!! * Called after the dimer midpoint was calculated
!! * Check overall convergence of the dimer optimisation
!! * Set xcoords to dimer endpoint before rotation (x1)
!!
!! SYNOPSIS
subroutine dlf_dimer_was_midpoint(trerun_energy,testconv)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr,stdout,printl
  use dlf_stat, only: stat
  use dlf_dimer
  use dlf_allocate, only: allocate,deallocate
  implicit none
  logical, intent(out)  :: trerun_energy
  logical, intent(out)  :: testconv ! is convergence tested here?
  real(rk)              :: dlength,svar
  logical               :: tok,tconv
  real(rk),external     :: ddot
! **********************************************************************
  testconv=.true.
  ! ==================================================================
  ! This was the midpoint calculation, xcoords contains midpoint
  ! ==================================================================

  ! send information to set_tsmode
  call dlf_formstep_set_tsmode(1,-1,(/glob%energy/)) ! send energy
  call dlf_formstep_set_tsmode(glob%nvar,0,glob%xcoords) ! TS-geometry

  call dlf_direct_xtoi(glob%nvar,dimer%varperimage,dimer%coreperimage, &
      glob%xcoords,glob%xgradient,glob%icoords(1:dimer%varperimage), &
      glob%igradient(1:dimer%varperimage))

  ! set xcoords to endpoint 1:

  !Set icoords(1) to endpoint1:
  if(.not.dimer%cdelta) then
    dlength=dsqrt(ddot(dimer%varperimage,glob%icoords(dimer%varperimage+1:),1, &
        glob%icoords(dimer%varperimage+1:),1))
    !print*,"Dimer length scaling",dlength/dimer%delta
    glob%icoords(1:dimer%varperimage)=glob%icoords(1:dimer%varperimage)+ &
        glob%icoords(dimer%varperimage+1:)*dimer%delta/dlength
  else
    glob%icoords(1:dimer%varperimage)=glob%icoords(1:dimer%varperimage)+ &
        glob%icoords(dimer%varperimage+1:)
  end if

  !Transform to x-coords
  call dlf_direct_itox(glob%nvar,dimer%varperimage,dimer%coreperimage, &
      glob%icoords(1:dimer%varperimage),glob%xcoords(:,:),tok)
  if(.not.tok) then

    if(printl>=4) write(stdout, &
        "('HDLC coordinate breakdown at dimer endpoint. Recalculating HDLCs and &
        &restarting optimiser and dimer.')")
    call dlf_hdlc_reset
    call dlf_hdlc_create(glob%nat,dimer%coreperimage,glob%spec,glob%micspec,&
        glob%znuc,1,glob%xcoords,glob%weight,glob%mass)
    ! recalculate iweights
    call dlf_hdlc_getweight(glob%nat,dimer%varperimage,dimer%coreperimage,glob%micspec,&
        glob%weight,glob%iweight(1:dimer%varperimage))
    ! copy weights to other image
    glob%iweight(dimer%varperimage+1:2*dimer%varperimage)= &
        glob%iweight(1:dimer%varperimage)
    
    call dlf_formstep_restart
    ! calculate internal coordinates of midpoint
    call dlf_direct_xtoi(glob%nvar,dimer%varperimage,dimer%coreperimage, &
        glob%xcoords,glob%xgradient,glob%icoords(1:dimer%varperimage), &
        glob%igradient(1:dimer%varperimage))
    !calculate internal coordinates of endpoint 1
    glob%xcoords=glob%xcoords+dimer%xtangent
    call dlf_direct_xtoi(glob%nvar,dimer%varperimage,dimer%coreperimage, &
        glob%xcoords,glob%xgradient,glob%icoords(dimer%varperimage+1:), &
        glob%igradient(dimer%varperimage+1:))
    ! now first half of internal gradient is correct, second half is
    ! not, but will be recalculated anyway.
    glob%icoords(dimer%varperimage+1:)=glob%icoords(dimer%varperimage+1:) -&
        glob%icoords(1:dimer%varperimage)
    ! normalise (they are not necessarily normal in the new HDLCs)
    svar=ddot(dimer%varperimage,glob%icoords(dimer%varperimage+1:),1, &
        glob%icoords(dimer%varperimage+1:),1)
    glob%icoords(dimer%varperimage+1:)=glob%icoords(dimer%varperimage+1:) &
        / dsqrt(svar) * dimer%delta
    ! set icoords(1) to endpoint 1, will be reset to midpoint below
    glob%icoords(1:dimer%varperimage)=glob%icoords(1:dimer%varperimage)+ &
        glob%icoords(dimer%varperimage+1:)
    
  else
    ! store cartesian dimer vector
    dimer%xtangent=glob%xcoords-dimer%xmidpoint
  end if
  !Set icoords(1) back to midpoint:
  if(.not.dimer%cdelta) then
    glob%icoords(1:dimer%varperimage)=glob%icoords(1:dimer%varperimage)- &
        glob%icoords(dimer%varperimage+1:)*dimer%delta/dlength
  else
    glob%icoords(1:dimer%varperimage)=glob%icoords(1:dimer%varperimage)- &
        glob%icoords(dimer%varperimage+1:)
  end if
  
  dimer%emid=glob%energy

  ! ==================================================================
  ! Test convergence
  ! ==================================================================
  call convergence_set_info("of dimer midpoint",dimer%varperimage,&
      dimer%emid,glob%igradient(1:dimer%varperimage),glob%step(1:dimer%varperimage))
  ! test convergence
  call convergence_test(stat%ccycle,.true.,tconv)
  trerun_energy=.true.
  if(tconv) then
    ! send again, so that the same valued will be tested
    call convergence_set_info("of dimer midpoint",dimer%varperimage,&
        dimer%emid,glob%igradient(1:dimer%varperimage),glob%step(1:dimer%varperimage))
    ! If converged, make sure that the latest TSmode is also set!
    call dlf_formstep_set_tsmode(dimer%varperimage,11,glob%icoords(dimer%varperimage+1:))
    ! TS mode in internals
    testconv=.false. ! should be tested again in the main cycle, which causes it to stop
    trerun_energy=.false.
    dimer%status=1
    return
  end if

  if(printl>=4) write(stdout,"('Next calculation will be the dimer &
      &endpoint before rotation')")
  trerun_energy=.true.
  dimer%status=2
end subroutine dlf_dimer_was_midpoint
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* dimer/dlf_dimer_was_g1
!!
!! FUNCTION
!! * Called after the dimer endpoint before rotation was calculated
!! * calculate theta (rotation direction)
!! * estimate rotation angle: phi1
!! * check convergence of rotation (based on phi1)
!! * rotate the dimer to x1' (xcoords) if rotation continues
!!
!! SYNOPSIS
subroutine dlf_dimer_was_g1(internal,stoprot)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr,stdout,printl,pi
  use dlf_stat, only: stat
  use dlf_dimer
  use dlf_allocate, only: allocate,deallocate
  implicit none
  logical,   intent(in)  :: internal ! internal gradient is already known
  logical,   intent(out) :: stoprot
  real(rk)               :: svar,gamma
  real(rk),  external    :: ddot
  logical                :: tok
! **********************************************************************

  ! ==================================================================
  ! This was one endpoint calculation, xcoords contains endpoint 1
  ! ==================================================================
  
  if(.not.internal) then
    call dlf_direct_xtoi(glob%nvar,dimer%varperimage,dimer%coreperimage, &
        glob%xcoords,glob%xgradient,glob%icoords(dimer%varperimage+1:), &
        glob%igradient(dimer%varperimage+1:))
    ! transform coords:
    dimer%vector(:)=glob%icoords(dimer%varperimage+1:)-glob%icoords(1:dimer%varperimage)
    glob%icoords(dimer%varperimage+1:)=dimer%vector(:)
    
    ! normalise dimer%vector:
    svar=dsqrt(ddot(dimer%varperimage,dimer%vector,1,dimer%vector,1))
    if(dimer%cdelta.and.abs(svar-dimer%delta) > 1.D-6 ) then
      print*,"Error: dimer distance wrong:"
      print*,"Distance after step:",svar
      print*,"Required distance:",dimer%delta
      call dlf_fail("Wrong dimer distance!")
    end if
    dimer%vector=dimer%vector/svar
  end if

  ! calculate curvature
  dimer%curve=(ddot(dimer%varperimage,glob%igradient(dimer%varperimage+1:),1,&
      dimer%vector,1)-ddot(dimer%varperimage,glob%igradient(1:dimer%varperimage),1,&
      dimer%vector,1))/dimer%delta
  if(printl>=2.and..not.internal) then
    write(stdout,"('Curvature at dimer midpoint               ',f12.5)") dimer%curve
  end if

  ! direction for rotation:
  dimer%rotgrad(:)=glob%igradient(dimer%varperimage+1:)- &
      glob%igradient(1:dimer%varperimage)
  ! weight direction for rotation
  dimer%rotgrad(:)=dimer%rotgrad(:) * glob%iweight(1:dimer%varperimage)
  ! orthogonalise to vector
  svar=ddot(dimer%varperimage,dimer%vector,1, dimer%rotgrad,1)
  dimer%rotgrad(:)=dimer%rotgrad(:) - svar * dimer%vector(:)

  if(rot_lbfgs) then
    call dlf_lbfgs_select("dimer rotation",.false.)
    call dlf_lbfgs_step(dimer%vector,dimer%rotgrad,dimer%rotdir)
    call dlf_lbfgs_deselect
  else
    ! CG rotation
    ! find rotation direction by conjugate gradient
    if((.not.dimer%toldrot).or.mod(dimer%cgstep,10)==0) then
      dimer%cgstep=1
      gamma =0.D0
      dimer%oldrotdir(:)=0.D0
    else
      gamma=ddot(dimer%varperimage, dimer%rotgrad-dimer%oldrotgrad,1 &
          ,dimer%rotgrad,1) / &
          ddot(dimer%varperimage,dimer%oldrotgrad,1,dimer%oldrotgrad,1)
      dimer%cgstep=dimer%cgstep+1
    end if
    gamma=max(gamma,0.d0)
    dimer%rotdir(:)= -dimer%rotgrad(:) + gamma * dimer%oldrotdir(:)
  end if

  dimer%oldrotgrad(:) = dimer%rotgrad(:)
  dimer%toldrot=.true. ! used: CG, away: SD

  dimer%theta(:)=dimer%rotdir(:)
  ! orthogonalise to dimer%vector
  svar=ddot(dimer%varperimage,dimer%vector,1,dimer%theta,1)
  dimer%theta(:)=dimer%theta(:) - svar * dimer%vector(:)
  ! normalise
  svar=dsqrt(sum(dimer%theta**2))
  dimer%theta(:)=dimer%theta(:)/svar
    
  ! estimate the rotation angle:
  dimer%dcurvedphi=2.D0 * sum((glob%igradient(dimer%varperimage+1:) &
      -glob%igradient(1:dimer%varperimage)) &
      * dimer%theta(:))/dimer%delta
  
  ! estimate the angle from curve and dcurvedphi. c0 and ca are ignored
  ! at the moment
  !call guess_phimin(dimer%curve,dimer%dcurvedphi,dimer%c0,dimer%ca,dimer%phi)
  dimer%phi=abs(0.5D0*atan(1.d0/( 2.d0*dimer%curve/dimer%dcurvedphi)))

  if(printl>=4) then
    write(stdout,"('Predicted dimer rotation angle:    ',f7.3,' deg')") &
        dimer%phi*180.D0/pi
  end if

  stoprot=.true.

  if(dimer%toptdir) then
    ! rotate dimer:
    if(abs(dimer%phi) > dimer%tolrot .and. dimer%nrot < dimer%maxrot) then 
      glob%icoords(dimer%varperimage+1:)=glob%icoords(1:dimer%varperimage) + &
          cos(dimer%phi) * dimer%delta * dimer%vector(:) + &
          sin(dimer%phi) * dimer%delta * dimer%theta(:)
      !Transform to x-coords
      call dlf_direct_itox(glob%nvar,dimer%varperimage,dimer%coreperimage, &
          glob%icoords(dimer%varperimage+1:),glob%xcoords(:,:),tok)
      if(.not.tok) call dlf_fail("Dimer internal->x conversion failed C")

      ! store cartesian dimer vector
      dimer%xtangent=glob%xcoords-dimer%xmidpoint

      dimer%status=3
      if(printl>=4) write(stdout,"('Next calculation will be the dimer &
          &endpoint after rotation')")

      ! rotation not converged
      stoprot=.false.

    ! if rotation finished, icoords(dimer%varperimage+1:) are relative coordinates
    ! of the non-rotated dimer.
    end if ! abs(dimer%phi) > dimer%tolrot

  end if ! dimer%toptdir

end subroutine dlf_dimer_was_g1
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* dimer/dlf_dimer_was_g1prime
!!
!! FUNCTION
!! * Called after the dimer endpoint after rotation was calculated
!! * calculate optimal rotation angle phi_opt
!! * check convergence based on phi_opt
!! * set dimer direction according to phi_opt (xcoords)
!!
!! SYNOPSIS
subroutine dlf_dimer_was_g1prime(stoprot,phi1)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stderr,stdout,printl,pi
  use dlf_stat, only: stat
  use dlf_dimer
  use dlf_allocate, only: allocate,deallocate
  implicit none
  logical,   intent(out) :: stoprot
  real(rk),  intent(out) :: phi1
  real(rk),  allocatable :: vector2(:)
  real(rk)               :: curve2,a1,a0,b1
  logical                :: tok
  real(rk), external     :: ddot
! **********************************************************************

  ! ==================================================================
  ! This was the second endpoint calculation
  ! ==================================================================

  ! Dimer has already been rotated once, now determine optimal rotational position.
  ! Vector and theta are allocated and point to the old dimer direction and
  ! old rotational direction.
  ! xcoords contains endpoint 1 after rotation.

  dimer%nrot=dimer%nrot+1

  ! store endpoint gradient before rotation
  dimer%grad1=glob%igradient(dimer%varperimage+1:)

  call dlf_direct_xtoi(glob%nvar,dimer%varperimage,dimer%coreperimage, &
      glob%xcoords,glob%xgradient,glob%icoords(dimer%varperimage+1:), &
      glob%igradient(dimer%varperimage+1:))

  call allocate(vector2,dimer%varperimage)
  vector2=(cos(dimer%phi) * dimer%vector(:) + sin(dimer%phi) * dimer%theta(:))

  ! calculate curvature
  curve2=(ddot(dimer%varperimage,glob%igradient(dimer%varperimage+1:),1,&
      vector2,1)-ddot(dimer%varperimage,glob%igradient(1:dimer%varperimage),1,&
      vector2,1))/dimer%delta
  
  if(printl>=4) then
    write(stdout,"('Curvature at dimer midpoint after rotation',f12.5)") curve2
  end if

  ! we use the first version of Eq 30 in hey05 for a1:
  a1= ( dimer%curve - curve2 + 0.5D0 * dimer%dcurvedphi * &
      sin(2.D0*dimer%phi) ) / ( 1.D0 - cos(2.D0 * dimer%phi) )
  b1= 0.5D0 * dimer%dcurvedphi
  a0= 2.d0 * ( dimer%curve - a1 )
  
  phi1=dimer%phi ! angle of first rotation
  dimer%phi=0.5d0 * datan(b1/a1) ! phi_opt, rotational minimum

  ! Make sure the angle is a minimum, not a maximum
  curve2=0.5D0 * a0 + a1 * cos(2.D0 * dimer%phi) + b1 * sin(2.D0 * dimer%phi)
  if(printl>=6) then
    write(stdout,"('Expected curvature at dimer minimum       ',f12.5)") curve2
  end if
  if( curve2 > dimer%curve ) then
    if(printl>=6) print*,"Obtained angle seems to be a maximum: ",curve2
    dimer%phi=dimer%phi-0.5d0 * pi
    curve2=0.5D0 * a0 + a1 * cos(2.D0 * dimer%phi) + b1 * sin(2.D0 * dimer%phi)
    if(printl>=6) print*,"New curvature, now hopefully a minimum",curve2
  end if
  if(abs(dimer%phi-phi1) > pi*0.5D0) then
    if(dimer%phi<phi1) then
      dimer%phi=dimer%phi+pi
    else
      dimer%phi=dimer%phi-pi
    end if
  end if
  
  if(printl>=4) then
    write(stdout,"('Curvature at dimer minimum                ',f12.5)") curve2
    write(stdout,"('Actual dimer rotation angle:       ',f7.3,' deg')") &
        dimer%phi*180.D0/pi
  end if

  ! if abs(dimer%phi)< dimer%tolrot, do this rotation but exit afterwards!
  stoprot=(abs(dimer%phi) < dimer%tolrot)

  glob%icoords(dimer%varperimage+1:)= &
      cos(dimer%phi) * dimer%delta * dimer%vector(:) + &
      sin(dimer%phi) * dimer%delta * dimer%theta(:)
  
  vector2= (cos(dimer%phi) * dimer%vector(:) + sin(dimer%phi) * dimer%theta(:))

  dimer%vector=vector2
  dimer%curve=curve2

  ! Set old rotation direction (for CG) to the normal vector. This was shown to be 
  !  better than the rotated one.
  dimer%oldrotdir(:)  = dimer%theta(:) * &
      sqrt(ddot(dimer%varperimage,dimer%rotdir(:),1,dimer%rotdir(:),1))

  glob%icoords(dimer%varperimage+1:)=glob%icoords(1:dimer%varperimage) + &
      dimer%delta * vector2(:)
  !Transform to x-coords
  call dlf_direct_itox(glob%nvar,dimer%varperimage,dimer%coreperimage, &
      glob%icoords(dimer%varperimage+1:),glob%xcoords(:,:),tok)
  if(.not.tok) call dlf_fail("Dimer internal->x conversion failed D")

  ! store cartesian dimer vector
  dimer%xtangent=glob%xcoords-dimer%xmidpoint

  ! set icoords back to relative rotated coords
  glob%icoords(dimer%varperimage+1:)= dimer%delta * vector2(:)

  if(.not.dimer%extrapolate_grad.and..not.stoprot) then
    if(printl>=4) write(stdout,"('Next calculation will be the dimer &
        &endpoint before rotation')")
  end if
  call deallocate(vector2)

end subroutine dlf_dimer_was_g1prime
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* dimer/dlf_dimer_extrapolate_gradient
!!
!! FUNCTION
!! * Extrapolate the i-gradient at the new dimer endpoint g1
!!
!! SYNOPSIS
subroutine dlf_dimer_extrapolate_gradient(nvar,phi1,phim,grad0,grad1,grad1prime)
!! SOURCE
  ! linear in r between r_0, r_1, and r_1'
  use dlf_parameter_module, only: rk
  use dlf_global, only: pi
  implicit none
  integer  ,intent(in)    :: nvar
  real(rk) ,intent(in)    :: phi1
  real(rk) ,intent(in)    :: phim
  real(rk) ,intent(in)    :: grad0(nvar)
  real(rk) ,intent(in)    :: grad1(nvar)
  real(rk) ,intent(inout) :: grad1prime(nvar)
  real(rk)                :: par1,par1prime,par0
  ! ******************************************************************
  par1=dsin(phi1-phim)/dsin(phi1)
  par1prime=dsin(phim)/dsin(phi1)
  par0=1.D0-dcos(phim)-dsin(phim)*dtan(0.5D0*phi1)
  grad1prime(:) = par1 * grad1(:) + par1prime * grad1prime(:) &
      + par0 * grad0(:)
end subroutine dlf_dimer_extrapolate_gradient
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* dimer/dlf_dimer_checkstep
!!
!! FUNCTION
!! If rotation is optimised in itox, just set rotational gradient to zero
!!
!! If rotation is optimised by the optimiser, scale rotational step,
!! the adjust the step to preserve the dimer direction.
!!
!! SYNOPSIS
subroutine dlf_dimer_checkstep
!! SOURCE
  ! Make sure the distance between the images is constant 
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stdout,pi,printl
  use dlf_dimer, only: dimer
  implicit none
  real(rk)              :: n0s, ss, svar
  real(RK) ,external    :: ddot
! **********************************************************************

  ! Versions for determining the step in the dimer direction
  if(dimer%toptdir) glob%step(dimer%varperimage+1:)=0.D0

  ! scale rotational step back ...
  ! Scaled L-BFGS rotation
  glob%step(dimer%varperimage+1:)=glob%step(dimer%varperimage+1:)*0.10D0  

  if(dimer%cdelta) then
    ! we have to scale the N-step back
    glob%step(dimer%varperimage+1:) = glob%step(dimer%varperimage+1:) + &
        glob%icoords(dimer%varperimage+1:)
    ss= ddot(dimer%varperimage,glob%step(dimer%varperimage+1:), 1, &
        glob%step(dimer%varperimage+1:), 1)

    write(*,'("Distance scaled from",F10.5," to",F10.5)') SQRT(ss),dimer%delta
    glob%step(dimer%varperimage+1:) = glob%step(dimer%varperimage+1:) &
        / dsqrt(ss) * dimer%delta
    ! make sure N does not change by more than 90 deg (as then -step is the relevant step)
    if(ddot(dimer%varperimage,glob%step(dimer%varperimage+1:), 1, &
        glob%icoords(dimer%varperimage+1:),1) < 0.D0 ) &
        glob%step(dimer%varperimage+1:)= - glob%step(dimer%varperimage+1:)
    glob%step(dimer%varperimage+1:) = glob%step(dimer%varperimage+1:) - &
        glob%icoords(dimer%varperimage+1:)

  end if
  ! rubbish for printing >>>>>>
  if(dimer%curve>0.D0) then
    svar=5.D-2/dimer%delta
  else
    svar=5.D-2/dimer%delta
  end if
  n0s=(glob%energy-dimer%emid)*svar
  if(.not.glob%tatoms) then
    if (glob%iam == 0) then
       write(40,"('cylinder{<',f12.4,',',f12.4,',',f12.4,'>,"//&
           &"<',f12.4,',',f12.4,',',f12.4,'> 0.005} ')") &
           glob%icoords(1)-glob%icoords(3)*svar,min(dimer%emid,1.D3)-n0s,&
           glob%icoords(2)-glob%icoords(4)*svar, &
           glob%icoords(1)+glob%icoords(3)*svar, min(dimer%emid,1.D3)+n0s,&
           glob%icoords(2)+glob%icoords(4)*svar
!!$       write(40,"('sphere{<',f12.4,',',f12.4,',',f12.4,'> 0.02} ')") &
!!$           glob%icoords(1)-glob%icoords(3)*svar,min(dimer%emid,1.D3)-n0s,&
!!$           glob%icoords(2)-glob%icoords(4)*svar
!!$       write(40,"('sphere{<',f12.4,',',f12.4,',',f12.4,'> 0.02} ')") &
!!$           glob%icoords(1)+glob%icoords(3)*svar,min(dimer%emid,1.D3)+n0s,&
!!$           glob%icoords(2)+glob%icoords(4)*svar
!!$       write(40,"('sphere{<',f12.4,',',f12.4,',',f12.4,'> 0.021} ')") &
!!$           glob%icoords(1),min(dimer%emid,1.D3),&
!!$           glob%icoords(2)
       write(41,*) glob%icoords(1:2)
    end if
  end if
  ! <<<< end of rubbish for printing

  ! calculate the angle between the new normal and the old normal:
  ! Maximum change is 90 deg, as only the direction, not the orientation is relevant
  if((.not.dimer%toptdir) .and. printl>=2) then
    n0s= ddot(dimer%varperimage,glob%icoords(dimer%varperimage+1:), 1, &
        glob%step(dimer%varperimage+1:), 1)
    svar=1.D0+n0s/dimer%delta**2
    if(svar>=1.D0) then
      svar=0.D0
    else if (svar<=-1.D0) then
      svar=180.D0
    else
      svar=acos(svar)*180.D0/pi
    end if
    write(stdout,"('Dimer axis rotated by ',f5.1,' degrees')") svar
  end if

  if(dimer%cdelta) then
    ! check:
    glob%icoords(dimer%varperimage+1:)=glob%icoords(dimer%varperimage+1:)+ &
        glob%step(dimer%varperimage+1:)
    ss= sqrt(ddot(dimer%varperimage,glob%icoords(dimer%varperimage+1:), 1, &
        glob%icoords(dimer%varperimage+1:), 1))
    if(abs(ss-dimer%delta) .gt. 1.D-6) then
      print*,"Error: dimer distance wrong:"
      print*,"Distance after step:",ss
      print*,"Required distance:",dimer%delta
      call dlf_fail("Wrong dimer distance")
    end if
    glob%icoords(dimer%varperimage+1:)=glob%icoords(dimer%varperimage+1:)- &
        glob%step(dimer%varperimage+1:)
  end if
end subroutine dlf_dimer_checkstep
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* dimer/dlf_dimer_itox
!!
!! FUNCTION
!! Set xcoords to dimer midpoint
!!
!! SYNOPSIS
subroutine dlf_dimer_itox
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: glob,stdout,printl
  use dlf_dimer, only: dimer,rot_lbfgs
  implicit none
  logical               :: tok
  real(rk)              :: svar
  real(RK) ,external    :: ddot
! **********************************************************************
  call dlf_direct_itox(glob%nvar,dimer%varperimage,dimer%coreperimage, &
      glob%icoords(1:dimer%varperimage),glob%xcoords(:,:),tok)
  if(.not.tok) then
    ! we have to cancel that step ...
    if(printl>=4) write(stdout, &
        "('HDLC coordinate breakdown at dimer midpoint. Recalculating HDLCs and &
        &restarting optimiser and dimer.')")
    call dlf_hdlc_reset
    glob%xcoords=dimer%xmidpoint
    call dlf_hdlc_create(glob%nat,dimer%coreperimage,glob%spec,glob%micspec,&
        glob%znuc,1,glob%xcoords,glob%weight,glob%mass)

    ! recalculate iweights
    call dlf_hdlc_getweight(glob%nat,dimer%varperimage,dimer%coreperimage,glob%micspec,&
        glob%weight,glob%iweight(1:dimer%varperimage))
    ! copy weights to other image
    glob%iweight(dimer%varperimage+1:2*dimer%varperimage)= &
        glob%iweight(1:dimer%varperimage)

    call dlf_formstep_restart
    ! reset internal rotation optimisation 
    dimer%nrot=0
    dimer%toldrot=.false. ! no CG for next rotation
    if(rot_lbfgs) then
      call dlf_lbfgs_select("dimer rotation",.false.)
      call dlf_lbfgs_restart
      dimer%rotdir(:)=0.D0
      call dlf_lbfgs_deselect
    end if


    ! calculate internal coordinates of midpoint
    call dlf_direct_xtoi(glob%nvar,dimer%varperimage,dimer%coreperimage, &
        glob%xcoords,glob%xgradient,glob%icoords(1:dimer%varperimage), &
        glob%igradient(1:dimer%varperimage))

    !calculate internal coordinates of endpoint 1
    glob%xcoords=glob%xcoords+dimer%xtangent
    call dlf_direct_xtoi(glob%nvar,dimer%varperimage,dimer%coreperimage, &
        glob%xcoords,glob%xgradient,glob%icoords(dimer%varperimage+1:), &
        glob%igradient(dimer%varperimage+1:))
    ! all the gradients are rubbish, but will be recalculated anyway

    ! make second set of icoords relative
    glob%icoords(dimer%varperimage+1:)=glob%icoords(dimer%varperimage+1:) -&
        glob%icoords(1:dimer%varperimage)
    ! normalise second set of icoords (they are not necessarily normal in the new HDLCs)
    svar=ddot(dimer%varperimage,glob%icoords(dimer%varperimage+1:),1, &
        glob%icoords(dimer%varperimage+1:),1)
    glob%icoords(dimer%varperimage+1:)=glob%icoords(dimer%varperimage+1:) &
        / dsqrt(svar) * dimer%delta
  else
    ! store cartesian dimer midpoint
    dimer%xmidpoint=glob%xcoords
  end if
  if(printl>=4) write(stdout,"('Next calculation will be the dimer &
        & midpoint')")
end subroutine dlf_dimer_itox
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* dimer/dlf_checkpoint_dimer_write
!!
!! FUNCTION
!! Write checkpoint information
!!
!! SYNOPSIS
subroutine dlf_checkpoint_dimer_write
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: stderr
  use dlf_dimer, only: dimer
  use dlf_checkpoint, only: tchkform,write_separator
  implicit none
  ! YL 15/12/2020: we need avoid using file units ifunit, 101, or 102 to make Cray compiler happy
  !                see pp 141: http://103.251.184.12/wp-content/uploads/2018/01/Cray_Fortran_Reference_Manual_S-3901_86.pdf
  !                The values of INPUT_UNIT, OUTPUT_UNIT, and ERROR_UNIT defined in the ISO_Fortran_env module are
  !                ifunit, 101, and 102, respectively. These three unit numbers are reserved and may not be used for other purposes.
  !                The files connected to these units are the same files used by the companion C processor for standard input
  !                (stdin), output (stdout), and error (stderr). An asterisk (*) specified as the unit for a READ statement specifies unit
  !                ifunit. An asterisk specified as the unit for a WRITE statement, and the unit for PRINT statements is unit 101. All
  !                positive default integer values are available for use as unit numbers.
  integer, parameter :: ifunit = 104
! **********************************************************************
  if(tchkform) then

    open(unit=ifunit,file="dlf_dimer.chk",form="formatted")

    call write_separator(ifunit,"Dimer Sizes")
    write(ifunit,*) dimer%varperimage
    call write_separator(ifunit,"Dimer Parameters")
    write(ifunit,*) dimer%status, dimer%mode, dimer%delta, dimer%emid, &
        dimer%curve, dimer%tolrot, dimer%toldrot, dimer%toptdir, &
        dimer%cgstep, dimer%extrapolate_grad, dimer%nrot, dimer%maxrot, &
        dimer%phi, dimer%dcurvedphi, dimer%cdelta
    call write_separator(ifunit,"Dimer Arrays")
    write(ifunit,*) dimer%xtangent, dimer%xmidpoint, dimer%rotgrad, &
        dimer%rotdir, dimer%oldrotgrad, dimer%oldrotdir, dimer%vector, &
        dimer%theta, dimer%grad1
    call write_separator(ifunit,"END")


  else

    open(unit=ifunit,file="dlf_dimer.chk",form="unformatted")

    call write_separator(ifunit,"Dimer Sizes")
    write(ifunit) dimer%varperimage
    call write_separator(ifunit,"Dimer Parameters")
    write(ifunit) dimer%status, dimer%mode, dimer%delta, dimer%emid, &
        dimer%curve, dimer%tolrot, dimer%toldrot, dimer%toptdir, &
        dimer%cgstep, dimer%extrapolate_grad, dimer%nrot, dimer%maxrot, &
        dimer%phi, dimer%dcurvedphi, dimer%cdelta
    call write_separator(ifunit,"Dimer Arrays")
    write(ifunit) dimer%xtangent, dimer%xmidpoint, dimer%rotgrad, &
        dimer%rotdir, dimer%oldrotgrad, dimer%oldrotdir, dimer%vector, &
        dimer%theta, dimer%grad1
    call write_separator(ifunit,"END")

  end if

  close(ifunit)
    
end subroutine dlf_checkpoint_dimer_write
!!****

! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!!****f* dimer/dlf_checkpoint_dimer_read
!!
!! FUNCTION
!! Read checkpoint information
!!
!! SYNOPSIS
subroutine dlf_checkpoint_dimer_read(tok)
!! SOURCE
  use dlf_parameter_module, only: rk
  use dlf_global, only: stderr,stdout,printl
  use dlf_dimer, only: dimer
  use dlf_checkpoint, only: tchkform,read_separator
  implicit none
  logical,intent(out) :: tok
  logical             :: tchk
  integer             :: varperimage
  integer, parameter  :: ifunit = 104
! **********************************************************************
  tok=.false.

  ! check if checkpoint file exists
  INQUIRE(FILE="dlf_dimer.chk",EXIST=tchk)
  if(.not.tchk) then
    write(stdout,10) "File dlf_dimer.chk not found"
    return
  end if

  if(tchkform) then
    open(unit=ifunit,file="dlf_dimer.chk",form="formatted")
  else
    open(unit=ifunit,file="dlf_dimer.chk",form="unformatted")
  end if


  call read_separator(ifunit,"Dimer Sizes",tchk)
  if(.not.tchk) return  

  if(tchkform) then
    read(ifunit,*,end=201,err=200) varperimage
  else
    read(ifunit,end=201,err=200) varperimage
  end if

  if(dimer%varperimage/=varperimage) then
    write(stdout,10) "Different numbers of variables per dimer image"
    close(ifunit)
    return
  end if

  call read_separator(ifunit,"Dimer Parameters",tchk)
  if(.not.tchk) return    

  if(tchkform) then
    read(ifunit,*,end=201,err=200) &
        dimer%status, dimer%mode, dimer%delta, dimer%emid, &
        dimer%curve, dimer%tolrot, dimer%toldrot, dimer%toptdir, &
        dimer%cgstep, dimer%extrapolate_grad, dimer%nrot, dimer%maxrot, &
        dimer%phi, dimer%dcurvedphi, dimer%cdelta
  else
    read(ifunit,end=201,err=200) &
        dimer%status, dimer%mode, dimer%delta, dimer%emid, &
        dimer%curve, dimer%tolrot, dimer%toldrot, dimer%toptdir, &
        dimer%cgstep, dimer%extrapolate_grad, dimer%nrot, dimer%maxrot, &
        dimer%phi, dimer%dcurvedphi, dimer%cdelta
  end if

  call read_separator(ifunit,"Dimer Arrays",tchk)
  if(.not.tchk) return

  if(tchkform) then
    read(ifunit,*,end=201,err=200) &
        dimer%xtangent, dimer%xmidpoint, dimer%rotgrad, &
        dimer%rotdir, dimer%oldrotgrad, dimer%oldrotdir, dimer%vector, &
        dimer%theta, dimer%grad1
  else
    read(ifunit,end=201,err=200) &
        dimer%xtangent, dimer%xmidpoint, dimer%rotgrad, &
        dimer%rotdir, dimer%oldrotgrad, dimer%oldrotdir, dimer%vector, &
        dimer%theta, dimer%grad1
  end if

  call read_separator(ifunit,"END",tchk)
  if(.not.tchk) return

  close(ifunit)
  tok=.true.

  if(printl >= 6) write(stdout,"('Dimer checkpoint file successfully read')")

  return

  ! return on error
200 continue
  write(stdout,10) "Error reading file"
  return
201 continue
  write(stdout,10) "Error (EOF) reading file"
  return

10 format("Checkpoint reading WARNING: ",a)
    
end subroutine dlf_checkpoint_dimer_read
!!****

!! COPYRIGHT
!!
!!  Copyright 2007 Johannes Kaestner (kaestner@theochem.uni-stuttgart.de),
!!  Tom Keal (thomas.keal@stfc.ac.uk)
!!
!!  This file is part of DL-FIND.
!!
!!  DL-FIND is free software: you can redistribute it and/or modify
!!  it under the terms of the GNU Lesser General Public License as 
!!  published by the Free Software Foundation, either version 3 of the 
!!  License, or (at your option) any later version.
!!
!!  DL-FIND is distributed in the hope that it will be useful,
!!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!!  GNU Lesser General Public License for more details.
!!
!!  You should have received a copy of the GNU Lesser General Public 
!!  License along with DL-FIND.  If not, see 
!!  <http://www.gnu.org/licenses/>.
!!
module dlf_parameter_module
  integer, parameter :: rk = kind(1.d0) ! read kind
  integer, parameter :: ik = kind(1)    ! integer kind (for memory tracking)
end module dlf_parameter_module

module dlf_stat
  implicit none
  type stat_type
    integer    :: sene=0      ! number of energy evaluation tasks
    integer    :: pene=0      ! number of energy evaluations on current processor
    integer    :: ccycle=0    ! number of cycles/steps in the current run
    integer    :: caccepted=0 ! number of accepted steps in the current run
    integer    :: miccycle=0  ! number of microiterative steps in current macro cycle
    integer    :: tmiccycle=0 ! total number of microiterative steps
    integer    :: tmicaccepted=0 ! total number of accepted microiterations
  end type stat_type
  type(stat_type),save :: stat
end module dlf_stat

subroutine dlf_stat_reset
  use dlf_stat, only: stat
  implicit none
  stat%ccycle=0
  stat%caccepted=0 
  stat%miccycle = 0
  stat%tmiccycle = 0
  stat%tmicaccepted = 0
end subroutine dlf_stat_reset

!  Copyright (C) 2020 The authors of Py-ChemShell
!
!  This file is part of Py-ChemShell.
!
!  Py-ChemShell is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as
!  published by the Free Software Foundation, either version 3 of the
!  License, or (at your option) any later version.
!
!  Py-ChemShell is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public
!  License along with Py-ChemShell.  If not, see
!  <http://www.gnu.org/licenses/>.

module ChemShellDLMONTEModule

    use, intrinsic :: iso_c_binding
    use DL_PY2F 
    use ChemShellParallelModule
    use DLMONTEModule

    implicit none
    private

    public register_dl_monte, interface_dl_monte, dl_monte_wrap
    public PyFrag, PyShells, nshells

    type(dictType) , pointer :: PyFrag, PyShells, PyResult
    integer                  :: natoms, nshells

    integer :: dl_monte_task
    integer(c_int) :: c_debug
    integer(c_int) :: dl_monte_handle

    contains

      
    subroutine register_dl_monte(debug) bind(c, name="f_register_dl_monte")

        use ChemShellParallelModule, only : chemsh_parallel

        integer(c_int), intent(in) :: debug

        type(c_funptr) :: dl_monte_pointer

        c_debug = debug

        dl_monte_pointer = c_funloc(dl_monte_wrap)
        dl_monte_handle = chemsh_parallel%get_function_handle(dl_monte_pointer)

    endsubroutine register_dl_monte
    ! called by master process only
    subroutine interface_dl_monte(fragPtr, resultPtr) bind(c)
 
        use ChemShellParallelModule, only : chemsh_parallel

        implicit none
 
        type(PyType)  , intent(in) :: fragPtr
        type(PyType)  , intent(in) :: resultPtr
 
        integer                    :: ierror
        type(PyType)  , pointer    :: shellsPtr

        ! set up dict of fragObj
        allocate(PyFrag, source=ptr2dict(fragPtr))
        call PyFrag%get('npts', natoms)
        call PyFrag%get('shells', shellsPtr)
        allocate(PyResult, source=ptr2dict(resultPtr))

        ! set up dict of shellsObj and save nshells
        allocate(PyShells, source=ptr2dict(shellsPtr))
        call PyShells%get('npts', nshells)
 
        if (chemsh_parallel%is_parallel()) then
           ierror = chemsh_parallel%exec_function(dl_monte_handle, c_debug)
        else
           ierror = dl_monte_wrap()
        endif
 
        deallocate(PyFrag, PyShells)
 
    endsubroutine interface_dl_monte


    ! also called by slave processes
    integer function dl_monte_wrap() result(ierror)

        use ChemShellParallelModule, only : chemsh_parallel

        integer                  :: itype, lenbuf, ifrom, itag
        logical                  :: opened
        integer                  :: i, shapebuff(2), nnodes, node
        integer(kind=4), pointer :: natoms_per_domain(:), global_indices_per_node(:)
        real(kind=8)   , pointer :: gradients(:,:), gbuff(:,:)

        ! size of int for GULP
        lenbuf = 4
        ifrom  = 0
        itag   = 66

        ! number of nodes per subset (rather than workgroup!)
        nnodes = chemsh_parallel%nnodes_subset
        node   = chemsh_parallel%node_subset

        ierror = chemsh_parallel%broadcast(natoms, lenbuf, ifrom)

!        allocate(gradients(3,natoms))
!        allocate(gbuff(3,natoms))
!        allocate(global_indices_per_node(natoms))
!        allocate(natoms_per_domain(nnodes))
!        gradients = 0.0
!        natoms_per_domain = 0
        
        ! share task control flag
        itype = 402

        if(chemsh_parallel%is_subset()) then
            ! cast to system integer kind
            call dl_monte(int(chemsh_parallel%comm_subset))
        endif

!        if(chemsh_parallel%is_root()) then
!            natoms_per_domain(1) = shapebuff(2)
!            do i = 1, nnodes-1
!                ierror = chemsh_parallel%receive(natoms_per_domain(i+1), lenbuf, i, itag)
!            enddo
!        else
!            ierror = chemsh_parallel%send(shapebuff(2), lenbuf, 0, itag)
!        endif
!
!        ! get the whole array of indices per node
!        if(chemsh_parallel%is_root()) then
!            do i = 1, nnodes-1
!                ierror = chemsh_parallel%receive(global_indices_per_node(sum(natoms_per_domain(1:i))+1:sum(natoms_per_domain(1:i+1))), 4*natoms_per_domain(i+1), i, itag)
!            enddo
!        endif
!
!        ierror = chemsh_parallel%broadcast(natoms_per_domain, lenbuf*nnodes, 0)
!
!        ! the root gathers the gradients
!        if(chemsh_parallel%is_root()) then
!            do i = 1, nnodes-1
!                ierror = chemsh_parallel%receive(gbuff(1:3,sum(natoms_per_domain(1:i))+1:sum(natoms_per_domain(1:i+1))), 8*3*natoms_per_domain(i+1), i, itag)
!            enddo
!        endif
!
!        ! sort the gradients according to the global indices
!        if(chemsh_parallel%is_root()) then
!            do i = 1, nnodes-1
!                gradients(1:3,global_indices_per_node(sum(natoms_per_domain(1:i))+1:sum(natoms_per_domain(1:i+1)))) = gbuff(1:3,sum(natoms_per_domain(1:i))+1:sum(natoms_per_domain(1:i+1)))
!            enddo
!        endif
!
!        if(chemsh_parallel%is_root()) then
!            call PyResult%set('gradients', gradients)
!        endif
        
!        deallocate(gradients, gbuff, natoms_per_domain, global_indices_per_node)

    endfunction dl_monte_wrap

endmodule ChemShellDLMONTEModule

#!/bin/bash --login
# you.lu@stfc.ac.uk

## load module(s)
module load anaconda/3         # Python 3 and NumPy

echo
echo =========================
echo $PBS_JOBID
echo $PBS_JOBNAME
echo $PFSDIR
echo =========================
echo 

export OMP_NUM_THREADS=16
export MALLOC_MMAP_MAX_=0
export MALLOC_TRIM_THRESHOLD_=-1
export FORT_BUFFERED=true
export decfort_dump_flag=true
export OMP_STACKSIZE=2G

# make sure any symbolic links are resolved to absolute path
export PBS_O_WORKDIR=$(readlink -f $PBS_O_WORKDIR)

# replace "home" with "work"
#export PYTHONHOME=`echo $ANACONDADIR | sed 's/home/work/1'`
export PYTHONPATH=$CHEMSH_PYTHONPATH
export CHEMSH_ARCH=intel

# Change to the directory that the job was submitted from
cd $PBS_O_WORKDIR

# run
mpirun -n $CHEMSH_NPROCS $CHEMSH_EXEC -nwg $CHEMSH_NWORKGROUPS -npmm $CHEMSH_NPROCS_MM $CHEMSH_INPUT > $CHEMSH_OUTPUT

#!/bin/bash --login
# ChemShell SLURM batch script

SBATCH -o $CHEMSH_INPUT.o$SLURM_JOBID
SBATCH -e $CHEMSH_INPUT.e$SLURM_JOBID

echo "Node list is" $SLURM_NODELIST

export I_MPI_PMI_LIBRARY=/cm/shared/apps/slurm/current/lib64/libpmi.so
export I_MPI_FABRICS=shm:dapl
export ALLINEA_MPI_INIT_PENDING=1
export ALLINEA_MPI_INIT=MPI_Init

# some things that might be useful
echo
echo SLURM parameters:
echo
echo SLURM_JOBID         = $SLURM_JOBID
echo SLURM_JOB_NODELIST  = $SLURM_JOB_NODELIST
echo SLURM_NNODES        = $SLURM_NNODES
echo SLURMTMPDIR         = $SLURMTMPDIR
echo SLURM_ARRAYID       = $SLURM_ARRAYID
echo SLURM_ARRAY_JOB_ID  = $SLURM_ARRAY_JOB_ID
echo SLURM_ARRAY_TASK_ID = $SLURM_ARRAY_TASK_ID

NPROCS=`srun --nodes=${SLURM_NNODES} bash -c 'hostname' | wc -l`

echo
echo ChemShell runtime parameters:
echo
echo working directory = $SLURM_SUBMIT_DIR
echo PYTHONPATH        = $PYTHONPATH
echo NPROCS            = $NPROCS
echo WRAPPER           = $CHEMSH_WRAPPER
echo EXEC              = $CHEMSH_EXEC
echo NWORKGROUPS       = $CHEMSH_NWORKGROUPS
echo INPUT             = $CHEMSH_INPUT
echo OUTPUT            = $CHEMSH_OUTPUT

# use srun preferably to use the allocated resources in a job step
echo $CHEMSH_WRAPPER srun -n $CHEMSH_NPROCS $CHEMSH_EXEC -nwg $CHEMSH_NWORKGROUPS $CHEMSH_INPUT \> $CHEMSH_OUTPUT
#$CHEMSH_WRAPPER mpirun -n $CHEMSH_NPROCS $CHEMSH_EXEC -nwg $CHEMSH_NWORKGROUPS $CHEMSH_INPUT > $CHEMSH_OUTPUT
$CHEMSH_WRAPPER srun -n $CHEMSH_NPROCS $CHEMSH_EXEC -nwg $CHEMSH_NWORKGROUPS $CHEMSH_INPUT > $CHEMSH_OUTPUT

#!/bin/bash

# ChemShell SLURM batch script
# you.lu@stfc.ac.uk

# unload modules
for mod in ${CHEMSH_UNLOAD_MODS}
do
    module unload $mod
done

# restore
#module restore

# swap modules
IFS=$';'
for pair in ${CHEMSH_SWAP_MODS}
do
    IFS=$' ' read -a mods <<< $pair
    module swap ${mods[0]} ${mods[1]}
done

# load modules
IFS=$' '
for mod in ${CHEMSH_LOAD_MODS}
do
    module load $mod
done

# epcc-job-env unloads cray-python
module load cray-python

# debug
#module --quiet load valgrind4hpc/2.10.2

module list

echo "Node list is" $SLURM_NODELIST

# some things that might be useful
echo
echo SLURM parameters:
echo
echo SLURM_JOBID         = $SLURM_JOBID
echo SLURM_JOB_NODELIST  = $SLURM_JOB_NODELIST
echo SLURM_NNODES        = $SLURM_NNODES
echo SLURMTMPDIR         = $SLURMTMPDIR
echo SLURM_ARRAYID       = $SLURM_ARRAYID
echo SLURM_ARRAY_JOB_ID  = $SLURM_ARRAY_JOB_ID
echo SLURM_ARRAY_TASK_ID = $SLURM_ARRAY_TASK_ID
echo SLURM_CPUS_PER_TASK = $SLURM_CPUS_PER_TASK
echo SLURM_CPU_FREQ_REQ  = $SLURM_CPU_FREQ_REQ

NPROCS=`srun --nodes=${SLURM_NNODES} bash -c 'hostname' | wc -l`

echo
echo ChemShell runtime parameters:
echo
echo working directory = $SLURM_SUBMIT_DIR
echo PYTHONPATH        = $PYTHONPATH
echo NPROCS            = $NPROCS
echo NTHREADS          = $CHEMSH_NTHREADS
echo WRAPPER           = $CHEMSH_WRAPPER
echo EXEC              = $CHEMSH_EXEC
echo NWORKGROUPS       = $CHEMSH_NWORKGROUPS
echo INPUT             = $CHEMSH_INPUT
echo OUTPUT            = $CHEMSH_OUTPUT
echo Print level       = $CHEMSH_DEBUG
echo Modules to load   = $CHEMSH_LOAD_MODULES
echo Modules to unload = $CHEMSH_UNLOAD_MODULES
echo Modules to swap   = $CHEMSH_SWAP_MODULES

# TWK 17/7/2023 Test driver mode
if [[ "$CHEMSH_TEST_DRIVER" != "" ]]
then
    echo 
    echo Running the ChemShell test suite:
    echo 
    echo CHEMSH_TEST_DRIVER = $CHEMSH_TEST_DRIVER
    echo CHEMSH_TESTSETS = $CHEMSH_TESTSETS
    echo
    CHEMSH_TEST="${CHEMSH_TEST_DRIVER} --sets ${CHEMSH_TESTSETS} --exe "
else
    CHEMSH_TEST=""
fi

# use srun preferably to use the allocated resources in a job step

# OpenMPI
export OMP_NUM_THREADS=$CHEMSH_NTHREADS
# TWK 4/1/2024 Require one thread per physical core (see ARCHER2 documentation)
if [[ $CHEMSH_NTHREADS -gt 1 ]]
then
    export OMP_PLACES=cores
fi

# Propagate the cpus-per-task setting from script to srun commands
# as recommended in the ARCHER2 user documentation.
#    By default, Slurm does not propagate this setting from the sbatch
#    options to srun commands in the job script. If this is not done,
#    process/thread pinning may be incorrect leading to poor performance
export SRUN_CPUS_PER_TASK=$SLURM_CPUS_PER_TASK

export ATP_ENABLED=1
# GA/ARMCI
export ARMCI_DEFAULT_SHMMAX_UBOUND=131072

# debug
#valgrind4hpc --tool=memcheck --valgrind-args="--track-origins=yes --leak-check=full --show-leak-kinds=all" --outputfile=_valgrind.log --launcher-args="-n 128" srun -- $CHEMSH_EXEC -nwg $CHEMSH_NWORKGROUPS -npmm $CHEMSH_NPROCS_MM -dbg $CHEMSH_DEBUG $CHEMSH_INPUT > $CHEMSH_OUTPUT

# srun verbose mode
#ulimit -c unlimited
#srun --slurmd-debug=verbose -n $CHEMSH_NPROCS $CHEMSH_EXEC -nwg $CHEMSH_NWORKGROUPS -npmm $CHEMSH_NPROCS_MM -dbg $CHEMSH_DEBUG $CHEMSH_INPUT

# ATP debug mode
#ATP_ENABLED=1 srun -n $CHEMSH_NPROCS $CHEMSH_EXEC -nwg $CHEMSH_NWORKGROUPS -npmm $CHEMSH_NPROCS_MM -dbg $CHEMSH_DEBUG $CHEMSH_INPUT

echo MEM_ARCHER2 = $MEM_ARCHER2

echo Executing command:
if [[ $MEM_ARCHER2 -gt 0 ]]
# YL 21/12/2021: request a certain amount of memory for ChemShell and reserve the rest for system call using srun (e.g., for NAMD)
then
    ARCHER2_SRUN_OPTIONS="--oversubscribe --mem=${MEM_ARCHER2}M"
else
    # TWK 4/1/2024 Standard srun options recommended in ARCHER2 user documentation
    ARCHER2_SRUN_OPTIONS="--distribution=block:block --hint=nomultithread"
fi

echo $CHEMSH_TEST $CHEMSH_WRAPPER srun -n $CHEMSH_NPROCS $ARCHER2_SRUN_OPTIONS $CHEMSH_EXEC -nwg $CHEMSH_NWORKGROUPS -npmm $CHEMSH_NPROCS_MM -gm $CHEMSH_GA_MEMORY -dbg $CHEMSH_DEBUG $CHEMSH_INPUT \> $CHEMSH_OUTPUT
$CHEMSH_TEST srun -n $CHEMSH_NPROCS $ARCHER2_SRUN_OPTIONS $CHEMSH_EXEC -nwg $CHEMSH_NWORKGROUPS -npmm $CHEMSH_NPROCS_MM -gm $CHEMSH_GA_MEMORY -dbg $CHEMSH_DEBUG $CHEMSH_INPUT > $CHEMSH_OUTPUT

# debug mode
#export PYTHONPATH=/work/c01/c01/ylu/chemsh/archer2
#export CHEMSH_ARCH=cray
# NB: because MPI is not initialised code involving MPI will fail in this mode (including base.connect)
#valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all --log-file=_valgrind.log python3 $CHEMSH_INPUT

#!/bin/bash --login

# ChemShell SLURM batch script
# you.lu@stfc.ac.uk

#SBATCH -o $CHEMSH_JOBNAME.o$SLURM_JOBID
#SBATCH -e $CHEMSH_JOBNAME.e$SLURM_JOBID

echo "Node list is" $SLURM_NODELIST


export I_MPI_PMI_LIBRARY=/usr/lib64/libpmi.so
#export I_MPI_FALLBACK_DEVICE=0
#export ALLINEA_MPI_INIT_PENDING=1
#export ALLINEA_MPI_INIT=MPI_Init

# some things that might be useful
echo
echo SLURM parameters:
echo
echo SLURM_JOBID         = $SLURM_JOBID
echo SLURM_JOB_NODELIST  = $SLURM_JOB_NODELIST
echo SLURM_NNODES        = $SLURM_NNODES
echo SLURMTMPDIR         = $SLURMTMPDIR
echo SLURM_ARRAYID       = $SLURM_ARRAYID
echo SLURM_ARRAY_JOB_ID  = $SLURM_ARRAY_JOB_ID
echo SLURM_ARRAY_TASK_ID = $SLURM_ARRAY_TASK_ID

NPROCS=`srun --nodes=${SLURM_NNODES} bash -c 'hostname' | wc -l`

echo
echo ChemShell runtime parameters:
echo
echo working directory = $SLURM_SUBMIT_DIR
echo PYTHONPATH        = $PYTHONPATH
echo NPROCS            = $NPROCS
echo WRAPPER           = $CHEMSH_WRAPPER
echo EXEC              = $CHEMSH_EXEC
echo NWORKGROUPS       = $CHEMSH_NWORKGROUPS
echo INPUT             = $CHEMSH_INPUT
echo OUTPUT            = $CHEMSH_OUTPUT
echo Print level       = $CHEMSH_DEBUG

# TWK 17/7/2023 Test driver mode
if [[ "$CHEMSH_TEST_DRIVER" != "" ]]
then
    echo
    echo Running the ChemShell test suite:
    echo
    echo CHEMSH_TEST_DRIVER = $CHEMSH_TEST_DRIVER
    echo CHEMSH_TESTSETS = $CHEMSH_TESTSETS
    echo
    CHEMSH_TEST="${CHEMSH_TEST_DRIVER} --sets ${CHEMSH_TESTSETS} --exe "
else
    CHEMSH_TEST=""
fi

# use srun preferably to use the allocated resources in a job step
echo Executing command:
echo $CHEMSH_TEST $CHEMSH_WRAPPER mpirun -n $CHEMSH_NPROCS $CHEMSH_EXEC -nwg $CHEMSH_NWORKGROUPS -npmm $CHEMSH_NPROCS_MM -dbg $CHEMSH_DEBUG $CHEMSH_INPUT \> $CHEMSH_OUTPUT

# YL 05/12/2018: srun fails somehow
#$CHEMSH_WRAPPER srun -n $CHEMSH_NPROCS $CHEMSH_EXEC -nwg $CHEMSH_NWORKGROUPS $CHEMSH_INPUT > $CHEMSH_OUTPUT
$CHEMSH_TEST $CHEMSH_WRAPPER mpirun -n $CHEMSH_NPROCS $CHEMSH_EXEC -nwg $CHEMSH_NWORKGROUPS -npmm $CHEMSH_NPROCS_MM -dbg $CHEMSH_DEBUG $CHEMSH_INPUT > $CHEMSH_OUTPUT

#!/bin/bash -l
# you.lu@stfc.ac.uk

#$ -S /bin/bash

echo
echo =========================
echo Py-ChemShell on UCL YOUNG
echo Job ID: $JOB_ID
echo =========================
echo 

echo "ChemShell executable   : $CHEMSH_EXEC"
echo "Number of MPI processes: $CHEMSH_NPROCS"
echo "Number of workgroups   : $CHEMSH_NWORKGROUPS"
echo "Number of procs for MM : $CHEMSH_NPROCS_MM"
echo "Input file             : $CHEMSH_INPUT"
echo "Print level            : $CHEMSH_DEBUG"

# TWK 17/7/2023 Test driver mode
if [[ "$CHEMSH_TEST_DRIVER" != "" ]]
then
    echo
    echo Running the ChemShell test suite:
    echo
    echo CHEMSH_TEST_DRIVER = $CHEMSH_TEST_DRIVER
    echo CHEMSH_TESTSETS = $CHEMSH_TESTSETS
    echo
    CHEMSH_TEST="${CHEMSH_TEST_DRIVER} --sets ${CHEMSH_TESTSETS} --exe "
else
    CHEMSH_TEST=""
fi

# run (launch MPI with gerun on THOMAS)
$CHEMSH_TEST $CHEMSH_WRAPPER mpirun -np $CHEMSH_NPROCS $CHEMSH_EXEC -nwg $CHEMSH_NWORKGROUPS -npmm $CHEMSH_NPROCS_MM -gm $CHEMSH_GA_MEMORY -dbg $CHEMSH_DEBUG $CHEMSH_INPUT > $CHEMSH_OUTPUT

#!/bin/bash

# ChemShell SLURM batch script
# you.lu@stfc.ac.uk

#SBATCH -o $CHEMSH_JOBNAME.o$SLURM_JOBID
#SBATCH -e $CHEMSH_JOBNAME.e$SLURM_JOBID

echo "Node list is" $SLURM_NODELIST

# number of OpenMP threads per MPI process
export OMP_NUM_THREADS=$CHEMSH_NTHREADS

# see: https://www.cfd-online.com/Forums/openfoam-solving/84084-decomposed-case-2-cores-not-working-2.html#post292700
export OMPI_MCA_btl_tcp_if_exclude=lo,virbr0

#export SLURM_MPI_TYPE=pmix_v3
#export I_MPI_PROCESS_MANAGER=hydra
#export I_MPI_FABRICS=shm:tmi
#export I_MPI_FALLBACK=0
#export I_MPI_PMI_LIBRARY=

# some things that might be useful
echo
echo SLURM parameters:
echo
echo SLURM_JOBID         = $SLURM_JOBID
echo SLURM_JOB_NODELIST  = $SLURM_JOB_NODELIST
echo SLURM_NNODES        = $SLURM_NNODES
echo SLURMTMPDIR         = $SLURMTMPDIR
echo SLURM_ARRAYID       = $SLURM_ARRAYID
echo SLURM_ARRAY_JOB_ID  = $SLURM_ARRAY_JOB_ID
echo SLURM_ARRAY_TASK_ID = $SLURM_ARRAY_TASK_ID

NPROCS=`srun --nodes=${SLURM_NNODES} bash -c 'hostname' | wc -l`

echo
echo ChemShell runtime parameters:
echo
echo working directory = $SLURM_SUBMIT_DIR
echo MPIEXEC           = $MPI_EXEC
echo PYTHONPATH        = $PYTHONPATH
echo NPROCS            = $CHEMSH_NPROCS
echo NPROCS_MM         = $CHEMSH_NPROCS_MM
echo NTHREADS          = $CHEMSH_NTHREADS
echo WRAPPER           = $CHEMSH_WRAPPER
echo EXEC              = $CHEMSH_EXEC
echo NWORKGROUPS       = $CHEMSH_NWORKGROUPS
echo CHEMSH_GA_MEMORY  = $CHEMSH_GA_MEMORY
echo INPUT             = $CHEMSH_INPUT
echo OUTPUT            = $CHEMSH_OUTPUT
echo Print level       = $CHEMSH_DEBUG
echo

# TWK 17/7/2023 Test driver mode
if [[ "$CHEMSH_TEST_DRIVER" != "" ]]
then
    echo
    echo Running the ChemShell test suite:
    echo
    echo CHEMSH_TEST_DRIVER = $CHEMSH_TEST_DRIVER
    echo CHEMSH_TESTSETS = $CHEMSH_TESTSETS
    echo
    CHEMSH_TEST="${CHEMSH_TEST_DRIVER} --sets ${CHEMSH_TESTSETS} --exe "
else
    CHEMSH_TEST=""
fi

# the output will go to .err
module list
echo
echo Executing command:
echo $CHEMSH_TEST $CHEMSH_WRAPPER $MPI_EXEC -n $CHEMSH_NPROCS $CHEMSH_EXEC -nwg $CHEMSH_NWORKGROUPS -npmm $CHEMSH_NPROCS_MM -gm $CHEMSH_GA_MEMORY -dbg $CHEMSH_DEBUG $CHEMSH_INPUT \> $CHEMSH_OUTPUT

$CHEMSH_TEST $CHEMSH_WRAPPER $MPI_EXEC -n $CHEMSH_NPROCS $CHEMSH_EXEC -nwg $CHEMSH_NWORKGROUPS -npmm $CHEMSH_NPROCS_MM -gm $CHEMSH_GA_MEMORY -dbg $CHEMSH_DEBUG $CHEMSH_INPUT > $CHEMSH_OUTPUT
